/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var be=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/network","vs/base/common/errors","vs/workbench/api/common/extHostRpcService","vs/base/common/path","vs/platform/log/common/log","vs/base/common/async","vs/base/common/arrays","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/base/common/cancellation","vs/base/common/map","vs/base/common/platform","vs/base/common/objects","vs/base/common/buffer","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/editor/common/core/range","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/codicons","vs/base/common/uuid","vs/editor/common/core/position","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/process","vs/base/common/hash","vs/base/common/severity","vs/base/common/extpath","vs/platform/contextkey/common/contextkey","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/marshalling","vs/editor/common/modes/languageSelector","vs/base/common/errorMessage","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/files/common/files","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/uint","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/mime","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/testing/common/testCollection","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/lazy","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostLogService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/marked/marked","vs/workbench/services/extensions/worker/extensionHostWorker"],Ee=function(ee){for(var e=[],g=0,F=ee.length;g<F;g++)e[g]=be[ee[g]];return e};define(be[40],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function g(F,S){if(!F)throw new Error(S?`Assertion failed (${S})`:"Assertion Failed")}e.ok=g}),define(be[50],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const g=Object.prototype.hasOwnProperty;function F(n){const I=[];for(let l in n)g.call(n,l)&&I.push(n[l]);return I}e.values=F;function S(n,I){for(let l in n)if(g.call(n,l)&&I({key:l,value:n[l]},function(){delete n[l]})===!1)return}e.forEach=S;function _(n,I){const l=Object.create(null);for(const d of n){const c=I(d);let m=l[c];m||(m=l[c]=[]),m.push(d)}return l}e.groupBy=_;function C(n){const I=Object.create(null);return n&&n.forEach((l,d)=>{I[d]=l}),I}e.fromMap=C;function y(n,I){const l=[],d=[];for(let c of n)I.has(c)||l.push(c);for(let c of I)n.has(c)||d.push(c);return{removed:l,added:d}}e.diffSets=y;function b(n,I){const l=[],d=[];for(let[c,m]of n)I.has(c)||l.push(m);for(let[c,m]of I)n.has(c)||d.push(m);return{removed:l,added:d}}e.diffMaps=b;class k{constructor(){this.map=new Map}add(I,l){let d=this.map.get(I);d||(d=new Set,this.map.set(I,d)),d.add(l)}delete(I,l){const d=this.map.get(I);!d||(d.delete(l),d.size===0&&this.map.delete(I))}forEach(I,l){const d=this.map.get(I);!d||d.forEach(l)}}e.SetMap=k}),define(be[51],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function g(C){return(y,b,k)=>{let n=null,I=null;if(typeof k.value=="function"?(n="value",I=k.value):typeof k.get=="function"&&(n="get",I=k.get),!I)throw new Error("not supported");k[n]=C(I,b)}}e.createDecorator=g;function F(C,y,b){let k=null,n=null;if(typeof b.value=="function"?(k="value",n=b.value,n.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof b.get=="function"&&(k="get",n=b.get),!n)throw new Error("not supported");const I=`$memoize$${y}`;b[k]=function(...l){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:n.apply(this,l)}),this[I]}}e.memoize=F;function S(C,y,b){return g((k,n)=>{const I=`$debounce$${n}`,l=`$debounce$result$${n}`;return function(...d){this[l]||(this[l]=b?b():void 0),clearTimeout(this[I]),y&&(this[l]=y(this[l],...d),d=[this[l]]),this[I]=setTimeout(()=>{k.apply(this,d),this[l]=b?b():void 0},C)}})}e.debounce=S;function _(C,y,b){return g((k,n)=>{const I=`$throttle$timer$${n}`,l=`$throttle$result$${n}`,d=`$throttle$lastRun$${n}`,c=`$throttle$pending$${n}`;return function(...m){if(this[l]||(this[l]=b?b():void 0),(this[d]===null||this[d]===void 0)&&(this[d]=-Number.MAX_VALUE),y&&(this[l]=y(this[l],...m)),this[c])return;const E=this[d]+C;E<=Date.now()?(this[d]=Date.now(),k.apply(this,[this[l]]),this[l]=b?b():void 0):(this[c]=!0,this[I]=setTimeout(()=>{this[c]=!1,this[d]=Date.now(),k.apply(this,[this[l]]),this[l]=b?b():void 0},E-Date.now()))}})}e.throttle=_}),define(be[12],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class g{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(r=>{r(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=g,e.errorHandler=new g;function F(p){e.errorHandler.setUnexpectedErrorHandler(p)}e.setUnexpectedErrorHandler=F;function S(p){b(p)||e.errorHandler.onUnexpectedError(p)}e.onUnexpectedError=S;function _(p){b(p)||e.errorHandler.onUnexpectedExternalError(p)}e.onUnexpectedExternalError=_;function C(p){if(p instanceof Error){let{name:t,message:r}=p;const s=p.stacktrace||p.stack;return{$isError:!0,name:t,message:r,stack:s}}return p}e.transformErrorForSerialization=C;const y="Canceled";function b(p){return p instanceof Error&&p.name===y&&p.message===y}e.isPromiseCanceledError=b;class k extends Error{constructor(){super(y);this.name=this.message}}e.CancellationError=k;function n(){const p=new Error(y);return p.name=p.message,p}e.canceled=n;function I(p){return p?new Error(`Illegal argument: ${p}`):new Error("Illegal argument")}e.illegalArgument=I;function l(p){return p?new Error(`Illegal state: ${p}`):new Error("Illegal state")}e.illegalState=l;function d(p){return p?new Error(`readonly property '${p} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=d;function c(p){const t=new Error(`${p} has been disposed`);return t.name="DISPOSED",t}e.disposed=c;function m(p){return p?p.message?p.message:p.stack?p.stack.split(`
`)[0]:String(p):"Error"}e.getErrorMessage=m;class E extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=E;class w extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=w;class P extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=P;function a(p){const t=p;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=a;function h(p,t=Object.create(null)){const r=new Error(p);return t.actions&&(r.actions=t.actions),r}e.createErrorWithActions=h}),define(be[17],Ee([0,1,12]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function F($,te=0){return $[$.length-(1+te)]}e.tail=F;function S($){if($.length===0)throw new Error("Invalid tail call");return[$.slice(0,$.length-1),$[$.length-1]]}e.tail2=S;function _($,te,ce=(ye,Re)=>ye===Re){if($===te)return!0;if(!$||!te||$.length!==te.length)return!1;for(let ye=0,Re=$.length;ye<Re;ye++)if(!ce($[ye],te[ye]))return!1;return!0}e.equals=_;function C($,te,ce){let ye=0,Re=$.length-1;for(;ye<=Re;){const Te=(ye+Re)/2|0,$e=ce($[Te],te);if($e<0)ye=Te+1;else if($e>0)Re=Te-1;else return Te}return-(ye+1)}e.binarySearch=C;function y($,te){let ce=0,ye=$.length;if(ye===0)return 0;for(;ce<ye;){const Re=Math.floor((ce+ye)/2);te($[Re])?ye=Re:ce=Re+1}return ce}e.findFirstInSorted=y;function b($,te,ce){if($=$|0,$>=te.length)throw new TypeError("invalid index");let ye=te[Math.floor(te.length*Math.random())],Re=[],Te=[],$e=[];for(let Je of te){const Ve=ce(Je,ye);Ve<0?Re.push(Je):Ve>0?Te.push(Je):$e.push(Je)}return $<Re.length?b($,Re,ce):$<Re.length+$e.length?$e[0]:b($-(Re.length+$e.length),Te,ce)}e.quickSelect=b;function k($,te){const ce=[];let ye;for(const Re of $.slice(0).sort(te))!ye||te(ye[0],Re)!==0?(ye=[Re],ce.push(ye)):ye.push(Re);return ce}e.groupBy=k;function n($,te,ce){const ye=[];function Re(Je,Ve,je){if(Ve===0&&je.length===0)return;const O=ye[ye.length-1];O&&O.start+O.deleteCount===Je?(O.deleteCount+=Ve,O.toInsert.push(...je)):ye.push({start:Je,deleteCount:Ve,toInsert:je})}let Te=0,$e=0;for(;;){if(Te===$.length){Re(Te,0,te.slice($e));break}if($e===te.length){Re(Te,$.length-Te,[]);break}const Je=$[Te],Ve=te[$e],je=ce(Je,Ve);je===0?(Te+=1,$e+=1):je<0?(Re(Te,1,[]),Te+=1):je>0&&(Re(Te,0,[Ve]),$e+=1)}return ye}e.sortedDiff=n;function I($,te,ce){const ye=n($,te,ce),Re=[],Te=[];for(const $e of ye)Re.push(...$.slice($e.start,$e.start+$e.deleteCount)),Te.push(...$e.toInsert);return{removed:Re,added:Te}}e.delta=I;function l($,te,ce){if(ce===0)return[];const ye=$.slice(0,ce).sort(te);return c($,te,ye,ce,$.length),ye}e.top=l;function d($,te,ce,ye,Re){return ce===0?Promise.resolve([]):new Promise((Te,$e)=>{(async()=>{const Je=$.length,Ve=$.slice(0,ce).sort(te);for(let je=ce,O=Math.min(ce+ye,Je);je<Je;je=O,O=Math.min(O+ye,Je)){if(je>ce&&await new Promise(G=>setTimeout(G)),Re&&Re.isCancellationRequested)throw(0,g.canceled)();c($,te,Ve,je,O)}return Ve})().then(Te,$e)})}e.topAsync=d;function c($,te,ce,ye,Re){for(const Te=ce.length;ye<Re;ye++){const $e=$[ye];if(te($e,ce[Te-1])<0){ce.pop();const Je=y(ce,Ve=>te($e,Ve)<0);ce.splice(Je,0,$e)}}}function m($){return $.filter(te=>!!te)}e.coalesce=m;function E($){let te=0;for(let ce=0;ce<$.length;ce++)$[ce]&&($[te]=$[ce],te+=1);$.length=te}e.coalesceInPlace=E;function w($,te,ce){$.splice(ce,0,$.splice(te,1)[0])}e.move=w;function P($){return!Array.isArray($)||$.length===0}e.isFalsyOrEmpty=P;function a($){return Array.isArray($)&&$.length>0}e.isNonEmptyArray=a;function h($,te){if(!te)return $.filter((ye,Re)=>$.indexOf(ye)===Re);const ce=Object.create(null);return $.filter(ye=>{const Re=te(ye);return ce[Re]?!1:(ce[Re]=!0,!0)})}e.distinct=h;function p($){const te=new Set;return $.filter(ce=>te.has(ce)?!1:(te.add(ce),!0))}e.distinctES6=p;function t($){const te=Object.create(null);return ce=>{const ye=$(ce);return te[ye]?!1:(te[ye]=!0,!0)}}e.uniqueFilter=t;function r($,te){for(let ce=$.length-1;ce>=0;ce--){const ye=$[ce];if(te(ye))return ce}return-1}e.lastIndex=r;function s($,te){return $.length>0?$[0]:te}e.firstOrDefault=s;function i($,te,ce=(ye,Re)=>ye===Re){let ye=0;for(let Re=0,Te=Math.min($.length,te.length);Re<Te&&ce($[Re],te[Re]);Re++)ye++;return ye}e.commonPrefixLength=i;function u($){return[].concat(...$)}e.flatten=u;function f($,te){let ce=typeof te=="number"?$:0;typeof te=="number"?ce=$:(ce=0,te=$);const ye=[];if(ce<=te)for(let Re=ce;Re<te;Re++)ye.push(Re);else for(let Re=ce;Re>te;Re--)ye.push(Re);return ye}e.range=f;function v($,te,ce){return $.reduce((ye,Re)=>(ye[te(Re)]=ce?ce(Re):Re,ye),Object.create(null))}e.index=v;function D($,te){return $.push(te),()=>T($,te)}e.insert=D;function T($,te){const ce=$.indexOf(te);if(ce>-1)return $.splice(ce,1),te}e.remove=T;function o($,te,ce){const ye=$.slice(0,te),Re=$.slice(te);return ye.concat(ce,Re)}e.arrayInsert=o;function A($,te){let ce;if(typeof te=="number"){let ye=te;ce=()=>{const Re=Math.sin(ye++)*179426549;return Re-Math.floor(Re)}}else ce=Math.random;for(let ye=$.length-1;ye>0;ye-=1){const Re=Math.floor(ce()*(ye+1)),Te=$[ye];$[ye]=$[Re],$[Re]=Te}}e.shuffle=A;function L($,te){const ce=$.indexOf(te);ce>-1&&($.splice(ce,1),$.unshift(te))}e.pushToStart=L;function B($,te){const ce=$.indexOf(te);ce>-1&&($.splice(ce,1),$.push(te))}e.pushToEnd=B;function oe($,te){return Array.isArray($)?$.map(te):te($)}e.mapArrayOrNot=oe;function he($){return Array.isArray($)?$:[$]}e.asArray=he;function Q($){return $[Math.floor(Math.random()*$.length)]}e.getRandomElement=Q;function z($,te){for(const ce of $){const ye=te(ce);if(ye!==void 0)return ye}}e.mapFind=z;function V($,te,ce){const ye=K($,te),Re=$.length,Te=ce.length;$.length=Re+Te;for(let $e=Re-1;$e>=ye;$e--)$[$e+Te]=$[$e];for(let $e=0;$e<Te;$e++)$[$e+ye]=ce[$e]}e.insertInto=V;function R($,te,ce,ye){const Re=K($,te),Te=$.splice(Re,ce);return V($,Re,ye),Te}e.splice=R;function K($,te){return te<0?Math.max(te+$.length,0):Math.min(te,$.length)}function x($,te){let ce=Number.MAX_SAFE_INTEGER,ye=0;return $.forEach((Re,Te)=>{const $e=te(Re);$e<ce&&(ce=$e,ye=Te)}),ye}e.minIndex=x;function j($,te){let ce=Number.MIN_SAFE_INTEGER,ye=0;return $.forEach((Re,Te)=>{const $e=te(Re);$e>ce&&(ce=$e,ye=Te)}),ye}e.maxIndex=j;class ue{constructor(te){this.items=te,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(te){let ce=this.firstIdx;for(;ce<this.items.length&&te(this.items[ce]);)ce++;const ye=ce===this.firstIdx?null:this.items.slice(this.firstIdx,ce);return this.firstIdx=ce,ye}takeFromEndWhile(te){let ce=this.lastIdx;for(;ce>=0&&te(this.items[ce]);)ce--;const ye=ce===this.lastIdx?null:this.items.slice(ce+1,this.lastIdx+1);return this.lastIdx=ce,ye}}e.ArrayQueue=ue}),define(be[52],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function g(F){const S=this;let _=!1,C;return function(){return _||(_=!0,C=F.apply(S,arguments)),C}}e.once=g}),define(be[53],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class g{constructor(S){this._prefix=S,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=g,e.defaultGenerator=new g("id#")}),define(be[54],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var g;(function(F){function S(p){return p&&typeof p=="object"&&typeof p[Symbol.iterator]=="function"}F.is=S;const _=Object.freeze([]);function C(){return _}F.empty=C;function*y(p){yield p}F.single=y;function b(p){return p||_}F.from=b;function k(p){return!p||p[Symbol.iterator]().next().done===!0}F.isEmpty=k;function n(p){return p[Symbol.iterator]().next().value}F.first=n;function I(p,t){for(const r of p)if(t(r))return!0;return!1}F.some=I;function l(p,t){for(const r of p)if(t(r))return r}F.find=l;function*d(p,t){for(const r of p)t(r)&&(yield r)}F.filter=d;function*c(p,t){let r=0;for(const s of p)yield t(s,r++)}F.map=c;function*m(...p){for(const t of p)for(const r of t)yield r}F.concat=m;function*E(p){for(const t of p)for(const r of t)yield r}F.concatNested=E;function w(p,t,r){let s=r;for(const i of p)s=t(s,i);return s}F.reduce=w;function*P(p,t,r=p.length){for(t<0&&(t+=p.length),r<0?r+=p.length:r>p.length&&(r=p.length);t<r;t++)yield p[t]}F.slice=P;function a(p,t=Number.POSITIVE_INFINITY){const r=[];if(t===0)return[r,p];const s=p[Symbol.iterator]();for(let i=0;i<t;i++){const u=s.next();if(u.done)return[r,F.empty()];r.push(u.value)}return[r,{[Symbol.iterator](){return s}}]}F.consume=a;function h(p,t,r=(s,i)=>s===i){const s=p[Symbol.iterator](),i=t[Symbol.iterator]();for(;;){const u=s.next(),f=i.next();if(u.done!==f.done)return!1;if(u.done)return!0;if(!r(u.value,f.value))return!1}}F.equals=h})(g=e.Iterable||(e.Iterable={}))}),define(be[111],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var g;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(g=e.ScanError||(e.ScanError={}));var F;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(F=e.SyntaxKind||(e.SyntaxKind={}));var S;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(S=e.ParseErrorCode||(e.ParseErrorCode={}));var _;(function(t){t.DEFAULT={allowTrailingComma:!0}})(_=e.ParseOptions||(e.ParseOptions={}));function C(t,r=!1){let s=0,i=t.length,u="",f=0,v=16,D=0;function T(Q){let z=0,V=0;for(;z<Q;){const R=t.charCodeAt(s);if(R>=48&&R<=57)V=V*16+R-48;else if(R>=65&&R<=70)V=V*16+R-65+10;else if(R>=97&&R<=102)V=V*16+R-97+10;else break;s++,z++}return z<Q&&(V=-1),V}function o(Q){s=Q,u="",f=0,v=16,D=0}function A(){const Q=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&k(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&k(t.charCodeAt(s)))for(s++;s<t.length&&k(t.charCodeAt(s));)s++;else return D=3,t.substring(Q,s);let z=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&k(t.charCodeAt(s))){for(s++;s<t.length&&k(t.charCodeAt(s));)s++;z=s}else D=3;return t.substring(Q,z)}function L(){let Q="",z=s;for(;;){if(s>=i){Q+=t.substring(z,s),D=2;break}const V=t.charCodeAt(s);if(V===34){Q+=t.substring(z,s),s++;break}if(V===92){if(Q+=t.substring(z,s),s++,s>=i){D=2;break}switch(t.charCodeAt(s++)){case 34:Q+='"';break;case 92:Q+="\\";break;case 47:Q+="/";break;case 98:Q+="\b";break;case 102:Q+="\f";break;case 110:Q+=`
`;break;case 114:Q+="\r";break;case 116:Q+="	";break;case 117:const K=T(4);K>=0?Q+=String.fromCharCode(K):D=4;break;default:D=5}z=s;continue}if(V>=0&&V<=31)if(b(V)){Q+=t.substring(z,s),D=2;break}else D=6;s++}return Q}function B(){if(u="",D=0,f=s,s>=i)return f=i,v=17;let Q=t.charCodeAt(s);if(y(Q)){do s++,u+=String.fromCharCode(Q),Q=t.charCodeAt(s);while(y(Q));return v=15}if(b(Q))return s++,u+=String.fromCharCode(Q),Q===13&&t.charCodeAt(s)===10&&(s++,u+=`
`),v=14;switch(Q){case 123:return s++,v=1;case 125:return s++,v=2;case 91:return s++,v=3;case 93:return s++,v=4;case 58:return s++,v=6;case 44:return s++,v=5;case 34:return s++,u=L(),v=10;case 47:const z=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<i&&!b(t.charCodeAt(s));)s++;return u=t.substring(z,s),v=12}if(t.charCodeAt(s+1)===42){s+=2;const V=i-1;let R=!1;for(;s<V;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,R=!0;break}s++}return R||(s++,D=1),u=t.substring(z,s),v=13}return u+=String.fromCharCode(Q),s++,v=16;case 45:if(u+=String.fromCharCode(Q),s++,s===i||!k(t.charCodeAt(s)))return v=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return u+=A(),v=11;default:for(;s<i&&oe(Q);)s++,Q=t.charCodeAt(s);if(f!==s){switch(u=t.substring(f,s),u){case"true":return v=8;case"false":return v=9;case"null":return v=7}return v=16}return u+=String.fromCharCode(Q),s++,v=16}}function oe(Q){if(y(Q)||b(Q))return!1;switch(Q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function he(){let Q;do Q=B();while(Q>=12&&Q<=15);return Q}return{setPosition:o,getPosition:()=>s,scan:r?he:B,getToken:()=>v,getTokenValue:()=>u,getTokenOffset:()=>f,getTokenLength:()=>s-f,getTokenError:()=>D}}e.createScanner=C;function y(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function b(t){return t===10||t===13||t===8232||t===8233}function k(t){return t>=48&&t<=57}var n;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(n||(n={}));function I(t,r){const s=[],i=new Object;let u;const f={value:{},offset:0,length:0,type:"object",parent:void 0};let v=!1;function D(T,o,A,L){f.value=T,f.offset=o,f.length=A,f.type=L,f.colonOffset=void 0,u=f}try{a(t,{onObjectBegin:(T,o)=>{if(r<=T)throw i;u=void 0,v=r>T,s.push("")},onObjectProperty:(T,o,A)=>{if(r<o||(D(T,o,A,"property"),s[s.length-1]=T,r<=o+A))throw i},onObjectEnd:(T,o)=>{if(r<=T)throw i;u=void 0,s.pop()},onArrayBegin:(T,o)=>{if(r<=T)throw i;u=void 0,s.push(0)},onArrayEnd:(T,o)=>{if(r<=T)throw i;u=void 0,s.pop()},onLiteralValue:(T,o,A)=>{if(r<o||(D(T,o,A,p(T)),r<=o+A))throw i},onSeparator:(T,o,A)=>{if(r<=o)throw i;if(T===":"&&u&&u.type==="property")u.colonOffset=o,v=!1,u=void 0;else if(T===","){const L=s[s.length-1];typeof L=="number"?s[s.length-1]=L+1:(v=!0,s[s.length-1]=""),u=void 0}}})}catch(T){if(T!==i)throw T}return{path:s,previousNode:u,isAtPropertyKey:v,matches:T=>{let o=0;for(let A=0;o<T.length&&A<s.length;A++)if(T[o]===s[A]||T[o]==="*")o++;else if(T[o]!=="**")return!1;return o===T.length}}}e.getLocation=I;function l(t,r=[],s=_.DEFAULT){let i=null,u=[];const f=[];function v(T){Array.isArray(u)?u.push(T):i!==null&&(u[i]=T)}return a(t,{onObjectBegin:()=>{const T={};v(T),f.push(u),u=T,i=null},onObjectProperty:T=>{i=T},onObjectEnd:()=>{u=f.pop()},onArrayBegin:()=>{const T=[];v(T),f.push(u),u=T,i=null},onArrayEnd:()=>{u=f.pop()},onLiteralValue:v,onError:(T,o,A)=>{r.push({error:T,offset:o,length:A})}},s),u[0]}e.parse=l;function d(t,r=[],s=_.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function u(T){i.type==="property"&&(i.length=T-i.offset,i=i.parent)}function f(T){return i.children.push(T),T}a(t,{onObjectBegin:T=>{i=f({type:"object",offset:T,length:-1,parent:i,children:[]})},onObjectProperty:(T,o,A)=>{i=f({type:"property",offset:o,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:T,offset:o,length:A,parent:i})},onObjectEnd:(T,o)=>{i.length=T+o-i.offset,i=i.parent,u(T+o)},onArrayBegin:(T,o)=>{i=f({type:"array",offset:T,length:-1,parent:i,children:[]})},onArrayEnd:(T,o)=>{i.length=T+o-i.offset,i=i.parent,u(T+o)},onLiteralValue:(T,o,A)=>{f({type:p(T),offset:o,length:A,parent:i,value:T}),u(o+A)},onSeparator:(T,o,A)=>{i.type==="property"&&(T===":"?i.colonOffset=o:T===","&&u(o))},onError:(T,o,A)=>{r.push({error:T,offset:o,length:A})}},s);const D=i.children[0];return D&&delete D.parent,D}e.parseTree=d;function c(t,r){if(!t)return;let s=t;for(let i of r)if(typeof i=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let u=!1;for(const f of s.children)if(Array.isArray(f.children)&&f.children[0].value===i){s=f.children[1],u=!0;break}if(!u)return}else{const u=i;if(s.type!=="array"||u<0||!Array.isArray(s.children)||u>=s.children.length)return;s=s.children[u]}return s}e.findNodeAtLocation=c;function m(t){if(!t.parent||!t.parent.children)return[];const r=m(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;r.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&r.push(s)}return r}e.getNodePath=m;function E(t){switch(t.type){case"array":return t.children.map(E);case"object":const r=Object.create(null);for(let s of t.children){const i=s.children[1];i&&(r[s.children[0].value]=E(i))}return r;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=E;function w(t,r,s=!1){return r>=t.offset&&r<t.offset+t.length||s&&r===t.offset+t.length}e.contains=w;function P(t,r,s=!1){if(w(t,r,s)){const i=t.children;if(Array.isArray(i))for(let u=0;u<i.length&&i[u].offset<=r;u++){const f=P(i[u],r,s);if(f)return f}return t}}e.findNodeAtOffset=P;function a(t,r,s=_.DEFAULT){const i=C(t,!1);function u(ce){return ce?()=>ce(i.getTokenOffset(),i.getTokenLength()):()=>!0}function f(ce){return ce?ye=>ce(ye,i.getTokenOffset(),i.getTokenLength()):()=>!0}const v=u(r.onObjectBegin),D=f(r.onObjectProperty),T=u(r.onObjectEnd),o=u(r.onArrayBegin),A=u(r.onArrayEnd),L=f(r.onLiteralValue),B=f(r.onSeparator),oe=u(r.onComment),he=f(r.onError),Q=s&&s.disallowComments,z=s&&s.allowTrailingComma;function V(){for(;;){const ce=i.scan();switch(i.getTokenError()){case 4:R(14);break;case 5:R(15);break;case 3:R(13);break;case 1:Q||R(11);break;case 2:R(12);break;case 6:R(16);break}switch(ce){case 12:case 13:Q?R(10):oe();break;case 16:R(1);break;case 15:case 14:break;default:return ce}}}function R(ce,ye=[],Re=[]){if(he(ce),ye.length+Re.length>0){let Te=i.getToken();for(;Te!==17;){if(ye.indexOf(Te)!==-1){V();break}else if(Re.indexOf(Te)!==-1)break;Te=V()}}}function K(ce){const ye=i.getTokenValue();return ce?L(ye):D(ye),V(),!0}function x(){switch(i.getToken()){case 11:let ce=0;try{ce=JSON.parse(i.getTokenValue()),typeof ce!="number"&&(R(2),ce=0)}catch(ye){R(2)}L(ce);break;case 7:L(null);break;case 8:L(!0);break;case 9:L(!1);break;default:return!1}return V(),!0}function j(){return i.getToken()!==10?(R(3,[],[2,5]),!1):(K(!1),i.getToken()===6?(B(":"),V(),te()||R(4,[],[2,5])):R(5,[],[2,5]),!0)}function ue(){v(),V();let ce=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(ce||R(4,[],[]),B(","),V(),i.getToken()===2&&z)break}else ce&&R(6,[],[]);j()||R(4,[],[2,5]),ce=!0}return T(),i.getToken()!==2?R(7,[2],[]):V(),!0}function $(){o(),V();let ce=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(ce||R(4,[],[]),B(","),V(),i.getToken()===4&&z)break}else ce&&R(6,[],[]);te()||R(4,[],[4,5]),ce=!0}return A(),i.getToken()!==4?R(8,[4],[]):V(),!0}function te(){switch(i.getToken()){case 3:return $();case 1:return ue();case 10:return K(!0);default:return x()}}return V(),i.getToken()===17?s.allowEmptyContent?!0:(R(4,[],[]),!1):te()?(i.getToken()!==17&&R(9,[],[]),!0):(R(4,[],[]),!1)}e.visit=a;function h(t,r){let s=C(t),i=[],u,f=0,v;do switch(v=s.getPosition(),u=s.scan(),u){case 12:case 13:case 17:f!==v&&i.push(t.substring(f,v)),r!==void 0&&i.push(s.getTokenValue().replace(/[^\r\n]/g,r)),f=s.getPosition();break}while(u!==17);return i.join("")}e.stripComments=h;function p(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=p}),define(be[112],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class g{constructor(S){this.executor=S,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(S){this._error=S}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(S){return new g(()=>S(this.getValue()))}}e.Lazy=g}),define(be[6],Ee([0,1,52,54]),function(ee,e,g,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const S=!1;let _=null;function C(s){_=s}if(e.setDisposableTracker=C,S){const s="__is_disposable_tracked__";C(new class{trackDisposable(i){const u=new Error("Potentially leaked disposable").stack;setTimeout(()=>{i[s]||console.log(u)},3e3)}setParent(i,u){if(i&&i!==P.None)try{i[s]=!0}catch{}}markAsDisposed(i){if(i&&i!==P.None)try{i[s]=!0}catch{}}markAsSingleton(i){}})}function y(s){return _?.trackDisposable(s),s}function b(s){_?.markAsDisposed(s)}function k(s,i){_?.setParent(s,i)}function n(s,i){if(!!_)for(const u of s)_.setParent(u,i)}function I(s){return _?.markAsSingleton(s),s}e.markAsSingleton=I;class l extends Error{constructor(i){super(`Encountered errors while disposing of store. Errors: [${i.join(", ")}]`);this.errors=i}}e.MultiDisposeError=l;function d(s){return typeof s.dispose=="function"&&s.dispose.length===0}e.isDisposable=d;function c(s){if(F.Iterable.is(s)){let i=[];for(const u of s)if(u)try{u.dispose()}catch(f){i.push(f)}if(i.length===1)throw i[0];if(i.length>1)throw new l(i);return Array.isArray(s)?[]:s}else if(s)return s.dispose(),s}e.dispose=c;function m(...s){const i=E(()=>c(s));return n(s,i),i}e.combinedDisposable=m;function E(s){const i=y({dispose:(0,g.once)(()=>{b(i),s()})});return i}e.toDisposable=E;class w{constructor(){this._toDispose=new Set,this._isDisposed=!1,y(this)}dispose(){this._isDisposed||(b(this),this._isDisposed=!0,this.clear())}clear(){try{c(this._toDispose.values())}finally{this._toDispose.clear()}}add(i){if(!i)return i;if(i===this)throw new Error("Cannot register a disposable on itself!");return k(i,this),this._isDisposed?w.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(i),i}}e.DisposableStore=w,w.DISABLE_DISPOSED_WARNING=!1;class P{constructor(){this._store=new w,y(this),k(this._store,this)}dispose(){b(this),this._store.dispose()}_register(i){if(i===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(i)}}e.Disposable=P,P.None=Object.freeze({dispose(){}});class a{constructor(){this._isDisposed=!1,y(this)}get value(){return this._isDisposed?void 0:this._value}set value(i){this._isDisposed||i===this._value||(this._value?.dispose(),i&&k(i,this),this._value=i)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,b(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const i=this._value;return this._value=void 0,i&&k(i,null),i}}e.MutableDisposable=a;class h{constructor(i){this._disposable=i,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=h;class p{constructor(){this.references=new Map}acquire(i,...u){let f=this.references.get(i);f||(f={counter:0,object:this.createReferencedObject(i,...u)},this.references.set(i,f));const{object:v}=f,D=(0,g.once)(()=>{--f.counter==0&&(this.destroyReferencedObject(i,f.object),this.references.delete(i))});return f.counter++,{object:v,dispose:D}}}e.ReferenceCollection=p;class t{constructor(i){this.referenceCollection=i}async acquire(i,...u){const f=this.referenceCollection.acquire(i,...u);try{return{object:await f.object,dispose:()=>f.dispose()}}catch(v){throw f.dispose(),v}}}e.AsyncReferenceCollection=t;class r{constructor(i){this.object=i}dispose(){}}e.ImmortalReference=r}),define(be[80],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class g{constructor(_){this.element=_,this.next=g.Undefined,this.prev=g.Undefined}}g.Undefined=new g(void 0);class F{constructor(){this._first=g.Undefined,this._last=g.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===g.Undefined}clear(){let _=this._first;for(;_!==g.Undefined;){const C=_.next;_.prev=g.Undefined,_.next=g.Undefined,_=C}this._first=g.Undefined,this._last=g.Undefined,this._size=0}unshift(_){return this._insert(_,!1)}push(_){return this._insert(_,!0)}_insert(_,C){const y=new g(_);if(this._first===g.Undefined)this._first=y,this._last=y;else if(C){const k=this._last;this._last=y,y.prev=k,k.next=y}else{const k=this._first;this._first=y,y.next=k,k.prev=y}this._size+=1;let b=!1;return()=>{b||(b=!0,this._remove(y))}}shift(){if(this._first!==g.Undefined){const _=this._first.element;return this._remove(this._first),_}}pop(){if(this._last!==g.Undefined){const _=this._last.element;return this._remove(this._last),_}}_remove(_){if(_.prev!==g.Undefined&&_.next!==g.Undefined){const C=_.prev;C.next=_.next,_.next.prev=C}else _.prev===g.Undefined&&_.next===g.Undefined?(this._first=g.Undefined,this._last=g.Undefined):_.next===g.Undefined?(this._last=this._last.prev,this._last.next=g.Undefined):_.prev===g.Undefined&&(this._first=this._first.next,this._first.prev=g.Undefined);this._size-=1}*[Symbol.iterator](){let _=this._first;for(;_!==g.Undefined;)yield _.element,_=_.next}}e.LinkedList=F}),function(ee,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(ee=typeof globalThis!="undefined"?globalThis:ee||self,ee.marked=e())}(this,function(){"use strict";function ee(De,Se){for(var Pe=0;Pe<Se.length;Pe++){var re=Se[Pe];re.enumerable=re.enumerable||!1,re.configurable=!0,"value"in re&&(re.writable=!0),Object.defineProperty(De,re.key,re)}}function e(De,Se,Pe){return Se&&ee(De.prototype,Se),Pe&&ee(De,Pe),De}function g(De,Se){if(!!De){if(typeof De=="string")return F(De,Se);var Pe=Object.prototype.toString.call(De).slice(8,-1);if(Pe==="Object"&&De.constructor&&(Pe=De.constructor.name),Pe==="Map"||Pe==="Set")return Array.from(De);if(Pe==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Pe))return F(De,Se)}}function F(De,Se){(Se==null||Se>De.length)&&(Se=De.length);for(var Pe=0,re=new Array(Se);Pe<Se;Pe++)re[Pe]=De[Pe];return re}function S(De,Se){var Pe;if(typeof Symbol=="undefined"||De[Symbol.iterator]==null){if(Array.isArray(De)||(Pe=g(De))||Se&&De&&typeof De.length=="number"){Pe&&(De=Pe);var re=0;return function(){return re>=De.length?{done:!0}:{done:!1,value:De[re++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return Pe=De[Symbol.iterator](),Pe.next.bind(Pe)}function _(De){var Se={exports:{}};return De(Se,Se.exports),Se.exports}var C=_(function(De){function Se(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function Pe(re){De.exports.defaults=re}De.exports={defaults:Se(),getDefaults:Se,changeDefaults:Pe}}),y=/[&<>"']/,b=/[&<>"']/g,k=/[<>"']|&(?!#?\w+;)/,n=/[<>"']|&(?!#?\w+;)/g,I={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},l=function(Se){return I[Se]};function d(De,Se){if(Se){if(y.test(De))return De.replace(b,l)}else if(k.test(De))return De.replace(n,l);return De}var c=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function m(De){return De.replace(c,function(Se,Pe){return Pe=Pe.toLowerCase(),Pe==="colon"?":":Pe.charAt(0)==="#"?Pe.charAt(1)==="x"?String.fromCharCode(parseInt(Pe.substring(2),16)):String.fromCharCode(+Pe.substring(1)):""})}var E=/(^|[^\[])\^/g;function w(De,Se){De=De.source||De,Se=Se||"";var Pe={replace:function(ae,fe){return fe=fe.source||fe,fe=fe.replace(E,"$1"),De=De.replace(ae,fe),Pe},getRegex:function(){return new RegExp(De,Se)}};return Pe}var P=/[^\w:]/g,a=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function h(De,Se,Pe){if(De){var re;try{re=decodeURIComponent(m(Pe)).replace(P,"").toLowerCase()}catch(ae){return null}if(re.indexOf("javascript:")===0||re.indexOf("vbscript:")===0||re.indexOf("data:")===0)return null}Se&&!a.test(Pe)&&(Pe=i(Se,Pe));try{Pe=encodeURI(Pe).replace(/%25/g,"%")}catch(ae){return null}return Pe}var p={},t=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,s=/^([^:]+:\/*[^/]*)[\s\S]*$/;function i(De,Se){p[" "+De]||(t.test(De)?p[" "+De]=De+"/":p[" "+De]=D(De,"/",!0)),De=p[" "+De];var Pe=De.indexOf(":")===-1;return Se.substring(0,2)==="//"?Pe?Se:De.replace(r,"$1")+Se:Se.charAt(0)==="/"?Pe?Se:De.replace(s,"$1")+Se:De+Se}var u={exec:function(){}};function f(De){for(var Se=1,Pe,re;Se<arguments.length;Se++){Pe=arguments[Se];for(re in Pe)Object.prototype.hasOwnProperty.call(Pe,re)&&(De[re]=Pe[re])}return De}function v(De,Se){var Pe=De.replace(/\|/g,function(fe,pe,U){for(var me=!1,we=pe;--we>=0&&U[we]==="\\";)me=!me;return me?"|":" |"}),re=Pe.split(/ \|/),ae=0;if(re.length>Se)re.splice(Se);else for(;re.length<Se;)re.push("");for(;ae<re.length;ae++)re[ae]=re[ae].trim().replace(/\\\|/g,"|");return re}function D(De,Se,Pe){var re=De.length;if(re===0)return"";for(var ae=0;ae<re;){var fe=De.charAt(re-ae-1);if(fe===Se&&!Pe)ae++;else if(fe!==Se&&Pe)ae++;else break}return De.substr(0,re-ae)}function T(De,Se){if(De.indexOf(Se[1])===-1)return-1;for(var Pe=De.length,re=0,ae=0;ae<Pe;ae++)if(De[ae]==="\\")ae++;else if(De[ae]===Se[0])re++;else if(De[ae]===Se[1]&&(re--,re<0))return ae;return-1}function o(De){De&&De.sanitize&&!De.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function A(De,Se){if(Se<1)return"";for(var Pe="";Se>1;)Se&1&&(Pe+=De),Se>>=1,De+=De;return Pe+De}var L={escape:d,unescape:m,edit:w,cleanUrl:h,resolveUrl:i,noopTest:u,merge:f,splitCells:v,rtrim:D,findClosingBracket:T,checkSanitizeDeprecation:o,repeatString:A},B=C.defaults,oe=L.rtrim,he=L.splitCells,Q=L.escape,z=L.findClosingBracket;function V(De,Se,Pe){var re=Se.href,ae=Se.title?Q(Se.title):null,fe=De[1].replace(/\\([\[\]])/g,"$1");return De[0].charAt(0)!=="!"?{type:"link",raw:Pe,href:re,title:ae,text:fe}:{type:"image",raw:Pe,href:re,title:ae,text:Q(fe)}}function R(De,Se){var Pe=De.match(/^(\s+)(?:```)/);if(Pe===null)return Se;var re=Pe[1];return Se.split(`
`).map(function(ae){var fe=ae.match(/^\s+/);if(fe===null)return ae;var pe=fe[0];return pe.length>=re.length?ae.slice(re.length):ae}).join(`
`)}var K=function(){function De(Pe){this.options=Pe||B}var Se=De.prototype;return Se.space=function(re){var ae=this.rules.block.newline.exec(re);if(ae)return ae[0].length>1?{type:"space",raw:ae[0]}:{raw:`
`}},Se.code=function(re){var ae=this.rules.block.code.exec(re);if(ae){var fe=ae[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ae[0],codeBlockStyle:"indented",text:this.options.pedantic?fe:oe(fe,`
`)}}},Se.fences=function(re){var ae=this.rules.block.fences.exec(re);if(ae){var fe=ae[0],pe=R(fe,ae[3]||"");return{type:"code",raw:fe,lang:ae[2]?ae[2].trim():ae[2],text:pe}}},Se.heading=function(re){var ae=this.rules.block.heading.exec(re);if(ae){var fe=ae[2].trim();if(/#$/.test(fe)){var pe=oe(fe,"#");(this.options.pedantic||!pe||/ $/.test(pe))&&(fe=pe.trim())}return{type:"heading",raw:ae[0],depth:ae[1].length,text:fe}}},Se.nptable=function(re){var ae=this.rules.block.nptable.exec(re);if(ae){var fe={type:"table",header:he(ae[1].replace(/^ *| *\| *$/g,"")),align:ae[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ae[3]?ae[3].replace(/\n$/,"").split(`
`):[],raw:ae[0]};if(fe.header.length===fe.align.length){var pe=fe.align.length,U;for(U=0;U<pe;U++)/^ *-+: *$/.test(fe.align[U])?fe.align[U]="right":/^ *:-+: *$/.test(fe.align[U])?fe.align[U]="center":/^ *:-+ *$/.test(fe.align[U])?fe.align[U]="left":fe.align[U]=null;for(pe=fe.cells.length,U=0;U<pe;U++)fe.cells[U]=he(fe.cells[U],fe.header.length);return fe}}},Se.hr=function(re){var ae=this.rules.block.hr.exec(re);if(ae)return{type:"hr",raw:ae[0]}},Se.blockquote=function(re){var ae=this.rules.block.blockquote.exec(re);if(ae){var fe=ae[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ae[0],text:fe}}},Se.list=function(re){var ae=this.rules.block.list.exec(re);if(ae){var fe=ae[0],pe=ae[2],U=pe.length>1,me={type:"list",raw:fe,ordered:U,start:U?+pe.slice(0,-1):"",loose:!1,items:[]},we=ae[0].match(this.rules.block.item),Ie=!1,Oe,He,et,Qe,Ke,lt,ft,_t,ut=we.length;et=this.rules.block.listItemStart.exec(we[0]);for(var ot=0;ot<ut;ot++){if(Oe=we[ot],fe=Oe,ot!==ut-1){if(Qe=this.rules.block.listItemStart.exec(we[ot+1]),this.options.pedantic?Qe[1].length>et[1].length:Qe[1].length>et[0].length||Qe[1].length>3){we.splice(ot,2,we[ot]+`
`+we[ot+1]),ot--,ut--;continue}else(!this.options.pedantic||this.options.smartLists?Qe[2][Qe[2].length-1]!==pe[pe.length-1]:U===(Qe[2].length===1))&&(Ke=we.slice(ot+1).join(`
`),me.raw=me.raw.substring(0,me.raw.length-Ke.length),ot=ut-1);et=Qe}He=Oe.length,Oe=Oe.replace(/^ *([*+-]|\d+[.)]) ?/,""),~Oe.indexOf(`
 `)&&(He-=Oe.length,Oe=this.options.pedantic?Oe.replace(/^ {1,4}/gm,""):Oe.replace(new RegExp("^ {1,"+He+"}","gm"),"")),lt=Ie||/\n\n(?!\s*$)/.test(Oe),ot!==ut-1&&(Ie=Oe.charAt(Oe.length-1)===`
`,lt||(lt=Ie)),lt&&(me.loose=!0),this.options.gfm&&(ft=/^\[[ xX]\] /.test(Oe),_t=void 0,ft&&(_t=Oe[1]!==" ",Oe=Oe.replace(/^\[[ xX]\] +/,""))),me.items.push({type:"list_item",raw:fe,task:ft,checked:_t,loose:lt,text:Oe})}return me}},Se.html=function(re){var ae=this.rules.block.html.exec(re);if(ae)return{type:this.options.sanitize?"paragraph":"html",raw:ae[0],pre:!this.options.sanitizer&&(ae[1]==="pre"||ae[1]==="script"||ae[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ae[0]):Q(ae[0]):ae[0]}},Se.def=function(re){var ae=this.rules.block.def.exec(re);if(ae){ae[3]&&(ae[3]=ae[3].substring(1,ae[3].length-1));var fe=ae[1].toLowerCase().replace(/\s+/g," ");return{tag:fe,raw:ae[0],href:ae[2],title:ae[3]}}},Se.table=function(re){var ae=this.rules.block.table.exec(re);if(ae){var fe={type:"table",header:he(ae[1].replace(/^ *| *\| *$/g,"")),align:ae[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ae[3]?ae[3].replace(/\n$/,"").split(`
`):[]};if(fe.header.length===fe.align.length){fe.raw=ae[0];var pe=fe.align.length,U;for(U=0;U<pe;U++)/^ *-+: *$/.test(fe.align[U])?fe.align[U]="right":/^ *:-+: *$/.test(fe.align[U])?fe.align[U]="center":/^ *:-+ *$/.test(fe.align[U])?fe.align[U]="left":fe.align[U]=null;for(pe=fe.cells.length,U=0;U<pe;U++)fe.cells[U]=he(fe.cells[U].replace(/^ *\| *| *\| *$/g,""),fe.header.length);return fe}}},Se.lheading=function(re){var ae=this.rules.block.lheading.exec(re);if(ae)return{type:"heading",raw:ae[0],depth:ae[2].charAt(0)==="="?1:2,text:ae[1]}},Se.paragraph=function(re){var ae=this.rules.block.paragraph.exec(re);if(ae)return{type:"paragraph",raw:ae[0],text:ae[1].charAt(ae[1].length-1)===`
`?ae[1].slice(0,-1):ae[1]}},Se.text=function(re){var ae=this.rules.block.text.exec(re);if(ae)return{type:"text",raw:ae[0],text:ae[0]}},Se.escape=function(re){var ae=this.rules.inline.escape.exec(re);if(ae)return{type:"escape",raw:ae[0],text:Q(ae[1])}},Se.tag=function(re,ae,fe){var pe=this.rules.inline.tag.exec(re);if(pe)return!ae&&/^<a /i.test(pe[0])?ae=!0:ae&&/^<\/a>/i.test(pe[0])&&(ae=!1),!fe&&/^<(pre|code|kbd|script)(\s|>)/i.test(pe[0])?fe=!0:fe&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(pe[0])&&(fe=!1),{type:this.options.sanitize?"text":"html",raw:pe[0],inLink:ae,inRawBlock:fe,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(pe[0]):Q(pe[0]):pe[0]}},Se.link=function(re){var ae=this.rules.inline.link.exec(re);if(ae){var fe=ae[2].trim();if(!this.options.pedantic&&/^</.test(fe)){if(!/>$/.test(fe))return;var pe=oe(fe.slice(0,-1),"\\");if((fe.length-pe.length)%2==0)return}else{var U=z(ae[2],"()");if(U>-1){var me=ae[0].indexOf("!")===0?5:4,we=me+ae[1].length+U;ae[2]=ae[2].substring(0,U),ae[0]=ae[0].substring(0,we).trim(),ae[3]=""}}var Ie=ae[2],Oe="";if(this.options.pedantic){var He=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ie);He&&(Ie=He[1],Oe=He[3])}else Oe=ae[3]?ae[3].slice(1,-1):"";return Ie=Ie.trim(),/^</.test(Ie)&&(this.options.pedantic&&!/>$/.test(fe)?Ie=Ie.slice(1):Ie=Ie.slice(1,-1)),V(ae,{href:Ie&&Ie.replace(this.rules.inline._escapes,"$1"),title:Oe&&Oe.replace(this.rules.inline._escapes,"$1")},ae[0])}},Se.reflink=function(re,ae){var fe;if((fe=this.rules.inline.reflink.exec(re))||(fe=this.rules.inline.nolink.exec(re))){var pe=(fe[2]||fe[1]).replace(/\s+/g," ");if(pe=ae[pe.toLowerCase()],!pe||!pe.href){var U=fe[0].charAt(0);return{type:"text",raw:U,text:U}}return V(fe,pe,fe[0])}},Se.emStrong=function(re,ae,fe){fe===void 0&&(fe="");var pe=this.rules.inline.emStrong.lDelim.exec(re);if(!!pe&&!(pe[3]&&fe.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var U=pe[1]||pe[2]||"";if(!U||U&&(fe===""||this.rules.inline.punctuation.exec(fe))){var me=pe[0].length-1,we,Ie,Oe=me,He=0,et=pe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(et.lastIndex=0,ae=ae.slice(-1*re.length+me);(pe=et.exec(ae))!=null;)if(we=pe[1]||pe[2]||pe[3]||pe[4]||pe[5]||pe[6],!!we){if(Ie=we.length,pe[3]||pe[4]){Oe+=Ie;continue}else if((pe[5]||pe[6])&&me%3&&!((me+Ie)%3)){He+=Ie;continue}if(Oe-=Ie,!(Oe>0)){if(Oe+He-Ie<=0&&!ae.slice(et.lastIndex).match(et)&&(Ie=Math.min(Ie,Ie+Oe+He)),Math.min(me,Ie)%2)return{type:"em",raw:re.slice(0,me+pe.index+Ie+1),text:re.slice(1,me+pe.index+Ie)};if(Math.min(me,Ie)%2==0)return{type:"strong",raw:re.slice(0,me+pe.index+Ie+1),text:re.slice(2,me+pe.index+Ie-1)}}}}}},Se.codespan=function(re){var ae=this.rules.inline.code.exec(re);if(ae){var fe=ae[2].replace(/\n/g," "),pe=/[^ ]/.test(fe),U=/^ /.test(fe)&&/ $/.test(fe);return pe&&U&&(fe=fe.substring(1,fe.length-1)),fe=Q(fe,!0),{type:"codespan",raw:ae[0],text:fe}}},Se.br=function(re){var ae=this.rules.inline.br.exec(re);if(ae)return{type:"br",raw:ae[0]}},Se.del=function(re){var ae=this.rules.inline.del.exec(re);if(ae)return{type:"del",raw:ae[0],text:ae[2]}},Se.autolink=function(re,ae){var fe=this.rules.inline.autolink.exec(re);if(fe){var pe,U;return fe[2]==="@"?(pe=Q(this.options.mangle?ae(fe[1]):fe[1]),U="mailto:"+pe):(pe=Q(fe[1]),U=pe),{type:"link",raw:fe[0],text:pe,href:U,tokens:[{type:"text",raw:pe,text:pe}]}}},Se.url=function(re,ae){var fe;if(fe=this.rules.inline.url.exec(re)){var pe,U;if(fe[2]==="@")pe=Q(this.options.mangle?ae(fe[0]):fe[0]),U="mailto:"+pe;else{var me;do me=fe[0],fe[0]=this.rules.inline._backpedal.exec(fe[0])[0];while(me!==fe[0]);pe=Q(fe[0]),fe[1]==="www."?U="http://"+pe:U=pe}return{type:"link",raw:fe[0],text:pe,href:U,tokens:[{type:"text",raw:pe,text:pe}]}}},Se.inlineText=function(re,ae,fe){var pe=this.rules.inline.text.exec(re);if(pe){var U;return ae?U=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(pe[0]):Q(pe[0]):pe[0]:U=Q(this.options.smartypants?fe(pe[0]):pe[0]),{type:"text",raw:pe[0],text:U}}},De}(),x=L.noopTest,j=L.edit,ue=L.merge,$={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:x,table:x,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};$._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,$._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,$.def=j($.def).replace("label",$._label).replace("title",$._title).getRegex(),$.bullet=/(?:[*+-]|\d{1,9}[.)])/,$.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,$.item=j($.item,"gm").replace(/bull/g,$.bullet).getRegex(),$.listItemStart=j(/^( *)(bull)/).replace("bull",$.bullet).getRegex(),$.list=j($.list).replace(/bull/g,$.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+$.def.source+")").getRegex(),$._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",$._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,$.html=j($.html,"i").replace("comment",$._comment).replace("tag",$._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),$.paragraph=j($._paragraph).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",$._tag).getRegex(),$.blockquote=j($.blockquote).replace("paragraph",$.paragraph).getRegex(),$.normal=ue({},$),$.gfm=ue({},$.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),$.gfm.nptable=j($.gfm.nptable).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",$._tag).getRegex(),$.gfm.table=j($.gfm.table).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",$._tag).getRegex(),$.pedantic=ue({},$.normal,{html:j(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",$._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:x,paragraph:j($.normal._paragraph).replace("hr",$.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",$.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var te={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:x,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:x,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};te._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",te.punctuation=j(te.punctuation).replace(/punctuation/g,te._punctuation).getRegex(),te.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,te.escapedEmSt=/\\\*|\\_/g,te._comment=j($._comment).replace("(?:-->|$)","-->").getRegex(),te.emStrong.lDelim=j(te.emStrong.lDelim).replace(/punct/g,te._punctuation).getRegex(),te.emStrong.rDelimAst=j(te.emStrong.rDelimAst,"g").replace(/punct/g,te._punctuation).getRegex(),te.emStrong.rDelimUnd=j(te.emStrong.rDelimUnd,"g").replace(/punct/g,te._punctuation).getRegex(),te._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,te._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,te._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,te.autolink=j(te.autolink).replace("scheme",te._scheme).replace("email",te._email).getRegex(),te._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,te.tag=j(te.tag).replace("comment",te._comment).replace("attribute",te._attribute).getRegex(),te._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,te._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,te._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,te.link=j(te.link).replace("label",te._label).replace("href",te._href).replace("title",te._title).getRegex(),te.reflink=j(te.reflink).replace("label",te._label).getRegex(),te.reflinkSearch=j(te.reflinkSearch,"g").replace("reflink",te.reflink).replace("nolink",te.nolink).getRegex(),te.normal=ue({},te),te.pedantic=ue({},te.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:j(/^!?\[(label)\]\((.*?)\)/).replace("label",te._label).getRegex(),reflink:j(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",te._label).getRegex()}),te.gfm=ue({},te.normal,{escape:j(te.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),te.gfm.url=j(te.gfm.url,"i").replace("email",te.gfm._extended_email).getRegex(),te.breaks=ue({},te.gfm,{br:j(te.br).replace("{2,}","*").getRegex(),text:j(te.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var ce={block:$,inline:te},ye=C.defaults,Re=ce.block,Te=ce.inline,$e=L.repeatString;function Je(De){return De.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Ve(De){var Se="",Pe,re,ae=De.length;for(Pe=0;Pe<ae;Pe++)re=De.charCodeAt(Pe),Math.random()>.5&&(re="x"+re.toString(16)),Se+="&#"+re+";";return Se}var je=function(){function De(Pe){this.tokens=[],this.tokens.links=Object.create(null),this.options=Pe||ye,this.options.tokenizer=this.options.tokenizer||new K,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var re={block:Re.normal,inline:Te.normal};this.options.pedantic?(re.block=Re.pedantic,re.inline=Te.pedantic):this.options.gfm&&(re.block=Re.gfm,this.options.breaks?re.inline=Te.breaks:re.inline=Te.gfm),this.tokenizer.rules=re}De.lex=function(re,ae){var fe=new De(ae);return fe.lex(re)},De.lexInline=function(re,ae){var fe=new De(ae);return fe.inlineTokens(re)};var Se=De.prototype;return Se.lex=function(re){return re=re.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(re,this.tokens,!0),this.inline(this.tokens),this.tokens},Se.blockTokens=function(re,ae,fe){ae===void 0&&(ae=[]),fe===void 0&&(fe=!0),this.options.pedantic&&(re=re.replace(/^ +$/gm,""));for(var pe,U,me,we;re;){if(pe=this.tokenizer.space(re)){re=re.substring(pe.raw.length),pe.type&&ae.push(pe);continue}if(pe=this.tokenizer.code(re)){re=re.substring(pe.raw.length),we=ae[ae.length-1],we&&we.type==="paragraph"?(we.raw+=`
`+pe.raw,we.text+=`
`+pe.text):ae.push(pe);continue}if(pe=this.tokenizer.fences(re)){re=re.substring(pe.raw.length),ae.push(pe);continue}if(pe=this.tokenizer.heading(re)){re=re.substring(pe.raw.length),ae.push(pe);continue}if(pe=this.tokenizer.nptable(re)){re=re.substring(pe.raw.length),ae.push(pe);continue}if(pe=this.tokenizer.hr(re)){re=re.substring(pe.raw.length),ae.push(pe);continue}if(pe=this.tokenizer.blockquote(re)){re=re.substring(pe.raw.length),pe.tokens=this.blockTokens(pe.text,[],fe),ae.push(pe);continue}if(pe=this.tokenizer.list(re)){for(re=re.substring(pe.raw.length),me=pe.items.length,U=0;U<me;U++)pe.items[U].tokens=this.blockTokens(pe.items[U].text,[],!1);ae.push(pe);continue}if(pe=this.tokenizer.html(re)){re=re.substring(pe.raw.length),ae.push(pe);continue}if(fe&&(pe=this.tokenizer.def(re))){re=re.substring(pe.raw.length),this.tokens.links[pe.tag]||(this.tokens.links[pe.tag]={href:pe.href,title:pe.title});continue}if(pe=this.tokenizer.table(re)){re=re.substring(pe.raw.length),ae.push(pe);continue}if(pe=this.tokenizer.lheading(re)){re=re.substring(pe.raw.length),ae.push(pe);continue}if(fe&&(pe=this.tokenizer.paragraph(re))){re=re.substring(pe.raw.length),ae.push(pe);continue}if(pe=this.tokenizer.text(re)){re=re.substring(pe.raw.length),we=ae[ae.length-1],we&&we.type==="text"?(we.raw+=`
`+pe.raw,we.text+=`
`+pe.text):ae.push(pe);continue}if(re){var Ie="Infinite loop on byte: "+re.charCodeAt(0);if(this.options.silent){console.error(Ie);break}else throw new Error(Ie)}}return ae},Se.inline=function(re){var ae,fe,pe,U,me,we,Ie=re.length;for(ae=0;ae<Ie;ae++)switch(we=re[ae],we.type){case"paragraph":case"text":case"heading":{we.tokens=[],this.inlineTokens(we.text,we.tokens);break}case"table":{for(we.tokens={header:[],cells:[]},U=we.header.length,fe=0;fe<U;fe++)we.tokens.header[fe]=[],this.inlineTokens(we.header[fe],we.tokens.header[fe]);for(U=we.cells.length,fe=0;fe<U;fe++)for(me=we.cells[fe],we.tokens.cells[fe]=[],pe=0;pe<me.length;pe++)we.tokens.cells[fe][pe]=[],this.inlineTokens(me[pe],we.tokens.cells[fe][pe]);break}case"blockquote":{this.inline(we.tokens);break}case"list":{for(U=we.items.length,fe=0;fe<U;fe++)this.inline(we.items[fe].tokens);break}}return re},Se.inlineTokens=function(re,ae,fe,pe){ae===void 0&&(ae=[]),fe===void 0&&(fe=!1),pe===void 0&&(pe=!1);var U,me,we=re,Ie,Oe,He;if(this.tokens.links){var et=Object.keys(this.tokens.links);if(et.length>0)for(;(Ie=this.tokenizer.rules.inline.reflinkSearch.exec(we))!=null;)et.includes(Ie[0].slice(Ie[0].lastIndexOf("[")+1,-1))&&(we=we.slice(0,Ie.index)+"["+$e("a",Ie[0].length-2)+"]"+we.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ie=this.tokenizer.rules.inline.blockSkip.exec(we))!=null;)we=we.slice(0,Ie.index)+"["+$e("a",Ie[0].length-2)+"]"+we.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ie=this.tokenizer.rules.inline.escapedEmSt.exec(we))!=null;)we=we.slice(0,Ie.index)+"++"+we.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;re;){if(Oe||(He=""),Oe=!1,U=this.tokenizer.escape(re)){re=re.substring(U.raw.length),ae.push(U);continue}if(U=this.tokenizer.tag(re,fe,pe)){re=re.substring(U.raw.length),fe=U.inLink,pe=U.inRawBlock;var Qe=ae[ae.length-1];Qe&&U.type==="text"&&Qe.type==="text"?(Qe.raw+=U.raw,Qe.text+=U.text):ae.push(U);continue}if(U=this.tokenizer.link(re)){re=re.substring(U.raw.length),U.type==="link"&&(U.tokens=this.inlineTokens(U.text,[],!0,pe)),ae.push(U);continue}if(U=this.tokenizer.reflink(re,this.tokens.links)){re=re.substring(U.raw.length);var Ke=ae[ae.length-1];U.type==="link"?(U.tokens=this.inlineTokens(U.text,[],!0,pe),ae.push(U)):Ke&&U.type==="text"&&Ke.type==="text"?(Ke.raw+=U.raw,Ke.text+=U.text):ae.push(U);continue}if(U=this.tokenizer.emStrong(re,we,He)){re=re.substring(U.raw.length),U.tokens=this.inlineTokens(U.text,[],fe,pe),ae.push(U);continue}if(U=this.tokenizer.codespan(re)){re=re.substring(U.raw.length),ae.push(U);continue}if(U=this.tokenizer.br(re)){re=re.substring(U.raw.length),ae.push(U);continue}if(U=this.tokenizer.del(re)){re=re.substring(U.raw.length),U.tokens=this.inlineTokens(U.text,[],fe,pe),ae.push(U);continue}if(U=this.tokenizer.autolink(re,Ve)){re=re.substring(U.raw.length),ae.push(U);continue}if(!fe&&(U=this.tokenizer.url(re,Ve))){re=re.substring(U.raw.length),ae.push(U);continue}if(U=this.tokenizer.inlineText(re,pe,Je)){re=re.substring(U.raw.length),U.raw.slice(-1)!=="_"&&(He=U.raw.slice(-1)),Oe=!0,me=ae[ae.length-1],me&&me.type==="text"?(me.raw+=U.raw,me.text+=U.text):ae.push(U);continue}if(re){var lt="Infinite loop on byte: "+re.charCodeAt(0);if(this.options.silent){console.error(lt);break}else throw new Error(lt)}}return ae},e(De,null,[{key:"rules",get:function(){return{block:Re,inline:Te}}}]),De}(),O=C.defaults,G=L.cleanUrl,X=L.escape,se=function(){function De(Pe){this.options=Pe||O}var Se=De.prototype;return Se.code=function(re,ae,fe){var pe=(ae||"").match(/\S*/)[0];if(this.options.highlight){var U=this.options.highlight(re,pe);U!=null&&U!==re&&(fe=!0,re=U)}return re=re.replace(/\n$/,"")+`
`,pe?'<pre><code class="'+this.options.langPrefix+X(pe,!0)+'">'+(fe?re:X(re,!0))+`</code></pre>
`:"<pre><code>"+(fe?re:X(re,!0))+`</code></pre>
`},Se.blockquote=function(re){return`<blockquote>
`+re+`</blockquote>
`},Se.html=function(re){return re},Se.heading=function(re,ae,fe,pe){return this.options.headerIds?"<h"+ae+' id="'+this.options.headerPrefix+pe.slug(fe)+'">'+re+"</h"+ae+`>
`:"<h"+ae+">"+re+"</h"+ae+`>
`},Se.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Se.list=function(re,ae,fe){var pe=ae?"ol":"ul",U=ae&&fe!==1?' start="'+fe+'"':"";return"<"+pe+U+`>
`+re+"</"+pe+`>
`},Se.listitem=function(re){return"<li>"+re+`</li>
`},Se.checkbox=function(re){return"<input "+(re?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Se.paragraph=function(re){return"<p>"+re+`</p>
`},Se.table=function(re,ae){return ae&&(ae="<tbody>"+ae+"</tbody>"),`<table>
<thead>
`+re+`</thead>
`+ae+`</table>
`},Se.tablerow=function(re){return`<tr>
`+re+`</tr>
`},Se.tablecell=function(re,ae){var fe=ae.header?"th":"td",pe=ae.align?"<"+fe+' align="'+ae.align+'">':"<"+fe+">";return pe+re+"</"+fe+`>
`},Se.strong=function(re){return"<strong>"+re+"</strong>"},Se.em=function(re){return"<em>"+re+"</em>"},Se.codespan=function(re){return"<code>"+re+"</code>"},Se.br=function(){return this.options.xhtml?"<br/>":"<br>"},Se.del=function(re){return"<del>"+re+"</del>"},Se.link=function(re,ae,fe){if(re=G(this.options.sanitize,this.options.baseUrl,re),re===null)return fe;var pe='<a href="'+X(re)+'"';return ae&&(pe+=' title="'+ae+'"'),pe+=">"+fe+"</a>",pe},Se.image=function(re,ae,fe){if(re=G(this.options.sanitize,this.options.baseUrl,re),re===null)return fe;var pe='<img src="'+re+'" alt="'+fe+'"';return ae&&(pe+=' title="'+ae+'"'),pe+=this.options.xhtml?"/>":">",pe},Se.text=function(re){return re},De}(),q=function(){function De(){}var Se=De.prototype;return Se.strong=function(re){return re},Se.em=function(re){return re},Se.codespan=function(re){return re},Se.del=function(re){return re},Se.html=function(re){return re},Se.text=function(re){return re},Se.link=function(re,ae,fe){return""+fe},Se.image=function(re,ae,fe){return""+fe},Se.br=function(){return""},De}(),ie=function(){function De(){this.seen={}}var Se=De.prototype;return Se.serialize=function(re){return re.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Se.getNextSafeSlug=function(re,ae){var fe=re,pe=0;if(this.seen.hasOwnProperty(fe)){pe=this.seen[re];do pe++,fe=re+"-"+pe;while(this.seen.hasOwnProperty(fe))}return ae||(this.seen[re]=pe,this.seen[fe]=0),fe},Se.slug=function(re,ae){ae===void 0&&(ae={});var fe=this.serialize(re);return this.getNextSafeSlug(fe,ae.dryrun)},De}(),ge=C.defaults,Le=L.unescape,We=function(){function De(Pe){this.options=Pe||ge,this.options.renderer=this.options.renderer||new se,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new q,this.slugger=new ie}De.parse=function(re,ae){var fe=new De(ae);return fe.parse(re)},De.parseInline=function(re,ae){var fe=new De(ae);return fe.parseInline(re)};var Se=De.prototype;return Se.parse=function(re,ae){ae===void 0&&(ae=!0);var fe="",pe,U,me,we,Ie,Oe,He,et,Qe,Ke,lt,ft,_t,ut,ot,_e,ke,Y,W=re.length;for(pe=0;pe<W;pe++)switch(Ke=re[pe],Ke.type){case"space":continue;case"hr":{fe+=this.renderer.hr();continue}case"heading":{fe+=this.renderer.heading(this.parseInline(Ke.tokens),Ke.depth,Le(this.parseInline(Ke.tokens,this.textRenderer)),this.slugger);continue}case"code":{fe+=this.renderer.code(Ke.text,Ke.lang,Ke.escaped);continue}case"table":{for(et="",He="",we=Ke.header.length,U=0;U<we;U++)He+=this.renderer.tablecell(this.parseInline(Ke.tokens.header[U]),{header:!0,align:Ke.align[U]});for(et+=this.renderer.tablerow(He),Qe="",we=Ke.cells.length,U=0;U<we;U++){for(Oe=Ke.tokens.cells[U],He="",Ie=Oe.length,me=0;me<Ie;me++)He+=this.renderer.tablecell(this.parseInline(Oe[me]),{header:!1,align:Ke.align[me]});Qe+=this.renderer.tablerow(He)}fe+=this.renderer.table(et,Qe);continue}case"blockquote":{Qe=this.parse(Ke.tokens),fe+=this.renderer.blockquote(Qe);continue}case"list":{for(lt=Ke.ordered,ft=Ke.start,_t=Ke.loose,we=Ke.items.length,Qe="",U=0;U<we;U++)ot=Ke.items[U],_e=ot.checked,ke=ot.task,ut="",ot.task&&(Y=this.renderer.checkbox(_e),_t?ot.tokens.length>0&&ot.tokens[0].type==="text"?(ot.tokens[0].text=Y+" "+ot.tokens[0].text,ot.tokens[0].tokens&&ot.tokens[0].tokens.length>0&&ot.tokens[0].tokens[0].type==="text"&&(ot.tokens[0].tokens[0].text=Y+" "+ot.tokens[0].tokens[0].text)):ot.tokens.unshift({type:"text",text:Y}):ut+=Y),ut+=this.parse(ot.tokens,_t),Qe+=this.renderer.listitem(ut,ke,_e);fe+=this.renderer.list(Qe,lt,ft);continue}case"html":{fe+=this.renderer.html(Ke.text);continue}case"paragraph":{fe+=this.renderer.paragraph(this.parseInline(Ke.tokens));continue}case"text":{for(Qe=Ke.tokens?this.parseInline(Ke.tokens):Ke.text;pe+1<W&&re[pe+1].type==="text";)Ke=re[++pe],Qe+=`
`+(Ke.tokens?this.parseInline(Ke.tokens):Ke.text);fe+=ae?this.renderer.paragraph(Qe):Qe;continue}default:{var Fe='Token with "'+Ke.type+'" type was not found.';if(this.options.silent){console.error(Fe);return}else throw new Error(Fe)}}return fe},Se.parseInline=function(re,ae){ae=ae||this.renderer;var fe="",pe,U,me=re.length;for(pe=0;pe<me;pe++)switch(U=re[pe],U.type){case"escape":{fe+=ae.text(U.text);break}case"html":{fe+=ae.html(U.text);break}case"link":{fe+=ae.link(U.href,U.title,this.parseInline(U.tokens,ae));break}case"image":{fe+=ae.image(U.href,U.title,U.text);break}case"strong":{fe+=ae.strong(this.parseInline(U.tokens,ae));break}case"em":{fe+=ae.em(this.parseInline(U.tokens,ae));break}case"codespan":{fe+=ae.codespan(U.text);break}case"br":{fe+=ae.br();break}case"del":{fe+=ae.del(this.parseInline(U.tokens,ae));break}case"text":{fe+=ae.text(U.text);break}default:{var we='Token with "'+U.type+'" type was not found.';if(this.options.silent){console.error(we);return}else throw new Error(we)}}return fe},De}(),ve=L.merge,Xe=L.checkSanitizeDeprecation,H=L.escape,Z=C.getDefaults,de=C.changeDefaults,Be=C.defaults;function xe(De,Se,Pe){if(typeof De=="undefined"||De===null)throw new Error("marked(): input parameter is undefined or null");if(typeof De!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(De)+", string expected");if(typeof Se=="function"&&(Pe=Se,Se=null),Se=ve({},xe.defaults,Se||{}),Xe(Se),Pe){var re=Se.highlight,ae;try{ae=je.lex(De,Se)}catch(me){return Pe(me)}var fe=function(we){var Ie;if(!we)try{Ie=We.parse(ae,Se)}catch(Oe){we=Oe}return Se.highlight=re,we?Pe(we):Pe(null,Ie)};if(!re||re.length<3||(delete Se.highlight,!ae.length))return fe();var pe=0;xe.walkTokens(ae,function(me){me.type==="code"&&(pe++,setTimeout(function(){re(me.text,me.lang,function(we,Ie){if(we)return fe(we);Ie!=null&&Ie!==me.text&&(me.text=Ie,me.escaped=!0),pe--,pe===0&&fe()})},0))}),pe===0&&fe();return}try{var U=je.lex(De,Se);return Se.walkTokens&&xe.walkTokens(U,Se.walkTokens),We.parse(U,Se)}catch(me){if(me.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+H(me.message+"",!0)+"</pre>";throw me}}xe.options=xe.setOptions=function(De){return ve(xe.defaults,De),de(xe.defaults),xe},xe.getDefaults=Z,xe.defaults=Be,xe.use=function(De){var Se=ve({},De);if(De.renderer&&function(){var re=xe.defaults.renderer||new se,ae=function(U){var me=re[U];re[U]=function(){for(var we=arguments.length,Ie=new Array(we),Oe=0;Oe<we;Oe++)Ie[Oe]=arguments[Oe];var He=De.renderer[U].apply(re,Ie);return He===!1&&(He=me.apply(re,Ie)),He}};for(var fe in De.renderer)ae(fe);Se.renderer=re}(),De.tokenizer&&function(){var re=xe.defaults.tokenizer||new K,ae=function(U){var me=re[U];re[U]=function(){for(var we=arguments.length,Ie=new Array(we),Oe=0;Oe<we;Oe++)Ie[Oe]=arguments[Oe];var He=De.tokenizer[U].apply(re,Ie);return He===!1&&(He=me.apply(re,Ie)),He}};for(var fe in De.tokenizer)ae(fe);Se.tokenizer=re}(),De.walkTokens){var Pe=xe.defaults.walkTokens;Se.walkTokens=function(re){De.walkTokens(re),Pe&&Pe(re)}}xe.setOptions(Se)},xe.walkTokens=function(De,Se){for(var Pe=S(De),re;!(re=Pe()).done;){var ae=re.value;switch(Se(ae),ae.type){case"table":{for(var fe=S(ae.tokens.header),pe;!(pe=fe()).done;){var U=pe.value;xe.walkTokens(U,Se)}for(var me=S(ae.tokens.cells),we;!(we=me()).done;)for(var Ie=we.value,Oe=S(Ie),He;!(He=Oe()).done;){var et=He.value;xe.walkTokens(et,Se)}break}case"list":{xe.walkTokens(ae.items,Se);break}default:ae.tokens&&xe.walkTokens(ae.tokens,Se)}}},xe.parseInline=function(De,Se){if(typeof De=="undefined"||De===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof De!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(De)+", string expected");Se=ve({},xe.defaults,Se||{}),Xe(Se);try{var Pe=je.lexInline(De,Se);return Se.walkTokens&&xe.walkTokens(Pe,Se.walkTokens),We.parseInline(Pe,Se)}catch(re){if(re.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+H(re.message+"",!0)+"</pre>";throw re}},xe.Parser=We,xe.parser=We.parse,xe.Renderer=se,xe.TextRenderer=q,xe.Lexer=je,xe.lexer=je.lex,xe.Tokenizer=K,xe.Slugger=ie,xe.parse=xe;var Ze=xe;return Ze}),define(be[81],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function g(C,y,b){return Math.min(Math.max(C,y),b)}e.clamp=g;function F(C,y){return(y+C%y)%y}e.rot=F;class S{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=S;class _{constructor(){this._n=1,this._val=0}update(y){return this._val=this._val+(y-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=_}),function(){function ee(S){const _=[];typeof S=="number"&&_.push("code/timeOrigin",S);function C(b){_.push(b,Date.now())}function y(){const b=[];for(let k=0;k<_.length;k+=2)b.push({name:_[k],startTime:_[k+1]});return b}return{mark:C,getMarks:y}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?ee():{mark(S){performance.mark(S)},getMarks(){let S=performance.timeOrigin;typeof S!="number"&&(S=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const _=[{name:"code/timeOrigin",startTime:Math.round(S)}];for(const C of performance.getEntriesByType("mark"))_.push({name:C.name,startTime:Math.round(S+C.startTime)});return _}};if(typeof process=="object"){const S=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return ee(S)}else return console.trace("perf-util loaded in UNKNOWN environment"),ee()}function g(S){return S.MonacoPerformanceMarks||(S.MonacoPerformanceMarks=e()),S.MonacoPerformanceMarks}var F;typeof global=="object"?F=global:typeof self=="object"?F=self:F={},typeof define=="function"?define("vs/base/common/performance",[],function(){return g(F)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=g(F):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),F.perf=g(F))}(),define(be[22],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const g="en";let F=!1,S=!1,_=!1,C=!1,y=!1,b=!1,k=!1,n,I=g,l,d;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let c;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?c=e.globals.vscode.process:typeof process!="undefined"&&(c=process);const m=typeof c?.versions?.electron=="string"&&c.type==="renderer";if(e.isElectronSandboxed=m&&c?.sandboxed,e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const s=c?.env.VSCODE_BROWSER_CODE_LOADING;if(typeof s=="string")return s==="none"||s==="code"||s==="bypassHeatCheck"||s==="bypassHeatCheckAndEagerCompile"?s:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!m)d=navigator.userAgent,F=d.indexOf("Windows")>=0,S=d.indexOf("Macintosh")>=0,k=(d.indexOf("Macintosh")>=0||d.indexOf("iPad")>=0||d.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,_=d.indexOf("Linux")>=0,b=!0,n=navigator.language,I=n;else if(typeof c=="object"){F=c.platform==="win32",S=c.platform==="darwin",_=c.platform==="linux",C=_&&!!c.env.SNAP&&!!c.env.SNAP_REVISION,n=g,I=g;const s=c.env.VSCODE_NLS_CONFIG;if(s)try{const i=JSON.parse(s),u=i.availableLanguages["*"];n=i.locale,I=u||g,l=i._translationsConfigFile}catch(i){}y=!0}else console.error("Unable to resolve platform.");var E;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(E=e.Platform||(e.Platform={}));function w(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=w;let P=0;S?P=1:F?P=3:_&&(P=2),e.isWindows=F,e.isMacintosh=S,e.isLinux=_,e.isLinuxSnap=C,e.isNative=y,e.isWeb=b,e.isIOS=k,e.platform=P,e.userAgent=d,e.language=I;var a;(function(s){function i(){return e.language}s.value=i;function u(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=u;function f(){return e.language==="en"}s.isDefault=f})(a=e.Language||(e.Language={})),e.locale=n,e.translationsConfigFile=l,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let u=[];e.globals.addEventListener("message",v=>{if(v.data&&v.data.vscodeSetImmediateId)for(let D=0,T=u.length;D<T;D++){const o=u[D];if(o.id===v.data.vscodeSetImmediateId){u.splice(D,1),o.callback();return}}});let f=0;return v=>{const D=++f;u.push({id:D,callback:v}),e.globals.postMessage({vscodeSetImmediateId:D},"*")}}if(typeof c?.nextTick=="function")return c.nextTick.bind(c);const i=Promise.resolve();return u=>i.then(u)}();var h;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(h=e.OperatingSystem||(e.OperatingSystem={})),e.OS=S||k?2:F?1:3;let p=!0,t=!1;function r(){if(!t){t=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,p=new Uint16Array(s.buffer)[0]===(2<<8)+1}return p}e.isLittleEndian=r}),define(be[41],Ee([0,1,22]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let F;if(typeof g.globals.vscode!="undefined"&&typeof g.globals.vscode.process!="undefined"){const S=g.globals.vscode.process;F={get platform(){return S.platform},get env(){return S.env},cwd(){return S.cwd()},nextTick(_){return(0,g.setImmediate)(_)}}}else typeof process!="undefined"?F={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(S){return process.nextTick(S)}}:F={get platform(){return g.isWindows?"win32":g.isMacintosh?"darwin":"linux"},nextTick(S){return(0,g.setImmediate)(S)},get env(){return{}},cwd(){return"/"}};e.cwd=F.cwd,e.env=F.env,e.platform=F.platform,e.nextTick=F.nextTick}),define(be[14],Ee([0,1,41]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const F=65,S=97,_=90,C=122,y=46,b=47,k=92,n=58,I=63;class l extends Error{constructor(h,p,t){let r;typeof p=="string"&&p.indexOf("not ")===0?(r="must not be",p=p.replace(/^not /,"")):r="must be";const s=h.indexOf(".")!==-1?"property":"argument";let i=`The "${h}" ${s} ${r} of type ${p}`;i+=`. Received type ${typeof t}`,super(i),this.code="ERR_INVALID_ARG_TYPE"}}function d(a,h){if(typeof a!="string")throw new l(h,"string",a)}function c(a){return a===b||a===k}function m(a){return a===b}function E(a){return a>=F&&a<=_||a>=S&&a<=C}function w(a,h,p,t){let r="",s=0,i=-1,u=0,f=0;for(let v=0;v<=a.length;++v){if(v<a.length)f=a.charCodeAt(v);else{if(t(f))break;f=b}if(t(f)){if(!(i===v-1||u===1))if(u===2){if(r.length<2||s!==2||r.charCodeAt(r.length-1)!==y||r.charCodeAt(r.length-2)!==y){if(r.length>2){const D=r.lastIndexOf(p);D===-1?(r="",s=0):(r=r.slice(0,D),s=r.length-1-r.lastIndexOf(p)),i=v,u=0;continue}else if(r.length!==0){r="",s=0,i=v,u=0;continue}}h&&(r+=r.length>0?`${p}..`:"..",s=2)}else r.length>0?r+=`${p}${a.slice(i+1,v)}`:r=a.slice(i+1,v),s=v-i-1;i=v,u=0}else f===y&&u!==-1?++u:u=-1}return r}function P(a,h){if(h===null||typeof h!="object")throw new l("pathObject","Object",h);const p=h.dir||h.root,t=h.base||`${h.name||""}${h.ext||""}`;return p?p===h.root?`${p}${t}`:`${p}${a}${t}`:t}e.win32={resolve(...a){let h="",p="",t=!1;for(let r=a.length-1;r>=-1;r--){let s;if(r>=0){if(s=a[r],d(s,"path"),s.length===0)continue}else h.length===0?s=g.cwd():(s=g.env[`=${h}`]||g.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==h.toLowerCase()&&s.charCodeAt(2)===k)&&(s=`${h}\\`));const i=s.length;let u=0,f="",v=!1;const D=s.charCodeAt(0);if(i===1)c(D)&&(u=1,v=!0);else if(c(D))if(v=!0,c(s.charCodeAt(1))){let T=2,o=T;for(;T<i&&!c(s.charCodeAt(T));)T++;if(T<i&&T!==o){const A=s.slice(o,T);for(o=T;T<i&&c(s.charCodeAt(T));)T++;if(T<i&&T!==o){for(o=T;T<i&&!c(s.charCodeAt(T));)T++;(T===i||T!==o)&&(f=`\\\\${A}\\${s.slice(o,T)}`,u=T)}}}else u=1;else E(D)&&s.charCodeAt(1)===n&&(f=s.slice(0,2),u=2,i>2&&c(s.charCodeAt(2))&&(v=!0,u=3));if(f.length>0)if(h.length>0){if(f.toLowerCase()!==h.toLowerCase())continue}else h=f;if(t){if(h.length>0)break}else if(p=`${s.slice(u)}\\${p}`,t=v,v&&h.length>0)break}return p=w(p,!t,"\\",c),t?`${h}\\${p}`:`${h}${p}`||"."},normalize(a){d(a,"path");const h=a.length;if(h===0)return".";let p=0,t,r=!1;const s=a.charCodeAt(0);if(h===1)return m(s)?"\\":a;if(c(s))if(r=!0,c(a.charCodeAt(1))){let u=2,f=u;for(;u<h&&!c(a.charCodeAt(u));)u++;if(u<h&&u!==f){const v=a.slice(f,u);for(f=u;u<h&&c(a.charCodeAt(u));)u++;if(u<h&&u!==f){for(f=u;u<h&&!c(a.charCodeAt(u));)u++;if(u===h)return`\\\\${v}\\${a.slice(f)}\\`;u!==f&&(t=`\\\\${v}\\${a.slice(f,u)}`,p=u)}}}else p=1;else E(s)&&a.charCodeAt(1)===n&&(t=a.slice(0,2),p=2,h>2&&c(a.charCodeAt(2))&&(r=!0,p=3));let i=p<h?w(a.slice(p),!r,"\\",c):"";return i.length===0&&!r&&(i="."),i.length>0&&c(a.charCodeAt(h-1))&&(i+="\\"),t===void 0?r?`\\${i}`:i:r?`${t}\\${i}`:`${t}${i}`},isAbsolute(a){d(a,"path");const h=a.length;if(h===0)return!1;const p=a.charCodeAt(0);return c(p)||h>2&&E(p)&&a.charCodeAt(1)===n&&c(a.charCodeAt(2))},join(...a){if(a.length===0)return".";let h,p;for(let s=0;s<a.length;++s){const i=a[s];d(i,"path"),i.length>0&&(h===void 0?h=p=i:h+=`\\${i}`)}if(h===void 0)return".";let t=!0,r=0;if(typeof p=="string"&&c(p.charCodeAt(0))){++r;const s=p.length;s>1&&c(p.charCodeAt(1))&&(++r,s>2&&(c(p.charCodeAt(2))?++r:t=!1))}if(t){for(;r<h.length&&c(h.charCodeAt(r));)r++;r>=2&&(h=`\\${h.slice(r)}`)}return e.win32.normalize(h)},relative(a,h){if(d(a,"from"),d(h,"to"),a===h)return"";const p=e.win32.resolve(a),t=e.win32.resolve(h);if(p===t||(a=p.toLowerCase(),h=t.toLowerCase(),a===h))return"";let r=0;for(;r<a.length&&a.charCodeAt(r)===k;)r++;let s=a.length;for(;s-1>r&&a.charCodeAt(s-1)===k;)s--;const i=s-r;let u=0;for(;u<h.length&&h.charCodeAt(u)===k;)u++;let f=h.length;for(;f-1>u&&h.charCodeAt(f-1)===k;)f--;const v=f-u,D=i<v?i:v;let T=-1,o=0;for(;o<D;o++){const L=a.charCodeAt(r+o);if(L!==h.charCodeAt(u+o))break;L===k&&(T=o)}if(o!==D){if(T===-1)return t}else{if(v>D){if(h.charCodeAt(u+o)===k)return t.slice(u+o+1);if(o===2)return t.slice(u+o)}i>D&&(a.charCodeAt(r+o)===k?T=o:o===2&&(T=3)),T===-1&&(T=0)}let A="";for(o=r+T+1;o<=s;++o)(o===s||a.charCodeAt(o)===k)&&(A+=A.length===0?"..":"\\..");return u+=T,A.length>0?`${A}${t.slice(u,f)}`:(t.charCodeAt(u)===k&&++u,t.slice(u,f))},toNamespacedPath(a){if(typeof a!="string")return a;if(a.length===0)return"";const h=e.win32.resolve(a);if(h.length<=2)return a;if(h.charCodeAt(0)===k){if(h.charCodeAt(1)===k){const p=h.charCodeAt(2);if(p!==I&&p!==y)return`\\\\?\\UNC\\${h.slice(2)}`}}else if(E(h.charCodeAt(0))&&h.charCodeAt(1)===n&&h.charCodeAt(2)===k)return`\\\\?\\${h}`;return a},dirname(a){d(a,"path");const h=a.length;if(h===0)return".";let p=-1,t=0;const r=a.charCodeAt(0);if(h===1)return c(r)?a:".";if(c(r)){if(p=t=1,c(a.charCodeAt(1))){let u=2,f=u;for(;u<h&&!c(a.charCodeAt(u));)u++;if(u<h&&u!==f){for(f=u;u<h&&c(a.charCodeAt(u));)u++;if(u<h&&u!==f){for(f=u;u<h&&!c(a.charCodeAt(u));)u++;if(u===h)return a;u!==f&&(p=t=u+1)}}}}else E(r)&&a.charCodeAt(1)===n&&(p=h>2&&c(a.charCodeAt(2))?3:2,t=p);let s=-1,i=!0;for(let u=h-1;u>=t;--u)if(c(a.charCodeAt(u))){if(!i){s=u;break}}else i=!1;if(s===-1){if(p===-1)return".";s=p}return a.slice(0,s)},basename(a,h){h!==void 0&&d(h,"ext"),d(a,"path");let p=0,t=-1,r=!0,s;if(a.length>=2&&E(a.charCodeAt(0))&&a.charCodeAt(1)===n&&(p=2),h!==void 0&&h.length>0&&h.length<=a.length){if(h===a)return"";let i=h.length-1,u=-1;for(s=a.length-1;s>=p;--s){const f=a.charCodeAt(s);if(c(f)){if(!r){p=s+1;break}}else u===-1&&(r=!1,u=s+1),i>=0&&(f===h.charCodeAt(i)?--i==-1&&(t=s):(i=-1,t=u))}return p===t?t=u:t===-1&&(t=a.length),a.slice(p,t)}for(s=a.length-1;s>=p;--s)if(c(a.charCodeAt(s))){if(!r){p=s+1;break}}else t===-1&&(r=!1,t=s+1);return t===-1?"":a.slice(p,t)},extname(a){d(a,"path");let h=0,p=-1,t=0,r=-1,s=!0,i=0;a.length>=2&&a.charCodeAt(1)===n&&E(a.charCodeAt(0))&&(h=t=2);for(let u=a.length-1;u>=h;--u){const f=a.charCodeAt(u);if(c(f)){if(!s){t=u+1;break}continue}r===-1&&(s=!1,r=u+1),f===y?p===-1?p=u:i!==1&&(i=1):p!==-1&&(i=-1)}return p===-1||r===-1||i===0||i===1&&p===r-1&&p===t+1?"":a.slice(p,r)},format:P.bind(null,"\\"),parse(a){d(a,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(a.length===0)return h;const p=a.length;let t=0,r=a.charCodeAt(0);if(p===1)return c(r)?(h.root=h.dir=a,h):(h.base=h.name=a,h);if(c(r)){if(t=1,c(a.charCodeAt(1))){let T=2,o=T;for(;T<p&&!c(a.charCodeAt(T));)T++;if(T<p&&T!==o){for(o=T;T<p&&c(a.charCodeAt(T));)T++;if(T<p&&T!==o){for(o=T;T<p&&!c(a.charCodeAt(T));)T++;T===p?t=T:T!==o&&(t=T+1)}}}}else if(E(r)&&a.charCodeAt(1)===n){if(p<=2)return h.root=h.dir=a,h;if(t=2,c(a.charCodeAt(2))){if(p===3)return h.root=h.dir=a,h;t=3}}t>0&&(h.root=a.slice(0,t));let s=-1,i=t,u=-1,f=!0,v=a.length-1,D=0;for(;v>=t;--v){if(r=a.charCodeAt(v),c(r)){if(!f){i=v+1;break}continue}u===-1&&(f=!1,u=v+1),r===y?s===-1?s=v:D!==1&&(D=1):s!==-1&&(D=-1)}return u!==-1&&(s===-1||D===0||D===1&&s===u-1&&s===i+1?h.base=h.name=a.slice(i,u):(h.name=a.slice(i,s),h.base=a.slice(i,u),h.ext=a.slice(s,u))),i>0&&i!==t?h.dir=a.slice(0,i-1):h.dir=h.root,h},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...a){let h="",p=!1;for(let t=a.length-1;t>=-1&&!p;t--){const r=t>=0?a[t]:g.cwd();d(r,"path"),r.length!==0&&(h=`${r}/${h}`,p=r.charCodeAt(0)===b)}return h=w(h,!p,"/",m),p?`/${h}`:h.length>0?h:"."},normalize(a){if(d(a,"path"),a.length===0)return".";const h=a.charCodeAt(0)===b,p=a.charCodeAt(a.length-1)===b;return a=w(a,!h,"/",m),a.length===0?h?"/":p?"./":".":(p&&(a+="/"),h?`/${a}`:a)},isAbsolute(a){return d(a,"path"),a.length>0&&a.charCodeAt(0)===b},join(...a){if(a.length===0)return".";let h;for(let p=0;p<a.length;++p){const t=a[p];d(t,"path"),t.length>0&&(h===void 0?h=t:h+=`/${t}`)}return h===void 0?".":e.posix.normalize(h)},relative(a,h){if(d(a,"from"),d(h,"to"),a===h||(a=e.posix.resolve(a),h=e.posix.resolve(h),a===h))return"";const p=1,t=a.length,r=t-p,s=1,i=h.length-s,u=r<i?r:i;let f=-1,v=0;for(;v<u;v++){const T=a.charCodeAt(p+v);if(T!==h.charCodeAt(s+v))break;T===b&&(f=v)}if(v===u)if(i>u){if(h.charCodeAt(s+v)===b)return h.slice(s+v+1);if(v===0)return h.slice(s+v)}else r>u&&(a.charCodeAt(p+v)===b?f=v:v===0&&(f=0));let D="";for(v=p+f+1;v<=t;++v)(v===t||a.charCodeAt(v)===b)&&(D+=D.length===0?"..":"/..");return`${D}${h.slice(s+f)}`},toNamespacedPath(a){return a},dirname(a){if(d(a,"path"),a.length===0)return".";const h=a.charCodeAt(0)===b;let p=-1,t=!0;for(let r=a.length-1;r>=1;--r)if(a.charCodeAt(r)===b){if(!t){p=r;break}}else t=!1;return p===-1?h?"/":".":h&&p===1?"//":a.slice(0,p)},basename(a,h){h!==void 0&&d(h,"ext"),d(a,"path");let p=0,t=-1,r=!0,s;if(h!==void 0&&h.length>0&&h.length<=a.length){if(h===a)return"";let i=h.length-1,u=-1;for(s=a.length-1;s>=0;--s){const f=a.charCodeAt(s);if(f===b){if(!r){p=s+1;break}}else u===-1&&(r=!1,u=s+1),i>=0&&(f===h.charCodeAt(i)?--i==-1&&(t=s):(i=-1,t=u))}return p===t?t=u:t===-1&&(t=a.length),a.slice(p,t)}for(s=a.length-1;s>=0;--s)if(a.charCodeAt(s)===b){if(!r){p=s+1;break}}else t===-1&&(r=!1,t=s+1);return t===-1?"":a.slice(p,t)},extname(a){d(a,"path");let h=-1,p=0,t=-1,r=!0,s=0;for(let i=a.length-1;i>=0;--i){const u=a.charCodeAt(i);if(u===b){if(!r){p=i+1;break}continue}t===-1&&(r=!1,t=i+1),u===y?h===-1?h=i:s!==1&&(s=1):h!==-1&&(s=-1)}return h===-1||t===-1||s===0||s===1&&h===t-1&&h===p+1?"":a.slice(h,t)},format:P.bind(null,"/"),parse(a){d(a,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(a.length===0)return h;const p=a.charCodeAt(0)===b;let t;p?(h.root="/",t=1):t=0;let r=-1,s=0,i=-1,u=!0,f=a.length-1,v=0;for(;f>=t;--f){const D=a.charCodeAt(f);if(D===b){if(!u){s=f+1;break}continue}i===-1&&(u=!1,i=f+1),D===y?r===-1?r=f:v!==1&&(v=1):r!==-1&&(v=-1)}if(i!==-1){const D=s===0&&p?1:s;r===-1||v===0||v===1&&r===i-1&&r===s+1?h.base=h.name=a.slice(D,i):(h.name=a.slice(D,r),h.base=a.slice(D,i),h.ext=a.slice(r,i))}return s>0?h.dir=a.slice(0,s-1):p&&(h.dir="/"),h},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=g.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=g.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=g.platform==="win32"?e.win32.join:e.posix.join,e.resolve=g.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=g.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=g.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=g.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=g.platform==="win32"?e.win32.extname:e.posix.extname,e.format=g.platform==="win32"?e.win32.format:e.posix.format,e.parse=g.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=g.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=g.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=g.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(be[55],Ee([0,1,22]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const F=g.globals.performance&&typeof g.globals.performance.now=="function";class S{constructor(C){this._highResolution=F&&C,this._startTime=this._now(),this._stopTime=-1}static create(C=!0){return new S(C)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?g.globals.performance.now():Date.now()}}e.StopWatch=S}),define(be[3],Ee([0,1,12,52,6,80,55]),function(ee,e,g,F,S,_,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var y;(function(a){a.None=()=>S.Disposable.None;function h(Q){return(z,V=null,R)=>{let K=!1,x;return x=Q(j=>{if(!K)return x?x.dispose():K=!0,z.call(V,j)},null,R),K&&x.dispose(),x}}a.once=h;function p(Q,z){return f((V,R=null,K)=>Q(x=>V.call(R,z(x)),null,K))}a.map=p;function t(Q,z){return f((V,R=null,K)=>Q(x=>{z(x),V.call(R,x)},null,K))}a.forEach=t;function r(Q,z){return f((V,R=null,K)=>Q(x=>z(x)&&V.call(R,x),null,K))}a.filter=r;function s(Q){return Q}a.signal=s;function i(...Q){return(z,V=null,R)=>(0,S.combinedDisposable)(...Q.map(K=>K(x=>z.call(V,x),null,R)))}a.any=i;function u(Q,z,V){let R=V;return p(Q,K=>(R=z(R,K),R))}a.reduce=u;function f(Q){let z;const V=new l({onFirstListenerAdd(){z=Q(V.fire,V)},onLastListenerRemove(){z.dispose()}});return V.event}function v(Q,z,V=100,R=!1,K){let x,j,ue,$=0;const te=new l({leakWarningThreshold:K,onFirstListenerAdd(){x=Q(ce=>{$++,j=z(j,ce),R&&!ue&&(te.fire(j),j=void 0),clearTimeout(ue),ue=setTimeout(()=>{const ye=j;j=void 0,ue=void 0,(!R||$>1)&&te.fire(ye),$=0},V)})},onLastListenerRemove(){x.dispose()}});return te.event}a.debounce=v;function D(Q,z=(V,R)=>V===R){let V=!0,R;return r(Q,K=>{const x=V||!z(K,R);return V=!1,R=K,x})}a.latch=D;function T(Q,z){return[a.filter(Q,z),a.filter(Q,V=>!z(V))]}a.split=T;function o(Q,z=!1,V=[]){let R=V.slice(),K=Q(ue=>{R?R.push(ue):j.fire(ue)});const x=()=>{R&&R.forEach(ue=>j.fire(ue)),R=null},j=new l({onFirstListenerAdd(){K||(K=Q(ue=>j.fire(ue)))},onFirstListenerDidAdd(){R&&(z?setTimeout(x):x())},onLastListenerRemove(){K&&K.dispose(),K=null}});return j.event}a.buffer=o;class A{constructor(z){this.event=z}map(z){return new A(p(this.event,z))}forEach(z){return new A(t(this.event,z))}filter(z){return new A(r(this.event,z))}reduce(z,V){return new A(u(this.event,z,V))}latch(){return new A(D(this.event))}debounce(z,V=100,R=!1,K){return new A(v(this.event,z,V,R,K))}on(z,V,R){return this.event(z,V,R)}once(z,V,R){return h(this.event)(z,V,R)}}function L(Q){return new A(Q)}a.chain=L;function B(Q,z,V=R=>R){const R=(...ue)=>j.fire(V(...ue)),K=()=>Q.on(z,R),x=()=>Q.removeListener(z,R),j=new l({onFirstListenerAdd:K,onLastListenerRemove:x});return j.event}a.fromNodeEventEmitter=B;function oe(Q,z,V=R=>R){const R=(...ue)=>j.fire(V(...ue)),K=()=>Q.addEventListener(z,R),x=()=>Q.removeEventListener(z,R),j=new l({onFirstListenerAdd:K,onLastListenerRemove:x});return j.event}a.fromDOMEventEmitter=oe;function he(Q){return new Promise(z=>h(Q)(z))}a.toPromise=he})(y=e.Event||(e.Event={}));class b{constructor(h){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${h}_${b._idPool++}`}start(h){this._stopWatch=new C.StopWatch(!0),this._listenerCount=h}stop(){if(this._stopWatch){const h=this._stopWatch.elapsed();this._elapsedOverall+=h,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${h.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}b._idPool=0;let k=-1;function n(a){const h=k;return k=a,{dispose(){k=h}}}e.setGlobalLeakWarningThreshold=n;class I{constructor(h,p=Math.random().toString(18).slice(2,5)){this.customThreshold=h,this.name=p,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(h){let p=k;if(typeof this.customThreshold=="number"&&(p=this.customThreshold),p<=0||h<p)return;this._stacks||(this._stacks=new Map);const t=new Error().stack.split(`
`).slice(3).join(`
`),r=this._stacks.get(t)||0;if(this._stacks.set(t,r+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=p*.5;let s,i=0;for(const[u,f]of this._stacks)(!s||i<f)&&(s=u,i=f);console.warn(`[${this.name}] potential listener LEAK detected, having ${h} listeners already. MOST frequent listener (${i}):`),console.warn(s)}return()=>{const s=this._stacks.get(t)||0;this._stacks.set(t,s-1)}}}class l{constructor(h){this._disposed=!1,this._options=h,this._leakageMon=k>0?new I(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new b(this._options._profName):void 0}get event(){return this._event||(this._event=(h,p,t)=>{this._listeners||(this._listeners=new _.LinkedList);const r=this._listeners.isEmpty();r&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const s=this._listeners.push(p?[h,p]:h);r&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,h,p);const i=this._leakageMon?.check(this._listeners.size),u=(0,S.toDisposable)(()=>{i&&i(),this._disposed||(s(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return t instanceof S.DisposableStore?t.add(u):Array.isArray(t)&&t.push(u),u}),this._event}fire(h){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new _.LinkedList);for(let p of this._listeners)this._deliveryQueue.push([p,h]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[p,t]=this._deliveryQueue.shift();try{typeof p=="function"?p.call(void 0,t):p[0].call(p[1],t)}catch(r){(0,g.onUnexpectedError)(r)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=l;class d extends l{async fireAsync(h,p,t){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new _.LinkedList);for(const r of this._listeners)this._asyncDeliveryQueue.push([r,h]);for(;this._asyncDeliveryQueue.size>0&&!p.isCancellationRequested;){const[r,s]=this._asyncDeliveryQueue.shift(),i=[],u={...s,waitUntil:f=>{if(Object.isFrozen(i))throw new Error("waitUntil can NOT be called asynchronous");t&&(f=t(f,typeof r=="function"?r:r[0])),i.push(f)}};try{typeof r=="function"?r.call(void 0,u):r[0].call(r[1],u)}catch(f){(0,g.onUnexpectedError)(f);continue}Object.freeze(i),await Promise.allSettled(i).then(f=>{for(const v of f)v.status==="rejected"&&(0,g.onUnexpectedError)(v.reason)})}}}}e.AsyncEmitter=d;class c extends l{constructor(h){super(h);this._isPaused=0,this._eventQueue=new _.LinkedList,this._mergeFn=h?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const h=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(h))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(h){this._listeners&&(this._isPaused!==0?this._eventQueue.push(h):super.fire(h))}}e.PauseableEmitter=c;class m extends c{constructor(h){super(h);this._delay=h.delay??100}fire(h){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(h)}}e.DebounceEmitter=m;class E{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new l({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(h){const p={event:h,listener:null};this.events.push(p),this.hasListeners&&this.hook(p);const t=()=>{this.hasListeners&&this.unhook(p);const r=this.events.indexOf(p);this.events.splice(r,1)};return(0,S.toDisposable)((0,F.once)(t))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(h=>this.hook(h))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(h=>this.unhook(h))}hook(h){h.listener=h.event(p=>this.emitter.fire(p))}unhook(h){h.listener&&h.listener.dispose(),h.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=E;class w{constructor(){this.buffers=[]}wrapEvent(h){return(p,t,r)=>h(s=>{const i=this.buffers[this.buffers.length-1];i?i.push(()=>p.call(t,s)):p.call(t,s)},void 0,r)}bufferEvents(h){const p=[];this.buffers.push(p);const t=h();return this.buffers.pop(),p.forEach(r=>r()),t}}e.EventBufferer=w;class P{constructor(){this.listening=!1,this.inputEvent=y.None,this.inputEventListener=S.Disposable.None,this.emitter=new l({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(h){this.inputEvent=h,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=h(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=P}),define(be[20],Ee([0,1,3]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const F=Object.freeze(function(y,b){const k=setTimeout(y.bind(b),0);return{dispose(){clearTimeout(k)}}});var S;(function(y){function b(k){return k===y.None||k===y.Cancelled||k instanceof _?!0:!k||typeof k!="object"?!1:typeof k.isCancellationRequested=="boolean"&&typeof k.onCancellationRequested=="function"}y.isCancellationToken=b,y.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:g.Event.None}),y.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:F})})(S=e.CancellationToken||(e.CancellationToken={}));class _{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?F:(this._emitter||(this._emitter=new g.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class C{constructor(b){this._token=void 0,this._parentListener=void 0,this._parentListener=b&&b.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new _),this._token}cancel(){this._token?this._token instanceof _&&this._token.cancel():this._token=S.Cancelled}dispose(b=!1){b&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof _&&this._token.dispose():this._token=S.None}}e.CancellationTokenSource=C}),define(be[35],Ee([0,1,3]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class F{constructor(){this._icons=new Map,this._onDidRegister=new g.Emitter}add(I){const l=this._icons.get(I.id);l?I.description?l.description=I.description:console.error(`Duplicate registration of codicon ${I.id}`):(this._icons.set(I.id,I),this._onDidRegister.fire(I))}get(I){return this._icons.get(I)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const S=new F;e.iconRegistry=S;function _(n,I){return new y(n,I)}e.registerCodicon=_;function C(n){return n?n.replace(/\$\((.*?)\)/g,(I,l)=>` ${l} `).trim():""}e.getCodiconAriaLabel=C;class y{constructor(I,l,d){this.id=I,this.definition=l,this.description=d,S.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=y;function b(n,I){const l=["codicon","codicon-"+n];return I&&l.push("codicon-modifier-"+I),l}e.getClassNamesArray=b;var k;(function(n){n.iconNameSegment="[A-Za-z0-9]+",n.iconNameExpression="[A-Za-z0-9\\-]+",n.iconModifierExpression="~[A-Za-z]+";const I=new RegExp(`^(${n.iconNameExpression})(${n.iconModifierExpression})?$`);function l(m){if(m instanceof y)return["codicon","codicon-"+m.id];const E=I.exec(m.id);if(!E)return l(y.error);let[,w,P]=E;const a=["codicon","codicon-"+w];return P&&a.push("codicon-modifier-"+P.substr(1)),a}n.asClassNameArray=l;function d(m){return l(m).join(" ")}n.asClassName=d;function c(m){return"."+l(m).join(".")}n.asCSSSelector=c})(k=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",{fontCharacter:"\\ea60"}),n.gistNew=new n("gist-new",{fontCharacter:"\\ea60"}),n.repoCreate=new n("repo-create",{fontCharacter:"\\ea60"}),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition)}(y=e.Codicon||(e.Codicon={}))}),define(be[113],Ee([0,1,12,6]),function(ee,e,g,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function S(a){const h=a;return h?[h.on,h.pause,h.resume,h.destroy].every(p=>typeof p=="function"):!1}e.isReadableStream=S;function _(a){const h=a;return h?S(h.stream)&&Array.isArray(h.buffer)&&typeof h.ended=="boolean":!1}e.isReadableBufferedStream=_;function C(a,h){return new y(a,h)}e.newWriteableStream=C;class y{constructor(h,p){this.reducer=h,this.options=p,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(h){if(!this.state.destroyed){if(this.state.flowing)this.emitData(h);else if(this.buffer.data.push(h),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(p=>this.pendingWritePromises.push(p))}}error(h){this.state.destroyed||(this.state.flowing?this.emitError(h):this.buffer.error.push(h))}end(h){this.state.destroyed||(typeof h!="undefined"&&this.write(h),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(h){this.listeners.data.slice(0).forEach(p=>p(h))}emitError(h){this.listeners.error.length===0?(0,g.onUnexpectedError)(h):this.listeners.error.slice(0).forEach(p=>p(h))}emitEnd(){this.listeners.end.slice(0).forEach(h=>h())}on(h,p){if(!this.state.destroyed)switch(h){case"data":this.listeners.data.push(p),this.resume();break;case"end":this.listeners.end.push(p),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(p),this.state.flowing&&this.flowErrors();break}}removeListener(h,p){if(this.state.destroyed)return;let t;switch(h){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const r=t.indexOf(p);r>=0&&t.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const h=this.reducer(this.buffer.data);this.emitData(h),this.buffer.data.length=0;const p=[...this.pendingWritePromises];this.pendingWritePromises.length=0,p.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const h of this.buffer.error)this.emitError(h);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function b(a,h){const p=[];let t;for(;(t=a.read())!==null;)p.push(t);return h(p)}e.consumeReadable=b;function k(a,h,p){const t=[];let r;for(;(r=a.read())!==null&&t.length<p;)t.push(r);return r===null&&t.length>0?h(t):{read:()=>{if(t.length>0)return t.shift();if(typeof r!="undefined"){const s=r;return r=void 0,s}return a.read()}}}e.peekReadable=k;function n(a,h){return new Promise((p,t)=>{const r=[];I(a,{onData:s=>{h&&r.push(s)},onError:s=>{h?t(s):p(void 0)},onEnd:()=>{p(h?h(r):void 0)}})})}e.consumeStream=n;function I(a,h){a.on("error",p=>h.onError(p)),a.on("end",()=>h.onEnd()),a.on("data",p=>h.onData(p))}e.listenStream=I;function l(a,h){return new Promise((p,t)=>{const r=new F.DisposableStore,s=[],i=v=>{if(s.push(v),s.length>h)return r.dispose(),a.pause(),p({stream:a,buffer:s,ended:!1})},u=v=>t(v),f=()=>p({stream:a,buffer:s,ended:!0});r.add((0,F.toDisposable)(()=>a.removeListener("error",u))),a.on("error",u),r.add((0,F.toDisposable)(()=>a.removeListener("end",f))),a.on("end",f),r.add((0,F.toDisposable)(()=>a.removeListener("data",i))),a.on("data",i)})}e.peekStream=l;function d(a,h){const p=C(h);return p.end(a),p}e.toStream=d;function c(){const a=C(()=>{throw new Error("not supported")});return a.end(),a}e.emptyStream=c;function m(a){let h=!1;return{read:()=>h?null:(h=!0,a)}}e.toReadable=m;function E(a,h,p){const t=C(p);return I(a,{onData:r=>t.write(h.data(r)),onError:r=>t.error(h.error?h.error(r):r),onEnd:()=>t.end()}),t}e.transform=E;function w(a,h,p){let t=!1;return{read:()=>{const r=h.read();return t?r:(t=!0,r!==null?p([a,r]):a)}}}e.prefixedReadable=w;function P(a,h,p){let t=!1;const r=C(p);return I(h,{onData:s=>t?r.write(s):(t=!0,r.write(p([a,s]))),onError:s=>r.error(s),onEnd:()=>{t||(t=!0,r.write(a)),r.end()}}),r}e.prefixedStream=P}),define(be[8],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function g(U){return!U||typeof U!="string"?!0:U.trim().length===0}e.isFalsyOrWhitespace=g;const F=/{(\d+)}/g;function S(U,...me){return me.length===0?U:U.replace(F,function(we,Ie){const Oe=parseInt(Ie,10);return isNaN(Oe)||Oe<0||Oe>=me.length?we:me[Oe]})}e.format=S;const _=/{([^}]+)}/g;function C(U,me){return U.replace(_,(we,Ie)=>me[Ie]??we)}e.format2=C;function y(U){return U.replace(/[<>&]/g,function(me){switch(me){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return me}})}e.escape=y;function b(U){return U.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=b;function k(U,me){let we=0;const Ie=me.charCodeAt(0);for(let Oe=U.length-1;Oe>=0;Oe--)U.charCodeAt(Oe)===Ie&&we++;return we}e.count=k;function n(U,me,we="\u2026"){return U.length<=me?U:`${U.substr(0,me)}${we}`}e.truncate=n;function I(U,me=" "){const we=l(U,me);return d(we,me)}e.trim=I;function l(U,me){if(!U||!me)return U;const we=me.length;if(we===0||U.length===0)return U;let Ie=0;for(;U.indexOf(me,Ie)===Ie;)Ie=Ie+we;return U.substring(Ie)}e.ltrim=l;function d(U,me){if(!U||!me)return U;const we=me.length,Ie=U.length;if(we===0||Ie===0)return U;let Oe=Ie,He=-1;for(;He=U.lastIndexOf(me,Oe-1),!(He===-1||He+we!==Oe);){if(He===0)return"";Oe=He}return U.substring(0,Oe)}e.rtrim=d;function c(U){return U.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=c;function m(U){return U.replace(/\*/g,"")}e.stripWildcards=m;function E(U,me,we={}){if(!U)throw new Error("Cannot create regex from empty string");me||(U=b(U)),we.wholeWord&&(/\B/.test(U.charAt(0))||(U="\\b"+U),/\B/.test(U.charAt(U.length-1))||(U=U+"\\b"));let Ie="";return we.global&&(Ie+="g"),we.matchCase||(Ie+="i"),we.multiline&&(Ie+="m"),we.unicode&&(Ie+="u"),new RegExp(U,Ie)}e.createRegExp=E;function w(U){return U.source==="^"||U.source==="^$"||U.source==="$"||U.source==="^\\s*$"?!1:!!(U.exec("")&&U.lastIndex===0)}e.regExpLeadsToEndlessLoop=w;function P(U){return!!U.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=P;function a(U){return(U.global?"g":"")+(U.ignoreCase?"i":"")+(U.multiline?"m":"")+(U.unicode?"u":"")}e.regExpFlags=a;function h(U){return U.split(/\r\n|\r|\n/)}e.splitLines=h;function p(U){for(let me=0,we=U.length;me<we;me++){const Ie=U.charCodeAt(me);if(Ie!==32&&Ie!==9)return me}return-1}e.firstNonWhitespaceIndex=p;function t(U,me=0,we=U.length){for(let Ie=me;Ie<we;Ie++){const Oe=U.charCodeAt(Ie);if(Oe!==32&&Oe!==9)return U.substring(me,Ie)}return U.substring(me,we)}e.getLeadingWhitespace=t;function r(U,me=U.length-1){for(let we=me;we>=0;we--){const Ie=U.charCodeAt(we);if(Ie!==32&&Ie!==9)return we}return-1}e.lastNonWhitespaceIndex=r;function s(U,me){return U<me?-1:U>me?1:0}e.compare=s;function i(U,me,we=0,Ie=U.length,Oe=0,He=me.length){for(;we<Ie&&Oe<He;we++,Oe++){let Ke=U.charCodeAt(we),lt=me.charCodeAt(Oe);if(Ke<lt)return-1;if(Ke>lt)return 1}const et=Ie-we,Qe=He-Oe;return et<Qe?-1:et>Qe?1:0}e.compareSubstring=i;function u(U,me){return f(U,me,0,U.length,0,me.length)}e.compareIgnoreCase=u;function f(U,me,we=0,Ie=U.length,Oe=0,He=me.length){for(;we<Ie&&Oe<He;we++,Oe++){let Ke=U.charCodeAt(we),lt=me.charCodeAt(Oe);if(Ke===lt)continue;const ft=Ke-lt;if(!(ft===32&&D(lt))&&!(ft===-32&&D(Ke)))return v(Ke)&&v(lt)?ft:i(U.toLowerCase(),me.toLowerCase(),we,Ie,Oe,He)}const et=Ie-we,Qe=He-Oe;return et<Qe?-1:et>Qe?1:0}e.compareSubstringIgnoreCase=f;function v(U){return U>=97&&U<=122}e.isLowerAsciiLetter=v;function D(U){return U>=65&&U<=90}e.isUpperAsciiLetter=D;function T(U){return v(U)||D(U)}function o(U,me){return U.length===me.length&&A(U,me)}e.equalsIgnoreCase=o;function A(U,me,we=U.length){for(let Ie=0;Ie<we;Ie++){const Oe=U.charCodeAt(Ie),He=me.charCodeAt(Ie);if(Oe!==He){if(T(Oe)&&T(He)){const et=Math.abs(Oe-He);if(et!==0&&et!==32)return!1}else if(String.fromCharCode(Oe).toLowerCase()!==String.fromCharCode(He).toLowerCase())return!1}}return!0}function L(U,me){const we=me.length;return me.length>U.length?!1:A(U,me,we)}e.startsWithIgnoreCase=L;function B(U,me){let we,Ie=Math.min(U.length,me.length);for(we=0;we<Ie;we++)if(U.charCodeAt(we)!==me.charCodeAt(we))return we;return Ie}e.commonPrefixLength=B;function oe(U,me){let we,Ie=Math.min(U.length,me.length);const Oe=U.length-1,He=me.length-1;for(we=0;we<Ie;we++)if(U.charCodeAt(Oe-we)!==me.charCodeAt(He-we))return we;return Ie}e.commonSuffixLength=oe;function he(U){return 55296<=U&&U<=56319}e.isHighSurrogate=he;function Q(U){return 56320<=U&&U<=57343}e.isLowSurrogate=Q;function z(U,me){return(U-55296<<10)+(me-56320)+65536}e.computeCodePoint=z;function V(U,me,we){const Ie=U.charCodeAt(we);if(he(Ie)&&we+1<me){const Oe=U.charCodeAt(we+1);if(Q(Oe))return z(Ie,Oe)}return Ie}e.getNextCodePoint=V;function R(U,me){const we=U.charCodeAt(me-1);if(Q(we)&&me>1){const Ie=U.charCodeAt(me-2);if(he(Ie))return z(Ie,we)}return we}function K(U,me){const we=De.getInstance(),Ie=me,Oe=U.length,He=V(U,Oe,me);me+=He>=65536?2:1;let et=we.getGraphemeBreakType(He);for(;me<Oe;){const Qe=V(U,Oe,me),Ke=we.getGraphemeBreakType(Qe);if(xe(et,Ke))break;me+=Qe>=65536?2:1,et=Ke}return me-Ie}e.nextCharLength=K;function x(U,me){const we=De.getInstance(),Ie=me,Oe=R(U,me);me-=Oe>=65536?2:1;let He=we.getGraphemeBreakType(Oe);for(;me>0;){const et=R(U,me),Qe=we.getGraphemeBreakType(et);if(xe(Qe,He))break;me-=et>=65536?2:1,He=Qe}return Ie-me}e.prevCharLength=x;function j(U,me){const we=De.getInstance(),Ie=U.length,Oe=me,He=V(U,Ie,me),et=we.getGraphemeBreakType(He);me+=He>=65536?2:1;let Qe=et;for(;me<Ie;){const lt=V(U,Ie,me),ft=we.getGraphemeBreakType(lt);if(xe(Qe,ft))break;me+=lt>=65536?2:1,Qe=ft}const Ke=me;for(me=Oe,Qe=et;me>0;){const lt=R(U,me),ft=we.getGraphemeBreakType(lt);if(xe(ft,Qe))break;me-=lt>=65536?2:1,Qe=ft}return[me,Ke]}function ue(U,me){return me>0&&Q(U.charCodeAt(me))?j(U,me-1):j(U,me)}e.getCharContainingOffset=ue;function $(U){const me=U.length;let we=0,Ie=0;for(;Ie<me;){const et=V(U,me,Ie);Ie+=et>=65536?2:1,et<128?we+=1:et<2048?we+=2:et<65536?we+=3:we+=4}const Oe=new Uint8Array(we);Ie=0;let He=0;for(;Ie<me;){const et=V(U,me,Ie);Ie+=et>=65536?2:1,et<128?Oe[He++]=et:et<2048?(Oe[He++]=192|(et&1984)>>>6,Oe[He++]=128|(et&63)>>>0):et<65536?(Oe[He++]=224|(et&61440)>>>12,Oe[He++]=128|(et&4032)>>>6,Oe[He++]=128|(et&63)>>>0):(Oe[He++]=240|(et&1835008)>>>18,Oe[He++]=128|(et&258048)>>>12,Oe[He++]=128|(et&4032)>>>6,Oe[He++]=128|(et&63)>>>0)}return Oe}e.encodeUTF8=$;function te(U){const me=U.byteLength,we=[];let Ie=0;for(;Ie<me;){const Oe=U[Ie];let He;if(Oe>=240&&Ie+3<me?He=(U[Ie++]&7)<<18>>>0|(U[Ie++]&63)<<12>>>0|(U[Ie++]&63)<<6>>>0|(U[Ie++]&63)<<0>>>0:Oe>=224&&Ie+2<me?He=(U[Ie++]&15)<<12>>>0|(U[Ie++]&63)<<6>>>0|(U[Ie++]&63)<<0>>>0:Oe>=192&&Ie+1<me?He=(U[Ie++]&31)<<6>>>0|(U[Ie++]&63)<<0>>>0:He=U[Ie++],He>=0&&He<=55295||He>=57344&&He<=65535)we.push(String.fromCharCode(He));else if(He>=65536&&He<=1114111){const et=He-65536,Qe=55296+((et&1047552)>>>10),Ke=56320+((et&1023)>>>0);we.push(String.fromCharCode(Qe)),we.push(String.fromCharCode(Ke))}else we.push(String.fromCharCode(65533))}return we.join("")}e.decodeUTF8=te;const ce=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function ye(U){return ce.test(U)}e.containsRTL=ye;const Re=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function Te(U){return Re.test(U)}e.containsEmoji=Te;const $e=/^[\t\n\r\x20-\x7E]*$/;function Je(U){return $e.test(U)}e.isBasicASCII=Je,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Ve(U){return e.UNUSUAL_LINE_TERMINATORS.test(U)}e.containsUnusualLineTerminators=Ve;function je(U){for(let me=0,we=U.length;me<we;me++)if(O(U.charCodeAt(me)))return!0;return!1}e.containsFullWidthCharacter=je;function O(U){return U=+U,U>=11904&&U<=55215||U>=63744&&U<=64255||U>=65281&&U<=65374}e.isFullWidthCharacter=O;function G(U){return U>=127462&&U<=127487||U===8986||U===8987||U===9200||U===9203||U>=9728&&U<=10175||U===11088||U===11093||U>=127744&&U<=128591||U>=128640&&U<=128764||U>=128992&&U<=129003||U>=129280&&U<=129535||U>=129648&&U<=129750}e.isEmojiImprecise=G;function X(U,me){if(U.length<me)return U;const we=/\b/g;let Ie=0;for(;we.test(U)&&!(U.length-we.lastIndex<me);)Ie=we.lastIndex,we.lastIndex+=1;return U.substring(Ie).replace(/^\s/,"")}e.lcut=X;const se=/\x1B\x5B[12]?K/g,q=/\x1b\[\d+m/g,ie=/\x1b\[0?m/g;function ge(U){return U&&(U=U.replace(se,""),U=U.replace(q,""),U=U.replace(ie,"")),U}e.removeAnsiEscapeCodes=ge,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Le(U){return!!(U&&U.length>0&&U.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Le;function We(U){return Le(U)?U.substr(1):U}e.stripUTF8BOM=We;function ve(U,me){if(!U||!me||U.length<me.length)return!1;const we=me.length,Ie=U.toLowerCase();let Oe=0,He=-1;for(;Oe<we;){const et=Ie.indexOf(me[Oe],He+1);if(et<0)return!1;He=et,Oe++}return!0}e.fuzzyContains=ve;function Xe(U,me=!1){return U?(me&&(U=U.replace(/\\./g,"")),U.toLowerCase()!==U):!1}e.containsUppercaseCharacter=Xe;function H(U){return U.charAt(0).toUpperCase()+U.slice(1)}e.uppercaseFirstLetter=H;function Z(U,me=1){if(me===0)return"";let we=-1;do we=U.indexOf(`
`,we+1),me--;while(me>0&&we>=0);return we===-1?U:(U[we-1]==="\r"&&we--,U.substr(0,we))}e.getNLines=Z;function de(U){const me=90-65+1;return U=U%(2*me),U<me?String.fromCharCode(97+U):String.fromCharCode(65+U-me)}e.singleLetterHash=de;function Be(U){return De.getInstance().getGraphemeBreakType(U)}e.getGraphemeBreakType=Be;function xe(U,me){return U===0?me!==5&&me!==7:U===2&&me===3?!1:U===4||U===2||U===3||me===4||me===2||me===3?!0:!(U===8&&(me===8||me===9||me===11||me===12)||(U===11||U===9)&&(me===9||me===10)||(U===12||U===10)&&me===10||me===5||me===13||me===7||U===1||U===13&&me===14||U===6&&me===6)}e.breakBetweenGraphemeBreakType=xe;var Ze;(function(U){U[U.Other=0]="Other",U[U.Prepend=1]="Prepend",U[U.CR=2]="CR",U[U.LF=3]="LF",U[U.Control=4]="Control",U[U.Extend=5]="Extend",U[U.Regional_Indicator=6]="Regional_Indicator",U[U.SpacingMark=7]="SpacingMark",U[U.L=8]="L",U[U.V=9]="V",U[U.T=10]="T",U[U.LV=11]="LV",U[U.LVT=12]="LVT",U[U.ZWJ=13]="ZWJ",U[U.Extended_Pictographic=14]="Extended_Pictographic"})(Ze=e.GraphemeBreakType||(e.GraphemeBreakType={}));class De{constructor(){this._data=Se()}static getInstance(){return De._INSTANCE||(De._INSTANCE=new De),De._INSTANCE}getGraphemeBreakType(me){if(me<32)return me===10?3:me===13?2:4;if(me<127)return 0;const we=this._data,Ie=we.length/3;let Oe=1;for(;Oe<=Ie;)if(me<we[3*Oe])Oe=2*Oe;else if(me>we[3*Oe+1])Oe=2*Oe+1;else return we[3*Oe+2];return 0}}De._INSTANCE=null;function Se(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function Pe(U,me){if(U===0)return 0;const we=re(U,me);if(we!==void 0)return we;const Ie=R(me,U);return U-=ae(Ie),U}e.getLeftDeleteOffset=Pe;function re(U,me){let we=R(me,U);for(U-=ae(we);fe(we)||we===65039||we===8419;){if(U===0)return;we=R(me,U),U-=ae(we)}if(!!G(we)){if(U>=0){const Ie=R(me,U);Ie===8205&&(U-=ae(Ie))}return U}}function ae(U){return U>=65536?2:1}function fe(U){return 127995<=U&&U<=127999}var pe;(function(U){U[U.zwj=8205]="zwj",U[U.emojiVariantSelector=65039]="emojiVariantSelector",U[U.enclosingKeyCap=8419]="enclosingKeyCap"})(pe||(pe={}))}),define(be[24],Ee([0,1,8,113]),function(ee,e,g,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const S=typeof Buffer!="undefined",_=typeof TextEncoder!="undefined",C=typeof TextDecoder!="undefined";let y,b;class k{constructor(v){this.buffer=v,this.byteLength=this.buffer.byteLength}static alloc(v){return S?new k(Buffer.allocUnsafe(v)):new k(new Uint8Array(v))}static wrap(v){return S&&!Buffer.isBuffer(v)&&(v=Buffer.from(v.buffer,v.byteOffset,v.byteLength)),new k(v)}static fromString(v,D){return!(D?.dontUseNodeBuffer||!1)&&S?new k(Buffer.from(v)):_?(y||(y=new TextEncoder),new k(y.encode(v))):new k(g.encodeUTF8(v))}static concat(v,D){if(typeof D=="undefined"){D=0;for(let A=0,L=v.length;A<L;A++)D+=v[A].byteLength}const T=k.alloc(D);let o=0;for(let A=0,L=v.length;A<L;A++){const B=v[A];T.set(B,o),o+=B.byteLength}return T}toString(){return S?this.buffer.toString():C?(b||(b=new TextDecoder),b.decode(this.buffer)):g.decodeUTF8(this.buffer)}slice(v,D){return new k(this.buffer.subarray(v,D))}set(v,D){v instanceof k?this.buffer.set(v.buffer,D):this.buffer.set(v,D)}readUInt32BE(v){return l(this.buffer,v)}writeUInt32BE(v,D){d(this.buffer,v,D)}readUInt32LE(v){return c(this.buffer,v)}writeUInt32LE(v,D){m(this.buffer,v,D)}readUInt8(v){return E(this.buffer,v)}writeUInt8(v,D){w(this.buffer,v,D)}}e.VSBuffer=k;function n(f,v){return f[v+0]<<0>>>0|f[v+1]<<8>>>0}e.readUInt16LE=n;function I(f,v,D){f[D+0]=v&255,v=v>>>8,f[D+1]=v&255}e.writeUInt16LE=I;function l(f,v){return f[v]*2**24+f[v+1]*2**16+f[v+2]*2**8+f[v+3]}e.readUInt32BE=l;function d(f,v,D){f[D+3]=v,v=v>>>8,f[D+2]=v,v=v>>>8,f[D+1]=v,v=v>>>8,f[D]=v}e.writeUInt32BE=d;function c(f,v){return f[v+0]<<0>>>0|f[v+1]<<8>>>0|f[v+2]<<16>>>0|f[v+3]<<24>>>0}e.readUInt32LE=c;function m(f,v,D){f[D+0]=v&255,v=v>>>8,f[D+1]=v&255,v=v>>>8,f[D+2]=v&255,v=v>>>8,f[D+3]=v&255}e.writeUInt32LE=m;function E(f,v){return f[v]}e.readUInt8=E;function w(f,v,D){f[D]=v}e.writeUInt8=w;function P(f){return F.consumeReadable(f,v=>k.concat(v))}e.readableToBuffer=P;function a(f){return F.toReadable(f)}e.bufferToReadable=a;function h(f){return F.consumeStream(f,v=>k.concat(v))}e.streamToBuffer=h;async function p(f){return f.ended?k.concat(f.buffer):k.concat([...f.buffer,await h(f.stream)])}e.bufferedStreamToBuffer=p;function t(f){return F.toStream(f,v=>k.concat(v))}e.bufferToStream=t;function r(f){return F.transform(f,{data:v=>typeof v=="string"?k.fromString(v):k.wrap(v)},v=>k.concat(v))}e.streamToBufferReadableStream=r;function s(f){return F.newWriteableStream(v=>k.concat(v),f)}e.newWriteableBufferStream=s;function i(f,v){return F.prefixedReadable(f,v,D=>k.concat(D))}e.prefixedBufferReadable=i;function u(f,v){return F.prefixedStream(f,v,D=>k.concat(D))}e.prefixedBufferStream=u}),define(be[42],Ee([0,1,8]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function F(w){return S(w,0)}e.hash=F;function S(w,P){switch(typeof w){case"object":return w===null?_(349,P):Array.isArray(w)?b(w,P):k(w,P);case"string":return y(w,P);case"boolean":return C(w,P);case"number":return _(w,P);case"undefined":return _(937,P);default:return _(617,P)}}e.doHash=S;function _(w,P){return(P<<5)-P+w|0}function C(w,P){return _(w?433:863,P)}function y(w,P){P=_(149417,P);for(let a=0,h=w.length;a<h;a++)P=_(w.charCodeAt(a),P);return P}e.stringHash=y;function b(w,P){return P=_(104579,P),w.reduce((a,h)=>S(h,a),P)}function k(w,P){return P=_(181387,P),Object.keys(w).sort().reduce((a,h)=>(a=y(h,a),S(w[h],a)),P)}class n{constructor(){this._value=0}get value(){return this._value}hash(P){return this._value=S(P,this._value),this._value}}e.Hasher=n;var I;(function(w){w[w.BLOCK_SIZE=64]="BLOCK_SIZE",w[w.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function l(w,P,a=32){const h=a-P,p=~((1<<h)-1);return(w<<P|(p&w)>>>h)>>>0}function d(w,P=0,a=w.byteLength,h=0){for(let p=0;p<a;p++)w[P+p]=h}function c(w,P,a="0"){for(;w.length<P;)w=a+w;return w}function m(w,P=32){return w instanceof ArrayBuffer?Array.from(new Uint8Array(w)).map(a=>a.toString(16).padStart(2,"0")).join(""):c((w>>>0).toString(16),P/4)}e.toHexString=m;class E{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(P){const a=P.length;if(a===0)return;const h=this._buff;let p=this._buffLen,t=this._leftoverHighSurrogate,r,s;for(t!==0?(r=t,s=-1,t=0):(r=P.charCodeAt(0),s=0);;){let i=r;if(g.isHighSurrogate(r))if(s+1<a){const u=P.charCodeAt(s+1);g.isLowSurrogate(u)?(s++,i=g.computeCodePoint(r,u)):i=65533}else{t=r;break}else g.isLowSurrogate(r)&&(i=65533);if(p=this._push(h,p,i),s++,s<a)r=P.charCodeAt(s);else break}this._buffLen=p,this._leftoverHighSurrogate=t}_push(P,a,h){return h<128?P[a++]=h:h<2048?(P[a++]=192|(h&1984)>>>6,P[a++]=128|(h&63)>>>0):h<65536?(P[a++]=224|(h&61440)>>>12,P[a++]=128|(h&4032)>>>6,P[a++]=128|(h&63)>>>0):(P[a++]=240|(h&1835008)>>>18,P[a++]=128|(h&258048)>>>12,P[a++]=128|(h&4032)>>>6,P[a++]=128|(h&63)>>>0),a>=64&&(this._step(),a-=64,this._totalLen+=64,P[0]=P[64+0],P[1]=P[64+1],P[2]=P[64+2]),a}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),m(this._h0)+m(this._h1)+m(this._h2)+m(this._h3)+m(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,d(this._buff,this._buffLen),this._buffLen>56&&(this._step(),d(this._buff));const P=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(P/4294967296),!1),this._buffDV.setUint32(60,P%4294967296,!1),this._step()}_step(){const P=E._bigBlock32,a=this._buffDV;for(let v=0;v<64;v+=4)P.setUint32(v,a.getUint32(v,!1),!1);for(let v=64;v<320;v+=4)P.setUint32(v,l(P.getUint32(v-12,!1)^P.getUint32(v-32,!1)^P.getUint32(v-56,!1)^P.getUint32(v-64,!1),1),!1);let h=this._h0,p=this._h1,t=this._h2,r=this._h3,s=this._h4,i,u,f;for(let v=0;v<80;v++)v<20?(i=p&t|~p&r,u=1518500249):v<40?(i=p^t^r,u=1859775393):v<60?(i=p&t|p&r|t&r,u=2400959708):(i=p^t^r,u=3395469782),f=l(h,5)+i+s+u+P.getUint32(v*4,!1)&4294967295,s=r,r=t,t=l(p,30),p=h,h=f;this._h0=this._h0+h&4294967295,this._h1=this._h1+p&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=E,E._bigBlock32=new DataView(new ArrayBuffer(320))}),define(be[43],Ee([0,1,8]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var F;(function(S){S[S.Ignore=0]="Ignore",S[S.Info=1]="Info",S[S.Warning=2]="Warning",S[S.Error=3]="Error"})(F||(F={})),function(S){const _="error",C="warning",y="warn",b="info",k="ignore";function n(l){return l?g.equalsIgnoreCase(_,l)?S.Error:g.equalsIgnoreCase(C,l)||g.equalsIgnoreCase(y,l)?S.Warning:g.equalsIgnoreCase(b,l)?S.Info:S.Ignore:S.Ignore}S.fromValue=n;function I(l){switch(l){case S.Error:return _;case S.Warning:return C;case S.Info:return b;default:return k}}S.toString=I}(F||(F={})),e.default=F}),define(be[10],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function g(v){return Array.isArray(v)}e.isArray=g;function F(v){return typeof v=="string"}e.isString=F;function S(v){return Array.isArray(v)&&v.every(D=>F(D))}e.isStringArray=S;function _(v){return typeof v=="object"&&v!==null&&!Array.isArray(v)&&!(v instanceof RegExp)&&!(v instanceof Date)}e.isObject=_;function C(v){return typeof v=="number"&&!isNaN(v)}e.isNumber=C;function y(v){return!!v&&typeof v[Symbol.iterator]=="function"}e.isIterable=y;function b(v){return v===!0||v===!1}e.isBoolean=b;function k(v){return typeof v=="undefined"}e.isUndefined=k;function n(v){return!I(v)}e.isDefined=n;function I(v){return k(v)||v===null}e.isUndefinedOrNull=I;function l(v,D){if(!v)throw new Error(D?`Unexpected type, expected '${D}'`:"Unexpected type")}e.assertType=l;function d(v){if(I(v))throw new Error("Assertion Failed: argument is undefined or null");return v}e.assertIsDefined=d;function c(...v){const D=[];for(let T=0;T<v.length;T++){const o=v[T];if(I(o))throw new Error(`Assertion Failed: argument at index ${T} is undefined or null`);D.push(o)}return D}e.assertAllDefined=c;const m=Object.prototype.hasOwnProperty;function E(v){if(!_(v))return!1;for(let D in v)if(m.call(v,D))return!1;return!0}e.isEmptyObject=E;function w(v){return typeof v=="function"}e.isFunction=w;function P(...v){return v.length>0&&v.every(w)}e.areFunctions=P;function a(v,D){const T=Math.min(v.length,D.length);for(let o=0;o<T;o++)h(v[o],D[o])}e.validateConstraints=a;function h(v,D){if(F(D)){if(typeof v!==D)throw new Error(`argument does not match constraint: typeof ${D}`)}else if(w(D)){try{if(v instanceof D)return}catch{}if(!I(v)&&v.constructor===D||D.length===1&&D.call(void 0,v)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=h;function p(v){let D=[],T=Object.getPrototypeOf(v);for(;Object.prototype!==T;)D=D.concat(Object.getOwnPropertyNames(T)),T=Object.getPrototypeOf(T);return D}e.getAllPropertyNames=p;function t(v){const D=[];for(const T of p(v))typeof v[T]=="function"&&D.push(T);return D}e.getAllMethodNames=t;function r(v,D){const T=A=>function(){const L=Array.prototype.slice.call(arguments,0);return D(A,L)};let o={};for(const A of v)o[A]=T(A);return o}e.createProxyObject=r;function s(v){return v===null?void 0:v}e.withNullAsUndefined=s;function i(v){return typeof v=="undefined"?null:v}e.withUndefinedAsNull=i;function u(v){return class{constructor(){return new Proxy({},{get(D,T){if(D[T])return D[T];throw new Error(`Not Implemented: ${v}->${String(T)}`)}})}}}e.NotImplementedProxy=u;function f(v,D="Unreachable"){throw new Error(D)}e.assertNever=f}),define(be[44],Ee([0,1,22,8,14,10]),function(ee,e,g,F,S,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function C(s){return s===47||s===92}e.isPathSeparator=C;function y(s){return s.replace(/[\\/]/g,S.posix.sep)}e.toSlashes=y;function b(s){return s.indexOf("/")===-1&&(s=y(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=b;function k(s,i=S.posix.sep){if(!s)return"";const u=s.length,f=s.charCodeAt(0);if(C(f)){if(C(s.charCodeAt(1))&&!C(s.charCodeAt(2))){let D=3;const T=D;for(;D<u&&!C(s.charCodeAt(D));D++);if(T!==D&&!C(s.charCodeAt(D+1))){for(D+=1;D<u;D++)if(C(s.charCodeAt(D)))return s.slice(0,D+1).replace(/[\\/]/g,i)}}return i}else if(w(f)&&s.charCodeAt(1)===58)return C(s.charCodeAt(2))?s.slice(0,2)+i:s.slice(0,2);let v=s.indexOf("://");if(v!==-1){for(v+=3;v<u;v++)if(C(s.charCodeAt(v)))return s.slice(0,v+1)}return""}e.getRoot=k;function n(s){if(!g.isWindows||!s||s.length<5)return!1;let i=s.charCodeAt(0);if(i!==92||(i=s.charCodeAt(1),i!==92))return!1;let u=2;const f=u;for(;u<s.length&&(i=s.charCodeAt(u),i!==92);u++);return!(f===u||(i=s.charCodeAt(u+1),isNaN(i)||i===92))}e.isUNC=n;const I=/[\\/:\*\?"<>\|]/g,l=/[\\/]/g,d=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function c(s,i=g.isWindows){const u=i?I:l;return!(!s||s.length===0||/^\s+$/.test(s)||(u.lastIndex=0,u.test(s))||i&&d.test(s)||s==="."||s===".."||i&&s[s.length-1]==="."||i&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=c;function m(s,i,u){const f=s===i;return!u||f?f:!s||!i?!1:(0,F.equalsIgnoreCase)(s,i)}e.isEqual=m;function E(s,i,u,f=S.sep){if(s===i)return!0;if(!s||!i||i.length>s.length)return!1;if(u){if(!(0,F.startsWithIgnoreCase)(s,i))return!1;if(i.length===s.length)return!0;let D=i.length;return i.charAt(i.length-1)===f&&D--,s.charAt(D)===f}return i.charAt(i.length-1)!==f&&(i+=f),s.indexOf(i)===0}e.isEqualOrParent=E;function w(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=w;function P(s,i){return g.isWindows&&s.endsWith(":")&&(s+=S.sep),(0,S.isAbsolute)(s)||(s=(0,S.join)(i,s)),s=(0,S.normalize)(s),g.isWindows?(s=(0,F.rtrim)(s,S.sep),s.endsWith(":")&&(s+=S.sep)):(s=(0,F.rtrim)(s,S.sep),s||(s=S.sep)),s}e.sanitizeFilePath=P;function a(s){const i=(0,S.normalize)(s);return g.isWindows?s.length>3?!1:h(i)&&(s.length===2||i.charCodeAt(2)===92):i===S.posix.sep}e.isRootOrDriveLetter=a;function h(s){return g.isWindows?w(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=h;function p(s){return h(s)?s[0]:void 0}e.getDriveLetter=p;function t(s,i,u){return i.length>s.length?-1:s===i?0:(u&&(s=s.toLowerCase(),i=i.toLowerCase()),s.indexOf(i))}e.indexOfPath=t;function r(s){const i=s.split(":");let u,f,v;if(i.forEach(D=>{const T=Number(D);(0,_.isNumber)(T)?f===void 0?f=T:v===void 0&&(v=T):u=u?[u,D].join(":"):D}),!u)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:u,line:f!==void 0?f:void 0,column:v!==void 0?v:f!==void 0?1:void 0}}e.parseLineAndColumnAware=r}),define(be[23],Ee([0,1,10]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function F(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const E=Array.isArray(m)?[]:{};return Object.keys(m).forEach(w=>{m[w]&&typeof m[w]=="object"?E[w]=F(m[w]):E[w]=m[w]}),E}e.deepClone=F;function S(m){if(!m||typeof m!="object")return m;const E=[m];for(;E.length>0;){const w=E.shift();Object.freeze(w);for(const P in w)if(_.call(w,P)){const a=w[P];typeof a=="object"&&!Object.isFrozen(a)&&E.push(a)}}return m}e.deepFreeze=S;const _=Object.prototype.hasOwnProperty;function C(m,E){return y(m,E,new Set)}e.cloneAndChange=C;function y(m,E,w){if((0,g.isUndefinedOrNull)(m))return m;const P=E(m);if(typeof P!="undefined")return P;if((0,g.isArray)(m)){const a=[];for(const h of m)a.push(y(h,E,w));return a}if((0,g.isObject)(m)){if(w.has(m))throw new Error("Cannot clone recursive data-structure");w.add(m);const a={};for(let h in m)_.call(m,h)&&(a[h]=y(m[h],E,w));return w.delete(m),a}return m}function b(m,E,w=!0){return(0,g.isObject)(m)?((0,g.isObject)(E)&&Object.keys(E).forEach(P=>{P in m?w&&((0,g.isObject)(m[P])&&(0,g.isObject)(E[P])?b(m[P],E[P],w):m[P]=E[P]):m[P]=E[P]}),m):E}e.mixin=b;function k(m,E){if(m===E)return!0;if(m==null||E===null||E===void 0||typeof m!=typeof E||typeof m!="object"||Array.isArray(m)!==Array.isArray(E))return!1;let w,P;if(Array.isArray(m)){if(m.length!==E.length)return!1;for(w=0;w<m.length;w++)if(!k(m[w],E[w]))return!1}else{const a=[];for(P in m)a.push(P);a.sort();const h=[];for(P in E)h.push(P);if(h.sort(),!k(a,h))return!1;for(w=0;w<a.length;w++)if(!k(m[a[w]],E[a[w]]))return!1}return!0}e.equals=k;function n(m){const E=new Set;return JSON.stringify(m,(w,P)=>{if((0,g.isObject)(P)||Array.isArray(P)){if(E.has(P))return"[Circular]";E.add(P)}return P})}e.safeStringify=n;function I(m,E,w){const P=E(m);return typeof P=="undefined"?w:P}e.getOrDefault=I;function l(m,E){const w=Object.create(null);return!m||!E||Object.keys(E).forEach(a=>{const h=m[a],p=E[a];k(h,p)||(w[a]=p)}),w}e.distinct=l;function d(m,E){const w=E.toLowerCase(),P=Object.keys(m).find(a=>a.toLowerCase()===w);return P?m[P]:m[E]}e.getCaseInsensitive=d;function c(m,E){const w=Object.create(null);for(const P of Object.keys(m))E(P,m[P])&&(w[P]=m[P]);return w}e.filter=c}),define(be[82],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var g;(function(_){_[_.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",_[_.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",_[_.MAX_UINT_8=255]="MAX_UINT_8",_[_.MAX_UINT_16=65535]="MAX_UINT_16",_[_.MAX_UINT_32=4294967295]="MAX_UINT_32",_[_.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(g=e.Constants||(e.Constants={}));function F(_){return _<0?0:_>255?255:_|0}e.toUint8=F;function S(_){return _<0?0:_>4294967295?4294967295:_|0}e.toUint32=S}),define(be[2],Ee([0,1,22,14]),function(ee,e,g,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const S=/^\w[\w\d+.-]*$/,_=/^\//,C=/^\/\//;function y(s,i){if(!s.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!S.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!_.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(C.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function b(s,i){return!s&&!i?"file":s}function k(s,i){switch(s){case"https":case"http":case"file":i?i[0]!==I&&(i=I+i):i=I;break}return i}const n="",I="/",l=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class d{constructor(i,u,f,v,D,T=!1){typeof i=="object"?(this.scheme=i.scheme||n,this.authority=i.authority||n,this.path=i.path||n,this.query=i.query||n,this.fragment=i.fragment||n):(this.scheme=b(i,T),this.authority=u||n,this.path=k(this.scheme,f||n),this.query=v||n,this.fragment=D||n,y(this,T))}static isUri(i){return i instanceof d?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}get fsPath(){return a(this,!1)}with(i){if(!i)return this;let{scheme:u,authority:f,path:v,query:D,fragment:T}=i;return u===void 0?u=this.scheme:u===null&&(u=n),f===void 0?f=this.authority:f===null&&(f=n),v===void 0?v=this.path:v===null&&(v=n),D===void 0?D=this.query:D===null&&(D=n),T===void 0?T=this.fragment:T===null&&(T=n),u===this.scheme&&f===this.authority&&v===this.path&&D===this.query&&T===this.fragment?this:new m(u,f,v,D,T)}static parse(i,u=!1){const f=l.exec(i);return f?new m(f[2]||n,r(f[4]||n),r(f[5]||n),r(f[7]||n),r(f[9]||n),u):new m(n,n,n,n,n)}static file(i){let u=n;if(g.isWindows&&(i=i.replace(/\\/g,I)),i[0]===I&&i[1]===I){const f=i.indexOf(I,2);f===-1?(u=i.substring(2),i=I):(u=i.substring(2,f),i=i.substring(f)||I)}return new m("file",u,i,n,n)}static from(i){const u=new m(i.scheme,i.authority,i.path,i.query,i.fragment);return y(u,!0),u}static joinPath(i,...u){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let f;return g.isWindows&&i.scheme==="file"?f=d.file(F.win32.join(a(i,!0),...u)).path:f=F.posix.join(i.path,...u),i.with({path:f})}toString(i=!1){return h(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof d)return i;{const u=new m(i);return u._formatted=i.external,u._fsPath=i._sep===c?i.fsPath:null,u}}else return i}}e.URI=d;const c=g.isWindows?1:void 0;class m extends d{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=a(this,!1)),this._fsPath}toString(i=!1){return i?h(this,!0):(this._formatted||(this._formatted=h(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=c),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const E={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function w(s,i){let u,f=-1;for(let v=0;v<s.length;v++){const D=s.charCodeAt(v);if(D>=97&&D<=122||D>=65&&D<=90||D>=48&&D<=57||D===45||D===46||D===95||D===126||i&&D===47)f!==-1&&(u+=encodeURIComponent(s.substring(f,v)),f=-1),u!==void 0&&(u+=s.charAt(v));else{u===void 0&&(u=s.substr(0,v));const T=E[D];T!==void 0?(f!==-1&&(u+=encodeURIComponent(s.substring(f,v)),f=-1),u+=T):f===-1&&(f=v)}}return f!==-1&&(u+=encodeURIComponent(s.substring(f))),u!==void 0?u:s}function P(s){let i;for(let u=0;u<s.length;u++){const f=s.charCodeAt(u);f===35||f===63?(i===void 0&&(i=s.substr(0,u)),i+=E[f]):i!==void 0&&(i+=s[u])}return i!==void 0?i:s}function a(s,i){let u;return s.authority&&s.path.length>1&&s.scheme==="file"?u=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?i?u=s.path.substr(1):u=s.path[1].toLowerCase()+s.path.substr(2):u=s.path,g.isWindows&&(u=u.replace(/\//g,"\\")),u}e.uriToFsPath=a;function h(s,i){const u=i?P:w;let f="",{scheme:v,authority:D,path:T,query:o,fragment:A}=s;if(v&&(f+=v,f+=":"),(D||v==="file")&&(f+=I,f+=I),D){let L=D.indexOf("@");if(L!==-1){const B=D.substr(0,L);D=D.substr(L+1),L=B.indexOf(":"),L===-1?f+=u(B,!1):(f+=u(B.substr(0,L),!1),f+=":",f+=u(B.substr(L+1),!1)),f+="@"}D=D.toLowerCase(),L=D.indexOf(":"),L===-1?f+=u(D,!1):(f+=u(D.substr(0,L),!1),f+=D.substr(L))}if(T){if(T.length>=3&&T.charCodeAt(0)===47&&T.charCodeAt(2)===58){const L=T.charCodeAt(1);L>=65&&L<=90&&(T=`/${String.fromCharCode(L+32)}:${T.substr(3)}`)}else if(T.length>=2&&T.charCodeAt(1)===58){const L=T.charCodeAt(0);L>=65&&L<=90&&(T=`${String.fromCharCode(L+32)}:${T.substr(2)}`)}f+=u(T,!0)}return o&&(f+="?",f+=u(o,!1)),A&&(f+="#",f+=i?A:w(A,!1)),f}function p(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+p(s.substr(3)):s}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(s){return s.match(t)?s.replace(t,i=>p(i)):s}});var nt=this&&this.__classPrivateFieldSet||function(ee,e,g,F,S){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?S.call(ee,g):S?S.value=g:e.set(ee,g),g},Ue=this&&this.__classPrivateFieldGet||function(ee,e,g,F){if(g==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!F:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?F:g==="a"?F.call(ee):F?F.value:e.get(ee)};define(be[21],Ee([0,1,2,8]),function(ee,e,g,F){"use strict";var S,_,C;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function y(t,r,s){let i=t.get(r);return i===void 0&&(i=s,t.set(r,i)),i}e.getOrSet=y;function b(t){const r=[];return t.forEach((s,i)=>{r.push(`${i} => ${s}`)}),`Map(${t.size}) {${r.join(", ")}}`}e.mapToString=b;function k(t){const r=[];return t.forEach(s=>{r.push(s)}),`Set(${t.size}) {${r.join(", ")}}`}e.setToString=k;class n{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const s=r.charCodeAt(0),i=this._value.charCodeAt(this._pos);return s-i}value(){return this._value[this._pos]}}e.StringIterator=n;class I{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,F.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,F.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=I;class l{constructor(r=!0,s=!0){this._splitOnBackslash=r,this._caseSensitive=s}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,F.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,F.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=l;var d;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(d||(d={}));class c{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new l(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,F.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,F.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,F.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,F.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=c;class m{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class E{constructor(r){this._iter=r}static forUris(r=()=>!1){return new E(new c(r))}static forPaths(){return new E(new l)}static forStrings(){return new E(new n)}static forConfigKeys(){return new E(new I)}clear(){this._root=void 0}set(r,s){const i=this._iter.reset(r);let u;for(this._root||(this._root=new m,this._root.segment=i.value()),u=this._root;;){const v=i.cmp(u.segment);if(v>0)u.left||(u.left=new m,u.left.segment=i.value()),u=u.left;else if(v<0)u.right||(u.right=new m,u.right.segment=i.value()),u=u.right;else if(i.hasNext())i.next(),u.mid||(u.mid=new m,u.mid.segment=i.value()),u=u.mid;else break}const f=u.value;return u.value=s,u.key=r,f}get(r){return this._getNode(r)?.value}_getNode(r){const s=this._iter.reset(r);let i=this._root;for(;i;){const u=s.cmp(i.segment);if(u>0)i=i.left;else if(u<0)i=i.right;else if(s.hasNext())s.next(),i=i.mid;else break}return i}has(r){const s=this._getNode(r);return!(s?.value===void 0&&s?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,s){const i=this._iter.reset(r),u=[];let f=this._root;for(;f;){const v=i.cmp(f.segment);if(v>0)u.push([1,f]),f=f.left;else if(v<0)u.push([-1,f]),f=f.right;else if(i.hasNext())i.next(),u.push([0,f]),f=f.mid;else{for(s?(f.left=void 0,f.mid=void 0,f.right=void 0):f.value=void 0;u.length>0&&f.isEmpty();){let[D,T]=u.pop();switch(D){case 1:T.left=void 0;break;case 0:T.mid=void 0;break;case-1:T.right=void 0;break}f=T}break}}}findSubstr(r){const s=this._iter.reset(r);let i=this._root,u;for(;i;){const f=s.cmp(i.segment);if(f>0)i=i.left;else if(f<0)i=i.right;else if(s.hasNext())s.next(),u=i.value||u,i=i.mid;else break}return i&&i.value||u}findSuperstr(r){const s=this._iter.reset(r);let i=this._root;for(;i;){const u=s.cmp(i.segment);if(u>0)i=i.left;else if(u<0)i=i.right;else if(s.hasNext())s.next(),i=i.mid;else return i.mid?this._entries(i.mid):void 0}}forEach(r){for(const[s,i]of this)r(i,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){if(!r)return;const s=[r];for(;s.length>0;){const i=s.pop();i&&(i.value&&(yield[i.key,i.value]),i.left&&s.push(i.left),i.mid&&s.push(i.mid),i.right&&s.push(i.right))}}}e.TernarySearchTree=E;class w{constructor(r,s){this[S]="ResourceMap",r instanceof w?(this.map=new Map(r.map),this.toKey=s??w.defaultToKey):(this.map=new Map,this.toKey=r??w.defaultToKey)}set(r,s){return this.map.set(this.toKey(r),s),this}get(r){return this.map.get(this.toKey(r))}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,s){typeof s!="undefined"&&(r=r.bind(s));for(let[i,u]of this.map)r(u,g.URI.parse(i),this)}values(){return this.map.values()}*keys(){for(let r of this.map.keys())yield g.URI.parse(r)}*entries(){for(let r of this.map.entries())yield[g.URI.parse(r[0]),r[1]]}*[(S=Symbol.toStringTag,Symbol.iterator)](){for(let r of this.map)yield[g.URI.parse(r[0]),r[1]]}}e.ResourceMap=w,w.defaultToKey=t=>t.toString();var P;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(P=e.Touch||(e.Touch={}));class a{constructor(){this[_]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,s=0){const i=this._map.get(r);if(!!i)return s!==0&&this.touch(i,s),i.value}set(r,s,i=0){let u=this._map.get(r);if(u)u.value=s,i!==0&&this.touch(u,i);else{switch(u={key:r,value:s,next:void 0,previous:void 0},i){case 0:this.addItemLast(u);break;case 1:this.addItemFirst(u);break;case 2:this.addItemLast(u);break;default:this.addItemLast(u);break}this._map.set(r,u),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const s=this._map.get(r);if(!!s)return this._map.delete(r),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,s){const i=this._state;let u=this._head;for(;u;){if(s?r.bind(s)(u.value,u.key,this):r(u.value,u.key,this),this._state!==i)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const r=this,s=this._state;let i=this._head;const u={[Symbol.iterator](){return u},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(i){const f={value:i.key,done:!1};return i=i.next,f}else return{value:void 0,done:!0}}};return u}values(){const r=this,s=this._state;let i=this._head;const u={[Symbol.iterator](){return u},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(i){const f={value:i.value,done:!1};return i=i.next,f}else return{value:void 0,done:!0}}};return u}entries(){const r=this,s=this._state;let i=this._head;const u={[Symbol.iterator](){return u},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(i){const f={value:[i.key,i.value],done:!1};return i=i.next,f}else return{value:void 0,done:!0}}};return u}[(_=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let s=this._head,i=this.size;for(;s&&i>r;)this._map.delete(s.key),s=s.next,i--;this._head=s,this._size=i,s&&(s.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const s=r.next,i=r.previous;if(!s||!i)throw new Error("Invalid list");s.previous=i,i.next=s}r.next=void 0,r.previous=void 0,this._state++}touch(r,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(r===this._head)return;const i=r.next,u=r.previous;r===this._tail?(u.next=void 0,this._tail=u):(i.previous=u,u.next=i),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(s===2){if(r===this._tail)return;const i=r.next,u=r.previous;r===this._head?(i.previous=void 0,this._head=i):(i.previous=u,u.next=i),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((s,i)=>{r.push([i,s])}),r}fromJSON(r){this.clear();for(const[s,i]of r)this.set(s,i)}}e.LinkedMap=a;class h extends a{constructor(r,s=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,s=2){return super.get(r,s)}peek(r){return super.get(r,0)}set(r,s){return super.set(r,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=h;class p{constructor(r){C.set(this,void 0),nt(this,C,r,"f")}get size(){return Ue(this,C,"f").size}forEach(r,s){Ue(this,C,"f").forEach(r,s)}get(r){return Ue(this,C,"f").get(r)}has(r){return Ue(this,C,"f").has(r)}entries(){return Ue(this,C,"f").entries()}keys(){return Ue(this,C,"f").keys()}values(){return Ue(this,C,"f").values()}[(C=new WeakMap,Symbol.iterator)](){return Ue(this,C,"f").entries()}}e.ReadonlyMapView=p}),define(be[114],Ee([0,1,21,8]),function(ee,e,g,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function S(...q){return function(ie,ge){for(let Le=0,We=q.length;Le<We;Le++){const ve=q[Le](ie,ge);if(ve)return ve}return null}}e.or=S,e.matchesStrictPrefix=_.bind(void 0,!1),e.matchesPrefix=_.bind(void 0,!0);function _(q,ie,ge){if(!ge||ge.length<ie.length)return null;let Le;return q?Le=F.startsWithIgnoreCase(ge,ie):Le=ge.indexOf(ie)===0,Le?ie.length>0?[{start:0,end:ie.length}]:[]:null}function C(q,ie){const ge=ie.toLowerCase().indexOf(q.toLowerCase());return ge===-1?null:[{start:ge,end:ge+q.length}]}e.matchesContiguousSubString=C;function y(q,ie){return b(q.toLowerCase(),ie.toLowerCase(),0,0)}e.matchesSubString=y;function b(q,ie,ge,Le){if(ge===q.length)return[];if(Le===ie.length)return null;if(q[ge]===ie[Le]){let We=null;return(We=b(q,ie,ge+1,Le+1))?w({start:Le,end:Le+1},We):null}return b(q,ie,ge,Le+1)}function k(q){return 97<=q&&q<=122}function n(q){return 65<=q&&q<=90}e.isUpper=n;function I(q){return 48<=q&&q<=57}function l(q){return q===32||q===9||q===10||q===13}const d=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(q=>d.add(q.charCodeAt(0)));function c(q){return l(q)||d.has(q)}function m(q,ie){return q===ie||c(q)&&c(ie)}function E(q){return k(q)||n(q)||I(q)}function w(q,ie){return ie.length===0?ie=[q]:q.end===ie[0].start?ie[0].start=q.start:ie.unshift(q),ie}function P(q,ie){for(let ge=ie;ge<q.length;ge++){const Le=q.charCodeAt(ge);if(n(Le)||I(Le)||ge>0&&!E(q.charCodeAt(ge-1)))return ge}return q.length}function a(q,ie,ge,Le){if(ge===q.length)return[];if(Le===ie.length)return null;if(q[ge]!==ie[Le].toLowerCase())return null;{let We=null,ve=Le+1;for(We=a(q,ie,ge+1,Le+1);!We&&(ve=P(ie,ve))<ie.length;)We=a(q,ie,ge+1,ve),ve++;return We===null?null:w({start:Le,end:Le+1},We)}}function h(q){let ie=0,ge=0,Le=0,We=0,ve=0;for(let Be=0;Be<q.length;Be++)ve=q.charCodeAt(Be),n(ve)&&ie++,k(ve)&&ge++,E(ve)&&Le++,I(ve)&&We++;const Xe=ie/q.length,H=ge/q.length,Z=Le/q.length,de=We/q.length;return{upperPercent:Xe,lowerPercent:H,alphaPercent:Z,numericPercent:de}}function p(q){const{upperPercent:ie,lowerPercent:ge}=q;return ge===0&&ie>.6}function t(q){const{upperPercent:ie,lowerPercent:ge,alphaPercent:Le,numericPercent:We}=q;return ge>.2&&ie<.8&&Le>.6&&We<.2}function r(q){let ie=0,ge=0,Le=0,We=0;for(let ve=0;ve<q.length;ve++)Le=q.charCodeAt(ve),n(Le)&&ie++,k(Le)&&ge++,l(Le)&&We++;return(ie===0||ge===0)&&We===0?q.length<=30:ie<=5}function s(q,ie){if(!ie||(ie=ie.trim(),ie.length===0)||!r(q)||ie.length>60)return null;const ge=h(ie);if(!t(ge)){if(!p(ge))return null;ie=ie.toLowerCase()}let Le=null,We=0;for(q=q.toLowerCase();We<ie.length&&(Le=a(q,ie,0,We))===null;)We=P(ie,We+1);return Le}e.matchesCamelCase=s;function i(q,ie,ge=!1){if(!ie||ie.length===0)return null;let Le=null,We=0;for(q=q.toLowerCase(),ie=ie.toLowerCase();We<ie.length&&(Le=u(q,ie,0,We,ge))===null;)We=f(ie,We+1);return Le}e.matchesWords=i;function u(q,ie,ge,Le,We){if(ge===q.length)return[];if(Le===ie.length)return null;if(m(q.charCodeAt(ge),ie.charCodeAt(Le))){let ve=null,Xe=Le+1;if(ve=u(q,ie,ge+1,Le+1,We),!We)for(;!ve&&(Xe=f(ie,Xe))<ie.length;)ve=u(q,ie,ge+1,Xe,We),Xe++;return ve===null?null:w({start:Le,end:Le+1},ve)}else return null}function f(q,ie){for(let ge=ie;ge<q.length;ge++)if(c(q.charCodeAt(ge))||ge>0&&c(q.charCodeAt(ge-1)))return ge;return q.length}const v=S(e.matchesPrefix,s,C),D=S(e.matchesPrefix,s,y),T=new g.LRUCache(1e4);function o(q,ie,ge=!1){if(typeof q!="string"||typeof ie!="string")return null;let Le=T.get(q);Le||(Le=new RegExp(F.convertSimple2RegExpPattern(q),"i"),T.set(q,Le));const We=Le.exec(ie);return We?[{start:We.index,end:We.index+We[0].length}]:ge?D(q,ie):v(q,ie)}e.matchesFuzzy=o;function A(q,ie){const ge=Je(q,q.toLowerCase(),0,ie,ie.toLowerCase(),0,!0);return ge?B(ge):null}e.matchesFuzzy2=A;function L(q,ie,ge,Le,We,ve){const Xe=Math.min(13,q.length);for(;ge<Xe;ge++){const H=Je(q,ie,ge,Le,We,ve,!1);if(H)return H}return[0,ve]}e.anyScore=L;function B(q){if(typeof q=="undefined")return[];const ie=[],ge=q[1];for(let Le=q.length-1;Le>1;Le--){const We=q[Le]+ge,ve=ie[ie.length-1];ve&&ve.end===We?ve.end=We+1:ie.push({start:We,end:We+1})}return ie}e.createMatches=B;const oe=128;function he(){const q=[],ie=[];for(let ge=0;ge<=oe;ge++)ie[ge]=0;for(let ge=0;ge<=oe;ge++)q.push(ie.slice(0));return q}function Q(q){const ie=[];for(let ge=0;ge<=q;ge++)ie[ge]=0;return ie}const z=Q(2*oe),V=Q(2*oe),R=he(),K=he(),x=he(),j=!1;function ue(q,ie,ge,Le,We){function ve(H,Z,de=" "){for(;H.length<Z;)H=de+H;return H}let Xe=` |   |${Le.split("").map(H=>ve(H,3)).join("|")}
`;for(let H=0;H<=ge;H++)H===0?Xe+=" |":Xe+=`${ie[H-1]}|`,Xe+=q[H].slice(0,We+1).map(Z=>ve(Z.toString(),3)).join("|")+`
`;return Xe}function $(q,ie,ge,Le){q=q.substr(ie),ge=ge.substr(Le),console.log(ue(K,q,q.length,ge,ge.length)),console.log(ue(x,q,q.length,ge,ge.length)),console.log(ue(R,q,q.length,ge,ge.length))}function te(q,ie){if(ie<0||ie>=q.length)return!1;const ge=q.codePointAt(ie);switch(ge){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!F.isEmojiImprecise(ge)}}function ce(q,ie){if(ie<0||ie>=q.length)return!1;switch(q.charCodeAt(ie)){case 32:case 9:return!0;default:return!1}}function ye(q,ie,ge){return ie[q]!==ge[q]}function Re(q,ie,ge,Le,We,ve,Xe=!1){for(;ie<ge&&We<ve;)q[ie]===Le[We]&&(Xe&&(z[ie]=We),ie+=1),We+=1;return ie===ge}e.isPatternInWord=Re;var Te;(function(q){q[q.Diag=1]="Diag",q[q.Left=2]="Left",q[q.LeftLeft=3]="LeftLeft"})(Te||(Te={}));var $e;(function(q){q.Default=[-100,0];function ie(ge){return!ge||ge.length===2&&ge[0]===-100&&ge[1]===0}q.isDefault=ie})($e=e.FuzzyScore||(e.FuzzyScore={}));function Je(q,ie,ge,Le,We,ve,Xe){const H=q.length>oe?oe:q.length,Z=Le.length>oe?oe:Le.length;if(ge>=H||ve>=Z||H-ge>Z-ve||!Re(ie,ge,H,We,ve,Z,!0))return;Ve(H,Z,ge,ve,ie,We);let de=1,Be=1,xe=ge,Ze=ve;const De=[!1];for(de=1,xe=ge;xe<H;de++,xe++){const fe=z[xe],pe=V[xe],U=xe+1<H?V[xe+1]:Z;for(Be=fe-ve+1,Ze=fe;Ze<U;Be++,Ze++){let me=Number.MIN_SAFE_INTEGER,we=!1;Ze<=pe&&(me=je(q,ie,xe,ge,Le,We,Ze,Z,ve,R[de-1][Be-1]===0,De));let Ie=0;me!==Number.MAX_SAFE_INTEGER&&(we=!0,Ie=me+K[de-1][Be-1]);const Oe=Ze>fe,He=Oe?K[de][Be-1]+(R[de][Be-1]>0?-5:0):0,et=Ze>fe+1&&R[de][Be-1]>0,Qe=et?K[de][Be-2]+(R[de][Be-2]>0?-5:0):0;if(et&&(!Oe||Qe>=He)&&(!we||Qe>=Ie))K[de][Be]=Qe,x[de][Be]=3,R[de][Be]=0;else if(Oe&&(!we||He>=Ie))K[de][Be]=He,x[de][Be]=2,R[de][Be]=0;else if(we)K[de][Be]=Ie,x[de][Be]=1,R[de][Be]=R[de-1][Be-1]+1;else throw new Error("not possible")}}if(j&&$(q,ge,Le,ve),!De[0]&&!Xe)return;de--,Be--;const Se=[K[de][Be],ve];let Pe=0,re=0;for(;de>=1;){let fe=Be;do{const pe=x[de][fe];if(pe===3)fe=fe-2;else if(pe===2)fe=fe-1;else break}while(fe>=1);Pe>1&&ie[ge+de-1]===We[ve+Be-1]&&!ye(fe+ve-1,Le,We)&&Pe+1>R[de][fe]&&(fe=Be),fe===Be?Pe++:Pe=1,re||(re=fe),de--,Be=fe-1,Se.push(Be)}Z===H&&(Se[0]+=2);const ae=re-H;return Se[0]-=ae,Se}e.fuzzyScore=Je;function Ve(q,ie,ge,Le,We,ve){let Xe=q-1,H=ie-1;for(;Xe>=ge&&H>=Le;)We[Xe]===ve[H]&&(V[Xe]=H,Xe--),H--}function je(q,ie,ge,Le,We,ve,Xe,H,Z,de,Be){if(ie[ge]!==ve[Xe])return Number.MIN_SAFE_INTEGER;let xe=1,Ze=!1;return Xe===ge-Le?xe=q[ge]===We[Xe]?7:5:ye(Xe,We,ve)&&(Xe===0||!ye(Xe-1,We,ve))?(xe=q[ge]===We[Xe]?7:5,Ze=!0):te(ve,Xe)&&(Xe===0||!te(ve,Xe-1))?xe=5:(te(ve,Xe-1)||ce(ve,Xe-1))&&(xe=5,Ze=!0),xe>1&&ge===Le&&(Be[0]=!0),Ze||(Ze=ye(Xe,We,ve)||te(ve,Xe-1)||ce(ve,Xe-1)),ge===Le?Xe>Z&&(xe-=Ze?3:5):de?xe+=Ze?2:0:xe+=Ze?0:1,Xe+1===H&&(xe-=Ze?3:5),xe}function O(q,ie,ge,Le,We,ve,Xe){return X(q,ie,ge,Le,We,ve,!0,Xe)}e.fuzzyScoreGracefulAggressive=O;function G(q,ie,ge,Le,We,ve,Xe){return X(q,ie,ge,Le,We,ve,!1,Xe)}e.fuzzyScoreGraceful=G;function X(q,ie,ge,Le,We,ve,Xe,H){let Z=Je(q,ie,ge,Le,We,ve,H);if(Z&&!Xe)return Z;if(q.length>=3){const de=Math.min(7,q.length-1);for(let Be=ge+1;Be<de;Be++){const xe=se(q,Be);if(xe){const Ze=Je(xe,xe.toLowerCase(),ge,Le,We,ve,H);Ze&&(Ze[0]-=3,(!Z||Ze[0]>Z[0])&&(Z=Ze))}}}return Z}function se(q,ie){if(ie+1>=q.length)return;const ge=q[ie],Le=q[ie+1];if(ge!==Le)return q.slice(0,ie)+Le+ge+q.slice(ie+2)}}),define(be[115],Ee([0,1,35,114,8]),function(ee,e,g,F,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const _=new RegExp(`\\$\\(${g.CSSIcon.iconNameExpression}(?:${g.CSSIcon.iconModifierExpression})?\\)`,"g"),C=new RegExp(`(\\\\)?${_.source}`,"g");function y(m){return m.replace(C,(E,w)=>w?E:`\\${E}`)}e.escapeIcons=y;const b=new RegExp(`\\\\${_.source}`,"g");function k(m){return m.replace(b,E=>`\\${E}`)}e.markdownEscapeEscapedIcons=k;const n=new RegExp(`(\\s)?(\\\\)?${_.source}(\\s)?`,"g");function I(m){return m.indexOf(e.iconStartMarker)===-1?m:m.replace(n,(E,w,P,a)=>P?E:w||a||"")}e.stripIcons=I;function l(m){const E=m.indexOf(e.iconStartMarker);return E===-1?{text:m}:d(m,E)}e.parseLabelWithIcons=l;function d(m,E){const w=[];let P="";function a(f){if(f){P+=f;for(const v of f)w.push(t)}}let h=-1,p="",t=0,r,s,i=E;const u=m.length;for(a(m.substr(0,E));i<u;)r=m[i],s=m[i+1],r===e.iconStartMarker[0]&&s===e.iconStartMarker[1]?(h=i,a(p),p=e.iconStartMarker,i++):r===")"&&h!==-1?(t+=i-h+1,h=-1,p=""):h!==-1?/^[a-z0-9\-]$/i.test(r)?p+=r:(a(p),h=-1,p=""):a(r),i++;return a(p),{text:P,iconOffsets:w}}function c(m,E,w=!1){const{text:P,iconOffsets:a}=E;if(!a||a.length===0)return(0,F.matchesFuzzy)(m,P,w);const h=(0,S.ltrim)(P," "),p=P.length-h.length,t=(0,F.matchesFuzzy)(m,h,w);if(t)for(const r of t){const s=a[r.start+p]+p;r.start+=s,r.end+=s}return t}e.matchesFuzzyIconAware=c}),define(be[83],Ee([0,1,115,12]),function(ee,e,g,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var S;(function(l){l[l.Paragraph=0]="Paragraph",l[l.Break=1]="Break"})(S=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class _{constructor(d="",c=!1){if(this.value=d,typeof this.value!="string")throw(0,F.illegalArgument)("value");typeof c=="boolean"?(this.isTrusted=c,this.supportThemeIcons=!1):(this.isTrusted=c.isTrusted??void 0,this.supportThemeIcons=c.supportThemeIcons??!1)}appendText(d,c=0){return this.value+=k(this.supportThemeIcons?(0,g.escapeIcons)(d):d).replace(/([ \t]+)/g,(m,E)=>"&nbsp;".repeat(E.length)).replace(/^>/gm,"\\>").replace(/\n/g,c===1?`\\
`:`

`),this}appendMarkdown(d){return this.value+=d,this}appendCodeblock(d,c){return this.value+="\n```",this.value+=d,this.value+=`
`,this.value+=c,this.value+="\n```\n",this}}e.MarkdownString=_;function C(l){return y(l)?!l.value:Array.isArray(l)?l.every(C):!0}e.isEmptyMarkdownString=C;function y(l){return l instanceof _?!0:l&&typeof l=="object"?typeof l.value=="string"&&(typeof l.isTrusted=="boolean"||l.isTrusted===void 0)&&(typeof l.supportThemeIcons=="boolean"||l.supportThemeIcons===void 0):!1}e.isMarkdownString=y;function b(l,d){return l===d?!0:!l||!d?!1:l.value===d.value&&l.isTrusted===d.isTrusted&&l.supportThemeIcons===d.supportThemeIcons}e.markdownStringEqual=b;function k(l){return l.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=k;function n(l){return l&&l.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=n;function I(l){const d=[],c=l.split("|").map(E=>E.trim());l=c[0];const m=c[1];if(m){const E=/height=(\d+)/.exec(m),w=/width=(\d+)/.exec(m),P=E?E[1]:"",a=w?w[1]:"",h=isFinite(parseInt(a)),p=isFinite(parseInt(P));h&&d.push(`width="${a}"`),p&&d.push(`height="${P}"`)}return{href:l,dimensions:d}}e.parseHrefAndDimensions=I}),define(be[56],Ee([0,1,24,8,2]),function(ee,e,g,F,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function _(n){return JSON.stringify(n,b)}e.stringify=_;function C(n){let I=JSON.parse(n);return I=k(I),I}e.parse=C;var y;(function(n){n[n.Uri=1]="Uri",n[n.Regexp=2]="Regexp",n[n.ScmResource=3]="ScmResource",n[n.ScmResourceGroup=4]="ScmResourceGroup",n[n.ScmProvider=5]="ScmProvider",n[n.CommentController=6]="CommentController",n[n.CommentThread=7]="CommentThread",n[n.CommentThreadReply=8]="CommentThreadReply",n[n.CommentNode=9]="CommentNode",n[n.CommentThreadNode=10]="CommentThreadNode",n[n.TimelineActionContext=11]="TimelineActionContext",n[n.NotebookCellActionContext=12]="NotebookCellActionContext",n[n.TestItemContext=13]="TestItemContext"})(y=e.MarshalledId||(e.MarshalledId={}));function b(n,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:(0,F.regExpFlags)(I)}:I}function k(n,I=0){if(!n||I>200)return n;if(typeof n=="object"){switch(n.$mid){case 1:return S.URI.revive(n);case 2:return new RegExp(n.source,n.flags)}if(n instanceof g.VSBuffer||n instanceof Uint8Array)return n;if(Array.isArray(n))for(let l=0;l<n.length;++l)n[l]=k(n[l],I+1);else for(const l in n)Object.hasOwnProperty.call(n,l)&&(n[l]=k(n[l],I+1))}return n}e.revive=k}),define(be[11],Ee([0,1,2,22]),function(ee,e,g,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var S;(function(y){y.inMemory="inmemory",y.vscode="vscode",y.internal="private",y.walkThrough="walkThrough",y.walkThroughSnippet="walkThroughSnippet",y.http="http",y.https="https",y.file="file",y.mailto="mailto",y.untitled="untitled",y.data="data",y.command="command",y.vscodeRemote="vscode-remote",y.vscodeRemoteResource="vscode-remote-resource",y.userData="vscode-userdata",y.vscodeCustomEditor="vscode-custom-editor",y.vscodeNotebook="vscode-notebook",y.vscodeNotebookCell="vscode-notebook-cell",y.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",y.vscodeNotebookCellOutput="vscode-notebook-cell-output",y.vscodeInteractive="vscode-interactive",y.vscodeInteractiveInput="vscode-interactive-input",y.vscodeSettings="vscode-settings",y.vscodeWorkspaceTrust="vscode-workspace-trust",y.vscodeTerminal="vscode-terminal",y.webviewPanel="webview-panel",y.vscodeWebview="vscode-webview",y.extension="extension",y.vscodeFileResource="vscode-file",y.tmp="tmp"})(S=e.Schemas||(e.Schemas={}));class _{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(b){this._preferredWebSchema=b}setDelegate(b){this._delegate=b}set(b,k,n){this._hosts[b]=k,this._ports[b]=n}setConnectionToken(b,k){this._connectionTokens[b]=k}rewrite(b){if(this._delegate)return this._delegate(b);const k=b.authority;let n=this._hosts[k];n&&n.indexOf(":")!==-1&&(n=`[${n}]`);const I=this._ports[k],l=this._connectionTokens[k];let d=`path=${encodeURIComponent(b.path)}`;return typeof l=="string"&&(d+=`&tkn=${encodeURIComponent(l)}`),g.URI.from({scheme:F.isWeb?this._preferredWebSchema:S.vscodeRemoteResource,authority:`${n}:${I}`,path:"/vscode-remote-resource",query:d})}}e.RemoteAuthorities=new _;class C{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(b,k,n){const I=this.toUri(b,k);if(I.scheme===S.vscodeRemote)return e.RemoteAuthorities.rewrite(I);let l=!1;return F.isNative&&(n||F.isPreferringBrowserCodeLoad)&&I.scheme===S.file&&(l=!0),I.scheme===S.file&&typeof F.globals.importScripts=="function"&&F.globals.origin==="vscode-file://vscode-app"&&(l=!0),l?I.with({scheme:S.vscodeFileResource,authority:I.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):I}asFileUri(b,k){const n=this.toUri(b,k);return n.scheme===S.vscodeFileResource?n.with({scheme:S.file,authority:n.authority!==this.FALLBACK_AUTHORITY?n.authority:null,query:null,fragment:null}):n}toUri(b,k){return g.URI.isUri(b)?b:g.URI.parse(k.toUrl(b))}}e.FileAccess=new C}),define(be[25],Ee([0,1,44,14,2,8,11,22]),function(ee,e,g,F,S,_,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function b(d){return(0,S.uriToFsPath)(d,!0)}e.originalFSPath=b;class k{constructor(c){this._ignorePathCasing=c}compare(c,m,E=!1){return c===m?0:(0,_.compare)(this.getComparisonKey(c,E),this.getComparisonKey(m,E))}isEqual(c,m,E=!1){return c===m?!0:!c||!m?!1:this.getComparisonKey(c,E)===this.getComparisonKey(m,E)}getComparisonKey(c,m=!1){return c.with({path:this._ignorePathCasing(c)?c.path.toLowerCase():void 0,fragment:m?null:void 0}).toString()}ignorePathCasing(c){return this._ignorePathCasing(c)}isEqualOrParent(c,m,E=!1){if(c.scheme===m.scheme){if(c.scheme===C.Schemas.file)return g.isEqualOrParent(b(c),b(m),this._ignorePathCasing(c))&&c.query===m.query&&(E||c.fragment===m.fragment);if((0,e.isEqualAuthority)(c.authority,m.authority))return g.isEqualOrParent(c.path,m.path,this._ignorePathCasing(c),"/")&&c.query===m.query&&(E||c.fragment===m.fragment)}return!1}joinPath(c,...m){return S.URI.joinPath(c,...m)}basenameOrAuthority(c){return(0,e.basename)(c)||c.authority}basename(c){return F.posix.basename(c.path)}extname(c){return F.posix.extname(c.path)}dirname(c){if(c.path.length===0)return c;let m;return c.scheme===C.Schemas.file?m=S.URI.file(F.dirname(b(c))).path:(m=F.posix.dirname(c.path),c.authority&&m.length&&m.charCodeAt(0)!==47&&(console.error(`dirname("${c.toString})) resulted in a relative path`),m="/")),c.with({path:m})}normalizePath(c){if(!c.path.length)return c;let m;return c.scheme===C.Schemas.file?m=S.URI.file(F.normalize(b(c))).path:m=F.posix.normalize(c.path),c.with({path:m})}relativePath(c,m){if(c.scheme!==m.scheme||!(0,e.isEqualAuthority)(c.authority,m.authority))return;if(c.scheme===C.Schemas.file){const P=F.relative(b(c),b(m));return y.isWindows?g.toSlashes(P):P}let E=c.path||"/",w=m.path||"/";if(this._ignorePathCasing(c)){let P=0;for(const a=Math.min(E.length,w.length);P<a&&!(E.charCodeAt(P)!==w.charCodeAt(P)&&E.charAt(P).toLowerCase()!==w.charAt(P).toLowerCase());P++);E=w.substr(0,P)+E.substr(P)}return F.posix.relative(E,w)}resolvePath(c,m){if(c.scheme===C.Schemas.file){const E=S.URI.file(F.resolve(b(c),m));return c.with({authority:E.authority,path:E.path})}return m=g.toPosixPath(m),c.with({path:F.posix.resolve(c.path,m)})}isAbsolutePath(c){return!!c.path&&c.path[0]==="/"}isEqualAuthority(c,m){return c===m||(0,_.equalsIgnoreCase)(c,m)}hasTrailingPathSeparator(c,m=F.sep){if(c.scheme===C.Schemas.file){const E=b(c);return E.length>g.getRoot(E).length&&E[E.length-1]===m}else{const E=c.path;return E.length>1&&E.charCodeAt(E.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(c.fsPath)}}removeTrailingPathSeparator(c,m=F.sep){return(0,e.hasTrailingPathSeparator)(c,m)?c.with({path:c.path.substr(0,c.path.length-1)}):c}addTrailingPathSeparator(c,m=F.sep){let E=!1;if(c.scheme===C.Schemas.file){const w=b(c);E=w!==void 0&&w.length===g.getRoot(w).length&&w[w.length-1]===m}else{m="/";const w=c.path;E=w.length===1&&w.charCodeAt(w.length-1)===47}return!E&&!(0,e.hasTrailingPathSeparator)(c,m)?c.with({path:c.path+"/"}):c}}e.ExtUri=k,e.extUri=new k(()=>!1),e.extUriBiasedIgnorePathCase=new k(d=>d.scheme===C.Schemas.file?!y.isLinux:!0),e.extUriIgnorePathCase=new k(d=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function n(d,c){const m=[];for(let E=0;E<d.length;E++){const w=c(d[E]);d.some((P,a)=>a===E?!1:(0,e.isEqualOrParent)(w,c(P)))||m.push(d[E])}return m}e.distinctParents=n;var I;(function(d){d.META_DATA_LABEL="label",d.META_DATA_DESCRIPTION="description",d.META_DATA_SIZE="size",d.META_DATA_MIME="mime";function c(m){const E=new Map;m.path.substring(m.path.indexOf(";")+1,m.path.lastIndexOf(";")).split(";").forEach(a=>{const[h,p]=a.split(":");h&&p&&E.set(h,p)});const P=m.path.substring(0,m.path.indexOf(";"));return P&&E.set(d.META_DATA_MIME,P),E}d.parseMetaData=c})(I=e.DataUri||(e.DataUri={}));function l(d,c,m){if(c){let E=d.path;return E&&E[0]!==F.posix.sep&&(E=F.posix.sep+E),d.with({scheme:m,authority:c,path:E})}return d.with({scheme:m})}e.toLocalResource=l}),define(be[16],Ee([0,1,20,12,3,6,25]),function(ee,e,g,F,S,_,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function y(V){return!!V&&typeof V.then=="function"}e.isThenable=y;function b(V){const R=new g.CancellationTokenSource,K=V(R.token),x=new Promise((j,ue)=>{const $=R.token.onCancellationRequested(()=>{$.dispose(),R.dispose(),ue((0,F.canceled)())});Promise.resolve(K).then(te=>{$.dispose(),R.dispose(),j(te)},te=>{$.dispose(),R.dispose(),ue(te)})});return new class{cancel(){R.cancel()}then(j,ue){return x.then(j,ue)}catch(j){return this.then(void 0,j)}finally(j){return x.finally(j)}}}e.createCancelablePromise=b;function k(V,R,K){return Promise.race([V,new Promise(x=>R.onCancellationRequested(()=>x(K)))])}e.raceCancellation=k;async function n(V){let R=-1;const K=V.map((j,ue)=>j.then($=>(R=ue,$))),x=await Promise.race(K);return V.forEach((j,ue)=>{ue!==R&&j.cancel()}),x}e.raceCancellablePromises=n;function I(V,R,K){let x;const j=setTimeout(()=>{x?.(void 0),K?.()},R);return Promise.race([V.finally(()=>clearTimeout(j)),new Promise(ue=>x=ue)])}e.raceTimeout=I;function l(V){return new Promise((R,K)=>{const x=V();y(x)?x.then(R,K):R(x)})}e.asPromise=l;class d{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(R){if(this.activePromise){if(this.queuedPromiseFactory=R,!this.queuedPromise){const K=()=>{this.queuedPromise=null;const x=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,x};this.queuedPromise=new Promise(x=>{this.activePromise.then(K,K).then(x)})}return new Promise((K,x)=>{this.queuedPromise.then(K,x)})}return this.activePromise=R(),new Promise((K,x)=>{this.activePromise.then(j=>{this.activePromise=null,K(j)},j=>{this.activePromise=null,x(j)})})}}e.Throttler=d;class c{constructor(){this.current=Promise.resolve(null)}queue(R){return this.current=this.current.then(()=>R(),()=>R())}}e.Sequencer=c;class m{constructor(){this.promiseMap=new Map}queue(R,K){const j=(this.promiseMap.get(R)??Promise.resolve()).catch(()=>{}).then(K).finally(()=>{this.promiseMap.get(R)===j&&this.promiseMap.delete(R)});return this.promiseMap.set(R,j),j}}e.SequencerByKey=m;class E{constructor(R){this.defaultDelay=R,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(R,K=this.defaultDelay){return this.task=R,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((x,j)=>{this.doResolve=x,this.doReject=j}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const x=this.task;return this.task=null,x()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},K),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,F.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=E;class w{constructor(R){this.delayer=new E(R),this.throttler=new d}trigger(R,K){return this.delayer.trigger(()=>this.throttler.queue(R),K)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=w;class P{constructor(){this._isOpen=!1,this._promise=new Promise((R,K)=>{this._completePromise=R})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=P;class a extends P{constructor(R){super();this._timeout=setTimeout(()=>this.open(),R)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=a;function h(V,R){return R?new Promise((K,x)=>{const j=setTimeout(()=>{ue.dispose(),K()},V),ue=R.onCancellationRequested(()=>{clearTimeout(j),ue.dispose(),x((0,F.canceled)())})}):b(K=>h(V,K))}e.timeout=h;function p(V,R=0){const K=setTimeout(V,R);return(0,_.toDisposable)(()=>clearTimeout(K))}e.disposableTimeout=p;function t(V){const R=[];let K=0;const x=V.length;function j(){return K<x?V[K++]():null}function ue($){$!=null&&R.push($);const te=j();return te?te.then(ue):Promise.resolve(R)}return Promise.resolve(null).then(ue)}e.sequence=t;function r(V,R=x=>!!x,K=null){let x=0;const j=V.length,ue=()=>{if(x>=j)return Promise.resolve(K);const $=V[x++];return Promise.resolve($()).then(ce=>R(ce)?Promise.resolve(ce):ue())};return ue()}e.first=r;function s(V,R=x=>!!x,K=null){if(V.length===0)return Promise.resolve(K);let x=V.length;const j=()=>{x=-1;for(const ue of V)ue.cancel?.()};return new Promise((ue,$)=>{for(const te of V)te.then(ce=>{--x>=0&&R(ce)?(j(),ue(ce)):x===0&&ue(K)}).catch(ce=>{--x>=0&&(j(),$(ce))})})}e.firstParallel=s;class i{constructor(R){this._size=0,this.maxDegreeOfParalellism=R,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new S.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(R){return this._size++,new Promise((K,x)=>{this.outstandingPromises.push({factory:R,c:K,e:x}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const R=this.outstandingPromises.shift();this.runningPromises++;const K=R.factory();K.then(R.c,R.e),K.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=i;class u extends i{constructor(){super(1)}}e.Queue=u;class f{constructor(){this.queues=new Map}queueFor(R,K=C.extUri){const x=K.getComparisonKey(R);let j=this.queues.get(x);return j||(j=new u,S.Event.once(j.onFinished)(()=>{j?.dispose(),this.queues.delete(x)}),this.queues.set(x,j)),j}dispose(){this.queues.forEach(R=>R.dispose()),this.queues.clear()}}e.ResourceQueue=f;class v{constructor(R,K){this._token=-1,typeof R=="function"&&typeof K=="number"&&this.setIfNotSet(R,K)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(R,K){this.cancel(),this._token=setTimeout(()=>{this._token=-1,R()},K)}setIfNotSet(R,K){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,R()},K))}}e.TimeoutTimer=v;class D{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(R,K){this.cancel(),this._token=setInterval(()=>{R()},K)}}e.IntervalTimer=D;class T{constructor(R,K){this.timeoutToken=-1,this.runner=R,this.timeout=K,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(R=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,R)}get delay(){return this.timeout}set delay(R){this.timeout=R}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=T;class o extends T{constructor(R,K){super(R,K);this.units=[]}work(R){this.units.push(R),this.isScheduled()||this.schedule()}doRun(){const R=this.units;this.units=[],this.runner&&this.runner(R)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=o;class A extends _.Disposable{constructor(R,K,x,j){super();this.maxWorkChunkSize=R,this.maxPendingWork=K,this.throttleDelay=x,this.handler=j,this.pendingWork=[],this.throttler=this._register(new _.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(R){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+R.length>this.maxPendingWork)return!1}else if(this.pending+R.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...R),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new T(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=A,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const V=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=R=>{const K=setTimeout(()=>R(V));let x=!1;return{dispose(){x||(x=!0,clearTimeout(K))}}}}else e.runWhenIdle=(V,R)=>{const K=requestIdleCallback(V,typeof R=="number"?{timeout:R}:void 0);let x=!1;return{dispose(){x||(x=!0,cancelIdleCallback(K))}}}}();class L{constructor(R){this._didRun=!1,this._executor=()=>{try{this._value=R()}catch(K){this._error=K}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=L;async function B(V,R,K){let x;for(let j=0;j<K;j++)try{return await V()}catch(ue){x=ue,await h(R)}throw x}e.retry=B;class oe{hasPending(R){return this._pending?typeof R=="number"?this._pending.taskId===R:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(R,K,x){return this._pending={taskId:R,cancel:()=>x?.(),promise:K},K.then(()=>this.donePending(R),()=>this.donePending(R)),K}donePending(R){this._pending&&R===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const R=this._next;this._next=void 0,R.run().then(R.promiseResolve,R.promiseReject)}}setNext(R){if(this._next)this._next.run=R;else{let K,x;const j=new Promise((ue,$)=>{K=ue,x=$});this._next={run:R,promise:j,promiseResolve:K,promiseReject:x}}return this._next.promise}}e.TaskSequentializer=oe;class he{constructor(R){this.interval=R,this.lastIncrementTime=0,this.value=0}increment(){const R=Date.now();return R-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=R,this.value=0),this.value++,this.value}}e.IntervalCounter=he;class Q{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((R,K)=>{this.completeCallback=R,this.errorCallback=K})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(R){return new Promise(K=>{this.completeCallback(R),this.resolved=!0,K()})}error(R){return new Promise(K=>{this.errorCallback(R),this.rejected=!0,K()})}cancel(){new Promise(R=>{this.errorCallback((0,F.canceled)()),this.rejected=!0,R()})}}e.DeferredPromise=Q;var z;(function(V){async function R(K){let x;const j=await Promise.all(K.map(ue=>ue.then($=>$,$=>{x||(x=$)})));if(typeof x!="undefined")throw x;return j}V.settled=R})(z=e.Promises||(e.Promises={}))}),define(be[116],Ee([0,1,14,16]),function(ee,e,g,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const S=new F.IdleValue(()=>{const T=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:T,collatorIsNumeric:T.resolvedOptions().numeric}}),_=new F.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),C=new F.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function y(T,o,A=!1){const L=T||"",B=o||"",oe=S.value.collator.compare(L,B);return S.value.collatorIsNumeric&&oe===0&&L!==B?L<B?-1:1:oe}e.compareFileNames=y;function b(T,o){const A=_.value.collator;return T=T||"",o=o||"",p(A,T,o)}e.compareFileNamesDefault=b;function k(T,o){const A=_.value.collator;return T=T||"",o=o||"",i(T,o)||p(A,T,o)}e.compareFileNamesUpper=k;function n(T,o){const A=_.value.collator;return T=T||"",o=o||"",s(T,o)||p(A,T,o)}e.compareFileNamesLower=n;function I(T,o){return T=T||"",o=o||"",T===o?0:T<o?-1:1}e.compareFileNamesUnicode=I;function l(T,o,A=!1){A||(T=T&&T.toLowerCase(),o=o&&o.toLowerCase());const[L,B]=a(T),[oe,he]=a(o);return L!==oe?L<oe?-1:1:B===he?0:B<he?-1:1}e.noIntlCompareFileNames=l;function d(T,o){const[A,L]=a(T),[B,oe]=a(o);let he=S.value.collator.compare(L,oe);if(he===0){if(S.value.collatorIsNumeric&&L!==oe)return L<oe?-1:1;if(he=S.value.collator.compare(A,B),S.value.collatorIsNumeric&&he===0&&A!==B)return A<B?-1:1}return he}e.compareFileExtensions=d;function c(T,o){T=T||"",o=o||"";const A=h(T),L=h(o),B=_.value.collator,oe=C.value.collator;return p(oe,A,L)||p(B,T,o)}e.compareFileExtensionsDefault=c;function m(T,o){T=T||"",o=o||"";const A=h(T),L=h(o),B=_.value.collator,oe=C.value.collator;return p(oe,A,L)||i(T,o)||p(B,T,o)}e.compareFileExtensionsUpper=m;function E(T,o){T=T||"",o=o||"";const A=h(T),L=h(o),B=_.value.collator,oe=C.value.collator;return p(oe,A,L)||s(T,o)||p(B,T,o)}e.compareFileExtensionsLower=E;function w(T,o){T=T||"",o=o||"";const A=h(T).toLowerCase(),L=h(o).toLowerCase();return A!==L?A<L?-1:1:T!==o?T<o?-1:1:0}e.compareFileExtensionsUnicode=w;const P=/^(.*?)(\.([^.]*))?$/;function a(T,o=!1){const A=T?P.exec(T):[];let L=[A&&A[1]||"",A&&A[3]||""];return o&&(!L[0]&&L[1]||L[0]&&L[0].charAt(0)===".")&&(L=[L[0]+"."+L[1],""]),L}function h(T){const o=T?P.exec(T):[];return o&&o[1]&&o[1].charAt(0)!=="."&&o[3]||""}function p(T,o,A){let L=T.compare(o,A);return L!==0?L:o.length!==A.length?o.length<A.length?-1:1:0}function t(T){const o=T.charAt(0);return o.toLocaleUpperCase()!==o}function r(T){const o=T.charAt(0);return o.toLocaleLowerCase()!==o}function s(T,o){return t(T)&&r(o)?-1:r(T)&&t(o)?1:0}function i(T,o){return r(T)&&t(o)?-1:t(T)&&r(o)?1:0}function u(T,o,A=!1){return A||(T=T&&T.toLowerCase(),o=o&&o.toLowerCase()),T===o?0:T<o?-1:1}function f(T,o,A=!1){const L=T.split(g.sep),B=o.split(g.sep),oe=L.length-1,he=B.length-1;let Q,z;for(let V=0;;V++){if(Q=oe===V,z=he===V,Q&&z)return y(L[V],B[V],A);if(Q)return-1;if(z)return 1;const R=u(L[V],B[V],A);if(R!==0)return R}}e.comparePaths=f;function v(T,o,A){const L=T.toLowerCase(),B=o.toLowerCase(),oe=D(T,o,A);if(oe)return oe;const he=L.endsWith(A),Q=B.endsWith(A);if(he!==Q)return he?-1:1;const z=y(L,B);return z!==0?z:L.localeCompare(B)}e.compareAnything=v;function D(T,o,A){const L=T.toLowerCase(),B=o.toLowerCase(),oe=L.startsWith(A),he=B.startsWith(A);if(oe!==he)return oe?-1:1;if(oe&&he){if(L.length<B.length)return-1;if(L.length>B.length)return 1}return 0}e.compareByPrefix=D}),define(be[27],Ee([0,1,8,44,14,21,16]),function(ee,e,g,F,S,_,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function y(){return Object.create(null)}e.getEmptyExpression=y;const b="**",k="/",n="[/\\\\]",I="[^/\\\\]",l=/\//g;function d(j){switch(j){case 0:return"";case 1:return`${I}*?`;default:return`(?:${n}|${I}+${n}|${n}${I}+)*?`}}function c(j,ue){if(!j)return[];const $=[];let te=!1,ce=!1,ye="";for(const Re of j){switch(Re){case ue:if(!te&&!ce){$.push(ye),ye="";continue}break;case"{":te=!0;break;case"}":te=!1;break;case"[":ce=!0;break;case"]":ce=!1;break}ye+=Re}return ye&&$.push(ye),$}e.splitGlobAware=c;function m(j){if(!j)return"";let ue="";const $=c(j,k);if($.every(te=>te===b))ue=".*";else{let te=!1;$.forEach((ce,ye)=>{if(ce===b){te||(ue+=d(2),te=!0);return}let Re=!1,Te="",$e=!1,Je="";for(const Ve of ce){if(Ve!=="}"&&Re){Te+=Ve;continue}if($e&&(Ve!=="]"||!Je)){let je;Ve==="-"?je=Ve:(Ve==="^"||Ve==="!")&&!Je?je="^":Ve===k?je="":je=g.escapeRegExpCharacters(Ve),Je+=je;continue}switch(Ve){case"{":Re=!0;continue;case"[":$e=!0;continue;case"}":ue+=`(?:${c(Te,",").map(G=>m(G)).join("|")})`,Re=!1,Te="";break;case"]":ue+="["+Je+"]",$e=!1,Je="";break;case"?":ue+=I;continue;case"*":ue+=d(1);continue;default:ue+=g.escapeRegExpCharacters(Ve)}}ye<$.length-1&&($[ye+1]!==b||ye+2<$.length)&&(ue+=n),te=!1})}return ue}const E=/^\*\*\/\*\.[\w\.-]+$/,w=/^\*\*\/([\w\.-]+)\/?$/,P=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,a=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,h=/^\*\*((\/[\w\.-]+)+)\/?$/,p=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new _.LRUCache(1e4),r=function(){return!1},s=function(){return null};function i(j,ue){if(!j)return s;let $;typeof j!="string"?$=j.pattern:$=j,$=$.trim();const te=`${$}_${!!ue.trimForExclusions}`;let ce=t.get(te);if(ce)return u(ce,j);let ye;if(E.test($)){const Re=$.substr(4);ce=function(Te,$e){return typeof Te=="string"&&Te.endsWith(Re)?$:null}}else(ye=w.exec(f($,ue)))?ce=v(ye[1],$):(ue.trimForExclusions?a:P).test($)?ce=D($,ue):(ye=h.exec(f($,ue)))?ce=T(ye[1].substr(1),$,!0):(ye=p.exec(f($,ue)))?ce=T(ye[1],$,!1):ce=o($);return t.set(te,ce),u(ce,j)}function u(j,ue){return typeof ue=="string"?j:function($,te){return F.isEqualOrParent($,ue.base)?j(S.relative(ue.base,$),te):null}}function f(j,ue){return ue.trimForExclusions&&j.endsWith("/**")?j.substr(0,j.length-2):j}function v(j,ue){const $=`/${j}`,te=`\\${j}`,ce=function(Re,Te){return typeof Re!="string"?null:Te?Te===j?ue:null:Re===j||Re.endsWith($)||Re.endsWith(te)?ue:null},ye=[j];return ce.basenames=ye,ce.patterns=[ue],ce.allBasenames=ye,ce}function D(j,ue){const $=x(j.slice(1,-1).split(",").map(Te=>i(Te,ue)).filter(Te=>Te!==s),j),te=$.length;if(!te)return s;if(te===1)return $[0];const ce=function(Te,$e){for(let Je=0,Ve=$.length;Je<Ve;Je++)if($[Je](Te,$e))return j;return null},ye=$.find(Te=>!!Te.allBasenames);ye&&(ce.allBasenames=ye.allBasenames);const Re=$.reduce((Te,$e)=>$e.allPaths?Te.concat($e.allPaths):Te,[]);return Re.length&&(ce.allPaths=Re),ce}function T(j,ue,$){const te=S.sep===S.posix.sep,ce=te?j:j.replace(l,S.sep),ye=S.sep+ce,Re=S.posix.sep+j,Te=$?function($e,Je){return typeof $e=="string"&&($e===ce||$e.endsWith(ye)||!te&&($e===j||$e.endsWith(Re)))?ue:null}:function($e,Je){return typeof $e=="string"&&($e===ce||!te&&$e===j)?ue:null};return Te.allPaths=[($?"*/":"./")+j],Te}function o(j){try{const ue=new RegExp(`^${m(j)}$`);return function($){return ue.lastIndex=0,typeof $=="string"&&ue.test($)?j:null}}catch(ue){return s}}function A(j,ue,$){return!j||typeof ue!="string"?!1:L(j)(ue,void 0,$)}e.match=A;function L(j,ue={}){if(!j)return r;if(typeof j=="string"||Q(j)){const $=i(j,ue);if($===s)return r;const te=function(ce,ye){return!!$(ce,ye)};return $.allBasenames&&(te.allBasenames=$.allBasenames),$.allPaths&&(te.allPaths=$.allPaths),te}return R(j,ue)}e.parse=L;function B(j){if(!j)return;let ue;return $=>(ue||(ue=(j()||Promise.resolve([])).then(te=>te?he(te):{})),ue.then(te=>!!te[$]))}e.hasSiblingPromiseFn=B;function oe(j){if(!j)return;let ue;return $=>{if(!ue){const te=j();ue=te?he(te):{}}return!!ue[$]}}e.hasSiblingFn=oe;function he(j){const ue={};for(const $ of j)ue[$]=!0;return ue}function Q(j){const ue=j;return ue&&typeof ue.base=="string"&&typeof ue.pattern=="string"}e.isRelativePattern=Q;function z(j){return j.allBasenames||[]}e.getBasenameTerms=z;function V(j){return j.allPaths||[]}e.getPathTerms=V;function R(j,ue){const $=x(Object.getOwnPropertyNames(j).map(Te=>K(Te,j[Te],ue)).filter(Te=>Te!==s)),te=$.length;if(!te)return s;if(!$.some(Te=>!!Te.requiresSiblings)){if(te===1)return $[0];const Te=function(Ve,je){for(let O=0,G=$.length;O<G;O++){const X=$[O](Ve,je);if(X)return X}return null},$e=$.find(Ve=>!!Ve.allBasenames);$e&&(Te.allBasenames=$e.allBasenames);const Je=$.reduce((Ve,je)=>je.allPaths?Ve.concat(je.allPaths):Ve,[]);return Je.length&&(Te.allPaths=Je),Te}const ce=function(Te,$e,Je){let Ve;for(let je=0,O=$.length;je<O;je++){const G=$[je];G.requiresSiblings&&Je&&($e||($e=S.basename(Te)),Ve||(Ve=$e.substr(0,$e.length-S.extname(Te).length)));const X=G(Te,$e,Ve,Je);if(X)return X}return null},ye=$.find(Te=>!!Te.allBasenames);ye&&(ce.allBasenames=ye.allBasenames);const Re=$.reduce((Te,$e)=>$e.allPaths?Te.concat($e.allPaths):Te,[]);return Re.length&&(ce.allPaths=Re),ce}function K(j,ue,$){if(ue===!1)return s;const te=i(j,$);if(te===s)return s;if(typeof ue=="boolean")return te;if(ue){const ce=ue.when;if(typeof ce=="string"){const ye=(Re,Te,$e,Je)=>{if(!Je||!te(Re,Te))return null;const Ve=ce.replace("$(basename)",$e),je=Je(Ve);return(0,C.isThenable)(je)?je.then(O=>O?j:null):je?j:null};return ye.requiresSiblings=!0,ye}}return te}function x(j,ue){const $=j.filter(Te=>!!Te.basenames);if($.length<2)return j;const te=$.reduce((Te,$e)=>{const Je=$e.basenames;return Je?Te.concat(Je):Te},[]);let ce;if(ue){ce=[];for(let Te=0,$e=te.length;Te<$e;Te++)ce.push(ue)}else ce=$.reduce((Te,$e)=>{const Je=$e.patterns;return Je?Te.concat(Je):Te},[]);const ye=function(Te,$e){if(typeof Te!="string")return null;if(!$e){let Ve;for(Ve=Te.length;Ve>0;Ve--){const je=Te.charCodeAt(Ve-1);if(je===47||je===92)break}$e=Te.substr(Ve)}const Je=te.indexOf($e);return Je!==-1?ce[Je]:null};ye.basenames=te,ye.patterns=ce,ye.allBasenames=te;const Re=j.filter(Te=>!Te.basenames);return Re.push(ye),Re}}),define(be[84],Ee([0,1,2,14,8,11,22,25,44]),function(ee,e,g,F,S,_,C,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function k(i,u,f){if(typeof i=="string"&&(i=g.URI.file(i)),f){const D=f.getWorkspaceFolder(i);if(D){const T=f.getWorkspace().folders.length>1;let o;if((0,y.isEqual)(D.uri,i)?o="":o=(0,y.relativePath)(D.uri,i),T){const A=D.name?D.name:(0,y.basename)(D.uri);o=o?A+" \u2022 "+o:A}return o}}if(i.scheme!==_.Schemas.file&&i.scheme!==_.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,b.hasDriveLetter)(i.fsPath))return(0,F.normalize)(I(i.fsPath));let v=(0,F.normalize)(i.fsPath);return!C.isWindows&&u?.userHome&&(v=d(v,u.userHome.fsPath)),v}e.getPathLabel=k;function n(i){if(!i)return;typeof i=="string"&&(i=g.URI.file(i));const u=(0,y.basename)(i)||(i.scheme===_.Schemas.file?i.fsPath:i.path);return C.isWindows&&(0,b.isRootOrDriveLetter)(u)?I(u):u}e.getBaseLabel=n;function I(i){return(0,b.hasDriveLetter)(i)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=I;let l=Object.create(null);function d(i,u){if(C.isWindows||!i||!u)return i;let f=l.original===u?l.normalized:void 0;return f||(f=`${(0,S.rtrim)(u,F.posix.sep)}${F.posix.sep}`,l={original:u,normalized:f}),(C.isLinux?i.startsWith(f):(0,S.startsWithIgnoreCase)(i,f))&&(i=`~/${i.substr(f.length)}`),i}e.tildify=d;function c(i,u){return i.replace(/^~($|\/|\\)/,`${u}$1`)}e.untildify=c;const m="\u2026",E="\\\\",w="~";function P(i,u=F.sep){const f=new Array(i.length);let v=!1;for(let D=0;D<i.length;D++){let T=i[D];if(T===""){f[D]=`.${u}`;continue}if(!T){f[D]=T;continue}v=!0;let o="";T.indexOf(E)===0?(o=T.substr(0,T.indexOf(E)+E.length),T=T.substr(T.indexOf(E)+E.length)):T.indexOf(u)===0?(o=T.substr(0,T.indexOf(u)+u.length),T=T.substr(T.indexOf(u)+u.length)):T.indexOf(w)===0&&(o=T.substr(0,T.indexOf(w)+w.length),T=T.substr(T.indexOf(w)+w.length));const A=T.split(u);for(let L=1;v&&L<=A.length;L++)for(let B=A.length-L;v&&B>=0;B--){v=!1;let oe=A.slice(B,B+L).join(u);for(let he=0;!v&&he<i.length;he++)if(he!==D&&i[he]&&i[he].indexOf(oe)>-1){const Q=B+L===A.length,z=B>0&&i[he].indexOf(u)>-1?u+oe:oe,V=i[he].endsWith(z);v=!Q||V}if(!v){let he="";(A[0].endsWith(":")||o!=="")&&(B===1&&(B=0,L++,oe=A[0]+u+oe),B>0&&(he=A[0]+u),he=o+he),B>0&&(he=he+m+u),he=he+oe,B+L<A.length&&(he=he+u+m),f[D]=he}}v&&(f[D]=T)}return f}e.shorten=P;var a;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(a||(a={}));function h(i,u=Object.create(null)){const f=[];let v=!1,D="";for(const T of i)if(T==="$"||v&&T==="{")D&&f.push({value:D,type:a.TEXT}),D="",v=!0;else if(T==="}"&&v){const o=u[D];if(typeof o=="string")o.length&&f.push({value:o,type:a.VARIABLE});else if(o){const A=f[f.length-1];(!A||A.type!==a.SEPARATOR)&&f.push({value:o.label,type:a.SEPARATOR})}D="",v=!1}else D+=T;return D&&!v&&f.push({value:D,type:a.TEXT}),f.filter((T,o)=>{if(T.type===a.SEPARATOR){const A=f[o-1],L=f[o+1];return[A,L].every(B=>B&&(B.type===a.VARIABLE||B.type===a.TEXT)&&B.value.length>0)}return!0}).map(T=>T.value).join("")}e.template=h;function p(i,u){return C.isMacintosh||u?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,C.isMacintosh?"&":"&&"):i.replace(/&&|&/g,f=>f==="&"?"&&":"&")}e.mnemonicMenuLabel=p;function t(i,u){return C.isMacintosh||u?i.replace(/\(&&\w\)|&&/g,""):C.isWindows?i.replace(/&&|&/g,f=>f==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function r(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=r;function s(i){const u=i.indexOf("/")!==-1?F.posix:F.win32,f=u.basename(i),v=u.dirname(i);return f.length?{name:f,parentPath:v}:{name:v,parentPath:""}}e.splitName=s}),define(be[85],Ee([0,1,14,8,27,11,25]),function(ee,e,g,F,S,_,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var y;(function(r){r.text="text/plain",r.binary="application/octet-stream",r.unknown="application/unknown",r.markdown="text/markdown"})(y=e.Mimes||(e.Mimes={}));let b=[],k=[],n=[];function I(r,s=!1){const i=l(r);b.push(i),i.userConfigured?n.push(i):k.push(i),s&&!i.userConfigured&&b.forEach(u=>{u.mime===i.mime||u.userConfigured||(i.extension&&u.extension===i.extension&&console.warn(`Overwriting extension <<${i.extension}>> to now point to mime <<${i.mime}>>`),i.filename&&u.filename===i.filename&&console.warn(`Overwriting filename <<${i.filename}>> to now point to mime <<${i.mime}>>`),i.filepattern&&u.filepattern===i.filepattern&&console.warn(`Overwriting filepattern <<${i.filepattern}>> to now point to mime <<${i.mime}>>`),i.firstline&&u.firstline===i.firstline&&console.warn(`Overwriting firstline <<${i.firstline}>> to now point to mime <<${i.mime}>>`))})}e.registerTextMime=I;function l(r){return{id:r.id,mime:r.mime,filename:r.filename,extension:r.extension,filepattern:r.filepattern,firstline:r.firstline,userConfigured:r.userConfigured,filenameLowercase:r.filename?r.filename.toLowerCase():void 0,extensionLowercase:r.extension?r.extension.toLowerCase():void 0,filepatternLowercase:r.filepattern?r.filepattern.toLowerCase():void 0,filepatternOnPath:r.filepattern?r.filepattern.indexOf(g.posix.sep)>=0:!1}}function d(r){r?(b=b.filter(s=>!s.userConfigured),n=[]):(b=[],k=[],n=[])}e.clearTextMimes=d;function c(r,s){let i;if(r)switch(r.scheme){case _.Schemas.file:i=r.fsPath;break;case _.Schemas.data:i=C.DataUri.parseMetaData(r).get(C.DataUri.META_DATA_LABEL);break;default:i=r.path}if(!i)return[y.unknown];i=i.toLowerCase();const u=(0,g.basename)(i),f=m(i,u,n);if(f)return[f,y.text];const v=m(i,u,k);if(v)return[v,y.text];if(s){const D=E(s);if(D)return[D,y.text]}return[y.unknown]}e.guessMimeTypes=c;function m(r,s,i){let u=null,f=null,v=null;for(let D=i.length-1;D>=0;D--){const T=i[D];if(s===T.filenameLowercase){u=T;break}if(T.filepattern&&(!f||T.filepattern.length>f.filepattern.length)){const o=T.filepatternOnPath?r:s;(0,S.match)(T.filepatternLowercase,o)&&(f=T)}T.extension&&(!v||T.extension.length>v.extension.length)&&s.endsWith(T.extensionLowercase)&&(v=T)}return u?u.mime:f?f.mime:v?v.mime:null}function E(r){if((0,F.startsWithUTF8BOM)(r)&&(r=r.substr(1)),r.length>0)for(let s=b.length-1;s>=0;s--){const i=b[s];if(!i.firstline)continue;const u=r.match(i.firstline);if(u&&u.length>0)return i.mime}return null}function w(r){return r?typeof r=="string"?r===y.binary||r===y.text||r===y.unknown:r.length===1&&w(r[0]):!0}e.isUnspecific=w;const P={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function a(r){const s=(0,g.extname)(r);return P[s.toLowerCase()]}e.getMediaMime=a;function h(r){for(const s in P)if(P[s]===r)return s}e.getExtensionForMimeType=h;const p=/^(.+)\/(.+?)(;.+)?$/;function t(r,s){const i=p.exec(r);return i?`${i[1].toLowerCase()}/${i[2].toLowerCase()}${i[3]??""}`:s?void 0:r}e.normalizeMimeType=t}),define(be[117],Ee([0,1,2]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function F(n){return n.toJSON()}class S{constructor(I){this._uriTransformer=I}transformIncoming(I){const l=this._uriTransformer.transformIncoming(I);return l===I?I:F(g.URI.from(l))}transformOutgoing(I){const l=this._uriTransformer.transformOutgoing(I);return l===I?I:F(g.URI.from(l))}transformOutgoingURI(I){const l=this._uriTransformer.transformOutgoing(I);return l===I?I:g.URI.from(l)}transformOutgoingScheme(I){return this._uriTransformer.transformOutgoingScheme(I)}}e.URITransformer=S,e.DefaultURITransformer=new class{transformIncoming(n){return n}transformOutgoing(n){return n}transformOutgoingURI(n){return n}transformOutgoingScheme(n){return n}};function _(n,I,l){if(!n||l>200)return null;if(typeof n=="object"){if(n instanceof g.URI)return I.transformOutgoing(n);for(let d in n)if(Object.hasOwnProperty.call(n,d)){const c=_(n[d],I,l+1);c!==null&&(n[d]=c)}}return null}function C(n,I){const l=_(n,I,0);return l===null?n:l}e.transformOutgoingURIs=C;function y(n,I,l,d){if(!n||d>200)return null;if(typeof n=="object"){if(n.$mid===1)return l?g.URI.revive(I.transformIncoming(n)):I.transformIncoming(n);for(let c in n)if(Object.hasOwnProperty.call(n,c)){const m=y(n[c],I,l,d+1);m!==null&&(n[c]=m)}}return null}function b(n,I){const l=y(n,I,!1,0);return l===null?n:l}e.transformIncomingURIs=b;function k(n,I){const l=y(n,I,!0,0);return l===null?n:l}e.transformAndReviveIncomingURIs=k}),define(be[36],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const g=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function F(b){return g.test(b)}e.isUUID=F;const S=new Uint8Array(16),_=[];for(let b=0;b<256;b++)_.push(b.toString(16).padStart(2,"0"));let C;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?C=crypto.getRandomValues.bind(crypto):C=function(b){for(let k=0;k<b.length;k++)b[k]=Math.floor(Math.random()*256);return b};function y(){C(S),S[6]=S[6]&15|64,S[8]=S[8]&63|128;let b=0,k="";return k+=_[S[b++]],k+=_[S[b++]],k+=_[S[b++]],k+=_[S[b++]],k+="-",k+=_[S[b++]],k+=_[S[b++]],k+="-",k+=_[S[b++]],k+=_[S[b++]],k+="-",k+=_[S[b++]],k+=_[S[b++]],k+="-",k+=_[S[b++]],k+=_[S[b++]],k+=_[S[b++]],k+=_[S[b++]],k+=_[S[b++]],k+=_[S[b++]],k}e.generateUuid=y}),define(be[86],Ee([0,1,82]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class F{constructor(y){let b=(0,g.toUint8)(y);this._defaultValue=b,this._asciiMap=F._createAsciiMap(b),this._map=new Map}static _createAsciiMap(y){let b=new Uint8Array(256);for(let k=0;k<256;k++)b[k]=y;return b}set(y,b){let k=(0,g.toUint8)(b);y>=0&&y<256?this._asciiMap[y]=k:this._map.set(y,k)}get(y){return y>=0&&y<256?this._asciiMap[y]:this._map.get(y)||this._defaultValue}}e.CharacterClassifier=F;var S;(function(C){C[C.False=0]="False",C[C.True=1]="True"})(S||(S={}));class _{constructor(){this._actual=new F(0)}add(y){this._actual.set(y,1)}has(y){return this._actual.get(y)===1}}e.CharacterSet=_}),define(be[118],Ee([0,1,86]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var F;(function(C){C[C.Regular=0]="Regular",C[C.Whitespace=1]="Whitespace",C[C.WordSeparator=2]="WordSeparator"})(F=e.WordCharacterClass||(e.WordCharacterClass={}));class S extends g.CharacterClassifier{constructor(y){super(0);for(let b=0,k=y.length;b<k;b++)this.set(y.charCodeAt(b),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=S;function _(C){let y={};return b=>(y.hasOwnProperty(b)||(y[b]=C(b)),y[b])}e.getMapForWordSeparators=_(C=>new S(C))}),define(be[37],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class g{constructor(S,_){this.lineNumber=S,this.column=_}with(S=this.lineNumber,_=this.column){return S===this.lineNumber&&_===this.column?this:new g(S,_)}delta(S=0,_=0){return this.with(this.lineNumber+S,this.column+_)}equals(S){return g.equals(this,S)}static equals(S,_){return!S&&!_?!0:!!S&&!!_&&S.lineNumber===_.lineNumber&&S.column===_.column}isBefore(S){return g.isBefore(this,S)}static isBefore(S,_){return S.lineNumber<_.lineNumber?!0:_.lineNumber<S.lineNumber?!1:S.column<_.column}isBeforeOrEqual(S){return g.isBeforeOrEqual(this,S)}static isBeforeOrEqual(S,_){return S.lineNumber<_.lineNumber?!0:_.lineNumber<S.lineNumber?!1:S.column<=_.column}static compare(S,_){let C=S.lineNumber|0,y=_.lineNumber|0;if(C===y){let b=S.column|0,k=_.column|0;return b-k}return C-y}clone(){return new g(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(S){return new g(S.lineNumber,S.column)}static isIPosition(S){return S&&typeof S.lineNumber=="number"&&typeof S.column=="number"}}e.Position=g}),define(be[31],Ee([0,1,37]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class F{constructor(_,C,y,b){_>y||_===y&&C>b?(this.startLineNumber=y,this.startColumn=b,this.endLineNumber=_,this.endColumn=C):(this.startLineNumber=_,this.startColumn=C,this.endLineNumber=y,this.endColumn=b)}isEmpty(){return F.isEmpty(this)}static isEmpty(_){return _.startLineNumber===_.endLineNumber&&_.startColumn===_.endColumn}containsPosition(_){return F.containsPosition(this,_)}static containsPosition(_,C){return!(C.lineNumber<_.startLineNumber||C.lineNumber>_.endLineNumber||C.lineNumber===_.startLineNumber&&C.column<_.startColumn||C.lineNumber===_.endLineNumber&&C.column>_.endColumn)}containsRange(_){return F.containsRange(this,_)}static containsRange(_,C){return!(C.startLineNumber<_.startLineNumber||C.endLineNumber<_.startLineNumber||C.startLineNumber>_.endLineNumber||C.endLineNumber>_.endLineNumber||C.startLineNumber===_.startLineNumber&&C.startColumn<_.startColumn||C.endLineNumber===_.endLineNumber&&C.endColumn>_.endColumn)}strictContainsRange(_){return F.strictContainsRange(this,_)}static strictContainsRange(_,C){return!(C.startLineNumber<_.startLineNumber||C.endLineNumber<_.startLineNumber||C.startLineNumber>_.endLineNumber||C.endLineNumber>_.endLineNumber||C.startLineNumber===_.startLineNumber&&C.startColumn<=_.startColumn||C.endLineNumber===_.endLineNumber&&C.endColumn>=_.endColumn)}plusRange(_){return F.plusRange(this,_)}static plusRange(_,C){let y,b,k,n;return C.startLineNumber<_.startLineNumber?(y=C.startLineNumber,b=C.startColumn):C.startLineNumber===_.startLineNumber?(y=C.startLineNumber,b=Math.min(C.startColumn,_.startColumn)):(y=_.startLineNumber,b=_.startColumn),C.endLineNumber>_.endLineNumber?(k=C.endLineNumber,n=C.endColumn):C.endLineNumber===_.endLineNumber?(k=C.endLineNumber,n=Math.max(C.endColumn,_.endColumn)):(k=_.endLineNumber,n=_.endColumn),new F(y,b,k,n)}intersectRanges(_){return F.intersectRanges(this,_)}static intersectRanges(_,C){let y=_.startLineNumber,b=_.startColumn,k=_.endLineNumber,n=_.endColumn,I=C.startLineNumber,l=C.startColumn,d=C.endLineNumber,c=C.endColumn;return y<I?(y=I,b=l):y===I&&(b=Math.max(b,l)),k>d?(k=d,n=c):k===d&&(n=Math.min(n,c)),y>k||y===k&&b>n?null:new F(y,b,k,n)}equalsRange(_){return F.equalsRange(this,_)}static equalsRange(_,C){return!!_&&!!C&&_.startLineNumber===C.startLineNumber&&_.startColumn===C.startColumn&&_.endLineNumber===C.endLineNumber&&_.endColumn===C.endColumn}getEndPosition(){return F.getEndPosition(this)}static getEndPosition(_){return new g.Position(_.endLineNumber,_.endColumn)}getStartPosition(){return F.getStartPosition(this)}static getStartPosition(_){return new g.Position(_.startLineNumber,_.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(_,C){return new F(this.startLineNumber,this.startColumn,_,C)}setStartPosition(_,C){return new F(_,C,this.endLineNumber,this.endColumn)}collapseToStart(){return F.collapseToStart(this)}static collapseToStart(_){return new F(_.startLineNumber,_.startColumn,_.startLineNumber,_.startColumn)}static fromPositions(_,C=_){return new F(_.lineNumber,_.column,C.lineNumber,C.column)}static lift(_){return _?new F(_.startLineNumber,_.startColumn,_.endLineNumber,_.endColumn):null}static isIRange(_){return _&&typeof _.startLineNumber=="number"&&typeof _.startColumn=="number"&&typeof _.endLineNumber=="number"&&typeof _.endColumn=="number"}static areIntersectingOrTouching(_,C){return!(_.endLineNumber<C.startLineNumber||_.endLineNumber===C.startLineNumber&&_.endColumn<C.startColumn||C.endLineNumber<_.startLineNumber||C.endLineNumber===_.startLineNumber&&C.endColumn<_.startColumn)}static areIntersecting(_,C){return!(_.endLineNumber<C.startLineNumber||_.endLineNumber===C.startLineNumber&&_.endColumn<=C.startColumn||C.endLineNumber<_.startLineNumber||C.endLineNumber===_.startLineNumber&&C.endColumn<=_.startColumn)}static compareRangesUsingStarts(_,C){if(_&&C){const k=_.startLineNumber|0,n=C.startLineNumber|0;if(k===n){const I=_.startColumn|0,l=C.startColumn|0;if(I===l){const d=_.endLineNumber|0,c=C.endLineNumber|0;if(d===c){const m=_.endColumn|0,E=C.endColumn|0;return m-E}return d-c}return I-l}return k-n}return(_?1:0)-(C?1:0)}static compareRangesUsingEnds(_,C){return _.endLineNumber===C.endLineNumber?_.endColumn===C.endColumn?_.startLineNumber===C.startLineNumber?_.startColumn-C.startColumn:_.startLineNumber-C.startLineNumber:_.endColumn-C.endColumn:_.endLineNumber-C.endLineNumber}static spansMultipleLines(_){return _.endLineNumber>_.startLineNumber}}e.Range=F}),define(be[119],Ee([0,1,37,31]),function(ee,e,g,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var S;(function(C){C[C.LTR=0]="LTR",C[C.RTL=1]="RTL"})(S=e.SelectionDirection||(e.SelectionDirection={}));class _ extends F.Range{constructor(y,b,k,n){super(y,b,k,n);this.selectionStartLineNumber=y,this.selectionStartColumn=b,this.positionLineNumber=k,this.positionColumn=n}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(y){return _.selectionsEqual(this,y)}static selectionsEqual(y,b){return y.selectionStartLineNumber===b.selectionStartLineNumber&&y.selectionStartColumn===b.selectionStartColumn&&y.positionLineNumber===b.positionLineNumber&&y.positionColumn===b.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(y,b){return this.getDirection()===0?new _(this.startLineNumber,this.startColumn,y,b):new _(y,b,this.startLineNumber,this.startColumn)}getPosition(){return new g.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(y,b){return this.getDirection()===0?new _(y,b,this.endLineNumber,this.endColumn):new _(this.endLineNumber,this.endColumn,y,b)}static fromPositions(y,b=y){return new _(y.lineNumber,y.column,b.lineNumber,b.column)}static liftSelection(y){return new _(y.selectionStartLineNumber,y.selectionStartColumn,y.positionLineNumber,y.positionColumn)}static selectionsArrEqual(y,b){if(y&&!b||!y&&b)return!1;if(!y&&!b)return!0;if(y.length!==b.length)return!1;for(let k=0,n=y.length;k<n;k++)if(!this.selectionsEqual(y[k],b[k]))return!1;return!0}static isISelection(y){return y&&typeof y.selectionStartLineNumber=="number"&&typeof y.selectionStartColumn=="number"&&typeof y.positionLineNumber=="number"&&typeof y.positionColumn=="number"}static createWithDirection(y,b,k,n,I){return I===0?new _(y,b,k,n):new _(k,n,y,b)}}e.Selection=_}),define(be[87],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var g;(function(c){c[c.Left=1]="Left",c[c.Center=2]="Center",c[c.Right=4]="Right",c[c.Full=7]="Full"})(g=e.OverviewRulerLane||(e.OverviewRulerLane={}));var F;(function(c){c[c.Inline=1]="Inline",c[c.Gutter=2]="Gutter"})(F=e.MinimapPosition||(e.MinimapPosition={}));var S;(function(c){c[c.TextDefined=0]="TextDefined",c[c.LF=1]="LF",c[c.CRLF=2]="CRLF"})(S=e.EndOfLinePreference||(e.EndOfLinePreference={}));var _;(function(c){c[c.LF=1]="LF",c[c.CRLF=2]="CRLF"})(_=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var C;(function(c){c[c.LF=0]="LF",c[c.CRLF=1]="CRLF"})(C=e.EndOfLineSequence||(e.EndOfLineSequence={}));class y{constructor(m){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,m.tabSize|0),this.indentSize=m.tabSize|0,this.insertSpaces=Boolean(m.insertSpaces),this.defaultEOL=m.defaultEOL|0,this.trimAutoWhitespace=Boolean(m.trimAutoWhitespace)}equals(m){return this.tabSize===m.tabSize&&this.indentSize===m.indentSize&&this.insertSpaces===m.insertSpaces&&this.defaultEOL===m.defaultEOL&&this.trimAutoWhitespace===m.trimAutoWhitespace}createChangeEvent(m){return{tabSize:this.tabSize!==m.tabSize,indentSize:this.indentSize!==m.indentSize,insertSpaces:this.insertSpaces!==m.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==m.trimAutoWhitespace}}}e.TextModelResolvedOptions=y;class b{constructor(m,E){this._findMatchBrand=void 0,this.range=m,this.matches=E}}e.FindMatch=b;var k;(function(c){c[c.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",c[c.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",c[c.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",c[c.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(k=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var n;(function(c){c[c.Left=0]="Left",c[c.Right=1]="Right",c[c.None=2]="None"})(n=e.PositionAffinity||(e.PositionAffinity={}));var I;(function(c){c[c.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(I=e.ModelConstants||(e.ModelConstants={}));class l{constructor(m,E,w,P,a,h){this.identifier=m,this.range=E,this.text=w,this.forceMoveMarkers=P,this.isAutoWhitespaceEdit=a,this._isTracked=h}}e.ValidAnnotatedEditOperation=l;class d{constructor(m,E,w){this.reverseEdits=m,this.changes=E,this.trimAutoWhitespaceLineNumbers=w}}e.ApplyEditsResult=d}),define(be[120],Ee([0,1,8,118,37,31,87]),function(ee,e,g,F,S,_,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const y=999;class b{constructor(a,h,p,t){this.searchString=a,this.isRegex=h,this.matchCase=p,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let a;this.isRegex?a=k(this.searchString):a=this.searchString.indexOf(`
`)>=0;let h=null;try{h=g.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:a,global:!0,unicode:!0})}catch(t){return null}if(!h)return null;let p=!this.isRegex&&!a;return p&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(p=this.matchCase),new n(h,this.wordSeparators?(0,F.getMapForWordSeparators)(this.wordSeparators):null,p?this.searchString:null)}}e.SearchParams=b;function k(P){if(!P||P.length===0)return!1;for(let a=0,h=P.length;a<h;a++)if(P.charCodeAt(a)===92){if(a++,a>=h)break;const t=P.charCodeAt(a);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=k;class n{constructor(a,h,p){this.regex=a,this.wordSeparators=h,this.simpleSearch=p}}e.SearchData=n;function I(P,a,h){if(!h)return new C.FindMatch(P,null);let p=[];for(let t=0,r=a.length;t<r;t++)p[t]=a[t];return new C.FindMatch(P,p)}e.createFindMatch=I;class l{constructor(a){let h=[],p=0;for(let t=0,r=a.length;t<r;t++)a.charCodeAt(t)===10&&(h[p++]=t);this._lineFeedsOffsets=h}findLineFeedCountBeforeOffset(a){const h=this._lineFeedsOffsets;let p=0,t=h.length-1;if(t===-1||a<=h[0])return 0;for(;p<t;){const r=p+((t-p)/2>>0);h[r]>=a?t=r-1:h[r+1]>=a?(p=r,t=r):p=r+1}return p+1}}class d{static findMatches(a,h,p,t,r){const s=h.parseSearchRequest();return s?s.regex.multiline?this._doFindMatchesMultiline(a,p,new w(s.wordSeparators,s.regex),t,r):this._doFindMatchesLineByLine(a,p,s,t,r):[]}static _getMultilineMatchRange(a,h,p,t,r,s){let i,u=0;t?(u=t.findLineFeedCountBeforeOffset(r),i=h+r+u):i=h+r;let f;if(t){let o=t.findLineFeedCountBeforeOffset(r+s.length)-u;f=i+s.length+o}else f=i+s.length;const v=a.getPositionAt(i),D=a.getPositionAt(f);return new _.Range(v.lineNumber,v.column,D.lineNumber,D.column)}static _doFindMatchesMultiline(a,h,p,t,r){const s=a.getOffsetAt(h.getStartPosition()),i=a.getValueInRange(h,1),u=a.getEOL()===`\r
`?new l(i):null,f=[];let v=0,D;for(p.reset(0);D=p.next(i);)if(f[v++]=I(this._getMultilineMatchRange(a,s,i,u,D.index,D[0]),D,t),v>=r)return f;return f}static _doFindMatchesLineByLine(a,h,p,t,r){const s=[];let i=0;if(h.startLineNumber===h.endLineNumber){const f=a.getLineContent(h.startLineNumber).substring(h.startColumn-1,h.endColumn-1);return i=this._findMatchesInLine(p,f,h.startLineNumber,h.startColumn-1,i,s,t,r),s}const u=a.getLineContent(h.startLineNumber).substring(h.startColumn-1);i=this._findMatchesInLine(p,u,h.startLineNumber,h.startColumn-1,i,s,t,r);for(let f=h.startLineNumber+1;f<h.endLineNumber&&i<r;f++)i=this._findMatchesInLine(p,a.getLineContent(f),f,0,i,s,t,r);if(i<r){const f=a.getLineContent(h.endLineNumber).substring(0,h.endColumn-1);i=this._findMatchesInLine(p,f,h.endLineNumber,0,i,s,t,r)}return s}static _findMatchesInLine(a,h,p,t,r,s,i,u){const f=a.wordSeparators;if(!i&&a.simpleSearch){const T=a.simpleSearch,o=T.length,A=h.length;let L=-o;for(;(L=h.indexOf(T,L+o))!==-1;)if((!f||E(f,h,A,L,o))&&(s[r++]=new C.FindMatch(new _.Range(p,L+1+t,p,L+1+o+t),null),r>=u))return r;return r}const v=new w(a.wordSeparators,a.regex);let D;v.reset(0);do if(D=v.next(h),D&&(s[r++]=I(new _.Range(p,D.index+1+t,p,D.index+1+D[0].length+t),D,i),r>=u))return r;while(D);return r}static findNextMatch(a,h,p,t){const r=h.parseSearchRequest();if(!r)return null;const s=new w(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindNextMatchMultiline(a,p,s,t):this._doFindNextMatchLineByLine(a,p,s,t)}static _doFindNextMatchMultiline(a,h,p,t){const r=new S.Position(h.lineNumber,1),s=a.getOffsetAt(r),i=a.getLineCount(),u=a.getValueInRange(new _.Range(r.lineNumber,r.column,i,a.getLineMaxColumn(i)),1),f=a.getEOL()===`\r
`?new l(u):null;p.reset(h.column-1);let v=p.next(u);return v?I(this._getMultilineMatchRange(a,s,u,f,v.index,v[0]),v,t):h.lineNumber!==1||h.column!==1?this._doFindNextMatchMultiline(a,new S.Position(1,1),p,t):null}static _doFindNextMatchLineByLine(a,h,p,t){const r=a.getLineCount(),s=h.lineNumber,i=a.getLineContent(s),u=this._findFirstMatchInLine(p,i,s,h.column,t);if(u)return u;for(let f=1;f<=r;f++){const v=(s+f-1)%r,D=a.getLineContent(v+1),T=this._findFirstMatchInLine(p,D,v+1,1,t);if(T)return T}return null}static _findFirstMatchInLine(a,h,p,t,r){a.reset(t-1);const s=a.next(h);return s?I(new _.Range(p,s.index+1,p,s.index+1+s[0].length),s,r):null}static findPreviousMatch(a,h,p,t){const r=h.parseSearchRequest();if(!r)return null;const s=new w(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindPreviousMatchMultiline(a,p,s,t):this._doFindPreviousMatchLineByLine(a,p,s,t)}static _doFindPreviousMatchMultiline(a,h,p,t){const r=this._doFindMatchesMultiline(a,new _.Range(1,1,h.lineNumber,h.column),p,t,10*y);if(r.length>0)return r[r.length-1];const s=a.getLineCount();return h.lineNumber!==s||h.column!==a.getLineMaxColumn(s)?this._doFindPreviousMatchMultiline(a,new S.Position(s,a.getLineMaxColumn(s)),p,t):null}static _doFindPreviousMatchLineByLine(a,h,p,t){const r=a.getLineCount(),s=h.lineNumber,i=a.getLineContent(s).substring(0,h.column-1),u=this._findLastMatchInLine(p,i,s,t);if(u)return u;for(let f=1;f<=r;f++){const v=(r+s-f-1)%r,D=a.getLineContent(v+1),T=this._findLastMatchInLine(p,D,v+1,t);if(T)return T}return null}static _findLastMatchInLine(a,h,p,t){let r=null,s;for(a.reset(0);s=a.next(h);)r=I(new _.Range(p,s.index+1,p,s.index+1+s[0].length),s,t);return r}}e.TextModelSearch=d;function c(P,a,h,p,t){if(p===0)return!0;const r=a.charCodeAt(p-1);if(P.get(r)!==0||r===13||r===10)return!0;if(t>0){const s=a.charCodeAt(p);if(P.get(s)!==0)return!0}return!1}function m(P,a,h,p,t){if(p+t===h)return!0;const r=a.charCodeAt(p+t);if(P.get(r)!==0||r===13||r===10)return!0;if(t>0){const s=a.charCodeAt(p+t-1);if(P.get(s)!==0)return!0}return!1}function E(P,a,h,p,t){return c(P,a,h,p,t)&&m(P,a,h,p,t)}e.isValidMatch=E;class w{constructor(a,h){this._wordSeparators=a,this._searchRegex=h,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(a){this._searchRegex.lastIndex=a,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(a){const h=a.length;let p;do{if(this._prevMatchStartIndex+this._prevMatchLength===h||(p=this._searchRegex.exec(a),!p))return null;const t=p.index,r=p[0].length;if(t===this._prevMatchStartIndex&&r===this._prevMatchLength){if(r===0){g.getNextCodePoint(a,h,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=r,!this._wordSeparators||E(this._wordSeparators,a,h,t,r))return p}while(p);return null}}e.Searcher=w}),define(be[88],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function g(y=""){let b="(-?\\d*\\.\\d\\w*)|([^";for(const k of e.USUAL_WORD_SEPARATORS)y.indexOf(k)>=0||(b+="\\"+k);return b+="\\s]+)",new RegExp(b,"g")}e.DEFAULT_WORD_REGEXP=g();function F(y){let b=e.DEFAULT_WORD_REGEXP;if(y&&y instanceof RegExp)if(y.global)b=y;else{let k="g";y.ignoreCase&&(k+="i"),y.multiline&&(k+="m"),y.unicode&&(k+="u"),b=new RegExp(y.source,k)}return b.lastIndex=0,b}e.ensureValidWordDefinition=F;const S={maxLen:1e3,windowSize:15,timeBudget:150};function _(y,b,k,n,I=S){if(k.length>I.maxLen){let E=y-I.maxLen/2;return E<0?E=0:n+=E,k=k.substring(E,y+I.maxLen/2),_(y,b,k,n,I)}const l=Date.now(),d=y-1-n;let c=-1,m=null;for(let E=1;!(Date.now()-l>=I.timeBudget);E++){const w=d-I.windowSize*E;b.lastIndex=Math.max(0,w);const P=C(b,k,d,c);if(!P&&m||(m=P,w<=0))break;c=w}if(m){let E={word:m[0],startColumn:n+1+m.index,endColumn:n+1+m.index+m[0].length};return b.lastIndex=0,E}return null}e.getWordAtText=_;function C(y,b,k,n){let I;for(;I=y.exec(b);){const l=I.index||0;if(l<=k&&y.lastIndex>=k)return I;if(n>0&&l>n)return null}return null}}),define(be[121],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var g;(function(C){C[C.None=0]="None",C[C.Indent=1]="Indent",C[C.IndentOutdent=2]="IndentOutdent",C[C.Outdent=3]="Outdent"})(g=e.IndentAction||(e.IndentAction={}));class F{constructor(y){if(this._standardAutoClosingPairConditionalBrand=void 0,this.open=y.open,this.close=y.close,this._standardTokenMask=0,Array.isArray(y.notIn))for(let b=0,k=y.notIn.length;b<k;b++)switch(y.notIn[b]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(y){return(this._standardTokenMask&y)==0}}e.StandardAutoClosingPairConditional=F;class S{constructor(y){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const b of y)_(this.autoClosingPairsOpenByStart,b.open.charAt(0),b),_(this.autoClosingPairsOpenByEnd,b.open.charAt(b.open.length-1),b),_(this.autoClosingPairsCloseByStart,b.close.charAt(0),b),_(this.autoClosingPairsCloseByEnd,b.close.charAt(b.close.length-1),b),b.close.length===1&&b.open.length===1&&_(this.autoClosingPairsCloseSingleChar,b.close,b)}}e.AutoClosingPairs=S;function _(C,y,b){C.has(y)?C.get(y).push(b):C.set(y,[b])}}),define(be[57],Ee([0,1,27,14]),function(ee,e,g,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function S(_,C,y,b){if(Array.isArray(_)){let k=0;for(const n of _){const I=S(n,C,y,b);if(I===10)return I;I>k&&(k=I)}return k}else{if(typeof _=="string")return b?_==="*"?5:_===y?10:0:0;if(_){const{language:k,pattern:n,scheme:I,hasAccessToAllModels:l}=_;if(!b&&!l)return 0;let d=0;if(I)if(I===C.scheme)d=10;else if(I==="*")d=5;else return 0;if(k)if(k===y)d=10;else if(k==="*")d=Math.max(d,5);else return 0;if(n){let c;if(typeof n=="string"?c=n:c={...n,base:(0,F.normalize)(n.base)},c===C.fsPath||(0,g.match)(c,C.fsPath))d=10;else return 0}return d}else return 0}}e.score=S}),define(be[122],Ee([0,1,86]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var F;(function(d){d[d.Invalid=0]="Invalid",d[d.Start=1]="Start",d[d.H=2]="H",d[d.HT=3]="HT",d[d.HTT=4]="HTT",d[d.HTTP=5]="HTTP",d[d.F=6]="F",d[d.FI=7]="FI",d[d.FIL=8]="FIL",d[d.BeforeColon=9]="BeforeColon",d[d.AfterColon=10]="AfterColon",d[d.AlmostThere=11]="AlmostThere",d[d.End=12]="End",d[d.Accept=13]="Accept",d[d.LastKnownState=14]="LastKnownState"})(F=e.State||(e.State={}));class S{constructor(c,m,E){const w=new Uint8Array(c*m);for(let P=0,a=c*m;P<a;P++)w[P]=E;this._data=w,this.rows=c,this.cols=m}get(c,m){return this._data[c*this.cols+m]}set(c,m,E){this._data[c*this.cols+m]=E}}e.Uint8Matrix=S;class _{constructor(c){let m=0,E=0;for(let P=0,a=c.length;P<a;P++){let[h,p,t]=c[P];p>m&&(m=p),h>E&&(E=h),t>E&&(E=t)}m++,E++;let w=new S(E,m,0);for(let P=0,a=c.length;P<a;P++){let[h,p,t]=c[P];w.set(h,p,t)}this._states=w,this._maxCharCode=m}nextState(c,m){return m<0||m>=this._maxCharCode?0:this._states.get(c,m)}}e.StateMachine=_;let C=null;function y(){return C===null&&(C=new _([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),C}var b;(function(d){d[d.None=0]="None",d[d.ForceTermination=1]="ForceTermination",d[d.CannotEndIn=2]="CannotEndIn"})(b||(b={}));let k=null;function n(){if(k===null){k=new g.CharacterClassifier(0);const d=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let m=0;m<d.length;m++)k.set(d.charCodeAt(m),1);const c=".,;";for(let m=0;m<c.length;m++)k.set(c.charCodeAt(m),2)}return k}class I{static _createLink(c,m,E,w,P){let a=P-1;do{const h=m.charCodeAt(a);if(c.get(h)!==2)break;a--}while(a>w);if(w>0){const h=m.charCodeAt(w-1),p=m.charCodeAt(a);(h===40&&p===41||h===91&&p===93||h===123&&p===125)&&a--}return{range:{startLineNumber:E,startColumn:w+1,endLineNumber:E,endColumn:a+2},url:m.substring(w,a+1)}}static computeLinks(c,m=y()){const E=n();let w=[];for(let P=1,a=c.getLineCount();P<=a;P++){const h=c.getLineContent(P),p=h.length;let t=0,r=0,s=0,i=1,u=!1,f=!1,v=!1,D=!1;for(;t<p;){let T=!1;const o=h.charCodeAt(t);if(i===13){let A;switch(o){case 40:u=!0,A=0;break;case 41:A=u?0:1;break;case 91:v=!0,f=!0,A=0;break;case 93:v=!1,A=f?0:1;break;case 123:D=!0,A=0;break;case 125:A=D?0:1;break;case 39:A=s===34||s===96?0:1;break;case 34:A=s===39||s===96?0:1;break;case 96:A=s===39||s===34?0:1;break;case 42:A=s===42?1:0;break;case 124:A=s===124?1:0;break;case 32:A=v?0:1;break;default:A=E.get(o)}A===1&&(w.push(I._createLink(E,h,P,r,t)),T=!0)}else if(i===12){let A;o===91?(f=!0,A=0):A=E.get(o),A===1?T=!0:i=13}else i=m.nextState(i,o),i===0&&(T=!0);T&&(i=1,u=!1,f=!1,D=!1,r=t+1,s=o),t++}i===13&&w.push(I._createLink(E,h,P,r,p))}return w}}e.LinkComputer=I;function l(d){return!d||typeof d.getLineCount!="function"||typeof d.getLineContent!="function"?[]:I.computeLinks(d)}e.computeLinks=l}),define(be[123],Ee([0,1,3,6]),function(ee,e,g,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class S{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new g.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(C){this._onDidChange.fire({changedLanguages:C,changedColorMap:!1})}register(C,y){return this._map.set(C,y),this.fire([C]),(0,F.toDisposable)(()=>{this._map.get(C)===y&&(this._map.delete(C),this.fire([C]))})}registerPromise(C,y){let b=null,k=!1;return this._promises.set(C,y.then(n=>{this._promises.delete(C),!(k||!n)&&(b=this.register(C,n))})),(0,F.toDisposable)(()=>{k=!0,b&&b.dispose()})}getPromise(C){const y=this.get(C);if(y)return Promise.resolve(y);const b=this._promises.get(C);return b?b.then(k=>this.get(C)):null}get(C){return this._map.get(C)||null}setColorMap(C){this._colorMap=C,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=S}),define(be[89],Ee([0,1,24,22]),function(ee,e,g,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var S;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(S||(S={}));function _(I){for(let l=0,d=I.length;l<d;l+=4){const c=I[l+0],m=I[l+1],E=I[l+2],w=I[l+3];I[l+0]=w,I[l+1]=E,I[l+2]=m,I[l+3]=c}}function C(I){const l=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return F.isLittleEndian()||_(l),g.VSBuffer.wrap(l)}function y(I){const l=I.buffer;if(F.isLittleEndian()||_(l),l.byteOffset%4==0)return new Uint32Array(l.buffer,l.byteOffset,l.length/4);{const d=new Uint8Array(l.byteLength);return d.set(l),new Uint32Array(d.buffer,d.byteOffset,d.length/4)}}function b(I){const l=new Uint32Array(k(I));let d=0;if(l[d++]=I.id,I.type==="full")l[d++]=1,l[d++]=I.data.length,l.set(I.data,d),d+=I.data.length;else{l[d++]=2,l[d++]=I.deltas.length;for(const c of I.deltas)l[d++]=c.start,l[d++]=c.deleteCount,c.data?(l[d++]=c.data.length,l.set(c.data,d),d+=c.data.length):l[d++]=0}return C(l)}e.encodeSemanticTokensDto=b;function k(I){let l=0;if(l+=1+1,I.type==="full")l+=1+I.data.length;else{l+=1,l+=(1+1+1)*I.deltas.length;for(const d of I.deltas)d.data&&(l+=d.data.length)}return l}function n(I){const l=y(I);let d=0;const c=l[d++];if(l[d++]===1){const P=l[d++],a=l.subarray(d,d+P);return d+=P,{id:c,type:"full",data:a}}const E=l[d++];let w=[];for(let P=0;P<E;P++){const a=l[d++],h=l[d++],p=l[d++];let t;p>0&&(t=l.subarray(d,d+p),d+=p),w[P]={start:a,deleteCount:h,data:t}}return{id:c,type:"delta",deltas:w}}e.decodeSemanticTokensDto=n}),define(be[90],Ee([0,1,82]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class F{constructor(C,y){this._prefixSumIndexOfResultBrand=void 0,this.index=C,this.remainder=y}}e.PrefixSumIndexOfResult=F;class S{constructor(C){this.values=C,this.prefixSum=new Uint32Array(C.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(C,y){C=(0,g.toUint32)(C);const b=this.values,k=this.prefixSum,n=y.length;return n===0?!1:(this.values=new Uint32Array(b.length+n),this.values.set(b.subarray(0,C),0),this.values.set(b.subarray(C),C+n),this.values.set(y,C),C-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=C-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(C,y){return C=(0,g.toUint32)(C),y=(0,g.toUint32)(y),this.values[C]===y?!1:(this.values[C]=y,C-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=C-1),!0)}removeValues(C,y){C=(0,g.toUint32)(C),y=(0,g.toUint32)(y);const b=this.values,k=this.prefixSum;if(C>=b.length)return!1;let n=b.length-C;return y>=n&&(y=n),y===0?!1:(this.values=new Uint32Array(b.length-y),this.values.set(b.subarray(0,C),0),this.values.set(b.subarray(C+y),C),this.prefixSum=new Uint32Array(this.values.length),C-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=C-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(C){return C<0?0:(C=(0,g.toUint32)(C),this._getPrefixSum(C))}_getPrefixSum(C){if(C<=this.prefixSumValidIndex[0])return this.prefixSum[C];let y=this.prefixSumValidIndex[0]+1;y===0&&(this.prefixSum[0]=this.values[0],y++),C>=this.values.length&&(C=this.values.length-1);for(let b=y;b<=C;b++)this.prefixSum[b]=this.prefixSum[b-1]+this.values[b];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],C),this.prefixSum[C]}getIndexOf(C){C=Math.floor(C),this.getTotalSum();let y=0,b=this.values.length-1,k=0,n=0,I=0;for(;y<=b;)if(k=y+(b-y)/2|0,n=this.prefixSum[k],I=n-this.values[k],C<I)b=k-1;else if(C>=n)y=k+1;else break;return new F(k,C-I)}}e.PrefixSumComputer=S}),define(be[124],Ee([0,1,8,37,90]),function(ee,e,g,F,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class _{constructor(y,b,k,n){this._uri=y,this._lines=b,this._eol=k,this._versionId=n,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(y){y.eol&&y.eol!==this._eol&&(this._eol=y.eol,this._lineStarts=null);const b=y.changes;for(const k of b)this._acceptDeleteRange(k.range),this._acceptInsertText(new F.Position(k.range.startLineNumber,k.range.startColumn),k.text);this._versionId=y.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const y=this._eol.length,b=this._lines.length,k=new Uint32Array(b);for(let n=0;n<b;n++)k[n]=this._lines[n].length+y;this._lineStarts=new S.PrefixSumComputer(k)}}_setLineText(y,b){this._lines[y]=b,this._lineStarts&&this._lineStarts.changeValue(y,this._lines[y].length+this._eol.length)}_acceptDeleteRange(y){if(y.startLineNumber===y.endLineNumber){if(y.startColumn===y.endColumn)return;this._setLineText(y.startLineNumber-1,this._lines[y.startLineNumber-1].substring(0,y.startColumn-1)+this._lines[y.startLineNumber-1].substring(y.endColumn-1));return}this._setLineText(y.startLineNumber-1,this._lines[y.startLineNumber-1].substring(0,y.startColumn-1)+this._lines[y.endLineNumber-1].substring(y.endColumn-1)),this._lines.splice(y.startLineNumber,y.endLineNumber-y.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(y.startLineNumber,y.endLineNumber-y.startLineNumber)}_acceptInsertText(y,b){if(b.length===0)return;let k=(0,g.splitLines)(b);if(k.length===1){this._setLineText(y.lineNumber-1,this._lines[y.lineNumber-1].substring(0,y.column-1)+k[0]+this._lines[y.lineNumber-1].substring(y.column-1));return}k[k.length-1]+=this._lines[y.lineNumber-1].substring(y.column-1),this._setLineText(y.lineNumber-1,this._lines[y.lineNumber-1].substring(0,y.column-1)+k[0]);let n=new Uint32Array(k.length-1);for(let I=1;I<k.length;I++)this._lines.splice(y.lineNumber+I-1,0,k[I]),n[I-1]=k[I].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(y.lineNumber,n)}}e.MirrorTextModel=_}),define(be[125],Ee([18,19]),function(ee,e){return ee.create("vs/base/common/errorMessage",e)}),define(be[58],Ee([0,1,125,10,17]),function(ee,e,g,F,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function _(k,n){return n&&(k.stack||k.stacktrace)?g.localize(0,null,y(k),C(k.stack)||C(k.stacktrace)):y(k)}function C(k){return Array.isArray(k)?k.join(`
`):k}function y(k){return typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?g.localize(1,null,k.message):k.message||g.localize(2,null)}function b(k=null,n=!1){if(!k)return g.localize(3,null);if(Array.isArray(k)){const I=S.coalesce(k),l=b(I[0],n);return I.length>1?g.localize(4,null,l,I.length):l}if(F.isString(k))return k;if(k.detail){const I=k.detail;if(I.error)return _(I.error,n);if(I.exception)return _(I.exception,n)}return k.stack?_(k,n):k.message?k.message:g.localize(5,null)}e.toErrorMessage=b}),define(be[126],Ee([18,19]),function(ee,e){return ee.create("vs/editor/common/config/editorOptions",e)}),define(be[127],Ee([0,1,126,22,88]),function(ee,e,g,F,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var _;(function(H){H[H.None=0]="None",H[H.Keep=1]="Keep",H[H.Brackets=2]="Brackets",H[H.Advanced=3]="Advanced",H[H.Full=4]="Full"})(_=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class C{constructor(Z){this._values=Z}hasChanged(Z){return this._values[Z]}}e.ConfigurationChangedEvent=C;class y{constructor(){this._values=[]}_read(Z){return this._values[Z]}get(Z){return this._values[Z]}_write(Z,de){this._values[Z]=de}}e.ValidatedEditorOptions=y;class b{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=b;class k{constructor(Z,de,Be,xe){this.id=Z,this.name=de,this.defaultValue=Be,this.schema=xe}compute(Z,de,Be){return Be}}class n{constructor(Z,de=null){this.schema=void 0,this.id=Z,this.name="_never_",this.defaultValue=void 0,this.deps=de}validate(Z){return this.defaultValue}}class I{constructor(Z,de,Be,xe){this.id=Z,this.name=de,this.defaultValue=Be,this.schema=xe}validate(Z){return typeof Z=="undefined"?this.defaultValue:Z}compute(Z,de,Be){return Be}}function l(H,Z){return typeof H=="undefined"?Z:H==="false"?!1:Boolean(H)}e.boolean=l;class d extends I{constructor(Z,de,Be,xe=void 0){typeof xe!="undefined"&&(xe.type="boolean",xe.default=Be),super(Z,de,Be,xe)}validate(Z){return l(Z,this.defaultValue)}}class c extends I{constructor(Z,de,Be,xe,Ze,De=void 0){typeof De!="undefined"&&(De.type="integer",De.default=Be,De.minimum=xe,De.maximum=Ze),super(Z,de,Be,De),this.minimum=xe,this.maximum=Ze}static clampedInt(Z,de,Be,xe){if(typeof Z=="undefined")return de;let Ze=parseInt(Z,10);return isNaN(Ze)?de:(Ze=Math.max(Be,Ze),Ze=Math.min(xe,Ze),Ze|0)}validate(Z){return c.clampedInt(Z,this.defaultValue,this.minimum,this.maximum)}}class m extends I{constructor(Z,de,Be,xe,Ze){typeof Ze!="undefined"&&(Ze.type="number",Ze.default=Be),super(Z,de,Be,Ze),this.validationFn=xe}static clamp(Z,de,Be){return Z<de?de:Z>Be?Be:Z}static float(Z,de){if(typeof Z=="number")return Z;if(typeof Z=="undefined")return de;const Be=parseFloat(Z);return isNaN(Be)?de:Be}validate(Z){return this.validationFn(m.float(Z,this.defaultValue))}}class E extends I{static string(Z,de){return typeof Z!="string"?de:Z}constructor(Z,de,Be,xe=void 0){typeof xe!="undefined"&&(xe.type="string",xe.default=Be),super(Z,de,Be,xe)}validate(Z){return E.string(Z,this.defaultValue)}}function w(H,Z,de){return typeof H!="string"||de.indexOf(H)===-1?Z:H}e.stringSet=w;class P extends I{constructor(Z,de,Be,xe,Ze=void 0){typeof Ze!="undefined"&&(Ze.type="string",Ze.enum=xe,Ze.default=Be),super(Z,de,Be,Ze),this._allowedValues=xe}validate(Z){return w(Z,this.defaultValue,this._allowedValues)}}class a extends k{constructor(Z,de,Be,xe,Ze,De,Se=void 0){typeof Se!="undefined"&&(Se.type="string",Se.enum=Ze,Se.default=xe),super(Z,de,Be,Se),this._allowedValues=Ze,this._convert=De}validate(Z){return typeof Z!="string"?this.defaultValue:this._allowedValues.indexOf(Z)===-1?this.defaultValue:this._convert(Z)}}function h(H){switch(H){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class p extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[g.localize(0,null),g.localize(1,null),g.localize(2,null)],default:"auto",description:g.localize(3,null)})}validate(Z){switch(Z){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Z,de,Be){return Be===0?Z.accessibilitySupport:Be}}class t extends k{constructor(){const Z={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",Z,{"editor.comments.insertSpace":{type:"boolean",default:Z.insertSpace,description:g.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Z.ignoreEmptyLines,description:g.localize(5,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const de=Z;return{insertSpace:l(de.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:l(de.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var r;(function(H){H[H.Hidden=0]="Hidden",H[H.Blink=1]="Blink",H[H.Smooth=2]="Smooth",H[H.Phase=3]="Phase",H[H.Expand=4]="Expand",H[H.Solid=5]="Solid"})(r=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function s(H){switch(H){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var i;(function(H){H[H.Line=1]="Line",H[H.Block=2]="Block",H[H.Underline=3]="Underline",H[H.LineThin=4]="LineThin",H[H.BlockOutline=5]="BlockOutline",H[H.UnderlineThin=6]="UnderlineThin"})(i=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function u(H){switch(H){case i.Line:return"line";case i.Block:return"block";case i.Underline:return"underline";case i.LineThin:return"line-thin";case i.BlockOutline:return"block-outline";case i.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=u;function f(H){switch(H){case"line":return i.Line;case"block":return i.Block;case"underline":return i.Underline;case"line-thin":return i.LineThin;case"block-outline":return i.BlockOutline;case"underline-thin":return i.UnderlineThin}}class v extends n{constructor(){super(126,[64,31])}compute(Z,de,Be){const xe=["monaco-editor"];return de.get(31)&&xe.push(de.get(31)),Z.extraEditorClassName&&xe.push(Z.extraEditorClassName),de.get(64)==="default"?xe.push("mouse-default"):de.get(64)==="copy"&&xe.push("mouse-copy"),de.get(99)&&xe.push("showUnused"),de.get(124)&&xe.push("showDeprecated"),xe.join(" ")}}class D extends d{constructor(){super(30,"emptySelectionClipboard",!0,{description:g.localize(6,null)})}compute(Z,de,Be){return Be&&Z.emptySelectionClipboard}}class T extends k{constructor(){const Z={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",Z,{"editor.find.cursorMoveOnType":{type:"boolean",default:Z.cursorMoveOnType,description:g.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:Z.seedSearchStringFromSelection,description:g.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Z.autoFindInSelection,enumDescriptions:[g.localize(9,null),g.localize(10,null),g.localize(11,null)],description:g.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Z.globalFindClipboard,description:g.localize(13,null),included:F.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Z.addExtraSpaceOnTop,description:g.localize(14,null)},"editor.find.loop":{type:"boolean",default:Z.loop,description:g.localize(15,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const de=Z;return{cursorMoveOnType:l(de.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:l(de.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof Z.autoFindInSelection=="boolean"?Z.autoFindInSelection?"always":"never":w(de.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:l(de.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:l(de.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:l(de.loop,this.defaultValue.loop)}}}class o extends k{constructor(){super(42,"fontLigatures",o.OFF,{anyOf:[{type:"boolean",description:g.localize(16,null)},{type:"string",description:g.localize(17,null)}],description:g.localize(18,null),default:!1})}validate(Z){return typeof Z=="undefined"?this.defaultValue:typeof Z=="string"?Z==="false"?o.OFF:Z==="true"?o.ON:Z:Boolean(Z)?o.ON:o.OFF}}e.EditorFontLigatures=o,o.OFF='"liga" off, "calt" off',o.ON='"liga" on, "calt" on';class A extends n{constructor(){super(41)}compute(Z,de,Be){return Z.fontInfo}}class L extends I{constructor(){super(43,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:g.localize(19,null)})}validate(Z){let de=m.float(Z,this.defaultValue);return de===0?e.EDITOR_FONT_DEFAULTS.fontSize:m.clamp(de,6,100)}compute(Z,de,Be){return Z.fontInfo.fontSize}}class B extends k{constructor(){super(44,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:B.MINIMUM_VALUE,maximum:B.MAXIMUM_VALUE,errorMessage:g.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:B.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:g.localize(21,null)})}validate(Z){return Z==="normal"||Z==="bold"?Z:String(c.clampedInt(Z,e.EDITOR_FONT_DEFAULTS.fontWeight,B.MINIMUM_VALUE,B.MAXIMUM_VALUE))}}B.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],B.MINIMUM_VALUE=1,B.MAXIMUM_VALUE=1e3;class oe extends k{constructor(){const Z={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},de={type:"string",enum:["peek","gotoAndPeek","goto"],default:Z.multiple,enumDescriptions:[g.localize(22,null),g.localize(23,null),g.localize(24,null)]},Be=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(48,"gotoLocation",Z,{"editor.gotoLocation.multiple":{deprecationMessage:g.localize(25,null)},"editor.gotoLocation.multipleDefinitions":{description:g.localize(26,null),...de},"editor.gotoLocation.multipleTypeDefinitions":{description:g.localize(27,null),...de},"editor.gotoLocation.multipleDeclarations":{description:g.localize(28,null),...de},"editor.gotoLocation.multipleImplementations":{description:g.localize(29,null),...de},"editor.gotoLocation.multipleReferences":{description:g.localize(30,null),...de},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Z.alternativeDefinitionCommand,enum:Be,description:g.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Z.alternativeTypeDefinitionCommand,enum:Be,description:g.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Z.alternativeDeclarationCommand,enum:Be,description:g.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Z.alternativeImplementationCommand,enum:Be,description:g.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Z.alternativeReferenceCommand,enum:Be,description:g.localize(35,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const de=Z;return{multiple:w(de.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:de.multipleDefinitions??w(de.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:de.multipleTypeDefinitions??w(de.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:de.multipleDeclarations??w(de.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:de.multipleImplementations??w(de.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:de.multipleReferences??w(de.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:E.string(de.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:E.string(de.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:E.string(de.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:E.string(de.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:E.string(de.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class he extends k{constructor(){const Z={enabled:!0,delay:300,sticky:!0};super(51,"hover",Z,{"editor.hover.enabled":{type:"boolean",default:Z.enabled,description:g.localize(36,null)},"editor.hover.delay":{type:"number",default:Z.delay,description:g.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:Z.sticky,description:g.localize(38,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const de=Z;return{enabled:l(de.enabled,this.defaultValue.enabled),delay:c.clampedInt(de.delay,this.defaultValue.delay,0,1e4),sticky:l(de.sticky,this.defaultValue.sticky)}}}var Q;(function(H){H[H.None=0]="None",H[H.Text=1]="Text",H[H.Blocks=2]="Blocks"})(Q=e.RenderMinimap||(e.RenderMinimap={}));class z extends n{constructor(){super(129,[47,56,35,63,91,58,59,93,116,119,120,121,2])}compute(Z,de,Be){return z.computeLayout(de,{memory:Z.memory,outerWidth:Z.outerWidth,outerHeight:Z.outerHeight,isDominatedByLongLines:Z.isDominatedByLongLines,lineHeight:Z.fontInfo.lineHeight,viewLineCount:Z.viewLineCount,lineNumbersDigitCount:Z.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Z.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Z.fontInfo.maxDigitWidth,pixelRatio:Z.pixelRatio})}static computeContainedMinimapLineCount(Z){const de=Z.height/Z.lineHeight,Be=Z.scrollBeyondLastLine?de-1:0,xe=(Z.viewLineCount+Be)/(Z.pixelRatio*Z.height),Ze=Math.floor(Z.viewLineCount/xe);return{typicalViewportLineCount:de,extraLinesBeyondLastLine:Be,desiredRatio:xe,minimapLineCount:Ze}}static _computeMinimapLayout(Z,de){const Be=Z.outerWidth,xe=Z.outerHeight,Ze=Z.pixelRatio;if(!Z.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ze*xe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:xe};const De=de.stableMinimapLayoutInput,Se=De&&Z.outerHeight===De.outerHeight&&Z.lineHeight===De.lineHeight&&Z.typicalHalfwidthCharacterWidth===De.typicalHalfwidthCharacterWidth&&Z.pixelRatio===De.pixelRatio&&Z.scrollBeyondLastLine===De.scrollBeyondLastLine&&Z.minimap.enabled===De.minimap.enabled&&Z.minimap.side===De.minimap.side&&Z.minimap.size===De.minimap.size&&Z.minimap.showSlider===De.minimap.showSlider&&Z.minimap.renderCharacters===De.minimap.renderCharacters&&Z.minimap.maxColumn===De.minimap.maxColumn&&Z.minimap.scale===De.minimap.scale&&Z.verticalScrollbarWidth===De.verticalScrollbarWidth&&Z.isViewportWrapping===De.isViewportWrapping,Pe=Z.lineHeight,re=Z.typicalHalfwidthCharacterWidth,ae=Z.scrollBeyondLastLine,fe=Z.minimap.renderCharacters;let pe=Ze>=2?Math.round(Z.minimap.scale*2):Z.minimap.scale;const U=Z.minimap.maxColumn,me=Z.minimap.size,we=Z.minimap.side,Ie=Z.verticalScrollbarWidth,Oe=Z.viewLineCount,He=Z.remainingWidth,et=Z.isViewportWrapping,Qe=fe?2:3;let Ke=Math.floor(Ze*xe);const lt=Ke/Ze;let ft=!1,_t=!1,ut=Qe*pe,ot=pe/Ze,_e=1;if(me==="fill"||me==="fit"){const{typicalViewportLineCount:Ge,extraLinesBeyondLastLine:dt,desiredRatio:yt,minimapLineCount:kt}=z.computeContainedMinimapLineCount({viewLineCount:Oe,scrollBeyondLastLine:ae,height:xe,lineHeight:Pe,pixelRatio:Ze});if(Oe/kt>1)ft=!0,_t=!0,pe=1,ut=1,ot=pe/Ze;else{let mt=!1,ct=pe+1;if(me==="fit"){const Et=Math.ceil((Oe+dt)*ut);et&&Se&&He<=de.stableFitRemainingWidth?(mt=!0,ct=de.stableFitMaxMinimapScale):mt=Et>Ke}if(me==="fill"||mt){ft=!0;const Et=pe;ut=Math.min(Pe*Ze,Math.max(1,Math.floor(1/yt))),et&&Se&&He<=de.stableFitRemainingWidth&&(ct=de.stableFitMaxMinimapScale),pe=Math.min(ct,Math.max(1,Math.floor(ut/Qe))),pe>Et&&(_e=Math.min(2,pe/Et)),ot=pe/Ze/_e,Ke=Math.ceil(Math.max(Ge,Oe+dt)*ut),et?(de.stableMinimapLayoutInput=Z,de.stableFitRemainingWidth=He,de.stableFitMaxMinimapScale=pe):(de.stableMinimapLayoutInput=null,de.stableFitRemainingWidth=0)}}}const ke=Math.floor(U*ot),Y=Math.min(ke,Math.max(0,Math.floor((He-Ie-2)*ot/(re+ot)))+e.MINIMAP_GUTTER_WIDTH);let W=Math.floor(Ze*Y);const Fe=W/Ze;W=Math.floor(W*_e);const Me=fe?1:2,tt=we==="left"?0:Be-Y-Ie;return{renderMinimap:Me,minimapLeft:tt,minimapWidth:Y,minimapHeightIsEditorHeight:ft,minimapIsSampling:_t,minimapScale:pe,minimapLineHeight:ut,minimapCanvasInnerWidth:W,minimapCanvasInnerHeight:Ke,minimapCanvasOuterWidth:Fe,minimapCanvasOuterHeight:lt}}static computeLayout(Z,de){const Be=de.outerWidth|0,xe=de.outerHeight|0,Ze=de.lineHeight|0,De=de.lineNumbersDigitCount|0,Se=de.typicalHalfwidthCharacterWidth,Pe=de.maxDigitWidth,re=de.pixelRatio,ae=de.viewLineCount,fe=Z.get(121),pe=fe==="inherit"?Z.get(120):fe,U=pe==="inherit"?Z.get(116):pe,me=Z.get(119),we=Z.get(2),Ie=de.isDominatedByLongLines,Oe=Z.get(47),He=Z.get(58).renderType!==0,et=Z.get(59),Qe=Z.get(93),Ke=Z.get(63),lt=Z.get(91),ft=lt.verticalScrollbarSize,_t=lt.verticalHasArrows,ut=lt.arrowSize,ot=lt.horizontalScrollbarSize,_e=Z.get(56),ke=Z.get(35);let Y;if(typeof _e=="string"&&/^\d+(\.\d+)?ch$/.test(_e)){const Pt=parseFloat(_e.substr(0,_e.length-2));Y=c.clampedInt(Pt*Se,0,0,1e3)}else Y=c.clampedInt(_e,0,0,1e3);ke&&(Y+=16);let W=0;if(He){const Pt=Math.max(De,et);W=Math.round(Pt*Pe)}let Fe=0;Oe&&(Fe=Ze);let Me=0,tt=Me+Fe,Ge=tt+W,dt=Ge+Y;const yt=Be-Fe-W-Y;let kt=!1,bt=!1,mt=-1;we!==2&&(pe==="inherit"&&Ie?(kt=!0,bt=!0):U==="on"||U==="bounded"?bt=!0:U==="wordWrapColumn"&&(mt=me));const ct=z._computeMinimapLayout({outerWidth:Be,outerHeight:xe,lineHeight:Ze,typicalHalfwidthCharacterWidth:Se,pixelRatio:re,scrollBeyondLastLine:Qe,minimap:Ke,verticalScrollbarWidth:ft,viewLineCount:ae,remainingWidth:yt,isViewportWrapping:bt},de.memory||new b);ct.renderMinimap!==0&&ct.minimapLeft===0&&(Me+=ct.minimapWidth,tt+=ct.minimapWidth,Ge+=ct.minimapWidth,dt+=ct.minimapWidth);const Et=yt-ct.minimapWidth,gt=Math.max(1,Math.floor((Et-ft-2)/Se)),Ot=_t?ut:0;return bt&&(mt=Math.max(1,gt),U==="bounded"&&(mt=Math.min(mt,me))),{width:Be,height:xe,glyphMarginLeft:Me,glyphMarginWidth:Fe,lineNumbersLeft:tt,lineNumbersWidth:W,decorationsLeft:Ge,decorationsWidth:Y,contentLeft:dt,contentWidth:Et,minimap:ct,viewportColumn:gt,isWordWrapMinified:kt,isViewportWrapping:bt,wrappingColumn:mt,verticalScrollbarWidth:ft,horizontalScrollbarHeight:ot,overviewRuler:{top:Ot,width:ft,height:xe-2*Ot,right:0}}}}e.EditorLayoutInfoComputer=z;class V extends k{constructor(){const Z={enabled:!0};super(55,"lightbulb",Z,{"editor.lightbulb.enabled":{type:"boolean",default:Z.enabled,description:g.localize(39,null)}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{enabled:l(Z.enabled,this.defaultValue.enabled)}}}class R extends k{constructor(){const Z={enabled:!0,fontSize:0,fontFamily:""};super(125,"inlayHints",Z,{"editor.inlayHints.enabled":{type:"boolean",default:Z.enabled,description:g.localize(40,null)},"editor.inlayHints.fontSize":{type:"number",default:Z.fontSize,markdownDescription:g.localize(41,null)},"editor.inlayHints.fontFamily":{type:"string",default:Z.fontFamily,description:g.localize(42,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const de=Z;return{enabled:l(de.enabled,this.defaultValue.enabled),fontSize:c.clampedInt(de.fontSize,this.defaultValue.fontSize,0,100),fontFamily:E.string(de.fontFamily,this.defaultValue.fontFamily)}}}class K extends m{constructor(){super(57,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Z=>m.clamp(Z,0,150),{markdownDescription:g.localize(43,null)})}compute(Z,de,Be){return Z.fontInfo.lineHeight}}class x extends k{constructor(){const Z={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(63,"minimap",Z,{"editor.minimap.enabled":{type:"boolean",default:Z.enabled,description:g.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[g.localize(45,null),g.localize(46,null),g.localize(47,null)],default:Z.size,description:g.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Z.side,description:g.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Z.showSlider,description:g.localize(50,null)},"editor.minimap.scale":{type:"number",default:Z.scale,minimum:1,maximum:3,enum:[1,2,3],description:g.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Z.renderCharacters,description:g.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:Z.maxColumn,description:g.localize(53,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const de=Z;return{enabled:l(de.enabled,this.defaultValue.enabled),size:w(de.size,this.defaultValue.size,["proportional","fill","fit"]),side:w(de.side,this.defaultValue.side,["right","left"]),showSlider:w(de.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:l(de.renderCharacters,this.defaultValue.renderCharacters),scale:c.clampedInt(de.scale,1,1,3),maxColumn:c.clampedInt(de.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function j(H){return H==="ctrlCmd"?F.isMacintosh?"metaKey":"ctrlKey":"altKey"}class ue extends k{constructor(){super(73,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:g.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:g.localize(55,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const de=Z;return{top:c.clampedInt(de.top,0,0,1e3),bottom:c.clampedInt(de.bottom,0,0,1e3)}}}class $ extends k{constructor(){const Z={enabled:!0,cycle:!1};super(74,"parameterHints",Z,{"editor.parameterHints.enabled":{type:"boolean",default:Z.enabled,description:g.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:Z.cycle,description:g.localize(57,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const de=Z;return{enabled:l(de.enabled,this.defaultValue.enabled),cycle:l(de.cycle,this.defaultValue.cycle)}}}class te extends n{constructor(){super(127)}compute(Z,de,Be){return Z.pixelRatio}}class ce extends k{constructor(){const Z={other:!0,comments:!1,strings:!1};super(77,"quickSuggestions",Z,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:Z.strings,description:g.localize(58,null)},comments:{type:"boolean",default:Z.comments,description:g.localize(59,null)},other:{type:"boolean",default:Z.other,description:g.localize(60,null)}}}],default:Z,description:g.localize(61,null)});this.defaultValue=Z}validate(Z){if(typeof Z=="boolean")return Z;if(Z&&typeof Z=="object"){const de=Z,Be={other:l(de.other,this.defaultValue.other),comments:l(de.comments,this.defaultValue.comments),strings:l(de.strings,this.defaultValue.strings)};return Be.other&&Be.comments&&Be.strings?!0:!Be.other&&!Be.comments&&!Be.strings?!1:Be}return this.defaultValue}}var ye;(function(H){H[H.Off=0]="Off",H[H.On=1]="On",H[H.Relative=2]="Relative",H[H.Interval=3]="Interval",H[H.Custom=4]="Custom"})(ye=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Re extends k{constructor(){super(58,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[g.localize(62,null),g.localize(63,null),g.localize(64,null),g.localize(65,null)],default:"on",description:g.localize(66,null)})}validate(Z){let de=this.defaultValue.renderType,Be=this.defaultValue.renderFn;return typeof Z!="undefined"&&(typeof Z=="function"?(de=4,Be=Z):Z==="interval"?de=3:Z==="relative"?de=2:Z==="on"?de=1:de=0),{renderType:de,renderFn:Be}}}function Te(H){const Z=H.get(86);return Z==="editable"?H.get(79):Z!=="on"}e.filterValidationDecorations=Te;class $e extends k{constructor(){const Z=[],de={type:"number",description:g.localize(67,null)};super(90,"rulers",Z,{type:"array",items:{anyOf:[de,{type:["object"],properties:{column:de,color:{type:"string",description:g.localize(68,null),format:"color-hex"}}}]},default:Z,description:g.localize(69,null)})}validate(Z){if(Array.isArray(Z)){let de=[];for(let Be of Z)if(typeof Be=="number")de.push({column:c.clampedInt(Be,0,0,1e4),color:null});else if(Be&&typeof Be=="object"){const xe=Be;de.push({column:c.clampedInt(xe.column,0,0,1e4),color:xe.color})}return de.sort((Be,xe)=>Be.column-xe.column),de}return this.defaultValue}}function Je(H,Z){if(typeof H!="string")return Z;switch(H){case"hidden":return 2;case"visible":return 3;default:return 1}}class Ve extends k{constructor(){const Z={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(91,"scrollbar",Z,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[g.localize(70,null),g.localize(71,null),g.localize(72,null)],default:"auto",description:g.localize(73,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[g.localize(74,null),g.localize(75,null),g.localize(76,null)],default:"auto",description:g.localize(77,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Z.verticalScrollbarSize,description:g.localize(78,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Z.horizontalScrollbarSize,description:g.localize(79,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Z.scrollByPage,description:g.localize(80,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const de=Z,Be=c.clampedInt(de.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),xe=c.clampedInt(de.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:c.clampedInt(de.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Je(de.vertical,this.defaultValue.vertical),horizontal:Je(de.horizontal,this.defaultValue.horizontal),useShadows:l(de.useShadows,this.defaultValue.useShadows),verticalHasArrows:l(de.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:l(de.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:l(de.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:l(de.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Be,horizontalSliderSize:c.clampedInt(de.horizontalSliderSize,Be,0,1e3),verticalScrollbarSize:xe,verticalSliderSize:c.clampedInt(de.verticalSliderSize,xe,0,1e3),scrollByPage:l(de.scrollByPage,this.defaultValue.scrollByPage)}}}class je extends k{constructor(){const Z={enabled:!1,mode:"subwordSmart"};super(53,"inlineSuggest",Z,{"editor.inlineSuggest.enabled":{type:"boolean",default:Z.enabled,description:g.localize(81,null)},"editor.inlineSuggest.mode":{type:"string",enum:["prefix","subword","subwordSmart"],enumDescriptions:[g.localize(82,null),g.localize(83,null),g.localize(84,null)],default:Z.mode,description:g.localize(85,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const de=Z;return{enabled:l(de.enabled,this.defaultValue.enabled),mode:w(de.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class O extends k{constructor(){const Z={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(105,"suggest",Z,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[g.localize(86,null),g.localize(87,null)],default:Z.insertMode,description:g.localize(88,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Z.filterGraceful,description:g.localize(89,null)},"editor.suggest.localityBonus":{type:"boolean",default:Z.localityBonus,description:g.localize(90,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Z.shareSuggestSelections,markdownDescription:g.localize(91,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Z.snippetsPreventQuickSuggestions,description:g.localize(92,null)},"editor.suggest.showIcons":{type:"boolean",default:Z.showIcons,description:g.localize(93,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Z.showStatusBar,description:g.localize(94,null)},"editor.suggest.preview":{type:"boolean",default:Z.preview,description:g.localize(95,null)},"editor.suggest.previewMode":{type:"string",enum:["prefix","subword","subwordSmart"],enumDescriptions:[g.localize(96,null),g.localize(97,null),g.localize(98,null)],default:Z.previewMode,description:g.localize(99,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Z.showInlineDetails,description:g.localize(100,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:g.localize(101,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:g.localize(102,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:g.localize(103,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:g.localize(104,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:g.localize(105,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:g.localize(106,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:g.localize(107,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:g.localize(108,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:g.localize(109,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:g.localize(110,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:g.localize(111,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:g.localize(112,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:g.localize(113,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:g.localize(114,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:g.localize(115,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:g.localize(116,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:g.localize(117,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:g.localize(118,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:g.localize(119,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:g.localize(120,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:g.localize(121,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:g.localize(122,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:g.localize(123,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:g.localize(124,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:g.localize(125,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:g.localize(126,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:g.localize(127,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:g.localize(128,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:g.localize(129,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:g.localize(130,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:g.localize(131,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const de=Z;return{insertMode:w(de.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:l(de.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:l(de.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:l(de.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:l(de.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:l(de.showIcons,this.defaultValue.showIcons),showStatusBar:l(de.showStatusBar,this.defaultValue.showStatusBar),preview:l(de.preview,this.defaultValue.preview),previewMode:w(de.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:l(de.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:l(de.showMethods,this.defaultValue.showMethods),showFunctions:l(de.showFunctions,this.defaultValue.showFunctions),showConstructors:l(de.showConstructors,this.defaultValue.showConstructors),showDeprecated:l(de.showDeprecated,this.defaultValue.showDeprecated),showFields:l(de.showFields,this.defaultValue.showFields),showVariables:l(de.showVariables,this.defaultValue.showVariables),showClasses:l(de.showClasses,this.defaultValue.showClasses),showStructs:l(de.showStructs,this.defaultValue.showStructs),showInterfaces:l(de.showInterfaces,this.defaultValue.showInterfaces),showModules:l(de.showModules,this.defaultValue.showModules),showProperties:l(de.showProperties,this.defaultValue.showProperties),showEvents:l(de.showEvents,this.defaultValue.showEvents),showOperators:l(de.showOperators,this.defaultValue.showOperators),showUnits:l(de.showUnits,this.defaultValue.showUnits),showValues:l(de.showValues,this.defaultValue.showValues),showConstants:l(de.showConstants,this.defaultValue.showConstants),showEnums:l(de.showEnums,this.defaultValue.showEnums),showEnumMembers:l(de.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:l(de.showKeywords,this.defaultValue.showKeywords),showWords:l(de.showWords,this.defaultValue.showWords),showColors:l(de.showColors,this.defaultValue.showColors),showFiles:l(de.showFiles,this.defaultValue.showFiles),showReferences:l(de.showReferences,this.defaultValue.showReferences),showFolders:l(de.showFolders,this.defaultValue.showFolders),showTypeParameters:l(de.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:l(de.showSnippets,this.defaultValue.showSnippets),showUsers:l(de.showUsers,this.defaultValue.showUsers),showIssues:l(de.showIssues,this.defaultValue.showIssues)}}}class G extends k{constructor(){super(101,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:g.localize(132,null),default:!0,type:"boolean"}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:l(Z.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class X extends n{constructor(){super(128,[79])}compute(Z,de,Be){return de.get(79)?!0:Z.tabFocusMode}}var se;(function(H){H[H.None=0]="None",H[H.Same=1]="Same",H[H.Indent=2]="Indent",H[H.DeepIndent=3]="DeepIndent"})(se=e.WrappingIndent||(e.WrappingIndent={}));function q(H){switch(H){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class ie extends n{constructor(){super(130,[129])}compute(Z,de,Be){const xe=de.get(129);return{isDominatedByLongLines:Z.isDominatedByLongLines,isWordWrapMinified:xe.isWordWrapMinified,isViewportWrapping:xe.isViewportWrapping,wrappingColumn:xe.wrappingColumn}}}const ge="Consolas, 'Courier New', monospace",Le="Menlo, Monaco, 'Courier New', monospace",We="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:F.isMacintosh?Le:F.isLinux?We:ge,fontWeight:"normal",fontSize:F.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function ve(H){return e.editorOptionsRegistry[H.id]=H,H}var Xe;(function(H){H[H.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",H[H.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",H[H.accessibilitySupport=2]="accessibilitySupport",H[H.accessibilityPageSize=3]="accessibilityPageSize",H[H.ariaLabel=4]="ariaLabel",H[H.autoClosingBrackets=5]="autoClosingBrackets",H[H.autoClosingDelete=6]="autoClosingDelete",H[H.autoClosingOvertype=7]="autoClosingOvertype",H[H.autoClosingQuotes=8]="autoClosingQuotes",H[H.autoIndent=9]="autoIndent",H[H.automaticLayout=10]="automaticLayout",H[H.autoSurround=11]="autoSurround",H[H.codeLens=12]="codeLens",H[H.codeLensFontFamily=13]="codeLensFontFamily",H[H.codeLensFontSize=14]="codeLensFontSize",H[H.colorDecorators=15]="colorDecorators",H[H.columnSelection=16]="columnSelection",H[H.comments=17]="comments",H[H.contextmenu=18]="contextmenu",H[H.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",H[H.cursorBlinking=20]="cursorBlinking",H[H.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",H[H.cursorStyle=22]="cursorStyle",H[H.cursorSurroundingLines=23]="cursorSurroundingLines",H[H.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",H[H.cursorWidth=25]="cursorWidth",H[H.disableLayerHinting=26]="disableLayerHinting",H[H.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",H[H.domReadOnly=28]="domReadOnly",H[H.dragAndDrop=29]="dragAndDrop",H[H.emptySelectionClipboard=30]="emptySelectionClipboard",H[H.extraEditorClassName=31]="extraEditorClassName",H[H.fastScrollSensitivity=32]="fastScrollSensitivity",H[H.find=33]="find",H[H.fixedOverflowWidgets=34]="fixedOverflowWidgets",H[H.folding=35]="folding",H[H.foldingStrategy=36]="foldingStrategy",H[H.foldingHighlight=37]="foldingHighlight",H[H.foldingImportsByDefault=38]="foldingImportsByDefault",H[H.unfoldOnClickAfterEndOfLine=39]="unfoldOnClickAfterEndOfLine",H[H.fontFamily=40]="fontFamily",H[H.fontInfo=41]="fontInfo",H[H.fontLigatures=42]="fontLigatures",H[H.fontSize=43]="fontSize",H[H.fontWeight=44]="fontWeight",H[H.formatOnPaste=45]="formatOnPaste",H[H.formatOnType=46]="formatOnType",H[H.glyphMargin=47]="glyphMargin",H[H.gotoLocation=48]="gotoLocation",H[H.hideCursorInOverviewRuler=49]="hideCursorInOverviewRuler",H[H.highlightActiveIndentGuide=50]="highlightActiveIndentGuide",H[H.hover=51]="hover",H[H.inDiffEditor=52]="inDiffEditor",H[H.inlineSuggest=53]="inlineSuggest",H[H.letterSpacing=54]="letterSpacing",H[H.lightbulb=55]="lightbulb",H[H.lineDecorationsWidth=56]="lineDecorationsWidth",H[H.lineHeight=57]="lineHeight",H[H.lineNumbers=58]="lineNumbers",H[H.lineNumbersMinChars=59]="lineNumbersMinChars",H[H.linkedEditing=60]="linkedEditing",H[H.links=61]="links",H[H.matchBrackets=62]="matchBrackets",H[H.minimap=63]="minimap",H[H.mouseStyle=64]="mouseStyle",H[H.mouseWheelScrollSensitivity=65]="mouseWheelScrollSensitivity",H[H.mouseWheelZoom=66]="mouseWheelZoom",H[H.multiCursorMergeOverlapping=67]="multiCursorMergeOverlapping",H[H.multiCursorModifier=68]="multiCursorModifier",H[H.multiCursorPaste=69]="multiCursorPaste",H[H.occurrencesHighlight=70]="occurrencesHighlight",H[H.overviewRulerBorder=71]="overviewRulerBorder",H[H.overviewRulerLanes=72]="overviewRulerLanes",H[H.padding=73]="padding",H[H.parameterHints=74]="parameterHints",H[H.peekWidgetDefaultFocus=75]="peekWidgetDefaultFocus",H[H.definitionLinkOpensInPeek=76]="definitionLinkOpensInPeek",H[H.quickSuggestions=77]="quickSuggestions",H[H.quickSuggestionsDelay=78]="quickSuggestionsDelay",H[H.readOnly=79]="readOnly",H[H.renameOnType=80]="renameOnType",H[H.renderControlCharacters=81]="renderControlCharacters",H[H.renderIndentGuides=82]="renderIndentGuides",H[H.renderFinalNewline=83]="renderFinalNewline",H[H.renderLineHighlight=84]="renderLineHighlight",H[H.renderLineHighlightOnlyWhenFocus=85]="renderLineHighlightOnlyWhenFocus",H[H.renderValidationDecorations=86]="renderValidationDecorations",H[H.renderWhitespace=87]="renderWhitespace",H[H.revealHorizontalRightPadding=88]="revealHorizontalRightPadding",H[H.roundedSelection=89]="roundedSelection",H[H.rulers=90]="rulers",H[H.scrollbar=91]="scrollbar",H[H.scrollBeyondLastColumn=92]="scrollBeyondLastColumn",H[H.scrollBeyondLastLine=93]="scrollBeyondLastLine",H[H.scrollPredominantAxis=94]="scrollPredominantAxis",H[H.selectionClipboard=95]="selectionClipboard",H[H.selectionHighlight=96]="selectionHighlight",H[H.selectOnLineNumbers=97]="selectOnLineNumbers",H[H.showFoldingControls=98]="showFoldingControls",H[H.showUnused=99]="showUnused",H[H.snippetSuggestions=100]="snippetSuggestions",H[H.smartSelect=101]="smartSelect",H[H.smoothScrolling=102]="smoothScrolling",H[H.stickyTabStops=103]="stickyTabStops",H[H.stopRenderingLineAfter=104]="stopRenderingLineAfter",H[H.suggest=105]="suggest",H[H.suggestFontSize=106]="suggestFontSize",H[H.suggestLineHeight=107]="suggestLineHeight",H[H.suggestOnTriggerCharacters=108]="suggestOnTriggerCharacters",H[H.suggestSelection=109]="suggestSelection",H[H.tabCompletion=110]="tabCompletion",H[H.tabIndex=111]="tabIndex",H[H.unusualLineTerminators=112]="unusualLineTerminators",H[H.useShadowDOM=113]="useShadowDOM",H[H.useTabStops=114]="useTabStops",H[H.wordSeparators=115]="wordSeparators",H[H.wordWrap=116]="wordWrap",H[H.wordWrapBreakAfterCharacters=117]="wordWrapBreakAfterCharacters",H[H.wordWrapBreakBeforeCharacters=118]="wordWrapBreakBeforeCharacters",H[H.wordWrapColumn=119]="wordWrapColumn",H[H.wordWrapOverride1=120]="wordWrapOverride1",H[H.wordWrapOverride2=121]="wordWrapOverride2",H[H.wrappingIndent=122]="wrappingIndent",H[H.wrappingStrategy=123]="wrappingStrategy",H[H.showDeprecated=124]="showDeprecated",H[H.inlayHints=125]="inlayHints",H[H.editorClassName=126]="editorClassName",H[H.pixelRatio=127]="pixelRatio",H[H.tabFocusMode=128]="tabFocusMode",H[H.layoutInfo=129]="layoutInfo",H[H.wrappingInfo=130]="wrappingInfo"})(Xe=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ve(new d(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:g.localize(133,null)})),acceptSuggestionOnEnter:ve(new P(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",g.localize(134,null),""],markdownDescription:g.localize(135,null)})),accessibilitySupport:ve(new p),accessibilityPageSize:ve(new c(3,"accessibilityPageSize",10,1,1073741824,{description:g.localize(136,null)})),ariaLabel:ve(new E(4,"ariaLabel",g.localize(137,null))),autoClosingBrackets:ve(new P(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(138,null),g.localize(139,null),""],description:g.localize(140,null)})),autoClosingDelete:ve(new P(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",g.localize(141,null),""],description:g.localize(142,null)})),autoClosingOvertype:ve(new P(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",g.localize(143,null),""],description:g.localize(144,null)})),autoClosingQuotes:ve(new P(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(145,null),g.localize(146,null),""],description:g.localize(147,null)})),autoIndent:ve(new a(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],h,{enumDescriptions:[g.localize(148,null),g.localize(149,null),g.localize(150,null),g.localize(151,null),g.localize(152,null)],description:g.localize(153,null)})),automaticLayout:ve(new d(10,"automaticLayout",!1)),autoSurround:ve(new P(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[g.localize(154,null),g.localize(155,null),g.localize(156,null),""],description:g.localize(157,null)})),stickyTabStops:ve(new d(103,"stickyTabStops",!1,{description:g.localize(158,null)})),codeLens:ve(new d(12,"codeLens",!0,{description:g.localize(159,null)})),codeLensFontFamily:ve(new E(13,"codeLensFontFamily","",{description:g.localize(160,null)})),codeLensFontSize:ve(new c(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:g.localize(161,null)})),colorDecorators:ve(new d(15,"colorDecorators",!0,{description:g.localize(162,null)})),columnSelection:ve(new d(16,"columnSelection",!1,{description:g.localize(163,null)})),comments:ve(new t),contextmenu:ve(new d(18,"contextmenu",!0)),copyWithSyntaxHighlighting:ve(new d(19,"copyWithSyntaxHighlighting",!0,{description:g.localize(164,null)})),cursorBlinking:ve(new a(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],s,{description:g.localize(165,null)})),cursorSmoothCaretAnimation:ve(new d(21,"cursorSmoothCaretAnimation",!1,{description:g.localize(166,null)})),cursorStyle:ve(new a(22,"cursorStyle",i.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],f,{description:g.localize(167,null)})),cursorSurroundingLines:ve(new c(23,"cursorSurroundingLines",0,0,1073741824,{description:g.localize(168,null)})),cursorSurroundingLinesStyle:ve(new P(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[g.localize(169,null),g.localize(170,null)],description:g.localize(171,null)})),cursorWidth:ve(new c(25,"cursorWidth",0,0,1073741824,{markdownDescription:g.localize(172,null)})),disableLayerHinting:ve(new d(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:ve(new d(27,"disableMonospaceOptimizations",!1)),domReadOnly:ve(new d(28,"domReadOnly",!1)),dragAndDrop:ve(new d(29,"dragAndDrop",!0,{description:g.localize(173,null)})),emptySelectionClipboard:ve(new D),extraEditorClassName:ve(new E(31,"extraEditorClassName","")),fastScrollSensitivity:ve(new m(32,"fastScrollSensitivity",5,H=>H<=0?5:H,{markdownDescription:g.localize(174,null)})),find:ve(new T),fixedOverflowWidgets:ve(new d(34,"fixedOverflowWidgets",!1)),folding:ve(new d(35,"folding",!0,{description:g.localize(175,null)})),foldingStrategy:ve(new P(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[g.localize(176,null),g.localize(177,null)],description:g.localize(178,null)})),foldingHighlight:ve(new d(37,"foldingHighlight",!0,{description:g.localize(179,null)})),foldingImportsByDefault:ve(new d(38,"foldingImportsByDefault",!1,{description:g.localize(180,null)})),unfoldOnClickAfterEndOfLine:ve(new d(39,"unfoldOnClickAfterEndOfLine",!1,{description:g.localize(181,null)})),fontFamily:ve(new E(40,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:g.localize(182,null)})),fontInfo:ve(new A),fontLigatures2:ve(new o),fontSize:ve(new L),fontWeight:ve(new B),formatOnPaste:ve(new d(45,"formatOnPaste",!1,{description:g.localize(183,null)})),formatOnType:ve(new d(46,"formatOnType",!1,{description:g.localize(184,null)})),glyphMargin:ve(new d(47,"glyphMargin",!0,{description:g.localize(185,null)})),gotoLocation:ve(new oe),hideCursorInOverviewRuler:ve(new d(49,"hideCursorInOverviewRuler",!1,{description:g.localize(186,null)})),highlightActiveIndentGuide:ve(new d(50,"highlightActiveIndentGuide",!0,{description:g.localize(187,null)})),hover:ve(new he),inDiffEditor:ve(new d(52,"inDiffEditor",!1)),letterSpacing:ve(new m(54,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,H=>m.clamp(H,-5,20),{description:g.localize(188,null)})),lightbulb:ve(new V),lineDecorationsWidth:ve(new I(56,"lineDecorationsWidth",10)),lineHeight:ve(new K),lineNumbers:ve(new Re),lineNumbersMinChars:ve(new c(59,"lineNumbersMinChars",5,1,300)),linkedEditing:ve(new d(60,"linkedEditing",!1,{description:g.localize(189,null)})),links:ve(new d(61,"links",!0,{description:g.localize(190,null)})),matchBrackets:ve(new P(62,"matchBrackets","always",["always","near","never"],{description:g.localize(191,null)})),minimap:ve(new x),mouseStyle:ve(new P(64,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ve(new m(65,"mouseWheelScrollSensitivity",1,H=>H===0?1:H,{markdownDescription:g.localize(192,null)})),mouseWheelZoom:ve(new d(66,"mouseWheelZoom",!1,{markdownDescription:g.localize(193,null)})),multiCursorMergeOverlapping:ve(new d(67,"multiCursorMergeOverlapping",!0,{description:g.localize(194,null)})),multiCursorModifier:ve(new a(68,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],j,{markdownEnumDescriptions:[g.localize(195,null),g.localize(196,null)],markdownDescription:g.localize(197,null)})),multiCursorPaste:ve(new P(69,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[g.localize(198,null),g.localize(199,null)],markdownDescription:g.localize(200,null)})),occurrencesHighlight:ve(new d(70,"occurrencesHighlight",!0,{description:g.localize(201,null)})),overviewRulerBorder:ve(new d(71,"overviewRulerBorder",!0,{description:g.localize(202,null)})),overviewRulerLanes:ve(new c(72,"overviewRulerLanes",3,0,3)),padding:ve(new ue),parameterHints:ve(new $),peekWidgetDefaultFocus:ve(new P(75,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[g.localize(203,null),g.localize(204,null)],description:g.localize(205,null)})),definitionLinkOpensInPeek:ve(new d(76,"definitionLinkOpensInPeek",!1,{description:g.localize(206,null)})),quickSuggestions:ve(new ce),quickSuggestionsDelay:ve(new c(78,"quickSuggestionsDelay",10,0,1073741824,{description:g.localize(207,null)})),readOnly:ve(new d(79,"readOnly",!1)),renameOnType:ve(new d(80,"renameOnType",!1,{description:g.localize(208,null),markdownDeprecationMessage:g.localize(209,null)})),renderControlCharacters:ve(new d(81,"renderControlCharacters",!1,{description:g.localize(210,null)})),renderIndentGuides:ve(new d(82,"renderIndentGuides",!0,{description:g.localize(211,null)})),renderFinalNewline:ve(new d(83,"renderFinalNewline",!0,{description:g.localize(212,null)})),renderLineHighlight:ve(new P(84,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",g.localize(213,null)],description:g.localize(214,null)})),renderLineHighlightOnlyWhenFocus:ve(new d(85,"renderLineHighlightOnlyWhenFocus",!1,{description:g.localize(215,null)})),renderValidationDecorations:ve(new P(86,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ve(new P(87,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",g.localize(216,null),g.localize(217,null),g.localize(218,null),""],description:g.localize(219,null)})),revealHorizontalRightPadding:ve(new c(88,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:ve(new d(89,"roundedSelection",!0,{description:g.localize(220,null)})),rulers:ve(new $e),scrollbar:ve(new Ve),scrollBeyondLastColumn:ve(new c(92,"scrollBeyondLastColumn",5,0,1073741824,{description:g.localize(221,null)})),scrollBeyondLastLine:ve(new d(93,"scrollBeyondLastLine",!0,{description:g.localize(222,null)})),scrollPredominantAxis:ve(new d(94,"scrollPredominantAxis",!0,{description:g.localize(223,null)})),selectionClipboard:ve(new d(95,"selectionClipboard",!0,{description:g.localize(224,null),included:F.isLinux})),selectionHighlight:ve(new d(96,"selectionHighlight",!0,{description:g.localize(225,null)})),selectOnLineNumbers:ve(new d(97,"selectOnLineNumbers",!0)),showFoldingControls:ve(new P(98,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[g.localize(226,null),g.localize(227,null)],description:g.localize(228,null)})),showUnused:ve(new d(99,"showUnused",!0,{description:g.localize(229,null)})),showDeprecated:ve(new d(124,"showDeprecated",!0,{description:g.localize(230,null)})),inlayHints:ve(new R),snippetSuggestions:ve(new P(100,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[g.localize(231,null),g.localize(232,null),g.localize(233,null),g.localize(234,null)],description:g.localize(235,null)})),smartSelect:ve(new G),smoothScrolling:ve(new d(102,"smoothScrolling",!1,{description:g.localize(236,null)})),stopRenderingLineAfter:ve(new c(104,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ve(new O),inlineSuggest:ve(new je),suggestFontSize:ve(new c(106,"suggestFontSize",0,0,1e3,{markdownDescription:g.localize(237,null)})),suggestLineHeight:ve(new c(107,"suggestLineHeight",0,0,1e3,{markdownDescription:g.localize(238,null)})),suggestOnTriggerCharacters:ve(new d(108,"suggestOnTriggerCharacters",!0,{description:g.localize(239,null)})),suggestSelection:ve(new P(109,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[g.localize(240,null),g.localize(241,null),g.localize(242,null)],description:g.localize(243,null)})),tabCompletion:ve(new P(110,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[g.localize(244,null),g.localize(245,null),g.localize(246,null)],description:g.localize(247,null)})),tabIndex:ve(new c(111,"tabIndex",0,-1,1073741824)),unusualLineTerminators:ve(new P(112,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[g.localize(248,null),g.localize(249,null),g.localize(250,null)],description:g.localize(251,null)})),useShadowDOM:ve(new d(113,"useShadowDOM",!0)),useTabStops:ve(new d(114,"useTabStops",!0,{description:g.localize(252,null)})),wordSeparators:ve(new E(115,"wordSeparators",S.USUAL_WORD_SEPARATORS,{description:g.localize(253,null)})),wordWrap:ve(new P(116,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[g.localize(254,null),g.localize(255,null),g.localize(256,null),g.localize(257,null)],description:g.localize(258,null)})),wordWrapBreakAfterCharacters:ve(new E(117,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ve(new E(118,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ve(new c(119,"wordWrapColumn",80,1,1073741824,{markdownDescription:g.localize(259,null)})),wordWrapOverride1:ve(new P(120,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ve(new P(121,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:ve(new a(122,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],q,{enumDescriptions:[g.localize(260,null),g.localize(261,null),g.localize(262,null),g.localize(263,null)],description:g.localize(264,null)})),wrappingStrategy:ve(new P(123,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[g.localize(265,null),g.localize(266,null)],description:g.localize(267,null)})),editorClassName:ve(new v),pixelRatio:ve(new te),tabFocusMode:ve(new X),layoutInfo:ve(new z),wrappingInfo:ve(new ie)}}),define(be[128],Ee([18,19]),function(ee,e){return ee.create("vs/platform/configuration/common/configurationRegistry",e)}),define(be[129],Ee([18,19]),function(ee,e){return ee.create("vs/platform/extensions/common/extensionValidator",e)}),define(be[130],Ee([18,19]),function(ee,e){return ee.create("vs/platform/files/common/files",e)}),define(be[131],Ee([18,19]),function(ee,e){return ee.create("vs/platform/markers/common/markers",e)}),define(be[132],Ee([18,19]),function(ee,e){return ee.create("vs/platform/theme/common/iconRegistry",e)}),define(be[133],Ee([18,19]),function(ee,e){return ee.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(be[134],Ee([18,19]),function(ee,e){return ee.create("vs/workbench/api/common/extHostExtensionService",e)}),define(be[135],Ee([18,19]),function(ee,e){return ee.create("vs/workbench/api/common/extHostProgress",e)}),define(be[136],Ee([18,19]),function(ee,e){return ee.create("vs/workbench/api/common/extHostStatusBar",e)}),define(be[137],Ee([18,19]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTerminalService",e)}),define(be[138],Ee([18,19]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTreeViews",e)}),define(be[139],Ee([18,19]),function(ee,e){return ee.create("vs/workbench/api/common/extHostWorkspace",e)}),define(be[140],Ee([18,19]),function(ee,e){return ee.create("vs/workbench/common/editor",e)}),define(be[141],Ee([18,19]),function(ee,e){return ee.create("vs/workbench/common/views",e)}),define(be[142],Ee([18,19]),function(ee,e){return ee.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(be[143],Ee([18,19]),function(ee,e){return ee.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(be[144],Ee([18,19]),function(ee,e){return ee.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(be[145],Ee([18,19]),function(ee,e){return ee.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(be[146],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var g;(function(C){C[C.ACTIVATE=1]="ACTIVATE",C[C.RESTORE=2]="RESTORE",C[C.PRESERVE=3]="PRESERVE"})(g=e.EditorActivation||(e.EditorActivation={}));var F;(function(C){C[C.PICK=0]="PICK",C[C.DISABLED=1]="DISABLED",C[C.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(F=e.EditorResolution||(e.EditorResolution={}));var S;(function(C){C[C.API=0]="API",C[C.USER=1]="USER"})(S=e.EditorOpenContext||(e.EditorOpenContext={}));var _;(function(C){C[C.Center=0]="Center",C[C.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",C[C.NearTop=2]="NearTop",C[C.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(_=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(be[147],Ee([0,1,129]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const F=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,S=/^-(\d{4})(\d{2})(\d{2})$/;function _(l){return l=l.trim(),l==="*"||F.test(l)}e.isValidVersionStr=_;function C(l){if(!_(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let d=l.match(F);return d?{hasCaret:d[1]==="^",hasGreaterEquals:d[1]===">=",majorBase:d[2]==="x"?0:parseInt(d[2],10),majorMustEqual:d[2]!=="x",minorBase:d[4]==="x"?0:parseInt(d[4],10),minorMustEqual:d[4]!=="x",patchBase:d[6]==="x"?0:parseInt(d[6],10),patchMustEqual:d[6]!=="x",preRelease:d[8]||null}:null}e.parseVersion=C;function y(l){if(!l)return null;let d=l.majorBase,c=l.majorMustEqual,m=l.minorBase,E=l.minorMustEqual,w=l.patchBase,P=l.patchMustEqual;l.hasCaret&&(d===0||(E=!1),P=!1);let a=0;if(l.preRelease){const h=S.exec(l.preRelease);if(h){const[,p,t,r]=h;a=Date.UTC(Number(p),Number(t)-1,Number(r))}}return{majorBase:d,majorMustEqual:c,minorBase:m,minorMustEqual:E,patchBase:w,patchMustEqual:P,isMinimum:l.hasGreaterEquals,notBefore:a}}e.normalizeVersion=y;function b(l,d,c){let m;typeof l=="string"?m=y(C(l)):m=l;let E;d instanceof Date?E=d.getTime():typeof d=="string"&&(E=new Date(d).getTime());let w;if(typeof c=="string"?w=y(C(c)):w=c,!m||!w)return!1;let P=m.majorBase,a=m.minorBase,h=m.patchBase,p=w.majorBase,t=w.minorBase,r=w.patchBase,s=w.notBefore,i=w.majorMustEqual,u=w.minorMustEqual,f=w.patchMustEqual;return w.isMinimum?P>p?!0:P<p?!1:a>t?!0:a<t||E&&E<s?!1:h>=r:(P===1&&p===0&&(!i||!u||!f)&&(p=1,t=0,r=0,i=!0,u=!1,f=!1),P<p?!1:P>p?!i:a<t?!1:a>t?!u:h<r?!1:h>r?!f:!(E&&E<s))}e.isValidVersion=b;function k(l,d,c,m){return c.isBuiltin||typeof c.main=="undefined"?!0:I(l,d,c.engines.vscode,m)}e.isValidExtensionVersion=k;function n(l,d,c){return l==="*"||I(d,c,l)}e.isEngineValid=n;function I(l,d,c,m=[]){let E=y(C(c));if(!E)return m.push(g.localize(0,null,c)),!1;if(E.majorBase===0){if(!E.majorMustEqual||!E.minorMustEqual)return m.push(g.localize(1,null,c)),!1}else if(!E.majorMustEqual)return m.push(g.localize(2,null,c)),!1;return b(l,d,E)?!0:(m.push(g.localize(3,null,l,c)),!1)}}),define(be[91],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class g{constructor(S,_=[],C=!1){this.ctor=S,this.staticArguments=_,this.supportsDelayedInstantiation=C}}e.SyncDescriptor=g}),define(be[59],Ee([0,1,91]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const F=[];function S(C,y,b){y instanceof g.SyncDescriptor||(y=new g.SyncDescriptor(y,[],b)),F.push([C,y])}e.registerSingleton=S;function _(){return F}e.getSingletonServiceDescriptors=_}),define(be[148],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class g{constructor(_){this.incoming=new Map,this.outgoing=new Map,this.data=_}}e.Node=g;class F{constructor(_){this._hashFn=_,this._nodes=new Map}roots(){const _=[];for(let C of this._nodes.values())C.outgoing.size===0&&_.push(C);return _}insertEdge(_,C){const y=this.lookupOrInsertNode(_),b=this.lookupOrInsertNode(C);y.outgoing.set(this._hashFn(C),b),b.incoming.set(this._hashFn(_),y)}removeNode(_){const C=this._hashFn(_);this._nodes.delete(C);for(let y of this._nodes.values())y.outgoing.delete(C),y.incoming.delete(C)}lookupOrInsertNode(_){const C=this._hashFn(_);let y=this._nodes.get(C);return y||(y=new g(_),this._nodes.set(C,y)),y}lookup(_){return this._nodes.get(this._hashFn(_))}isEmpty(){return this._nodes.size===0}toString(){let _=[];for(let[C,y]of this._nodes)_.push(`${C}, (incoming)[${[...y.incoming.keys()].join(", ")}], (outgoing)[${[...y.outgoing.keys()].join(",")}]`);return _.join(`
`)}findCycleSlow(){for(let[_,C]of this._nodes){const y=new Set([_]),b=this._findCycle(C,y);if(b)return b}}_findCycle(_,C){for(let[y,b]of _.outgoing){if(C.has(y))return[...C,y].join(" -> ");C.add(y);const k=this._findCycle(b,C);if(k)return k;C.delete(y)}}}e.Graph=F}),define(be[4],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var g;(function(y){y.serviceIds=new Map,y.DI_TARGET="$di$target",y.DI_DEPENDENCIES="$di$dependencies";function b(k){return k[y.DI_DEPENDENCIES]||[]}y.getServiceDependencies=b})(g=e._util||(e._util={})),e.IInstantiationService=S("instantiationService");function F(y,b,k,n){b[g.DI_TARGET]===b?b[g.DI_DEPENDENCIES].push({id:y,index:k,optional:n}):(b[g.DI_DEPENDENCIES]=[{id:y,index:k,optional:n}],b[g.DI_TARGET]=b)}function S(y){if(g.serviceIds.has(y))return g.serviceIds.get(y);const b=function(k,n,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");F(b,k,I,!1)};return b.toString=()=>y,g.serviceIds.set(y,b),b}e.createDecorator=S;function _(y){return y}e.refineServiceDecorator=_;function C(y){return function(b,k,n){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");F(y,b,n,!0)}}e.optional=C}),define(be[149],Ee([0,1,4]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,g.createDecorator)("modelService");function F(S){return!S.isTooLargeForSyncing()&&!S.isForSimpleWidget}e.shouldSynchronizeModel=F}),define(be[150],Ee([0,1,3,42,6,21,81,57,149]),function(ee,e,g,F,S,_,C,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function k(l){return typeof l=="string"?!1:Array.isArray(l)?l.every(k):!!l.exclusive}class n{constructor(){this._clock=0,this._entries=[],this._onDidChange=new g.Emitter}get onDidChange(){return this._onDidChange.event}register(d,c){let m={selector:d,provider:c,_score:-1,_time:this._clock++};return this._entries.push(m),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,S.toDisposable)(()=>{if(m){let E=this._entries.indexOf(m);E>=0&&(this._entries.splice(E,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),m=void 0)}})}has(d){return this.all(d).length>0}all(d){if(!d)return[];this._updateScores(d);const c=[];for(let m of this._entries)m._score>0&&c.push(m.provider);return c}ordered(d){const c=[];return this._orderedForEach(d,m=>c.push(m.provider)),c}orderedGroups(d){const c=[];let m,E;return this._orderedForEach(d,w=>{m&&E===w._score?m.push(w.provider):(E=w._score,m=[w.provider],c.push(m))}),c}_orderedForEach(d,c){if(!!d){this._updateScores(d);for(const m of this._entries)m._score>0&&c(m)}}_updateScores(d){let c={uri:d.uri.toString(),language:d.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===c.language&&this._lastCandidate.uri===c.uri)){this._lastCandidate=c;for(let m of this._entries)if(m._score=(0,y.score)(m.selector,d.uri,d.getLanguageIdentifier().language,(0,b.shouldSynchronizeModel)(d)),k(m.selector)&&m._score>0){for(let E of this._entries)E._score=0;m._score=1e3;break}this._entries.sort(n._compareByScoreAndTime)}}static _compareByScoreAndTime(d,c){return d._score<c._score?1:d._score>c._score?-1:d._time<c._time?1:d._time>c._time?-1:0}}e.LanguageFeatureRegistry=n;class I{constructor(d,c,m=Number.MAX_SAFE_INTEGER){this._registry=d,this.min=c,this.max=m,this._cache=new _.LRUCache(50,.7)}_key(d){return d.id+(0,F.hash)(this._registry.all(d))}_clamp(d){return d===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(d*1.3)))}get(d){const c=this._key(d),m=this._cache.get(c);return this._clamp(m?.value)}update(d,c){const m=this._key(d);let E=this._cache.get(m);return E||(E=new C.MovingAverage,this._cache.set(m,E)),E.update(c),this.get(d)}}e.LanguageFeatureRequestDelays=I}),define(be[60],Ee([0,1,2,31,150,123,35]),function(ee,e,g,F,S,_,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var y;(function(o){o[o.Null=0]="Null",o[o.PlainText=1]="PlainText"})(y=e.LanguageId||(e.LanguageId={}));class b{constructor(A,L){this.language=A,this.id=L}}e.LanguageIdentifier=b;var k;(function(o){o[o.NotSet=-1]="NotSet",o[o.None=0]="None",o[o.Italic=1]="Italic",o[o.Bold=2]="Bold",o[o.Underline=4]="Underline"})(k=e.FontStyle||(e.FontStyle={}));var n;(function(o){o[o.None=0]="None",o[o.DefaultForeground=1]="DefaultForeground",o[o.DefaultBackground=2]="DefaultBackground"})(n=e.ColorId||(e.ColorId={}));var I;(function(o){o[o.Other=0]="Other",o[o.Comment=1]="Comment",o[o.String=2]="String",o[o.RegEx=4]="RegEx"})(I=e.StandardTokenType||(e.StandardTokenType={}));var l;(function(o){o[o.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",o[o.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",o[o.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",o[o.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",o[o.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",o[o.ITALIC_MASK=2048]="ITALIC_MASK",o[o.BOLD_MASK=4096]="BOLD_MASK",o[o.UNDERLINE_MASK=8192]="UNDERLINE_MASK",o[o.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",o[o.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",o[o.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",o[o.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",o[o.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",o[o.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",o[o.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",o[o.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",o[o.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",o[o.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(l=e.MetadataConsts||(e.MetadataConsts={}));class d{static getLanguageId(A){return(A&255)>>>0}static getTokenType(A){return(A&1792)>>>8}static getFontStyle(A){return(A&14336)>>>11}static getForeground(A){return(A&8372224)>>>14}static getBackground(A){return(A&4286578688)>>>23}static getClassNameFromMetadata(A){let L=this.getForeground(A),B="mtk"+L,oe=this.getFontStyle(A);return oe&1&&(B+=" mtki"),oe&2&&(B+=" mtkb"),oe&4&&(B+=" mtku"),B}static getInlineStyleFromMetadata(A,L){const B=this.getForeground(A),oe=this.getFontStyle(A);let he=`color: ${L[B]};`;return oe&1&&(he+="font-style: italic;"),oe&2&&(he+="font-weight: bold;"),oe&4&&(he+="text-decoration: underline;"),he}}e.TokenMetadata=d;var c;(function(o){o[o.Method=0]="Method",o[o.Function=1]="Function",o[o.Constructor=2]="Constructor",o[o.Field=3]="Field",o[o.Variable=4]="Variable",o[o.Class=5]="Class",o[o.Struct=6]="Struct",o[o.Interface=7]="Interface",o[o.Module=8]="Module",o[o.Property=9]="Property",o[o.Event=10]="Event",o[o.Operator=11]="Operator",o[o.Unit=12]="Unit",o[o.Value=13]="Value",o[o.Constant=14]="Constant",o[o.Enum=15]="Enum",o[o.EnumMember=16]="EnumMember",o[o.Keyword=17]="Keyword",o[o.Text=18]="Text",o[o.Color=19]="Color",o[o.File=20]="File",o[o.Reference=21]="Reference",o[o.Customcolor=22]="Customcolor",o[o.Folder=23]="Folder",o[o.TypeParameter=24]="TypeParameter",o[o.User=25]="User",o[o.Issue=26]="Issue",o[o.Snippet=27]="Snippet"})(c=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let o=Object.create(null);return o[0]="symbol-method",o[1]="symbol-function",o[2]="symbol-constructor",o[3]="symbol-field",o[4]="symbol-variable",o[5]="symbol-class",o[6]="symbol-struct",o[7]="symbol-interface",o[8]="symbol-module",o[9]="symbol-property",o[10]="symbol-event",o[11]="symbol-operator",o[12]="symbol-unit",o[13]="symbol-value",o[14]="symbol-constant",o[15]="symbol-enum",o[16]="symbol-enum-member",o[17]="symbol-keyword",o[27]="symbol-snippet",o[18]="symbol-text",o[19]="symbol-color",o[20]="symbol-file",o[21]="symbol-reference",o[22]="symbol-customcolor",o[23]="symbol-folder",o[24]="symbol-type-parameter",o[25]="account",o[26]="issues",function(A){const L=o[A];let B=L&&C.iconRegistry.get(L);return B||(console.info("No codicon found for CompletionItemKind "+A),B=C.Codicon.symbolProperty),B.classNames}}(),e.completionKindFromString=function(){let o=Object.create(null);return o.method=0,o.function=1,o.constructor=2,o.field=3,o.variable=4,o.class=5,o.struct=6,o.interface=7,o.module=8,o.property=9,o.event=10,o.operator=11,o.unit=12,o.value=13,o.constant=14,o.enum=15,o["enum-member"]=16,o.enumMember=16,o.keyword=17,o.snippet=27,o.text=18,o.color=19,o.file=20,o.reference=21,o.customcolor=22,o.folder=23,o["type-parameter"]=24,o.typeParameter=24,o.account=25,o.issue=26,function(A,L){let B=o[A];return typeof B=="undefined"&&!L&&(B=9),B}}();var m;(function(o){o[o.Deprecated=1]="Deprecated"})(m=e.CompletionItemTag||(e.CompletionItemTag={}));var E;(function(o){o[o.KeepWhitespace=1]="KeepWhitespace",o[o.InsertAsSnippet=4]="InsertAsSnippet"})(E=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var w;(function(o){o[o.Invoke=0]="Invoke",o[o.TriggerCharacter=1]="TriggerCharacter",o[o.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(w=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var P;(function(o){o[o.Automatic=0]="Automatic",o[o.Explicit=1]="Explicit"})(P=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var a;(function(o){o[o.Invoke=1]="Invoke",o[o.Auto=2]="Auto"})(a=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var h;(function(o){o[o.Invoke=1]="Invoke",o[o.TriggerCharacter=2]="TriggerCharacter",o[o.ContentChange=3]="ContentChange"})(h=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var p;(function(o){o[o.Text=0]="Text",o[o.Read=1]="Read",o[o.Write=2]="Write"})(p=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function t(o){return o&&g.URI.isUri(o.uri)&&F.Range.isIRange(o.range)&&(F.Range.isIRange(o.originSelectionRange)||F.Range.isIRange(o.targetSelectionRange))}e.isLocationLink=t;var r;(function(o){o[o.File=0]="File",o[o.Module=1]="Module",o[o.Namespace=2]="Namespace",o[o.Package=3]="Package",o[o.Class=4]="Class",o[o.Method=5]="Method",o[o.Property=6]="Property",o[o.Field=7]="Field",o[o.Constructor=8]="Constructor",o[o.Enum=9]="Enum",o[o.Interface=10]="Interface",o[o.Function=11]="Function",o[o.Variable=12]="Variable",o[o.Constant=13]="Constant",o[o.String=14]="String",o[o.Number=15]="Number",o[o.Boolean=16]="Boolean",o[o.Array=17]="Array",o[o.Object=18]="Object",o[o.Key=19]="Key",o[o.Null=20]="Null",o[o.EnumMember=21]="EnumMember",o[o.Struct=22]="Struct",o[o.Event=23]="Event",o[o.Operator=24]="Operator",o[o.TypeParameter=25]="TypeParameter"})(r=e.SymbolKind||(e.SymbolKind={}));var s;(function(o){o[o.Deprecated=1]="Deprecated"})(s=e.SymbolTag||(e.SymbolTag={}));var i;(function(o){const A=new Map;A.set("file",0),A.set("module",1),A.set("namespace",2),A.set("package",3),A.set("class",4),A.set("method",5),A.set("property",6),A.set("field",7),A.set("constructor",8),A.set("enum",9),A.set("interface",10),A.set("function",11),A.set("variable",12),A.set("constant",13),A.set("string",14),A.set("number",15),A.set("boolean",16),A.set("array",17),A.set("object",18),A.set("key",19),A.set("null",20),A.set("enum-member",21),A.set("struct",22),A.set("event",23),A.set("operator",24),A.set("type-parameter",25);const L=new Map;L.set(0,"file"),L.set(1,"module"),L.set(2,"namespace"),L.set(3,"package"),L.set(4,"class"),L.set(5,"method"),L.set(6,"property"),L.set(7,"field"),L.set(8,"constructor"),L.set(9,"enum"),L.set(10,"interface"),L.set(11,"function"),L.set(12,"variable"),L.set(13,"constant"),L.set(14,"string"),L.set(15,"number"),L.set(16,"boolean"),L.set(17,"array"),L.set(18,"object"),L.set(19,"key"),L.set(20,"null"),L.set(21,"enum-member"),L.set(22,"struct"),L.set(23,"event"),L.set(24,"operator"),L.set(25,"type-parameter");function B(Q){return A.get(Q)}o.fromString=B;function oe(Q){return L.get(Q)}o.toString=oe;function he(Q,z){const V=L.get(Q);let R=V&&C.iconRegistry.get("symbol-"+V);return R||(console.info("No codicon found for SymbolKind "+Q),R=C.Codicon.symbolProperty),`${z?"inline":"block"} ${R.classNames}`}o.toCssClassName=he})(i=e.SymbolKinds||(e.SymbolKinds={}));class u{constructor(A){this.value=A}}e.FoldingRangeKind=u,u.Comment=new u("comment"),u.Imports=new u("imports"),u.Region=new u("region");var f;(function(o){o[o.Collapsed=0]="Collapsed",o[o.Expanded=1]="Expanded"})(f=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var v;(function(o){o[o.Editing=0]="Editing",o[o.Preview=1]="Preview"})(v=e.CommentMode||(e.CommentMode={}));var D;(function(o){o[o.Other=0]="Other",o[o.Type=1]="Type",o[o.Parameter=2]="Parameter"})(D=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new S.LanguageFeatureRegistry,e.RenameProviderRegistry=new S.LanguageFeatureRegistry,e.CompletionProviderRegistry=new S.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new S.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new S.LanguageFeatureRegistry,e.HoverProviderRegistry=new S.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new S.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new S.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new S.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new S.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new S.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new S.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new S.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new S.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new S.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new S.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new S.LanguageFeatureRegistry,e.LinkProviderRegistry=new S.LanguageFeatureRegistry,e.ColorProviderRegistry=new S.LanguageFeatureRegistry,e.SelectionRangeRegistry=new S.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new S.LanguageFeatureRegistry,e.TokenizationRegistry=new _.TokenizationRegistryImpl;var T;(function(o){o[o.None=0]="None",o[o.Option=1]="Option",o[o.Default=2]="Default",o[o.Preferred=3]="Preferred"})(T=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(be[45],Ee([0,1,8,4,22]),function(ee,e,g,F,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let _=S.userAgent||"";const C=new Map;C.set("false",!1),C.set("true",!0),C.set("isMac",S.isMacintosh),C.set("isLinux",S.isLinux),C.set("isWindows",S.isWindows),C.set("isWeb",S.isWeb),C.set("isMacNative",S.isMacintosh&&!S.isWeb),C.set("isEdge",_.indexOf("Edg/")>=0),C.set("isFirefox",_.indexOf("Firefox")>=0),C.set("isChrome",_.indexOf("Chrome")>=0),C.set("isSafari",_.indexOf("Safari")>=0);const y=Object.prototype.hasOwnProperty;var b;(function(T){T[T.False=0]="False",T[T.True=1]="True",T[T.Defined=2]="Defined",T[T.Not=3]="Not",T[T.Equals=4]="Equals",T[T.NotEquals=5]="NotEquals",T[T.And=6]="And",T[T.Regex=7]="Regex",T[T.NotRegex=8]="NotRegex",T[T.Or=9]="Or",T[T.In=10]="In",T[T.NotIn=11]="NotIn",T[T.Greater=12]="Greater",T[T.GreaterEquals=13]="GreaterEquals",T[T.Smaller=14]="Smaller",T[T.SmallerEquals=15]="SmallerEquals"})(b=e.ContextKeyExprType||(e.ContextKeyExprType={}));class k{static false(){return I.INSTANCE}static true(){return l.INSTANCE}static has(o){return d.create(o)}static equals(o,A){return c.create(o,A)}static notEquals(o,A){return w.create(o,A)}static regex(o,A){return r.create(o,A)}static in(o,A){return m.create(o,A)}static not(o){return P.create(o)}static and(...o){return i.create(o)}static or(...o){return u.create(o)}static greater(o,A){return a.create(o,A)}static less(o,A){return p.create(o,A)}static deserialize(o,A=!1){if(!!o)return this._deserializeOrExpression(o,A)}static _deserializeOrExpression(o,A){let L=o.split("||");return u.create(L.map(B=>this._deserializeAndExpression(B,A)))}static _deserializeAndExpression(o,A){let L=o.split("&&");return i.create(L.map(B=>this._deserializeOne(B,A)))}static _deserializeOne(o,A){if(o=o.trim(),o.indexOf("!=")>=0){let L=o.split("!=");return w.create(L[0].trim(),this._deserializeValue(L[1],A))}if(o.indexOf("==")>=0){let L=o.split("==");return c.create(L[0].trim(),this._deserializeValue(L[1],A))}if(o.indexOf("=~")>=0){let L=o.split("=~");return r.create(L[0].trim(),this._deserializeRegexValue(L[1],A))}if(o.indexOf(" in ")>=0){let L=o.split(" in ");return m.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(o)){const L=o.split(">=");return h.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(o)){const L=o.split(">");return a.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(o)){const L=o.split("<=");return t.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(o)){const L=o.split("<");return p.create(L[0].trim(),L[1].trim())}return/^\!\s*/.test(o)?P.create(o.substr(1).trim()):d.create(o)}static _deserializeValue(o,A){if(o=o.trim(),o==="true")return!0;if(o==="false")return!1;let L=/^'([^']*)'$/.exec(o);return L?L[1].trim():o}static _deserializeRegexValue(o,A){if((0,g.isFalsyOrWhitespace)(o)){if(A)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let L=o.indexOf("/"),B=o.lastIndexOf("/");if(L===B||L<0){if(A)throw new Error(`bad regexp-value '${o}', missing /-enclosure`);return console.warn(`bad regexp-value '${o}', missing /-enclosure`),null}let oe=o.slice(L+1,B),he=o[B+1]==="i"?"i":"";try{return new RegExp(oe,he)}catch(Q){if(A)throw new Error(`bad regexp-value '${o}', parse error: ${Q}`);return console.warn(`bad regexp-value '${o}', parse error: ${Q}`),null}}}e.ContextKeyExpr=k;function n(T,o){return T.cmp(o)}class I{constructor(){this.type=0}cmp(o){return this.type-o.type}equals(o){return o.type===this.type}evaluate(o){return!1}serialize(){return"false"}keys(){return[]}map(o){return this}negate(){return l.INSTANCE}}e.ContextKeyFalseExpr=I,I.INSTANCE=new I;class l{constructor(){this.type=1}cmp(o){return this.type-o.type}equals(o){return o.type===this.type}evaluate(o){return!0}serialize(){return"true"}keys(){return[]}map(o){return this}negate(){return I.INSTANCE}}e.ContextKeyTrueExpr=l,l.INSTANCE=new l;class d{constructor(o){this.key=o,this.type=2}static create(o){const A=C.get(o);return typeof A=="boolean"?A?l.INSTANCE:I.INSTANCE:new d(o)}cmp(o){return o.type!==this.type?this.type-o.type:v(this.key,o.key)}equals(o){return o.type===this.type?this.key===o.key:!1}evaluate(o){return!!o.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(o){return o.mapDefined(this.key)}negate(){return P.create(this.key)}}e.ContextKeyDefinedExpr=d;class c{constructor(o,A){this.key=o,this.value=A,this.type=4}static create(o,A){if(typeof A=="boolean")return A?d.create(o):P.create(o);const L=C.get(o);return typeof L=="boolean"?A===(L?"true":"false")?l.INSTANCE:I.INSTANCE:new c(o,A)}cmp(o){return o.type!==this.type?this.type-o.type:D(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return o.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(o){return o.mapEquals(this.key,this.value)}negate(){return w.create(this.key,this.value)}}e.ContextKeyEqualsExpr=c;class m{constructor(o,A){this.key=o,this.valueKey=A,this.type=10}static create(o,A){return new m(o,A)}cmp(o){return o.type!==this.type?this.type-o.type:D(this.key,this.valueKey,o.key,o.valueKey)}equals(o){return o.type===this.type?this.key===o.key&&this.valueKey===o.valueKey:!1}evaluate(o){const A=o.getValue(this.valueKey),L=o.getValue(this.key);return Array.isArray(A)?A.indexOf(L)>=0:typeof L=="string"&&typeof A=="object"&&A!==null?y.call(A,L):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(o){return o.mapIn(this.key,this.valueKey)}negate(){return E.create(this)}}e.ContextKeyInExpr=m;class E{constructor(o){this._actual=o,this.type=11}static create(o){return new E(o)}cmp(o){return o.type!==this.type?this.type-o.type:this._actual.cmp(o._actual)}equals(o){return o.type===this.type?this._actual.equals(o._actual):!1}evaluate(o){return!this._actual.evaluate(o)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(o){return new E(this._actual.map(o))}negate(){return this._actual}}e.ContextKeyNotInExpr=E;class w{constructor(o,A){this.key=o,this.value=A,this.type=5}static create(o,A){if(typeof A=="boolean")return A?P.create(o):d.create(o);const L=C.get(o);return typeof L=="boolean"?A===(L?"true":"false")?I.INSTANCE:l.INSTANCE:new w(o,A)}cmp(o){return o.type!==this.type?this.type-o.type:D(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return o.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(o){return o.mapNotEquals(this.key,this.value)}negate(){return c.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=w;class P{constructor(o){this.key=o,this.type=3}static create(o){const A=C.get(o);return typeof A=="boolean"?A?I.INSTANCE:l.INSTANCE:new P(o)}cmp(o){return o.type!==this.type?this.type-o.type:v(this.key,o.key)}equals(o){return o.type===this.type?this.key===o.key:!1}evaluate(o){return!o.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(o){return o.mapNot(this.key)}negate(){return d.create(this.key)}}e.ContextKeyNotExpr=P;class a{constructor(o,A){this.key=o,this.value=A,this.type=12}static create(o,A){return new a(o,A)}cmp(o){return o.type!==this.type?this.type-o.type:D(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return parseFloat(o.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(o){return o.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=a;class h{constructor(o,A){this.key=o,this.value=A,this.type=13}static create(o,A){return new h(o,A)}cmp(o){return o.type!==this.type?this.type-o.type:D(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return parseFloat(o.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(o){return o.mapGreaterEquals(this.key,this.value)}negate(){return p.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=h;class p{constructor(o,A){this.key=o,this.value=A,this.type=14}static create(o,A){return new p(o,A)}cmp(o){return o.type!==this.type?this.type-o.type:D(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return parseFloat(o.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(o){return o.mapSmaller(this.key,this.value)}negate(){return h.create(this.key,this.value)}}e.ContextKeySmallerExpr=p;class t{constructor(o,A){this.key=o,this.value=A,this.type=15}static create(o,A){return new t(o,A)}cmp(o){return o.type!==this.type?this.type-o.type:D(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return parseFloat(o.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(o){return o.mapSmallerEquals(this.key,this.value)}negate(){return a.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class r{constructor(o,A){this.key=o,this.regexp=A,this.type=7}static create(o,A){return new r(o,A)}cmp(o){if(o.type!==this.type)return this.type-o.type;if(this.key<o.key)return-1;if(this.key>o.key)return 1;const A=this.regexp?this.regexp.source:"",L=o.regexp?o.regexp.source:"";return A<L?-1:A>L?1:0}equals(o){if(o.type===this.type){const A=this.regexp?this.regexp.source:"",L=o.regexp?o.regexp.source:"";return this.key===o.key&&A===L}return!1}evaluate(o){let A=o.getValue(this.key);return this.regexp?this.regexp.test(A):!1}serialize(){const o=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${o}`}keys(){return[this.key]}map(o){return o.mapRegex(this.key,this.regexp)}negate(){return s.create(this)}}e.ContextKeyRegexExpr=r;class s{constructor(o){this._actual=o,this.type=8}static create(o){return new s(o)}cmp(o){return o.type!==this.type?this.type-o.type:this._actual.cmp(o._actual)}equals(o){return o.type===this.type?this._actual.equals(o._actual):!1}evaluate(o){return!this._actual.evaluate(o)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(o){return new s(this._actual.map(o))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=s;class i{constructor(o){this.expr=o,this.type=6}static create(o){return i._normalizeArr(o)}cmp(o){if(o.type!==this.type)return this.type-o.type;if(this.expr.length<o.expr.length)return-1;if(this.expr.length>o.expr.length)return 1;for(let A=0,L=this.expr.length;A<L;A++){const B=n(this.expr[A],o.expr[A]);if(B!==0)return B}return 0}equals(o){if(o.type===this.type){if(this.expr.length!==o.expr.length)return!1;for(let A=0,L=this.expr.length;A<L;A++)if(!this.expr[A].equals(o.expr[A]))return!1;return!0}return!1}evaluate(o){for(let A=0,L=this.expr.length;A<L;A++)if(!this.expr[A].evaluate(o))return!1;return!0}static _normalizeArr(o){const A=[];let L=!1;for(const B of o)if(!!B){if(B.type===1){L=!0;continue}if(B.type===0)return I.INSTANCE;if(B.type===6){A.push(...B.expr);continue}A.push(B)}if(A.length===0&&L)return l.INSTANCE;if(A.length!==0){if(A.length===1)return A[0];for(A.sort(n);A.length>1;){const B=A[A.length-1];if(B.type!==9)break;A.pop();const oe=A.pop(),he=u.create(B.expr.map(Q=>i.create([Q,oe])));he&&(A.push(he),A.sort(n))}return A.length===1?A[0]:new i(A)}}serialize(){return this.expr.map(o=>o.serialize()).join(" && ")}keys(){const o=[];for(let A of this.expr)o.push(...A.keys());return o}map(o){return new i(this.expr.map(A=>A.map(o)))}negate(){let o=[];for(let A of this.expr)o.push(A.negate());return u.create(o)}}e.ContextKeyAndExpr=i;class u{constructor(o){this.expr=o,this.type=9}static create(o){const A=u._normalizeArr(o);if(A.length!==0)return A.length===1?A[0]:new u(A)}cmp(o){if(o.type!==this.type)return this.type-o.type;if(this.expr.length<o.expr.length)return-1;if(this.expr.length>o.expr.length)return 1;for(let A=0,L=this.expr.length;A<L;A++){const B=n(this.expr[A],o.expr[A]);if(B!==0)return B}return 0}equals(o){if(o.type===this.type){if(this.expr.length!==o.expr.length)return!1;for(let A=0,L=this.expr.length;A<L;A++)if(!this.expr[A].equals(o.expr[A]))return!1;return!0}return!1}evaluate(o){for(let A=0,L=this.expr.length;A<L;A++)if(this.expr[A].evaluate(o))return!0;return!1}static _normalizeArr(o){let A=[],L=!1;if(o){for(let B=0,oe=o.length;B<oe;B++){const he=o[B];if(!!he){if(he.type===0){L=!0;continue}if(he.type===1)return[l.INSTANCE];if(he.type===9){A=A.concat(he.expr);continue}A.push(he)}}if(A.length===0&&L)return[I.INSTANCE];A.sort(n)}return A}serialize(){return this.expr.map(o=>o.serialize()).join(" || ")}keys(){const o=[];for(let A of this.expr)o.push(...A.keys());return o}map(o){return new u(this.expr.map(A=>A.map(o)))}negate(){let o=[];for(let L of this.expr)o.push(L.negate());const A=L=>L.type===9?L.expr:[L];for(;o.length>1;){const L=o.shift(),B=o.shift(),oe=[];for(const he of A(L))for(const Q of A(B))oe.push(k.and(he,Q));o.unshift(k.or(...oe))}return o[0]}}e.ContextKeyOrExpr=u;class f extends d{constructor(o,A,L){super(o);this._defaultValue=A,typeof L=="object"?f._info.push({...L,key:o}):L!==!0&&f._info.push({key:o,description:L,type:A!=null?typeof A:void 0})}static all(){return f._info.values()}bindTo(o){return o.createKey(this.key,this._defaultValue)}getValue(o){return o.getContextKeyValue(this.key)}toNegated(){return k.not(this.key)}isEqualTo(o){return k.equals(this.key,o)}notEqualsTo(o){return k.notEquals(this.key,o)}}e.RawContextKey=f,f._info=[],e.IContextKeyService=(0,F.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function v(T,o){return T<o?-1:T>o?1:0}function D(T,o,A,L){return T<A?-1:T>A?1:o<L?-1:o>L?1:0}}),define(be[151],Ee([0,1,4]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,g.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,g.refineServiceDecorator)(e.IEnvironmentService)}),define(be[26],Ee([0,1,8,4]),function(ee,e,g,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function S(n){if(typeof n=="object"&&n!==null&&n.supported!==!0)return n.description}e.getWorkspaceSupportTypeMessage=S;function _(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=_,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var C;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(C=e.ExtensionType||(e.ExtensionType={}));class y{constructor(I){this.value=I,this._lower=I.toLowerCase()}static equals(I,l){if(typeof I=="undefined"||I===null)return typeof l=="undefined"||l===null;if(typeof l=="undefined"||l===null)return!1;if(typeof I=="string"||typeof l=="string"){let d=typeof I=="string"?I:I.value,c=typeof l=="string"?l:l.value;return g.equalsIgnoreCase(d,c)}return I._lower===l._lower}static toKey(I){return typeof I=="string"?I.toLowerCase():I._lower}}e.ExtensionIdentifier=y;function b(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=b;function k(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=k,e.IBuiltinExtensionsScannerService=(0,F.createDecorator)("IBuiltinExtensionsScannerService")}),define(be[152],Ee([0,1,8,26]),function(ee,e,g,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function S(c,m){return c.uuid&&m.uuid?c.uuid===m.uuid:c.id===m.id?!0:(0,g.compareIgnoreCase)(c.id,m.id)===0}e.areSameExtensions=S;class _{constructor(m,E){this.version=E,this.id=m.id,this.uuid=m.uuid}key(){return`${this.id}-${this.version}`}equals(m){return m instanceof _?S(this,m)&&this.version===m.version:!1}}e.ExtensionIdentifierWithVersion=_;function C(c,m){return`${c}.${m}`}e.getExtensionId=C;function y(c){return c.toLocaleLowerCase()}e.adoptToGalleryExtensionId=y;function b(c,m){return y(C(c,m))}e.getGalleryExtensionId=b;function k(c,m){const E=[],w=P=>{for(const a of E)if(a.some(h=>S(m(h),m(P))))return a;return null};for(const P of c){const a=w(P);a?a.push(P):E.push([P])}return E}e.groupByExtension=k;function n(c){return{id:c.identifier.id,name:c.manifest.name,galleryId:null,publisherId:c.publisherId,publisherName:c.manifest.publisher,publisherDisplayName:c.publisherDisplayName,dependencies:c.manifest.extensionDependencies&&c.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=n;function I(c){return{id:c.identifier.id,name:c.name,galleryId:c.identifier.uuid,publisherId:c.publisherId,publisherName:c.publisher,publisherDisplayName:c.publisherDisplayName,dependencies:!!(c.properties.dependencies&&c.properties.dependencies.length>0),...c.telemetryData}}e.getGalleryExtensionTelemetryData=I,e.BetterMergeId=new F.ExtensionIdentifier("pprice.better-merge");function l(c){const m=new Set;for(const E of c)E.malicious&&m.add(E.id.id);return m}e.getMaliciousExtensionsSet=l;function d(c,m){const E=[],w=m.manifest.extensionDependencies?.slice(0)??[];for(;w.length;){const P=w.shift();if(P&&E.every(a=>!S(a.identifier,{id:P}))){const a=c.filter(h=>S(h.identifier,{id:P}));a.length===1&&(E.push(a[0]),w.push(...a[0].manifest.extensionDependencies?.slice(0)??[]))}}return E}e.getExtensionDependencies=d}),define(be[61],Ee([0,1,130,14,2,4,8,10,21]),function(ee,e,g,F,S,_,C,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,_.createDecorator)("fileService");function k(z){return z.create===!0}e.isFileOpenForWriteOptions=k;var n;(function(z){z[z.Unknown=0]="Unknown",z[z.File=1]="File",z[z.Directory=2]="Directory",z[z.SymbolicLink=64]="SymbolicLink"})(n=e.FileType||(e.FileType={}));var I;(function(z){z[z.Readonly=1]="Readonly"})(I=e.FilePermission||(e.FilePermission={}));var l;(function(z){z[z.FileReadWrite=2]="FileReadWrite",z[z.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",z[z.FileReadStream=16]="FileReadStream",z[z.FileFolderCopy=8]="FileFolderCopy",z[z.PathCaseSensitive=1024]="PathCaseSensitive",z[z.Readonly=2048]="Readonly",z[z.Trash=4096]="Trash",z[z.FileWriteUnlock=8192]="FileWriteUnlock"})(l=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function d(z){return!!(z.capabilities&2)}e.hasReadWriteCapability=d;function c(z){return!!(z.capabilities&8)}e.hasFileFolderCopyCapability=c;function m(z){return!!(z.capabilities&4)}e.hasOpenReadWriteCloseCapability=m;function E(z){return!!(z.capabilities&16)}e.hasFileReadStreamCapability=E;var w;(function(z){z.FileExists="EntryExists",z.FileNotFound="EntryNotFound",z.FileNotADirectory="EntryNotADirectory",z.FileIsADirectory="EntryIsADirectory",z.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",z.FileTooLarge="EntryTooLarge",z.FileWriteLocked="EntryWriteLocked",z.NoPermissions="NoPermissions",z.Unavailable="Unavailable",z.Unknown="Unknown"})(w=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class P extends Error{constructor(V,R){super(V);this.code=R}}e.FileSystemProviderError=P;function a(z,V){const R=new P(z.toString(),V);return p(R,V),R}e.createFileSystemProviderError=a;function h(z){return z||a((0,g.localize)(0,null),w.Unknown)}e.ensureFileSystemProviderError=h;function p(z,V){return z.name=V?`${V} (FileSystemError)`:"FileSystemError",z}e.markAsFileSystemProviderError=p;function t(z){if(!z)return w.Unknown;if(z instanceof P)return z.code;const V=/^(.+) \(FileSystemError\)$/.exec(z.name);if(!V)return w.Unknown;switch(V[1]){case w.FileExists:return w.FileExists;case w.FileIsADirectory:return w.FileIsADirectory;case w.FileNotADirectory:return w.FileNotADirectory;case w.FileNotFound:return w.FileNotFound;case w.FileExceedsMemoryLimit:return w.FileExceedsMemoryLimit;case w.FileTooLarge:return w.FileTooLarge;case w.FileWriteLocked:return w.FileWriteLocked;case w.NoPermissions:return w.NoPermissions;case w.Unavailable:return w.Unavailable}return w.Unknown}e.toFileSystemProviderErrorCode=t;function r(z){if(z instanceof D)return z.fileOperationResult;switch(t(z)){case w.FileNotFound:return 1;case w.FileIsADirectory:return 0;case w.FileNotADirectory:return 10;case w.FileWriteLocked:return 5;case w.NoPermissions:return 6;case w.FileExists:return 4;case w.FileExceedsMemoryLimit:return 9;case w.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var s;(function(z){z[z.CREATE=0]="CREATE",z[z.DELETE=1]="DELETE",z[z.MOVE=2]="MOVE",z[z.COPY=3]="COPY"})(s=e.FileOperation||(e.FileOperation={}));class i{constructor(V,R,K){this.resource=V,this.operation=R,this.target=K}isOperation(V){return this.operation===V}}e.FileOperationEvent=i;var u;(function(z){z[z.UPDATED=0]="UPDATED",z[z.ADDED=1]="ADDED",z[z.DELETED=2]="DELETED"})(u=e.FileChangeType||(e.FileChangeType={}));class f{constructor(V,R){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const K of V)switch(K.type){case 1:this.added||(this.added=b.TernarySearchTree.forUris(()=>R)),this.added.set(K.resource,K);break;case 0:this.updated||(this.updated=b.TernarySearchTree.forUris(()=>R)),this.updated.set(K.resource,K);break;case 2:this.deleted||(this.deleted=b.TernarySearchTree.forUris(()=>R)),this.deleted.set(K.resource,K);break}}contains(V,...R){return this.doContains(V,{includeChildren:!1},...R)}affects(V,...R){return this.doContains(V,{includeChildren:!0},...R)}doContains(V,R,...K){if(!V)return!1;const x=K.length>0;return!!((!x||K.includes(1))&&(this.added?.get(V)||R.includeChildren&&this.added?.findSuperstr(V))||(!x||K.includes(0))&&(this.updated?.get(V)||R.includeChildren&&this.updated?.findSuperstr(V))||(!x||K.includes(2))&&(this.deleted?.findSubstr(V)||R.includeChildren&&this.deleted?.findSuperstr(V)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=f;function v(z,V,R){return!z||!V||z===V||V.length>z.length?!1:(V.charAt(V.length-1)!==F.sep&&(V+=F.sep),R?(0,C.startsWithIgnoreCase)(z,V):z.indexOf(V)===0)}e.isParent=v;class D extends Error{constructor(V,R,K){super(V);this.fileOperationResult=R,this.options=K}}e.FileOperationError=D;class T extends D{constructor(V,R,K){super(V,2,K);this.stat=R}}e.NotModifiedSinceFileOperationError=T;var o;(function(z){z[z.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",z[z.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",z[z.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",z[z.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",z[z.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",z[z.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",z[z.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",z[z.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",z[z.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",z[z.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",z[z.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",z[z.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(o=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var A;(function(z){z[z.FILE=0]="FILE",z[z.FOLDER=1]="FOLDER",z[z.ROOT_FOLDER=2]="ROOT_FOLDER"})(A=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function L(z){if(!(typeof z.size!="number"||typeof z.mtime!="number"))return z.mtime.toString(29)+z.size.toString(31)}e.etag=L;async function B(z,V){if(!V.canHandleResource(S.URI.from({scheme:z.scheme})))return new Promise(R=>{const K=V.onDidChangeFileSystemProviderRegistrations(x=>{x.scheme===z.scheme&&x.added&&(K.dispose(),R())})})}e.whenProviderRegistered=B,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class oe{static formatSize(V){return(0,y.isNumber)(V)||(V=0),V<oe.KB?(0,g.localize)(1,null,V.toFixed(0)):V<oe.MB?(0,g.localize)(2,null,(V/oe.KB).toFixed(2)):V<oe.GB?(0,g.localize)(3,null,(V/oe.MB).toFixed(2)):V<oe.TB?(0,g.localize)(4,null,(V/oe.GB).toFixed(2)):(0,g.localize)(5,null,(V/oe.TB).toFixed(2))}}e.ByteSize=oe,oe.KB=1024,oe.MB=oe.KB*oe.KB,oe.GB=oe.MB*oe.KB,oe.TB=oe.GB*oe.KB;var he;(function(z){z[z.IA32=0]="IA32",z[z.OTHER=1]="OTHER"})(he=e.Arch||(e.Arch={}));function Q(z){return{maxFileSize:z===0?300*oe.MB:16*oe.GB,maxHeapSize:z===0?700*oe.MB:2*700*oe.MB}}e.getPlatformLimits=Q}),define(be[62],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class g{constructor(...S){this._entries=new Map;for(let[_,C]of S)this.set(_,C)}set(S,_){const C=this._entries.get(S);return this._entries.set(S,_),C}has(S){return this._entries.has(S)}get(S){return this._entries.get(S)}}e.ServiceCollection=g}),define(be[153],Ee([0,1,12,148,91,4,62,16]),function(ee,e,g,F,S,_,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const b=!1;class k extends Error{constructor(c){super("cyclic dependency between services");this.message=c.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${c.toString()}`}}class n{constructor(c=new C.ServiceCollection,m=!1,E){this._activeInstantiations=new Set,this._services=c,this._strict=m,this._parent=E,this._services.set(_.IInstantiationService,this)}createChild(c){return new n(c,this._strict,this)}invokeFunction(c,...m){let E=l.traceInvocation(c),w=!1;try{return c({get:(a,h)=>{if(w)throw(0,g.illegalState)("service accessor is only valid during the invocation of its target method");const p=this._getOrCreateServiceInstance(a,E);if(!p&&h!==_.optional)throw new Error(`[invokeFunction] unknown service '${a}'`);return p}},...m)}finally{w=!0,E.stop()}}createInstance(c,...m){let E,w;return c instanceof S.SyncDescriptor?(E=l.traceCreation(c.ctor),w=this._createInstance(c.ctor,c.staticArguments.concat(m),E)):(E=l.traceCreation(c),w=this._createInstance(c,m,E)),E.stop(),w}_createInstance(c,m=[],E){let w=_._util.getServiceDependencies(c).sort((h,p)=>h.index-p.index),P=[];for(const h of w){let p=this._getOrCreateServiceInstance(h.id,E);if(!p&&this._strict&&!h.optional)throw new Error(`[createInstance] ${c.name} depends on UNKNOWN service ${h.id}.`);P.push(p)}let a=w.length>0?w[0].index:m.length;if(m.length!==a){console.warn(`[createInstance] First service dependency of ${c.name} at position ${a+1} conflicts with ${m.length} static arguments`);let h=a-m.length;h>0?m=m.concat(new Array(h)):m=m.slice(0,a)}return new c(...[...m,...P])}_setServiceInstance(c,m){if(this._services.get(c)instanceof S.SyncDescriptor)this._services.set(c,m);else if(this._parent)this._parent._setServiceInstance(c,m);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(c){let m=this._services.get(c);return!m&&this._parent?this._parent._getServiceInstanceOrDescriptor(c):m}_getOrCreateServiceInstance(c,m){let E=this._getServiceInstanceOrDescriptor(c);return E instanceof S.SyncDescriptor?this._safeCreateAndCacheServiceInstance(c,E,m.branch(c,!0)):(m.branch(c,!1),E)}_safeCreateAndCacheServiceInstance(c,m,E){if(this._activeInstantiations.has(c))throw new Error(`illegal state - RECURSIVELY instantiating service '${c}'`);this._activeInstantiations.add(c);try{return this._createAndCacheServiceInstance(c,m,E)}finally{this._activeInstantiations.delete(c)}}_createAndCacheServiceInstance(c,m,E){const w=new F.Graph(h=>h.id.toString());let P=0;const a=[{id:c,desc:m,_trace:E}];for(;a.length;){const h=a.pop();if(w.lookupOrInsertNode(h),P++>1e3)throw new k(w);for(let p of _._util.getServiceDependencies(h.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(p.id);if(!t&&!p.optional&&console.warn(`[createInstance] ${c} depends on ${p.id} which is NOT registered.`),t instanceof S.SyncDescriptor){const r={id:p.id,desc:t,_trace:h._trace.branch(p.id,!0)};w.insertEdge(h,r),a.push(r)}}}for(;;){const h=w.roots();if(h.length===0){if(!w.isEmpty())throw new k(w);break}for(const{data:p}of h){if(this._getServiceInstanceOrDescriptor(p.id)instanceof S.SyncDescriptor){const r=this._createServiceInstanceWithOwner(p.id,p.desc.ctor,p.desc.staticArguments,p.desc.supportsDelayedInstantiation,p._trace);this._setServiceInstance(p.id,r)}w.removeNode(p)}}return this._getServiceInstanceOrDescriptor(c)}_createServiceInstanceWithOwner(c,m,E=[],w,P){if(this._services.get(c)instanceof S.SyncDescriptor)return this._createServiceInstance(m,E,w,P);if(this._parent)return this._parent._createServiceInstanceWithOwner(c,m,E,w,P);throw new Error(`illegalState - creating UNKNOWN service instance ${m.name}`)}_createServiceInstance(c,m=[],E,w){if(E){const P=new y.IdleValue(()=>this._createInstance(c,m,w));return new Proxy(Object.create(null),{get(a,h){if(h in a)return a[h];let p=P.value,t=p[h];return typeof t!="function"||(t=t.bind(p),a[h]=t),t},set(a,h,p){return P.value[h]=p,!0}})}else return this._createInstance(c,m,w)}}e.InstantiationService=n;var I;(function(d){d[d.Creation=0]="Creation",d[d.Invocation=1]="Invocation",d[d.Branch=2]="Branch"})(I||(I={}));class l{constructor(c,m){this.type=c,this.name=m,this._start=Date.now(),this._dep=[]}static traceInvocation(c){return b?new l(1,c.name||c.toString().substring(0,42).replace(/\n/g,"")):l._None}static traceCreation(c){return b?new l(0,c.name):l._None}branch(c,m){let E=new l(2,c.toString());return this._dep.push([c,m,E]),E}stop(){let c=Date.now()-this._start;l._totals+=c;let m=!1;function E(P,a){let h=[],p=new Array(P+1).join("	");for(const[t,r,s]of a._dep)if(r&&s){m=!0,h.push(`${p}CREATES -> ${t}`);let i=E(P+1,s);i&&h.push(i)}else h.push(`${p}uses -> ${t}`);return h.join(`
`)}let w=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${E(1,this)}`,`DONE, took ${c.toFixed(2)}ms (grand total ${l._totals.toFixed(2)}ms)`];(c>2||m)&&console.log(w.join(`
`))}}l._None=new class extends l{constructor(){super(-1,null)}stop(){}branch(){return this}},l._totals=0}),define(be[15],Ee([0,1,4,6,22,3,58]),function(ee,e,g,F,S,_,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,g.createDecorator)("logService"),e.ILoggerService=(0,g.createDecorator)("loggerService");function y(){return new Date().toISOString()}var b;(function(p){p[p.Trace=0]="Trace",p[p.Debug=1]="Debug",p[p.Info=2]="Info",p[p.Warning=3]="Warning",p[p.Error=4]="Error",p[p.Critical=5]="Critical",p[p.Off=6]="Off"})(b=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=b.Info;class k extends F.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new _.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=k;class n extends k{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...r){this.checkLogLevel(b.Trace)&&this.log(b.Trace,this.format([t,...r]))}debug(t,...r){this.checkLogLevel(b.Debug)&&this.log(b.Debug,this.format([t,...r]))}info(t,...r){this.checkLogLevel(b.Info)&&this.log(b.Info,this.format([t,...r]))}warn(t,...r){this.checkLogLevel(b.Warning)&&this.log(b.Warning,this.format([t,...r]))}error(t,...r){if(this.checkLogLevel(b.Error))if(t instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=t.stack,this.log(b.Error,this.format(s))}else this.log(b.Error,this.format([t,...r]))}critical(t,...r){this.checkLogLevel(b.Critical)&&this.log(b.Critical,this.format([t,...r]))}flush(){}format(t){let r="";for(let s=0;s<t.length;s++){let i=t[s];if(typeof i=="object")try{i=JSON.stringify(i)}catch(u){}r+=(s>0?" ":"")+i}return r}}e.AbstractMessageLogger=n;class I extends k{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!S.isWindows}trace(t,...r){this.getLevel()<=b.Trace&&(this.useColors?console.log(`[90m[main ${y()}][0m`,t,...r):console.log(`[main ${y()}]`,t,...r))}debug(t,...r){this.getLevel()<=b.Debug&&(this.useColors?console.log(`[90m[main ${y()}][0m`,t,...r):console.log(`[main ${y()}]`,t,...r))}info(t,...r){this.getLevel()<=b.Info&&(this.useColors?console.log(`[90m[main ${y()}][0m`,t,...r):console.log(`[main ${y()}]`,t,...r))}warn(t,...r){this.getLevel()<=b.Warning&&(this.useColors?console.warn(`[93m[main ${y()}][0m`,t,...r):console.warn(`[main ${y()}]`,t,...r))}error(t,...r){this.getLevel()<=b.Error&&(this.useColors?console.error(`[91m[main ${y()}][0m`,t,...r):console.error(`[main ${y()}]`,t,...r))}critical(t,...r){this.getLevel()<=b.Critical&&(this.useColors?console.error(`[90m[main ${y()}][0m`,t,...r):console.error(`[main ${y()}]`,t,...r))}dispose(){}flush(){}}e.ConsoleMainLogger=I;class l extends k{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...r){this.getLevel()<=b.Trace&&console.log("%cTRACE","color: #888",t,...r)}debug(t,...r){this.getLevel()<=b.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...r)}info(t,...r){this.getLevel()<=b.Info&&console.log("%c INFO","color: #33f",t,...r)}warn(t,...r){this.getLevel()<=b.Warning&&console.log("%c WARN","color: #993",t,...r)}error(t,...r){this.getLevel()<=b.Error&&console.log("%c  ERR","color: #f33",t,...r)}critical(t,...r){this.getLevel()<=b.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...r)}dispose(){}flush(){}}e.ConsoleLogger=l;class d extends k{constructor(t,r=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(r)}trace(t,...r){this.getLevel()<=b.Trace&&this.adapter.log(b.Trace,[this.extractMessage(t),...r])}debug(t,...r){this.getLevel()<=b.Debug&&this.adapter.log(b.Debug,[this.extractMessage(t),...r])}info(t,...r){this.getLevel()<=b.Info&&this.adapter.log(b.Info,[this.extractMessage(t),...r])}warn(t,...r){this.getLevel()<=b.Warning&&this.adapter.log(b.Warning,[this.extractMessage(t),...r])}error(t,...r){this.getLevel()<=b.Error&&this.adapter.log(b.Error,[this.extractMessage(t),...r])}critical(t,...r){this.getLevel()<=b.Critical&&this.adapter.log(b.Critical,[this.extractMessage(t),...r])}extractMessage(t){return typeof t=="string"?t:(0,C.toErrorMessage)(t,this.getLevel()<=b.Trace)}dispose(){}flush(){}}e.AdapterLogger=d;class c extends k{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const r of this.logServices)r.setLevel(t);super.setLevel(t)}trace(t,...r){for(const s of this.logServices)s.trace(t,...r)}debug(t,...r){for(const s of this.logServices)s.debug(t,...r)}info(t,...r){for(const s of this.logServices)s.info(t,...r)}warn(t,...r){for(const s of this.logServices)s.warn(t,...r)}error(t,...r){for(const s of this.logServices)s.error(t,...r)}critical(t,...r){for(const s of this.logServices)s.critical(t,...r)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=c;class m extends F.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...r){this.logger.trace(t,...r)}debug(t,...r){this.logger.debug(t,...r)}info(t,...r){this.logger.info(t,...r)}warn(t,...r){this.logger.warn(t,...r)}error(t,...r){this.logger.error(t,...r)}critical(t,...r){this.logger.critical(t,...r)}flush(){this.logger.flush()}}e.LogService=m;class E extends F.Disposable{constructor(t,r){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(r(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(i=>i.setLevel(s))}))}getLogger(t){return this.loggers.get(t.toString())}createLogger(t,r){let s=this.loggers.get(t.toString());return s||(s=this.doCreateLogger(t,r?.always?b.Trace:this.logLevel,r),this.loggers.set(t.toString(),s),r?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=E;class w{constructor(){this.onDidChangeLogLevel=new _.Emitter().event}setLevel(t){}getLevel(){return b.Info}trace(t,...r){}debug(t,...r){}info(t,...r){}warn(t,...r){}error(t,...r){}critical(t,...r){}dispose(){}flush(){}}e.NullLogService=w;function P(p){if(p.verbose)return b.Trace;if(typeof p.logLevel=="string"){const t=a(p.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=P;function a(p){switch(p){case"trace":return b.Trace;case"debug":return b.Debug;case"info":return b.Info;case"warn":return b.Warning;case"error":return b.Error;case"critical":return b.Critical;case"off":return b.Off}}e.parseLogLevel=a;function h(p){switch(p){case b.Trace:return"trace";case b.Debug:return"debug";case b.Info:return"info";case b.Warning:return"warn";case b.Error:return"error";case b.Critical:return"critical";case b.Off:return"off"}}e.LogLevelToString=h}),define(be[92],Ee([0,1,4,131,43]),function(ee,e,g,F,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var _;(function(b){b[b.Unnecessary=1]="Unnecessary",b[b.Deprecated=2]="Deprecated"})(_=e.MarkerTag||(e.MarkerTag={}));var C;(function(b){b[b.Hint=1]="Hint",b[b.Info=2]="Info",b[b.Warning=4]="Warning",b[b.Error=8]="Error"})(C=e.MarkerSeverity||(e.MarkerSeverity={})),function(b){function k(c,m){return m-c}b.compare=k;const n=Object.create(null);n[b.Error]=(0,F.localize)(0,null),n[b.Warning]=(0,F.localize)(1,null),n[b.Info]=(0,F.localize)(2,null);function I(c){return n[c]||""}b.toString=I;function l(c){switch(c){case S.default.Error:return b.Error;case S.default.Warning:return b.Warning;case S.default.Info:return b.Info;case S.default.Ignore:return b.Hint}}b.fromSeverity=l;function d(c){switch(c){case b.Error:return S.default.Error;case b.Warning:return S.default.Warning;case b.Info:return S.default.Info;case b.Hint:return S.default.Ignore}}b.toSeverity=d}(C=e.MarkerSeverity||(e.MarkerSeverity={}));var y;(function(b){const k="";function n(l){return I(l,!0)}b.makeKey=n;function I(l,d){let c=[k];return l.source?c.push(l.source.replace("\xA6","\\\xA6")):c.push(k),l.code?typeof l.code=="string"?c.push(l.code.replace("\xA6","\\\xA6")):c.push(l.code.value.replace("\xA6","\\\xA6")):c.push(k),l.severity!==void 0&&l.severity!==null?c.push(C.toString(l.severity)):c.push(k),l.message&&d?c.push(l.message.replace("\xA6","\\\xA6")):c.push(k),l.startLineNumber!==void 0&&l.startLineNumber!==null?c.push(l.startLineNumber.toString()):c.push(k),l.startColumn!==void 0&&l.startColumn!==null?c.push(l.startColumn.toString()):c.push(k),l.endLineNumber!==void 0&&l.endLineNumber!==null?c.push(l.endLineNumber.toString()):c.push(k),l.endColumn!==void 0&&l.endColumn!==null?c.push(l.endColumn.toString()):c.push(k),c.push(k),c.join("\xA6")}b.makeKeyOptionalMessage=I})(y=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,g.createDecorator)("markerService")}),define(be[154],Ee([0,1,43,4,3]),function(ee,e,g,F,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=g.default,e.INotificationService=(0,F.createDecorator)("notificationService");var _;(function(k){k[k.WORKSPACE=0]="WORKSPACE",k[k.GLOBAL=1]="GLOBAL"})(_=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var C;(function(k){k[k.OFF=0]="OFF",k[k.SILENT=1]="SILENT",k[k.ERROR=2]="ERROR"})(C=e.NotificationsFilter||(e.NotificationsFilter={}));class y{constructor(){this.progress=new b,this.onDidClose=S.Event.None,this.onDidChangeVisibility=S.Event.None}updateSeverity(n){}updateMessage(n){}updateActions(n){}close(){}}e.NoOpNotification=y;class b{infinite(){}done(){}total(n){}worked(n){}}e.NoOpProgress=b}),define(be[155],Ee([0,1,6,8,2,4]),function(ee,e,g,F,S,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,_.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return g.Disposable.None},registerValidator(){return g.Disposable.None},registerExternalUriResolver(){return g.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return g.Disposable.None},async open(){return!1},async resolveExternalUri(y){return{resolved:y,dispose(){}}}});function C(y,b){return S.URI.isUri(y)?(0,F.equalsIgnoreCase)(y.scheme,b):(0,F.startsWithIgnoreCase)(y,b+":")}e.matchesScheme=C});var ze=this&&this.__decorate||function(ee,e,g,F){var S=arguments.length,_=S<3?e:F===null?F=Object.getOwnPropertyDescriptor(e,g):F,C;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")_=Reflect.decorate(ee,e,g,F);else for(var y=ee.length-1;y>=0;y--)(C=ee[y])&&(_=(S<3?C(_):S>3?C(e,g,_):C(e,g))||_);return S>3&&_&&Object.defineProperty(e,g,_),_},qe=this&&this.__param||function(ee,e){return function(g,F){e(g,F,ee)}};define(be[156],Ee([0,1,4,20,6,16]),function(ee,e,g,F,S,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,g.createDecorator)("progressService");var C;(function(n){n[n.Explorer=1]="Explorer",n[n.Scm=3]="Scm",n[n.Extensions=5]="Extensions",n[n.Window=10]="Window",n[n.Notification=15]="Notification",n[n.Dialog=20]="Dialog"})(C=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class y{constructor(I){this.callback=I}get value(){return this._value}report(I){this._value=I,this.callback(this._value)}}e.Progress=y,y.None=Object.freeze({report(){}});let b=class extends S.Disposable{constructor(I,l){super();this.deferred=new _.DeferredPromise,l.withProgress(I,d=>(this.reporter=d,this.lastStep&&d.report(this.lastStep),this.deferred.p)),this._register((0,S.toDisposable)(()=>this.deferred.complete()))}report(I){this.reporter?this.reporter.report(I):this.lastStep=I}};b=ze([qe(1,e.IProgressService)],b),e.UnmanagedProgress=b;class k extends S.Disposable{constructor(I){super();this.progressIndicator=I,this.currentOperationId=0,this.currentOperationDisposables=this._register(new S.DisposableStore)}start(I){this.stop();const l=++this.currentOperationId,d=new F.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{l===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},I),this.currentOperationDisposables.add((0,S.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,S.toDisposable)(()=>d.cancel())),this.currentOperationDisposables.add((0,S.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:l,token:d.token,stop:()=>this.doStop(l),isCurrent:()=>this.currentOperationId===l}}stop(){this.doStop(this.currentOperationId)}doStop(I){this.currentOperationId===I&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=k,e.IEditorProgressService=(0,g.createDecorator)("editorProgressService")}),define(be[28],Ee([0,1,10,40]),function(ee,e,g,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class S{constructor(){this.data=new Map}add(C,y){F.ok(g.isString(C)),F.ok(g.isObject(y)),F.ok(!this.data.has(C),"There is already an extension with this id"),this.data.set(C,y)}knows(C){return this.data.has(C)}as(C){return this.data.get(C)||null}}e.Registry=new S}),define(be[93],Ee([0,1,28,3]),function(ee,e,g,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function S(y){return y.length>0&&y.charAt(y.length-1)==="#"?y.substring(0,y.length-1):y}class _{constructor(){this._onDidChangeSchema=new F.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(b,k){this.schemasById[S(b)]=k,this._onDidChangeSchema.fire(b)}notifySchemaChanged(b){this._onDidChangeSchema.fire(b)}getSchemaContributions(){return{schemas:this.schemasById}}}const C=new _;g.Registry.add(e.Extensions.JSONContribution,C)}),define(be[63],Ee([0,1,128,3,28,10,93]),function(ee,e,g,F,S,_,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var y;(function(w){w.Multiline="multilineText",w.Singleline="singlelineText"})(y=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var b;(function(w){w[w.APPLICATION=1]="APPLICATION",w[w.MACHINE=2]="MACHINE",w[w.WINDOW=3]="WINDOW",w[w.RESOURCE=4]="RESOURCE",w[w.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",w[w.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(b=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const k=S.Registry.as(C.Extensions.JSONContribution);class n{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new F.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new F.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:g.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(P,a=!0){this.registerConfigurations([P],a)}registerConfigurations(P,a=!0){const h=[];P.forEach(p=>{h.push(...this.validateAndRegisterProperties(p,a,p.extensionInfo)),this.configurationContributors.push(p),this.registerJSONConfiguration(p)}),k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(h)}deregisterConfigurations(P){const a=[],h=p=>{if(p.properties)for(const t in p.properties)a.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,p.properties[t]);p.allOf&&p.allOf.forEach(t=>h(t))};for(const p of P){h(p);const t=this.configurationContributors.indexOf(p);t!==-1&&this.configurationContributors.splice(t,1)}k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}registerDefaultConfigurations(P){const a=[],h=[];for(const p of P)for(const t in p)if(a.push(t),e.OVERRIDE_PROPERTY_PATTERN.test(t)){this.defaultValues[t]={...this.defaultValues[t]||{},...p[t]};const r={type:"object",default:this.defaultValues[t],description:g.localize(1,null,t),$ref:e.resourceLanguageSettingsSchemaId};h.push(l(t)),this.configurationProperties[t]=r,this.defaultLanguageConfigurationOverridesNode.properties[t]=r}else{this.defaultValues[t]=p[t];const r=this.configurationProperties[t];r&&(this.updatePropertyDefaultValue(t,r),this.updateSchema(t,r))}this.registerOverrideIdentifiers(h),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}deregisterDefaultConfigurations(P){const a=[];for(const h of P)for(const p in h)if(a.push(p),delete this.defaultValues[p],e.OVERRIDE_PROPERTY_PATTERN.test(p))delete this.configurationProperties[p],delete this.defaultLanguageConfigurationOverridesNode.properties[p];else{const t=this.configurationProperties[p];t&&(this.updatePropertyDefaultValue(p,t),this.updateSchema(p,t))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}notifyConfigurationSchemaUpdated(...P){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(P){for(const a of P)this.overrideIdentifiers.add(a);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(P,a=!0,h,p=3){p=_.isUndefinedOrNull(P.scope)?p:P.scope;let t=[],r=P.properties;if(r)for(let i in r){if(a&&m(i)){delete r[i];continue}const u=r[i];if(this.updatePropertyDefaultValue(i,u),e.OVERRIDE_PROPERTY_PATTERN.test(i)?u.scope=void 0:(u.scope=_.isUndefinedOrNull(u.scope)?p:u.scope,u.restricted=_.isUndefinedOrNull(u.restricted)?!!h?.restrictedConfigurations?.includes(i):u.restricted),r[i].hasOwnProperty("included")&&!r[i].included){this.excludedConfigurationProperties[i]=r[i],delete r[i];continue}else this.configurationProperties[i]=r[i];!r[i].deprecationMessage&&r[i].markdownDeprecationMessage&&(r[i].deprecationMessage=r[i].markdownDeprecationMessage),t.push(i)}let s=P.allOf;if(s)for(let i of s)t.push(...this.validateAndRegisterProperties(i,a,h,p));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(P){const a=h=>{let p=h.properties;if(p)for(const r in p)this.updateSchema(r,p[r]);let t=h.allOf;t&&t.forEach(a)};a(P)}updateSchema(P,a){switch(e.allSettings.properties[P]=a,a.scope){case 1:e.applicationSettings.properties[P]=a;break;case 2:e.machineSettings.properties[P]=a;break;case 6:e.machineOverridableSettings.properties[P]=a;break;case 3:e.windowSettings.properties[P]=a;break;case 4:e.resourceSettings.properties[P]=a;break;case 5:e.resourceSettings.properties[P]=a,this.resourceLanguageSettingsSchema.properties[P]=a;break}}removeFromSchema(P,a){switch(delete e.allSettings.properties[P],a.scope){case 1:delete e.applicationSettings.properties[P];break;case 2:delete e.machineSettings.properties[P];break;case 6:delete e.machineOverridableSettings.properties[P];break;case 3:delete e.windowSettings.properties[P];break;case 4:case 5:delete e.resourceSettings.properties[P];break}}updateOverridePropertyPatternKey(){for(const P of this.overrideIdentifiers.values()){const a=`[${P}]`,h={type:"object",description:g.localize(2,null),errorMessage:g.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(a,h),e.allSettings.properties[a]=h,e.applicationSettings.properties[a]=h,e.machineSettings.properties[a]=h,e.machineOverridableSettings.properties[a]=h,e.windowSettings.properties[a]=h,e.resourceSettings.properties[a]=h}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(P,a){let h=this.defaultValues[P];_.isUndefined(h)&&(h=a.default),_.isUndefined(h)&&(h=d(a.type)),a.default=h}}const I="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(I);function l(w){return w.substring(1,w.length-1)}e.overrideIdentifierFromKey=l;function d(w){switch(Array.isArray(w)?w[0]:w){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const c=new n;S.Registry.add(e.Extensions.Configuration,c);function m(w){return w.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(w)?g.localize(5,null,w):c.getConfigurationProperties()[w]!==void 0?g.localize(6,null,w):null:g.localize(4,null)}e.validateProperty=m;function E(){const w=[],P=c.getConfigurationProperties();for(const a of Object.keys(P))w.push([a,P[a].scope]);return w.push(["launch",4]),w.push(["task",4]),w}e.getScopes=E}),define(be[94],Ee([0,1,23,10,2,28,4,63]),function(ee,e,g,F,S,_,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,C.createDecorator)("configurationService");function b(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof S.URI)}e.isConfigurationOverrides=b;var k;(function(r){r[r.USER=1]="USER",r[r.USER_LOCAL=2]="USER_LOCAL",r[r.USER_REMOTE=3]="USER_REMOTE",r[r.WORKSPACE=4]="WORKSPACE",r[r.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",r[r.DEFAULT=6]="DEFAULT",r[r.MEMORY=7]="MEMORY"})(k=e.ConfigurationTarget||(e.ConfigurationTarget={}));function n(r){switch(r){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=n;function I(r,s){const i=s?r?s.keys.filter(A=>r.keys.indexOf(A)===-1):[...s.keys]:[],u=r?s?r.keys.filter(A=>s.keys.indexOf(A)===-1):[...r.keys]:[],f=[];if(s&&r){for(const A of r.keys)if(s.keys.indexOf(A)!==-1){const L=w(r.contents,A),B=w(s.contents,A);g.equals(L,B)||f.push(A)}}const v=[],D=A=>{const L={};for(const B of A)for(const oe of B.identifiers)L[p(oe)]=B;return L},T=s?D(s.overrides):{},o=r?D(r.overrides):{};if(Object.keys(T).length)for(const A of i){const L=T[A];L&&v.push([(0,y.overrideIdentifierFromKey)(A),L.keys])}if(Object.keys(o).length)for(const A of u){const L=o[A];L&&v.push([(0,y.overrideIdentifierFromKey)(A),L.keys])}if(Object.keys(T).length&&Object.keys(o).length)for(const A of f){const L=o[A],B=T[A];if(L&&B){const oe=I({contents:L.contents,keys:L.keys,overrides:[]},{contents:B.contents,keys:B.keys,overrides:[]});v.push([(0,y.overrideIdentifierFromKey)(A),[...oe.added,...oe.removed,...oe.updated]])}}return{added:i,removed:u,updated:f,overrides:v}}e.compare=I;function l(r,s){const i=[];for(const u of Object.keys(r))if(y.OVERRIDE_PROPERTY_PATTERN.test(u)){const f={};for(const v in r[u])f[v]=r[u][v];i.push({identifiers:[(0,y.overrideIdentifierFromKey)(u).trim()],keys:Object.keys(f),contents:d(f,s)})}return i}e.toOverrides=l;function d(r,s){const i=Object.create(null);for(let u in r)c(i,u,r[u],s);return i}e.toValuesTree=d;function c(r,s,i,u){const f=s.split("."),v=f.pop();let D=r;for(let T=0;T<f.length;T++){let o=f[T],A=D[o];switch(typeof A){case"undefined":A=D[o]=Object.create(null);break;case"object":break;default:u(`Ignoring ${s} as ${f.slice(0,T+1).join(".")} is ${JSON.stringify(A)}`);return}D=A}if(typeof D=="object"&&D!==null)try{D[v]=i}catch(T){u(`Ignoring ${s} as ${f.join(".")} is ${JSON.stringify(D)}`)}else u(`Ignoring ${s} as ${f.join(".")} is ${JSON.stringify(D)}`)}e.addToValueTree=c;function m(r,s){const i=s.split(".");E(r,i)}e.removeFromValueTree=m;function E(r,s){const i=s.shift();if(s.length===0){delete r[i];return}if(Object.keys(r).indexOf(i)!==-1){const u=r[i];typeof u=="object"&&!Array.isArray(u)&&(E(u,s),Object.keys(u).length===0&&delete r[i])}}function w(r,s,i){function u(D,T){let o=D;for(const A of T){if(typeof o!="object"||o===null)return;o=o[A]}return o}const f=s.split("."),v=u(r,f);return typeof v=="undefined"?i:v}e.getConfigurationValue=w;function P(r,s,i){Object.keys(s).forEach(u=>{u!=="__proto__"&&(u in r?F.isObject(r[u])&&F.isObject(s[u])?P(r[u],s[u],i):i&&(r[u]=s[u]):r[u]=s[u])})}e.merge=P;function a(){const r=_.Registry.as(y.Extensions.Configuration).getConfigurationProperties();return Object.keys(r)}e.getConfigurationKeys=a;function h(){const r=Object.create(null),s=_.Registry.as(y.Extensions.Configuration).getConfigurationProperties();for(let i in s){let u=s[i].default;c(r,i,u,f=>console.error(`Conflict in default settings: ${f}`))}return r}e.getDefaultValues=h;function p(r){return`[${r}]`}e.keyFromOverrideIdentifier=p;function t(r,s,i){const u=r.inspect(s),f=r.inspect(i);return typeof u.userValue!="undefined"||typeof u.workspaceValue!="undefined"||typeof u.workspaceFolderValue!="undefined"?u.value:typeof f.userValue!="undefined"||typeof f.workspaceValue!="undefined"||typeof f.workspaceFolderValue!="undefined"?f.value:u.defaultValue}e.getMigratedSettingValue=t}),define(be[157],Ee([0,1,111,21,17,10,23,2,63,94,28,6,3]),function(ee,e,g,F,S,_,C,y,b,k,n,I,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class d{constructor(t={},r=[],s=[]){this._contents=t,this._keys=r,this._overrides=s,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,k.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,r){const s=this.getContentsForOverrideIdentifer(r);return s?t?(0,k.getConfigurationValue)(s,t):s:void 0}getKeysForOverrideIdentifier(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.keys;return[]}override(t){const r=this.getContentsForOverrideIdentifer(t);if(!r||typeof r!="object"||!Object.keys(r).length)return this;let s={};for(const i of S.distinct([...Object.keys(this.contents),...Object.keys(r)])){let u=this.contents[i],f=r[i];f&&(typeof u=="object"&&typeof f=="object"?(u=C.deepClone(u),this.mergeContents(u,f)):u=f),s[i]=u}return new d(s,this.keys,this.overrides)}merge(...t){const r=C.deepClone(this.contents),s=C.deepClone(this.overrides),i=[...this.keys];for(const u of t){this.mergeContents(r,u.contents);for(const f of u.overrides){const[v]=s.filter(D=>S.equals(D.identifiers,f.identifiers));v?this.mergeContents(v.contents,f.contents):s.push(C.deepClone(f))}for(const f of u.keys)i.indexOf(f)===-1&&i.push(f)}return new d(r,i,s)}freeze(){return this.isFrozen=!0,this}mergeContents(t,r){for(const s of Object.keys(r)){if(s in t&&_.isObject(t[s])&&_.isObject(r[s])){this.mergeContents(t[s],r[s]);continue}t[s]=C.deepClone(r[s])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?C.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,r){this.addKey(t),(0,k.addToValueTree)(this.contents,t,r,s=>{throw new Error(s)})}removeValue(t){this.removeKey(t)&&(0,k.removeFromValueTree)(this.contents,t)}addKey(t){let r=this.keys.length;for(let s=0;s<r;s++)t.indexOf(this.keys[s])===0&&(r=s);this.keys.splice(r,1,t)}removeKey(t){let r=this.keys.indexOf(t);return r!==-1?(this.keys.splice(r,1),!0):!1}}e.ConfigurationModel=d;class c extends d{constructor(){const t=(0,k.getDefaultValues)(),r=(0,k.getConfigurationKeys)(),s=[];for(const i of Object.keys(t))b.OVERRIDE_PROPERTY_PATTERN.test(i)&&s.push({identifiers:[(0,b.overrideIdentifierFromKey)(i).trim()],keys:Object.keys(t[i]),contents:(0,k.toValuesTree)(t[i],u=>console.error(`Conflict in default settings file: ${u}`))});super(t,r,s)}}e.DefaultConfigurationModel=c;class m{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new d}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,r){if(!_.isUndefinedOrNull(t)){const s=this.doParseContent(t);this.parseRaw(s,r)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,r){this._raw=t;const{contents:s,keys:i,overrides:u,restricted:f}=this.doParseRaw(t,r);this._configurationModel=new d(s,i,u),this._restrictedConfigurations=f||[]}doParseContent(t){let r={},s=null,i=[],u=[],f=[];function v(T){Array.isArray(i)?i.push(T):s&&(i[s]=T)}let D={onObjectBegin:()=>{let T={};v(T),u.push(i),i=T,s=null},onObjectProperty:T=>{s=T},onObjectEnd:()=>{i=u.pop()},onArrayBegin:()=>{let T=[];v(T),u.push(i),i=T,s=null},onArrayEnd:()=>{i=u.pop()},onLiteralValue:v,onError:(T,o,A)=>{f.push({error:T,offset:o,length:A})}};if(t)try{g.visit(t,D),r=i[0]||{}}catch(T){console.error(`Error while parsing settings file ${this._name}: ${T}`),this._parseErrors=[T]}return r}doParseRaw(t,r){const s=n.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),i=this.filter(t,s,!0,r);t=i.raw;const u=(0,k.toValuesTree)(t,D=>console.error(`Conflict in settings file ${this._name}: ${D}`)),f=Object.keys(t),v=(0,k.toOverrides)(t,D=>console.error(`Conflict in settings file ${this._name}: ${D}`));return{contents:u,keys:f,overrides:v,restricted:i.restricted}}filter(t,r,s,i){if(!i?.scopes&&!i?.skipRestricted)return{raw:t,restricted:[]};const u={},f=[];for(let v in t)if(b.OVERRIDE_PROPERTY_PATTERN.test(v)&&s){const D=this.filter(t[v],r,!1,i);u[v]=D.raw,f.push(...D.restricted)}else{const D=r[v],T=D?typeof D.scope!="undefined"?D.scope:3:void 0;D?.restricted&&f.push(v),(T===void 0||i.scopes===void 0||i.scopes.includes(T))&&(i.skipRestricted&&D?.restricted||(u[v]=t[v]))}return{raw:u,restricted:f}}}e.ConfigurationModelParser=m;class E extends I.Disposable{constructor(t,r,s,i){super();this.userSettingsResource=t,this.scopes=r,this.fileService=i,this._onDidChange=this._register(new l.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new m(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(l.Event.filter(this.fileService.onDidFilesChange,u=>u.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new d}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=E;class w{constructor(t,r,s=new d,i=new d,u=new F.ResourceMap,f=new d,v=new F.ResourceMap,D=!0){this._defaultConfiguration=t,this._localUserConfiguration=r,this._remoteUserConfiguration=s,this._workspaceConfiguration=i,this._folderConfigurations=u,this._memoryConfiguration=f,this._memoryConfigurationByResource=v,this._freeze=D,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new F.ResourceMap,this._userConfiguration=null}getValue(t,r,s){return this.getConsolidateConfigurationModel(r,s).getValue(t)}updateValue(t,r,s={}){let i;s.resource?(i=this._memoryConfigurationByResource.get(s.resource),i||(i=new d,this._memoryConfigurationByResource.set(s.resource,i))):i=this._memoryConfiguration,r===void 0?i.removeValue(t):i.setValue(t,r),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,r,s){const i=this.getConsolidateConfigurationModel(r,s),u=this.getFolderConfigurationModelForResource(r.resource,s),f=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,v=r.overrideIdentifier?this._defaultConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),D=r.overrideIdentifier?this.userConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),T=r.overrideIdentifier?this.localUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),o=r.overrideIdentifier?this.remoteUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),A=s?r.overrideIdentifier?this._workspaceConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,L=u?r.overrideIdentifier?u.freeze().override(r.overrideIdentifier).getValue(t):u.freeze().getValue(t):void 0,B=r.overrideIdentifier?f.override(r.overrideIdentifier).getValue(t):f.getValue(t),oe=i.getValue(t),he=S.distinct(S.flatten(i.overrides.map(Q=>Q.identifiers))).filter(Q=>i.getOverrideValue(t,Q)!==void 0);return{defaultValue:v,userValue:D,userLocalValue:T,userRemoteValue:o,workspaceValue:A,workspaceFolderValue:L,memoryValue:B,value:oe,default:v!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,user:D!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userLocal:T!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userRemote:o!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspace:A!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspaceFolder:L!==void 0?{value:u?.freeze().getValue(t),override:r.overrideIdentifier?u?.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,memory:B!==void 0?{value:f.getValue(t),override:r.overrideIdentifier?f.getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,overrideIdentifiers:he.length?he:void 0}}keys(t){const r=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,r){this._folderConfigurations.set(t,r),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,r){const s=r.filter(i=>b.OVERRIDE_PROPERTY_PATTERN.test(i)).map(i=>{const u=(0,b.overrideIdentifierFromKey)(i),f=this._defaultConfiguration.getKeysForOverrideIdentifier(u),v=t.getKeysForOverrideIdentifier(u),D=[...v.filter(T=>f.indexOf(T)===-1),...f.filter(T=>v.indexOf(T)===-1),...f.filter(T=>!C.equals(this._defaultConfiguration.override(u).getValue(T),t.override(u).getValue(T)))];return[u,D]});return this.updateDefaultConfiguration(t),{keys:r,overrides:s}}compareAndUpdateLocalUserConfiguration(t){const{added:r,updated:s,removed:i,overrides:u}=(0,k.compare)(this.localUserConfiguration,t),f=[...r,...s,...i];return f.length&&this.updateLocalUserConfiguration(t),{keys:f,overrides:u}}compareAndUpdateRemoteUserConfiguration(t){const{added:r,updated:s,removed:i,overrides:u}=(0,k.compare)(this.remoteUserConfiguration,t);let f=[...r,...s,...i];return f.length&&this.updateRemoteUserConfiguration(t),{keys:f,overrides:u}}compareAndUpdateWorkspaceConfiguration(t){const{added:r,updated:s,removed:i,overrides:u}=(0,k.compare)(this.workspaceConfiguration,t);let f=[...r,...s,...i];return f.length&&this.updateWorkspaceConfiguration(t),{keys:f,overrides:u}}compareAndUpdateFolderConfiguration(t,r){const s=this.folderConfigurations.get(t),{added:i,updated:u,removed:f,overrides:v}=(0,k.compare)(s,r);let D=[...i,...u,...f];return(D.length||!s)&&this.updateFolderConfiguration(t,r),{keys:D,overrides:v}}compareAndDeleteFolderConfiguration(t){const r=this.folderConfigurations.get(t);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:i,removed:u,overrides:f}=(0,k.compare)(r,void 0);return{keys:[...s,...i,...u],overrides:f}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,r){let s=this.getConsolidatedConfigurationModelForResource(t,r);return t.overrideIdentifier?s.override(t.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:t},r){let s=this.getWorkspaceConsolidatedConfiguration();if(r&&t){const i=r.getFolder(t);i&&(s=this.getFolderConsolidatedConfiguration(i.uri)||s);const u=this._memoryConfigurationByResource.get(t);u&&(s=s.merge(u))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let r=this._foldersConsolidatedConfigurations.get(t);if(!r){const s=this.getWorkspaceConsolidatedConfiguration(),i=this._folderConfigurations.get(t);i?(r=s.merge(i),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(t,r)):r=s}return r}getFolderConfigurationModelForResource(t,r){if(r&&t){const s=r.getFolder(t);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,r)=>{const{contents:s,overrides:i,keys:u}=this._folderConfigurations.get(r);return t.push([r,{contents:s,overrides:i,keys:u}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>t.add(r)),this.userConfiguration.freeze().keys.forEach(r=>t.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(s=>t.add(s))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>r.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>r.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>r.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(i=>r.add(i))),[...r.values()]}static parse(t){const r=this.parseConfigurationModel(t.defaults),s=this.parseConfigurationModel(t.user),i=this.parseConfigurationModel(t.workspace),u=t.folders.reduce((f,v)=>(f.set(y.URI.revive(v[0]),this.parseConfigurationModel(v[1])),f),new F.ResourceMap);return new w(r,s,new d,i,u,new d,new F.ResourceMap,!1)}static parseConfigurationModel(t){return new d(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=w;function P(...p){if(p.length===0)return{keys:[],overrides:[]};if(p.length===1)return p[0];const t=new Set,r=new Map;for(const i of p)i.keys.forEach(u=>t.add(u)),i.overrides.forEach(([u,f])=>{const v=(0,F.getOrSet)(r,u,new Set);f.forEach(D=>v.add(D))});const s=[];return r.forEach((i,u)=>s.push([u,[...i.values()]])),{keys:[...t.values()],overrides:s}}e.mergeChanges=P;class a{constructor(t,r,s,i){this.change=t,this.previous=r,this.currentConfiguraiton=s,this.currentWorkspace=i,this._previousConfiguration=void 0;const u=new Set;t.keys.forEach(v=>u.add(v)),t.overrides.forEach(([,v])=>v.forEach(D=>u.add(D))),this.affectedKeys=[...u.values()];const f=new d;this.affectedKeys.forEach(v=>f.setValue(v,{})),this.affectedKeysTree=f.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=w.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,r){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(r){const s=this.previousConfiguration?this.previousConfiguration.getValue(t,r,this.previous?.workspace):void 0,i=this.currentConfiguraiton.getValue(t,r,this.currentWorkspace);return!C.equals(s,i)}return!0}return!1}doesAffectedKeysTreeContains(t,r){let s=(0,k.toValuesTree)({[r]:!0},()=>{}),i;for(;typeof s=="object"&&(i=Object.keys(s)[0]);){if(t=t[i],!t)return!1;s=s[i]}return!0}}e.ConfigurationChangeEvent=a;class h extends a{constructor(t,r,s,i){super({keys:t.allKeys(),overrides:[]},void 0,t,r);this.source=s,this.sourceConfig=i}}e.AllKeysConfigurationChangeEvent=h}),define(be[95],Ee([0,1,4]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,g.createDecorator)("remoteAuthorityResolverService");var F;(function(_){_.Unknown="Unknown",_.NotAvailable="NotAvailable",_.TemporarilyNotAvailable="TemporarilyNotAvailable",_.NoResolverFound="NoResolverFound"})(F=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class S extends Error{constructor(C,y=F.Unknown,b){super(C);this._message=C,this._code=y,this._detail=b,this.isHandled=y===F.NotAvailable&&b===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,S.prototype)}static isTemporarilyNotAvailable(C){return C instanceof S&&C._code===F.TemporarilyNotAvailable}static isNoResolverFound(C){return C instanceof S&&C._code===F.NoResolverFound}static isHandled(C){return C instanceof S&&C.isHandled}}e.RemoteAuthorityResolverError=S}),define(be[96],Ee([0,1,11]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function F(k){return k.scheme===g.Schemas.vscodeRemote?k.authority:void 0}e.getRemoteAuthority=F;function S(k){if(!k)return;const n=k.indexOf("+");return n<0?k:k.substr(0,n)}e.getRemoteName=S;function _(k){return k.scheme!==g.Schemas.file&&k.scheme!==g.Schemas.vscodeRemote}e.isVirtualResource=_;function C(k){if(k.folders.length)return k.folders.every(n=>_(n.uri))?k.folders[0].uri:void 0;if(k.configuration&&_(k.configuration))return k.configuration}e.getVirtualWorkspaceLocation=C;function y(k){return C(k)?.scheme}e.getVirtualWorkspaceScheme=y;function b(k){return C(k)!==void 0}e.isVirtualWorkspace=b}),define(be[158],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class g{constructor(S){this._callback=S,this._terminalBufferMap=new Map}dispose(){for(const S of this._terminalBufferMap.values())S.dispose()}startBuffering(S,_,C=5){let y;return y=_(b=>{const k=typeof b=="string"?b:b.data;let n=this._terminalBufferMap.get(S);if(n){n.data.push(k);return}const I=setTimeout(()=>this.flushBuffer(S),C);n={data:[k],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(S),y.dispose()}},this._terminalBufferMap.set(S,n)}),y}stopBuffering(S){const _=this._terminalBufferMap.get(S);_&&_.dispose()}flushBuffer(S){const _=this._terminalBufferMap.get(S);_&&(this._terminalBufferMap.delete(S),this._callback(S,_.data.join("")))}}e.TerminalDataBufferer=g}),define(be[159],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var g;(function(F){F.DARK="dark",F.LIGHT="light",F.HIGH_CONTRAST="hc"})(g=e.ColorScheme||(e.ColorScheme={}))}),define(be[64],Ee([0,1,4,6,28,3,159,35]),function(ee,e,g,F,S,_,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,g.createDecorator)("themeService");var b;(function(E){function w(P){return P&&typeof P=="object"&&typeof P.id=="string"}E.isThemeColor=w})(b=e.ThemeColor||(e.ThemeColor={}));function k(E){return{id:E}}e.themeColorFromId=k;var n;(function(E){function w(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color=="undefined"||b.isThemeColor(r.color))}E.isThemeIcon=w;const P=new RegExp(`^\\$\\((${y.CSSIcon.iconNameExpression}(?:${y.CSSIcon.iconModifierExpression})?)\\)$`);function a(r){const s=P.exec(r);if(!s)return;let[,i]=s;return{id:i}}E.fromString=a;function h(r,s){let i=r.id;const u=i.lastIndexOf("~");return u!==-1&&(i=i.substring(0,u)),s&&(i=`${i}~${s}`),{id:i}}E.modify=h;function p(r,s){return r.id===s.id&&r.color?.id===s.color?.id}E.isEqual=p;function t(r,s){return{id:r.id,color:s?k(s):void 0}}E.asThemeIcon=t,E.asClassNameArray=y.CSSIcon.asClassNameArray,E.asClassName=y.CSSIcon.asClassName,E.asCSSSelector=y.CSSIcon.asCSSSelector})(n=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=y.Codicon.file,e.FolderThemeIcon=y.Codicon.folder;function I(E){switch(E){case C.ColorScheme.DARK:return"vs-dark";case C.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=I,e.Extensions={ThemingContribution:"base.contributions.theming"};class l{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new _.Emitter}onColorThemeChange(w){return this.themingParticipants.push(w),this.onThemingParticipantAddedEmitter.fire(w),(0,F.toDisposable)(()=>{const P=this.themingParticipants.indexOf(w);this.themingParticipants.splice(P,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let d=new l;S.Registry.add(e.Extensions.ThemingContribution,d);function c(E){return d.onColorThemeChange(E)}e.registerThemingParticipant=c;class m extends F.Disposable{constructor(w){super();this.themeService=w,this.theme=w.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(P=>this.onThemeChange(P)))}onThemeChange(w){this.theme=w,this.updateStyles()}updateStyles(){}getColor(w,P){let a=this.theme.getColor(w);return a&&P&&(a=P(a,this.theme)),a?a.toString():null}}e.Themable=m}),define(be[160],Ee([0,1,28,64,3,132,93,16,35]),function(ee,e,g,F,S,_,C,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class k{constructor(){this._onDidChange=new S.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,_.localize)(0,null)},fontCharacter:{type:"string",description:(0,_.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${b.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(w,P,a,h){const p=this.iconsById[w];if(p){if(a&&!p.description){p.description=a,this.iconSchema.properties[w].markdownDescription=`${a} $(${w})`;const s=this.iconReferenceSchema.enum.indexOf(w);s!==-1&&(this.iconReferenceSchema.enumDescriptions[s]=a),this._onDidChange.fire()}return p}let t={id:w,description:a,defaults:P,deprecationMessage:h};this.iconsById[w]=t;let r={$ref:"#/definitions/icons"};return h&&(r.deprecationMessage=h),a&&(r.markdownDescription=`${a}: $(${w})`),this.iconSchema.properties[w]=r,this.iconReferenceSchema.enum.push(w),this.iconReferenceSchema.enumDescriptions.push(a||""),this._onDidChange.fire(),{id:w}}deregisterIcon(w){delete this.iconsById[w],delete this.iconSchema.properties[w];const P=this.iconReferenceSchema.enum.indexOf(w);P!==-1&&(this.iconReferenceSchema.enum.splice(P,1),this.iconReferenceSchema.enumDescriptions.splice(P,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(w=>this.iconsById[w])}getIcon(w){return this.iconsById[w]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(w,P){const a=this.iconFontsById[w];if(a)return a;let h={id:w,definition:P};return this.iconFontsById[w]=h,this._onDidChange.fire(),h}deregisterIconFont(w){delete this.iconFontsById[w]}getIconFonts(){return Object.keys(this.iconFontsById).map(w=>this.iconFontsById[w])}getIconFont(w){return this.iconFontsById[w]}toString(){const w=(p,t)=>p.id.localeCompare(t.id),P=p=>{for(;F.ThemeIcon.isThemeIcon(p.defaults);)p=this.iconsById[p.defaults.id];return`codicon codicon-${p?p.id:""}`};let a=[];a.push("| preview     | identifier                        | default codicon ID                | description"),a.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const h=Object.keys(this.iconsById).map(p=>this.iconsById[p]);for(const p of h.filter(t=>!!t.description).sort(w))a.push(`|<i class="${P(p)}"></i>|${p.id}|${F.ThemeIcon.isThemeIcon(p.defaults)?p.defaults.id:p.id}|${p.description||""}|`);a.push("| preview     | identifier                        "),a.push("| ----------- | --------------------------------- |");for(const p of h.filter(t=>!F.ThemeIcon.isThemeIcon(t.defaults)).sort(w))a.push(`|<i class="${P(p)}"></i>|${p.id}|`);return a.join(`
`)}}const n=new k;g.Registry.add(e.Extensions.IconContribution,n);function I(E,w,P,a){return n.registerIcon(E,w,P,a)}e.registerIcon=I;function l(){return n}e.getIconRegistry=l;function d(){for(const E of b.iconRegistry.all)n.registerIcon(E.id,E.definition,E.description);b.iconRegistry.onDidRegister(E=>n.registerIcon(E.id,E.definition,E.description))}d(),e.iconsSchemaId="vscode://schemas/icons";let c=g.Registry.as(C.Extensions.JSONContribution);c.registerSchema(e.iconsSchemaId,n.getIconSchema());const m=new y.RunOnceScheduler(()=>c.notifySchemaChanged(e.iconsSchemaId),200);n.onDidChange(()=>{m.isScheduled()||m.schedule()}),e.widgetClose=I("widget-close",b.Codicon.close,(0,_.localize)(2,null)),e.gotoPreviousLocation=I("goto-previous-location",b.Codicon.arrowUp,(0,_.localize)(3,null)),e.gotoNextLocation=I("goto-next-location",b.Codicon.arrowDown,(0,_.localize)(4,null)),e.syncing=F.ThemeIcon.modify(b.Codicon.sync,"spin")}),define(be[46],Ee([0,1,2,25,4,21]),function(ee,e,g,F,S,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,S.createDecorator)("contextService");var C;(function(l){l[l.EMPTY=1]="EMPTY",l[l.FOLDER=2]="FOLDER",l[l.WORKSPACE=3]="WORKSPACE"})(C=e.WorkbenchState||(e.WorkbenchState={}));function y(l){const d=l;return!!(d&&typeof d=="object"&&typeof d.id=="string"&&Array.isArray(d.folders))}e.isWorkspace=y;function b(l){const d=l;return!!(d&&typeof d=="object"&&g.URI.isUri(d.uri)&&typeof d.name=="string"&&typeof d.toResource=="function")}e.isWorkspaceFolder=b;class k{constructor(d,c,m,E){this._id=d,this._configuration=m,this._ignorePathCasing=E,this._foldersMap=_.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=c}update(d){this._id=d.id,this._configuration=d.configuration,this._ignorePathCasing=d._ignorePathCasing,this.folders=d.folders}get folders(){return this._folders}set folders(d){this._folders=d,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(d){this._configuration=d}getFolder(d){return d&&this._foldersMap.findSubstr(d.with({scheme:d.scheme,authority:d.authority,path:d.path}))||null}updateFoldersMap(){this._foldersMap=_.TernarySearchTree.forUris(this._ignorePathCasing);for(const d of this.folders)this._foldersMap.set(d.uri,d)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=k;class n{constructor(d,c){this.raw=c,this.uri=d.uri,this.index=d.index,this.name=d.name}toResource(d){return(0,F.joinPath)(this.uri,d)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=n;function I(l){return new n({uri:l,index:0,name:(0,F.basenameOrAuthority)(l)},{uri:l.toString()})}e.toWorkspaceFolder=I}),define(be[65],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class g{constructor(S){this.id=S,this._data=new Map,this._idPool=1}add(S){const _=this._idPool++;return this._data.set(_,S),this.logDebugInfo(),_}get(S,_){return this._data.has(S)?this._data.get(S)[_]:void 0}delete(S){this._data.delete(S),this.logDebugInfo()}logDebugInfo(){!g.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=g,g.enableDebugLogging=!1}),define(be[66],Ee([0,1,2,3,4]),function(ee,e,g,F,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,S.createDecorator)("IExtHostEditorTabs");class _{constructor(){this._onDidChangeTabs=new F.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(y){this._tabs=y.map(b=>({name:b.name,group:b.group,resource:g.URI.revive(b.resource),isActive:b.isActive})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=_}),define(be[47],Ee([0,1,11,4]),function(ee,e,g,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class S{constructor(){this._systemSchemes=new Set(Object.keys(g.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(C,y){y===null?this._providerInfo.delete(C):this._providerInfo.set(C,y)}isFreeScheme(C){return!this._providerInfo.has(C)&&!this._systemSchemes.has(C)}getCapabilities(C){return this._providerInfo.get(C)}}e.ExtHostFileSystemInfo=S,e.IExtHostFileSystemInfo=(0,F.createDecorator)("IExtHostFileSystemInfo")}),define(be[29],Ee([0,1,4]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,g.createDecorator)("IExtHostInitDataService")}),define(be[161],Ee([0,1,2]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class F{constructor(_,C,y){this._extHostNotebooks=C,this._textDocumentsAndEditors=y}$willAddInteractiveDocument(_,C,y,b){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:C,lines:[""],modeId:y,uri:_,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(g.URI.revive(b))?.apiNotebook}]})}$willRemoveInteractiveDocument(_,C){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[_]})}}e.ExtHostInteractive=F}),define(be[162],Ee([0,1,16]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class F{constructor(C,y,b){this._deferredPromises=new Map,this._id=C,this._shared=y,this._storage=b,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(k=>(this._value=k,this)),this._storageListener=this._storage.onDidChangeStorage(k=>{k.shared===this._shared&&k.key===this._id&&(this._value=k.value)}),this._scheduler=new g.RunOnceScheduler(()=>{const k=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const n of k.values())n.complete()}catch(n){for(const I of k.values())I.error(n)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,C])=>C!==void 0).map(([C])=>C)}get whenReady(){return this._init}get(C,y){let b=this._value[C];return typeof b=="undefined"&&(b=y),b}update(C,y){this._value[C]=y;let b=this._deferredPromises.get(C);if(b!==void 0)return b.p;const k=new g.DeferredPromise;return this._deferredPromises.set(C,k),this._scheduler.isScheduled()||this._scheduler.schedule(),k.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=F;class S extends F{constructor(C,y){super(C.identifier.value,!0,y);this._extension=C}setKeysForSync(C){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},C)}}e.ExtensionGlobalMemento=S}),define(be[163],Ee([0,1,3,2,15]),function(ee,e,g,F,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let _=class{constructor(y,b){this._logService=y,this._notebooksAndEditors=b,this._onDidChangeNotebookDocumentMetadata=new g.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new g.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(y,b,k){this._notebooksAndEditors.getNotebookDocument(F.URI.revive(y)).acceptModelChanged(b,k)}$acceptDirtyStateChanged(y,b){this._notebooksAndEditors.getNotebookDocument(F.URI.revive(y)).acceptDirty(b)}$acceptModelSaved(y){const b=this._notebooksAndEditors.getNotebookDocument(F.URI.revive(y));this._onDidSaveNotebookDocument.fire(b.apiNotebook)}$acceptDocumentPropertiesChanged(y,b){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",y.path,b);const k=this._notebooksAndEditors.getNotebookDocument(F.URI.revive(y));k.acceptDocumentPropertiesChanged(b),b.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:k.apiNotebook})}};_=ze([qe(0,S.ILogService)],_),e.ExtHostNotebookDocuments=_}),define(be[13],Ee([0,1,4]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,g.createDecorator)("IExtHostRpcService");class F{constructor(_){this.getProxy=_.getProxy.bind(_),this.set=_.set.bind(_),this.assertRegistered=_.assertRegistered.bind(_),this.drain=_.drain.bind(_)}}e.ExtHostRpcService=F});var nt=this&&this.__classPrivateFieldSet||function(ee,e,g,F,S){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?S.call(ee,g):S?S.value=g:e.set(ee,g),g},Ue=this&&this.__classPrivateFieldGet||function(ee,e,g,F){if(g==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!F:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?F:g==="a"?F.call(ee):F?F.value:e.get(ee)};define(be[164],Ee([0,1,26,3]),function(ee,e,g,F){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class _{constructor(y,b){S.set(this,void 0),this._onDidChange=new F.Emitter,this.onDidChange=this._onDidChange.event,this._id=g.ExtensionIdentifier.toKey(y.identifier),nt(this,S,b,"f"),Ue(this,S,"f").onDidChangePassword(k=>{k.extensionId===this._id&&this._onDidChange.fire({key:k.key})})}get(y){return Ue(this,S,"f").get(this._id,y)}store(y,b){return Ue(this,S,"f").store(this._id,y,b)}delete(y){return Ue(this,S,"f").delete(this._id,y)}}e.ExtensionSecrets=_,S=new WeakMap}),define(be[97],Ee([0,1,4,3]),function(ee,e,g,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class S{constructor(){this._onDidChangeTelemetryEnabled=new F.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(C){this._enabled=C}$onDidChangeTelemetryEnabled(C){this._enabled=C,this._onDidChangeTelemetryEnabled.fire(C)}}e.ExtHostTelemetry=S,e.IExtHostTelemetry=(0,g.createDecorator)("IExtHostTelemetry")}),define(be[67],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var g;(function(P){P[P.Upsert=0]="Upsert",P[P.RemoveChild=1]="RemoveChild",P[P.Invalidated=2]="Invalidated",P[P.SetProp=3]="SetProp",P[P.Bulk=4]="Bulk"})(g=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const F=new WeakMap,S=(P,a)=>{const h={controllerId:a};return F.set(P,h),h};e.createPrivateApiFor=S;const _=P=>F.get(P);e.getPrivateApiFor=_;const C=(P,a,h,p)=>{let t=h;return{enumerable:!0,configurable:!1,get(){return t},set(r){p(t,r)||(t=r,P.listener?.({op:3,key:a,value:r}))}}},y=(P,a)=>P===a,b={range:(P,a)=>P===a?!0:!P||!a?!1:P.isEqual(a),label:y,description:y,busy:y,error:y,canResolveChildren:y},k=Object.keys(b),n=(P,a)=>({range:C(P,"range",void 0,b.range),label:C(P,"label",a,b.label),description:C(P,"description",void 0,b.description),canResolveChildren:C(P,"canResolveChildren",!1,b.canResolveChildren),busy:C(P,"busy",!1,b.busy),error:C(P,"error",void 0,b.error)}),I=(P,a)=>{const h=new Map;for(const p of k)b[p](P[p],a[p])||h.set(p,a[p]);return h};e.diffTestItems=I;class l extends Error{constructor(a){super(`Attempted to insert a duplicate test item ID ${a}`)}}e.DuplicateTestItemError=l;class d extends Error{constructor(a){super(`TestItem with ID "${a}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=d;class c extends Error{constructor(a,h,p){super(`TestItem with ID "${a}" is from controller "${h}" and cannot be added as a child of an item from controller "${p}".`)}}e.MixedTestItemController=c;const m=P=>{const a=(0,e.getPrivateApiFor)(P);let h=new Map;return{forEach(p,t){for(const r of h.values())p.call(t,r,this)},replace(p){const t=new Map,r=new Set(h.keys()),s={op:4,ops:[]};for(const i of p){if(!(i instanceof E))throw new d(i.id);const u=(0,e.getPrivateApiFor)(i).controllerId;if(u!==a.controllerId)throw new c(i.id,u,a.controllerId);if(t.has(i.id))throw new l(i.id);t.set(i.id,i),r.delete(i.id),s.ops.push({op:0,item:i})}for(const i of r.keys())s.ops.push({op:1,id:i});a.listener?.(s),h=t},add(p){if(!(p instanceof E))throw new d(p.id);h.set(p.id,p),a.listener?.({op:0,item:p})},delete(p){h.delete(p)&&a.listener?.({op:1,id:p})},get(p){return h.get(p)},toJSON(){return Array.from(h.values())},[Symbol.iterator](){return h.values()}}};class E{constructor(a,h,p,t){if(h.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(h)} symbol`);const r=(0,e.createPrivateApiFor)(this,a);Object.defineProperties(this,{id:{value:h,enumerable:!0,writable:!1},uri:{value:t,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return r.parent instanceof w?void 0:r.parent}},children:{value:m(this),enumerable:!0,writable:!1},...n(r,p)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=E;class w extends E{constructor(a,h){super(a,a,h,void 0)}}e.TestItemRootImpl=w}),define(be[68],Ee([0,1,4,3,13]),function(ee,e,g,F,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var _;(function(y){function b(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public,protocol:n.protocol}}y.fromApiTunnel=b;function k(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.public,protocol:n.protocol}}y.fromServiceTunnel=k})(_=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,g.createDecorator)("IExtHostTunnelService");let C=class{constructor(b){this.onDidChangeTunnels=new F.Emitter().event}async $applyCandidateFilter(b){return b}async openTunnel(b,k){}async getTunnels(){return[]}async setTunnelExtensionFunctions(b){return{dispose:()=>{}}}registerPortsAttributesProvider(b,k){return{dispose:()=>{}}}async $providePortAttributes(b,k,n,I,l){return[]}async $forwardPort(b,k){}async $closeTunnel(b){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};C=ze([qe(0,S.IExtHostRpcService)],C),e.ExtHostTunnelService=C});var nt=this&&this.__classPrivateFieldSet||function(ee,e,g,F,S){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?S.call(ee,g):S?S.value=g:e.set(ee,g),g},Ue=this&&this.__classPrivateFieldGet||function(ee,e,g,F){if(g==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!F:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?F:g==="a"?F.call(ee):F?F.value:e.get(ee)};define(be[7],Ee([0,1,17,12,83,21,85,10,2,36,61,95]),function(ee,e,g,F,S,_,C,y,b,k,n,I){"use strict";var l,d,c,m,E,w,P,a,h,p,t,r,s,i,u,f,v,D,T,o;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestMessageSeverity=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function A(N){function M(){return Reflect.construct(N,arguments,this.constructor)}return Object.defineProperty(M,"name",Object.getOwnPropertyDescriptor(N,"name")),Object.setPrototypeOf(M,N),Object.setPrototypeOf(M.prototype,N.prototype),M}let L=E=class{constructor(M){l.set(this,void 0),nt(this,l,M,"f")}static from(...M){let ne=M;return new E(function(){if(ne){for(const Ce of ne)Ce&&typeof Ce.dispose=="function"&&Ce.dispose();ne=void 0}})}dispose(){typeof Ue(this,l,"f")=="function"&&(Ue(this,l,"f").call(this),nt(this,l,void 0,"f"))}};l=new WeakMap,L=E=ze([A],L),e.Disposable=L;let B=w=class{constructor(M,ne){if(M<0)throw(0,F.illegalArgument)("line must be non-negative");if(ne<0)throw(0,F.illegalArgument)("character must be non-negative");this._line=M,this._character=ne}static Min(...M){if(M.length===0)throw new TypeError;let ne=M[0];for(let Ce=1;Ce<M.length;Ce++){const Ye=M[Ce];Ye.isBefore(ne)&&(ne=Ye)}return ne}static Max(...M){if(M.length===0)throw new TypeError;let ne=M[0];for(let Ce=1;Ce<M.length;Ce++){const Ye=M[Ce];Ye.isAfter(ne)&&(ne=Ye)}return ne}static isPosition(M){if(!M)return!1;if(M instanceof w)return!0;let{line:ne,character:Ce}=M;return typeof ne=="number"&&typeof Ce=="number"}get line(){return this._line}get character(){return this._character}isBefore(M){return this._line<M._line?!0:M._line<this._line?!1:this._character<M._character}isBeforeOrEqual(M){return this._line<M._line?!0:M._line<this._line?!1:this._character<=M._character}isAfter(M){return!this.isBeforeOrEqual(M)}isAfterOrEqual(M){return!this.isBefore(M)}isEqual(M){return this._line===M._line&&this._character===M._character}compareTo(M){return this._line<M._line?-1:this._line>M.line?1:this._character<M._character?-1:this._character>M._character?1:0}translate(M,ne=0){if(M===null||ne===null)throw(0,F.illegalArgument)();let Ce;return typeof M=="undefined"?Ce=0:typeof M=="number"?Ce=M:(Ce=typeof M.lineDelta=="number"?M.lineDelta:0,ne=typeof M.characterDelta=="number"?M.characterDelta:0),Ce===0&&ne===0?this:new w(this.line+Ce,this.character+ne)}with(M,ne=this.character){if(M===null||ne===null)throw(0,F.illegalArgument)();let Ce;return typeof M=="undefined"?Ce=this.line:typeof M=="number"?Ce=M:(Ce=typeof M.line=="number"?M.line:this.line,ne=typeof M.character=="number"?M.character:this.character),Ce===this.line&&ne===this.character?this:new w(Ce,ne)}toJSON(){return{line:this.line,character:this.character}}};B=w=ze([A],B),e.Position=B;let oe=P=class{constructor(M,ne,Ce,Ye){let it,rt;if(typeof M=="number"&&typeof ne=="number"&&typeof Ce=="number"&&typeof Ye=="number"?(it=new B(M,ne),rt=new B(Ce,Ye)):M instanceof B&&ne instanceof B&&(it=M,rt=ne),!it||!rt)throw new Error("Invalid arguments");it.isBefore(rt)?(this._start=it,this._end=rt):(this._start=rt,this._end=it)}static isRange(M){return M instanceof P?!0:M?B.isPosition(M.start)&&B.isPosition(M.end):!1}get start(){return this._start}get end(){return this._end}contains(M){return M instanceof P?this.contains(M._start)&&this.contains(M._end):M instanceof B?!(M.isBefore(this._start)||this._end.isBefore(M)):!1}isEqual(M){return this._start.isEqual(M._start)&&this._end.isEqual(M._end)}intersection(M){const ne=B.Max(M.start,this._start),Ce=B.Min(M.end,this._end);if(!ne.isAfter(Ce))return new P(ne,Ce)}union(M){if(this.contains(M))return this;if(M.contains(this))return M;const ne=B.Min(M.start,this._start),Ce=B.Max(M.end,this.end);return new P(ne,Ce)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(M,ne=this.end){if(M===null||ne===null)throw(0,F.illegalArgument)();let Ce;return M?B.isPosition(M)?Ce=M:(Ce=M.start||this.start,ne=M.end||this.end):Ce=this.start,Ce.isEqual(this._start)&&ne.isEqual(this.end)?this:new P(Ce,ne)}toJSON(){return[this.start,this.end]}};oe=P=ze([A],oe),e.Range=oe;let he=a=class extends oe{constructor(M,ne,Ce,Ye){let it,rt;if(typeof M=="number"&&typeof ne=="number"&&typeof Ce=="number"&&typeof Ye=="number"?(it=new B(M,ne),rt=new B(Ce,Ye)):M instanceof B&&ne instanceof B&&(it=M,rt=ne),!it||!rt)throw new Error("Invalid arguments");super(it,rt);this._anchor=it,this._active=rt}static isSelection(M){return M instanceof a?!0:M?oe.isRange(M)&&B.isPosition(M.anchor)&&B.isPosition(M.active)&&typeof M.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};he=a=ze([A],he),e.Selection=he;class Q{constructor(M,ne,Ce){if(typeof M!="string"||M.length===0)throw(0,F.illegalArgument)("host");if(typeof ne!="number"||ne===0||Math.round(ne)!==ne)throw(0,F.illegalArgument)("port");if(typeof Ce!="undefined"&&(typeof Ce!="string"||Ce.length===0||!/^[0-9A-Za-z\-]+$/.test(Ce)))throw(0,F.illegalArgument)("connectionToken");this.host=M,this.port=Math.round(ne),this.connectionToken=Ce}}e.ResolvedAuthority=Q;class z extends Error{constructor(M,ne=I.RemoteAuthorityResolverErrorCode.Unknown,Ce){super(M);this._message=M,this._code=ne,this._detail=Ce,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,z.prototype)}static NotAvailable(M,ne){return new z(M,I.RemoteAuthorityResolverErrorCode.NotAvailable,ne)}static TemporarilyNotAvailable(M){return new z(M,I.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=z;var V;(function(N){N[N.LF=1]="LF",N[N.CRLF=2]="CRLF"})(V=e.EndOfLine||(e.EndOfLine={}));var R;(function(N){N[N.Replace=1]="Replace",N[N.Append=2]="Append",N[N.Prepend=3]="Prepend"})(R=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let K=h=class{constructor(M,ne){this._range=M,this._newText=ne}static isTextEdit(M){return M instanceof h?!0:M?oe.isRange(M)&&typeof M.newText=="string":!1}static replace(M,ne){return new h(M,ne)}static insert(M,ne){return h.replace(new oe(M,M),ne)}static delete(M){return h.replace(M,"")}static setEndOfLine(M){const ne=new h(new oe(new B(0,0),new B(0,0)),"");return ne.newEol=M,ne}get range(){return this._range}set range(M){if(M&&!oe.isRange(M))throw(0,F.illegalArgument)("range");this._range=M}get newText(){return this._newText||""}set newText(M){if(M&&typeof M!="string")throw(0,F.illegalArgument)("newText");this._newText=M}get newEol(){return this._newEol}set newEol(M){if(M&&typeof M!="number")throw(0,F.illegalArgument)("newEol");this._newEol=M}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};K=h=ze([A],K),e.TextEdit=K;var x;(function(N){N[N.File=1]="File",N[N.Text=2]="Text",N[N.Cell=3]="Cell",N[N.CellReplace=5]="CellReplace"})(x=e.FileEditType||(e.FileEditType={}));let j=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(M,ne,Ce,Ye){this._edits.push({_type:1,from:M,to:ne,options:Ce,metadata:Ye})}createFile(M,ne,Ce){this._edits.push({_type:1,from:void 0,to:M,options:ne,metadata:Ce})}deleteFile(M,ne,Ce){this._edits.push({_type:1,from:M,to:void 0,options:ne,metadata:Ce})}replaceNotebookMetadata(M,ne,Ce){this._edits.push({_type:3,metadata:Ce,uri:M,edit:{editType:5,metadata:ne},notebookMetadata:ne})}replaceNotebookCells(M,ne,Ce,Ye,it){let rt,at,St=[],It;if(Bt.isNotebookRange(ne)&&Lt.isNotebookCellDataArray(Ce)&&!Lt.isNotebookCellDataArray(Ye)?(rt=ne.start,at=ne.end,St=Ce,It=Ye):typeof ne=="number"&&typeof Ce=="number"&&Lt.isNotebookCellDataArray(Ye)&&(rt=ne,at=Ce,St=Ye,It=it),rt===void 0||at===void 0)throw new Error("Invalid arguments");(rt!==at||St.length>0)&&this._edits.push({_type:5,uri:M,index:rt,count:at-rt,cells:St,metadata:It})}replaceNotebookCellMetadata(M,ne,Ce,Ye){this._edits.push({_type:3,metadata:Ye,uri:M,edit:{editType:8,index:ne,metadata:Ce}})}replace(M,ne,Ce,Ye){this._edits.push({_type:2,uri:M,edit:new K(ne,Ce),metadata:Ye})}insert(M,ne,Ce,Ye){this.replace(M,new oe(ne,ne),Ce,Ye)}delete(M,ne,Ce){this.replace(M,ne,"",Ce)}has(M){return this._edits.some(ne=>ne._type===2&&ne.uri.toString()===M.toString())}set(M,ne){if(ne)for(const Ce of ne)Ce&&this._edits.push({_type:2,uri:M,edit:Ce});else{for(let Ce=0;Ce<this._edits.length;Ce++){const Ye=this._edits[Ce];Ye._type===2&&Ye.uri.toString()===M.toString()&&(this._edits[Ce]=void 0)}(0,g.coalesceInPlace)(this._edits)}}get(M){const ne=[];for(let Ce of this._edits)Ce._type===2&&Ce.uri.toString()===M.toString()&&ne.push(Ce.edit);return ne}entries(){const M=new _.ResourceMap;for(let ne of this._edits)if(ne._type===2){let Ce=M.get(ne.uri);Ce||(Ce=[ne.uri,[]],M.set(ne.uri,Ce)),Ce[1].push(ne.edit)}return[...M.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};j=ze([A],j),e.WorkspaceEdit=j;let ue=p=class{constructor(M){this._tabstop=1,this.value=M||""}static isSnippetString(M){return M instanceof p?!0:M?typeof M.value=="string":!1}static _escape(M){return M.replace(/\$|}|\\/g,"\\$&")}appendText(M){return this.value+=p._escape(M),this}appendTabstop(M=this._tabstop++){return this.value+="$",this.value+=M,this}appendPlaceholder(M,ne=this._tabstop++){if(typeof M=="function"){const Ce=new p;Ce._tabstop=this._tabstop,M(Ce),this._tabstop=Ce._tabstop,M=Ce.value}else M=p._escape(M);return this.value+="${",this.value+=ne,this.value+=":",this.value+=M,this.value+="}",this}appendChoice(M,ne=this._tabstop++){const Ce=M.map(Ye=>Ye.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ne,this.value+="|",this.value+=Ce,this.value+="|}",this}appendVariable(M,ne){if(typeof ne=="function"){const Ce=new p;Ce._tabstop=this._tabstop,ne(Ce),this._tabstop=Ce._tabstop,ne=Ce.value}else typeof ne=="string"&&(ne=ne.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=M,ne&&(this.value+=":",this.value+=ne),this.value+="}",this}};ue=p=ze([A],ue),e.SnippetString=ue;var $;(function(N){N[N.Unnecessary=1]="Unnecessary",N[N.Deprecated=2]="Deprecated"})($=e.DiagnosticTag||(e.DiagnosticTag={}));var te;(function(N){N[N.Hint=3]="Hint",N[N.Information=2]="Information",N[N.Warning=1]="Warning",N[N.Error=0]="Error"})(te=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let ce=t=class{constructor(M,ne){if(this.uri=M,ne)if(ne instanceof oe)this.range=ne;else if(ne instanceof B)this.range=new oe(ne,ne);else throw new Error("Illegal argument")}static isLocation(M){return M instanceof t?!0:M?oe.isRange(M.range)&&b.URI.isUri(M.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};ce=t=ze([A],ce),e.Location=ce;let ye=class{constructor(M,ne){this.location=M,this.message=ne}static is(M){return M?typeof M.message=="string"&&M.location&&oe.isRange(M.location.range)&&b.URI.isUri(M.location.uri):!1}static isEqual(M,ne){return M===ne?!0:!M||!ne?!1:M.message===ne.message&&M.location.range.isEqual(ne.location.range)&&M.location.uri.toString()===ne.location.uri.toString()}};ye=ze([A],ye),e.DiagnosticRelatedInformation=ye;let Re=class{constructor(M,ne,Ce=te.Error){if(!oe.isRange(M))throw new TypeError("range must be set");if(!ne)throw new TypeError("message must be set");this.range=M,this.message=ne,this.severity=Ce}toJSON(){return{severity:te[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(M,ne){return M===ne?!0:!M||!ne?!1:M.message===ne.message&&M.severity===ne.severity&&M.code===ne.code&&M.severity===ne.severity&&M.source===ne.source&&M.range.isEqual(ne.range)&&(0,g.equals)(M.tags,ne.tags)&&(0,g.equals)(M.relatedInformation,ne.relatedInformation,ye.isEqual)}};Re=ze([A],Re),e.Diagnostic=Re;let Te=class{constructor(M,ne){if(!M)throw new Error("Illegal argument, contents must be defined");Array.isArray(M)?this.contents=M:this.contents=[M],this.range=ne}};Te=ze([A],Te),e.Hover=Te;var $e;(function(N){N[N.Text=0]="Text",N[N.Read=1]="Read",N[N.Write=2]="Write"})($e=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Je=class{constructor(M,ne=$e.Text){this.range=M,this.kind=ne}toJSON(){return{range:this.range,kind:$e[this.kind]}}};Je=ze([A],Je),e.DocumentHighlight=Je;var Ve;(function(N){N[N.File=0]="File",N[N.Module=1]="Module",N[N.Namespace=2]="Namespace",N[N.Package=3]="Package",N[N.Class=4]="Class",N[N.Method=5]="Method",N[N.Property=6]="Property",N[N.Field=7]="Field",N[N.Constructor=8]="Constructor",N[N.Enum=9]="Enum",N[N.Interface=10]="Interface",N[N.Function=11]="Function",N[N.Variable=12]="Variable",N[N.Constant=13]="Constant",N[N.String=14]="String",N[N.Number=15]="Number",N[N.Boolean=16]="Boolean",N[N.Array=17]="Array",N[N.Object=18]="Object",N[N.Key=19]="Key",N[N.Null=20]="Null",N[N.EnumMember=21]="EnumMember",N[N.Struct=22]="Struct",N[N.Event=23]="Event",N[N.Operator=24]="Operator",N[N.TypeParameter=25]="TypeParameter"})(Ve=e.SymbolKind||(e.SymbolKind={}));var je;(function(N){N[N.Deprecated=1]="Deprecated"})(je=e.SymbolTag||(e.SymbolTag={}));let O=r=class{constructor(M,ne,Ce,Ye,it){this.name=M,this.kind=ne,this.containerName=it,typeof Ce=="string"&&(this.containerName=Ce),Ye instanceof ce?this.location=Ye:Ce instanceof oe&&(this.location=new ce(Ye,Ce)),r.validate(this)}static validate(M){if(!M.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Ve[this.kind],location:this.location,containerName:this.containerName}}};O=r=ze([A],O),e.SymbolInformation=O;let G=s=class{constructor(M,ne,Ce,Ye,it){this.name=M,this.detail=ne,this.kind=Ce,this.range=Ye,this.selectionRange=it,this.children=[],s.validate(this)}static validate(M){if(!M.name)throw new Error("name must not be falsy");if(!M.range.contains(M.selectionRange))throw new Error("selectionRange must be contained in fullRange");M.children&&M.children.forEach(s.validate)}};G=s=ze([A],G),e.DocumentSymbol=G;var X;(function(N){N[N.Invoke=1]="Invoke",N[N.Automatic=2]="Automatic"})(X=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let se=class{constructor(M,ne){this.title=M,this.kind=ne}};se=ze([A],se),e.CodeAction=se;let q=i=class{constructor(M){this.value=M}append(M){return new i(this.value?this.value+i.sep+M:M)}intersects(M){return this.contains(M)||M.contains(this)}contains(M){return this.value===M.value||M.value.startsWith(this.value+i.sep)}};q.sep=".",q=i=ze([A],q),e.CodeActionKind=q,q.Empty=new q(""),q.QuickFix=q.Empty.append("quickfix"),q.Refactor=q.Empty.append("refactor"),q.RefactorExtract=q.Refactor.append("extract"),q.RefactorInline=q.Refactor.append("inline"),q.RefactorRewrite=q.Refactor.append("rewrite"),q.Source=q.Empty.append("source"),q.SourceOrganizeImports=q.Source.append("organizeImports"),q.SourceFixAll=q.Source.append("fixAll");let ie=class{constructor(M,ne){if(this.range=M,this.parent=ne,ne&&!ne.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};ie=ze([A],ie),e.SelectionRange=ie;class ge{constructor(M,ne,Ce,Ye,it,rt){this.kind=M,this.name=ne,this.detail=Ce,this.uri=Ye,this.range=it,this.selectionRange=rt}}e.CallHierarchyItem=ge;class Le{constructor(M,ne){this.fromRanges=ne,this.from=M}}e.CallHierarchyIncomingCall=Le;class We{constructor(M,ne){this.fromRanges=ne,this.to=M}}e.CallHierarchyOutgoingCall=We;let ve=class{constructor(M,ne){this.range=M,this.command=ne}get isResolved(){return!!this.command}};ve=ze([A],ve),e.CodeLens=ve;let Xe=u=class{constructor(M,ne=!1){d.set(this,void 0),nt(this,d,new S.MarkdownString(M,{supportThemeIcons:ne}),"f")}static isMarkdownString(M){return M instanceof u?!0:M&&M.appendCodeblock&&M.appendMarkdown&&M.appendText&&M.value!==void 0}get value(){return Ue(this,d,"f").value}set value(M){Ue(this,d,"f").value=M}get isTrusted(){return Ue(this,d,"f").isTrusted}set isTrusted(M){Ue(this,d,"f").isTrusted=M}get supportThemeIcons(){return Ue(this,d,"f").supportThemeIcons}set supportThemeIcons(M){Ue(this,d,"f").supportThemeIcons=M}appendText(M){return Ue(this,d,"f").appendText(M),this}appendMarkdown(M){return Ue(this,d,"f").appendMarkdown(M),this}appendCodeblock(M,ne){return Ue(this,d,"f").appendCodeblock(ne??"",M),this}};d=new WeakMap,Xe=u=ze([A],Xe),e.MarkdownString=Xe;let H=class{constructor(M,ne){this.label=M,this.documentation=ne}};H=ze([A],H),e.ParameterInformation=H;let Z=class{constructor(M,ne){this.label=M,this.documentation=ne,this.parameters=[]}};Z=ze([A],Z),e.SignatureInformation=Z;let de=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};de=ze([A],de),e.SignatureHelp=de;var Be;(function(N){N[N.Invoke=1]="Invoke",N[N.TriggerCharacter=2]="TriggerCharacter",N[N.ContentChange=3]="ContentChange"})(Be=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var xe;(function(N){N[N.Other=0]="Other",N[N.Type=1]="Type",N[N.Parameter=2]="Parameter"})(xe=e.InlayHintKind||(e.InlayHintKind={}));let Ze=class{constructor(M,ne,Ce){this.text=M,this.position=ne,this.kind=Ce}};Ze=ze([A],Ze),e.InlayHint=Ze;var De;(function(N){N[N.Invoke=0]="Invoke",N[N.TriggerCharacter=1]="TriggerCharacter",N[N.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(De=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Se;(function(N){N[N.Text=0]="Text",N[N.Method=1]="Method",N[N.Function=2]="Function",N[N.Constructor=3]="Constructor",N[N.Field=4]="Field",N[N.Variable=5]="Variable",N[N.Class=6]="Class",N[N.Interface=7]="Interface",N[N.Module=8]="Module",N[N.Property=9]="Property",N[N.Unit=10]="Unit",N[N.Value=11]="Value",N[N.Enum=12]="Enum",N[N.Keyword=13]="Keyword",N[N.Snippet=14]="Snippet",N[N.Color=15]="Color",N[N.File=16]="File",N[N.Reference=17]="Reference",N[N.Folder=18]="Folder",N[N.EnumMember=19]="EnumMember",N[N.Constant=20]="Constant",N[N.Struct=21]="Struct",N[N.Event=22]="Event",N[N.Operator=23]="Operator",N[N.TypeParameter=24]="TypeParameter",N[N.User=25]="User",N[N.Issue=26]="Issue"})(Se=e.CompletionItemKind||(e.CompletionItemKind={}));var Pe;(function(N){N[N.Deprecated=1]="Deprecated"})(Pe=e.CompletionItemTag||(e.CompletionItemTag={}));let re=class{constructor(M,ne){this.label=M,this.kind=ne}toJSON(){return{label:this.label,kind:this.kind&&Se[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};re=ze([A],re),e.CompletionItem=re;let ae=class{constructor(M=[],ne=!1){this.items=M,this.isIncomplete=ne}};ae=ze([A],ae),e.CompletionList=ae;let fe=class{constructor(M,ne,Ce){this.text=M,this.range=ne,this.command=Ce}};fe=ze([A],fe),e.InlineSuggestion=fe;let pe=class{constructor(M){this.items=M}};pe=ze([A],pe),e.InlineSuggestions=pe;var U;(function(N){N[N.Active=-1]="Active",N[N.Beside=-2]="Beside",N[N.One=1]="One",N[N.Two=2]="Two",N[N.Three=3]="Three",N[N.Four=4]="Four",N[N.Five=5]="Five",N[N.Six=6]="Six",N[N.Seven=7]="Seven",N[N.Eight=8]="Eight",N[N.Nine=9]="Nine"})(U=e.ViewColumn||(e.ViewColumn={}));var me;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(me=e.StatusBarAlignment||(e.StatusBarAlignment={}));var we;(function(N){N[N.Off=0]="Off",N[N.On=1]="On",N[N.Relative=2]="Relative"})(we=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ie;(function(N){N[N.Manual=1]="Manual",N[N.AfterDelay=2]="AfterDelay",N[N.FocusOut=3]="FocusOut"})(Ie=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Oe;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(Oe=e.TextEditorRevealType||(e.TextEditorRevealType={}));var He;(function(N){N[N.Keyboard=1]="Keyboard",N[N.Mouse=2]="Mouse",N[N.Command=3]="Command"})(He=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var et;(function(N){N[N.Undo=1]="Undo",N[N.Redo=2]="Redo"})(et=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Qe;(function(N){N[N.OpenOpen=0]="OpenOpen",N[N.ClosedClosed=1]="ClosedClosed",N[N.OpenClosed=2]="OpenClosed",N[N.ClosedOpen=3]="ClosedOpen"})(Qe=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(N){function M(ne){switch(ne){case"keyboard":return N.Keyboard;case"mouse":return N.Mouse;case"api":return N.Command}}N.fromValue=M}(He=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Ke=class{constructor(M,ne){if(ne&&!b.URI.isUri(ne))throw(0,F.illegalArgument)("target");if(!oe.isRange(M)||M.isEmpty)throw(0,F.illegalArgument)("range");this.range=M,this.target=ne}};Ke=ze([A],Ke),e.DocumentLink=Ke;let lt=class{constructor(M,ne,Ce,Ye){this.red=M,this.green=ne,this.blue=Ce,this.alpha=Ye}};lt=ze([A],lt),e.Color=lt;let ft=class{constructor(M,ne){if(ne&&!(ne instanceof lt))throw(0,F.illegalArgument)("color");if(!oe.isRange(M)||M.isEmpty)throw(0,F.illegalArgument)("range");this.range=M,this.color=ne}};ft=ze([A],ft),e.ColorInformation=ft;let _t=class{constructor(M){if(!M||typeof M!="string")throw(0,F.illegalArgument)("label");this.label=M}};_t=ze([A],_t),e.ColorPresentation=_t;var ut;(function(N){N[N.RGB=0]="RGB",N[N.HEX=1]="HEX",N[N.HSL=2]="HSL"})(ut=e.ColorFormat||(e.ColorFormat={}));var ot;(function(N){N[N.Error=0]="Error",N[N.Warning=1]="Warning",N[N.Information=2]="Information"})(ot=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class _e{constructor(M,ne,Ce){if(this.startIndex=M,this.length=ne,this.tooltip=Ce,typeof M!="number"||M<0)throw(0,F.illegalArgument)("startIndex");if(typeof ne!="number"||ne<1)throw(0,F.illegalArgument)("length");if(Ce!==void 0&&typeof Ce!="string")throw(0,F.illegalArgument)("tooltip")}}e.TerminalLink=_e;class ke{constructor(M){this.options=M,typeof M!="object"&&(0,F.illegalArgument)("options")}}e.TerminalProfile=ke;var Y;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(Y=e.TaskRevealKind||(e.TaskRevealKind={}));var W;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(W=e.TaskPanelKind||(e.TaskPanelKind={}));let Fe=f=class{constructor(M,ne){if(typeof M!="string"||typeof ne!="string")throw(0,F.illegalArgument)("name");this._id=M}static from(M){switch(M){case"clean":return f.Clean;case"build":return f.Build;case"rebuild":return f.Rebuild;case"test":return f.Test;default:return}}get id(){return this._id}};Fe.Clean=new f("clean","Clean"),Fe.Build=new f("build","Build"),Fe.Rebuild=new f("rebuild","Rebuild"),Fe.Test=new f("test","Test"),Fe=f=ze([A],Fe),e.TaskGroup=Fe;function Me(N){let M="";for(let ne=0;ne<N.length;ne++)M+=N[ne].replace(/,/g,",,")+",";return M}let tt=class{constructor(M,ne,Ce){if(typeof M!="string")throw(0,F.illegalArgument)("process");this._args=[],this._process=M,ne!==void 0&&(Array.isArray(ne)?(this._args=ne,this._options=Ce):this._options=ne)}get process(){return this._process}set process(M){if(typeof M!="string")throw(0,F.illegalArgument)("process");this._process=M}get args(){return this._args}set args(M){Array.isArray(M)||(M=[]),this._args=M}get options(){return this._options}set options(M){this._options=M}computeId(){const M=[];if(M.push("process"),this._process!==void 0&&M.push(this._process),this._args&&this._args.length>0)for(let ne of this._args)M.push(ne);return Me(M)}};tt=ze([A],tt),e.ProcessExecution=tt;let Ge=class{constructor(M,ne,Ce){if(this._args=[],Array.isArray(ne)){if(!M)throw(0,F.illegalArgument)("command can't be undefined or null");if(typeof M!="string"&&typeof M.value!="string")throw(0,F.illegalArgument)("command");this._command=M,this._args=ne,this._options=Ce}else{if(typeof M!="string")throw(0,F.illegalArgument)("commandLine");this._commandLine=M,this._options=ne}}get commandLine(){return this._commandLine}set commandLine(M){if(typeof M!="string")throw(0,F.illegalArgument)("commandLine");this._commandLine=M}get command(){return this._command?this._command:""}set command(M){if(typeof M!="string"&&typeof M.value!="string")throw(0,F.illegalArgument)("command");this._command=M}get args(){return this._args}set args(M){this._args=M||[]}get options(){return this._options}set options(M){this._options=M}computeId(){const M=[];if(M.push("shell"),this._commandLine!==void 0&&M.push(this._commandLine),this._command!==void 0&&M.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let ne of this._args)M.push(typeof ne=="string"?ne:ne.value);return Me(M)}};Ge=ze([A],Ge),e.ShellExecution=Ge;var dt;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(dt=e.ShellQuoting||(e.ShellQuoting={}));var yt;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace"})(yt=e.TaskScope||(e.TaskScope={}));class kt{constructor(M){this._callback=M}computeId(){return"customExecution"+(0,k.generateUuid)()}set callback(M){this._callback=M}get callback(){return this._callback}}e.CustomExecution=kt;let bt=v=class{constructor(M,ne,Ce,Ye,it,rt){this.__deprecated=!1,this._definition=this.definition=M;let at;typeof ne=="string"?(this._name=this.name=ne,this._source=this.source=Ce,this.execution=Ye,at=it,this.__deprecated=!0):ne===yt.Global||ne===yt.Workspace?(this.target=ne,this._name=this.name=Ce,this._source=this.source=Ye,this.execution=it,at=rt):(this.target=ne,this._name=this.name=Ce,this._source=this.source=Ye,this.execution=it,at=rt),typeof at=="string"?(this._problemMatchers=[at],this._hasDefinedMatchers=!0):Array.isArray(at)?(this._problemMatchers=at,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(M){this.__id=M}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof tt?this._definition={type:v.ProcessType,id:this._execution.computeId()}:this._execution instanceof Ge?this._definition={type:v.ShellType,id:this._execution.computeId()}:this._execution instanceof kt?this._definition={type:v.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:v.EmptyType,id:(0,k.generateUuid)()}}get definition(){return this._definition}set definition(M){if(M==null)throw(0,F.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=M}get scope(){return this._scope}set target(M){this.clear(),this._scope=M}get name(){return this._name}set name(M){if(typeof M!="string")throw(0,F.illegalArgument)("name");this.clear(),this._name=M}get execution(){return this._execution}set execution(M){M===null&&(M=void 0),this.clear(),this._execution=M;const ne=this._definition.type;(v.EmptyType===ne||v.ProcessType===ne||v.ShellType===ne||v.ExtensionCallbackType===ne)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(M){if(Array.isArray(M))this.clear(),this._problemMatchers=M,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(M){M!==!0&&M!==!1&&(M=!1),this.clear(),this._isBackground=M}get source(){return this._source}set source(M){if(typeof M!="string"||M.length===0)throw(0,F.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=M}get group(){return this._group}set group(M){M===null&&(M=void 0),this.clear(),this._group=M}get detail(){return this._detail}set detail(M){M===null&&(M=void 0),this._detail=M}get presentationOptions(){return this._presentationOptions}set presentationOptions(M){M==null&&(M=Object.create(null)),this.clear(),this._presentationOptions=M}get runOptions(){return this._runOptions}set runOptions(M){M==null&&(M=Object.create(null)),this.clear(),this._runOptions=M}};bt.ExtensionCallbackType="customExecution",bt.ProcessType="process",bt.ShellType="shell",bt.EmptyType="$empty",bt=v=ze([A],bt),e.Task=bt;var mt;(function(N){N[N.SourceControl=1]="SourceControl",N[N.Window=10]="Window",N[N.Notification=15]="Notification"})(mt=e.ProgressLocation||(e.ProgressLocation={}));let ct=class{constructor(M,ne=Et.None){this.collapsibleState=ne,b.URI.isUri(M)?this.resourceUri=M:this.label=M}};ct=ze([A],ct),e.TreeItem=ct;var Et;(function(N){N[N.None=0]="None",N[N.Collapsed=1]="Collapsed",N[N.Expanded=2]="Expanded"})(Et=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let gt=class{constructor(M,ne){this.id=M,this.color=ne}};gt=ze([A],gt),e.ThemeIcon=gt,gt.File=new gt("file"),gt.Folder=new gt("folder");let Ot=class{constructor(M){this.id=M}};Ot=ze([A],Ot),e.ThemeColor=Ot;var Pt;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.WorkspaceFolder=3]="WorkspaceFolder"})(Pt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Kt=class{constructor(M,ne){if(typeof M!="string"&&(!M||!b.URI.isUri(M)&&!b.URI.isUri(M.uri)))throw(0,F.illegalArgument)("base");if(typeof ne!="string")throw(0,F.illegalArgument)("pattern");typeof M=="string"?(this.baseFolder=b.URI.file(M),this.base=M):b.URI.isUri(M)?(this.baseFolder=M,this.base=M.fsPath):(this.baseFolder=M.uri,this.base=M.uri.fsPath),this.pattern=ne}};Kt=ze([A],Kt),e.RelativePattern=Kt;let Ut=class{constructor(M,ne,Ce,Ye){this.enabled=typeof M=="boolean"?M:!0,typeof ne=="string"&&(this.condition=ne),typeof Ce=="string"&&(this.hitCondition=Ce),typeof Ye=="string"&&(this.logMessage=Ye)}get id(){return this._id||(this._id=(0,k.generateUuid)()),this._id}};Ut=ze([A],Ut),e.Breakpoint=Ut;let Ct=class extends Ut{constructor(M,ne,Ce,Ye,it){super(ne,Ce,Ye,it);if(M===null)throw(0,F.illegalArgument)("location");this.location=M}};Ct=ze([A],Ct),e.SourceBreakpoint=Ct;let Qt=class extends Ut{constructor(M,ne,Ce,Ye,it){super(ne,Ce,Ye,it);this.functionName=M}};Qt=ze([A],Qt),e.FunctionBreakpoint=Qt;let Yt=class extends Ut{constructor(M,ne,Ce,Ye,it,rt,at){super(Ye,it,rt,at);if(!ne)throw(0,F.illegalArgument)("dataId");this.label=M,this.dataId=ne,this.canPersist=Ce}};Yt=ze([A],Yt),e.DataBreakpoint=Yt;let pt=class{constructor(M,ne,Ce){this.command=M,this.args=ne||[],this.options=Ce}};pt=ze([A],pt),e.DebugAdapterExecutable=pt;let qt=class{constructor(M,ne){this.port=M,this.host=ne}};qt=ze([A],qt),e.DebugAdapterServer=qt;let zt=class{constructor(M){this.path=M}};zt=ze([A],zt),e.DebugAdapterNamedPipeServer=zt;let Jt=class{constructor(M){this.implementation=M}};Jt=ze([A],Jt),e.DebugAdapterInlineImplementation=Jt;let Xt=class{constructor(M,ne){this.range=M,this.expression=ne}};Xt=ze([A],Xt),e.EvaluatableExpression=Xt;var At;(function(N){N[N.Automatic=0]="Automatic",N[N.Explicit=1]="Explicit"})(At=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let jt=class{constructor(M,ne){this.range=M,this.text=ne}};jt=ze([A],jt),e.InlineValueText=jt;let Zt=class{constructor(M,ne,Ce=!0){this.range=M,this.variableName=ne,this.caseSensitiveLookup=Ce}};Zt=ze([A],Zt),e.InlineValueVariableLookup=Zt;let Ht=class{constructor(M,ne){this.range=M,this.expression=ne}};Ht=ze([A],Ht),e.InlineValueEvaluatableExpression=Ht;let ht=class{constructor(M,ne){this.frameId=M,this.stoppedLocation=ne}};ht=ze([A],ht),e.InlineValueContext=ht;var bn;(function(N){N[N.Changed=1]="Changed",N[N.Created=2]="Created",N[N.Deleted=3]="Deleted"})(bn=e.FileChangeType||(e.FileChangeType={}));let Rt=D=class extends Error{constructor(M,ne=n.FileSystemProviderErrorCode.Unknown,Ce){super(b.URI.isUri(M)?M.toString(!0):M);this.code=Ce?.name??"Unknown",(0,n.markAsFileSystemProviderError)(this,ne),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,D.prototype),typeof Error.captureStackTrace=="function"&&typeof Ce=="function"&&Error.captureStackTrace(this,Ce)}static FileExists(M){return new D(M,n.FileSystemProviderErrorCode.FileExists,D.FileExists)}static FileNotFound(M){return new D(M,n.FileSystemProviderErrorCode.FileNotFound,D.FileNotFound)}static FileNotADirectory(M){return new D(M,n.FileSystemProviderErrorCode.FileNotADirectory,D.FileNotADirectory)}static FileIsADirectory(M){return new D(M,n.FileSystemProviderErrorCode.FileIsADirectory,D.FileIsADirectory)}static NoPermissions(M){return new D(M,n.FileSystemProviderErrorCode.NoPermissions,D.NoPermissions)}static Unavailable(M){return new D(M,n.FileSystemProviderErrorCode.Unavailable,D.Unavailable)}};Rt=D=ze([A],Rt),e.FileSystemError=Rt;let xt=class{constructor(M,ne,Ce){this.start=M,this.end=ne,this.kind=Ce}};xt=ze([A],xt),e.FoldingRange=xt;var cn;(function(N){N[N.Comment=1]="Comment",N[N.Imports=2]="Imports",N[N.Region=3]="Region"})(cn=e.FoldingRangeKind||(e.FoldingRangeKind={}));var En;(function(N){N[N.Collapsed=0]="Collapsed",N[N.Expanded=1]="Expanded"})(En=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var dn;(function(N){N[N.Editing=0]="Editing",N[N.Preview=1]="Preview"})(dn=e.CommentMode||(e.CommentMode={}));class _n{constructor(M,ne=[]){this.tokenTypes=M,this.tokenModifiers=ne}}e.SemanticTokensLegend=_n;function hn(N){return typeof N=="undefined"||(0,y.isStringArray)(N)}class Vt{constructor(M){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,M){this._hasLegend=!0;for(let ne=0,Ce=M.tokenTypes.length;ne<Ce;ne++)this._tokenTypeStrToInt.set(M.tokenTypes[ne],ne);for(let ne=0,Ce=M.tokenModifiers.length;ne<Ce;ne++)this._tokenModifierStrToInt.set(M.tokenModifiers[ne],ne)}}push(M,ne,Ce,Ye,it){if(typeof M=="number"&&typeof ne=="number"&&typeof Ce=="number"&&typeof Ye=="number"&&(typeof it=="number"||typeof it=="undefined"))return typeof it=="undefined"&&(it=0),this._pushEncoded(M,ne,Ce,Ye,it);if(oe.isRange(M)&&typeof ne=="string"&&hn(Ce))return this._push(M,ne,Ce);throw(0,F.illegalArgument)()}_push(M,ne,Ce){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(M.start.line!==M.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ne))throw new Error("`tokenType` is not in the provided legend");const Ye=M.start.line,it=M.start.character,rt=M.end.character-M.start.character,at=this._tokenTypeStrToInt.get(ne);let St=0;if(Ce)for(const It of Ce){if(!this._tokenModifierStrToInt.has(It))throw new Error("`tokenModifier` is not in the provided legend");const Ft=this._tokenModifierStrToInt.get(It);St|=1<<Ft>>>0}this._pushEncoded(Ye,it,rt,at,St)}_pushEncoded(M,ne,Ce,Ye,it){if(this._dataIsSortedAndDeltaEncoded&&(M<this._prevLine||M===this._prevLine&&ne<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const St=this._data.length/5|0;let It=0,Ft=0;for(let Nt=0;Nt<St;Nt++){let $t=this._data[5*Nt],ln=this._data[5*Nt+1];$t===0?($t=It,ln+=Ft):$t+=It,this._data[5*Nt]=$t,this._data[5*Nt+1]=ln,It=$t,Ft=ln}}let rt=M,at=ne;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(rt-=this._prevLine,rt===0&&(at-=this._prevChar)),this._data[this._dataLen++]=rt,this._data[this._dataLen++]=at,this._data[this._dataLen++]=Ce,this._data[this._dataLen++]=Ye,this._data[this._dataLen++]=it,this._prevLine=M,this._prevChar=ne}static _sortAndDeltaEncode(M){let ne=[];const Ce=M.length/5|0;for(let at=0;at<Ce;at++)ne[at]=at;ne.sort((at,St)=>{const It=M[5*at],Ft=M[5*St];if(It===Ft){const Nt=M[5*at+1],$t=M[5*St+1];return Nt-$t}return It-Ft});const Ye=new Uint32Array(M.length);let it=0,rt=0;for(let at=0;at<Ce;at++){const St=5*ne[at],It=M[St+0],Ft=M[St+1],Nt=M[St+2],$t=M[St+3],ln=M[St+4],On=It-it,qn=On===0?Ft-rt:Ft,un=5*at;Ye[un+0]=On,Ye[un+1]=qn,Ye[un+2]=Nt,Ye[un+3]=$t,Ye[un+4]=ln,it=It,rt=Ft}return Ye}build(M){return this._dataIsSortedAndDeltaEncoded?new en(new Uint32Array(this._data),M):new en(Vt._sortAndDeltaEncode(this._data),M)}}e.SemanticTokensBuilder=Vt;class en{constructor(M,ne){this.resultId=ne,this.data=M}}e.SemanticTokens=en;class tn{constructor(M,ne,Ce){this.start=M,this.deleteCount=ne,this.data=Ce}}e.SemanticTokensEdit=tn;class nn{constructor(M,ne){this.resultId=ne,this.edits=M}}e.SemanticTokensEdits=nn;var yn;(function(N){N[N.Separate=0]="Separate",N[N.MergeWithParent=1]="MergeWithParent"})(yn=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Sn;(function(N){N[N.Initial=1]="Initial",N[N.Dynamic=2]="Dynamic"})(Sn=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Mt=class{constructor(){}};Mt.Back={iconPath:new gt("arrow-left")},Mt=ze([A],Mt),e.QuickInputButtons=Mt;var Dn;(function(N){N[N.UI=1]="UI",N[N.Workspace=2]="Workspace"})(Dn=e.ExtensionKind||(e.ExtensionKind={}));class Cn{constructor(M,ne,Ce){this.badge=M,this.tooltip=ne,this.color=Ce}static validate(M){if(M.badge&&M.badge.length!==1&&M.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!M.color&&!M.badge&&!M.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=Cn;let rn=class{constructor(M){this.kind=M}};rn=ze([A],rn),e.ColorTheme=rn;var kn;(function(N){N[N.Light=1]="Light",N[N.Dark=2]="Dark",N[N.HighContrast=3]="HighContrast"})(kn=e.ColorThemeKind||(e.ColorThemeKind={}));class Bt{constructor(M,ne){if(M<0)throw(0,F.illegalArgument)("start must be positive");if(ne<0)throw(0,F.illegalArgument)("end must be positive");M<=ne?(this._start=M,this._end=ne):(this._start=ne,this._end=M)}static isNotebookRange(M){return M instanceof Bt?!0:M?typeof M.start=="number"&&typeof M.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(M){let ne=this._start,Ce=this._end;return M.start!==void 0&&(ne=M.start),M.end!==void 0&&(Ce=M.end),ne===this._start&&Ce===this._end?this:new Bt(ne,Ce)}}e.NotebookRange=Bt;class Lt{constructor(M,ne,Ce,Ye,it,rt,at){this.kind=M,this.value=ne,this.languageId=Ce,this.mime=Ye,this.outputs=it??[],this.metadata=rt,this.executionSummary=at,Lt.validate(this)}static validate(M){if(typeof M.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof M.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof M.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(M){return Array.isArray(M)&&M.every(ne=>Lt.isNotebookCellData(ne))}static isNotebookCellData(M){return!0}}e.NotebookCellData=Lt;class fn{constructor(M){this.cells=M}}e.NotebookData=fn;class Tt{constructor(M,ne){this.data=M,this.mime=ne;const Ce=(0,C.normalizeMimeType)(ne,!0);if(!Ce)throw new Error("INVALID mime type, must not be empty or falsy: "+ne);this.mime=Ce}static isNotebookCellOutputItem(M){return M instanceof Tt?!0:M?typeof M.mime=="string"&&M.data instanceof Uint8Array:!1}static error(M){const ne={name:M.name,message:M.message,stack:M.stack};return Tt.json(ne,"application/vnd.code.notebook.error")}static stdout(M){return Tt.text(M,"application/vnd.code.notebook.stdout")}static stderr(M){return Tt.text(M,"application/vnd.code.notebook.stderr")}static bytes(M,ne="application/octet-stream"){return new Tt(M,ne)}static text(M,ne=C.Mimes.text){const Ce=Ue(Tt,c,"f",m).encode(String(M));return new Tt(Ce,ne)}static json(M,ne="application/json"){const Ce=JSON.stringify(M,void 0,"	");return Tt.text(Ce,ne)}}e.NotebookCellOutputItem=Tt,c=Tt,m={value:new TextEncoder};class Ne{constructor(M,ne,Ce){this.items=Ne.ensureUniqueMimeTypes(M,!0),typeof ne=="string"?(this.id=ne,this.metadata=Ce):(this.id=(0,k.generateUuid)(),this.metadata=ne??Ce)}static isNotebookCellOutput(M){return M instanceof Ne?!0:!M||typeof M!="object"?!1:typeof M.id=="string"&&(0,y.isArray)(M.items)}static ensureUniqueMimeTypes(M,ne=!1){const Ce=new Set,Ye=new Set;for(let it=0;it<M.length;it++){const rt=M[it],at=(0,C.normalizeMimeType)(rt.mime);if(!Ce.has(at)){Ce.add(at);continue}Ye.add(it),ne&&console.warn(`DUPLICATED mime type '${rt.mime}' will be dropped`)}return Ye.size===0?M:M.filter((it,rt)=>!Ye.has(rt))}}e.NotebookCellOutput=Ne;var sn;(function(N){N[N.Markup=1]="Markup",N[N.Code=2]="Code"})(sn=e.NotebookCellKind||(e.NotebookCellKind={}));var mn;(function(N){N[N.Idle=1]="Idle",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(mn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var vt;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(vt=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var In;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(In=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Pn{constructor(M,ne){this.text=M,this.alignment=ne}}e.NotebookCellStatusBarItem=Pn;var gn;(function(N){N[N.Default=1]="Default",N[N.Preferred=2]="Preferred"})(gn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class pn{constructor(M,ne=[]){this.uri=M,this.provides=(0,g.asArray)(ne)}}e.NotebookRendererScript=pn;let on=class{constructor(M,ne){this.label=M,this.timestamp=ne}};on=ze([A],on),e.TimelineItem=on;var An;(function(N){N[N.Production=1]="Production",N[N.Development=2]="Development",N[N.Test=3]="Test"})(An=e.ExtensionMode||(e.ExtensionMode={}));var Tn;(function(N){N[N.Node=1]="Node",N[N.Webworker=2]="Webworker"})(Tn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Rn;(function(N){N[N.Other=0]="Other",N[N.Comment=1]="Comment",N[N.String=2]="String",N[N.RegEx=4]="RegEx"})(Rn=e.StandardTokenType||(e.StandardTokenType={}));class vn{constructor(M,ne){this.ranges=M,this.wordPattern=ne}}e.LinkedEditingRanges=vn;class Fn{constructor(M,ne){this._port=M,this._autoForwardAction=ne}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Fn;var Mn;(function(N){N[N.Queued=1]="Queued",N[N.Running=2]="Running",N[N.Passed=3]="Passed",N[N.Failed=4]="Failed",N[N.Skipped=5]="Skipped",N[N.Errored=6]="Errored"})(Mn=e.TestResultState||(e.TestResultState={}));var Ln;(function(N){N[N.Error=0]="Error",N[N.Warning=1]="Warning",N[N.Information=2]="Information",N[N.Hint=3]="Hint"})(Ln=e.TestMessageSeverity||(e.TestMessageSeverity={}));var Nn;(function(N){N[N.Run=1]="Run",N[N.Debug=2]="Debug",N[N.Coverage=3]="Coverage"})(Nn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let an=class{constructor(M,ne,Ce){this.include=M,this.exclude=ne,this.profile=Ce}};an=ze([A],an),e.TestRunRequest=an;let J=T=class{constructor(M){this.message=M}static diff(M,ne,Ce){const Ye=new T(M);return Ye.expectedOutput=ne,Ye.actualOutput=Ce,Ye}};J=T=ze([A],J),e.TestMessage=J;let le=class{constructor(M,ne){this.covered=M,this.total=ne}};le=ze([A],le),e.CoveredCount=le;let Ae=o=class{constructor(M,ne,Ce,Ye){this.uri=M,this.statementCoverage=ne,this.branchCoverage=Ce,this.functionCoverage=Ye}static fromDetails(M,ne){const Ce=new le(0,0),Ye=new le(0,0),it=new le(0,0);for(const at of ne)if("branches"in at){Ce.total+=1,Ce.covered+=at.executionCount>0?1:0;for(const St of at.branches)Ye.total+=1,Ye.covered+=St.executionCount>0?1:0}else it.total+=1,it.covered+=at.executionCount>0?1:0;const rt=new o(M,Ce,Ye.total>0?Ye:void 0,it.total>0?it:void 0);return rt.detailedCoverage=ne,rt}};Ae=o=ze([A],Ae),e.FileCoverage=Ae;let st=class{constructor(M,ne,Ce=[]){this.executionCount=M,this.location=ne,this.branches=Ce}};st=ze([A],st),e.StatementCoverage=st;let wt=class{constructor(M,ne){this.executionCount=M,this.location=ne}};wt=ze([A],wt),e.BranchCoverage=wt;let Dt=class{constructor(M,ne){this.executionCount=M,this.location=ne}};Dt=ze([A],Dt),e.FunctionCoverage=Dt;var Wn;(function(N){N[N.None=0]="None",N[N.Option=1]="Option",N[N.Default=2]="Default",N[N.Preferred=3]="Preferred"})(Wn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Hn;(function(N){N[N.Untrusted=0]="Untrusted",N[N.Trusted=1]="Trusted",N[N.Unspecified=2]="Unspecified"})(Hn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var zn;(function(N){N[N.Notify=1]="Notify",N[N.OpenBrowser=2]="OpenBrowser",N[N.OpenPreview=3]="OpenPreview",N[N.Silent=4]="Silent",N[N.Ignore=5]="Ignore",N[N.OpenBrowserOnce=6]="OpenBrowserOnce"})(zn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class Vn{constructor(M,ne,Ce,Ye,it,rt){this.kind=M,this.name=ne,this.detail=Ce,this.uri=Ye,this.range=it,this.selectionRange=rt}}e.TypeHierarchyItem=Vn}),define(be[98],Ee([0,1,40,11,8,124,88,7,17]),function(ee,e,g,F,S,_,C,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const k=new Map;function n(c,m){m?k.set(c,m):k.delete(c)}e.setWordDefinitionFor=n;function I(c){return k.get(c)}e.getWordDefinitionFor=I;class l extends _.MirrorTextModel{constructor(m,E,w,P,a,h,p,t){super(E,w,P,a);this._proxy=m,this._languageId=h,this._isDirty=p,this._notebook=t,this._isDisposed=!1}dispose(){(0,g.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(m){return(0,b.equals)(this._lines,m)}get document(){if(!this._document){const m=this;this._document={get uri(){return m._uri},get fileName(){return m._uri.fsPath},get isUntitled(){return m._uri.scheme===F.Schemas.untitled},get languageId(){return m._languageId},get version(){return m._versionId},get isClosed(){return m._isDisposed},get isDirty(){return m._isDirty},get notebook(){return m._notebook},save(){return m._save()},getText(E){return E?m._getTextInRange(E):m.getText()},get eol(){return m._eol===`
`?y.EndOfLine.LF:y.EndOfLine.CRLF},get lineCount(){return m._lines.length},lineAt(E){return m._lineAt(E)},offsetAt(E){return m._offsetAt(E)},positionAt(E){return m._positionAt(E)},validateRange(E){return m._validateRange(E)},validatePosition(E){return m._validatePosition(E)},getWordRangeAtPosition(E,w){return m._getWordRangeAtPosition(E,w)}}}return Object.freeze(this._document)}_acceptLanguageId(m){(0,g.ok)(!this._isDisposed),this._languageId=m}_acceptIsDirty(m){(0,g.ok)(!this._isDisposed),this._isDirty=m}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(m){const E=this._validateRange(m);if(E.isEmpty)return"";if(E.isSingleLine)return this._lines[E.start.line].substring(E.start.character,E.end.character);const w=this._eol,P=E.start.line,a=E.end.line,h=[];h.push(this._lines[P].substring(E.start.character));for(let p=P+1;p<a;p++)h.push(this._lines[p]);return h.push(this._lines[a].substring(0,E.end.character)),h.join(w)}_lineAt(m){let E;if(m instanceof y.Position?E=m.line:typeof m=="number"&&(E=m),typeof E!="number"||E<0||E>=this._lines.length||Math.floor(E)!==E)throw new Error("Illegal value for `line`");return new d(E,this._lines[E],E===this._lines.length-1)}_offsetAt(m){return m=this._validatePosition(m),this._ensureLineStarts(),this._lineStarts.getPrefixSum(m.line-1)+m.character}_positionAt(m){m=Math.floor(m),m=Math.max(0,m),this._ensureLineStarts();const E=this._lineStarts.getIndexOf(m),w=this._lines[E.index].length;return new y.Position(E.index,Math.min(E.remainder,w))}_validateRange(m){if(!(m instanceof y.Range))throw new Error("Invalid argument");const E=this._validatePosition(m.start),w=this._validatePosition(m.end);return E===m.start&&w===m.end?m:new y.Range(E.line,E.character,w.line,w.character)}_validatePosition(m){if(!(m instanceof y.Position))throw new Error("Invalid argument");if(this._lines.length===0)return m.with(0,0);let{line:E,character:w}=m,P=!1;if(E<0)E=0,w=0,P=!0;else if(E>=this._lines.length)E=this._lines.length-1,w=this._lines[E].length,P=!0;else{const a=this._lines[E].length;w<0?(w=0,P=!0):w>a&&(w=a,P=!0)}return P?new y.Position(E,w):m}_getWordRangeAtPosition(m,E){const w=this._validatePosition(m);if(!E)E=I(this._languageId);else if((0,S.regExpLeadsToEndlessLoop)(E))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${E.source}' because it matches the empty string.`);const P=(0,C.getWordAtText)(w.character+1,(0,C.ensureValidWordDefinition)(E),this._lines[w.line],0);if(P)return new y.Range(w.line,P.startColumn-1,w.line,P.endColumn-1)}}e.ExtHostDocumentData=l;class d{constructor(m,E,w){this._line=m,this._text=E,this._isLastLine=w}get lineNumber(){return this._line}get text(){return this._text}get range(){return new y.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new y.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=d}),define(be[165],Ee([0,1,7,3,90,6,57,21,2,36]),function(ee,e,g,F,S,_,C,y,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class n{constructor(l,d,c,m){this._notebook=c,this._selector=m,this._disposables=new _.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new F.Emitter,this.onDidChange=this._onDidChange.event,this.uri=b.URI.from({scheme:"vscode-concat-doc",path:(0,k.generateUuid)()}),this._init(),this._disposables.add(d.onDidChangeDocument(w=>{const P=this._cellUris.get(w.document.uri);P!==void 0&&(this._cellLengths.changeValue(P,this._cells[P].document.getText().length+1),this._cellLines.changeValue(P,this._cells[P].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const E=w=>{w===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(l.onDidChangeNotebookCells(w=>E(w.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new y.ResourceMap;const l=[],d=[];for(const c of this._notebook.getCells())c.kind===g.NotebookCellKind.Code&&(!this._selector||(0,C.score)(this._selector,c.document.uri,c.document.languageId,!0))&&(this._cellUris.set(c.document.uri,this._cells.length),this._cells.push(c),l.push(c.document.getText().length+1),d.push(c.document.lineCount));this._cellLengths=new S.PrefixSumComputer(new Uint32Array(l)),this._cellLines=new S.PrefixSumComputer(new Uint32Array(d))}get version(){return this._versionId}getText(l){if(!l){let P="";for(const a of this._cells)P+=a.document.getText()+`
`;return P=P.slice(0,-1),P}if(l.isEmpty)return"";const d=this.locationAt(l.start),c=this.locationAt(l.end),m=this._cellUris.get(d.uri),E=this._cellUris.get(c.uri);if(m===void 0||E===void 0)return"";if(m===E)return this._cells[m].document.getText(new g.Range(d.range.start,c.range.end));const w=[this._cells[m].document.getText(new g.Range(d.range.start,new g.Position(this._cells[m].document.lineCount,0)))];for(let P=m+1;P<E;P++)w.push(this._cells[P].document.getText());return w.push(this._cells[E].document.getText(new g.Range(new g.Position(0,0),c.range.end))),w.join(`
`)}offsetAt(l){const d=this._cellLines.getIndexOf(l.line),c=this._cellLengths.getPrefixSum(d.index-1),m=this._cells[d.index].document.offsetAt(l.with(d.remainder));return c+m}positionAt(l){if(typeof l=="number"){const c=this._cellLengths.getIndexOf(l),m=this._cellLines.getPrefixSum(c.index-1);return this._cells[c.index].document.positionAt(c.remainder).translate(m)}const d=this._cellUris.get(l.uri);if(d!==void 0){const c=this._cellLines.getPrefixSum(d-1);return new g.Position(c+l.range.start.line,l.range.start.character)}return new g.Position(0,0)}locationAt(l){g.Range.isRange(l)||(l=new g.Range(l,l));const d=this._cellLines.getIndexOf(l.start.line);let c=d;l.isEmpty||(c=this._cellLines.getIndexOf(l.end.line));const m=new g.Position(d.remainder,l.start.character),E=new g.Position(c.remainder,l.end.character),w=new g.Range(m,E),P=this._cells[d.index];return new g.Location(P.document.uri,P.document.validateRange(w))}contains(l){return this._cellUris.has(l)}validateRange(l){const d=this.validatePosition(l.start),c=this.validatePosition(l.end);return l.with(d,c)}validatePosition(l){const d=this._cellLines.getIndexOf(l.line),c=new g.Position(d.remainder,l.character),m=this._cells[d.index].document.validatePosition(c),E=this._cellLines.getPrefixSum(d.index-1);return new g.Position(E+m.line,m.character)}}e.ExtHostNotebookConcatDocument=n}),define(be[166],Ee([0,1,7,13,3]),function(ee,e,g,F,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let _=class{constructor(y){this._actual=new g.ColorTheme(g.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new S.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(y){let b=y==="light"?g.ColorThemeKind.Light:y==="dark"?g.ColorThemeKind.Dark:g.ColorThemeKind.HighContrast;this._actual=new g.ColorTheme(b),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};_=ze([qe(0,F.IExtHostRpcService)],_),e.ExtHostTheming=_}),define(be[69],Ee([0,1,4]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,g.createDecorator)("IURITransformerService");class F{constructor(_){_?(this.transformIncoming=_.transformIncoming.bind(_),this.transformOutgoing=_.transformOutgoing.bind(_),this.transformOutgoingURI=_.transformOutgoingURI.bind(_),this.transformOutgoingScheme=_.transformOutgoingScheme.bind(_)):(this.transformIncoming=C=>C,this.transformOutgoing=C=>C,this.transformOutgoingURI=C=>C,this.transformOutgoingScheme=C=>C)}}e.URITransformerService=F}),define(be[167],Ee([0,1,24]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class F{constructor(){this.buffers=[]}add(b){let k=this.buffers.indexOf(b);return k<0&&(k=this.buffers.length,this.buffers.push(b)),k}}function S(y,b){if(b.serializeBuffersForPostMessage){const k=new F,n=(d,c)=>{if(c instanceof ArrayBuffer){const m=k.add(c);return{$$vscode_array_buffer_reference$$:!0,index:m}}else if(ArrayBuffer.isView(c)){const m=_(c);if(m){const E=k.add(c.buffer);return{$$vscode_array_buffer_reference$$:!0,index:E,view:{type:m,byteLength:c.byteLength,byteOffset:c.byteOffset}}}}return c},I=JSON.stringify(y,n),l=k.buffers.map(d=>{const c=new Uint8Array(d);return g.VSBuffer.wrap(c)});return{message:I,buffers:l}}else return{message:JSON.stringify(y),buffers:[]}}e.serializeWebviewMessage=S;function _(y){switch(y.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function C(y,b){const k=b.map(l=>{const d=new ArrayBuffer(l.byteLength);return new Uint8Array(d).set(l.buffer),d}),n=b.length?(l,d)=>{if(typeof d=="object"&&d.$$vscode_array_buffer_reference$$){const c=d,{index:m}=c,E=k[m];if(c.view)switch(c.view.type){case 1:return new Int8Array(E,c.view.byteOffset,c.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(E,c.view.byteOffset,c.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(E,c.view.byteOffset,c.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(E,c.view.byteOffset,c.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(E,c.view.byteOffset,c.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(E,c.view.byteOffset,c.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(E,c.view.byteOffset,c.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(E,c.view.byteOffset,c.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(E,c.view.byteOffset,c.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(E,c.view.byteOffset,c.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(E,c.view.byteOffset,c.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return E}return d}:void 0;return{message:JSON.parse(y,n),arrayBuffers:k}}e.deserializeWebviewMessage=C}),define(be[168],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var g;(function(F){function S(C){const y={items:new Map};return C.types.forEach((b,k)=>{y.items.set(b,{asString:async()=>C.items[k].asString})}),y}F.toITreeDataTransfer=S;async function _(C){const y={types:[],items:[]},b=Array.from(C.items.entries());for(const k of b)y.types.push(k[0]),y.items.push({asString:await k[1].asString()});return y}F.toTreeDataTransferDTO=_})(g=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(be[70],Ee([0,1,11,2]),function(ee,e,g,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function S(_,C){return _.scheme===g.Schemas.http||_.scheme===g.Schemas.https?_:(C&&C.authority&&C.isRemote&&_.scheme===g.Schemas.file&&(_=F.URI.from({scheme:g.Schemas.vscodeRemote,authority:C.authority,path:_.path})),F.URI.from({scheme:g.Schemas.https,authority:`${_.scheme}+${_.authority}.${e.webviewRootResourceAuthority}`,path:_.path,fragment:_.fragment,query:_.query}))}e.asWebviewUri=S}),define(be[169],Ee([0,1,3,6,70]),function(ee,e,g,F,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class _{constructor(y,b,k){this._proxy=y,this._editors=b,this._initData=k,this._handlePool=0,this._disposables=new F.DisposableStore,this._insets=new Map,this._disposables.add(b.onDidChangeVisibleTextEditors(()=>{const n=b.getVisibleTextEditors();for(const I of this._insets.values())n.indexOf(I.editor)<0&&I.inset.dispose()}))}dispose(){this._insets.forEach(y=>y.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(y,b,k,n,I){let l;for(const a of this._editors.getVisibleTextEditors(!0))if(a.value===y){l=a;break}if(!l)throw new Error("not a visible editor");const d=this,c=this._handlePool++,m=new g.Emitter,E=new g.Emitter,w=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(a){return(0,S.asWebviewUri)(a,d._initData.remote)}get cspSource(){return S.webviewGenericCspSource}set options(a){this._options=a,d._proxy.$setOptions(c,a)}get options(){return this._options}set html(a){this._html=a,d._proxy.$setHtml(c,a)}get html(){return this._html}get onDidReceiveMessage(){return m.event}postMessage(a){return d._proxy.$postMessage(c,a)}},P=new class{constructor(){this.editor=y,this.line=b,this.height=k,this.webview=w,this.onDidDispose=E.event}dispose(){d._insets.has(c)&&(d._insets.delete(c),d._proxy.$disposeEditorInset(c),E.fire(),E.dispose(),m.dispose())}};return this._proxy.$createEditorInset(c,l.id,l.value.document.uri,b+1,k,n||{},I.identifier,I.extensionLocation),this._insets.set(c,{editor:y,inset:P,onDidReceiveMessage:m}),P}$onDidDispose(y){const b=this._insets.get(y);b&&b.inset.dispose()}$onDidReceiveMessage(y,b){const k=this._insets.get(y);k&&k.onDidReceiveMessage.fire(b)}}e.ExtHostEditorInsets=_}),define(be[170],Ee([0,1,140,10,2,6,4,45,28,17,11]),function(ee,e,g,F,S,_,C,y,b,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.isTextEditorPane=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,g.localize)(0,null),providerDisplayName:(0,g.localize)(1,null)},e.ActiveEditorDirtyContext=new y.RawContextKey("activeEditorIsDirty",!1,(0,g.localize)(2,null)),e.ActiveEditorPinnedContext=new y.RawContextKey("activeEditorIsNotPreview",!1,(0,g.localize)(3,null)),e.ActiveEditorStickyContext=new y.RawContextKey("activeEditorIsPinned",!1,(0,g.localize)(4,null)),e.ActiveEditorReadonlyContext=new y.RawContextKey("activeEditorIsReadonly",!1,(0,g.localize)(5,null)),e.ActiveEditorCanRevertContext=new y.RawContextKey("activeEditorCanRevert",!1,(0,g.localize)(6,null)),e.ActiveEditorContext=new y.RawContextKey("activeEditor",null,{type:"string",description:(0,g.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new y.RawContextKey("activeEditorAvailableEditorIds","",(0,g.localize)(8,null)),e.TextCompareEditorVisibleContext=new y.RawContextKey("textCompareEditorVisible",!1,(0,g.localize)(9,null)),e.TextCompareEditorActiveContext=new y.RawContextKey("textCompareEditorActive",!1,(0,g.localize)(10,null)),e.EditorGroupEditorsCountContext=new y.RawContextKey("groupEditorsCount",0,(0,g.localize)(11,null)),e.ActiveEditorGroupEmptyContext=new y.RawContextKey("activeEditorGroupEmpty",!1,(0,g.localize)(12,null)),e.ActiveEditorGroupIndexContext=new y.RawContextKey("activeEditorGroupIndex",0,(0,g.localize)(13,null)),e.ActiveEditorGroupLastContext=new y.RawContextKey("activeEditorGroupLast",!1,(0,g.localize)(14,null)),e.MultipleEditorGroupsContext=new y.RawContextKey("multipleEditorGroups",!1,(0,g.localize)(15,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new y.RawContextKey("editorIsOpen",!1,(0,g.localize)(16,null)),e.InEditorZenModeContext=new y.RawContextKey("inZenMode",!1,(0,g.localize)(17,null)),e.IsCenteredLayoutContext=new y.RawContextKey("isCenteredLayout",!1,(0,g.localize)(18,null)),e.SplitEditorsVertically=new y.RawContextKey("splitEditorsVertically",!1,(0,g.localize)(19,null)),e.EditorAreaVisibleContext=new y.RawContextKey("editorAreaVisible",!0,(0,g.localize)(20,null)),e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function I(o){return typeof o?.getViewState=="function"}e.isTextEditorPane=I;function l(o){if(a(o))return!1;const A=o;return S.URI.isUri(A?.resource)}e.isResourceEditorInput=l;function d(o){if(a(o))return!1;const A=o;return A?.original!==void 0&&A.modified!==void 0}e.isResourceDiffEditorInput=d;function c(o){if(a(o))return!1;const A=o;return A?A?.resource===void 0||A.resource.scheme===n.Schemas.untitled||A.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=c;var m;(function(o){o[o.SHORT=0]="SHORT",o[o.MEDIUM=1]="MEDIUM",o[o.LONG=2]="LONG"})(m=e.Verbosity||(e.Verbosity={}));var E;(function(o){o[o.EXPLICIT=1]="EXPLICIT",o[o.AUTO=2]="AUTO",o[o.FOCUS_CHANGE=3]="FOCUS_CHANGE",o[o.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(E=e.SaveReason||(e.SaveReason={}));var w;(function(o){o[o.None=0]="None",o[o.Readonly=2]="Readonly",o[o.Untitled=4]="Untitled",o[o.Singleton=8]="Singleton",o[o.RequiresTrust=16]="RequiresTrust"})(w=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class P extends _.Disposable{}e.AbstractEditorInput=P;function a(o){return o instanceof P}e.isEditorInput=a;function h(o){const A=o;return S.URI.isUri(A?.preferredResource)}function p(o){const A=o;return a(A?.primary)&&a(A?.secondary)}e.isSideBySideEditorInput=p;function t(o){return a(o?.editor)}e.isEditorInputWithOptions=t;function r(o){const A=o;return t(o)&&A?.group!==void 0}e.isEditorInputWithOptionsAndGroup=r;function s(o){const A=o;return typeof A?.groupId=="number"&&a(A.editor)}e.isEditorIdentifier=s;var i;(function(o){o[o.PRIMARY=1]="PRIMARY",o[o.SECONDARY=2]="SECONDARY",o[o.BOTH=3]="BOTH"})(i=e.SideBySideEditor||(e.SideBySideEditor={}));class u{getOriginalUri(A,L){if(!A)return;const B=p(A)?A.primary:d(A)?A.modified:void 0,oe=p(A)?A.secondary:d(A)?A.original:void 0;if(L?.supportSideBySide&&B&&oe){if(L?.supportSideBySide===i.BOTH)return{primary:this.getOriginalUri(B,{filterByScheme:L.filterByScheme}),secondary:this.getOriginalUri(oe,{filterByScheme:L.filterByScheme})};A=L.supportSideBySide===i.PRIMARY?B:oe}if(d(A))return;const he=h(A)?A.preferredResource:A.resource;return!he||!L||!L.filterByScheme?he:this.filterUri(he,L.filterByScheme)}getCanonicalUri(A,L){if(!A)return;const B=p(A)?A.primary:d(A)?A.modified:void 0,oe=p(A)?A.secondary:d(A)?A.original:void 0;if(L?.supportSideBySide&&B&&oe){if(L?.supportSideBySide===i.BOTH)return{primary:this.getCanonicalUri(B,{filterByScheme:L.filterByScheme}),secondary:this.getCanonicalUri(oe,{filterByScheme:L.filterByScheme})};A=L.supportSideBySide===i.PRIMARY?B:oe}if(d(A))return;const he=A.resource;return!he||!L||!L.filterByScheme?he:this.filterUri(he,L.filterByScheme)}filterUri(A,L){if(Array.isArray(L)){if(L.some(B=>A.scheme===B))return A}else if(L===A.scheme)return A}}e.EditorResourceAccessor=new u;var f;(function(o){o[o.LEFT=0]="LEFT",o[o.RIGHT=1]="RIGHT"})(f=e.CloseDirection||(e.CloseDirection={}));class v{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(A){const L=this.instantiationService=A.get(C.IInstantiationService);for(const[B,oe]of this.editorSerializerConstructors)this.createEditorSerializer(B,oe,L);this.editorSerializerConstructors.clear()}createEditorSerializer(A,L,B){const oe=B.createInstance(L);this.editorSerializerInstances.set(A,oe)}registerFileEditorFactory(A){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=A}getFileEditorFactory(){return(0,F.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(A,L){if(this.editorSerializerConstructors.has(A)||this.editorSerializerInstances.has(A))throw new Error(`A editor serializer with type ID '${A}' was already registered.`);return this.instantiationService?this.createEditorSerializer(A,L,this.instantiationService):this.editorSerializerConstructors.set(A,L),(0,_.toDisposable)(()=>{this.editorSerializerConstructors.delete(A),this.editorSerializerInstances.delete(A)})}getEditorSerializer(A){return this.editorSerializerInstances.get(typeof A=="string"?A:A.typeId)}}b.Registry.add(e.EditorExtensions.EditorFactory,new v);async function D(o,A){if(!o||!o.length)return[];const L=await Promise.all(o.map(async B=>{const oe=S.URI.revive(B.fileUri);if(!oe||(await A.activateProvider(oe.scheme),!A.canHandleResource(oe)))return;const he=typeof B.exists=="boolean"?B.exists:await A.exists(oe);if(!he&&B.openOnlyIfExists)return;const Q=he&&typeof B.lineNumber=="number"?{selection:{startLineNumber:B.lineNumber,startColumn:B.columnNumber||1},pinned:!0,override:B.editorOverrideId}:{pinned:!0,override:B.editorOverrideId};let z;return he?z={resource:oe,options:Q,forceFile:!0}:z={resource:oe,options:Q,forceUntitled:!0},z}));return(0,k.coalesce)(L)}e.pathsToEditors=D;var T;(function(o){o[o.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",o[o.SEQUENTIAL=1]="SEQUENTIAL"})(T=e.EditorsOrder||(e.EditorsOrder={}))}),define(be[171],Ee([0,1,3,45,141,4,6,21,28,17,50,23,35,160]),function(ee,e,g,F,S,_,C,y,b,k,n,I,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TREE_ITEM_DATA_TRANSFER_TYPE=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,d.registerIcon)("default-view-icon",l.Codicon.window,(0,S.localize)(0,null));var c;(function(u){u.ViewContainersRegistry="workbench.registry.view.containers",u.ViewsRegistry="workbench.registry.view"})(c=e.Extensions||(e.Extensions={}));var m;(function(u){u[u.Sidebar=0]="Sidebar",u[u.Panel=1]="Panel"})(m=e.ViewContainerLocation||(e.ViewContainerLocation={}));function E(u){switch(u){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=E;function w(u){return`viewContainer.${u}.enabled`}e.getEnabledViewContainerContextKey=w;class P extends C.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new g.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new g.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,k.flatten)([...this.viewContainers.values()])}registerViewContainer(f,v,D){const T=this.get(f.id);if(T)return T;const o=f;return o.openCommandActionDescriptor=D?.donotRegisterOpenCommand?void 0:o.openCommandActionDescriptor??{id:o.id},(0,y.getOrSet)(this.viewContainers,v,[]).push(o),D?.isDefault&&this.defaultViewContainers.push(o),this._onDidRegister.fire({viewContainer:o,viewContainerLocation:v}),o}deregisterViewContainer(f){for(const v of this.viewContainers.keys()){const D=this.viewContainers.get(v),T=D?.indexOf(f);if(T!==-1){D?.splice(T,1),D.length===0&&this.viewContainers.delete(v),this._onDidDeregister.fire({viewContainer:f,viewContainerLocation:v});return}}}get(f){return this.all.filter(v=>v.id===f)[0]}getViewContainers(f){return[...this.viewContainers.get(f)||[]]}getViewContainerLocation(f){return[...this.viewContainers.keys()].filter(v=>this.getViewContainers(v).filter(D=>D?.id===f.id).length>0)[0]}getDefaultViewContainer(f){return this.defaultViewContainers.find(v=>this.getViewContainerLocation(v)===f)}}b.Registry.add(c.ViewContainersRegistry,new P);var a;(function(u){u.Open="2_open",u.Debug="4_debug",u.SCM="5_scm",u.More="9_more"})(a=e.ViewContentGroups||(e.ViewContentGroups={}));function h(u,f){const v=u.group??a.More,D=f.group??a.More;return v!==D?v.localeCompare(D):(u.order??5)-(f.order??5)}class p extends C.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new g.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new g.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new g.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new g.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new n.SetMap}registerViews(f,v){this.registerViews2([{views:f,viewContainer:v}])}registerViews2(f){f.forEach(({views:v,viewContainer:D})=>this.addViews(v,D)),this._onViewsRegistered.fire(f)}deregisterViews(f,v){const D=this.removeViews(f,v);D.length&&this._onViewsDeregistered.fire({views:D,viewContainer:v})}moveViews(f,v){for(const D of this._views.keys())if(D!==v){const T=this.removeViews(f,D);T.length&&(this.addViews(T,v),this._onDidChangeContainer.fire({views:T,from:D,to:v}))}}getViews(f){return this._views.get(f)||[]}getView(f){for(const v of this._viewContainers){const D=(this._views.get(v)||[]).filter(T=>T.id===f)[0];if(D)return D}return null}getViewContainer(f){for(const v of this._viewContainers)if((this._views.get(v)||[]).filter(T=>T.id===f)[0])return v;return null}registerViewWelcomeContent(f,v){return this._viewWelcomeContents.add(f,v),this._onDidChangeViewWelcomeContent.fire(f),(0,C.toDisposable)(()=>{this._viewWelcomeContents.delete(f,v),this._onDidChangeViewWelcomeContent.fire(f)})}registerViewWelcomeContent2(f,v){const D=new Map;for(const[T,o]of v)this._viewWelcomeContents.add(f,o),D.set(T,(0,C.toDisposable)(()=>{this._viewWelcomeContents.delete(f,o),this._onDidChangeViewWelcomeContent.fire(f)}));return this._onDidChangeViewWelcomeContent.fire(f),D}getViewWelcomeContent(f){const v=[];return this._viewWelcomeContents.forEach(f,D=>v.push(D)),v.sort(h)}addViews(f,v){let D=this._views.get(v);D||(D=[],this._views.set(v,D),this._viewContainers.push(v));for(const T of f){if(this.getView(T.id)!==null)throw new Error((0,S.localize)(1,null,T.id));D.push(T)}}removeViews(f,v){const D=this._views.get(v);if(!D)return[];const T=[],o=[];for(const A of D)f.includes(A)?T.push(A):o.push(A);return T.length&&(o.length?this._views.set(v,o):(this._views.delete(v),this._viewContainers.splice(this._viewContainers.indexOf(v),1))),T}}b.Registry.add(c.ViewsRegistry,new p),e.IViewsService=(0,_.createDecorator)("viewsService"),e.FocusedViewContext=new F.RawContextKey("focusedView","",(0,S.localize)(2,null));function t(u){return`view.${u}.visible`}e.getVisbileViewContextKey=t,e.IViewDescriptorService=(0,_.createDecorator)("viewDescriptorService");var r;(function(u){u[u.Default=0]="Default",u[u.Expand=1]="Expand"})(r=e.ViewVisibilityState||(e.ViewVisibilityState={}));var s;(function(u){u[u.None=0]="None",u[u.Collapsed=1]="Collapsed",u[u.Expanded=2]="Expanded"})(s=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class i{constructor(f,v){this.resolved=!1,this._hasResolve=!1,(0,I.mixin)(this,f),this._hasResolve=!!v,this.resolve=async D=>{if(v&&!this.resolved){const T=await v(D);T&&(this.tooltip=this.tooltip??T.tooltip,this.command=this.command??T.command)}D.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=i,e.TREE_ITEM_DATA_TRANSFER_TYPE="text/treeitems"}),define(be[172],Ee([0,1,3,16,142]),function(ee,e,g,F,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class _{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new g.Emitter,this._onExit=new g.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(y){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=y}onEvent(y){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=y}onRequest(y){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=y}sendResponse(y){y.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${y.command}`)):this.internalSend("response",y)}sendRequest(y,b,k,n){const I={command:y};if(b&&Object.keys(b).length>0&&(I.arguments=b),this.internalSend("request",I),typeof n=="number"){const l=setTimeout(()=>{clearTimeout(l);const d=this.pendingRequests.get(I.seq);if(d){this.pendingRequests.delete(I.seq);const c={type:"response",seq:0,request_seq:I.seq,success:!1,command:y,message:(0,S.localize)(0,null,n,y)};d(c)}},n)}return k&&this.pendingRequests.set(I.seq,k),I.seq}acceptMessage(y){this.messageCallback?this.messageCallback(y):(this.queue.push(y),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(y,b){return y.type!=="event"||b.type!=="event"}async processQueue(){let y;for(;this.queue.length;){if((!y||this.needsTaskBoundaryBetween(this.queue[0],y))&&await(0,F.timeout)(0),y=this.queue.shift(),!y)return;switch(y.type){case"event":this.eventCallback&&this.eventCallback(y);break;case"request":this.requestCallback&&this.requestCallback(y);break;case"response":const b=y,k=this.pendingRequests.get(b.request_seq);k&&(this.pendingRequests.delete(b.request_seq),k(b));break}}}internalSend(y,b){b.type=y,b.seq=this.sequence++,this.sendMessage(b)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const y=new Map;this.pendingRequests.forEach((b,k)=>y.set(k,b)),await(0,F.timeout)(500),y.forEach((b,k)=>{b({type:"response",seq:0,request_seq:k,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(k)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=_}),define(be[173],Ee([0,1,8,2,14,23,11]),function(ee,e,g,F,S,_,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const y=/{([^}]+)}/g;function b(r,s,i){return r.replace(y,function(u,f){return s&&f.length>0&&f[0]!=="_"?u:i&&i.hasOwnProperty(f)?i[f]:u})}e.formatPII=b;function k(r){const s={};for(const i of Object.keys(r))i.startsWith("!")||(s[i]=r[i]);return s}e.filterExceptionsFromTelemetry=k;function n(r){return r.configuration.request==="attach"&&!I(r)&&(!r.parentSession||n(r.parentSession))}e.isSessionAttach=n;function I(r){let s=r.configuration.type;if(!!s)return s==="vslsShare"&&(s=r.configuration.adapterProxy.configuration.type),(0,g.equalsIgnoreCase)(s,"extensionhost")||(0,g.equalsIgnoreCase)(s,"pwa-extensionhost")?r:r.parentSession?I(r.parentSession):void 0}e.getExtensionHostDebugSession=I;function l(r){return r.type&&(r.label||r.program||r.runtime)}e.isDebuggerMainContribution=l;function d(r,s,i){let u,f=0,v=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,D=null;for(;D=v.exec(r);){let T=D.index+1,o=T+D[0].length;if(T<=s&&o>=i){u=D[0],f=T;break}}if(u){let T=/\w+/g,o=null;for(;(o=T.exec(u))&&!(o.index+1+f+o[0].length>=i););o&&(u=u.substring(0,T.lastIndex))}return u?{start:f,end:f+u.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=d;const c=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function m(r){return!!(r&&r.match(c))}e.isUri=m;function E(r){if(typeof r.path=="string"&&!(typeof r.sourceReference=="number"&&r.sourceReference>0)){if(m(r.path))return F.URI.parse(r.path);if((0,S.isAbsolute)(r.path))return F.URI.file(r.path)}return r.path}function w(r){if(typeof r.path=="object"){const s=F.URI.revive(r.path);if(s)return s.scheme===C.Schemas.file?s.fsPath:s.toString()}return r.path}function P(r,s){const i=s?E:w,u=(0,_.deepClone)(r);return h(u,(f,v)=>{f&&v&&(v.path=i(v))}),u}e.convertToDAPaths=P;function a(r,s){const i=s?E:w,u=(0,_.deepClone)(r);return h(u,(f,v)=>{!f&&v&&(v.path=i(v))}),u}e.convertToVSCPaths=a;function h(r,s){switch(r.type){case"event":const i=r;switch(i.event){case"output":s(!1,i.body.source);break;case"loadedSource":s(!1,i.body.source);break;case"breakpoint":s(!1,i.body.breakpoint.source);break;default:break}break;case"request":const u=r;switch(u.command){case"setBreakpoints":s(!0,u.arguments.source);break;case"breakpointLocations":s(!0,u.arguments.source);break;case"source":s(!0,u.arguments.source);break;case"gotoTargets":s(!0,u.arguments.source);break;case"launchVSCode":u.arguments.args.forEach(v=>s(!1,v));break;default:break}break;case"response":const f=r;if(f.success&&f.body)switch(f.command){case"stackTrace":f.body.stackFrames.forEach(v=>s(!1,v.source));break;case"loadedSources":f.body.sources.forEach(v=>s(!1,v));break;case"scopes":f.body.scopes.forEach(v=>s(!1,v.source));break;case"setFunctionBreakpoints":f.body.breakpoints.forEach(v=>s(!1,v.source));break;case"setBreakpoints":f.body.breakpoints.forEach(v=>s(!1,v.source));break;default:break}break}}function p(r){return r.filter(s=>!s.presentation?.hidden).sort((s,i)=>s.presentation?i.presentation?s.presentation.group?i.presentation.group?s.presentation.group!==i.presentation.group?s.presentation.group.localeCompare(i.presentation.group):t(s.presentation.order,i.presentation.order):-1:i.presentation.group?1:t(s.presentation.order,i.presentation.order):-1:i.presentation?1:0)}e.getVisibleAndSorted=p;function t(r,s){return typeof r!="number"?typeof s!="number"?0:1:typeof s!="number"?-1:r-s}}),define(be[71],Ee([0,1,27,85,11,14,22,45]),function(ee,e,g,F,S,_,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.OpenGettingStarted=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarLocation=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBar=e.CellToolbarVisibility=e.CellToolbarLocation=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var b;(function(o){o[o.Markup=1]="Markup",o[o.Code=2]="Code"})(b=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",F.Mimes.markdown,"image/png","image/jpeg",F.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[F.Mimes.markdown,"application/json",F.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var k;(function(o){o[o.Running=1]="Running",o[o.Idle=2]="Idle"})(k=e.NotebookRunState||(e.NotebookRunState={}));var n;(function(o){o[o.Pending=2]="Pending",o[o.Executing=3]="Executing"})(n=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var I;(function(o){o[o.WithHardKernelDependency=0]="WithHardKernelDependency",o[o.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",o[o.Pure=2]="Pure",o[o.Never=3]="Never"})(I=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var l;(function(o){o.Always="always",o.Never="never",o.Optional="optional"})(l=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var d;(function(o){o[o.ModelChange=1]="ModelChange",o[o.Move=2]="Move",o[o.ChangeLanguage=5]="ChangeLanguage",o[o.Initialize=6]="Initialize",o[o.ChangeCellMetadata=7]="ChangeCellMetadata",o[o.Output=8]="Output",o[o.OutputItem=9]="OutputItem",o[o.ChangeCellContent=10]="ChangeCellContent",o[o.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",o[o.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",o[o.ChangeCellMime=13]="ChangeCellMime",o[o.Unknown=100]="Unknown"})(d=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var c;(function(o){o[o.Handle=0]="Handle",o[o.Index=1]="Index"})(c=e.SelectionStateType||(e.SelectionStateType={}));var m;(function(o){o[o.Replace=1]="Replace",o[o.Output=2]="Output",o[o.Metadata=3]="Metadata",o[o.CellLanguage=4]="CellLanguage",o[o.DocumentMetadata=5]="DocumentMetadata",o[o.Move=6]="Move",o[o.OutputItems=7]="OutputItems",o[o.PartialMetadata=8]="PartialMetadata",o[o.PartialInternalMetadata=9]="PartialInternalMetadata"})(m=e.CellEditType||(e.CellEditType={}));var E;(function(o){o.scheme=S.Schemas.vscodeNotebookCell;const A=/^ch(\d{7,})/;function L(z,V){return z.with({scheme:o.scheme,fragment:`ch${V.toString().padStart(7,"0")}${z.scheme!==S.Schemas.file?z.scheme:""}`})}o.generate=L;function B(z){if(z.scheme!==o.scheme)return;const V=A.exec(z.fragment);return V?{handle:Number(V[1]),notebook:z.with({scheme:z.fragment.substr(V[0].length)||S.Schemas.file,fragment:null})}:void 0}o.parse=B;function oe(z){if(z.scheme!==S.Schemas.vscodeNotebookCellMetadata)return;const V=A.exec(z.fragment);return V?{handle:Number(V[1]),notebook:z.with({scheme:z.fragment.substr(V[0].length)||S.Schemas.file,fragment:null})}:void 0}o.parseCellMetadataUri=oe;function he(z,V,R){return z.with({scheme:R,fragment:`ch${V.toString().padStart(7,"0")}${z.scheme!==S.Schemas.file?z.scheme:""}`})}o.generateCellUri=he;function Q(z,V){if(z.scheme!==V)return;const R=A.exec(z.fragment);return R?{handle:Number(R[1]),notebook:z.with({scheme:z.fragment.substr(R[0].length)||S.Schemas.file,fragment:null})}:void 0}o.parseCellUri=Q})(E=e.CellUri||(e.CellUri={}));const w=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[F.Mimes.markdown,{alwaysSecure:!0,supportedByCore:!0}],[F.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function P(o){return w.get(o)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=P;function a(o){return w.get(o)?.supportedByCore??!1}e.mimeTypeSupportedByCore=a;function h(o){return w.get(o)?.mergeable??!1}e.mimeTypeIsMergeable=h;function p(o,A){return C.isWindows&&(o=o.replace(/\//g,"\\"),A=A.replace(/\//g,"\\")),g.match(o,A)}function t(o,A,L){let B=0;for(let oe=0;oe<A.length;oe++){if(p(A[oe],o))return B;B++}for(let oe=0;oe<L.length;oe++){if(p(L[oe],o))return B;B++}return B}function r(o,A,L){return o.sort((B,oe)=>t(B,A,L)-t(oe,A,L))}e.sortMimeTypes=r;function s(o,A,L,B=(oe,he)=>oe===he){const oe=[];function he(V,R,K){if(R===0&&K.length===0)return;const x=oe[oe.length-1];x&&x.start+x.deleteCount===V?(x.deleteCount+=R,x.toInsert.push(...K)):oe.push({start:V,deleteCount:R,toInsert:K})}let Q=0,z=0;for(;;){if(Q===o.length){he(Q,0,A.slice(z));break}if(z===A.length){he(Q,o.length-Q,[]);break}const V=o[Q],R=A[z];if(B(V,R)){Q+=1,z+=1;continue}L(R)?(he(Q,1,[]),Q+=1):(he(Q,0,[R]),z+=1)}return oe}e.diff=s,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new y.RawContextKey("notebookEditorCursorAtBoundary","none");var i;(function(o){o.default="default",o.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function u(o){const A=o;return!!((typeof A.include=="string"||g.isRelativePattern(A.include))&&(typeof A.exclude=="string"||g.isRelativePattern(A.exclude)))}e.isDocumentExcludePattern=u;function f(o,A,L){if(Array.isArray(o.viewType)&&o.viewType.indexOf(A)>=0||o.viewType===A)return!0;if(o.filenamePattern){let B=u(o.filenamePattern)?o.filenamePattern.include:o.filenamePattern,oe=u(o.filenamePattern)?o.filenamePattern.exclude:void 0;if(g.match(B,(0,_.basename)(L.fsPath).toLowerCase()))return!(oe&&g.match(oe,(0,_.basename)(L.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=f;class v{constructor(A){this.textModel=A}getElements(){const A=new Int32Array(this.textModel.cells.length);for(let L=0;L<this.textModel.cells.length;L++)A[L]=this.textModel.cells[L].getHashValue();return A}}e.CellSequence=v,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocation="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBar="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarLocation="notebook.insertToolbarLocation",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton",e.OpenGettingStarted="notebook.experimental.openGettingStarted";var D;(function(o){o[o.Left=1]="Left",o[o.Right=2]="Right"})(D=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class T{static create(A){return`${T._prefix}${A}`}static parse(A){if(A.startsWith(T._prefix))return A.substr(T._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=T,T._prefix="notebook/"}),define(be[174],Ee([0,1,144,4,45]),function(ee,e,g,F,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new S.RawContextKey("customExecutionSupported",!0,g.localize(0,null)),e.ShellExecutionSupportedContext=new S.RawContextKey("shellExecutionSupported",!1,g.localize(1,null)),e.ProcessExecutionSupportedContext=new S.RawContextKey("processExecutionSupported",!1,g.localize(2,null)),e.ITaskService=(0,F.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(be[175],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function g(S){return[...S.entries()]}e.serializeEnvironmentVariableCollection=g;function F(S){return new Map(S)}e.deserializeEnvironmentVariableCollection=F}),define(be[99],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.identifyTest=e.TestResultState=void 0;var g;(function(I){I[I.Unset=0]="Unset",I[I.Queued=1]="Queued",I[I.Running=2]="Running",I[I.Passed=3]="Passed",I[I.Failed=4]="Failed",I[I.Skipped=5]="Skipped",I[I.Errored=6]="Errored"})(g=e.TestResultState||(e.TestResultState={}));const F=I=>({testId:I.item.extId,controllerId:I.controllerId});e.identifyTest=F;var S;(function(I){I[I.Run=2]="Run",I[I.Debug=4]="Debug",I[I.Coverage=8]="Coverage",I[I.HasNonDefaultProfile=16]="HasNonDefaultProfile",I[I.HasConfigurable=32]="HasConfigurable"})(S=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var _;(function(I){I[I.NotExpandable=0]="NotExpandable",I[I.Expandable=1]="Expandable",I[I.BusyExpanding=2]="BusyExpanding",I[I.Expanded=3]="Expanded"})(_=e.TestItemExpandState||(e.TestItemExpandState={}));const C=(I,l)=>{l.expand!==void 0&&(I.expand=l.expand),l.item!==void 0&&(I.item=I.item?Object.assign(I.item,l.item):l.item)};e.applyTestItemUpdate=C;var y;(function(I){I[I.Function=0]="Function",I[I.Statement=1]="Statement"})(y=e.DetailType||(e.DetailType={}));var b;(function(I){I[I.Add=0]="Add",I[I.Update=1]="Update",I[I.Remove=2]="Remove",I[I.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",I[I.Retire=4]="Retire"})(b=e.TestDiffOpType||(e.TestDiffOpType={}));class k{add(l){}update(l){}remove(l,d){}complete(){}}e.IncrementalChangeCollector=k;class n{constructor(){this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0}apply(l){const d=this.createChangeCollector();for(const c of l)switch(c[0]){case 0:{const m=c[1];if(m.parent){if(this.items.has(m.parent)){const E=this.items.get(m.parent);E.children.add(m.item.extId);const w=this.createItem(m,E);this.items.set(m.item.extId,w),d.add(w)}}else{const E=this.createItem(m);this.roots.add(E),this.items.set(m.item.extId,E),d.add(E)}m.expand===2&&this.busyControllerCount++;break}case 1:{const m=c[1],E=this.items.get(m.extId);if(!E)break;m.expand!==void 0&&(E.expand===2&&this.busyControllerCount--,m.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(E,m),d.update(E);break}case 2:{const m=this.items.get(c[1]);if(!m)break;m.parent?this.items.get(m.parent).children.delete(m.item.extId):this.roots.delete(m);const E=[[c[1]]];for(;E.length;)for(const w of E.pop()){const P=this.items.get(w);P&&(E.push(P.children),this.items.delete(w),d.remove(P,P!==m),P.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(c[1]);break;case 3:this.updatePendingRoots(c[1]);break}d.complete()}retireTest(l){}updatePendingRoots(l){this.pendingRootCount+=l}createChangeCollector(){return new k}}e.AbstractIncrementalTestCollection=n}),define(be[72],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var g;(function(_){_.Delimiter="\0"})(g=e.TestIdPathParts||(e.TestIdPathParts={}));var F;(function(_){_[_.IsSame=0]="IsSame",_[_.Disconnected=1]="Disconnected",_[_.IsChild=2]="IsChild",_[_.IsParent=3]="IsParent"})(F=e.TestPosition||(e.TestPosition={}));class S{constructor(C,y=C.length){if(this.path=C,this.viewEnd=y,C.length===0||y<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(C,y,b=C.parent){if(C.id===y)return new S([y]);let k=[C.id];for(let n=b;n&&n.id!==y;n=n.parent)k.push(n.id);return k.push(y),new S(k.reverse())}static fromString(C){return new S(C.split("\0"))}static join(C,y){return new S([...C.path,y])}static joinToString(C,y){return C.toString()+"\0"+y}get parentId(){return this.viewEnd>1?new S(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){let C=this.path[0];yield C;for(let y=1;y<this.viewEnd;y++)C+="\0",C+=this.path[y],yield C}compare(C){for(let y=0;y<C.viewEnd&&y<this.viewEnd;y++)if(C.path[y]!==this.path[y])return 1;return C.viewEnd>this.viewEnd?2:C.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let C=1;C<this.viewEnd;C++)this.stringifed+="\0",this.stringifed+=this.path[C]}return this.stringifed}}e.TestId=S}),define(be[176],Ee([0,1,14,41,10,23,22,84,145]),function(ee,e,g,F,S,_,C,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class k{constructor(I,l,d){this._contributedVariables=new Map,this._context=I,this._labelService=l,d&&(this._envVariablesPromise=d.then(c=>this.prepareEnv(c)))}prepareEnv(I){if(C.isWindows){const l=Object.create(null);return Object.keys(I).forEach(d=>{l[d.toLowerCase()]=I[d]}),l}return I}resolveWithEnvironment(I,l,d){return this.recursiveResolve(this.prepareEnv(I),l?l.uri:void 0,d)}async resolveAsync(I,l){return this.recursiveResolve(await this._envVariablesPromise,I?I.uri:void 0,l)}async resolveAnyBase(I,l,d,c){const m=_.deepClone(l);return C.isWindows&&m.windows?Object.keys(m.windows).forEach(E=>m[E]=m.windows[E]):C.isMacintosh&&m.osx?Object.keys(m.osx).forEach(E=>m[E]=m.osx[E]):C.isLinux&&m.linux&&Object.keys(m.linux).forEach(E=>m[E]=m.linux[E]),delete m.windows,delete m.osx,delete m.linux,this.recursiveResolve(await this._envVariablesPromise,I?I.uri:void 0,m,d,c)}async resolveAnyAsync(I,l,d){return this.resolveAnyBase(I,l,d)}async resolveAnyMap(I,l,d){const c=new Map;return{newConfig:await this.resolveAnyBase(I,l,d,c),resolvedVariables:c}}resolveWithInteractionReplace(I,l,d,c){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(I,l,d,c){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(I,l){if(this._contributedVariables.has(I))throw new Error("Variable "+I+" is contributed twice.");this._contributedVariables.set(I,l)}recursiveResolve(I,l,d,c,m){if(S.isString(d))return this.resolveString(I,l,d,c,m);if(S.isArray(d))return d.map(E=>this.recursiveResolve(I,l,E,c,m));if(S.isObject(d)){let E=Object.create(null);return Object.keys(d).forEach(w=>{const P=this.resolveString(I,l,w,c,m);E[P]=this.recursiveResolve(I,l,d[w],c,m)}),E}return d}resolveString(I,l,d,c,m){return d.replace(k.VARIABLE_REGEXP,(w,P)=>{if(P.includes(k.VARIABLE_LHS))return w;let a=this.evaluateSingleVariable(I,w,P,l,c);return m&&m.set(P,a),a!==w&&S.isString(a)&&a.match(k.VARIABLE_REGEXP)&&(a=this.resolveString(I,l,a,c,m)),a})}fsPath(I){return this._labelService?this._labelService.getUriLabel(I,{noPrefix:!0}):I.fsPath}evaluateSingleVariable(I,l,d,c,m){let E;const w=d.split(":");w.length>1&&(d=w[0],E=w[1]);const P=()=>{const p=this._context.getFilePath();if(p)return p;throw new Error((0,b.localize)(0,null,l))},a=()=>{const p=P();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error((0,b.localize)(1,null,l,g.basename(p)))},h=()=>{if(E){const p=this._context.getFolderUri(E);if(p)return p;throw new Error((0,b.localize)(2,null,l,E))}if(c)return c;throw this._context.getWorkspaceFolderCount()>1?new Error((0,b.localize)(3,null,l)):new Error((0,b.localize)(4,null,l))};switch(d){case"env":if(E){if(I){const p=I[C.isWindows?E.toLowerCase():E];if(S.isString(p))return p}return""}throw new Error((0,b.localize)(5,null,l));case"config":if(E){const p=this._context.getConfigurationValue(c,E);if(S.isUndefinedOrNull(p))throw new Error((0,b.localize)(6,null,l,E));if(S.isObject(p))throw new Error((0,b.localize)(7,null,l,E));return p}throw new Error((0,b.localize)(8,null,l));case"command":return this.resolveFromMap(l,E,m,"command");case"input":return this.resolveFromMap(l,E,m,"input");default:switch(d){case"workspaceRoot":case"workspaceFolder":return(0,y.normalizeDriveLetter)(this.fsPath(h()));case"cwd":return c||E?(0,y.normalizeDriveLetter)(this.fsPath(h())):F.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return g.basename(this.fsPath(h()));case"lineNumber":const p=this._context.getLineNumber();if(p)return p;throw new Error((0,b.localize)(9,null,l));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error((0,b.localize)(10,null,l));case"file":return P();case"fileWorkspaceFolder":return a();case"relativeFile":return c||E?g.relative(this.fsPath(h()),P()):P();case"relativeFileDirname":const r=g.dirname(P());if(c||E){const f=g.relative(this.fsPath(h()),r);return f.length===0?".":f}return r;case"fileDirname":return g.dirname(P());case"fileExtname":return g.extname(P());case"fileBasename":return g.basename(P());case"fileBasenameNoExtension":const s=g.basename(P());return s.slice(0,s.length-g.extname(s).length);case"fileDirnameBasename":return g.basename(g.dirname(P()));case"execPath":const i=this._context.getExecPath();return i||l;case"execInstallFolder":const u=this._context.getAppRoot();return u||l;case"pathSeparator":return g.sep;default:try{const f=E?`${d}:${E}`:d;return this.resolveFromMap(l,f,m,void 0)}catch(f){return l}}}}resolveFromMap(I,l,d,c){if(l&&d){const m=c===void 0?d[l]:d[c+":"+l];if(typeof m=="string")return m;throw new Error((0,b.localize)(11,null,I))}return I}}e.AbstractVariableResolverService=k,k.VARIABLE_LHS="${",k.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(be[100],Ee([0,1,4,170]),function(ee,e,g,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,g.createDecorator)("editorGroupsService");var S;(function(m){m[m.UP=0]="UP",m[m.DOWN=1]="DOWN",m[m.LEFT=2]="LEFT",m[m.RIGHT=3]="RIGHT"})(S=e.GroupDirection||(e.GroupDirection={}));var _;(function(m){m[m.HORIZONTAL=0]="HORIZONTAL",m[m.VERTICAL=1]="VERTICAL"})(_=e.GroupOrientation||(e.GroupOrientation={}));var C;(function(m){m[m.FIRST=0]="FIRST",m[m.LAST=1]="LAST",m[m.NEXT=2]="NEXT",m[m.PREVIOUS=3]="PREVIOUS"})(C=e.GroupLocation||(e.GroupLocation={}));var y;(function(m){m[m.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",m[m.EVEN=1]="EVEN",m[m.TOGGLE=2]="TOGGLE"})(y=e.GroupsArrangement||(e.GroupsArrangement={}));var b;(function(m){m[m.COPY_EDITORS=0]="COPY_EDITORS",m[m.MOVE_EDITORS=1]="MOVE_EDITORS"})(b=e.MergeGroupMode||(e.MergeGroupMode={}));function k(m){const E=m;return(0,F.isEditorInput)(E?.editor)&&(0,F.isEditorInput)(E?.replacement)}e.isEditorReplacement=k;var n;(function(m){m[m.CREATION_TIME=0]="CREATION_TIME",m[m.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",m[m.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(n=e.GroupsOrder||(e.GroupsOrder={}));var I;(function(m){m[m.GROUP_ACTIVE=0]="GROUP_ACTIVE",m[m.GROUP_INDEX=1]="GROUP_INDEX",m[m.EDITOR_OPEN=2]="EDITOR_OPEN",m[m.EDITOR_CLOSE=3]="EDITOR_CLOSE",m[m.EDITOR_MOVE=4]="EDITOR_MOVE",m[m.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",m[m.EDITOR_LABEL=6]="EDITOR_LABEL",m[m.EDITOR_CAPABILITIES=7]="EDITOR_CAPABILITIES",m[m.EDITOR_PIN=8]="EDITOR_PIN",m[m.EDITOR_STICKY=9]="EDITOR_STICKY",m[m.EDITOR_DIRTY=10]="EDITOR_DIRTY"})(I=e.GroupChangeKind||(e.GroupChangeKind={}));var l;(function(m){m[m.NEW_EDITOR=1]="NEW_EDITOR",m[m.MOVE_EDITOR=2]="MOVE_EDITOR",m[m.COPY_EDITOR=3]="COPY_EDITOR"})(l=e.OpenEditorContext||(e.OpenEditorContext={}));function d(m){const E=m;return!!E&&typeof E.id=="number"&&Array.isArray(E.editors)}e.isEditorGroup=d;function c(m){return m.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=c}),define(be[177],Ee([0,1,4,100]),function(ee,e,g,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,g.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function S(_){const C=_;return typeof _=="number"||(0,F.isEditorGroup)(C)}e.isPreferredGroup=S}),define(be[9],Ee([0,1,17,83,233,56,23,10,2,31,60,146,92,67,71,72,177,7]),function(ee,e,g,F,S,_,C,y,b,k,n,I,l,d,c,m,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var P;(function(_e){function ke(W){const{selectionStartLineNumber:Fe,selectionStartColumn:Me,positionLineNumber:tt,positionColumn:Ge}=W,dt=new w.Position(Fe-1,Me-1),yt=new w.Position(tt-1,Ge-1);return new w.Selection(dt,yt)}_e.to=ke;function Y(W){const{anchor:Fe,active:Me}=W;return{selectionStartLineNumber:Fe.line+1,selectionStartColumn:Fe.character+1,positionLineNumber:Me.line+1,positionColumn:Me.character+1}}_e.from=Y})(P=e.Selection||(e.Selection={}));var a;(function(_e){function ke(W){if(!W)return;const{start:Fe,end:Me}=W;return{startLineNumber:Fe.line+1,startColumn:Fe.character+1,endLineNumber:Me.line+1,endColumn:Me.character+1}}_e.from=ke;function Y(W){if(!W)return;const{startLineNumber:Fe,startColumn:Me,endLineNumber:tt,endColumn:Ge}=W;return new w.Range(Fe-1,Me-1,tt-1,Ge-1)}_e.to=Y})(a=e.Range||(e.Range={}));var h;(function(_e){function ke(Y){switch(Y){case 1:return w.StandardTokenType.Comment;case 0:return w.StandardTokenType.Other;case 4:return w.StandardTokenType.RegEx;case 2:return w.StandardTokenType.String}}_e.to=ke})(h=e.TokenType||(e.TokenType={}));var p;(function(_e){function ke(W){return new w.Position(W.lineNumber-1,W.column-1)}_e.to=ke;function Y(W){return{lineNumber:W.line+1,column:W.character+1}}_e.from=Y})(p=e.Position||(e.Position={}));var t;(function(_e){function ke(W){switch(W){case w.DiagnosticTag.Unnecessary:return 1;case w.DiagnosticTag.Deprecated:return 2}}_e.from=ke;function Y(W){switch(W){case 1:return w.DiagnosticTag.Unnecessary;case 2:return w.DiagnosticTag.Deprecated;default:return}}_e.to=Y})(t=e.DiagnosticTag||(e.DiagnosticTag={}));var r;(function(_e){function ke(W){let Fe;return W.code&&((0,y.isString)(W.code)||(0,y.isNumber)(W.code)?Fe=String(W.code):Fe={value:String(W.code.value),target:W.code.target}),{...a.from(W.range),message:W.message,source:W.source,code:Fe,severity:i.from(W.severity),relatedInformation:W.relatedInformation&&W.relatedInformation.map(s.from),tags:Array.isArray(W.tags)?(0,g.coalesce)(W.tags.map(t.from)):void 0}}_e.from=ke;function Y(W){const Fe=new w.Diagnostic(a.to(W),W.message,i.to(W.severity));return Fe.source=W.source,Fe.code=(0,y.isString)(W.code)?W.code:W.code?.value,Fe.relatedInformation=W.relatedInformation&&W.relatedInformation.map(s.to),Fe.tags=W.tags&&(0,g.coalesce)(W.tags.map(t.to)),Fe}_e.to=Y})(r=e.Diagnostic||(e.Diagnostic={}));var s;(function(_e){function ke(W){return{...a.from(W.location.range),message:W.message,resource:W.location.uri}}_e.from=ke;function Y(W){return new w.DiagnosticRelatedInformation(new w.Location(W.resource,a.to(W)),W.message)}_e.to=Y})(s=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var i;(function(_e){function ke(W){switch(W){case w.DiagnosticSeverity.Error:return l.MarkerSeverity.Error;case w.DiagnosticSeverity.Warning:return l.MarkerSeverity.Warning;case w.DiagnosticSeverity.Information:return l.MarkerSeverity.Info;case w.DiagnosticSeverity.Hint:return l.MarkerSeverity.Hint}return l.MarkerSeverity.Error}_e.from=ke;function Y(W){switch(W){case l.MarkerSeverity.Info:return w.DiagnosticSeverity.Information;case l.MarkerSeverity.Warning:return w.DiagnosticSeverity.Warning;case l.MarkerSeverity.Error:return w.DiagnosticSeverity.Error;case l.MarkerSeverity.Hint:return w.DiagnosticSeverity.Hint;default:return w.DiagnosticSeverity.Error}}_e.to=Y})(i=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var u;(function(_e){function ke(W){return typeof W=="number"&&W>=w.ViewColumn.One?W-1:W===w.ViewColumn.Beside?E.SIDE_GROUP:E.ACTIVE_GROUP}_e.from=ke;function Y(W){if(typeof W=="number"&&W>=0)return W+1;throw new Error("invalid 'EditorGroupColumn'")}_e.to=Y})(u=e.ViewColumn||(e.ViewColumn={}));function f(_e){return typeof _e.range!="undefined"}function v(_e){return _e.length===0?!0:!!f(_e[0])}e.isDecorationOptionsArr=v;var D;(function(_e){function ke(Ge){return Ge.map(_e.from)}_e.fromMany=ke;function Y(Ge){return Ge&&typeof Ge=="object"&&typeof Ge.language=="string"&&typeof Ge.value=="string"}function W(Ge){let dt;if(Y(Ge)){const{language:mt,value:ct}=Ge;dt={value:"```"+mt+`
`+ct+"\n```\n"}}else w.MarkdownString.isMarkdownString(Ge)?dt={value:Ge.value,isTrusted:Ge.isTrusted,supportThemeIcons:Ge.supportThemeIcons}:typeof Ge=="string"?dt={value:Ge}:dt={value:""};const yt=Object.create(null);dt.uris=yt;const kt=mt=>{try{let ct=b.URI.parse(mt,!0);ct=ct.with({query:Fe(ct.query,yt)}),yt[mt]=ct}catch(ct){}return""},bt=new S.Renderer;return bt.link=kt,bt.image=mt=>kt(F.parseHrefAndDimensions(mt).href),S(dt.value,{renderer:bt}),dt}_e.from=W;function Fe(Ge,dt){if(!Ge)return Ge;let yt;try{yt=(0,_.parse)(Ge)}catch(bt){}if(!yt)return Ge;let kt=!1;return yt=(0,C.cloneAndChange)(yt,bt=>{if(b.URI.isUri(bt)){const mt=`__uri_${Math.random().toString(16).slice(2,8)}`;return dt[mt]=bt,kt=!0,mt}else return}),kt?JSON.stringify(yt):Ge}function Me(Ge){const dt=new w.MarkdownString(Ge.value,Ge.supportThemeIcons);return dt.isTrusted=Ge.isTrusted,dt}_e.to=Me;function tt(Ge){if(!!Ge)return typeof Ge=="string"?Ge:_e.from(Ge)}_e.fromStrict=tt})(D=e.MarkdownString||(e.MarkdownString={}));function T(_e){return v(_e)?_e.map(ke=>({range:a.from(ke.range),hoverMessage:Array.isArray(ke.hoverMessage)?D.fromMany(ke.hoverMessage):ke.hoverMessage?D.from(ke.hoverMessage):void 0,renderOptions:ke.renderOptions})):_e.map(ke=>({range:a.from(ke)}))}e.fromRangeOrRangeWithMessage=T;function o(_e){return typeof _e=="undefined"?_e:typeof _e=="string"?b.URI.file(_e):_e}e.pathOrURIToURI=o;var A;(function(_e){function ke(Y){return typeof Y=="undefined"?Y:{contentText:Y.contentText,contentIconPath:Y.contentIconPath?o(Y.contentIconPath):void 0,border:Y.border,borderColor:Y.borderColor,fontStyle:Y.fontStyle,fontWeight:Y.fontWeight,textDecoration:Y.textDecoration,color:Y.color,backgroundColor:Y.backgroundColor,margin:Y.margin,width:Y.width,height:Y.height}}_e.from=ke})(A=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var L;(function(_e){function ke(Y){return typeof Y=="undefined"?Y:{backgroundColor:Y.backgroundColor,outline:Y.outline,outlineColor:Y.outlineColor,outlineStyle:Y.outlineStyle,outlineWidth:Y.outlineWidth,border:Y.border,borderColor:Y.borderColor,borderRadius:Y.borderRadius,borderSpacing:Y.borderSpacing,borderStyle:Y.borderStyle,borderWidth:Y.borderWidth,fontStyle:Y.fontStyle,fontWeight:Y.fontWeight,textDecoration:Y.textDecoration,cursor:Y.cursor,color:Y.color,opacity:Y.opacity,letterSpacing:Y.letterSpacing,gutterIconPath:Y.gutterIconPath?o(Y.gutterIconPath):void 0,gutterIconSize:Y.gutterIconSize,overviewRulerColor:Y.overviewRulerColor,before:Y.before?A.from(Y.before):void 0,after:Y.after?A.from(Y.after):void 0}}_e.from=ke})(L=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var B;(function(_e){function ke(Y){if(typeof Y=="undefined")return Y;switch(Y){case w.DecorationRangeBehavior.OpenOpen:return 0;case w.DecorationRangeBehavior.ClosedClosed:return 1;case w.DecorationRangeBehavior.OpenClosed:return 2;case w.DecorationRangeBehavior.ClosedOpen:return 3}}_e.from=ke})(B=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var oe;(function(_e){function ke(Y){return{isWholeLine:Y.isWholeLine,rangeBehavior:Y.rangeBehavior?B.from(Y.rangeBehavior):void 0,overviewRulerLane:Y.overviewRulerLane,light:Y.light?L.from(Y.light):void 0,dark:Y.dark?L.from(Y.dark):void 0,backgroundColor:Y.backgroundColor,outline:Y.outline,outlineColor:Y.outlineColor,outlineStyle:Y.outlineStyle,outlineWidth:Y.outlineWidth,border:Y.border,borderColor:Y.borderColor,borderRadius:Y.borderRadius,borderSpacing:Y.borderSpacing,borderStyle:Y.borderStyle,borderWidth:Y.borderWidth,fontStyle:Y.fontStyle,fontWeight:Y.fontWeight,textDecoration:Y.textDecoration,cursor:Y.cursor,color:Y.color,opacity:Y.opacity,letterSpacing:Y.letterSpacing,gutterIconPath:Y.gutterIconPath?o(Y.gutterIconPath):void 0,gutterIconSize:Y.gutterIconSize,overviewRulerColor:Y.overviewRulerColor,before:Y.before?A.from(Y.before):void 0,after:Y.after?A.from(Y.after):void 0}}_e.from=ke})(oe=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var he;(function(_e){function ke(W){return{text:W.newText,eol:W.newEol&&de.from(W.newEol),range:a.from(W.range)}}_e.from=ke;function Y(W){const Fe=new w.TextEdit(a.to(W.range),W.text);return Fe.newEol=typeof W.eol=="undefined"?void 0:de.to(W.eol),Fe}_e.to=Y})(he=e.TextEdit||(e.TextEdit={}));var Q;(function(_e){function ke(W,Fe,Me){const tt={edits:[]};if(W instanceof w.WorkspaceEdit)for(let Ge of W._allEntries())if(Ge._type===1)tt.edits.push({_type:1,oldUri:Ge.from,newUri:Ge.to,options:Ge.options,metadata:Ge.metadata});else if(Ge._type===2){const dt=Fe?.getDocument(Ge.uri);tt.edits.push({_type:2,resource:Ge.uri,edit:he.from(Ge.edit),modelVersionId:dt?.version,metadata:Ge.metadata})}else Ge._type===3?tt.edits.push({_type:3,metadata:Ge.metadata,resource:Ge.uri,edit:Ge.edit,notebookMetadata:Ge.notebookMetadata,notebookVersionId:Me?.getNotebookDocument(Ge.uri,!0)?.apiNotebook.version}):Ge._type===5&&tt.edits.push({_type:3,metadata:Ge.metadata,resource:Ge.uri,notebookVersionId:Me?.getNotebookDocument(Ge.uri,!0)?.apiNotebook.version,edit:{editType:1,index:Ge.index,count:Ge.count,cells:Ge.cells.map(U.from)}});return tt}_e.from=ke;function Y(W){const Fe=new w.WorkspaceEdit;for(const Me of W.edits)Me.edit?Fe.replace(b.URI.revive(Me.resource),a.to(Me.edit.range),Me.edit.text):Fe.renameFile(b.URI.revive(Me.oldUri),b.URI.revive(Me.newUri),Me.options);return Fe}_e.to=Y})(Q=e.WorkspaceEdit||(e.WorkspaceEdit={}));var z;(function(_e){const ke=Object.create(null);ke[w.SymbolKind.File]=0,ke[w.SymbolKind.Module]=1,ke[w.SymbolKind.Namespace]=2,ke[w.SymbolKind.Package]=3,ke[w.SymbolKind.Class]=4,ke[w.SymbolKind.Method]=5,ke[w.SymbolKind.Property]=6,ke[w.SymbolKind.Field]=7,ke[w.SymbolKind.Constructor]=8,ke[w.SymbolKind.Enum]=9,ke[w.SymbolKind.Interface]=10,ke[w.SymbolKind.Function]=11,ke[w.SymbolKind.Variable]=12,ke[w.SymbolKind.Constant]=13,ke[w.SymbolKind.String]=14,ke[w.SymbolKind.Number]=15,ke[w.SymbolKind.Boolean]=16,ke[w.SymbolKind.Array]=17,ke[w.SymbolKind.Object]=18,ke[w.SymbolKind.Key]=19,ke[w.SymbolKind.Null]=20,ke[w.SymbolKind.EnumMember]=21,ke[w.SymbolKind.Struct]=22,ke[w.SymbolKind.Event]=23,ke[w.SymbolKind.Operator]=24,ke[w.SymbolKind.TypeParameter]=25;function Y(Fe){return typeof ke[Fe]=="number"?ke[Fe]:6}_e.from=Y;function W(Fe){for(const Me in ke)if(ke[Me]===Fe)return Number(Me);return w.SymbolKind.Property}_e.to=W})(z=e.SymbolKind||(e.SymbolKind={}));var V;(function(_e){function ke(W){switch(W){case w.SymbolTag.Deprecated:return 1}}_e.from=ke;function Y(W){switch(W){case 1:return w.SymbolTag.Deprecated}}_e.to=Y})(V=e.SymbolTag||(e.SymbolTag={}));var R;(function(_e){function ke(W){return{name:W.name,kind:z.from(W.kind),tags:W.tags&&W.tags.map(V.from),containerName:W.containerName,location:$.from(W.location)}}_e.from=ke;function Y(W){const Fe=new w.SymbolInformation(W.name,z.to(W.kind),W.containerName,$.to(W.location));return Fe.tags=W.tags&&W.tags.map(V.to),Fe}_e.to=Y})(R=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var K;(function(_e){function ke(W){const Fe={name:W.name||"!!MISSING: name!!",detail:W.detail,range:a.from(W.range),selectionRange:a.from(W.selectionRange),kind:z.from(W.kind),tags:W.tags?.map(V.from)??[]};return W.children&&(Fe.children=W.children.map(ke)),Fe}_e.from=ke;function Y(W){const Fe=new w.DocumentSymbol(W.name,W.detail,z.to(W.kind),a.to(W.range),a.to(W.selectionRange));return(0,g.isNonEmptyArray)(W.tags)&&(Fe.tags=W.tags.map(V.to)),W.children&&(Fe.children=W.children.map(Y)),Fe}_e.to=Y})(K=e.DocumentSymbol||(e.DocumentSymbol={}));var x;(function(_e){function ke(W){const Fe=new w.CallHierarchyItem(z.to(W.kind),W.name,W.detail||"",b.URI.revive(W.uri),a.to(W.range),a.to(W.selectionRange));return Fe._sessionId=W._sessionId,Fe._itemId=W._itemId,Fe}_e.to=ke;function Y(W,Fe,Me){if(Fe=Fe??W._sessionId,Me=Me??W._itemId,Fe===void 0||Me===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:Me,name:W.name,detail:W.detail,kind:z.from(W.kind),uri:W.uri,range:a.from(W.range),selectionRange:a.from(W.selectionRange),tags:W.tags?.map(V.from)}}_e.from=Y})(x=e.CallHierarchyItem||(e.CallHierarchyItem={}));var j;(function(_e){function ke(Y){return new w.CallHierarchyIncomingCall(x.to(Y.from),Y.fromRanges.map(W=>a.to(W)))}_e.to=ke})(j=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var ue;(function(_e){function ke(Y){return new w.CallHierarchyOutgoingCall(x.to(Y.to),Y.fromRanges.map(W=>a.to(W)))}_e.to=ke})(ue=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var $;(function(_e){function ke(W){return{range:W.range&&a.from(W.range),uri:W.uri}}_e.from=ke;function Y(W){return new w.Location(b.URI.revive(W.uri),a.to(W.range))}_e.to=Y})($=e.location||(e.location={}));var te;(function(_e){function ke(W){const Fe=W,Me=W;return{originSelectionRange:Fe.originSelectionRange?a.from(Fe.originSelectionRange):void 0,uri:Fe.targetUri?Fe.targetUri:Me.uri,range:a.from(Fe.targetRange?Fe.targetRange:Me.range),targetSelectionRange:Fe.targetSelectionRange?a.from(Fe.targetSelectionRange):void 0}}_e.from=ke;function Y(W){return{targetUri:b.URI.revive(W.uri),targetRange:a.to(W.range),targetSelectionRange:W.targetSelectionRange?a.to(W.targetSelectionRange):void 0,originSelectionRange:W.originSelectionRange?a.to(W.originSelectionRange):void 0}}_e.to=Y})(te=e.DefinitionLink||(e.DefinitionLink={}));var ce;(function(_e){function ke(W){return{range:a.from(W.range),contents:D.fromMany(W.contents)}}_e.from=ke;function Y(W){return new w.Hover(W.contents.map(D.to),a.to(W.range))}_e.to=Y})(ce=e.Hover||(e.Hover={}));var ye;(function(_e){function ke(W){return{range:a.from(W.range),expression:W.expression}}_e.from=ke;function Y(W){return new w.EvaluatableExpression(a.to(W.range),W.expression)}_e.to=Y})(ye=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Re;(function(_e){function ke(W){if(W instanceof w.InlineValueText)return{type:"text",range:a.from(W.range),text:W.text};if(W instanceof w.InlineValueVariableLookup)return{type:"variable",range:a.from(W.range),variableName:W.variableName,caseSensitiveLookup:W.caseSensitiveLookup};if(W instanceof w.InlineValueEvaluatableExpression)return{type:"expression",range:a.from(W.range),expression:W.expression};throw new Error("Unknown 'InlineValue' type")}_e.from=ke;function Y(W){switch(W.type){case"text":return{range:a.to(W.range),text:W.text};case"variable":return{range:a.to(W.range),variableName:W.variableName,caseSensitiveLookup:W.caseSensitiveLookup};case"expression":return{range:a.to(W.range),expression:W.expression}}}_e.to=Y})(Re=e.InlineValue||(e.InlineValue={}));var Te;(function(_e){function ke(W){return{frameId:W.frameId,stoppedLocation:a.from(W.stoppedLocation)}}_e.from=ke;function Y(W){return new w.InlineValueContext(W.frameId,a.to(W.stoppedLocation))}_e.to=Y})(Te=e.InlineValueContext||(e.InlineValueContext={}));var $e;(function(_e){function ke(W){return{range:a.from(W.range),kind:W.kind}}_e.from=ke;function Y(W){return new w.DocumentHighlight(a.to(W.range),W.kind)}_e.to=Y})($e=e.DocumentHighlight||(e.DocumentHighlight={}));var Je;(function(_e){function ke(Y){switch(Y){case 1:return w.CompletionTriggerKind.TriggerCharacter;case 2:return w.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return w.CompletionTriggerKind.Invoke}}_e.to=ke})(Je=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ve;(function(_e){function ke(Y){return{triggerKind:Je.to(Y.triggerKind),triggerCharacter:Y.triggerCharacter}}_e.to=ke})(Ve=e.CompletionContext||(e.CompletionContext={}));var je;(function(_e){function ke(W){switch(W){case w.CompletionItemTag.Deprecated:return 1}}_e.from=ke;function Y(W){switch(W){case 1:return w.CompletionItemTag.Deprecated}}_e.to=Y})(je=e.CompletionItemTag||(e.CompletionItemTag={}));var O;(function(_e){const ke=new Map([[w.CompletionItemKind.Method,0],[w.CompletionItemKind.Function,1],[w.CompletionItemKind.Constructor,2],[w.CompletionItemKind.Field,3],[w.CompletionItemKind.Variable,4],[w.CompletionItemKind.Class,5],[w.CompletionItemKind.Interface,7],[w.CompletionItemKind.Struct,6],[w.CompletionItemKind.Module,8],[w.CompletionItemKind.Property,9],[w.CompletionItemKind.Unit,12],[w.CompletionItemKind.Value,13],[w.CompletionItemKind.Constant,14],[w.CompletionItemKind.Enum,15],[w.CompletionItemKind.EnumMember,16],[w.CompletionItemKind.Keyword,17],[w.CompletionItemKind.Snippet,27],[w.CompletionItemKind.Text,18],[w.CompletionItemKind.Color,19],[w.CompletionItemKind.File,20],[w.CompletionItemKind.Reference,21],[w.CompletionItemKind.Folder,23],[w.CompletionItemKind.Event,10],[w.CompletionItemKind.Operator,11],[w.CompletionItemKind.TypeParameter,24],[w.CompletionItemKind.Issue,26],[w.CompletionItemKind.User,25]]);function Y(Me){return ke.get(Me)??9}_e.from=Y;const W=new Map([[0,w.CompletionItemKind.Method],[1,w.CompletionItemKind.Function],[2,w.CompletionItemKind.Constructor],[3,w.CompletionItemKind.Field],[4,w.CompletionItemKind.Variable],[5,w.CompletionItemKind.Class],[7,w.CompletionItemKind.Interface],[6,w.CompletionItemKind.Struct],[8,w.CompletionItemKind.Module],[9,w.CompletionItemKind.Property],[12,w.CompletionItemKind.Unit],[13,w.CompletionItemKind.Value],[14,w.CompletionItemKind.Constant],[15,w.CompletionItemKind.Enum],[16,w.CompletionItemKind.EnumMember],[17,w.CompletionItemKind.Keyword],[27,w.CompletionItemKind.Snippet],[18,w.CompletionItemKind.Text],[19,w.CompletionItemKind.Color],[20,w.CompletionItemKind.File],[21,w.CompletionItemKind.Reference],[23,w.CompletionItemKind.Folder],[10,w.CompletionItemKind.Event],[11,w.CompletionItemKind.Operator],[24,w.CompletionItemKind.TypeParameter],[25,w.CompletionItemKind.User],[26,w.CompletionItemKind.Issue]]);function Fe(Me){return W.get(Me)??w.CompletionItemKind.Property}_e.to=Fe})(O=e.CompletionItemKind||(e.CompletionItemKind={}));var G;(function(_e){function ke(Y,W){const Fe=new w.CompletionItem(Y.label);return Fe.insertText=Y.insertText,Fe.kind=O.to(Y.kind),Fe.tags=Y.tags?.map(je.to),Fe.detail=Y.detail,Fe.documentation=F.isMarkdownString(Y.documentation)?D.to(Y.documentation):Y.documentation,Fe.sortText=Y.sortText,Fe.filterText=Y.filterText,Fe.preselect=Y.preselect,Fe.commitCharacters=Y.commitCharacters,k.Range.isIRange(Y.range)?Fe.range=a.to(Y.range):typeof Y.range=="object"&&(Fe.range={inserting:a.to(Y.range.insert),replacing:a.to(Y.range.replace)}),Fe.keepWhitespace=typeof Y.insertTextRules=="undefined"?!1:Boolean(Y.insertTextRules&1),typeof Y.insertTextRules!="undefined"&&Y.insertTextRules&4?Fe.insertText=new w.SnippetString(Y.insertText):(Fe.insertText=Y.insertText,Fe.textEdit=Fe.range instanceof w.Range?new w.TextEdit(Fe.range,Fe.insertText):void 0),Y.additionalTextEdits&&Y.additionalTextEdits.length>0&&(Fe.additionalTextEdits=Y.additionalTextEdits.map(Me=>he.to(Me))),Fe.command=W&&Y.command?W.fromInternal(Y.command):void 0,Fe}_e.to=ke})(G=e.CompletionItem||(e.CompletionItem={}));var X;(function(_e){function ke(W){return{label:W.label,documentation:W.documentation?D.fromStrict(W.documentation):void 0}}_e.from=ke;function Y(W){return{label:W.label,documentation:F.isMarkdownString(W.documentation)?D.to(W.documentation):W.documentation}}_e.to=Y})(X=e.ParameterInformation||(e.ParameterInformation={}));var se;(function(_e){function ke(W){return{label:W.label,documentation:W.documentation?D.fromStrict(W.documentation):void 0,parameters:Array.isArray(W.parameters)?W.parameters.map(X.from):[],activeParameter:W.activeParameter}}_e.from=ke;function Y(W){return{label:W.label,documentation:F.isMarkdownString(W.documentation)?D.to(W.documentation):W.documentation,parameters:Array.isArray(W.parameters)?W.parameters.map(X.to):[],activeParameter:W.activeParameter}}_e.to=Y})(se=e.SignatureInformation||(e.SignatureInformation={}));var q;(function(_e){function ke(W){return{activeSignature:W.activeSignature,activeParameter:W.activeParameter,signatures:Array.isArray(W.signatures)?W.signatures.map(se.from):[]}}_e.from=ke;function Y(W){return{activeSignature:W.activeSignature,activeParameter:W.activeParameter,signatures:Array.isArray(W.signatures)?W.signatures.map(se.to):[]}}_e.to=Y})(q=e.SignatureHelp||(e.SignatureHelp={}));var ie;(function(_e){function ke(W){return{text:W.text,position:p.from(W.position),kind:ge.from(W.kind??w.InlayHintKind.Other),whitespaceBefore:W.whitespaceBefore,whitespaceAfter:W.whitespaceAfter}}_e.from=ke;function Y(W){const Fe=new w.InlayHint(W.text,p.to(W.position),ge.to(W.kind));return Fe.whitespaceAfter=W.whitespaceAfter,Fe.whitespaceBefore=W.whitespaceBefore,Fe}_e.to=Y})(ie=e.InlayHint||(e.InlayHint={}));var ge;(function(_e){function ke(W){return W}_e.from=ke;function Y(W){return W}_e.to=Y})(ge=e.InlayHintKind||(e.InlayHintKind={}));var Le;(function(_e){function ke(W){return{range:a.from(W.range),url:W.target,tooltip:W.tooltip}}_e.from=ke;function Y(W){let Fe;if(W.url)try{Fe=typeof W.url=="string"?b.URI.parse(W.url,!0):b.URI.revive(W.url)}catch(Me){}return new w.DocumentLink(a.to(W.range),Fe)}_e.to=Y})(Le=e.DocumentLink||(e.DocumentLink={}));var We;(function(_e){function ke(W){const Fe=new w.ColorPresentation(W.label);return W.textEdit&&(Fe.textEdit=he.to(W.textEdit)),W.additionalTextEdits&&(Fe.additionalTextEdits=W.additionalTextEdits.map(Me=>he.to(Me))),Fe}_e.to=ke;function Y(W){return{label:W.label,textEdit:W.textEdit?he.from(W.textEdit):void 0,additionalTextEdits:W.additionalTextEdits?W.additionalTextEdits.map(Fe=>he.from(Fe)):void 0}}_e.from=Y})(We=e.ColorPresentation||(e.ColorPresentation={}));var ve;(function(_e){function ke(W){return new w.Color(W[0],W[1],W[2],W[3])}_e.to=ke;function Y(W){return[W.red,W.green,W.blue,W.alpha]}_e.from=Y})(ve=e.Color||(e.Color={}));var Xe;(function(_e){function ke(W){return{range:a.from(W.range)}}_e.from=ke;function Y(W){return new w.SelectionRange(a.to(W.range))}_e.to=Y})(Xe=e.SelectionRange||(e.SelectionRange={}));var H;(function(_e){function ke(Y){switch(Y){case 2:return w.TextDocumentSaveReason.AfterDelay;case 1:return w.TextDocumentSaveReason.Manual;case 3:case 4:return w.TextDocumentSaveReason.FocusOut}}_e.to=ke})(H=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Z;(function(_e){function ke(W){switch(W){case w.TextEditorLineNumbersStyle.Off:return 0;case w.TextEditorLineNumbersStyle.Relative:return 2;case w.TextEditorLineNumbersStyle.On:default:return 1}}_e.from=ke;function Y(W){switch(W){case 0:return w.TextEditorLineNumbersStyle.Off;case 2:return w.TextEditorLineNumbersStyle.Relative;case 1:default:return w.TextEditorLineNumbersStyle.On}}_e.to=Y})(Z=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var de;(function(_e){function ke(W){if(W===w.EndOfLine.CRLF)return 1;if(W===w.EndOfLine.LF)return 0}_e.from=ke;function Y(W){if(W===1)return w.EndOfLine.CRLF;if(W===0)return w.EndOfLine.LF}_e.to=Y})(de=e.EndOfLine||(e.EndOfLine={}));var Be;(function(_e){function ke(Y){if(typeof Y=="object")return Y.viewId;switch(Y){case w.ProgressLocation.SourceControl:return 3;case w.ProgressLocation.Window:return 10;case w.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}_e.from=ke})(Be=e.ProgressLocation||(e.ProgressLocation={}));var xe;(function(_e){function ke(Y){const W={start:Y.start+1,end:Y.end+1};return Y.kind&&(W.kind=Ze.from(Y.kind)),W}_e.from=ke})(xe=e.FoldingRange||(e.FoldingRange={}));var Ze;(function(_e){function ke(Y){if(Y)switch(Y){case w.FoldingRangeKind.Comment:return n.FoldingRangeKind.Comment;case w.FoldingRangeKind.Imports:return n.FoldingRangeKind.Imports;case w.FoldingRangeKind.Region:return n.FoldingRangeKind.Region}}_e.from=ke})(Ze=e.FoldingRangeKind||(e.FoldingRangeKind={}));var De;(function(_e){function ke(Y){if(Y)return{pinned:typeof Y.preview=="boolean"?!Y.preview:void 0,inactive:Y.background,preserveFocus:Y.preserveFocus,selection:typeof Y.selection=="object"?a.from(Y.selection):void 0,override:typeof Y.override=="boolean"?I.EditorResolution.DISABLED:void 0}}_e.from=ke})(De=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Se;(function(_e){function ke(W){return W instanceof w.RelativePattern||typeof W=="string"?W:Y(W)?new w.RelativePattern(W.base,W.pattern):W}_e.from=ke;function Y(W){const Fe=W;return Fe&&typeof Fe.base=="string"&&typeof Fe.pattern=="string"}})(Se=e.GlobPattern||(e.GlobPattern={}));var Pe;(function(_e){function ke(Y){if(Y){if(Array.isArray(Y))return Y.map(ke);if(typeof Y=="string")return Y;{const W=Y;return{language:W.language,scheme:W.scheme,pattern:typeof W.pattern=="undefined"?void 0:Se.from(W.pattern),exclusive:W.exclusive}}}else return}_e.from=ke})(Pe=e.LanguageSelector||(e.LanguageSelector={}));var re;(function(_e){function ke(W){return{start:W.start,end:W.end}}_e.from=ke;function Y(W){return new w.NotebookRange(W.start,W.end)}_e.to=Y})(re=e.NotebookRange||(e.NotebookRange={}));var ae;(function(_e){function ke(W){return{timing:typeof W.runStartTime=="number"&&typeof W.runEndTime=="number"?{startTime:W.runStartTime,endTime:W.runEndTime}:void 0,executionOrder:W.executionOrder,success:W.lastRunSuccess}}_e.to=ke;function Y(W){return{lastRunSuccess:W.success,runStartTime:W.timing?.startTime,runEndTime:W.timing?.endTime,executionOrder:W.executionOrder}}_e.from=Y})(ae=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var fe;(function(_e){function ke(W){switch(W){case w.NotebookCellKind.Markup:return c.CellKind.Markup;case w.NotebookCellKind.Code:default:return c.CellKind.Code}}_e.from=ke;function Y(W){switch(W){case c.CellKind.Markup:return w.NotebookCellKind.Markup;case c.CellKind.Code:default:return w.NotebookCellKind.Code}}_e.to=Y})(fe=e.NotebookCellKind||(e.NotebookCellKind={}));var pe;(function(_e){function ke(W){const Fe={metadata:W.metadata??Object.create(null),cells:[]};for(let Me of W.cells)w.NotebookCellData.validate(Me),Fe.cells.push(U.from(Me));return Fe}_e.from=ke;function Y(W){const Fe=new w.NotebookData(W.cells.map(U.to));return(0,y.isEmptyObject)(W.metadata)||(Fe.metadata=W.metadata),Fe}_e.to=Y})(pe=e.NotebookData||(e.NotebookData={}));var U;(function(_e){function ke(W){return{cellKind:fe.from(W.kind),language:W.languageId,mime:W.mime,source:W.value,metadata:W.metadata,internalMetadata:ae.from(W.executionSummary??{}),outputs:W.outputs?W.outputs.map(we.from):[]}}_e.from=ke;function Y(W){return new w.NotebookCellData(fe.to(W.cellKind),W.source,W.language,W.mime,W.outputs?W.outputs.map(we.to):void 0,W.metadata,W.internalMetadata?ae.to(W.internalMetadata):void 0)}_e.to=Y})(U=e.NotebookCellData||(e.NotebookCellData={}));var me;(function(_e){function ke(W){return{mime:W.mime,valueBytes:Array.from(W.data)}}_e.from=ke;function Y(W){return new w.NotebookCellOutputItem(new Uint8Array(W.valueBytes),W.mime)}_e.to=Y})(me=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var we;(function(_e){function ke(W){return{outputId:W.id,items:W.items.map(me.from),metadata:W.metadata}}_e.from=ke;function Y(W){const Fe=W.items.map(me.to);return new w.NotebookCellOutput(Fe,W.outputId,W.metadata)}_e.to=Y})(we=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Ie;(function(_e){function ke(Me){if(Me!=null){if(Me instanceof w.RelativePattern||typeof Me=="string")return Me;if(Fe(Me))return new w.RelativePattern(Me.base,Me.pattern);if(W(Me))return{include:Se.from(Me.include)||void 0,exclude:Se.from(Me.exclude)||void 0}}}_e.from=ke;function Y(Me){return typeof Me=="string"?Me:Fe(Me)?{base:Me.base,pattern:Me.pattern}:{include:Me.include,exclude:Me.exclude}}_e.to=Y;function W(Me){const tt=Me,Ge=Se.from(tt.include);if(!(Ge&&Ge instanceof w.RelativePattern||typeof Ge=="string"))return!1;const dt=Se.from(tt.exclude);return!!(dt&&dt instanceof w.RelativePattern||typeof dt=="string")}function Fe(Me){const tt=Me;return tt&&typeof tt.base=="string"&&typeof tt.pattern=="string"}})(Ie=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Oe;(function(_e){function ke(Y){return{backgroundColor:Y.backgroundColor,borderColor:Y.borderColor,top:Y.top?A.from(Y.top):void 0}}_e.from=ke})(Oe=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var He;(function(_e){function ke(Y,W,Fe){const Me=typeof Y.command=="string"?{title:"",command:Y.command}:Y.command;return{alignment:Y.alignment===w.NotebookCellStatusBarAlignment.Left?1:2,command:W.toInternal(Me,Fe),text:Y.text,tooltip:Y.tooltip,accessibilityInformation:Y.accessibilityInformation,priority:Y.priority}}_e.from=ke})(He=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var et;(function(_e){function ke(Y){return{transientOutputs:Y?.transientOutputs??!1,transientCellMetadata:Y?.transientCellMetadata??{},transientDocumentMetadata:Y?.transientDocumentMetadata??{}}}_e.from=ke})(et=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Qe;(function(_e){function ke(W){return{uri:W.uri,provides:W.provides}}_e.from=ke;function Y(W){return new w.NotebookRendererScript(b.URI.revive(W.uri),W.provides)}_e.to=Y})(Qe=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Ke;(function(_e){function ke(W){return{message:D.fromStrict(W.message)||"",severity:w.TestMessageSeverity.Error,expectedOutput:W.expectedOutput,actualOutput:W.actualOutput,location:W.location?$.from(W.location):void 0}}_e.from=ke;function Y(W){const Fe=new w.TestMessage(typeof W.message=="string"?W.message:D.to(W.message));return Fe.actualOutput=W.actualOutput,Fe.expectedOutput=W.expectedOutput,Fe}_e.to=Y})(Ke=e.TestMessage||(e.TestMessage={}));var lt;(function(_e){function ke(Me){return{extId:m.TestId.fromExtHostTestItem(Me,(0,d.getPrivateApiFor)(Me).controllerId).toString(),label:Me.label,uri:Me.uri,range:a.from(Me.range)||null,description:Me.description||null,error:Me.error&&D.fromStrict(Me.error)||null}}_e.from=ke;function Y(Me){return{id:m.TestId.fromString(Me.extId).localId,label:Me.label,uri:b.URI.revive(Me.uri),range:a.to(Me.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Me.description||void 0}}_e.toPlain=Y;function W(Me){const tt=m.TestId.fromString(Me.extId),Ge=new d.TestItemImpl(tt.controllerId,tt.localId,Me.label,b.URI.revive(Me.uri));return Ge.range=a.to(Me.range||void 0),Ge.description=Me.description||void 0,Ge}function Fe(Me){let tt;for(const Ge of Me.tests){const dt=W(Ge.item);(0,d.getPrivateApiFor)(dt).parent=tt,tt=dt}return tt}_e.toItemFromContext=Fe})(lt=e.TestItem||(e.TestItem={}));var ft;(function(_e){const ke=(W,Fe)=>{const Me={...lt.toPlain(W.item),parent:void 0,taskStates:W.tasks.map(tt=>({state:tt.state,duration:tt.duration,messages:tt.messages.map(Ke.to)})),children:W.children.map(tt=>Fe.get(tt)).filter(y.isDefined).map(tt=>ke(tt,Fe))};for(const tt of Me.children)tt.parent=Me;return Me};function Y(W){const Fe=[],Me=new Map;for(const tt of W.items)Me.set(tt.item.extId,tt),W.request.targets.some(Ge=>Ge.controllerId===tt.controllerId&&Ge.testIds.includes(tt.item.extId))&&Fe.push(tt);return{completedAt:W.completedAt,results:Fe.map(tt=>ke(tt,Me))}}_e.to=Y})(ft=e.TestResults||(e.TestResults={}));var _t;(function(_e){function ke(Me){return{covered:Me.covered,total:Me.covered}}function Y(Me){return"line"in Me?p.from(Me):a.from(Me)}function W(Me){return"branches"in Me?{count:Me.executionCount,location:Y(Me.location),type:1,branches:Me.branches.length?Me.branches.map(tt=>({count:tt.executionCount,location:tt.location&&Y(tt.location)})):void 0}:{type:0,count:Me.executionCount,location:Y(Me.location)}}_e.fromDetailed=W;function Fe(Me){return{uri:Me.uri,statement:ke(Me.statementCoverage),branch:Me.branchCoverage&&ke(Me.branchCoverage),function:Me.functionCoverage&&ke(Me.functionCoverage),details:Me.detailedCoverage?.map(W)}}_e.fromFile=Fe})(_t=e.TestCoverage||(e.TestCoverage={}));var ut;(function(_e){function ke(Y){switch(Y){case 1:return w.CodeActionTriggerKind.Invoke;case 2:return w.CodeActionTriggerKind.Automatic}}_e.to=ke})(ut=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var ot;(function(_e){function ke(W){const Fe=new w.TypeHierarchyItem(z.to(W.kind),W.name,W.detail||"",b.URI.revive(W.uri),a.to(W.range),a.to(W.selectionRange));return Fe._sessionId=W._sessionId,Fe._itemId=W._itemId,Fe}_e.to=ke;function Y(W,Fe,Me){if(Fe=Fe??W._sessionId,Me=Me??W._itemId,Fe===void 0||Me===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:Me,kind:z.from(W.kind),name:W.name,detail:W.detail??"",uri:W.uri,range:a.from(W.range),selectionRange:a.from(W.selectionRange),tags:W.tags?.map(V.from)}}_e.from=Y})(ot=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(be[178],Ee([0,1,2,12,7,9,80]),function(ee,e,g,F,S,_,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class y{constructor(k,n,I,l={timeout:1500,errors:3}){this._logService=k,this._documents=n,this._mainThreadBulkEdits=I,this._thresholds=l,this._callbacks=new C.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(k){return(n,I,l)=>{const c={dispose:this._callbacks.push([n,I,k])};return Array.isArray(l)&&l.push(c),c}}async $participateInSave(k,n){const I=g.URI.revive(k);let l=!1;const d=setTimeout(()=>l=!0,this._thresholds.timeout),c=[];try{for(let m of[...this._callbacks]){if(l)break;const E=this._documents.getDocument(I),w=await this._deliverEventAsyncAndBlameBadListeners(m,{document:E,reason:_.TextDocumentSaveReason.to(n)});c.push(w)}}finally{clearTimeout(d)}return c}_deliverEventAsyncAndBlameBadListeners([k,n,I],l){const d=this._badListeners.get(k);return typeof d=="number"&&d>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(I,k,n,l).then(()=>!0,c=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this._logService.error(c),!(c instanceof Error)||c.message!=="concurrent_edits"){const m=this._badListeners.get(k);this._badListeners.set(k,m?m+1:1),typeof m=="number"&&m>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(k,n,I,l){const d=[],c=Date.now(),{document:m,reason:E}=l,{version:w}=m,P=Object.freeze({document:m,reason:E,waitUntil(a){if(Object.isFrozen(d))throw(0,F.illegalState)("waitUntil can not be called async");d.push(Promise.resolve(a))}});try{n.apply(I,[P])}catch(a){return Promise.reject(a)}return Object.freeze(d),new Promise((a,h)=>{const p=setTimeout(()=>h(new Error("timeout")),this._thresholds.timeout);return Promise.all(d).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' finished after ${Date.now()-c}ms`),clearTimeout(p),a(t)}).catch(t=>{clearTimeout(p),h(t)})}).then(a=>{const h={edits:[]};for(const p of a)if(Array.isArray(p)&&p.every(t=>t instanceof S.TextEdit))for(const{newText:t,newEol:r,range:s}of p)h.edits.push({_type:2,resource:m.uri,edit:{range:s&&_.Range.from(s),text:t,eol:r&&_.EndOfLine.from(r)}});if(h.edits.length!==0)return w===m.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(h):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=y}),define(be[179],Ee([0,1,3,27,2,9,7]),function(ee,e,g,F,S,_,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class y{constructor(n,I,l,d,c){this._onDidCreate=new g.Emitter,this._onDidChange=new g.Emitter,this._onDidDelete=new g.Emitter,this._config=0,l&&(this._config+=1),d&&(this._config+=2),c&&(this._config+=4);const m=(0,F.parse)(I),E=n(w=>{if(!l)for(let P of w.created){const a=S.URI.revive(P);m(a.fsPath)&&this._onDidCreate.fire(a)}if(!d)for(let P of w.changed){const a=S.URI.revive(P);m(a.fsPath)&&this._onDidChange.fire(a)}if(!c)for(let P of w.deleted){const a=S.URI.revive(P);m(a.fsPath)&&this._onDidDelete.fire(a)}});this._disposable=C.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,E)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class b{constructor(n,I,l){this._logService=I,this._extHostDocumentsAndEditors=l,this._onFileSystemEvent=new g.Emitter,this._onDidRenameFile=new g.Emitter,this._onDidCreateFile=new g.Emitter,this._onDidDeleteFile=new g.Emitter,this._onWillRenameFile=new g.AsyncEmitter,this._onWillCreateFile=new g.AsyncEmitter,this._onWillDeleteFile=new g.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(n,I,l,d){return new y(this._onFileSystemEvent.event,n,I,l,d)}$onFileEvent(n){this._onFileSystemEvent.fire(n)}$onDidRunFileOperation(n,I){switch(n){case 2:this._onDidRenameFile.fire(Object.freeze({files:I.map(l=>({oldUri:S.URI.revive(l.source),newUri:S.URI.revive(l.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:I.map(l=>S.URI.revive(l.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:I.map(l=>S.URI.revive(l.target))}));break;default:}}getOnWillRenameFileEvent(n){return this._createWillExecuteEvent(n,this._onWillRenameFile)}getOnWillCreateFileEvent(n){return this._createWillExecuteEvent(n,this._onWillCreateFile)}getOnWillDeleteFileEvent(n){return this._createWillExecuteEvent(n,this._onWillDeleteFile)}_createWillExecuteEvent(n,I){return(l,d,c)=>{const m=function(w){l.call(d,w)};return m.extension=n,I.event(m,void 0,c)}}async $onWillRunFileOperation(n,I,l,d){switch(n){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:I.map(c=>({oldUri:S.URI.revive(c.source),newUri:S.URI.revive(c.target)}))},l,d);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:I.map(c=>S.URI.revive(c.target))},l,d);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:I.map(c=>S.URI.revive(c.target))},l,d)}}async _fireWillEvent(n,I,l,d){const c=new Set,m=[];if(await n.fireAsync(I,d,async(w,P)=>{const a=Date.now(),h=await Promise.resolve(w);h instanceof C.WorkspaceEdit&&(m.push(h),c.add(P.extension.displayName??P.extension.identifier.value)),Date.now()-a>l&&this._logService.warn("SLOW file-participant",P.extension.identifier)}),d.isCancellationRequested||m.length===0)return;const E={edits:[]};for(let w of m){let{edits:P}=_.WorkspaceEdit.from(w,this._extHostDocumentsAndEditors);E.edits=E.edits.concat(P)}return{edit:E,extensionNames:Array.from(c)}}}e.ExtHostFileSystemEventService=b}),define(be[180],Ee([0,1,11,23,2,9,7,71]),function(ee,e,g,F,S,_,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class b{constructor(l,d,c,m){this.start=l,this.deletedCount=d,this.deletedItems=c,this.items=m}static asApiEvents(l){return l.map(d=>({start:d.start,deletedCount:d.deletedCount,deletedItems:d.deletedItems,items:d.items.map(c=>c.apiCell)}))}}class k{constructor(l,d,c){this.notebook=l,this._extHostDocument=d,this._cellData=c,this.handle=c.handle,this.uri=S.URI.revive(c.uri),this.cellKind=c.cellKind,this._outputs=c.outputs.map(_.NotebookCellOutput.to),this._internalMetadata=c.internalMetadata??{},this._metadata=c.metadata??{},this._previousResult=_.NotebookCellExecutionSummary.to(c.internalMetadata??{})}static asModelAddData(l,d){return{EOL:d.eol,lines:d.source,modeId:d.language,uri:d.uri,isDirty:!1,versionId:1,notebook:l}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const l=this,d=this._extHostDocument.getDocument(this.uri);if(!d)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return l.notebook.getCellIndex(l)},notebook:l.notebook.apiNotebook,kind:_.NotebookCellKind.to(this._cellData.cellKind),document:d.document,get mime(){return l._mime},set mime(c){l._mime=c},get outputs(){return l._outputs.slice(0)},get metadata(){return l._metadata},get executionSummary(){return l._previousResult}})}return this._apiCell}setOutputs(l){this._outputs=l.map(_.NotebookCellOutput.to)}setOutputItems(l,d,c){const m=c.map(_.NotebookCellOutputItem.to),E=this._outputs.find(w=>w.id===l);E&&(d||(E.items.length=0),E.items.push(...m))}setMetadata(l){this._metadata=l}setInternalMetadata(l){this._internalMetadata=l,this._previousResult=_.NotebookCellExecutionSummary.to(l)}setMime(l){}}e.ExtHostCell=k;class n{constructor(l,d,c,m,E,w){this._proxy=l,this._textDocumentsAndEditors=d,this._textDocuments=c,this._emitter=m,this.uri=E,this.handle=n._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=w.viewType,this._metadata=w.metadata??Object.create(null),this._spliceNotebookCells([[0,0,w.cells]],!0),this._versionId=w.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const l=this;this._notebook={get uri(){return l.uri},get version(){return l._versionId},get notebookType(){return l._notebookType},get isDirty(){return l._isDirty},get isUntitled(){return l.uri.scheme===g.Schemas.untitled},get isClosed(){return l._disposed},get metadata(){return l._metadata},get cellCount(){return l._cells.length},cellAt(d){return d=l._validateIndex(d),l._cells[d].apiCell},getCells(d){return(d?l._getCells(d):l._cells).map(m=>m.apiCell)},save(){return l._save()}}}return this._notebook}updateBackup(l){this._backup?.delete(),this._backup=l}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(l){l.metadata&&(this._metadata={...this._metadata,...l.metadata})}acceptDirty(l){this._isDirty=l}acceptModelChanged(l,d){this._versionId=l.versionId,this._isDirty=d;for(const c of l.rawEvents)c.kind===y.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(c.changes,!1):c.kind===y.NotebookCellsChangeType.Move?this._moveCell(c.index,c.newIdx):c.kind===y.NotebookCellsChangeType.Output?this._setCellOutputs(c.index,c.outputs):c.kind===y.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(c.index,c.outputId,c.append,c.outputItems):c.kind===y.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(c.index,c.language):c.kind===y.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(c.index,c.mime):c.kind===y.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(c.index,c.metadata):c.kind===y.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(c.index,c.internalMetadata)}_validateIndex(l){return l=l|0,l<0?0:l>=this._cells.length?this._cells.length-1:l}_validateRange(l){let d=l.start|0,c=l.end|0;return d<0&&(d=0),c>this._cells.length&&(c=this._cells.length),l.with({start:d,end:c})}_getCells(l){l=this._validateRange(l);const d=[];for(let c=l.start;c<l.end;c++)d.push(this._cells[c]);return d}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(l,d){if(this._disposed)return;const c=[],m=[],E=[];l.reverse().forEach(w=>{const a=w[2].map(t=>{const r=new k(this,this._textDocumentsAndEditors,t);return d||m.push(k.asModelAddData(this.apiNotebook,t)),r}),h=new b(w[0],w[1],[],a),p=this._cells.splice(w[0],w[1],...a);for(const t of p)E.push(t.uri),h.deletedItems.push(t.apiCell);c.push(h)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:m,removedDocuments:E}),d||this._emitter.emitModelChange((0,F.deepFreeze)({document:this.apiNotebook,changes:b.asApiEvents(c)}))}_moveCell(l,d){const c=this._cells.splice(l,1);this._cells.splice(d,0,...c);const m=[new b(l,1,c.map(E=>E.apiCell),[]),new b(d,0,[],c)];this._emitter.emitModelChange((0,F.deepFreeze)({document:this.apiNotebook,changes:b.asApiEvents(m)}))}_setCellOutputs(l,d){const c=this._cells[l];c.setOutputs(d),this._emitter.emitCellOutputsChange((0,F.deepFreeze)({document:this.apiNotebook,cells:[c.apiCell]}))}_setCellOutputItems(l,d,c,m){const E=this._cells[l];E.setOutputItems(d,c,m),this._emitter.emitCellOutputsChange((0,F.deepFreeze)({document:this.apiNotebook,cells:[E.apiCell]}))}_changeCellLanguage(l,d){const c=this._cells[l];c.apiCell.document.languageId!==d&&this._textDocuments.$acceptModelModeChanged(c.uri,d)}_changeCellMime(l,d){const c=this._cells[l];c.apiCell.mime=d}_changeCellMetadata(l,d){const c=this._cells[l],m=c.apiCell.metadata;c.setMetadata(d);const E=c.apiCell.metadata;(0,F.equals)(m,E)||this._emitter.emitCellMetadataChange((0,F.deepFreeze)({document:this.apiNotebook,cell:c.apiCell}))}_changeCellInternalMetadata(l,d){const c=this._cells[l],m=c.internalMetadata;if(c.setInternalMetadata(d),m.runState!==d.runState){const E=d.runState??C.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,F.deepFreeze)({document:this.apiNotebook,cell:c.apiCell,state:E}))}}getCellFromApiCell(l){return this._cells.find(d=>d.apiCell===l)}getCellFromIndex(l){return this._cells[l]}getCell(l){return this._cells.find(d=>d.handle===l)}getCellIndex(l){return this._cells.indexOf(l)}}e.ExtHostNotebookDocument=n,n._handlePool=0}),define(be[101],Ee([0,1,7,9,12]),function(ee,e,g,F,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class _{constructor(b){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=b}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(b){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:b})}replaceCellMetadata(b,k){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:b,metadata:k})}replaceCells(b,k,n){this._throwIfFinalized(),!(b===k&&n.length===0)&&this._collectedEdits.push({editType:1,index:b,count:k-b,cells:n.map(F.NotebookCellData.from)})}}class C{constructor(b,k,n,I,l,d){this.id=b,this._proxy=k,this.notebookData=n,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=l,this._visibleRanges=I,this._viewColumn=d}get apiEditor(){if(!this._editor){const b=this;this._editor={get document(){return b.notebookData.apiNotebook},get selections(){return b._selections},set selections(k){if(!Array.isArray(k)||!k.every(g.NotebookRange.isNotebookRange))throw(0,S.illegalArgument)("selections");b._selections=k,b._trySetSelections(k)},get visibleRanges(){return b._visibleRanges},revealRange(k,n){b._proxy.$tryRevealRange(b.id,F.NotebookRange.from(k),n??g.NotebookEditorRevealType.Default)},get viewColumn(){return b._viewColumn},edit(k){const n=new _(this.document.version);return k(n),b._applyEdit(n.finalize())},setDecorations(k,n){return b.setDecorations(k,n)}},C.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(b){this._visible=b}_acceptVisibleRanges(b){this._visibleRanges=b}_acceptSelections(b){this._selections=b}_trySetSelections(b){this._proxy.$trySetSelections(this.id,b.map(F.NotebookRange.from))}_acceptViewColumn(b){this._viewColumn=b}_applyEdit(b){if(b.cellEdits.length===0)return Promise.resolve(!0);const k=[];let n=-1;for(let I=0;I<b.cellEdits.length;I++){if(n<0){k.push(b.cellEdits[I]),n++;continue}const d=k[n],c=b.cellEdits[I];if(d.editType===1&&c.editType===1&&d.index===c.index){d.cells.push(...b.cellEdits[I].cells),d.count+=b.cellEdits[I].count;continue}k.push(b.cellEdits[I]),n++}return this._proxy.$tryApplyEdits(this.id,b.documentVersionId,k)}setDecorations(b,k){if(!(k.isEmpty&&!this._hasDecorationsForKey.has(b.key)))return k.isEmpty?this._hasDecorationsForKey.delete(b.key):this._hasDecorationsForKey.add(b.key),this._proxy.$trySetDecorations(this.id,F.NotebookRange.from(k),b.key)}}e.ExtHostNotebookEditor=C,C.apiEditorsToExtHost=new WeakMap}),define(be[181],Ee([0,1,9,156,135,20,51]),function(ee,e,g,F,S,_,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class y{constructor(I){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=I}withProgress(I,l,d){const c=this._handles++,{title:m,location:E,cancellable:w}=l,P={label:(0,S.localize)(0,null,I.displayName||I.name),id:I.identifier.value};return this._proxy.$startProgress(c,{location:g.ProgressLocation.from(E),title:m,source:P,cancellable:w},I),this._withProgress(c,d,!!w)}_withProgress(I,l,d){let c;d&&(c=new _.CancellationTokenSource,this._mapHandleToCancellationSource.set(I,c));const m=w=>{this._proxy.$progressEnd(w),this._mapHandleToCancellationSource.delete(w),c&&c.dispose()};let E;try{E=l(new k(this._proxy,I),d&&c?c.token:_.CancellationToken.None)}catch(w){throw m(I),w}return E.then(w=>m(I),w=>m(I)),E}$acceptProgressCanceled(I){const l=this._mapHandleToCancellationSource.get(I);l&&(l.cancel(),this._mapHandleToCancellationSource.delete(I))}}e.ExtHostProgress=y;function b(n,I){return n.message=I.message,typeof I.increment=="number"&&(typeof n.increment=="number"?n.increment+=I.increment:n.increment=I.increment),n}class k extends F.Progress{constructor(I,l){super(d=>this.throttledReport(d));this._proxy=I,this._handle=l}throttledReport(I){this._proxy.$progressReport(this._handle,I)}}ze([(0,C.throttle)(100,(n,I)=>b(n,I),()=>Object.create(null))],k.prototype,"throttledReport",null)}),define(be[102],Ee([0,1,40,12,53,9,7]),function(ee,e,g,F,S,_,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class y{constructor(l,d,c){const m=y._Keys.nextId();l.$registerTextEditorDecorationType(d.identifier,m,_.DecorationRenderOptions.from(c)),this.value=Object.freeze({key:m,dispose(){l.$removeTextEditorDecorationType(m)}})}}e.TextEditorDecorationType=y,y._Keys=new S.IdGenerator("TextEditorDecorationType");class b{constructor(l,d){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=l,this._documentVersionId=l.version,this._undoStopBefore=d.undoStopBefore,this._undoStopAfter=d.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(l,d){this._throwIfFinalized();let c=null;if(l instanceof C.Position)c=new C.Range(l,l);else if(l instanceof C.Range)c=l;else throw new Error("Unrecognized location");this._pushEdit(c,d,!1)}insert(l,d){this._throwIfFinalized(),this._pushEdit(new C.Range(l,l),d,!0)}delete(l){this._throwIfFinalized();let d=null;if(l instanceof C.Range)d=l;else throw new Error("Unrecognized location");this._pushEdit(d,null,!0)}_pushEdit(l,d,c){const m=this._document.validateRange(l);this._collectedEdits.push({range:m,text:d,forceMoveMarkers:c})}setEndOfLine(l){if(this._throwIfFinalized(),l!==C.EndOfLine.LF&&l!==C.EndOfLine.CRLF)throw(0,F.illegalArgument)("endOfLine");this._setEndOfLine=l}}e.TextEditorEdit=b;class k{constructor(l,d,c,m){this._proxy=l,this._id=d,this._accept(c),this._logService=m;const E=this;this.value={get tabSize(){return E._tabSize},set tabSize(w){E._setTabSize(w)},get insertSpaces(){return E._insertSpaces},set insertSpaces(w){E._setInsertSpaces(w)},get cursorStyle(){return E._cursorStyle},set cursorStyle(w){E._setCursorStyle(w)},get lineNumbers(){return E._lineNumbers},set lineNumbers(w){E._setLineNumbers(w)}}}_accept(l){this._tabSize=l.tabSize,this._insertSpaces=l.insertSpaces,this._cursorStyle=l.cursorStyle,this._lineNumbers=_.TextEditorLineNumbersStyle.to(l.lineNumbers)}_validateTabSize(l){if(l==="auto")return"auto";if(typeof l=="number"){const d=Math.floor(l);return d>0?d:null}if(typeof l=="string"){const d=parseInt(l,10);return isNaN(d)?null:d>0?d:null}return null}_setTabSize(l){const d=this._validateTabSize(l);if(d!==null){if(typeof d=="number"){if(this._tabSize===d)return;this._tabSize=d}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:d}))}}_validateInsertSpaces(l){return l==="auto"?"auto":l==="false"?!1:Boolean(l)}_setInsertSpaces(l){const d=this._validateInsertSpaces(l);if(typeof d=="boolean"){if(this._insertSpaces===d)return;this._insertSpaces=d}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:d}))}_setCursorStyle(l){this._cursorStyle!==l&&(this._cursorStyle=l,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:l})))}_setLineNumbers(l){this._lineNumbers!==l&&(this._lineNumbers=l,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:_.TextEditorLineNumbersStyle.from(l)})))}assign(l){const d={};let c=!1;if(typeof l.tabSize!="undefined"){const m=this._validateTabSize(l.tabSize);m==="auto"?(c=!0,d.tabSize=m):typeof m=="number"&&this._tabSize!==m&&(this._tabSize=m,c=!0,d.tabSize=m)}if(typeof l.insertSpaces!="undefined"){const m=this._validateInsertSpaces(l.insertSpaces);m==="auto"?(c=!0,d.insertSpaces=m):this._insertSpaces!==m&&(this._insertSpaces=m,c=!0,d.insertSpaces=m)}typeof l.cursorStyle!="undefined"&&this._cursorStyle!==l.cursorStyle&&(this._cursorStyle=l.cursorStyle,c=!0,d.cursorStyle=l.cursorStyle),typeof l.lineNumbers!="undefined"&&this._lineNumbers!==l.lineNumbers&&(this._lineNumbers=l.lineNumbers,c=!0,d.lineNumbers=_.TextEditorLineNumbersStyle.from(l.lineNumbers)),c&&this._warnOnError(this._proxy.$trySetOptions(this._id,d))}_warnOnError(l){l.catch(d=>this._logService.warn(d))}}e.ExtHostTextEditorOptions=k;class n{constructor(l,d,c,m,E,w,P,a){this.id=l,this._proxy=d,this._logService=c,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=E,this._options=new k(this._proxy,this.id,w,c),this._visibleRanges=P,this._viewColumn=a;const h=this;this.value=Object.freeze({get document(){return m.getValue()},set document(p){throw(0,F.readonly)("document")},get selection(){return h._selections&&h._selections[0]},set selection(p){if(!(p instanceof C.Selection))throw(0,F.illegalArgument)("selection");h._selections=[p],h._trySetSelection()},get selections(){return h._selections},set selections(p){if(!Array.isArray(p)||p.some(t=>!(t instanceof C.Selection)))throw(0,F.illegalArgument)("selections");h._selections=p,h._trySetSelection()},get visibleRanges(){return h._visibleRanges},set visibleRanges(p){throw(0,F.readonly)("visibleRanges")},get options(){return h._options.value},set options(p){h._disposed||h._options.assign(p)},get viewColumn(){return h._viewColumn},set viewColumn(p){throw(0,F.readonly)("viewColumn")},edit(p,t={undoStopBefore:!0,undoStopAfter:!0}){if(h._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const r=new b(m.getValue(),t);return p(r),h._applyEdit(r)},insertSnippet(p,t,r={undoStopBefore:!0,undoStopAfter:!0}){if(h._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!t||Array.isArray(t)&&t.length===0)s=h._selections.map(i=>_.Range.from(i));else if(t instanceof C.Position){const{lineNumber:i,column:u}=_.Position.from(t);s=[{startLineNumber:i,startColumn:u,endLineNumber:i,endColumn:u}]}else if(t instanceof C.Range)s=[_.Range.from(t)];else{s=[];for(const i of t)if(i instanceof C.Range)s.push(_.Range.from(i));else{const{lineNumber:u,column:f}=_.Position.from(i);s.push({startLineNumber:u,startColumn:f,endLineNumber:u,endColumn:f})}}return d.$tryInsertSnippet(l,p.value,s,r)},setDecorations(p,t){const r=t.length===0;r&&!h._hasDecorationsForKey.has(p.key)||(r?h._hasDecorationsForKey.delete(p.key):h._hasDecorationsForKey.add(p.key),h._runOnProxy(()=>{if(_.isDecorationOptionsArr(t))return d.$trySetDecorations(l,p.key,_.fromRangeOrRangeWithMessage(t));{const s=new Array(4*t.length);for(let i=0,u=t.length;i<u;i++){const f=t[i];s[4*i]=f.start.line+1,s[4*i+1]=f.start.character+1,s[4*i+2]=f.end.line+1,s[4*i+3]=f.end.character+1}return d.$trySetDecorationsFast(l,p.key,s)}}))},revealRange(p,t){h._runOnProxy(()=>d.$tryRevealRange(l,_.Range.from(p),t||C.TextEditorRevealType.Default))},show(p){d.$tryShowEditor(l,_.ViewColumn.from(p))},hide(){d.$tryHideEditor(l)}})}dispose(){(0,g.ok)(!this._disposed),this._disposed=!0}_acceptOptions(l){(0,g.ok)(!this._disposed),this._options._accept(l)}_acceptVisibleRanges(l){(0,g.ok)(!this._disposed),this._visibleRanges=l}_acceptViewColumn(l){(0,g.ok)(!this._disposed),this._viewColumn=l}_acceptSelections(l){(0,g.ok)(!this._disposed),this._selections=l}async _trySetSelection(){const l=this._selections.map(_.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,l)),this.value}_applyEdit(l){const d=l.finalize();if(d.edits.length===0&&!d.setEndOfLine)return Promise.resolve(!0);const c=d.edits.map(E=>E.range);c.sort((E,w)=>E.end.line===w.end.line?E.end.character===w.end.character?E.start.line===w.start.line?E.start.character-w.start.character:E.start.line-w.start.line:E.end.character-w.end.character:E.end.line-w.end.line);for(let E=0,w=c.length-1;E<w;E++){const P=c[E].end;if(c[E+1].start.isBefore(P))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const m=d.edits.map(E=>({range:_.Range.from(E.range),text:E.text,forceMoveMarkers:E.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,d.documentVersionId,m,{setEndOfLine:typeof d.setEndOfLine=="number"?_.EndOfLine.from(d.setEndOfLine):void 0,undoStopBefore:d.undoStopBefore,undoStopAfter:d.undoStopAfter})}_runOnProxy(l){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):l().then(()=>this,d=>(d instanceof Error&&d.name==="DISPOSED"||this._logService.warn(d),null))}}e.ExtHostTextEditor=n}),define(be[182],Ee([0,1,138,25,2,3,6,171,16,7,10,17,9,20,168]),function(ee,e,g,F,S,_,C,y,b,k,n,I,l,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function m(P,a){if((0,n.isString)(P))return{label:P};if(P&&typeof P=="object"&&typeof P.label=="string"){let h;return Array.isArray(P.highlights)&&(h=P.highlights.filter(p=>p.length===2&&typeof p[0]=="number"&&typeof p[1]=="number"),h=h.length?h:void 0),{label:P.label,highlights:h}}}class E{constructor(a,h,p){this._proxy=a,this.commands=h,this.logService=p,this.treeViews=new Map;function t(r){return r&&r.$treeViewId&&r.$treeItemHandle}h.registerArgumentProcessor({processArgument:r=>t(r)?this.convertArgument(r):Array.isArray(r)&&r.length>0?r.map(s=>t(s)?this.convertArgument(s):s):r})}registerTreeDataProvider(a,h,p){const t=this.createTreeView(a,{treeDataProvider:h},p);return{dispose:()=>t.dispose()}}createTreeView(a,h,p){if(!h||!h.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const t=h.dragAndDropController!==void 0,r=this._proxy.$registerTreeViewDataProvider(a,{showCollapseAll:!!h.showCollapseAll,canSelectMany:!!h.canSelectMany,canDragAndDrop:t}),s=this.createExtHostTreeView(a,h,p);return{get onDidCollapseElement(){return s.onDidCollapseElement},get onDidExpandElement(){return s.onDidExpandElement},get selection(){return s.selectedElements},get onDidChangeSelection(){return s.onDidChangeSelection},get visible(){return s.visible},get onDidChangeVisibility(){return s.onDidChangeVisibility},get message(){return s.message},set message(i){s.message=i},get title(){return s.title},set title(i){s.title=i},get description(){return s.description},set description(i){s.description=i},reveal:(i,u)=>s.reveal(i,u),dispose:async()=>{await r,this.treeViews.delete(a),s.dispose()}}}$getChildren(a,h){const p=this.treeViews.get(a);return p?p.getChildren(h):Promise.reject(new Error((0,g.localize)(0,null,a)))}async $onDrop(a,h,p){const t=this.treeViews.get(a);if(!t)return Promise.reject(new Error((0,g.localize)(1,null,a)));const r=c.TreeDataTransferConverter.toITreeDataTransfer(h);if(r.items.has(y.TREE_ITEM_DATA_TRANSFER_TYPE)){const i=JSON.parse(await r.items.get(y.TREE_ITEM_DATA_TRANSFER_TYPE).asString()).map(u=>t.getExtensionElement(u)).filter(u=>!!u);i.length>0?r.items.set(y.TREE_ITEM_DATA_TRANSFER_TYPE,{asString:async()=>JSON.stringify(i)}):r.items.delete(y.TREE_ITEM_DATA_TRANSFER_TYPE)}return t.onDrop(r,p)}async $hasResolve(a){const h=this.treeViews.get(a);if(!h)throw new Error((0,g.localize)(2,null,a));return h.hasResolve}$resolve(a,h,p){const t=this.treeViews.get(a);if(!t)throw new Error((0,g.localize)(3,null,a));return t.resolveTreeItem(h,p)}$setExpanded(a,h,p){const t=this.treeViews.get(a);if(!t)throw new Error((0,g.localize)(4,null,a));t.setExpanded(h,p)}$setSelection(a,h){const p=this.treeViews.get(a);if(!p)throw new Error((0,g.localize)(5,null,a));p.setSelection(h)}$setVisible(a,h){const p=this.treeViews.get(a);if(!p)throw new Error((0,g.localize)(6,null,a));p.setVisible(h)}createExtHostTreeView(a,h,p){const t=new w(a,h,this._proxy,this.commands.converter,this.logService,p);return this.treeViews.set(a,t),t}convertArgument(a){const h=this.treeViews.get(a.$treeViewId);return h?h.getExtensionElement(a.$treeItemHandle):null}}e.ExtHostTreeViews=E;class w extends C.Disposable{constructor(a,h,p,t,r,s){super();if(this.viewId=a,this.proxy=p,this.commands=t,this.logService=r,this.extension=s,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new _.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new _.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new _.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new _.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new _.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new d.CancellationTokenSource,s.contributes&&s.contributes.views)for(const f in s.contributes.views)for(const v of s.contributes.views[f])v.id===a&&(this._title=v.name);this.dataProvider=h.treeDataProvider,this.dndController=h.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(f=>this._onDidChangeData.fire({message:!1,element:f}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(f=>this._onDidChangeData.fire({message:!1,element:f})));let i,u;this._register(_.Event.debounce(this._onDidChangeData.event,(f,v)=>(f||(f={message:!1,elements:[]}),v.element!==!1&&(i||(i=new Promise(D=>u=D),this.refreshPromise=this.refreshPromise.then(()=>i)),Array.isArray(v.element)?f.elements.push(...v.element):f.elements.push(v.element)),v.message&&(f.message=!0),f),200,!0)(({message:f,elements:v})=>{v.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const D=u;return i=null,this.refresh(v).then(()=>D())})),f&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(a=>this.getExtensionElement(a)).filter(a=>!(0,n.isUndefinedOrNull)(a))}getChildren(a){const h=a?this.getExtensionElement(a):void 0;if(a&&!h)return this.logService.error(`No tree item with id '${a}' found.`),Promise.resolve([]);const p=this.getChildrenNodes(a);return(p?Promise.resolve(p):this.fetchChildrenNodes(h)).then(t=>t.map(r=>r.item))}getExtensionElement(a){return this.elements.get(a)}reveal(a,h){h=h||{select:!0,focus:!1};const p=(0,n.isUndefinedOrNull)(h.select)?!0:h.select,t=(0,n.isUndefinedOrNull)(h.focus)?!1:h.focus,r=(0,n.isUndefinedOrNull)(h.expand)?!1:h.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):a?this.refreshPromise.then(()=>this.resolveUnknownParentChain(a)).then(s=>this.resolveTreeNode(a,s[s.length-1]).then(i=>this.proxy.$reveal(this.viewId,{item:i.item,parentChain:s.map(u=>u.item)},{select:p,focus:t,expand:r})),s=>this.logService.error(s)):this.proxy.$reveal(this.viewId,void 0,{select:p,focus:t,expand:r})}get message(){return this._message}set message(a){this._message=a,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(a){this._title=a,this.proxy.$setTitle(this.viewId,a,this._description)}get description(){return this._description}set description(a){this._description=a,this.proxy.$setTitle(this.viewId,this._title,a)}setExpanded(a,h){const p=this.getExtensionElement(a);p&&(h?this._onDidExpandElement.fire(Object.freeze({element:p})):this._onDidCollapseElement.fire(Object.freeze({element:p})))}setSelection(a){(0,I.equals)(this._selectedHandles,a)||(this._selectedHandles=a,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(a){a!==this._visible&&(this._visible=a,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onDrop(a,h){const p=this.getExtensionElement(h);if(!!p)return(0,b.asPromise)(()=>this.dndController?.onDrop(a,p))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(a,h){if(!this.dataProvider.resolveTreeItem)return;const p=this.elements.get(a);if(p){const t=this.nodes.get(p);if(t){const r=await this.dataProvider.resolveTreeItem(t.extensionItem,p,h)??t.extensionItem;return t.item.tooltip=this.getTooltip(r.tooltip),t.item.command=this.getCommand(t.disposableStore,r.command),t.item}}}resolveUnknownParentChain(a){return this.resolveParent(a).then(h=>h?this.resolveUnknownParentChain(h).then(p=>this.resolveTreeNode(h,p[p.length-1]).then(t=>(p.push(t),p))):Promise.resolve([]))}resolveParent(a){const h=this.nodes.get(a);return h?Promise.resolve(h.parent?this.elements.get(h.parent.item.handle):void 0):(0,b.asPromise)(()=>this.dataProvider.getParent(a))}resolveTreeNode(a,h){const p=this.nodes.get(a);return p?Promise.resolve(p):(0,b.asPromise)(()=>this.dataProvider.getTreeItem(a)).then(t=>this.createHandle(a,t,h,!0)).then(t=>this.getChildren(h?h.item.handle:void 0).then(()=>{const r=this.getExtensionElement(t);if(r){const s=this.nodes.get(r);if(s)return Promise.resolve(s)}throw new Error(`Cannot resolve tree item for element ${t}`)}))}getChildrenNodes(a){if(a){let h;if(typeof a=="string"){const p=this.getExtensionElement(a);h=p?this.nodes.get(p):void 0}else h=a;return h&&h.children||null}return this.roots}async fetchChildrenNodes(a){this.clearChildren(a);const h=new d.CancellationTokenSource(this._refreshCancellationSource.token);try{const p=a?this.nodes.get(a):void 0,t=await this.dataProvider.getChildren(a);if(h.token.isCancellationRequested)return[];const r=await Promise.all((0,I.coalesce)(t||[]).map(async s=>{const i=await this.dataProvider.getTreeItem(s);return i&&!h.token.isCancellationRequested?this.createAndRegisterTreeNode(s,i,p):null}));return h.token.isCancellationRequested?[]:(0,I.coalesce)(r)}finally{h.dispose()}}refresh(a){if(a.some(p=>!p))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new d.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const p=this.getHandlesToRefresh(a);if(p.length)return this.refreshHandles(p)}return Promise.resolve(void 0)}getHandlesToRefresh(a){const h=new Set,p=a.map(r=>this.nodes.get(r));for(const r of p)if(r&&!h.has(r.item.handle)){let s=r;for(;s&&s.parent&&p.findIndex(i=>s&&s.parent&&i&&i.item.handle===s.parent.item.handle)===-1;){const i=this.elements.get(s.parent.item.handle);s=i?this.nodes.get(i):void 0}s&&!s.parent&&h.add(r.item.handle)}const t=[];return h.forEach(r=>{const s=this.elements.get(r);if(s){const i=this.nodes.get(s);i&&(!i.parent||!h.has(i.parent.item.handle))&&t.push(r)}}),t}refreshHandles(a){const h={};return Promise.all(a.map(p=>this.refreshNode(p).then(t=>{t&&(h[p]=t.item)}))).then(()=>Object.keys(h).length?this.proxy.$refresh(this.viewId,h):void 0)}refreshNode(a){const h=this.getExtensionElement(a);if(h){const p=this.nodes.get(h);if(p)return this.clearChildren(h),(0,b.asPromise)(()=>this.dataProvider.getTreeItem(h)).then(t=>{if(t){const r=this.createTreeNode(h,t,p.parent);return this.updateNodeCache(h,r,p,p.parent),p.dispose(),r}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(a,h,p){const t=this.createTreeNode(a,h,p);if(h.id&&this.elements.has(t.item.handle))throw new Error((0,g.localize)(7,null,h.id));return this.addNodeToCache(a,t),this.addNodeToParentCache(t,p),t}getTooltip(a){return k.MarkdownString.isMarkdownString(a)?l.MarkdownString.from(a):a}getCommand(a,h){return h?this.commands.toInternal(h,a):void 0}createTreeNode(a,h,p){const t=new C.DisposableStore,r=this.createHandle(a,h,p),s=this.getLightIconPath(h);return{item:{handle:r,parentHandle:p?p.item.handle:void 0,label:m(h.label,this.extension),description:h.description,resourceUri:h.resourceUri,tooltip:this.getTooltip(h.tooltip),command:this.getCommand(t,h.command),contextValue:h.contextValue,icon:s,iconDark:this.getDarkIconPath(h)||s,themeIcon:this.getThemeIcon(h),collapsibleState:(0,n.isUndefinedOrNull)(h.collapsibleState)?k.TreeItemCollapsibleState.None:h.collapsibleState,accessibilityInformation:h.accessibilityInformation},extensionItem:h,parent:p,children:void 0,disposableStore:t,dispose(){t.dispose()}}}getThemeIcon(a){return a.iconPath instanceof k.ThemeIcon?a.iconPath:void 0}createHandle(a,{id:h,label:p,resourceUri:t},r,s){if(h)return`${w.ID_HANDLE_PREFIX}/${h}`;const i=m(p,this.extension),u=r?r.item.handle:w.LABEL_HANDLE_PREFIX;let f=i?i.label:t?(0,F.basename)(t):"";f=f.indexOf("/")!==-1?f.replace("/","//"):f;const v=this.nodes.has(a)?this.nodes.get(a).item.handle:void 0,D=this.getChildrenNodes(r)||[];let T,o=0;do{if(T=`${u}/${o}:${f}`,s||!this.elements.has(T)||v===T)break;o++}while(o<=D.length);return T}getLightIconPath(a){if(a.iconPath&&!(a.iconPath instanceof k.ThemeIcon))return typeof a.iconPath=="string"||S.URI.isUri(a.iconPath)?this.getIconPath(a.iconPath):this.getIconPath(a.iconPath.light)}getDarkIconPath(a){if(a.iconPath&&!(a.iconPath instanceof k.ThemeIcon)&&a.iconPath.dark)return this.getIconPath(a.iconPath.dark)}getIconPath(a){return S.URI.isUri(a)?a:S.URI.file(a)}addNodeToCache(a,h){this.elements.set(h.item.handle,a),this.nodes.set(a,h)}updateNodeCache(a,h,p,t){this.elements.delete(h.item.handle),this.nodes.delete(a),h.item.handle!==p.item.handle&&this.elements.delete(p.item.handle),this.addNodeToCache(a,h);const r=this.getChildrenNodes(t)||[],s=r.filter(i=>i.item.handle===p.item.handle)[0];s&&r.splice(r.indexOf(s),1,h)}addNodeToParentCache(a,h){h?(h.children||(h.children=[]),h.children.push(a)):(this.roots||(this.roots=[]),this.roots.push(a))}clearChildren(a){if(a){const h=this.nodes.get(a);if(h){if(h.children)for(const p of h.children){const t=this.elements.get(p.item.handle);t&&this.clear(t)}h.children=void 0}}else this.clearAll()}clear(a){const h=this.nodes.get(a);if(h){if(h.children)for(const p of h.children){const t=this.elements.get(p.item.handle);t&&this.clear(t)}this.nodes.delete(a),this.elements.delete(h.item.handle),h.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(a=>a.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}w.LABEL_HANDLE_PREFIX="0",w.ID_HANDLE_PREFIX="1"}),define(be[183],Ee([0,1,16,3,6,10,67,9,99,72]),function(ee,e,g,F,S,_,C,y,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class n extends S.Disposable{constructor(l){super();this.controllerId=l,this.debounceSendDiff=this._register(new g.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new F.Emitter),this.root=new C.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(l){this._resolveHandler=l;for(const d of this.tree.values())this.updateExpandability(d)}collectDiff(){const l=this.diff;return this.diff=[],l}pushDiff(l){const d=this.diff[this.diff.length-1];if(d&&l[0]===1){if(d[0]===1&&d[1].extId===l[1].extId){(0,b.applyTestItemUpdate)(d[1],l[1]);return}if(d[0]===0&&d[1].item.extId===l[1].extId){(0,b.applyTestItemUpdate)(d[1],l[1]);return}}this.diff.push(l),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(l,d){const c=this.tree.get(l);if(!!c){if((c.expandLevels===void 0||d>c.expandLevels)&&(c.expandLevels=d),c.expand===1){const m=this.resolveChildren(c);return m.isOpen()?this.expandChildren(c,d-1):m.wait().then(()=>this.expandChildren(c,d-1))}else if(c.expand===3)return c.resolveBarrier?.isOpen()===!1?c.resolveBarrier.wait().then(()=>this.expandChildren(c,d-1)):this.expandChildren(c,d-1)}}dispose(){for(const l of this.tree.values())(0,C.getPrivateApiFor)(l.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(l,d){switch(d.op){case 2:this.pushDiff([4,l.fullId.toString()]);break;case 1:this.removeItem(k.TestId.joinToString(l.fullId,d.id));break;case 0:this.upsertItem(d.item,l);break;case 4:for(const w of d.ops)this.onTestItemEvent(l,w);break;case 3:const{key:c,value:m}=d,E=l.fullId.toString();switch(c){case"canResolveChildren":this.updateExpandability(l);break;case"range":this.pushDiff([1,{extId:E,item:{range:y.Range.from(m)}}]);break;case"error":this.pushDiff([1,{extId:E,item:{error:y.MarkdownString.fromStrict(m)||null}}]);break;default:this.pushDiff([1,{extId:E,item:{[c]:m??null}}]);break}break;default:(0,_.assertNever)(d)}}upsertItem(l,d){if(!(l instanceof C.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${l.id} did not`);const c=k.TestId.fromExtHostTestItem(l,this.root.id,d?.actual),m=(0,C.getPrivateApiFor)(l);m.parent&&m.parent!==d?.actual&&m.parent.children.delete(l.id);let E=this.tree.get(c.toString());if(!E){E={fullId:c,actual:l,parent:d?c.parentId:null,expandLevels:d?.expandLevels?d.expandLevels-1:void 0,expand:0},this.tree.set(E.fullId.toString(),E),this.setItemParent(l,d),this.pushDiff([0,{parent:E.parent&&E.parent.toString(),controllerId:this.controllerId,expand:E.expand,item:y.TestItem.from(l)}]),this.connectItemAndChildren(l,E,d);return}if(E.actual===l){this.connectItem(l,E,d);return}const w=E.actual.children,P=E.actual,a=(0,C.diffTestItems)(P,l);(0,C.getPrivateApiFor)(P).listener=void 0,E.actual=l,E.expand=0;for(const[h,p]of a)this.onTestItemEvent(E,{op:3,key:h,value:p});this.connectItemAndChildren(l,E,d);for(const h of w)l.children.get(h.id)||this.removeItem(k.TestId.joinToString(c,h.id))}setItemParent(l,d){(0,C.getPrivateApiFor)(l).parent=d&&d.actual!==this.root?d.actual:void 0}connectItem(l,d,c){this.setItemParent(l,c);const m=(0,C.getPrivateApiFor)(l);m.parent=c?.actual,m.listener=E=>this.onTestItemEvent(d,E),this.updateExpandability(d)}connectItemAndChildren(l,d,c){this.connectItem(l,d,c);for(const m of l.children)this.upsertItem(m,d)}updateExpandability(l){let d;this._resolveHandler?l.resolveBarrier?d=l.resolveBarrier.isOpen()?3:2:d=l.actual.canResolveChildren?1:0:d=0,d!==l.expand&&(l.expand=d,this.pushDiff([1,{extId:l.fullId.toString(),expand:d}]),d===1&&l.expandLevels!==void 0&&this.resolveChildren(l))}expandChildren(l,d){if(d<0)return;const c=[];for(const m of l.actual.children){const E=this.expand(k.TestId.joinToString(l.fullId,m.id),d);(0,g.isThenable)(E)&&c.push(E)}if(c.length)return Promise.all(c).then(()=>{})}resolveChildren(l){if(l.resolveBarrier)return l.resolveBarrier;if(!this._resolveHandler){const m=new g.Barrier;return m.open(),m}l.expand=2,this.pushExpandStateUpdate(l);const d=l.resolveBarrier=new g.Barrier;let c;try{c=this._resolveHandler(l.actual===this.root?void 0:l.actual)}catch(m){l.actual.error=m.stack||m.message}return(0,g.isThenable)(c)?c.catch(m=>l.actual.error=m.stack||m.message).then(()=>{d.open(),this.updateExpandability(l)}):(d.open(),this.updateExpandability(l)),l.resolveBarrier}pushExpandStateUpdate(l){this.pushDiff([1,{extId:l.fullId.toString(),expand:l.expand}])}removeItem(l){const d=this.tree.get(l);if(!d)throw new Error("attempting to remove non-existent child");this.pushDiff([2,l]);const c=[d];for(;c.length;){const m=c.pop();if(!!m){(0,C.getPrivateApiFor)(m.actual).listener=void 0,this.tree.delete(m.fullId.toString());for(const E of m.actual.children)c.push(this.tree.get(k.TestId.joinToString(m.fullId,E.id)))}}}flushDiff(){const l=this.collectDiff();l.length&&this.diffOpEmitter.fire(l)}}e.SingleUseTestCollection=n}),define(be[184],Ee([0,1,4,151]),function(ee,e,g,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,g.refineServiceDecorator)(F.IEnvironmentService)}),define(be[185],Ee([0,1,26,3,14]),function(ee,e,g,F,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class _{constructor(n){this.removedDueToLooping=n}}e.DeltaExtensionsResult=_;class C{constructor(n){this._onDidChange=new F.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=n,this._initialize()}_initialize(){this._extensionDescriptions.sort(b),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const n of this._extensionDescriptions){if(this._extensionsMap.has(g.ExtensionIdentifier.toKey(n.identifier))){console.error("Extension `"+n.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(g.ExtensionIdentifier.toKey(n.identifier),n),this._extensionsArr.push(n),Array.isArray(n.activationEvents))for(let I of n.activationEvents)I==="onUri"&&(I=`onUri:${g.ExtensionIdentifier.toKey(n.identifier)}`),this._activationMap.has(I)||this._activationMap.set(I,[]),this._activationMap.get(I).push(n)}}keepOnly(n){const I=new Set;n.forEach(l=>I.add(g.ExtensionIdentifier.toKey(l))),this._extensionDescriptions=this._extensionDescriptions.filter(l=>I.has(g.ExtensionIdentifier.toKey(l.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(n,I){n.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(n));const l=C._findLoopingExtensions(this._extensionDescriptions);if(I=I.concat(l.map(d=>d.identifier)),I.length>0){const d=new Set;I.forEach(c=>d.add(g.ExtensionIdentifier.toKey(c))),this._extensionDescriptions=this._extensionDescriptions.filter(c=>!d.has(g.ExtensionIdentifier.toKey(c.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new _(l)}static _findLoopingExtensions(n){const I=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(E){this._nodesSet.has(E)||(this._nodesSet.add(E),this._nodesArr.push(E))}addArc(E,w){this.addNode(E),this.addNode(w),this._arcs.has(E)?this._arcs.get(E).push(w):this._arcs.set(E,[w])}getArcs(E){return this._arcs.has(E)?this._arcs.get(E):[]}hasOnlyGoodArcs(E,w){const P=I.getArcs(E);for(let a=0;a<P.length;a++)if(!w.has(P[a]))return!1;return!0}getNodes(){return this._nodesArr}};let l=new Map;for(let E of n){const w=g.ExtensionIdentifier.toKey(E.identifier);if(l.set(w,E),E.extensionDependencies)for(let P of E.extensionDependencies){const a=g.ExtensionIdentifier.toKey(P);I.addArc(w,a)}}let d=new Set;I.getNodes().filter(E=>I.getArcs(E).length===0).forEach(E=>d.add(E));let c=I.getNodes().filter(E=>!d.has(E)),m;do{m=!1;for(let E=0;E<c.length;E++){const w=c[E];I.hasOnlyGoodArcs(w,d)&&(c.splice(E,1),E--,d.add(w),m=!0)}}while(m);return c.map(E=>l.get(E))}containsActivationEvent(n){return this._activationMap.has(n)}containsExtension(n){return this._extensionsMap.has(g.ExtensionIdentifier.toKey(n))}getExtensionDescriptionsForActivationEvent(n){const I=this._activationMap.get(n);return I?I.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(n){const I=this._extensionsMap.get(g.ExtensionIdentifier.toKey(n));return I||void 0}}e.ExtensionDescriptionRegistry=C;var y;(function(k){k[k.Builtin=0]="Builtin",k[k.User=1]="User",k[k.Dev=2]="Dev"})(y||(y={}));function b(k,n){const I=k.isBuiltin?0:k.isUnderDevelopment?2:1,l=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(I!==l)return I-l;const d=S.posix.basename(k.extensionLocation.path),c=S.posix.basename(n.extensionLocation.path);return d<c?-1:d>c?1:0}}),define(be[186],Ee([0,1,24]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var F;(function(y){y[y.VersionMismatch=55]="VersionMismatch",y[y.UnexpectedError=81]="UnexpectedError"})(F=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var S;(function(y){y[y.Initialized=0]="Initialized",y[y.Ready=1]="Ready",y[y.Terminate=2]="Terminate"})(S=e.MessageType||(e.MessageType={}));function _(y){const b=g.VSBuffer.alloc(1);switch(y){case 0:b.writeUInt8(1,0);break;case 1:b.writeUInt8(2,0);break;case 2:b.writeUInt8(3,0);break}return b}e.createMessageOfType=_;function C(y,b){if(y.byteLength!==1)return!1;switch(y.readUInt8(0)){case 1:return b===0;case 2:return b===1;case 3:return b===2;default:return!1}}e.isMessageOfType=C}),define(be[30],Ee([0,1,3,2,4,26,152]),function(ee,e,g,F,S,_,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new _.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:F.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,S.createDecorator)("extensionService");class y{constructor(P){this.dependency=P}}e.MissingExtensionDependency=y;var b;(function(w){w[w.LocalProcess=0]="LocalProcess",w[w.LocalWebWorker=1]="LocalWebWorker",w[w.Remote=2]="Remote"})(b=e.ExtensionHostKind||(e.ExtensionHostKind={}));class k{constructor(P,a,h,p){this.codeLoadingTime=P,this.activateCallTime=a,this.activateResolvedTime=h,this.activationReason=p}}e.ActivationTimes=k;class n{constructor(P,a){this.description=P,this.value=a}}e.ExtensionPointContribution=n,e.ExtensionHostLogFileName="exthost";var I;(function(w){w[w.Normal=0]="Normal",w[w.Immediate=1]="Immediate"})(I=e.ActivationKind||(e.ActivationKind={}));function l(w){w.enableProposedApi||d(w)}e.checkProposedApiEnabled=l;function d(w){throw new Error(`[${w.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${w.identifier.value}`)}e.throwProposedApiError=d;function c(w){return{type:w.isBuiltin?0:1,isBuiltin:w.isBuiltin||w.isUserBuiltin,identifier:{id:(0,C.getGalleryExtensionId)(w.publisher,w.name),uuid:w.uuid},manifest:w,location:w.extensionLocation}}e.toExtension=c;function m(w,P){return{identifier:new _.ExtensionIdentifier(w.identifier.id),isBuiltin:w.type===0,isUserBuiltin:w.type===1&&w.isBuiltin,isUnderDevelopment:!!P,extensionLocation:w.location,...w.manifest,uuid:w.identifier.uuid}}e.toExtensionDescription=m;class E{constructor(){this.onDidRegisterExtensions=g.Event.None,this.onDidChangeExtensionsStatus=g.Event.None,this.onDidChangeExtensions=g.Event.None,this.onWillActivateByEvent=g.Event.None,this.onDidChangeResponsiveChange=g.Event.None}activateByEvent(P){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(P){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(P){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(P){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(P,a){return Promise.resolve()}_onWillActivateExtension(P){}_onDidActivateExtension(P,a,h,p,t){}_onDidActivateExtensionError(P,a){}_onExtensionRuntimeError(P,a){}_onExtensionHostExit(P){}}e.NullExtensionService=E}),define(be[187],Ee([0,1,26,30,15]),function(ee,e,g,F,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const _=Promise.resolve(void 0);class C{constructor(c,m,E,w){this.startup=c,this.codeLoadingTime=m,this.activateCallTime=E,this.activateResolvedTime=w}}e.ExtensionActivationTimes=C,C.NONE=new C(!1,-1,-1,-1);class y{constructor(c){this._startup=c,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(c,m){return c===-1||m===-1?-1:m-c}build(){return new C(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=y;class b{constructor(c,m,E,w,P,a){this.activationFailed=c,this.activationFailedError=m,this.activationTimes=E,this.module=w,this.exports=P,this.subscriptions=a}}e.ActivatedExtension=b;class k extends b{constructor(c){super(!1,null,c,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=k;class n extends b{constructor(){super(!1,null,C.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=n;class I extends b{constructor(c){super(!0,c,C.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=I;let l=class{constructor(c,m,E,w,P){this._logService=P,this._registry=c,this._resolvedExtensionsSet=new Set,m.forEach(a=>this._resolvedExtensionsSet.add(g.ExtensionIdentifier.toKey(a))),this._hostExtensionsMap=new Map,E.forEach(a=>this._hostExtensionsMap.set(g.ExtensionIdentifier.toKey(a),a)),this._host=w,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(c){const m=g.ExtensionIdentifier.toKey(c);return this._activatedExtensions.has(m)}getActivatedExtension(c){const m=g.ExtensionIdentifier.toKey(c),E=this._activatedExtensions.get(m);if(!E)throw new Error("Extension `"+c.value+"` is not known or not activated");return E}activateByEvent(c,m){if(this._alreadyActivatedEvents[c])return _;const E=this._registry.getExtensionDescriptionsForActivationEvent(c);return this._activateExtensions(E.map(w=>({id:w.identifier,reason:{startup:m,extensionId:w.identifier,activationEvent:c}}))).then(()=>{this._alreadyActivatedEvents[c]=!0})}activateById(c,m){const E=this._registry.getExtensionDescription(c);if(!E)throw new Error("Extension `"+c+"` is not known");return this._activateExtensions([{id:E.identifier,reason:m}])}_handleActivateRequest(c,m,E){if(this._hostExtensionsMap.has(g.ExtensionIdentifier.toKey(c.id))){m[g.ExtensionIdentifier.toKey(c.id)]=c;return}const w=this._registry.getExtensionDescription(c.id);if(!w){const h=new Error(`Cannot activate unknown extension '${c.id.value}'`);this._host.onExtensionActivationError(c.id,h,new F.MissingExtensionDependency(c.id.value)),this._activatedExtensions.set(g.ExtensionIdentifier.toKey(c.id),new I(h));return}const P=typeof w.extensionDependencies=="undefined"?[]:w.extensionDependencies;let a=!0;for(let h=0,p=P.length;h<p;h++){const t=P[h];if(this._resolvedExtensionsSet.has(g.ExtensionIdentifier.toKey(t)))continue;const r=this._activatedExtensions.get(g.ExtensionIdentifier.toKey(t));if(r&&!r.activationFailed)continue;if(r&&r.activationFailed){const f=w.displayName||w.identifier.value,v=this._registry.getExtensionDescription(t),D=v&&v.displayName||t,T=new Error(`Cannot activate the '${f}' extension because its dependency '${D}' failed to activate`);T.detail=r.activationFailedError,this._host.onExtensionActivationError(w.identifier,T,null),this._activatedExtensions.set(g.ExtensionIdentifier.toKey(w.identifier),new I(T));return}if(this._hostExtensionsMap.has(g.ExtensionIdentifier.toKey(t))){a=!1,m[g.ExtensionIdentifier.toKey(t)]={id:this._hostExtensionsMap.get(g.ExtensionIdentifier.toKey(t)),reason:c.reason};continue}const s=this._registry.getExtensionDescription(t);if(s){a=!1,m[g.ExtensionIdentifier.toKey(t)]={id:s.identifier,reason:c.reason};continue}const i=w.displayName||w.identifier.value,u=new Error(`Cannot activate the '${i}' extension because it depends on unknown extension '${t}'`);this._host.onExtensionActivationError(w.identifier,u,new F.MissingExtensionDependency(t)),this._activatedExtensions.set(g.ExtensionIdentifier.toKey(w.identifier),new I(u));return}a?m[g.ExtensionIdentifier.toKey(w.identifier)]=c:E.push(c)}_activateExtensions(c){if(c.length===0||(c=c.filter(P=>!this._activatedExtensions.has(g.ExtensionIdentifier.toKey(P.id))),c.length===0))return Promise.resolve(void 0);const m=Object.create(null),E=[];for(let P=0,a=c.length;P<a;P++)this._handleActivateRequest(c[P],m,E);for(let P=0,a=E.length;P<a;P++){const h=g.ExtensionIdentifier.toKey(E[P].id);m[h]&&delete m[h]}const w=Object.keys(m).map(P=>m[P]);return E.length===0?Promise.all(w.map(P=>this._activateExtension(P.id,P.reason))).then(P=>{}):this._activateExtensions(w).then(P=>this._activateExtensions(E))}_activateExtension(c,m){const E=g.ExtensionIdentifier.toKey(c);if(this._activatedExtensions.has(E))return Promise.resolve(void 0);const w=this._activatingExtensions.get(E);if(w)return w;const P=this._host.actualActivateExtension(c,m).then(void 0,a=>{const h=new Error;return a&&a.name&&(h.name=a.name),a&&a.message?h.message=`Activating extension '${c.value}' failed: ${a.message}.`:h.message=`Activating extension '${c.value}' failed: ${a}.`,a&&a.stack&&(h.stack=a.stack),this._host.onExtensionActivationError(c,h,null),this._logService.error(`Activating extension ${c.value} failed due to an error:`),this._logService.error(a),new I(a)}).then(a=>{this._activatedExtensions.set(E,a),this._activatingExtensions.delete(E)});return this._activatingExtensions.set(E,P),P}};l=ze([qe(4,S.ILogService)],l),e.ExtensionsActivator=l}),define(be[188],Ee([0,1,12]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class F{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((_,C)=>{this._actualOk=_,this._actualErr=C,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(_){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=_,this._actual&&this._actualOk(_))}resolveErr(_){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=_,this._actual?this._actualErr(_):(0,g.onUnexpectedError)(_))}then(_,C){return this._ensureActual().then(_,C)}catch(_){return this._ensureActual().then(void 0,_)}finally(_){return this._ensureActual().finally(_)}}e.LazyPromise=F}),define(be[103],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class g{constructor(b,k){this._proxyIdentifierBrand=void 0,this.isMain=b,this.sid=k,this.nid=++g.count}}e.ProxyIdentifier=g,g.count=0;const F=[];function S(y){const b=new g(!0,y);return F[b.nid]=b,b}e.createMainContextProxyIdentifier=S;function _(y){const b=new g(!1,y);return F[b.nid]=b,b}e.createExtHostContextProxyIdentifier=_;function C(y){return F[y].sid}e.getStringIdentifierForProxy=C}),define(be[5],Ee([0,1,56,2,103]),function(ee,e,g,F,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var _;(function(a){a[a.Desktop=1]="Desktop",a[a.Web=2]="Web"})(_=e.UIKind||(e.UIKind={}));var C;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(C=e.TextEditorRevealType||(e.TextEditorRevealType={}));var y;(function(a){a[a.Editable=0]="Editable",a[a.SupportsHotExit=1]="SupportsHotExit"})(y=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var b;(function(a){a[a.Int8Array=1]="Int8Array",a[a.Uint8Array=2]="Uint8Array",a[a.Uint8ClampedArray=3]="Uint8ClampedArray",a[a.Int16Array=4]="Int16Array",a[a.Uint16Array=5]="Uint16Array",a[a.Int32Array=6]="Int32Array",a[a.Uint32Array=7]="Uint32Array",a[a.Float32Array=8]="Float32Array",a[a.Float64Array=9]="Float64Array",a[a.BigInt64Array=10]="BigInt64Array",a[a.BigUint64Array=11]="BigUint64Array"})(b=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var k;(function(a){a[a.Text=1]="Text",a[a.Error=2]="Error",a[a.Rich=3]="Rich"})(k=e.CellOutputKind||(e.CellOutputKind={}));var n;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(n=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var I;(function(a){a[a.None=0]="None",a[a.Process=1]="Process",a[a.Output=2]="Output"})(I=e.CandidatePortSource||(e.CandidatePortSource={}));var l;(function(a){a.name="$ident";function h(t,r){return Object.defineProperty(t,a.name,{value:r,enumerable:!0}),t}a.mixin=h;function p(t){return t[a.name]}a.of=p})(l=e.ObjectIdentifier||(e.ObjectIdentifier={}));class d{static mixin(h){return h._id=d._n++,h}}e.IdObject=d,d._n=0;var c;(function(a){a.label="a",a.kind="b",a.detail="c",a.documentation="d",a.sortText="e",a.filterText="f",a.preselect="g",a.insertText="h",a.insertTextRules="i",a.range="j",a.commitCharacters="k",a.additionalTextEdits="l",a.command="m",a.kindModifier="n"})(c=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var m;(function(a){a.defaultRanges="a",a.completions="b",a.isIncomplete="c",a.duration="d"})(m=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var E;(function(a){a[a.File=1]="File",a[a.Text=2]="Text",a[a.Cell=3]="Cell"})(E=e.WorkspaceEditType||(e.WorkspaceEditType={}));function w(a){if(a&&a.edits)for(const h of a.edits)typeof h.resource=="object"?h.resource=F.URI.revive(h.resource):(h.newUri=F.URI.revive(h.newUri),h.oldUri=F.URI.revive(h.oldUri)),h.metadata&&h.metadata.iconPath&&(h.metadata=(0,g.revive)(h.metadata));return a}e.reviveWorkspaceEditDto=w;var P;(function(a){a[a.Workspace=0]="Workspace",a[a.TextDocument=1]="TextDocument"})(P=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,S.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,S.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,S.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,S.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,S.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,S.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,S.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,S.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,S.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,S.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,S.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,S.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,S.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,S.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,S.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,S.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,S.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,S.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,S.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,S.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,S.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,S.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,S.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,S.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,S.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,S.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,S.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,S.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,S.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,S.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,S.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,S.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,S.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,S.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,S.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,S.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,S.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,S.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,S.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,S.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,S.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,S.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,S.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,S.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,S.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,S.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,S.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,S.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,S.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,S.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,S.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,S.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,S.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,S.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,S.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,S.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,S.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,S.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,S.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,S.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,S.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,S.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,S.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,S.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,S.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,S.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,S.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,S.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,S.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,S.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,S.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,S.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,S.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,S.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,S.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,S.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,S.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,S.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,S.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,S.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,S.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,S.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,S.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,S.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,S.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,S.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,S.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,S.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,S.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,S.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,S.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,S.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,S.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,S.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,S.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,S.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,S.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,S.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,S.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,S.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,S.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,S.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,S.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,S.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,S.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,S.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(be[73],Ee([0,1,5,3,4]),function(ee,e,g,F,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class _{constructor(y){this._onDidChangePassword=new F.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=y.getProxy(g.MainContext.MainThreadSecretState)}async $onDidChangePassword(y){this._onDidChangePassword.fire(y)}get(y,b){return this._proxy.$getPassword(y,b)}store(y,b,k){return this._proxy.$setPassword(y,b,k)}delete(y,b){return this._proxy.$deletePassword(y,b)}}e.ExtHostSecretState=_,e.IExtHostSecretState=(0,S.createDecorator)("IExtHostSecretState")}),define(be[74],Ee([0,1,4,15,5,13]),function(ee,e,g,F,S,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,g.createDecorator)("IExtHostApiDeprecationService");let C=class{constructor(b,k){this._extHostLogService=k,this._reportedUsages=new Set,this._telemetryShape=b.getProxy(S.MainContext.MainThreadTelemetry)}report(b,k,n){const I=this.getUsageKey(b,k);this._reportedUsages.has(I)||(this._reportedUsages.add(I),k.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${b}' is deprecated. ${n}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:k.identifier.value,apiId:b}))}getUsageKey(b,k){return`${b}-${k.identifier.value}`}};C=ze([qe(0,_.IExtHostRpcService),qe(1,F.ILogService)],C),e.ExtHostApiDeprecationService=C,e.NullApiDeprecationService=Object.freeze(new class{report(y,b,k){}})}),define(be[189],Ee([0,1,3,5,7,26]),function(ee,e,g,F,S,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class C{constructor(b){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new g.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=b.getProxy(F.MainContext.MainThreadAuthentication)}$setProviders(b){return this._providers=b,Promise.resolve()}async getSession(b,k,n,I={}){const l=_.ExtensionIdentifier.toKey(b.identifier),d=this._inFlightRequests.get(l)||[],c=[...n].sort().join(" ");let m=d.find(E=>E.scopes===c);if(m)return m.result;{const E=this._getSession(b,l,k,n,I);m={scopes:c,result:E},d.push(m),this._inFlightRequests.set(l,d);try{await E}finally{const w=d.findIndex(P=>P.scopes===c);w>-1&&(d.splice(w),this._inFlightRequests.set(l,d))}return E}}async _getSession(b,k,n,I,l={}){await this._proxy.$ensureProvider(n);const d=b.displayName||b.name;return this._proxy.$getSession(n,I,k,d,l)}async removeSession(b,k){const n=this._authenticationProviders.get(b);return n?n.provider.removeSession(k):this._proxy.$removeSession(b,k)}registerAuthenticationProvider(b,k,n,I){if(this._authenticationProviders.get(b))throw new Error(`An authentication provider with id '${b}' is already registered.`);this._authenticationProviders.set(b,{label:k,provider:n,options:I??{supportsMultipleAccounts:!1}}),this._providers.find(d=>d.id===b)||this._providers.push({id:b,label:k});const l=n.onDidChangeSessions(d=>{this._proxy.$sendDidChangeSessions(b,{added:d.added??[],changed:d.changed??[],removed:d.removed??[]})});return this._proxy.$registerAuthenticationProvider(b,k,I?.supportsMultipleAccounts??!1),new S.Disposable(()=>{l.dispose(),this._authenticationProviders.delete(b);const d=this._providers.findIndex(c=>c.id===b);d>-1&&this._providers.splice(d),this._proxy.$unregisterAuthenticationProvider(b)})}$createSession(b,k){const n=this._authenticationProviders.get(b);if(n)return Promise.resolve(n.provider.createSession(k));throw new Error(`Unable to find authentication provider with handle: ${b}`)}$removeSession(b,k){const n=this._authenticationProviders.get(b);if(n)return Promise.resolve(n.provider.removeSession(k));throw new Error(`Unable to find authentication provider with handle: ${b}`)}$getSessions(b,k){const n=this._authenticationProviders.get(b);if(n)return Promise.resolve(n.provider.getSessions(k));throw new Error(`Unable to find authentication provider with handle: ${b}`)}$onDidChangeAuthenticationSessions(b,k){return this._onDidChangeSessions.fire({provider:{id:b,label:k}}),Promise.resolve()}}e.ExtHostAuthentication=C}),define(be[190],Ee([0,1,5,13,9]),function(ee,e,g,F,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let _=class{constructor(y,b){this._extHostDocumentsAndEditors=b,this._proxy=y.getProxy(g.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(y){const b=S.WorkspaceEdit.from(y,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(b)}};_=ze([qe(0,F.IExtHostRpcService)],_),e.ExtHostBulkEdits=_}),define(be[191],Ee([0,1,5]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class F{constructor(_){const C=_.getProxy(g.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return C.$readText()},writeText(y){return C.$writeText(y)}})}}e.ExtHostClipboard=F}),define(be[75],Ee([0,1,10,7,9,23,5,17,15,56,31,37,2,6,4,13]),function(ee,e,g,F,S,_,C,y,b,k,n,I,l,d,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let E=class{constructor(t,r){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(C.MainContext.MainThreadCommands),this._logService=r,this.converter=new w(this,s=>{const i=this._apiCommands.get(s);return i?.result===a.Void?i:void 0},r),this._argumentProcessors=[{processArgument(s){return(0,k.revive)(s)}},{processArgument(s){return(0,_.cloneAndChange)(s,function(i){if(n.Range.isIRange(i))return S.Range.to(i);if(I.Position.isIPosition(i))return S.Position.to(i);if(n.Range.isIRange(i.range)&&l.URI.isUri(i.uri))return S.location.to(i);if(!Array.isArray(i))return i})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const r=this.registerCommand(!1,t.id,async(...s)=>{const i=t.args.map((f,v)=>{if(!f.validate(s[v]))throw new Error(`Invalid argument '${f.name}' when running '${t.id}', received: ${s[v]}`);return f.convert(s[v])}),u=await this.executeCommand(t.internalId,...i);return t.result.convert(u,s,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new F.Disposable(()=>{r.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,r,s,i,u){if(this._logService.trace("ExtHostCommands#registerCommand",r),!r.trim().length)throw new Error("invalid id");if(this._commands.has(r))throw new Error(`command '${r}' already exists`);return this._commands.set(r,{callback:s,thisArg:i,description:u}),t&&this._proxy.$registerCommand(r),new F.Disposable(()=>{this._commands.delete(r)&&t&&this._proxy.$unregisterCommand(r)})}executeCommand(t,...r){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,r,!0)}async _doExecuteCommand(t,r,s){if(this._commands.has(t))return this._executeContributedCommand(t,r);{const i=(0,_.cloneAndChange)(r,function(u){if(u instanceof F.Position)return S.Position.from(u);if(u instanceof F.Range)return S.Range.from(u);if(u instanceof F.Location)return S.location.from(u);if(F.NotebookRange.isNotebookRange(u))return S.NotebookRange.from(u);if(!Array.isArray(u))return u});try{const u=await this._proxy.$executeCommand(t,i,s);return(0,k.revive)(u)}catch(u){if(u instanceof Error&&u.message==="$executeCommand:retry")return this._doExecuteCommand(t,r,!1);throw u}}}async _executeContributedCommand(t,r){const s=this._commands.get(t);if(!s)throw new Error("Unknown command");let{callback:i,thisArg:u,description:f}=s;if(f)for(let v=0;v<f.args.length;v++)try{(0,g.validateConstraint)(r[v],f.args[v].constraint)}catch(D){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${f.args[v].name}' - ${f.args[v].description}`)}try{return await i.apply(u,r)}catch(v){if(t===this.converter.delegatingCommandId){const D=this.converter.getActualCommand(...r);D&&(t=D.command)}throw this._logService.error(v,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...r){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(r=r.map(s=>this._argumentProcessors.reduce((i,u)=>u.processArgument(i),s)),this._executeContributedCommand(t,r)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(r=>(t&&(r=r.filter(s=>s[0]!=="_")),r))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[r,s]of this._commands){let{description:i}=s;i&&(t[r]=i)}return Promise.resolve(t)}};E=ze([qe(0,m.IExtHostRpcService),qe(1,b.ILogService)],E),e.ExtHostCommands=E,e.IExtHostCommands=(0,c.createDecorator)("IExtHostCommands");class w{constructor(t,r,s){this._commands=t,this._lookupApiCommand=r,this._logService=s,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,r){if(!t)return;const s={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return s;const i=this._lookupApiCommand(t.command);if(i)s.id=i.internalId,s.arguments=i.args.map((u,f)=>u.convert(t.arguments&&t.arguments[f]));else if((0,y.isNonEmptyArray)(t.arguments)){const u=++this._cachIdPool;this._cache.set(u,t),r.add((0,d.toDisposable)(()=>{this._cache.delete(u),this._logService.trace("CommandsConverter#DISPOSE",u)})),s.$ident=u,s.id=this.delegatingCommandId,s.arguments=[u],this._logService.trace("CommandsConverter#CREATE",t.command,u)}return s}fromInternal(t){const r=C.ObjectIdentifier.of(t);return typeof r=="number"?this._cache.get(r):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const r=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],r?r.command:"MISSING"),r?this._commands.executeCommand(r.command,...r.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=w;class P{constructor(t,r,s,i){this.name=t,this.description=r,this.validate=s,this.convert=i}optional(){return new P(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,r){return new P(t??this.name,r??this.description,this.validate,this.convert)}}e.ApiCommandArgument=P,P.Uri=new P("uri","Uri of a text document",p=>l.URI.isUri(p),p=>p),P.Position=new P("position","A position in a text document",p=>F.Position.isPosition(p),S.Position.from),P.Range=new P("range","A range in a text document",p=>F.Range.isRange(p),S.Range.from),P.Selection=new P("selection","A selection in a text document",p=>F.Selection.isSelection(p),S.Selection.from),P.Number=new P("number","",p=>typeof p=="number",p=>p),P.String=new P("string","",p=>typeof p=="string",p=>p),P.CallHierarchyItem=new P("item","A call hierarchy item",p=>p instanceof F.CallHierarchyItem,S.CallHierarchyItem.from),P.TypeHierarchyItem=new P("item","A type hierarchy item",p=>p instanceof F.TypeHierarchyItem,S.TypeHierarchyItem.from);class a{constructor(t,r){this.description=t,this.convert=r}}e.ApiCommandResult=a,a.Void=new a("no result",p=>p);class h{constructor(t,r,s,i,u){this.id=t,this.internalId=r,this.description=s,this.args=i,this.result=u}}e.ApiCommand=h}),define(be[192],Ee([0,1,9,7,60,75,17,89]),function(ee,e,g,F,S,_,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const b=[new _.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",n(g.DocumentHighlight.to))),new _.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(l,d)=>{if((0,C.isFalsyOrEmpty)(l))return;class c extends F.SymbolInformation{static to(E){const w=new c(E.name,g.SymbolKind.to(E.kind),E.containerName||"",new F.Location(d[0],g.Range.to(E.range)));return w.detail=E.detail,w.range=w.location.range,w.selectionRange=g.Range.to(E.selectionRange),w.children=E.children?E.children.map(c.to):[],w}}return l.map(c.to)})),new _.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[_.ApiCommandArgument.Uri,new _.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new _.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(g.TextEdit.to))),new _.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range,new _.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new _.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(g.TextEdit.to))),new _.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,new _.ApiCommandArgument("ch","Trigger character",l=>typeof l=="string",l=>l),new _.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new _.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(g.TextEdit.to))),new _.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new _.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new _.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new _.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new _.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location-instances.",n(g.location.to))),new _.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Hover-instances.",n(g.Hover.to))),new _.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[_.ApiCommandArgument.Uri,new _.ApiCommandArgument("position","A position in a text document",l=>Array.isArray(l)&&l.every(d=>F.Position.isPosition(d)),l=>l.map(g.Position.from))],new _.ApiCommandResult("A promise that resolves to an array of ranges.",l=>l.map(d=>{let c;for(const m of d.reverse())c=new F.SelectionRange(g.Range.to(m),c);return c}))),new _.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[_.ApiCommandArgument.String.with("query","Search string")],new _.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",l=>{const d=[];if(Array.isArray(l))for(let c of l)d.push(...c[1].map(g.WorkspaceSymbol.to));return d})),new _.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(g.CallHierarchyItem.to))),new _.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[_.ApiCommandArgument.CallHierarchyItem],new _.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(g.CallHierarchyIncomingCall.to))),new _.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[_.ApiCommandArgument.CallHierarchyItem],new _.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(g.CallHierarchyOutgoingCall.to))),new _.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,_.ApiCommandArgument.String.with("newName","The new symbol name")],new _.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",l=>{if(!!l){if(l.rejectReason)throw new Error(l.rejectReason);return g.WorkspaceEdit.to(l)}})),new _.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new _.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",l=>l.map(g.DocumentLink.to))),new _.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",l=>{if(!!l)return new F.SemanticTokensLegend(l.tokenTypes,l.tokenModifiers)})),new _.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const d=(0,y.decodeSemanticTokensDto)(l);if(d.type==="full")return new F.SemanticTokens(d.data,void 0)})),new _.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",l=>{if(!!l)return new F.SemanticTokensLegend(l.tokenTypes,l.tokenModifiers)})),new _.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range],new _.ApiCommandResult("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const d=(0,y.decodeSemanticTokensDto)(l);if(d.type==="full")return new F.SemanticTokens(d.data,void 0)})),new _.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,_.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),_.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new _.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(l,d,c)=>{if(!l)return new F.CompletionList([]);const m=l.suggestions.map(E=>g.CompletionItem.to(E,c));return new F.CompletionList(m,l.incomplete)})),new _.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,_.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new _.ApiCommandResult("A promise that resolves to SignatureHelp.",l=>{if(l)return g.SignatureHelp.to(l)})),new _.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new _.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(l,d,c)=>n(m=>new F.CodeLens(g.Range.to(m.range),m.command&&c.fromInternal(m.command)))(l))),new _.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[_.ApiCommandArgument.Uri,new _.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",l=>F.Range.isRange(l),l=>F.Selection.isSelection(l)?g.Selection.from(l):g.Range.from(l)),_.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),_.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new _.ApiCommandResult("A promise that resolves to an array of Command-instances.",(l,d,c)=>n(m=>{if(m._isSynthetic){if(!m.command)throw new Error("Synthetic code actions must have a command");return c.fromInternal(m.command)}else{const E=new F.CodeAction(m.title,m.kind?new F.CodeActionKind(m.kind):void 0);return m.edit&&(E.edit=g.WorkspaceEdit.to(m.edit)),m.command&&(E.command=c.fromInternal(m.command)),E.isPreferred=m.isPreferred,E}})(l))),new _.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",l=>l?l.map(d=>new F.ColorInformation(g.Range.to(d.range),g.Color.to(d.color))):[])),new _.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new _.ApiCommandArgument("color","The color to show and insert",l=>l instanceof F.Color,g.Color.from),new _.ApiCommandArgument("context","Context object with uri and range",l=>!0,l=>({uri:l.uri,range:g.Range.from(l.range)}))],new _.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",l=>l?l.map(g.ColorPresentation.to):[])),new _.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range],new _.ApiCommandResult("A promise that resolves to an array of Inlay objects",l=>l.map(g.InlayHint.to))),new _.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new _.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",n(l=>({viewType:l.viewType,displayName:l.displayName,options:{transientOutputs:l.options.transientOutputs,transientCellMetadata:l.options.transientCellMetadata,transientDocumentMetadata:l.options.transientDocumentMetadata},filenamePattern:l.filenamePattern.map(d=>g.NotebookExclusiveDocumentPattern.to(d))})))),new _.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range],new _.ApiCommandResult("A promise that resolves to an array of InlineValue objects",l=>l.map(g.InlineValue.to))),new _.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[_.ApiCommandArgument.Uri,new _.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[l,void 0]:[g.ViewColumn.from(l.viewColumn),g.TextEditorOpenOptions.from(l)])).optional(),_.ApiCommandArgument.String.with("label","").optional()],_.ApiCommandResult.Void),new _.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[_.ApiCommandArgument.Uri.with("resource","Resource to open"),_.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new _.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[l,void 0]:[g.ViewColumn.from(l.viewColumn),g.TextEditorOpenOptions.from(l)])).optional()],_.ApiCommandResult.Void),new _.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[_.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),_.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),_.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new _.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="object",l=>l&&[g.ViewColumn.from(l.viewColumn),g.TextEditorOpenOptions.from(l)]).optional()],_.ApiCommandResult.Void),new _.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A TypeHierarchyItem or undefined",l=>l.map(g.TypeHierarchyItem.to))),new _.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[_.ApiCommandArgument.TypeHierarchyItem],new _.ApiCommandResult("A TypeHierarchyItem or undefined",l=>l.map(g.TypeHierarchyItem.to))),new _.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[_.ApiCommandArgument.TypeHierarchyItem],new _.ApiCommandResult("A TypeHierarchyItem or undefined",l=>l.map(g.TypeHierarchyItem.to)))];class k{static register(d){b.forEach(d.registerApiCommand,d)}}e.ExtHostApiCommands=k;function n(l){return d=>{if(Array.isArray(d))return d.map(l)}}function I(l){if(!Array.isArray(l))return;const d=[];for(const c of l)S.isLocationLink(c)?d.push(g.DefinitionLink.to(c)):d.push(g.location.to(c));return d}}),define(be[193],Ee([0,1,16,51,3,6,2,60,26,9,7,5]),function(ee,e,g,F,S,_,C,y,b,k,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function l(d,c,m){const E=d.getProxy(I.MainContext.MainThreadComments);class w{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,c.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===6){const u=this._commentControllers.get(i.handle);return u||i}else if(i&&i.$mid===7){const u=this._commentControllers.get(i.commentControlHandle);if(!u)return i;const f=u.getCommentThread(i.commentThreadHandle);return f||i}else if(i&&i.$mid===8){const u=this._commentControllers.get(i.thread.commentControlHandle);if(!u)return i;const f=u.getCommentThread(i.thread.commentThreadHandle);return f?{thread:f,text:i.text}:i}else if(i&&i.$mid===9){const u=this._commentControllers.get(i.thread.commentControlHandle);if(!u)return i;const f=u.getCommentThread(i.thread.commentThreadHandle);if(!f)return i;let v=i.commentUniqueId,D=f.getCommentByUniqueId(v);return D||i}else if(i&&i.$mid===10){const u=this._commentControllers.get(i.thread.commentControlHandle);if(!u)return i;const f=u.getCommentThread(i.thread.commentThreadHandle);if(!f)return i;let v=i.text,D=i.commentUniqueId,T=f.getCommentByUniqueId(D);return T?(T.body=v,T):i}return i}})}createCommentController(i,u,f){const v=w.handlePool++,D=new a(i,v,u,f);this._commentControllers.set(D.handle,D);const T=this._commentControllersByExtension.get(b.ExtensionIdentifier.toKey(i.identifier))||[];return T.push(D),this._commentControllersByExtension.set(b.ExtensionIdentifier.toKey(i.identifier),T),D.value}$createCommentThreadTemplate(i,u,f){const v=this._commentControllers.get(i);!v||v.$createCommentThreadTemplate(u,f)}async $updateCommentThreadTemplate(i,u,f){const v=this._commentControllers.get(i);!v||v.$updateCommentThreadTemplate(u,f)}$deleteCommentThread(i,u){const f=this._commentControllers.get(i);f&&f.$deleteCommentThread(u)}$provideCommentingRanges(i,u,f){const v=this._commentControllers.get(i);if(!v||!v.commentingRangeProvider)return Promise.resolve(void 0);const D=m.getDocument(C.URI.revive(u));return(0,g.asPromise)(()=>v.commentingRangeProvider.provideCommentingRanges(D,f)).then(T=>T?T.map(o=>k.Range.from(o)):void 0)}$toggleReaction(i,u,f,v,D){const T=this._commentControllers.get(i);return!T||!T.reactionHandler?Promise.resolve(void 0):(0,g.asPromise)(()=>{const o=T.getCommentThread(u);if(o){const A=o.getCommentByUniqueId(v.uniqueIdInThread);if(T!==void 0&&A&&T.reactionHandler)return T.reactionHandler(A,t(D))}return Promise.resolve(void 0)})}dispose(){}}w.handlePool=0;class P{constructor(i,u,f,v,D,T,o){this._commentControllerHandle=u,this._id=f,this._uri=v,this._range=D,this._comments=T,this.handle=P._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new S.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new _.MutableDisposable,this._acceptInputDisposables.value=new _.DisposableStore,this._id===void 0&&(this._id=`${i}.${this.handle}`),E.$createCommentThread(u,this.handle,this._id,this._uri,k.Range.from(this._range),o),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=T,this._localDisposables.push({dispose:()=>{E.$deleteCommentThread(u,this.handle)}});const A=this;this.value={get uri(){return A.uri},get range(){return A.range},set range(L){A.range=L},get comments(){return A.comments},set comments(L){A.comments=L},get collapsibleState(){return A.collapsibleState},set collapsibleState(L){A.collapsibleState=L},get canReply(){return A.canReply},set canReply(L){A.canReply=L},get contextValue(){return A.contextValue},set contextValue(L){A.contextValue=L},get label(){return A.label},set label(L){A.label=L},dispose:()=>{A.dispose()}}}set threadId(i){this._id=i}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(i){i.isEqual(this._range)||(this._range=i,this.modifications.range=i,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(i){this._canReply!==i&&(this._canReply=i,this.modifications.canReply=i,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(i){this._label=i,this.modifications.label=i,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(i){this._contextValue=i,this.modifications.contextValue=i,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(i){this._comments=i,this.modifications.comments=i,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(i){this._collapseState=i,this.modifications.collapsibleState=i,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new _.DisposableStore);const i=f=>Object.prototype.hasOwnProperty.call(this.modifications,f),u={};i("range")&&(u.range=k.Range.from(this._range)),i("label")&&(u.label=this.label),i("contextValue")&&(u.contextValue=this.contextValue),i("comments")&&(u.comments=this._comments.map(f=>h(this,f,this._commentsMap))),i("collapsibleState")&&(u.collapseState=r(this._collapseState)),i("canReply")&&(u.canReply=this.canReply),this.modifications={},E.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,u)}getCommentByUniqueId(i){for(let u of this._commentsMap){let f=u[0],v=u[1];if(i===v)return f}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(i=>i.dispose())}}P._handlePool=0,ze([(0,F.debounce)(100)],P.prototype,"eventuallyUpdateCommentThread",null);class a{constructor(i,u,f,v){this._extension=i,this._handle=u,this._id=f,this._label=v,this._threads=new Map,E.$registerCommentController(this.handle,f,v);const D=this;this.value=Object.freeze({id:D.id,label:D.label,get options(){return D.options},set options(T){D.options=T},get commentingRangeProvider(){return D.commentingRangeProvider},set commentingRangeProvider(T){D.commentingRangeProvider=T},get reactionHandler(){return D.reactionHandler},set reactionHandler(T){D.reactionHandler=T},createCommentThread(T,o,A){return D.createCommentThread(T,o,A).value},dispose:()=>{D.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{E.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(i){this._reactionHandler=i,E.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!i})}get options(){return this._options}set options(i){this._options=i,E.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(i,u,f,v){if(typeof i=="string"){const D=new P(this.id,this.handle,i,u,f,v,this._extension.identifier);return this._threads.set(D.handle,D),D}else{const D=new P(this.id,this.handle,void 0,i,u,f,this._extension.identifier);return this._threads.set(D.handle,D),D}}$createCommentThreadTemplate(i,u){const f=new P(this.id,this.handle,void 0,C.URI.revive(i),k.Range.to(u),[],this._extension.identifier);return f.collapsibleState=y.CommentThreadCollapsibleState.Expanded,this._threads.set(f.handle,f),f}$updateCommentThreadTemplate(i,u){let f=this._threads.get(i);f&&(f.range=k.Range.to(u))}$deleteCommentThread(i){let u=this._threads.get(i);u&&u.dispose(),this._threads.delete(i)}getCommentThread(i){return this._threads.get(i)}dispose(){this._threads.forEach(i=>{i.dispose()}),this._localDisposables.forEach(i=>i.dispose())}}function h(s,i,u){let f=u.get(i);f||(f=++s.commentHandle,u.set(i,f));const v=i.author&&i.author.iconPath?i.author.iconPath.toString():void 0;return{mode:i.mode,contextValue:i.contextValue,uniqueIdInThread:f,body:k.MarkdownString.from(i.body),userName:i.author.name,userIconPath:v,label:i.label,commentReactions:i.reactions?i.reactions.map(D=>p(D)):void 0}}function p(s){return{label:s.label,iconPath:s.iconPath?k.pathOrURIToURI(s.iconPath):void 0,count:s.count,hasReacted:s.authorHasReacted}}function t(s){return{label:s.label||"",count:s.count||0,iconPath:s.iconPath?C.URI.revive(s.iconPath):"",authorHasReacted:s.hasReacted||!1}}function r(s){if(s!==void 0)switch(s){case n.CommentThreadCollapsibleState.Expanded:return y.CommentThreadCollapsibleState.Expanded;case n.CommentThreadCollapsibleState.Collapsed:return y.CommentThreadCollapsibleState.Collapsed}return y.CommentThreadCollapsibleState.Collapsed}return new w}e.createExtHostComments=l}),define(be[104],Ee([0,1,2,5,7,4,13,15,17,8,14]),function(ee,e,g,F,S,_,C,y,b,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let I=class wn{constructor(d,c){this._logService=c,this._provider=new Map,this._proxy=d.getProxy(F.MainContext.MainThreadDecorations)}registerFileDecorationProvider(d,c){const m=wn._handlePool++;this._provider.set(m,{provider:d,extensionId:c}),this._proxy.$registerDecorationProvider(m,c.value);const E=d.onDidChangeFileDecorations&&d.onDidChangeFileDecorations(w=>{if(!w){this._proxy.$onDidChange(m,null);return}let P=(0,b.asArray)(w);if(P.length<=wn._maxEventSize){this._proxy.$onDidChange(m,P);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",c.value,P.length);const a=P.map(t=>({uri:t,rank:(0,k.count)(t.path,"/")})),h=(0,b.groupBy)(a,(t,r)=>t.rank-r.rank||(0,k.compare)(t.uri.path,r.uri.path));let p=[];e:for(let t of h){let r;for(let s of t){let i=(0,n.dirname)(s.uri.path);if(r!==i&&(r=i,p.push(s.uri)>=wn._maxEventSize))break e}}this._proxy.$onDidChange(m,p)});return new S.Disposable(()=>{E?.dispose(),this._proxy.$unregisterDecorationProvider(m),this._provider.delete(m)})}async $provideDecorations(d,c,m){if(!this._provider.has(d))return Object.create(null);const E=Object.create(null),{provider:w,extensionId:P}=this._provider.get(d);return await Promise.all(c.map(async a=>{try{const{uri:h,id:p}=a,t=await Promise.resolve(w.provideFileDecoration(g.URI.revive(h),m));if(!t)return;try{S.FileDecoration.validate(t),E[p]=[t.propagate,t.tooltip,t.badge,t.color]}catch(r){this._logService.warn(`INVALID decoration from extension '${P.value}': ${r}`)}}catch(h){this._logService.error(h)}})),E}};I._handlePool=0,I._maxEventSize=250,I=ze([qe(0,C.IExtHostRpcService),qe(1,y.ILogService)],I),e.ExtHostDecorations=I,e.IExtHostDecorations=(0,_.createDecorator)("IExtHostDecorations")}),define(be[194],Ee([0,1,133,92,2,5,7,9,3,15,21]),function(ee,e,g,F,S,_,C,y,b,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class I{constructor(c,m,E,w,P){this._name=c,this._owner=m,this._maxDiagnosticsPerFile=E,this._proxy=w,this._onDidChangeDiagnostics=P,this._isDisposed=!1,this._data=new n.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(c,m){if(!c){this.clear();return}this._checkDisposed();let E=[];if(S.URI.isUri(c)){if(!m){this.delete(c);return}this._data.set(c,m.slice()),E=[c]}else if(Array.isArray(c)){E=[];let P;c=[...c].sort(I._compareIndexedTuplesByUri);for(const a of c){const[h,p]=a;if((!P||h.toString()!==P.toString())&&(P&&this._data.get(P).length===0&&this._data.delete(P),P=h,E.push(h),this._data.set(h,[])),p){const t=this._data.get(h);t&&t.push(...p)}else{const t=this._data.get(h);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(E),!this._proxy)return;const w=[];for(let P of E){let a=[];const h=this._data.get(P);if(h)if(h.length>this._maxDiagnosticsPerFile){a=[];const p=[C.DiagnosticSeverity.Error,C.DiagnosticSeverity.Warning,C.DiagnosticSeverity.Information,C.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let r of h)if(r.severity===p[t]&&a.push(y.Diagnostic.from(r))===this._maxDiagnosticsPerFile)break e;a.push({severity:F.MarkerSeverity.Info,message:(0,g.localize)(0,null,h.length-this._maxDiagnosticsPerFile),startLineNumber:a[a.length-1].startLineNumber,startColumn:a[a.length-1].startColumn,endLineNumber:a[a.length-1].endLineNumber,endColumn:a[a.length-1].endColumn})}else a=h.map(p=>y.Diagnostic.from(p));w.push([P,a])}this._proxy.$changeMany(this._owner,w)}delete(c){this._checkDisposed(),this._onDidChangeDiagnostics.fire([c]),this._data.delete(c),this._proxy&&this._proxy.$changeMany(this._owner,[[c,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(c,m){this._checkDisposed();for(let E of this._data.keys())c.apply(m,[E,this.get(E),this])}get(c){this._checkDisposed();const m=this._data.get(c);return Array.isArray(m)?Object.freeze(m.slice(0)):[]}has(c){return this._checkDisposed(),Array.isArray(this._data.get(c))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(c,m){return c[0].toString()<m[0].toString()?-1:c[0].toString()>m[0].toString()?1:0}}e.DiagnosticCollection=I;let l=class Gt{constructor(c,m){this._logService=m,this._collections=new Map,this._onDidChangeDiagnostics=new b.DebounceEmitter({merge:E=>E.flat(),delay:50}),this.onDidChangeDiagnostics=b.Event.map(this._onDidChangeDiagnostics.event,Gt._mapper),this._proxy=c.getProxy(_.MainContext.MainThreadDiagnostics)}static _mapper(c){const m=new n.ResourceMap;for(const E of c)m.set(E,E);return{uris:Object.freeze(Array.from(m.values()))}}createDiagnosticCollection(c,m){const{_collections:E,_proxy:w,_onDidChangeDiagnostics:P,_logService:a}=this,h=new class{$changeMany(r,s){w.$changeMany(r,s),a.trace("[DiagnosticCollection] change many (extension, owner, uris)",c.value,r,s.length===0?"CLEARING":s)}$clear(r){w.$clear(r),a.trace("[DiagnosticCollection] remove all (extension, owner)",c.value,r)}dispose(){w.dispose()}};let p;if(!m)m="_generated_diagnostic_collection_name_#"+Gt._idPool++,p=m;else if(!E.has(m))p=m;else{this._logService.warn(`DiagnosticCollection with name '${m}' does already exist.`);do p=m+Gt._idPool++;while(E.has(p))}return new class extends I{constructor(){super(m,p,Gt._maxDiagnosticsPerFile,h,P);E.set(p,this)}dispose(){super.dispose(),E.delete(p)}}}getDiagnostics(c){if(c)return this._getDiagnostics(c);{const m=new Map,E=[];for(const w of this._collections.values())w.forEach((P,a)=>{let h=m.get(P.toString());typeof h=="undefined"&&(h=E.length,m.set(P.toString(),h),E.push([P,[]])),E[h][1]=E[h][1].concat(...a)});return E}}_getDiagnostics(c){let m=[];for(let E of this._collections.values())E.has(c)&&(m=m.concat(E.get(c)));return m}$acceptMarkersChange(c){if(!this._mirrorCollection){const m="_generated_mirror",E=new I(m,m,Gt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(m,E),this._mirrorCollection=E}for(const[m,E]of c)this._mirrorCollection.set(S.URI.revive(m),E.map(y.Diagnostic.to))}};l._idPool=0,l._maxDiagnosticsPerFile=1e3,l=ze([qe(1,k.ILogService)],l),e.ExtHostDiagnostics=l}),define(be[195],Ee([0,1,2,5]),function(ee,e,g,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class S{constructor(C){this._proxy=C.getProxy(F.MainContext.MainThreadDialogs)}showOpenDialog(C){return this._proxy.$showOpenDialog(C).then(y=>y?y.map(b=>g.URI.revive(b)):void 0)}showSaveDialog(C){return this._proxy.$showSaveDialog(C).then(y=>y?g.URI.revive(y):void 0)}}e.ExtHostDialogs=S}),define(be[196],Ee([0,1,12,2,7,5,11,20,8]),function(ee,e,g,F,S,_,C,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class k{constructor(I,l,d){this._documentsAndEditors=l,this._logService=d,this._documentContentProviders=new Map,this._proxy=I.getProxy(_.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,l){if(Object.keys(C.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const d=k._handlePool++;this._documentContentProviders.set(d,l),this._proxy.$registerTextContentProvider(d,I);let c;return typeof l.onDidChange=="function"&&(c=l.onDidChange(m=>{if(m.scheme!==I){this._logService.warn(`Provider for scheme '${I}' is firing event for schema '${m.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(m)&&this.$provideTextDocumentContent(d,m).then(E=>{if(!E&&typeof E!="string")return;const w=this._documentsAndEditors.getDocument(m);if(!w)return;const P=(0,b.splitLines)(E);if(!w.equalLines(P))return this._proxy.$onVirtualDocumentChange(m,E)},g.onUnexpectedError)})),new S.Disposable(()=>{this._documentContentProviders.delete(d)&&this._proxy.$unregisterTextContentProvider(d),c&&(c.dispose(),c=void 0)})}$provideTextDocumentContent(I,l){const d=this._documentContentProviders.get(I);return d?Promise.resolve(d.provideTextDocumentContent(F.URI.revive(l),y.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${l.scheme}`))}}e.ExtHostDocumentContentProvider=k,k._handlePool=0}),define(be[197],Ee([0,1,3,6,2,5,98,9,10,23,7]),function(ee,e,g,F,S,_,C,y,b,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class I{constructor(d,c){this._onDidAddDocument=new g.Emitter,this._onDidRemoveDocument=new g.Emitter,this._onDidChangeDocument=new g.Emitter,this._onDidSaveDocument=new g.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new F.DisposableStore,this._documentLoader=new Map,this._proxy=d.getProxy(_.MainContext.MainThreadDocuments),this._documentsAndEditors=c,this._documentsAndEditors.onDidRemoveDocuments(m=>{for(const E of m)this._onDidRemoveDocument.fire(E.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(m=>{for(const E of m)this._onDidAddDocument.fire(E.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(d){if(!d)return;const c=this._documentsAndEditors.getDocument(d);if(c)return c}getDocument(d){const c=this.getDocumentData(d);if(!c?.document)throw new Error(`Unable to retrieve document from URI '${d}'`);return c.document}ensureDocumentData(d){const c=this._documentsAndEditors.getDocument(d);if(c)return Promise.resolve(c);let m=this._documentLoader.get(d.toString());return m||(m=this._proxy.$tryOpenDocument(d).then(E=>{this._documentLoader.delete(d.toString());const w=S.URI.revive(E);return(0,b.assertIsDefined)(this._documentsAndEditors.getDocument(w))},E=>(this._documentLoader.delete(d.toString()),Promise.reject(E))),this._documentLoader.set(d.toString(),m)),m}createDocumentData(d){return this._proxy.$tryCreateDocument(d).then(c=>S.URI.revive(c))}$acceptModelModeChanged(d,c){const m=S.URI.revive(d),E=this._documentsAndEditors.getDocument(m);if(!E)throw new Error("unknown document");this._onDidRemoveDocument.fire(E.document),E._acceptLanguageId(c),this._onDidAddDocument.fire(E.document)}$acceptModelSaved(d){const c=S.URI.revive(d),m=this._documentsAndEditors.getDocument(c);if(!m)throw new Error("unknown document");this.$acceptDirtyStateChanged(d,!1),this._onDidSaveDocument.fire(m.document)}$acceptDirtyStateChanged(d,c){const m=S.URI.revive(d),E=this._documentsAndEditors.getDocument(m);if(!E)throw new Error("unknown document");E._acceptIsDirty(c),this._onDidChangeDocument.fire({document:E.document,contentChanges:[],reason:void 0})}$acceptModelChanged(d,c,m){const E=S.URI.revive(d),w=this._documentsAndEditors.getDocument(E);if(!w)throw new Error("unknown document");w._acceptIsDirty(m),w.onEvents(c);let P;c.isUndoing?P=n.TextDocumentChangeReason.Undo:c.isRedoing&&(P=n.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,k.deepFreeze)({document:w.document,contentChanges:c.changes.map(a=>({range:y.Range.to(a.range),rangeOffset:a.rangeOffset,rangeLength:a.rangeLength,text:a.text})),reason:P}))}setWordDefinitionFor(d,c){(0,C.setWordDefinitionFor)(d,c)}}e.ExtHostDocuments=I}),define(be[48],Ee([0,1,40,3,6,2,4,5,98,13,102,9,15,21,11,54,112]),function(ee,e,g,F,S,_,C,y,b,k,n,I,l,d,c,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class w{constructor(h){this.value=h,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let P=class{constructor(h,p){this._extHostRpc=h,this._logService=p,this._activeEditorId=null,this._editors=new Map,this._documents=new d.ResourceMap,this._onDidAddDocuments=new F.Emitter,this._onDidRemoveDocuments=new F.Emitter,this._onDidChangeVisibleTextEditors=new F.Emitter,this._onDidChangeActiveTextEditor=new F.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(h){this.acceptDocumentsAndEditorsDelta(h)}acceptDocumentsAndEditorsDelta(h){const p=[],t=[],r=[];if(h.removedDocuments)for(const s of h.removedDocuments){const i=_.URI.revive(s),u=this._documents.get(i);u?.unref()&&(this._documents.delete(i),p.push(u.value))}if(h.addedDocuments)for(const s of h.addedDocuments){const i=_.URI.revive(s.uri);let u=this._documents.get(i);if(u&&i.scheme!==c.Schemas.vscodeNotebookCell&&i.scheme!==c.Schemas.vscodeInteractiveInput)throw new Error(`document '${i} already exists!'`);u||(u=new w(new b.ExtHostDocumentData(this._extHostRpc.getProxy(y.MainContext.MainThreadDocuments),i,s.lines,s.EOL,s.versionId,s.modeId,s.isDirty,s.notebook)),this._documents.set(i,u),t.push(u.value)),u.ref()}if(h.removedEditors)for(const s of h.removedEditors){const i=this._editors.get(s);this._editors.delete(s),i&&r.push(i)}if(h.addedEditors)for(const s of h.addedEditors){const i=_.URI.revive(s.documentUri);g.ok(this._documents.has(i),`document '${i}' does not exist`),g.ok(!this._editors.has(s.id),`editor '${s.id}' already exists!`);const u=this._documents.get(i).value,f=new n.ExtHostTextEditor(s.id,this._extHostRpc.getProxy(y.MainContext.MainThreadTextEditors),this._logService,new E.Lazy(()=>u.document),s.selections.map(I.Selection.to),s.options,s.visibleRanges.map(v=>I.Range.to(v)),typeof s.editorPosition=="number"?I.ViewColumn.to(s.editorPosition):void 0);this._editors.set(s.id,f)}h.newActiveEditor!==void 0&&(g.ok(h.newActiveEditor===null||this._editors.has(h.newActiveEditor),`active editor '${h.newActiveEditor}' does not exist`),this._activeEditorId=h.newActiveEditor),(0,S.dispose)(p),(0,S.dispose)(r),h.removedDocuments&&this._onDidRemoveDocuments.fire(p),h.addedDocuments&&this._onDidAddDocuments.fire(t),(h.removedEditors||h.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(s=>s.value)),h.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(h){return this._documents.get(h)?.value}allDocuments(){return m.Iterable.map(this._documents.values(),h=>h.value)}getEditor(h){return this._editors.get(h)}activeEditor(h){if(!this._activeEditorId)return;const p=this._editors.get(this._activeEditorId);return h?p:p?.value}allEditors(){return[...this._editors.values()]}};P=ze([qe(0,k.IExtHostRpcService),qe(1,l.ILogService)],P),e.ExtHostDocumentsAndEditors=P,e.IExtHostDocumentsAndEditors=(0,C.createDecorator)("IExtHostDocumentsAndEditors")}),define(be[198],Ee([0,1,2,5,6,7,9,122,8,24]),function(ee,e,g,F,S,_,C,y,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class n{constructor(){this._schemes=[]}add(d){this._stateMachine=void 0,this._schemes.push(d)}delete(d){const c=this._schemes.indexOf(d);c>=0&&(this._schemes.splice(c,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const d=this._schemes.sort(),c=[];let m,E,w=14,P=14;for(const a of d){let h=m?(0,b.commonPrefixLength)(m,a):0;for(h===0?E=1:E=P;h<a.length;h++)h+1===a.length?(w=P,P=9):P+=1,c.push([E,a.toUpperCase().charCodeAt(h),P]),c.push([E,a.toLowerCase().charCodeAt(h),P]),E=P;m=a,P=w}c.push([9,58,10]),c.push([10,47,12]),this._stateMachine=new y.StateMachine(c)}}provideDocumentLinks(d){this._initStateMachine();const c=[],m=y.LinkComputer.computeLinks({getLineContent(E){return d.lineAt(E-1).text},getLineCount(){return d.lineCount}},this._stateMachine);for(const E of m){const w=C.DocumentLink.to(E);w.target&&c.push(w)}return c}}class I{constructor(d,c){this._extHostLanguageFeatures=c,this._linkProvider=new n,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._enableProposedApi=new Map,this._handlePool=0,this._proxy=d.getProxy(F.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(d,c,m,E={},w){if(this._registeredSchemes.has(c))throw new Error(`a provider for the scheme '${c}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const P=this._handlePool++;this._linkProvider.add(c),this._registeredSchemes.add(c),this._fsProvider.set(P,m),this._enableProposedApi.set(P,w??!1);let a=2;E.isCaseSensitive&&(a+=1024),E.isReadonly&&(a+=2048),typeof m.copy=="function"&&(a+=8),typeof m.open=="function"&&typeof m.close=="function"&&typeof m.read=="function"&&typeof m.write=="function"&&(a+=4),this._proxy.$registerFileSystemProvider(P,c,a).catch(p=>{console.error(`FAILED to register filesystem provider of ${d.value}-extension for the scheme ${c}`),console.error(p)});const h=m.onDidChangeFile(p=>{const t=[];for(const r of p){let{uri:s,type:i}=r;if(s.scheme!==c)continue;let u;switch(i){case _.FileChangeType.Changed:u=0;break;case _.FileChangeType.Created:u=1;break;case _.FileChangeType.Deleted:u=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:s,type:u})}this._proxy.$onFileSystemChange(P,t)});return(0,S.toDisposable)(()=>{h.dispose(),this._linkProvider.delete(c),this._registeredSchemes.delete(c),this._fsProvider.delete(P),this._enableProposedApi.delete(P),this._proxy.$unregisterProvider(P)})}static _asIStat(d,c){const{type:m,ctime:E,mtime:w,size:P,permissions:a}=d;return c?{type:m,ctime:E,mtime:w,size:P,permissions:a}:{type:m,ctime:E,mtime:w,size:P}}$stat(d,c){return Promise.resolve(this._getFsProvider(d).stat(g.URI.revive(c))).then(m=>I._asIStat(m,this._enableProposedApi.get(d)??!1))}$readdir(d,c){return Promise.resolve(this._getFsProvider(d).readDirectory(g.URI.revive(c)))}$readFile(d,c){return Promise.resolve(this._getFsProvider(d).readFile(g.URI.revive(c))).then(m=>k.VSBuffer.wrap(m))}$writeFile(d,c,m,E){return Promise.resolve(this._getFsProvider(d).writeFile(g.URI.revive(c),m.buffer,E))}$delete(d,c,m){return Promise.resolve(this._getFsProvider(d).delete(g.URI.revive(c),m))}$rename(d,c,m,E){return Promise.resolve(this._getFsProvider(d).rename(g.URI.revive(c),g.URI.revive(m),E))}$copy(d,c,m,E){const w=this._getFsProvider(d);if(!w.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(w.copy(g.URI.revive(c),g.URI.revive(m),E))}$mkdir(d,c){return Promise.resolve(this._getFsProvider(d).createDirectory(g.URI.revive(c)))}$watch(d,c,m,E){const w=this._getFsProvider(d).watch(g.URI.revive(m),E);this._watches.set(c,w)}$unwatch(d,c){const m=this._watches.get(c);m&&(m.dispose(),this._watches.delete(c))}$open(d,c,m){const E=this._getFsProvider(d);if(!E.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(E.open(g.URI.revive(c),m))}$close(d,c){const m=this._getFsProvider(d);if(!m.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(m.close(c))}$read(d,c,m,E){const w=this._getFsProvider(d);if(!w.read)throw new Error('FileSystemProvider does not implement "read"');const P=k.VSBuffer.alloc(E);return Promise.resolve(w.read(c,m,P.buffer,0,E)).then(a=>P.slice(0,a))}$write(d,c,m,E){const w=this._getFsProvider(d);if(!w.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(w.write(c,m,E.buffer,0,E.byteLength))}_getFsProvider(d){const c=this._fsProvider.get(d);if(!c){const m=new Error;throw m.name="ENOPRO",m.message="no provider",m}return c}}e.ExtHostFileSystem=I}),define(be[76],Ee([0,1,5,61,7,24,4,13,47]),function(ee,e,g,F,S,_,C,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let k=class Wt{constructor(I,l){const d=I.getProxy(g.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(c){return d.$stat(c).catch(Wt._handleError)},readDirectory(c){return d.$readdir(c).catch(Wt._handleError)},createDirectory(c){return d.$mkdir(c).catch(Wt._handleError)},async readFile(c){return d.$readFile(c).then(m=>m.buffer).catch(Wt._handleError)},writeFile(c,m){return d.$writeFile(c,_.VSBuffer.wrap(m)).catch(Wt._handleError)},delete(c,m){return d.$delete(c,{recursive:!1,useTrash:!1,...m}).catch(Wt._handleError)},rename(c,m,E){return d.$rename(c,m,{overwrite:!1,...E}).catch(Wt._handleError)},copy(c,m,E){return d.$copy(c,m,{overwrite:!1,...E}).catch(Wt._handleError)},isWritableFileSystem(c){const m=l.getCapabilities(c);if(typeof m=="number")return!(m&2048)}})}static _handleError(I){if(!(I instanceof Error))throw new S.FileSystemError(String(I));if(I.name==="ENOPRO")throw S.FileSystemError.Unavailable(I.message);switch(I.name){case F.FileSystemProviderErrorCode.FileExists:throw S.FileSystemError.FileExists(I.message);case F.FileSystemProviderErrorCode.FileNotFound:throw S.FileSystemError.FileNotFound(I.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw S.FileSystemError.FileNotADirectory(I.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw S.FileSystemError.FileIsADirectory(I.message);case F.FileSystemProviderErrorCode.NoPermissions:throw S.FileSystemError.NoPermissions(I.message);case F.FileSystemProviderErrorCode.Unavailable:throw S.FileSystemError.Unavailable(I.message);default:throw new S.FileSystemError(I.message,I.name)}}};k=ze([qe(0,y.IExtHostRpcService),qe(1,b.IExtHostFileSystemInfo)],k),e.ExtHostConsumerFileSystem=k,e.IExtHostConsumerFileSystem=(0,C.createDecorator)("IExtHostConsumerFileSystem")}),define(be[199],Ee([0,1,6,5]),function(ee,e,g,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class S{constructor(C){this._handlePool=0,this._proxy=C.getProxy(F.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(C){const y=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(y,C),(0,g.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(y)})}}e.ExtHostLabelService=S}),define(be[200],Ee([0,1,2,23,9,7,5,8,31,17,10,119,6,89,53,65,55,12,3]),function(ee,e,g,F,S,_,C,y,b,k,n,I,l,d,c,m,E,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class a{constructor(O,G){this._documents=O,this._provider=G}async provideDocumentSymbols(O,G){const X=this._documents.getDocument(O),se=await this._provider.provideDocumentSymbols(X,G);if(!(0,k.isFalsyOrEmpty)(se))return se[0]instanceof _.DocumentSymbol?se.map(S.DocumentSymbol.from):a._asDocumentSymbolTree(se)}static _asDocumentSymbolTree(O){O=O.slice(0).sort((se,q)=>{let ie=se.location.range.start.compareTo(q.location.range.start);return ie===0&&(ie=q.location.range.end.compareTo(se.location.range.end)),ie});const G=[],X=[];for(const se of O){const q={name:se.name||"!!MISSING: name!!",kind:S.SymbolKind.from(se.kind),tags:se.tags?.map(S.SymbolTag.from)||[],detail:"",containerName:se.containerName,range:S.Range.from(se.location.range),selectionRange:S.Range.from(se.location.range),children:[]};for(;;){if(X.length===0){X.push(q),G.push(q);break}const ie=X[X.length-1];if(b.Range.containsRange(ie.range,q.range)&&!b.Range.equalsRange(ie.range,q.range)){ie.children&&ie.children.push(q),X.push(q);break}X.pop()}}return G}}class h{constructor(O,G,X){this._documents=O,this._commands=G,this._provider=X,this._cache=new m.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(O,G){const X=this._documents.getDocument(O),se=await this._provider.provideCodeLenses(X,G);if(!se||G.isCancellationRequested)return;const q=this._cache.add(se),ie=new l.DisposableStore;this._disposables.set(q,ie);const ge={cacheId:q,lenses:[]};for(let Le=0;Le<se.length;Le++)ge.lenses.push({cacheId:[q,Le],range:S.Range.from(se[Le].range),command:this._commands.toInternal(se[Le].command,ie)});return ge}async resolveCodeLens(O,G){const X=O.cacheId&&this._cache.get(...O.cacheId);if(!X)return;let se;if(typeof this._provider.resolveCodeLens!="function"||X.isResolved?se=X:se=await this._provider.resolveCodeLens(X,G),se||(se=X),G.isCancellationRequested)return;const q=O.cacheId&&this._disposables.get(O.cacheId[0]);if(!!q)return O.command=this._commands.toInternal(se.command??h._badCmd,q),O}releaseCodeLenses(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}}h._badCmd={command:"missing",title:"!!MISSING: command!!"};function p(je){return Array.isArray(je)?je.map(S.DefinitionLink.from):je?[S.DefinitionLink.from(je)]:[]}class t{constructor(O,G){this._documents=O,this._provider=G}async provideDefinition(O,G,X){const se=this._documents.getDocument(O),q=S.Position.to(G),ie=await this._provider.provideDefinition(se,q,X);return p(ie)}}class r{constructor(O,G){this._documents=O,this._provider=G}async provideDeclaration(O,G,X){const se=this._documents.getDocument(O),q=S.Position.to(G),ie=await this._provider.provideDeclaration(se,q,X);return p(ie)}}class s{constructor(O,G){this._documents=O,this._provider=G}async provideImplementation(O,G,X){const se=this._documents.getDocument(O),q=S.Position.to(G),ie=await this._provider.provideImplementation(se,q,X);return p(ie)}}class i{constructor(O,G){this._documents=O,this._provider=G}async provideTypeDefinition(O,G,X){const se=this._documents.getDocument(O),q=S.Position.to(G),ie=await this._provider.provideTypeDefinition(se,q,X);return p(ie)}}class u{constructor(O,G){this._documents=O,this._provider=G}async provideHover(O,G,X){const se=this._documents.getDocument(O),q=S.Position.to(G),ie=await this._provider.provideHover(se,q,X);if(!(!ie||(0,k.isFalsyOrEmpty)(ie.contents)))return ie.range||(ie.range=se.getWordRangeAtPosition(q)),ie.range||(ie.range=new _.Range(q,q)),S.Hover.from(ie)}}class f{constructor(O,G){this._documents=O,this._provider=G}async provideEvaluatableExpression(O,G,X){const se=this._documents.getDocument(O),q=S.Position.to(G),ie=await this._provider.provideEvaluatableExpression(se,q,X);if(ie)return S.EvaluatableExpression.from(ie)}}class v{constructor(O,G){this._documents=O,this._provider=G}async provideInlineValues(O,G,X,se){const q=this._documents.getDocument(O),ie=await this._provider.provideInlineValues(q,S.Range.to(G),S.InlineValueContext.to(X),se);if(Array.isArray(ie))return ie.map(ge=>S.InlineValue.from(ge))}}class D{constructor(O,G){this._documents=O,this._provider=G}async provideDocumentHighlights(O,G,X){const se=this._documents.getDocument(O),q=S.Position.to(G),ie=await this._provider.provideDocumentHighlights(se,q,X);if(Array.isArray(ie))return ie.map(S.DocumentHighlight.from)}}class T{constructor(O,G){this._documents=O,this._provider=G}async provideLinkedEditingRanges(O,G,X){const se=this._documents.getDocument(O),q=S.Position.to(G),ie=await this._provider.provideLinkedEditingRanges(se,q,X);if(ie&&Array.isArray(ie.ranges))return{ranges:(0,k.coalesce)(ie.ranges.map(S.Range.from)),wordPattern:ie.wordPattern}}}class o{constructor(O,G){this._documents=O,this._provider=G}async provideReferences(O,G,X,se){const q=this._documents.getDocument(O),ie=S.Position.to(G),ge=await this._provider.provideReferences(q,ie,X,se);if(Array.isArray(ge))return ge.map(S.location.from)}}class A{constructor(O,G,X,se,q,ie,ge){this._documents=O,this._commands=G,this._diagnostics=X,this._provider=se,this._logService=q,this._extension=ie,this._apiDeprecation=ge,this._cache=new m.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(O,G,X,se){const q=this._documents.getDocument(O),ie=I.Selection.isISelection(G)?S.Selection.to(G):S.Range.to(G),ge=[];for(const Z of this._diagnostics.getDiagnostics(O))if(ie.intersection(Z.range)&&ge.push(Z)>A._maxCodeActionsPerFile)break;const Le={diagnostics:ge,only:X.only?new _.CodeActionKind(X.only):void 0,triggerKind:S.CodeActionTriggerKind.to(X.trigger)},We=await this._provider.provideCodeActions(q,ie,Le,se);if(!(0,k.isNonEmptyArray)(We)||se.isCancellationRequested)return;const ve=this._cache.add(We),Xe=new l.DisposableStore;this._disposables.set(ve,Xe);const H=[];for(let Z=0;Z<We.length;Z++){const de=We[Z];!de||(A._isCommand(de)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),H.push({_isSynthetic:!0,title:de.title,command:this._commands.toInternal(de,Xe)})):(Le.only&&(de.kind?Le.only.contains(de.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Le.only.value} 'requested but returned code action is of kind '${de.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Le.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),H.push({cacheId:[ve,Z],title:de.title,command:de.command&&this._commands.toInternal(de.command,Xe),diagnostics:de.diagnostics&&de.diagnostics.map(S.Diagnostic.from),edit:de.edit&&S.WorkspaceEdit.from(de.edit),kind:de.kind&&de.kind.value,isPreferred:de.isPreferred,disabled:de.disabled?.reason})))}return{cacheId:ve,actions:H}}async resolveCodeAction(O,G){const[X,se]=O,q=this._cache.get(X,se);if(!q||A._isCommand(q)||!this._provider.resolveCodeAction)return;const ie=await this._provider.resolveCodeAction(q,G)??q;return ie?.edit?S.WorkspaceEdit.from(ie.edit):void 0}releaseCodeActions(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}static _isCommand(O){return typeof O.command=="string"&&typeof O.title=="string"}}A._maxCodeActionsPerFile=1e3;class L{constructor(O,G){this._documents=O,this._provider=G}async provideDocumentFormattingEdits(O,G,X){const se=this._documents.getDocument(O),q=await this._provider.provideDocumentFormattingEdits(se,G,X);if(Array.isArray(q))return q.map(S.TextEdit.from)}}class B{constructor(O,G){this._documents=O,this._provider=G}async provideDocumentRangeFormattingEdits(O,G,X,se){const q=this._documents.getDocument(O),ie=S.Range.to(G),ge=await this._provider.provideDocumentRangeFormattingEdits(q,ie,X,se);if(Array.isArray(ge))return ge.map(S.TextEdit.from)}}class oe{constructor(O,G){this._documents=O,this._provider=G,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(O,G,X,se,q){const ie=this._documents.getDocument(O),ge=S.Position.to(G),Le=await this._provider.provideOnTypeFormattingEdits(ie,ge,X,se,q);if(Array.isArray(Le))return Le.map(S.TextEdit.from)}}class he{constructor(O,G){this._provider=O,this._logService=G,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(O,G){const X=C.IdObject.mixin({symbols:[]}),se=await this._provider.provideWorkspaceSymbols(O,G);if((0,k.isNonEmptyArray)(se))for(const q of se){if(!q)continue;if(!q.name){this._logService.warn("INVALID SymbolInformation, lacks name",q);continue}const ie=C.IdObject.mixin(S.WorkspaceSymbol.from(q));this._symbolCache.set(ie._id,q),X.symbols.push(ie)}return X.symbols.length>0&&this._resultCache.set(X._id,[X.symbols[0]._id,X.symbols[X.symbols.length-1]._id]),X}async resolveWorkspaceSymbol(O,G){if(typeof this._provider.resolveWorkspaceSymbol!="function")return O;const X=this._symbolCache.get(O._id);if(X){const se=await this._provider.resolveWorkspaceSymbol(X,G);return se&&(0,F.mixin)(O,S.WorkspaceSymbol.from(se),!0)}}releaseWorkspaceSymbols(O){const G=this._resultCache.get(O);if(G){for(let[X,se]=G;X<=se;X++)this._symbolCache.delete(X);this._resultCache.delete(O)}}}class Q{constructor(O,G,X){this._documents=O,this._provider=G,this._logService=X}static supportsResolving(O){return typeof O.prepareRename=="function"}async provideRenameEdits(O,G,X,se){const q=this._documents.getDocument(O),ie=S.Position.to(G);try{const ge=await this._provider.provideRenameEdits(q,ie,X,se);return ge?S.WorkspaceEdit.from(ge):void 0}catch(ge){const Le=Q._asMessage(ge);return Le?{rejectReason:Le,edits:void 0}:Promise.reject(ge)}}async resolveRenameLocation(O,G,X){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const se=this._documents.getDocument(O),q=S.Position.to(G);try{const ie=await this._provider.prepareRename(se,q,X);let ge,Le;if(_.Range.isRange(ie)?(ge=ie,Le=se.getText(ie)):(0,n.isObject)(ie)&&(ge=ie.range,Le=ie.placeholder),!ge||!Le)return;if(ge.start.line>q.line||ge.end.line<q.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:S.Range.from(ge),text:Le}}catch(ie){const ge=Q._asMessage(ie);return ge?{rejectReason:ge,range:void 0,text:void 0}:Promise.reject(ie)}}static _asMessage(O){return typeof O=="string"?O:O instanceof Error&&typeof O.message=="string"?O.message:void 0}}class z{constructor(O,G){this.resultId=O,this.tokens=G}}class V{constructor(O,G){this._documents=O,this._provider=G,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(O,G,X){const se=this._documents.getDocument(O),q=G!==0?this._previousResults.get(G):null;let ie=typeof q?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(se,q.resultId,X):await this._provider.provideDocumentSemanticTokens(se,X);return q&&this._previousResults.delete(G),ie?(ie=V._fixProvidedSemanticTokens(ie),this._send(V._convertToEdits(q,ie),ie)):null}async releaseDocumentSemanticColoring(O){this._previousResults.delete(O)}static _fixProvidedSemanticTokens(O){return V._isSemanticTokens(O)?V._isCorrectSemanticTokens(O)?O:new _.SemanticTokens(new Uint32Array(O.data),O.resultId):V._isSemanticTokensEdits(O)?V._isCorrectSemanticTokensEdits(O)?O:new _.SemanticTokensEdits(O.edits.map(G=>new _.SemanticTokensEdit(G.start,G.deleteCount,G.data?new Uint32Array(G.data):G.data)),O.resultId):O}static _isSemanticTokens(O){return O&&!!O.data}static _isCorrectSemanticTokens(O){return O.data instanceof Uint32Array}static _isSemanticTokensEdits(O){return O&&Array.isArray(O.edits)}static _isCorrectSemanticTokensEdits(O){for(const G of O.edits)if(!(G.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(O,G){if(!V._isSemanticTokens(G)||!O||!O.tokens)return G;const X=O.tokens,se=X.length,q=G.data,ie=q.length;let ge=0;const Le=Math.min(se,ie);for(;ge<Le&&X[ge]===q[ge];)ge++;if(ge===se&&ge===ie)return new _.SemanticTokensEdits([],G.resultId);let We=0;const ve=Le-ge;for(;We<ve&&X[se-We-1]===q[ie-We-1];)We++;return new _.SemanticTokensEdits([{start:ge,deleteCount:se-ge-We,data:q.subarray(ge,ie-We)}],G.resultId)}_send(O,G){if(V._isSemanticTokens(O)){const X=this._nextResultId++;return this._previousResults.set(X,new z(O.resultId,O.data)),(0,d.encodeSemanticTokensDto)({id:X,type:"full",data:O.data})}if(V._isSemanticTokensEdits(O)){const X=this._nextResultId++;return V._isSemanticTokens(G)?this._previousResults.set(X,new z(G.resultId,G.data)):this._previousResults.set(X,new z(O.resultId)),(0,d.encodeSemanticTokensDto)({id:X,type:"delta",deltas:(O.edits||[]).map(se=>({start:se.start,deleteCount:se.deleteCount,data:se.data}))})}return null}}e.DocumentSemanticTokensAdapter=V;class R{constructor(O,G){this._documents=O,this._provider=G}async provideDocumentRangeSemanticTokens(O,G,X){const se=this._documents.getDocument(O),q=await this._provider.provideDocumentRangeSemanticTokens(se,S.Range.to(G),X);return q?this._send(q):null}_send(O){return(0,d.encodeSemanticTokensDto)({id:0,type:"full",data:O.data})}}e.DocumentRangeSemanticTokensAdapter=R;class K{constructor(O,G,X,se,q){this._documents=O,this._commands=G,this._provider=X,this._apiDeprecation=se,this._extension=q,this._cache=new m.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(O){return typeof O.resolveCompletionItem=="function"}async provideCompletionItems(O,G,X,se){const q=this._documents.getDocument(O),ie=S.Position.to(G),ge=q.getWordRangeAtPosition(ie)||new _.Range(ie,ie),Le=ge.with({end:ie}),We=new E.StopWatch(!0),ve=await this._provider.provideCompletionItems(q,ie,se,S.CompletionContext.to(X));if(!ve||se.isCancellationRequested)return;const Xe=Array.isArray(ve)?new _.CompletionList(ve):ve,H=K.supportsResolving(this._provider)?this._cache.add(Xe.items):this._cache.add([]),Z=new l.DisposableStore;this._disposables.set(H,Z);const de=[],Be={x:H,b:de,a:{replace:S.Range.from(ge),insert:S.Range.from(Le)},c:Xe.isIncomplete||void 0,d:We.elapsed()};for(let xe=0;xe<Xe.items.length;xe++){const Ze=Xe.items[xe],De=this._convertCompletionItem(Ze,[H,xe],Le,ge);de.push(De)}return Be}async resolveCompletionItem(O,G){if(typeof this._provider.resolveCompletionItem!="function")return;const X=this._cache.get(...O);if(!X)return;const se=await this._provider.resolveCompletionItem(X,G);if(!!se)return this._convertCompletionItem(se,O)}releaseCompletionItems(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}_convertCompletionItem(O,G,X,se){const q=this._disposables.get(G[0]);if(!q)throw Error("DisposableStore is missing...");const ie={x:G,a:O.label,b:O.kind!==void 0?S.CompletionItemKind.from(O.kind):void 0,n:O.tags&&O.tags.map(S.CompletionItemTag.from),c:O.detail,d:typeof O.documentation=="undefined"?void 0:S.MarkdownString.fromStrict(O.documentation),e:O.sortText!==O.label?O.sortText:void 0,f:O.filterText!==O.label?O.filterText:void 0,g:O.preselect||void 0,i:O.keepWhitespace?1:0,k:O.commitCharacters,l:O.additionalTextEdits&&O.additionalTextEdits.map(S.TextEdit.from),m:this._commands.toInternal(O.command,q)};O.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ie.h=O.textEdit.newText):typeof O.insertText=="string"?ie.h=O.insertText:O.insertText instanceof _.SnippetString&&(ie.h=O.insertText.value,ie.i|=4);let ge;return O.textEdit?ge=O.textEdit.range:O.range&&(ge=O.range),_.Range.isRange(ge)?ie.j=S.Range.from(ge):ge&&(!X?.isEqual(ge.inserting)||!se?.isEqual(ge.replacing))&&(ie.j={insert:S.Range.from(ge.inserting),replace:S.Range.from(ge.replacing)}),ie}}class x{constructor(O,G,X){this._documents=O,this._provider=G,this._commands=X,this._cache=new m.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(O,G,X,se){const q=this._documents.getDocument(O),ie=S.Position.to(G),ge=await this._provider.provideInlineCompletionItems(q,ie,X,se);if(!ge||se.isCancellationRequested)return;const Le=(0,n.isArray)(ge)?{items:ge}:ge,We=this._cache.add(Le.items);let ve;return{pid:We,items:Le.items.map((Xe,H)=>{let Z;return Xe.command&&(ve||(ve=new l.DisposableStore,this._disposables.set(We,ve)),Z=this._commands.toInternal(Xe.command,ve)),{text:Xe.text,range:Xe.range?S.Range.from(Xe.range):void 0,command:Z,idx:H}})}}disposeCompletions(O){this._cache.delete(O);const G=this._disposables.get(O);G&&G.clear(),this._disposables.delete(O)}handleDidShowCompletionItem(O,G){const X=this._cache.get(O,G);X&&j.get(this._provider).fireOnDidShowCompletionItem({completionItem:X})}}class j{constructor(){this._onDidShowCompletionItemEmitter=new P.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(O){let G=j.map.get(O);return G||(G=new j,j.map.set(O,G)),G}fireOnDidShowCompletionItem(O){this._onDidShowCompletionItemEmitter.fire(O)}}e.InlineCompletionController=j,j.map=new WeakMap;class ue{constructor(O,G){this._documents=O,this._provider=G,this._cache=new m.Cache("SignatureHelp")}async provideSignatureHelp(O,G,X,se){const q=this._documents.getDocument(O),ie=S.Position.to(G),ge=this.reviveContext(X),Le=await this._provider.provideSignatureHelp(q,ie,se,ge);if(Le){const We=this._cache.add([Le]);return{...S.SignatureHelp.from(Le),id:We}}}reviveContext(O){let G;if(O.activeSignatureHelp){const X=S.SignatureHelp.to(O.activeSignatureHelp),se=this._cache.get(O.activeSignatureHelp.id,0);se?(G=se,G.activeSignature=X.activeSignature,G.activeParameter=X.activeParameter):G=X}return{...O,activeSignatureHelp:G}}releaseSignatureHelp(O){this._cache.delete(O)}}class ${constructor(O,G){this._documents=O,this._provider=G}async provideInlayHints(O,G,X){const se=this._documents.getDocument(O),q=await this._provider.provideInlayHints(se,S.Range.to(G),X);return q?{hints:q.map(S.InlayHint.from)}:void 0}}class te{constructor(O,G){this._documents=O,this._provider=G,this._cache=new m.Cache("DocumentLink")}async provideLinks(O,G){const X=this._documents.getDocument(O),se=await this._provider.provideDocumentLinks(X,G);if(!(!Array.isArray(se)||se.length===0)&&!G.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:se.filter(te._validateLink).map(S.DocumentLink.from)};{const q=this._cache.add(se),ie={links:[],id:q};for(let ge=0;ge<se.length;ge++){if(!te._validateLink(se[ge]))continue;const Le=S.DocumentLink.from(se[ge]);Le.cacheId=[q,ge],ie.links.push(Le)}return ie}}}static _validateLink(O){return O.target&&O.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(O,G){if(typeof this._provider.resolveDocumentLink!="function")return;const X=this._cache.get(...O);if(!X)return;const se=await this._provider.resolveDocumentLink(X,G);if(!(!se||!te._validateLink(se)))return S.DocumentLink.from(se)}releaseLinks(O){this._cache.delete(O)}}class ce{constructor(O,G){this._documents=O,this._provider=G}async provideColors(O,G){const X=this._documents.getDocument(O),se=await this._provider.provideDocumentColors(X,G);return Array.isArray(se)?se.map(ie=>({color:S.Color.from(ie.color),range:S.Range.from(ie.range)})):[]}async provideColorPresentations(O,G,X){const se=this._documents.getDocument(O),q=S.Range.to(G.range),ie=S.Color.to(G.color),ge=await this._provider.provideColorPresentations(ie,{document:se,range:q},X);if(!!Array.isArray(ge))return ge.map(S.ColorPresentation.from)}}class ye{constructor(O,G){this._documents=O,this._provider=G}async provideFoldingRanges(O,G,X){const se=this._documents.getDocument(O),q=await this._provider.provideFoldingRanges(se,G,X);if(!!Array.isArray(q))return q.map(S.FoldingRange.from)}}class Re{constructor(O,G,X){this._documents=O,this._provider=G,this._logService=X}async provideSelectionRanges(O,G,X){const se=this._documents.getDocument(O),q=G.map(S.Position.to),ie=await this._provider.provideSelectionRanges(se,q,X);if(!(0,k.isNonEmptyArray)(ie))return[];if(ie.length!==q.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const ge=[];for(let Le=0;Le<q.length;Le++){const We=[];ge.push(We);let ve=q[Le],Xe=ie[Le];for(;;){if(!Xe.range.contains(ve))throw new Error("INVALID selection range, must contain the previous range");if(We.push(S.SelectionRange.from(Xe)),!Xe.parent)break;ve=Xe.range,Xe=Xe.parent}}return ge}}class Te{constructor(O,G){this._documents=O,this._provider=G,this._idPool=new c.IdGenerator(""),this._cache=new Map}async prepareSession(O,G,X){const se=this._documents.getDocument(O),q=S.Position.to(G),ie=await this._provider.prepareCallHierarchy(se,q,X);if(!ie)return;const ge=this._idPool.nextId();return this._cache.set(ge,new Map),Array.isArray(ie)?ie.map(Le=>this._cacheAndConvertItem(ge,Le)):[this._cacheAndConvertItem(ge,ie)]}async provideCallsTo(O,G,X){const se=this._itemFromCache(O,G);if(!se)throw new Error("missing call hierarchy item");const q=await this._provider.provideCallHierarchyIncomingCalls(se,X);if(!!q)return q.map(ie=>({from:this._cacheAndConvertItem(O,ie.from),fromRanges:ie.fromRanges.map(ge=>S.Range.from(ge))}))}async provideCallsFrom(O,G,X){const se=this._itemFromCache(O,G);if(!se)throw new Error("missing call hierarchy item");const q=await this._provider.provideCallHierarchyOutgoingCalls(se,X);if(!!q)return q.map(ie=>({to:this._cacheAndConvertItem(O,ie.to),fromRanges:ie.fromRanges.map(ge=>S.Range.from(ge))}))}releaseSession(O){this._cache.delete(O)}_cacheAndConvertItem(O,G){const X=this._cache.get(O),se=S.CallHierarchyItem.from(G,O,X.size.toString(36));return X.set(se._itemId,G),se}_itemFromCache(O,G){return this._cache.get(O)?.get(G)}}class $e{constructor(O,G){this._documents=O,this._provider=G,this._idPool=new c.IdGenerator(""),this._cache=new Map}async prepareSession(O,G,X){const se=this._documents.getDocument(O),q=S.Position.to(G),ie=await this._provider.prepareTypeHierarchy(se,q,X);if(!ie)return;const ge=this._idPool.nextId();return this._cache.set(ge,new Map),Array.isArray(ie)?ie.map(Le=>this._cacheAndConvertItem(ge,Le)):[this._cacheAndConvertItem(ge,ie)]}async provideSupertypes(O,G,X){const se=this._itemFromCache(O,G);if(!se)throw new Error("missing type hierarchy item");const q=await this._provider.provideTypeHierarchySupertypes(se,X);if(!!q)return q.map(ie=>this._cacheAndConvertItem(O,ie))}async provideSubtypes(O,G,X){const se=this._itemFromCache(O,G);if(!se)throw new Error("missing type hierarchy item");const q=await this._provider.provideTypeHierarchySubtypes(se,X);if(!!q)return q.map(ie=>this._cacheAndConvertItem(O,ie))}releaseSession(O){this._cache.delete(O)}_cacheAndConvertItem(O,G){const X=this._cache.get(O),se=S.TypeHierarchyItem.from(G,O,X.size.toString(36));return X.set(se._itemId,G),se}_itemFromCache(O,G){return this._cache.get(O)?.get(G)}}class Je{constructor(O,G){this.adapter=O,this.extension=G}}class Ve{constructor(O,G,X,se,q,ie,ge){this._adapter=new Map,this._uriTransformer=G,this._proxy=O.getProxy(C.MainContext.MainThreadLanguageFeatures),this._documents=X,this._commands=se,this._diagnostics=q,this._logService=ie,this._apiDeprecation=ge}_transformDocumentSelector(O){return(0,k.coalesce)((0,k.asArray)(O).map(G=>this._doTransformDocumentSelector(G)))}_doTransformDocumentSelector(O){if(typeof O=="string")return{$serialized:!0,language:O};if(O)return{$serialized:!0,language:O.language,scheme:this._transformScheme(O.scheme),pattern:typeof O.pattern=="undefined"?void 0:S.GlobPattern.from(O.pattern),exclusive:O.exclusive}}_transformScheme(O){return this._uriTransformer&&typeof O=="string"?this._uriTransformer.transformOutgoingScheme(O):O}_createDisposable(O){return new _.Disposable(()=>{this._adapter.delete(O),this._proxy.$unregister(O)})}_nextHandle(){return Ve._handlePool++}_withAdapter(O,G,X,se,q=!1){const ie=this._adapter.get(O);if(!ie)return Promise.resolve(se);if(ie.adapter instanceof G){let ge;ie.extension&&(ge=Date.now(),this._logService.trace(`[${ie.extension.identifier.value}] INVOKE provider '${G.name}'`));const Le=X(ie.adapter,ie.extension),We=ie.extension;return We&&Promise.resolve(Le).then(()=>this._logService.trace(`[${We.identifier.value}] provider DONE after ${Date.now()-ge}ms`),ve=>{q&&ve instanceof w.CancellationError||(this._logService.error(`[${We.identifier.value}] provider FAILED`),this._logService.error(ve))}),Le}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(O,G){const X=this._nextHandle();return this._adapter.set(X,new Je(O,G)),X}static _extLabel(O){return O.displayName||O.name}registerDocumentSymbolProvider(O,G,X,se){const q=this._addNewAdapter(new a(this._documents,X),O),ie=se&&se.label||Ve._extLabel(O);return this._proxy.$registerDocumentSymbolProvider(q,this._transformDocumentSelector(G),ie),this._createDisposable(q)}$provideDocumentSymbols(O,G,X){return this._withAdapter(O,a,se=>se.provideDocumentSymbols(g.URI.revive(G),X),void 0)}registerCodeLensProvider(O,G,X){const se=this._nextHandle(),q=typeof X.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(se,new Je(new h(this._documents,this._commands.converter,X),O)),this._proxy.$registerCodeLensSupport(se,this._transformDocumentSelector(G),q);let ie=this._createDisposable(se);if(q!==void 0){const ge=X.onDidChangeCodeLenses(Le=>this._proxy.$emitCodeLensEvent(q));ie=_.Disposable.from(ie,ge)}return ie}$provideCodeLenses(O,G,X){return this._withAdapter(O,h,se=>se.provideCodeLenses(g.URI.revive(G),X),void 0)}$resolveCodeLens(O,G,X){return this._withAdapter(O,h,se=>se.resolveCodeLens(G,X),void 0)}$releaseCodeLenses(O,G){this._withAdapter(O,h,X=>Promise.resolve(X.releaseCodeLenses(G)),void 0)}registerDefinitionProvider(O,G,X){const se=this._addNewAdapter(new t(this._documents,X),O);return this._proxy.$registerDefinitionSupport(se,this._transformDocumentSelector(G)),this._createDisposable(se)}$provideDefinition(O,G,X,se){return this._withAdapter(O,t,q=>q.provideDefinition(g.URI.revive(G),X,se),[])}registerDeclarationProvider(O,G,X){const se=this._addNewAdapter(new r(this._documents,X),O);return this._proxy.$registerDeclarationSupport(se,this._transformDocumentSelector(G)),this._createDisposable(se)}$provideDeclaration(O,G,X,se){return this._withAdapter(O,r,q=>q.provideDeclaration(g.URI.revive(G),X,se),[])}registerImplementationProvider(O,G,X){const se=this._addNewAdapter(new s(this._documents,X),O);return this._proxy.$registerImplementationSupport(se,this._transformDocumentSelector(G)),this._createDisposable(se)}$provideImplementation(O,G,X,se){return this._withAdapter(O,s,q=>q.provideImplementation(g.URI.revive(G),X,se),[])}registerTypeDefinitionProvider(O,G,X){const se=this._addNewAdapter(new i(this._documents,X),O);return this._proxy.$registerTypeDefinitionSupport(se,this._transformDocumentSelector(G)),this._createDisposable(se)}$provideTypeDefinition(O,G,X,se){return this._withAdapter(O,i,q=>q.provideTypeDefinition(g.URI.revive(G),X,se),[])}registerHoverProvider(O,G,X,se){const q=this._addNewAdapter(new u(this._documents,X),O);return this._proxy.$registerHoverProvider(q,this._transformDocumentSelector(G)),this._createDisposable(q)}$provideHover(O,G,X,se){return this._withAdapter(O,u,q=>q.provideHover(g.URI.revive(G),X,se),void 0)}registerEvaluatableExpressionProvider(O,G,X,se){const q=this._addNewAdapter(new f(this._documents,X),O);return this._proxy.$registerEvaluatableExpressionProvider(q,this._transformDocumentSelector(G)),this._createDisposable(q)}$provideEvaluatableExpression(O,G,X,se){return this._withAdapter(O,f,q=>q.provideEvaluatableExpression(g.URI.revive(G),X,se),void 0)}registerInlineValuesProvider(O,G,X,se){const q=typeof X.onDidChangeInlineValues=="function"?this._nextHandle():void 0,ie=this._addNewAdapter(new v(this._documents,X),O);this._proxy.$registerInlineValuesProvider(ie,this._transformDocumentSelector(G),q);let ge=this._createDisposable(ie);if(q!==void 0){const Le=X.onDidChangeInlineValues(We=>this._proxy.$emitInlineValuesEvent(q));ge=_.Disposable.from(ge,Le)}return ge}$provideInlineValues(O,G,X,se,q){return this._withAdapter(O,v,ie=>ie.provideInlineValues(g.URI.revive(G),X,se,q),void 0)}registerDocumentHighlightProvider(O,G,X){const se=this._addNewAdapter(new D(this._documents,X),O);return this._proxy.$registerDocumentHighlightProvider(se,this._transformDocumentSelector(G)),this._createDisposable(se)}$provideDocumentHighlights(O,G,X,se){return this._withAdapter(O,D,q=>q.provideDocumentHighlights(g.URI.revive(G),X,se),void 0)}registerLinkedEditingRangeProvider(O,G,X){const se=this._addNewAdapter(new T(this._documents,X),O);return this._proxy.$registerLinkedEditingRangeProvider(se,this._transformDocumentSelector(G)),this._createDisposable(se)}$provideLinkedEditingRanges(O,G,X,se){return this._withAdapter(O,T,async q=>{const ie=await q.provideLinkedEditingRanges(g.URI.revive(G),X,se);if(ie)return{ranges:ie.ranges,wordPattern:ie.wordPattern?Ve._serializeRegExp(ie.wordPattern):void 0}},void 0)}registerReferenceProvider(O,G,X){const se=this._addNewAdapter(new o(this._documents,X),O);return this._proxy.$registerReferenceSupport(se,this._transformDocumentSelector(G)),this._createDisposable(se)}$provideReferences(O,G,X,se,q){return this._withAdapter(O,o,ie=>ie.provideReferences(g.URI.revive(G),X,se,q),void 0)}registerCodeActionProvider(O,G,X,se){const q=new l.DisposableStore,ie=this._addNewAdapter(new A(this._documents,this._commands.converter,this._diagnostics,X,this._logService,O,this._apiDeprecation),O);return this._proxy.$registerQuickFixSupport(ie,this._transformDocumentSelector(G),{providedKinds:se?.providedCodeActionKinds?.map(ge=>ge.value),documentation:se?.documentation?.map(ge=>({kind:ge.kind.value,command:this._commands.converter.toInternal(ge.command,q)}))},Ve._extLabel(O),Boolean(X.resolveCodeAction)),q.add(this._createDisposable(ie)),q}$provideCodeActions(O,G,X,se,q){return this._withAdapter(O,A,ie=>ie.provideCodeActions(g.URI.revive(G),X,se,q),void 0)}$resolveCodeAction(O,G,X){return this._withAdapter(O,A,se=>se.resolveCodeAction(G,X),void 0)}$releaseCodeActions(O,G){this._withAdapter(O,A,X=>Promise.resolve(X.releaseCodeActions(G)),void 0)}registerDocumentFormattingEditProvider(O,G,X){const se=this._addNewAdapter(new L(this._documents,X),O);return this._proxy.$registerDocumentFormattingSupport(se,this._transformDocumentSelector(G),O.identifier,O.displayName||O.name),this._createDisposable(se)}$provideDocumentFormattingEdits(O,G,X,se){return this._withAdapter(O,L,q=>q.provideDocumentFormattingEdits(g.URI.revive(G),X,se),void 0)}registerDocumentRangeFormattingEditProvider(O,G,X){const se=this._addNewAdapter(new B(this._documents,X),O);return this._proxy.$registerRangeFormattingSupport(se,this._transformDocumentSelector(G),O.identifier,O.displayName||O.name),this._createDisposable(se)}$provideDocumentRangeFormattingEdits(O,G,X,se,q){return this._withAdapter(O,B,ie=>ie.provideDocumentRangeFormattingEdits(g.URI.revive(G),X,se,q),void 0)}registerOnTypeFormattingEditProvider(O,G,X,se){const q=this._addNewAdapter(new oe(this._documents,X),O);return this._proxy.$registerOnTypeFormattingSupport(q,this._transformDocumentSelector(G),se,O.identifier),this._createDisposable(q)}$provideOnTypeFormattingEdits(O,G,X,se,q,ie){return this._withAdapter(O,oe,ge=>ge.provideOnTypeFormattingEdits(g.URI.revive(G),X,se,q,ie),void 0)}registerWorkspaceSymbolProvider(O,G){const X=this._addNewAdapter(new he(G,this._logService),O);return this._proxy.$registerNavigateTypeSupport(X),this._createDisposable(X)}$provideWorkspaceSymbols(O,G,X){return this._withAdapter(O,he,se=>se.provideWorkspaceSymbols(G,X),{symbols:[]})}$resolveWorkspaceSymbol(O,G,X){return this._withAdapter(O,he,se=>se.resolveWorkspaceSymbol(G,X),void 0)}$releaseWorkspaceSymbols(O,G){this._withAdapter(O,he,X=>X.releaseWorkspaceSymbols(G),void 0)}registerRenameProvider(O,G,X){const se=this._addNewAdapter(new Q(this._documents,X,this._logService),O);return this._proxy.$registerRenameSupport(se,this._transformDocumentSelector(G),Q.supportsResolving(X)),this._createDisposable(se)}$provideRenameEdits(O,G,X,se,q){return this._withAdapter(O,Q,ie=>ie.provideRenameEdits(g.URI.revive(G),X,se,q),void 0)}$resolveRenameLocation(O,G,X,se){return this._withAdapter(O,Q,q=>q.resolveRenameLocation(g.URI.revive(G),X,se),void 0)}registerDocumentSemanticTokensProvider(O,G,X,se){const q=this._nextHandle(),ie=typeof X.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(q,new Je(new V(this._documents,X),O)),this._proxy.$registerDocumentSemanticTokensProvider(q,this._transformDocumentSelector(G),se,ie);let ge=this._createDisposable(q);if(ie){const Le=X.onDidChangeSemanticTokens(We=>this._proxy.$emitDocumentSemanticTokensEvent(ie));ge=_.Disposable.from(ge,Le)}return ge}$provideDocumentSemanticTokens(O,G,X,se){return this._withAdapter(O,V,q=>q.provideDocumentSemanticTokens(g.URI.revive(G),X,se),null,!0)}$releaseDocumentSemanticTokens(O,G){this._withAdapter(O,V,X=>X.releaseDocumentSemanticColoring(G),void 0)}registerDocumentRangeSemanticTokensProvider(O,G,X,se){const q=this._addNewAdapter(new R(this._documents,X),O);return this._proxy.$registerDocumentRangeSemanticTokensProvider(q,this._transformDocumentSelector(G),se),this._createDisposable(q)}$provideDocumentRangeSemanticTokens(O,G,X,se){return this._withAdapter(O,R,q=>q.provideDocumentRangeSemanticTokens(g.URI.revive(G),X,se),null,!0)}registerCompletionItemProvider(O,G,X,se){const q=this._addNewAdapter(new K(this._documents,this._commands.converter,X,this._apiDeprecation,O),O);return this._proxy.$registerSuggestSupport(q,this._transformDocumentSelector(G),se,K.supportsResolving(X),`${O.identifier.value}(${se.join("")})`),this._createDisposable(q)}$provideCompletionItems(O,G,X,se,q){return this._withAdapter(O,K,ie=>ie.provideCompletionItems(g.URI.revive(G),X,se,q),void 0)}$resolveCompletionItem(O,G,X){return this._withAdapter(O,K,se=>se.resolveCompletionItem(G,X),void 0)}$releaseCompletionItems(O,G){this._withAdapter(O,K,X=>X.releaseCompletionItems(G),void 0)}registerInlineCompletionsProvider(O,G,X){const se=this._addNewAdapter(new x(this._documents,X,this._commands.converter),O);return this._proxy.$registerInlineCompletionsSupport(se,this._transformDocumentSelector(G)),this._createDisposable(se)}$provideInlineCompletions(O,G,X,se,q){return this._withAdapter(O,x,ie=>ie.provideInlineCompletions(g.URI.revive(G),X,se,q),void 0)}$handleInlineCompletionDidShow(O,G,X){this._withAdapter(O,x,async se=>{se.handleDidShowCompletionItem(G,X)},void 0)}$freeInlineCompletionsList(O,G){this._withAdapter(O,x,async X=>{X.disposeCompletions(G)},void 0)}registerSignatureHelpProvider(O,G,X,se){const q=Array.isArray(se)?{triggerCharacters:se,retriggerCharacters:[]}:se,ie=this._addNewAdapter(new ue(this._documents,X),O);return this._proxy.$registerSignatureHelpProvider(ie,this._transformDocumentSelector(G),q),this._createDisposable(ie)}$provideSignatureHelp(O,G,X,se,q){return this._withAdapter(O,ue,ie=>ie.provideSignatureHelp(g.URI.revive(G),X,se,q),void 0)}$releaseSignatureHelp(O,G){this._withAdapter(O,ue,X=>X.releaseSignatureHelp(G),void 0)}registerInlayHintsProvider(O,G,X){const se=typeof X.onDidChangeInlayHints=="function"?this._nextHandle():void 0,q=this._addNewAdapter(new $(this._documents,X),O);this._proxy.$registerInlayHintsProvider(q,this._transformDocumentSelector(G),se);let ie=this._createDisposable(q);if(se!==void 0){const ge=X.onDidChangeInlayHints(Le=>this._proxy.$emitInlayHintsEvent(se));ie=_.Disposable.from(ie,ge)}return ie}$provideInlayHints(O,G,X,se){return this._withAdapter(O,$,q=>q.provideInlayHints(g.URI.revive(G),X,se),void 0)}registerDocumentLinkProvider(O,G,X){const se=this._addNewAdapter(new te(this._documents,X),O);return this._proxy.$registerDocumentLinkProvider(se,this._transformDocumentSelector(G),typeof X.resolveDocumentLink=="function"),this._createDisposable(se)}$provideDocumentLinks(O,G,X){return this._withAdapter(O,te,se=>se.provideLinks(g.URI.revive(G),X),void 0)}$resolveDocumentLink(O,G,X){return this._withAdapter(O,te,se=>se.resolveLink(G,X),void 0)}$releaseDocumentLinks(O,G){this._withAdapter(O,te,X=>X.releaseLinks(G),void 0)}registerColorProvider(O,G,X){const se=this._addNewAdapter(new ce(this._documents,X),O);return this._proxy.$registerDocumentColorProvider(se,this._transformDocumentSelector(G)),this._createDisposable(se)}$provideDocumentColors(O,G,X){return this._withAdapter(O,ce,se=>se.provideColors(g.URI.revive(G),X),[])}$provideColorPresentations(O,G,X,se){return this._withAdapter(O,ce,q=>q.provideColorPresentations(g.URI.revive(G),X,se),void 0)}registerFoldingRangeProvider(O,G,X){const se=this._nextHandle(),q=typeof X.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(se,new Je(new ye(this._documents,X),O)),this._proxy.$registerFoldingRangeProvider(se,this._transformDocumentSelector(G),q);let ie=this._createDisposable(se);if(q!==void 0){const ge=X.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(q));ie=_.Disposable.from(ie,ge)}return ie}$provideFoldingRanges(O,G,X,se){return this._withAdapter(O,ye,q=>q.provideFoldingRanges(g.URI.revive(G),X,se),void 0)}registerSelectionRangeProvider(O,G,X){const se=this._addNewAdapter(new Re(this._documents,X,this._logService),O);return this._proxy.$registerSelectionRangeProvider(se,this._transformDocumentSelector(G)),this._createDisposable(se)}$provideSelectionRanges(O,G,X,se){return this._withAdapter(O,Re,q=>q.provideSelectionRanges(g.URI.revive(G),X,se),[])}registerCallHierarchyProvider(O,G,X){const se=this._addNewAdapter(new Te(this._documents,X),O);return this._proxy.$registerCallHierarchyProvider(se,this._transformDocumentSelector(G)),this._createDisposable(se)}$prepareCallHierarchy(O,G,X,se){return this._withAdapter(O,Te,q=>Promise.resolve(q.prepareSession(g.URI.revive(G),X,se)),void 0)}$provideCallHierarchyIncomingCalls(O,G,X,se){return this._withAdapter(O,Te,q=>q.provideCallsTo(G,X,se),void 0)}$provideCallHierarchyOutgoingCalls(O,G,X,se){return this._withAdapter(O,Te,q=>q.provideCallsFrom(G,X,se),void 0)}$releaseCallHierarchy(O,G){this._withAdapter(O,Te,X=>Promise.resolve(X.releaseSession(G)),void 0)}registerTypeHierarchyProvider(O,G,X){const se=this._addNewAdapter(new $e(this._documents,X),O);return this._proxy.$registerTypeHierarchyProvider(se,this._transformDocumentSelector(G)),this._createDisposable(se)}$prepareTypeHierarchy(O,G,X,se){return this._withAdapter(O,$e,q=>Promise.resolve(q.prepareSession(g.URI.revive(G),X,se)),void 0)}$provideTypeHierarchySupertypes(O,G,X,se){return this._withAdapter(O,$e,q=>q.provideSupertypes(G,X,se),void 0)}$provideTypeHierarchySubtypes(O,G,X,se){return this._withAdapter(O,$e,q=>q.provideSubtypes(G,X,se),void 0)}$releaseTypeHierarchy(O,G){this._withAdapter(O,$e,X=>Promise.resolve(X.releaseSession(G)),void 0)}static _serializeRegExp(O){return{pattern:O.source,flags:(0,y.regExpFlags)(O)}}static _serializeIndentationRule(O){return{decreaseIndentPattern:Ve._serializeRegExp(O.decreaseIndentPattern),increaseIndentPattern:Ve._serializeRegExp(O.increaseIndentPattern),indentNextLinePattern:O.indentNextLinePattern?Ve._serializeRegExp(O.indentNextLinePattern):void 0,unIndentedLinePattern:O.unIndentedLinePattern?Ve._serializeRegExp(O.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(O){return{beforeText:Ve._serializeRegExp(O.beforeText),afterText:O.afterText?Ve._serializeRegExp(O.afterText):void 0,previousLineText:O.previousLineText?Ve._serializeRegExp(O.previousLineText):void 0,action:O.action}}static _serializeOnEnterRules(O){return O.map(Ve._serializeOnEnterRule)}setLanguageConfiguration(O,G,X){let{wordPattern:se}=X;if(se&&(0,y.regExpLeadsToEndlessLoop)(se))throw new Error(`Invalid language configuration: wordPattern '${se}' is not allowed to match the empty string.`);se?this._documents.setWordDefinitionFor(G,se):this._documents.setWordDefinitionFor(G,void 0),X.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",O,"Do not use."),X.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",O,"Do not use.");const q=this._nextHandle(),ie={comments:X.comments,brackets:X.brackets,wordPattern:X.wordPattern?Ve._serializeRegExp(X.wordPattern):void 0,indentationRules:X.indentationRules?Ve._serializeIndentationRule(X.indentationRules):void 0,onEnterRules:X.onEnterRules?Ve._serializeOnEnterRules(X.onEnterRules):void 0,__electricCharacterSupport:X.__electricCharacterSupport,__characterPairSupport:X.__characterPairSupport};return this._proxy.$setLanguageConfiguration(q,G,ie),this._createDisposable(q)}$setWordDefinitions(O){for(const G of O)this._documents.setWordDefinitionFor(G.languageId,new RegExp(G.regexSource,G.regexFlags))}}e.ExtHostLanguageFeatures=Ve,Ve._handlePool=0}),define(be[201],Ee([0,1,5,9,7]),function(ee,e,g,F,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class _{constructor(y,b){this._proxy=y.getProxy(g.MainContext.MainThreadLanguages),this._documents=b}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(y,b){await this._proxy.$changeLanguage(y,b);const k=this._documents.getDocumentData(y);if(!k)throw new Error(`document '${y.toString}' NOT found`);return k.document}async tokenAtPosition(y,b){const k=y.version,n=F.Position.from(b),I=await this._proxy.$tokensAtPosition(y.uri,n),l={type:S.StandardTokenType.Other,range:y.getWordRangeAtPosition(b)??new S.Range(b.line,b.character,b.line,b.character)};if(!I)return l;const d={range:F.Range.to(I.range),type:F.TokenType.to(I.type)};return!d.range.contains(b)||k!==y.version?l:d}}e.ExtHostLanguages=_}),define(be[202],Ee([0,1,5,15,30]),function(ee,e,g,F,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function _(y){return y&&y.title}let C=class{constructor(b,k){this._logService=k,this._proxy=b.getProxy(g.MainContext.MainThreadMessageService)}showMessage(b,k,n,I,l){const d={extension:b};let c;typeof I=="string"||_(I)?c=[I,...l]:(d.modal=I?.modal,d.useCustom=I?.useCustom,d.detail=I?.detail,c=l),d.useCustom&&(0,S.checkProposedApiEnabled)(b);const m=[];for(let E=0;E<c.length;E++){const w=c[E];if(typeof w=="string")m.push({title:w,handle:E,isCloseAffordance:!1});else if(typeof w=="object"){let{title:P,isCloseAffordance:a}=w;m.push({title:P,isCloseAffordance:!!a,handle:E})}else this._logService.warn("Invalid message item:",w)}return this._proxy.$showMessage(k,n,d,m).then(E=>{if(typeof E=="number")return c[E]})}};C=ze([qe(1,F.ILogService)],C),e.ExtHostMessageService=C}),define(be[203],Ee([0,1,24,3,42,6,21,8,10,2,65,5,9,7,180,101]),function(ee,e,g,F,S,_,C,y,b,k,n,I,l,d,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class E{constructor(P,a,h,p,t){this._textDocumentsAndEditors=h,this._textDocuments=p,this._extensionStoragePaths=t,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new C.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new F.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new F.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new F.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new F.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new F.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new F.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new F.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new F.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new n.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=P.getProxy(I.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=P.getProxy(I.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=P.getProxy(I.MainContext.MainThreadNotebookEditors),this._commandsConverter=a.converter,a.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===12){const s=r.notebookEditor?.notebookUri,i=r.cell.handle,f=this._documents.get(s)?.getCell(i);if(f)return f.apiCell}return r}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(P=>P.apiEditor)}getEditorById(P){const a=this._editors.get(P);if(!a)throw new Error(`unknown text editor: ${P}. known editors: ${[...this._editors.keys()]} `);return a}getIdByEditor(P){for(const[a,h]of this._editors)if(h.apiEditor===P)return a}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(P,a){const h=this._documents.get(P);if(!h&&!a)throw new Error(`NO notebook document for '${P}'`);return h}_getProviderData(P){const a=this._notebookContentProviders.get(P);if(!a)throw new Error(`NO provider for '${P}'`);return a}registerNotebookContentProvider(P,a,h,p,t){if((0,y.isFalsyOrWhitespace)(a))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(a))throw new Error(`Notebook provider for '${a}' already registered`);this._notebookContentProviders.set(a,{extension:P,provider:h});let r;return h.onDidChangeNotebookContentOptions&&(r=h.onDidChangeNotebookContentOptions(()=>{const s=l.NotebookDocumentContentOptions.from(h.options);this._notebookProxy.$updateNotebookProviderOptions(a,s)})),this._notebookProxy.$registerNotebookProvider({id:P.identifier,location:P.extensionLocation},a,l.NotebookDocumentContentOptions.from(p),E._convertNotebookRegistrationData(P,t)),new d.Disposable(()=>{r?.dispose(),this._notebookContentProviders.delete(a),this._notebookProxy.$unregisterNotebookProvider(a)})}static _convertNotebookRegistrationData(P,a){if(!a)return;const h=a.filenamePattern.map(p=>l.NotebookExclusiveDocumentPattern.from(p)).filter(p=>p!==void 0);if(a.filenamePattern&&!h){console.warn(`Notebook content provider view options file name pattern is invalid ${a.filenamePattern}`);return}return{extension:P.identifier,providerDisplayName:P.displayName||P.name,displayName:a.displayName,filenamePattern:h,exclusive:a.exclusive||!1}}registerNotebookCellStatusBarItemProvider(P,a,h){const p=E._notebookStatusBarItemProviderHandlePool++,t=typeof h.onDidChangeCellStatusBarItems=="function"?E._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(p,h),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(p,t,a);let r;return t!==void 0&&(r=h.onDidChangeCellStatusBarItems(s=>this._notebookProxy.$emitCellStatusBarEvent(t))),new d.Disposable(()=>{this._notebookStatusBarItemProviders.delete(p),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(p,t),r&&r.dispose()})}async createNotebookDocument(P){const a=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:P.viewType,content:P.content&&l.NotebookData.from(P.content)});return k.URI.revive(a)}async openNotebookDocument(P){const a=this._documents.get(P);if(a)return a.apiNotebook;const h=await this._notebookDocumentsProxy.$tryOpenNotebook(P),p=this._documents.get(k.URI.revive(h));return(0,b.assertIsDefined)(p?.apiNotebook)}async showNotebookDocument(P,a){k.URI.isUri(P)&&(P=await this.openNotebookDocument(P));let h;typeof a=="object"?h={position:l.ViewColumn.from(a.viewColumn),preserveFocus:a.preserveFocus,selections:a.selections&&a.selections.map(l.NotebookRange.from),pinned:typeof a.preview=="boolean"?!a.preview:void 0}:h={preserveFocus:!1};const p=await this._notebookEditorsProxy.$tryShowNotebookDocument(P.uri,P.notebookType,h),t=p&&this._editors.get(p)?.apiEditor;if(t)return t;throw p?new Error(`Could NOT open editor for "${P.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${P.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(P,a,h,p){const t=this._notebookStatusBarItemProviders.get(P),r=k.URI.revive(a),s=this._documents.get(r);if(!s||!t)return;const i=s.getCellFromIndex(h);if(!i)return;const u=await t.provideCellStatusBarItems(i.apiCell,p);if(!u)return;const f=new _.DisposableStore,v=this._statusBarCache.add([f]),T=(Array.isArray(u)?u:[u]).map(o=>l.NotebookStatusBarItem.from(o,this._commandsConverter,f));return{cacheId:v,items:T}}$releaseNotebookCellStatusBarItems(P){this._statusBarCache.delete(P)}registerNotebookSerializer(P,a,h,p,t){if((0,y.isFalsyOrWhitespace)(a))throw new Error("viewType cannot be empty or just whitespace");const r=this._handlePool++;return this._notebookSerializer.set(r,h),this._notebookProxy.$registerNotebookSerializer(r,{id:P.identifier,location:P.extensionLocation},a,l.NotebookDocumentContentOptions.from(p),E._convertNotebookRegistrationData(P,t)),(0,_.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(r)})}async $dataToNotebook(P,a,h){const p=this._notebookSerializer.get(P);if(!p)throw new Error("NO serializer found");const t=await p.deserializeNotebook(a.buffer,h);return l.NotebookData.from(t)}async $notebookToData(P,a,h){const p=this._notebookSerializer.get(P);if(!p)throw new Error("NO serializer found");const t=await p.serializeNotebook(l.NotebookData.to(a),h);return g.VSBuffer.wrap(t)}async $openNotebook(P,a,h,p,t){const{provider:r}=this._getProviderData(P),s=await r.openNotebook(k.URI.revive(a),{backupId:h,untitledDocumentData:p?.buffer},t);return{metadata:s.metadata??Object.create(null),cells:s.cells.map(l.NotebookCellData.from)}}async $saveNotebook(P,a,h){const p=this.getNotebookDocument(k.URI.revive(a)),{provider:t}=this._getProviderData(P);return await t.saveNotebook(p.apiNotebook,h),!0}async $saveNotebookAs(P,a,h,p){const t=this.getNotebookDocument(k.URI.revive(a)),{provider:r}=this._getProviderData(P);return await r.saveNotebookAs(k.URI.revive(h),t.apiNotebook,p),!0}async $backupNotebook(P,a,h){const p=this.getNotebookDocument(k.URI.revive(a)),t=this._getProviderData(P),r=this._extensionStoragePaths.workspaceValue(t.extension)??this._extensionStoragePaths.globalValue(t.extension),s=String((0,S.hash)([p.uri.toString(),this._backupIdPool++])),i=k.URI.joinPath(r,s),u=await t.provider.backupNotebook(p.apiNotebook,{destination:i},h);return p.updateBackup(u),u.id}_createExtHostEditor(P,a,h){if(this._editors.has(a))throw new Error(`editor with id ALREADY EXSIST: ${a}`);const p=new m.ExtHostNotebookEditor(a,this._notebookEditorsProxy,P,h.visibleRanges.map(l.NotebookRange.to),h.selections.map(l.NotebookRange.to),typeof h.viewColumn=="number"?l.ViewColumn.to(h.viewColumn):void 0);this._editors.set(a,p)}$acceptDocumentAndEditorsDelta(P){if(P.removedDocuments)for(const h of P.removedDocuments){const p=k.URI.revive(h),t=this._documents.get(p);t&&(t.dispose(),this._documents.delete(p),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:t.apiNotebook.getCells().map(r=>r.document.uri)}),this._onDidCloseNotebookDocument.fire(t.apiNotebook));for(const r of this._editors.values())r.notebookData.uri.toString()===p.toString()&&this._editors.delete(r.id)}if(P.addedDocuments){const h=[];for(const p of P.addedDocuments){const t=k.URI.revive(p.uri);if(this._documents.has(t))throw new Error(`adding EXISTING notebook ${t} `);const r=this,s=new c.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(i){r._onDidChangeNotebookCells.fire(i)},emitCellOutputsChange(i){r._onDidChangeCellOutputs.fire(i)},emitCellMetadataChange(i){r._onDidChangeCellMetadata.fire(i)},emitCellExecutionStateChange(i){r._onDidChangeCellExecutionState.fire(i)}},t,p);h.push(...p.cells.map(i=>c.ExtHostCell.asModelAddData(s.apiNotebook,i))),this._documents.get(t)?.dispose(),this._documents.set(t,s),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:h}),this._onDidOpenNotebookDocument.fire(s.apiNotebook)}}if(P.addedEditors)for(const h of P.addedEditors){if(this._editors.has(h.id))return;const p=k.URI.revive(h.documentUri),t=this._documents.get(p);t&&this._createExtHostEditor(t,h.id,h)}const a=[];if(P.removedEditors)for(const h of P.removedEditors){const p=this._editors.get(h);p&&(this._editors.delete(h),this._activeNotebookEditor?.id===p.id&&(this._activeNotebookEditor=void 0),a.push(p))}if(P.visibleEditors){this._visibleNotebookEditors=P.visibleEditors.map(p=>this._editors.get(p)).filter(p=>!!p);const h=new Set;this._visibleNotebookEditors.forEach(p=>h.add(p.id));for(const p of this._editors.values()){const t=h.has(p.id);p._acceptVisibility(t)}this._visibleNotebookEditors=[...this._editors.values()].map(p=>p).filter(p=>p.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}P.newActiveEditor===null?this._activeNotebookEditor=void 0:P.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(P.newActiveEditor)),P.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=E,E._notebookStatusBarItemProviderHandlePool=0}),define(be[204],Ee([0,1,3,53,15,5,13,9]),function(ee,e,g,F,S,_,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class b{constructor(I,l){const d=b._Keys.nextId();I.$registerNotebookEditorDecorationType(d,y.NotebookDecorationRenderOptions.from(l)),this.value={key:d,dispose(){I.$removeNotebookEditorDecorationType(d)}}}}b._Keys=new F.IdGenerator("NotebookEditorDecorationType");let k=class{constructor(I,l,d){this._logService=I,this._extHostRpc=l,this._notebooksAndEditors=d,this._onDidChangeNotebookEditorSelection=new g.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new g.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(I){return new b(this._extHostRpc.getProxy(_.MainContext.MainThreadNotebookEditors),I).value}$acceptEditorPropertiesChanged(I,l){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",I,l);const d=this._notebooksAndEditors.getEditorById(I);l.visibleRanges&&d._acceptVisibleRanges(l.visibleRanges.ranges.map(y.NotebookRange.to)),l.selections&&d._acceptSelections(l.selections.selections.map(y.NotebookRange.to)),l.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:d.apiEditor,visibleRanges:d.apiEditor.visibleRanges}),l.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:d.apiEditor,selections:d.apiEditor.selections}))}$acceptEditorViewColumns(I){for(const l in I)this._notebooksAndEditors.getEditorById(l)._acceptViewColumn(y.ViewColumn.to(I[l]))}};k=ze([qe(0,S.ILogService),qe(1,C.IExtHostRpcService)],k),e.ExtHostNotebookEditors=k}),define(be[205],Ee([0,1,3,6,5,26,2,9,70,21,16,71,20,17,15,7,30]),function(ee,e,g,F,S,_,C,y,b,k,n,I,l,d,c,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let w=class{constructor(t,r,s,i){this._initData=r,this._extHostNotebook=s,this._logService=i,this._activeExecutions=new k.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=t.getProxy(S.MainContext.MainThreadNotebookKernels)}createNotebookController(t,r,s,i,u,f){for(let x of this._kernelData.values())if(x.controller.id===r&&_.ExtensionIdentifier.equals(t.identifier,x.extensionId))throw new Error(`notebook controller with id '${r}' ALREADY exist`);const v=this._handlePool++,D=this;this._logService.trace(`NotebookController[${v}], CREATED by ${t.identifier.value}, ${r}`);const T=()=>console.warn(`NO execute handler from notebook controller '${oe.id}' of extension: '${t.identifier}'`);let o=!1;const A=new F.DisposableStore,L=new g.Emitter,B=new g.Emitter,oe={id:`${t.identifier.value}/${r}`,notebookType:s,extensionId:t.identifier,extensionLocation:t.extensionLocation,label:i||t.identifier.value,preloads:f?f.map(y.NotebookRendererScript.from):[]};let he=u??T,Q;this._proxy.$addKernel(v,oe).catch(x=>{console.log(x),o=!0});let z=0;const V=()=>{if(o)return;const x=++z;Promise.resolve().then(()=>{x===z&&this._proxy.$updateKernel(v,oe)})},R=new k.ResourceMap,K={get id(){return r},get notebookType(){return oe.notebookType},onDidChangeSelectedNotebooks:L.event,get label(){return oe.label},set label(x){oe.label=x??t.displayName??t.name,V()},get detail(){return oe.detail??""},set detail(x){oe.detail=x,V()},get description(){return oe.description??""},set description(x){oe.description=x,V()},get supportedLanguages(){return oe.supportedLanguages},set supportedLanguages(x){oe.supportedLanguages=x,V()},get supportsExecutionOrder(){return oe.supportsExecutionOrder??!1},set supportsExecutionOrder(x){oe.supportsExecutionOrder=x,V()},get rendererScripts(){return oe.preloads?oe.preloads.map(y.NotebookRendererScript.to):[]},get executeHandler(){return he},set executeHandler(x){he=x??T},get interruptHandler(){return Q},set interruptHandler(x){Q=x,oe.supportsInterrupt=Boolean(x),V()},createNotebookCellExecution(x){if(o)throw new Error("notebook controller is DISPOSED");if(!R.has(x.notebook.uri))throw D._logService.trace(`NotebookController[${v}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(R.keys()).map(j=>j.toString())),new Error(`notebook controller is NOT associated to notebook: ${x.notebook.uri.toString()}`);return D._createNotebookCellExecution(x)},dispose:()=>{o||(this._logService.trace(`NotebookController[${v}], DISPOSED`),o=!0,this._kernelData.delete(v),A.dispose(),L.dispose(),B.dispose(),this._proxy.$removeKernel(v))},updateNotebookAffinity(x,j){D._proxy.$updateNotebookPriority(v,x.uri,j)},onDidReceiveMessage:B.event,postMessage(x,j){return(0,E.checkProposedApiEnabled)(t),D._proxy.$postMessage(v,j&&D._extHostNotebook.getIdByEditor(j),x)},asWebviewUri(x){return(0,E.checkProposedApiEnabled)(t),(0,b.asWebviewUri)(x,D._initData.remote)}};return this._kernelData.set(v,{extensionId:t.identifier,controller:K,onDidReceiveMessage:B,onDidChangeSelection:L,associatedNotebooks:R}),K}$acceptNotebookAssociation(t,r,s){const i=this._kernelData.get(t);if(i){const u=this._extHostNotebook.getNotebookDocument(C.URI.revive(r));s?i.associatedNotebooks.set(u.uri,!0):i.associatedNotebooks.delete(u.uri),this._logService.trace(`NotebookController[${t}] ASSOCIATE notebook`,u.uri.toString(),s),i.onDidChangeSelection.fire({selected:s,notebook:u.apiNotebook})}}async $executeCells(t,r,s){const i=this._kernelData.get(t);if(!i)return;const u=this._extHostNotebook.getNotebookDocument(C.URI.revive(r)),f=[];for(let v of s){const D=u.getCell(v);D&&f.push(D.apiCell)}try{this._logService.trace(`NotebookController[${t}] EXECUTE cells`,u.uri.toString(),f.length),await i.controller.executeHandler.call(i.controller,f,u.apiNotebook,i.controller)}catch(v){this._logService.error(`NotebookController[${t}] execute cells FAILED`,v),console.error(v)}}async $cancelCells(t,r,s){const i=this._kernelData.get(t);if(!i)return;const u=this._extHostNotebook.getNotebookDocument(C.URI.revive(r));if(i.controller.interruptHandler)await i.controller.interruptHandler.call(i.controller,u.apiNotebook);else for(let f of s){const v=u.getCell(f);v&&this._activeExecutions.get(v.uri)?.cancel()}}$acceptKernelMessageFromRenderer(t,r,s){const i=this._kernelData.get(t);if(!i)return;const u=this._extHostNotebook.getEditorById(r);i.onDidReceiveMessage.fire(Object.freeze({editor:u.apiEditor,message:s}))}_createNotebookCellExecution(t){if(t.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const s=this._extHostNotebook.getNotebookDocument(t.notebook.uri).getCellFromApiCell(t);if(!s)throw new Error("invalid cell");if(this._activeExecutions.has(s.uri))throw new Error(`duplicate execution for ${s.uri}`);const i=new a(s.notebook,s,this._proxy);this._activeExecutions.set(s.uri,i);const u=i.onDidChangeState(()=>{i.state===P.Resolved&&(i.dispose(),u.dispose(),this._activeExecutions.delete(s.uri))});return i.asApiObject()}};w=ze([qe(3,c.ILogService)],w),e.ExtHostNotebookKernels=w;var P;(function(p){p[p.Init=0]="Init",p[p.Started=1]="Started",p[p.Resolved=2]="Resolved"})(P||(P={}));class a extends F.Disposable{constructor(t,r,s){super();this._document=t,this._cell=r,this._proxy=s,this._onDidChangeState=new g.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=P.Init,this._tokenSource=this._register(new l.CancellationTokenSource),this._collector=new h(10,i=>this.applyEdits(i)),this._executionOrder=r.internalMetadata.executionOrder,this.mixinMetadata({runState:I.NotebookCellExecutionState.Pending,executionOrder:null})}get state(){return this._state}cancel(){this._tokenSource.cancel()}async applyEditSoon(t){await this._collector.addItem(t)}async applyEdits(t){return this._proxy.$applyExecutionEdits(this._document.uri,t)}verifyStateForOutput(){if(this._state===P.Init)throw new Error("Must call start before modifying cell output");if(this._state===P.Resolved)throw new Error("Cannot modify cell output after calling resolve")}mixinMetadata(t){this.applyEdits([{editType:9,handle:this._cell.handle,internalMetadata:t}])}cellIndexToHandle(t){let r=this._cell;if(t&&(r=this._document.getCellFromApiCell(t)),!r)throw new Error("INVALID cell");return r.handle}validateAndConvertOutputs(t){return t.map(r=>{const s=m.NotebookCellOutput.ensureUniqueMimeTypes(r.items,!0);return s===r.items?y.NotebookCellOutput.from(r):y.NotebookCellOutput.from({items:s,id:r.id,metadata:r.metadata})})}async updateOutputs(t,r,s){const i=this.cellIndexToHandle(r),u=this.validateAndConvertOutputs((0,d.asArray)(t));return this.applyEditSoon({editType:2,handle:i,append:s,outputs:u})}async updateOutputItems(t,r,s){return t=m.NotebookCellOutput.ensureUniqueMimeTypes((0,d.asArray)(t),!0),this.applyEditSoon({editType:7,items:t.map(y.NotebookCellOutputItem.from),outputId:r.id,append:s})}asApiObject(){const t=this;return Object.freeze({get token(){return t._tokenSource.token},get cell(){return t._cell.apiCell},get executionOrder(){return t._executionOrder},set executionOrder(s){t._executionOrder=s,t.mixinMetadata({executionOrder:s})},start(s){if(t._state===P.Resolved||t._state===P.Started)throw new Error("Cannot call start again");t._state=P.Started,t._onDidChangeState.fire(),t.mixinMetadata({runState:I.NotebookCellExecutionState.Executing,runStartTime:s??null})},end(s,i){if(t._state===P.Resolved)throw new Error("Cannot call resolve twice");t._state=P.Resolved,t._onDidChangeState.fire(),t.mixinMetadata({runState:null,lastRunSuccess:s??null,runEndTime:i??null})},clearOutput(s){return t.verifyStateForOutput(),t.updateOutputs([],s,!1)},appendOutput(s,i){return t.verifyStateForOutput(),t.updateOutputs(s,i,!0)},replaceOutput(s,i){return t.verifyStateForOutput(),t.updateOutputs(s,i,!1)},appendOutputItems(s,i){return t.verifyStateForOutput(),t.updateOutputItems(s,i,!0)},replaceOutputItems(s,i){return t.verifyStateForOutput(),t.updateOutputItems(s,i,!1)}})}}class h{constructor(t,r){this.delay=t,this.callback=r,this.batch=[]}addItem(t){return this.batch.push(t),this.waitPromise||(this.waitPromise=(0,n.timeout)(this.delay).then(()=>{this.waitPromise=void 0;const r=this.batch;return this.batch=[],this.callback(r)})),this.waitPromise}}}),define(be[206],Ee([0,1,3,5,101]),function(ee,e,g,F,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class _{constructor(y,b){this._extHostNotebook=b,this._rendererMessageEmitters=new Map,this.proxy=y.getProxy(F.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(y,b,k){const n=this._extHostNotebook.getEditorById(y);this._rendererMessageEmitters.get(b)?.fire({editor:n.apiEditor,message:k})}createRendererMessaging(y,b){if(!y.contributes?.notebookRenderer?.some(l=>l.id===b))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${b})`);const k=!!y.enableProposedApi,n=new WeakMap;return{onDidReceiveMessage:(l,d,c)=>{const m=k?l:E=>{const w={};n.set(w,E.editor),l({editor:w,message:E.message})};return this.getOrCreateEmitterFor(b).event(m,d,c)},postMessage:(l,d)=>{const c=k?l:n.get(l),m=c&&S.ExtHostNotebookEditor.apiEditorsToExtHost.get(c);if(!m)throw new Error("The first argument to postMessage() must be a NotebookEditor");return this.proxy.$postMessage(m.id,b,d)}}}getOrCreateEmitterFor(y){let b=this._rendererMessageEmitters.get(y);return b||(b=new g.Emitter({onLastListenerRemove:()=>{b?.dispose(),this._rendererMessageEmitters.delete(y)}}),this._rendererMessageEmitters.set(y,b),b)}}e.ExtHostNotebookRenderers=_}),define(be[105],Ee([0,1,5,3,6,24,4,13]),function(ee,e,g,F,S,_,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class b extends S.Disposable{constructor(c,m,E,w,P){super();this._onDidAppend=this._register(new F.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=c,this._proxy=P,this._id=P.$register(this.name,m,E,w),this._disposed=!1,this._offset=0}get name(){return this._name}append(c){this.validate(),this._offset+=c?_.VSBuffer.fromString(c).byteLength:0}update(){this._id.then(c=>this._proxy.$update(c))}appendLine(c){this.validate(),this.append(c+`
`)}clear(){this.validate();const c=this._offset;this._id.then(m=>this._proxy.$clear(m,c))}show(c,m){this.validate(),this._id.then(E=>this._proxy.$reveal(E,!!(typeof c=="boolean"?c:m)))}hide(){this.validate(),this._id.then(c=>this._proxy.$close(c))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(c=>this._proxy.$dispose(c)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=b;class k extends b{constructor(c,m,E){super(c,!1,void 0,m,E)}append(c){super.append(c),this._id.then(m=>this._proxy.$append(m,c)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=k;class n extends b{constructor(c,m,E){super(c,!0,m,void 0,E)}append(c){throw new Error("Not supported")}}class I{constructor(c,m){this.name=c,this._channel=m}append(c){this._channel.then(m=>m.append(c))}appendLine(c){this._channel.then(m=>m.appendLine(c))}clear(){this._channel.then(c=>c.clear())}show(c,m){this._channel.then(E=>E.show(c,m))}hide(){this._channel.then(c=>c.hide())}dispose(){this._channel.then(c=>c.dispose())}}e.LazyOutputChannel=I;let l=class{constructor(c){this._proxy=c.getProxy(g.MainContext.MainThreadOutputService)}$setVisibleChannel(c){}createOutputChannel(c,m){if(c=c.trim(),!c)throw new Error("illegal argument `name`. must not be falsy");return new k(c,m.identifier.value,this._proxy)}createOutputChannelFromLogFile(c,m){if(c=c.trim(),!c)throw new Error("illegal argument `name`. must not be falsy");if(!m)throw new Error("illegal argument `file`. must not be falsy");return new n(c,m,this._proxy)}};l=ze([qe(0,y.IExtHostRpcService)],l),e.ExtHostOutputService=l,e.IExtHostOutputService=(0,C.createDecorator)("IExtHostOutputService")}),define(be[207],Ee([0,1,16,20,3,6,5,2,7,12,17,43]),function(ee,e,g,F,S,_,C,y,b,k,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function l(d,c,m){const E=d.getProxy(C.MainContext.MainThreadQuickOpen);class w{constructor(i,u){this._sessions=new Map,this._instances=0,this._workspace=i,this._commands=u}showQuickPick(i,u,f,v=F.CancellationToken.None){this._onDidSelectItem=void 0;const D=Promise.resolve(i),T=++this._instances,o=E.$show(T,{title:f?.title,placeHolder:f?.placeHolder,matchOnDescription:f?.matchOnDescription,matchOnDetail:f?.matchOnDetail,ignoreFocusLost:f?.ignoreFocusOut,canPickMany:f?.canPickMany},v),A={},L=o.then(()=>A);return Promise.race([L,D]).then(B=>{if(B!==A)return D.then(oe=>{const he=[];for(let Q=0;Q<oe.length;Q++){const z=oe[Q];let V,R,K,x,j;typeof z=="string"?V=z:(V=z.label,R=z.description,K=z.detail,x=z.picked,j=z.alwaysShow),he.push({label:V,description:R,handle:Q,detail:K,picked:x,alwaysShow:j})}return f&&typeof f.onDidSelectItem=="function"&&(this._onDidSelectItem=Q=>{f.onDidSelectItem(oe[Q])}),E.$setItems(T,he),o.then(Q=>{if(typeof Q=="number")return oe[Q];if(Array.isArray(Q))return Q.map(z=>oe[z])})})}).then(void 0,B=>{if(!(0,k.isPromiseCanceledError)(B))return E.$setError(T,B),Promise.reject(B)})}$onItemSelected(i){this._onDidSelectItem&&this._onDidSelectItem(i)}showInput(i,u=F.CancellationToken.None){return this._validateInput=i?i.validateInput:void 0,E.$input(i,typeof this._validateInput=="function",u).then(void 0,f=>{if(!(0,k.isPromiseCanceledError)(f))return Promise.reject(f)})}$validateInput(i){return this._validateInput?(0,g.asPromise)(()=>this._validateInput(i)):Promise.resolve(void 0)}async showWorkspaceFolderPick(i,u=F.CancellationToken.None){const f=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[i]);if(!f)return;const v=await this._workspace.getWorkspaceFolders2();if(!!v)return v.find(D=>D.uri.toString()===f.uri.toString())}createQuickPick(i,u){const f=new t(i,u,()=>this._sessions.delete(f._id));return this._sessions.set(f._id,f),f}createInputBox(i){const u=new r(i,()=>this._sessions.delete(u._id));return this._sessions.set(u._id,u),u}$onDidChangeValue(i,u){const f=this._sessions.get(i);f&&f._fireDidChangeValue(u)}$onDidAccept(i){const u=this._sessions.get(i);u&&u._fireDidAccept()}$onDidChangeActive(i,u){const f=this._sessions.get(i);f instanceof t&&f._fireDidChangeActive(u)}$onDidChangeSelection(i,u){const f=this._sessions.get(i);f instanceof t&&f._fireDidChangeSelection(u)}$onDidTriggerButton(i,u){const f=this._sessions.get(i);f&&f._fireDidTriggerButton(u)}$onDidHide(i){const u=this._sessions.get(i);u&&u._fireDidHide()}}class P{constructor(i,u){this._extensionId=i,this._onDidDispose=u,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new S.Emitter,this._onDidChangeValueEmitter=new S.Emitter,this._onDidTriggerButtonEmitter=new S.Emitter,this._onDidHideEmitter=new S.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(i){this._title=i,this.update({title:i})}get step(){return this._steps}set step(i){this._steps=i,this.update({step:i})}get totalSteps(){return this._totalSteps}set totalSteps(i){this._totalSteps=i,this.update({totalSteps:i})}get enabled(){return this._enabled}set enabled(i){this._enabled=i,this.update({enabled:i})}get busy(){return this._busy}set busy(i){this._busy=i,this.update({busy:i})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(i){this._ignoreFocusOut=i,this.update({ignoreFocusOut:i})}get value(){return this._value}set value(i){this._value=i,this.update({value:i})}get placeholder(){return this._placeholder}set placeholder(i){this._placeholder=i,this.update({placeholder:i})}get buttons(){return this._buttons}set buttons(i){this._buttons=i.slice(),this._handlesToButtons.clear(),i.forEach((u,f)=>{const v=u===b.QuickInputButtons.Back?-1:f;this._handlesToButtons.set(v,u)}),this.update({buttons:i.map((u,f)=>({iconPath:a(u.iconPath),tooltip:u.tooltip,handle:u===b.QuickInputButtons.Back?-1:f}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(i){this._value=i,this._onDidChangeValueEmitter.fire(i)}_fireDidTriggerButton(i){const u=this._handlesToButtons.get(i);u&&this._onDidTriggerButtonEmitter.fire(u)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,_.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),E.$dispose(this._id))}update(i){if(!this._disposed){for(const u of Object.keys(i)){const f=i[u];this._pendingUpdate[u]=f===void 0?null:f}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){E.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}P._nextId=1;function a(s){if(s instanceof b.ThemeIcon)return{id:s.id};const i=p(s),u=h(s);return{dark:typeof i=="string"?y.URI.file(i):i,light:typeof u=="string"?y.URI.file(u):u}}function h(s){return typeof s=="object"&&"light"in s?s.light:s}function p(s){return typeof s=="object"&&"dark"in s?s.dark:s}class t extends P{constructor(i,u,f){super(i,f);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new S.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new S.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(i){this._items=i.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),i.forEach((u,f)=>{this._handlesToItems.set(f,u),this._itemsToHandles.set(u,f)}),this.update({items:i.map((u,f)=>({label:u.label,description:u.description,handle:f,detail:u.detail,picked:u.picked,alwaysShow:u.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(i){this._canSelectMany=i,this.update({canSelectMany:i})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(i){this._matchOnDescription=i,this.update({matchOnDescription:i})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(i){this._matchOnDetail=i,this.update({matchOnDetail:i})}get sortByLabel(){return this._sortByLabel}set sortByLabel(i){this._sortByLabel=i,this.update({sortByLabel:i})}get activeItems(){return this._activeItems}set activeItems(i){this._activeItems=i.filter(u=>this._itemsToHandles.has(u)),this.update({activeItems:this._activeItems.map(u=>this._itemsToHandles.get(u))})}get selectedItems(){return this._selectedItems}set selectedItems(i){this._selectedItems=i.filter(u=>this._itemsToHandles.has(u)),this.update({selectedItems:this._selectedItems.map(u=>this._itemsToHandles.get(u))})}_fireDidChangeActive(i){const u=(0,n.coalesce)(i.map(f=>this._handlesToItems.get(f)));this._activeItems=u,this._onDidChangeActiveEmitter.fire(u)}_fireDidChangeSelection(i){const u=(0,n.coalesce)(i.map(f=>this._handlesToItems.get(f)));this._selectedItems=u,this._onDidChangeSelectionEmitter.fire(u)}}class r extends P{constructor(i,u){super(i,u);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(i){this._password=i,this.update({password:i})}get prompt(){return this._prompt}set prompt(i){this._prompt=i,this.update({prompt:i})}get validationMessage(){return this._validationMessage}set validationMessage(i){this._validationMessage=i,this.update({validationMessage:i,severity:i?I.default.Error:I.default.Ignore})}}return new w(c,m)}e.createExtHostQuickOpen=l}),define(be[208],Ee([0,1,2,3,51,6,16,5,17,116,15,26,30,64]),function(ee,e,g,F,S,_,C,y,b,k,n,I,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function c(u){if(u)return typeof u.iconPath=="string"?g.URI.file(u.iconPath):g.URI.isUri(u.iconPath)||d.ThemeIcon.isThemeIcon(u.iconPath)?u.iconPath:void 0}function m(u,f){if(!u.iconPath&&!f.iconPath)return 0;if(u.iconPath){if(!f.iconPath)return 1}else return-1;const v=typeof u.iconPath=="string"?u.iconPath:g.URI.isUri(u.iconPath)?u.iconPath.fsPath:u.iconPath.id,D=typeof f.iconPath=="string"?f.iconPath:g.URI.isUri(f.iconPath)?f.iconPath.fsPath:f.iconPath.id;return(0,k.comparePaths)(v,D)}function E(u,f){let v=0;if(u.strikeThrough!==f.strikeThrough)return u.strikeThrough?1:-1;if(u.faded!==f.faded)return u.faded?1:-1;if(u.tooltip!==f.tooltip)return(u.tooltip||"").localeCompare(f.tooltip||"");if(v=m(u,f),v!==0)return v;if(u.light&&f.light)v=m(u.light,f.light);else{if(u.light)return 1;if(f.light)return-1}if(v!==0)return v;if(u.dark&&f.dark)v=m(u.dark,f.dark);else{if(u.dark)return 1;if(f.dark)return-1}return v}function w(u,f){if(u.command!==f.command)return u.command<f.command?-1:1;if(u.title!==f.title)return u.title<f.title?-1:1;if(u.tooltip!==f.tooltip){if(u.tooltip!==void 0&&f.tooltip!==void 0)return u.tooltip<f.tooltip?-1:1;if(u.tooltip!==void 0)return 1;if(f.tooltip!==void 0)return-1}if(u.arguments===f.arguments)return 0;if(u.arguments)if(f.arguments){if(u.arguments.length!==f.arguments.length)return u.arguments.length-f.arguments.length}else return 1;else return-1;for(let v=0;v<u.arguments.length;v++){const D=u.arguments[v],T=f.arguments[v];if(D!==T)return D<T?-1:1}return 0}function P(u,f){let v=(0,k.comparePaths)(u.resourceUri.fsPath,f.resourceUri.fsPath,!0);if(v!==0)return v;if(u.command&&f.command)v=w(u.command,f.command);else{if(u.command)return 1;if(f.command)return-1}if(v!==0)return v;if(u.decorations&&f.decorations)v=E(u.decorations,f.decorations);else{if(u.decorations)return 1;if(f.decorations)return-1}return v}function a(u,f){for(let v=0;v<u.length;v++)if(u[v]!==f[v])return!1;return!0}function h(u,f){return u.command===f.command&&u.title===f.title&&u.tooltip===f.tooltip&&(u.arguments&&f.arguments?a(u.arguments,f.arguments):u.arguments===f.arguments)}function p(u,f){return(0,b.equals)(u,f,h)}class t{constructor(f,v,D){this._extension=f,this._proxy=v,this._sourceControlHandle=D,this._value="",this._onDidChange=new F.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(f){this._proxy.$setInputBoxValue(this._sourceControlHandle,f),this.updateValue(f)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(f){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,f),this._placeholder=f}get validateInput(){return(0,l.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(f){if((0,l.checkProposedApiEnabled)(this._extension),f&&typeof f!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=f,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!f)}get visible(){return this._visible}set visible(f){f=!!f,this._visible!==f&&(this._visible=f,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,f))}focus(){(0,l.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(f,v){(0,l.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,f,v)}$onInputBoxValueChange(f){this.updateValue(f)}updateValue(f){this._value=f,this._onDidChange.fire(f)}}e.ExtHostSCMInputBox=t;class r{constructor(f,v,D,T,o){this._proxy=f,this._commands=v,this._sourceControlHandle=D,this._id=T,this._label=o,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new F.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new F.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=r._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(f){this._label=f,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,f)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(f){this._hideWhenEmpty=f,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(f){this._resourceStates=[...f],this._onDidUpdateResourceStates.fire()}getResourceState(f){return this._resourceStatesMap.get(f)}$executeResourceCommand(f,v){const D=this._resourceStatesCommandsMap.get(f);return D?(0,C.asPromise)(()=>this._commands.executeCommand(D.command,...D.arguments||[],v)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const f=[...this._resourceStates].sort(P),D=(0,b.sortedDiff)(this._resourceSnapshot,f,P).map(A=>{const L=A.toInsert.map(B=>{const oe=this._resourceHandlePool++;this._resourceStatesMap.set(oe,B);const he=B.resourceUri;let Q;if(B.command)if(B.command.command==="vscode.open"||B.command.command==="vscode.diff"){const ce=new _.DisposableStore;Q=this._commands.converter.toInternal(B.command,ce),this._resourceStatesDisposablesMap.set(oe,ce)}else this._resourceStatesCommandsMap.set(oe,B.command);const z=c(B.decorations),V=B.decorations&&c(B.decorations.light)||z,R=B.decorations&&c(B.decorations.dark)||z,K=[V,R],x=B.decorations&&B.decorations.tooltip||"",j=B.decorations&&!!B.decorations.strikeThrough,ue=B.decorations&&!!B.decorations.faded,$=B.contextValue||"";return{rawResource:[oe,he,K,x,j,ue,$,Q],handle:oe}});return{start:A.start,deleteCount:A.deleteCount,toInsert:L}}),T=D.map(({start:A,deleteCount:L,toInsert:B})=>[A,L,B.map(oe=>oe.rawResource)]),o=D.reverse();for(const{start:A,deleteCount:L,toInsert:B}of o){const oe=B.map(Q=>Q.handle),he=this._handlesSnapshot.splice(A,L,...oe);for(const Q of he)this._resourceStatesMap.delete(Q),this._resourceStatesCommandsMap.delete(Q),this._resourceStatesDisposablesMap.get(Q)?.dispose(),this._resourceStatesDisposablesMap.delete(Q)}return this._resourceSnapshot=f,T}dispose(){this._disposed=!0,this._onDidDispose.fire()}}r._handlePool=0;class s{constructor(f,v,D,T,o,A){this._proxy=v,this._commands=D,this._id=T,this._label=o,this._rootUri=A,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new _.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new _.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new F.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=s._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new t(f,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,T,o,A)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(f){this._count!==f&&(this._count=f,this._proxy.$updateSourceControl(this.handle,{count:f}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(f){this._quickDiffProvider=f,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!f})}get commitTemplate(){return this._commitTemplate}set commitTemplate(f){f!==this._commitTemplate&&(this._commitTemplate=f,this._proxy.$updateSourceControl(this.handle,{commitTemplate:f}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(f){this._acceptInputDisposables.value=new _.DisposableStore,this._acceptInputCommand=f;const v=this._commands.converter.toInternal(f,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:v})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(f){if(this._statusBarCommands&&f&&p(this._statusBarCommands,f))return;this._statusBarDisposables.value=new _.DisposableStore,this._statusBarCommands=f;const v=(f||[]).map(D=>this._commands.converter.toInternal(D,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:v})}get selected(){return this._selected}createResourceGroup(f,v){const D=new r(this._proxy,this._commands,this.handle,f,v),T=F.Event.once(D.onDidDispose)(()=>this.createdResourceGroups.delete(D));return this.createdResourceGroups.set(D,T),this.eventuallyAddResourceGroups(),D}eventuallyAddResourceGroups(){const f=[],v=[];for(const[D,T]of this.createdResourceGroups){T.dispose();const o=D.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(D),this.eventuallyUpdateResourceStates()});F.Event.once(D.onDidDispose)(()=>{this.updatedResourceGroups.delete(D),o.dispose(),this._groups.delete(D.handle),this._proxy.$unregisterGroup(this.handle,D.handle)}),f.push([D.handle,D.id,D.label,D.features]);const A=D._takeResourceStateSnapshot();A.length>0&&v.push([D.handle,A]),this._groups.set(D.handle,D)}this._proxy.$registerGroups(this.handle,f,v),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const f=[];this.updatedResourceGroups.forEach(v=>{const D=v._takeResourceStateSnapshot();D.length!==0&&f.push([v.handle,D])}),f.length>0&&this._proxy.$spliceResourceStates(this.handle,f),this.updatedResourceGroups.clear()}getResourceGroup(f){return this._groups.get(f)}setSelectionState(f){this._selected=f,this._onDidChangeSelection.fire(f)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(f=>f.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}s._handlePool=0,ze([(0,S.debounce)(100)],s.prototype,"eventuallyAddResourceGroups",null),ze([(0,S.debounce)(100)],s.prototype,"eventuallyUpdateResourceStates",null);let i=class Un{constructor(f,v,D){this._commands=v,this.logService=D,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new F.Emitter,this._proxy=f.getProxy(y.MainContext.MainThreadSCM),this._telemetry=f.getProxy(y.MainContext.MainThreadTelemetry),v.registerArgumentProcessor({processArgument:T=>{if(T&&T.$mid===3){const o=this._sourceControls.get(T.sourceControlHandle);if(!o)return T;const A=o.getResourceGroup(T.groupHandle);return A?A.getResourceState(T.handle):T}else if(T&&T.$mid===4){const o=this._sourceControls.get(T.sourceControlHandle);return o?o.getResourceGroup(T.groupHandle):T}else if(T&&T.$mid===5){const o=this._sourceControls.get(T.handle);return o||T}return T}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(f,v,D,T){this.logService.trace("ExtHostSCM#createSourceControl",f.identifier.value,v,D,T),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:f.identifier.value});const o=Un._handlePool++,A=new s(f,this._proxy,this._commands,v,D,T);this._sourceControls.set(o,A);const L=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(f.identifier))||[];return L.push(A),this._sourceControlsByExtension.set(I.ExtensionIdentifier.toKey(f.identifier),L),A}getLastInputBox(f){this.logService.trace("ExtHostSCM#getLastInputBox",f.identifier.value);const v=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(f.identifier)),D=v&&v[v.length-1];return D&&D.inputBox}$provideOriginalResource(f,v,D){const T=g.URI.revive(v);this.logService.trace("ExtHostSCM#$provideOriginalResource",f,T.toString());const o=this._sourceControls.get(f);return!o||!o.quickDiffProvider||!o.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,C.asPromise)(()=>o.quickDiffProvider.provideOriginalResource(T,D)).then(A=>A||null)}$onInputBoxValueChange(f,v){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",f);const D=this._sourceControls.get(f);return D&&D.inputBox.$onInputBoxValueChange(v),Promise.resolve(void 0)}$executeResourceCommand(f,v,D,T){this.logService.trace("ExtHostSCM#$executeResourceCommand",f,v,D);const o=this._sourceControls.get(f);if(!o)return Promise.resolve(void 0);const A=o.getResourceGroup(v);return A?A.$executeResourceCommand(D,T):Promise.resolve(void 0)}$validateInput(f,v,D){this.logService.trace("ExtHostSCM#$validateInput",f);const T=this._sourceControls.get(f);return!T||!T.inputBox.validateInput?Promise.resolve(void 0):(0,C.asPromise)(()=>T.inputBox.validateInput(v,D)).then(o=>o?Promise.resolve([o.message,o.type]):Promise.resolve(void 0))}$setSelectedSourceControl(f){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",f),f!==void 0&&this._sourceControls.get(f)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=f,Promise.resolve(void 0)}};i._handlePool=0,i=ze([qe(2,n.ILogService)],i),e.ExtHostSCM=i});var nt=this&&this.__classPrivateFieldSet||function(ee,e,g,F,S){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?S.call(ee,g):S?S.value=g:e.set(ee,g),g},Ue=this&&this.__classPrivateFieldGet||function(ee,e,g,F){if(g==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!F:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?F:g==="a"?F.call(ee):F?F.value:e.get(ee)};define(be[209],Ee([0,1,7,5,136,6,9]),function(ee,e,g,F,S,_,C){"use strict";var y,b;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class k{constructor(d,c,m,E,w=g.StatusBarAlignment.Left,P){y.set(this,void 0),b.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new _.DisposableStore,nt(this,y,d,"f"),nt(this,b,c,"f"),this._entryId=k.ID_GEN++,this._extension=m,this._id=E,this._alignment=w,this._priority=P}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(d){this._text=d,this.update()}set name(d){this._name=d,this.update()}set tooltip(d){this._tooltip=d,this.update()}set color(d){this._color=d,this.update()}set backgroundColor(d){d&&!k.ALLOWED_BACKGROUND_COLORS.has(d.id)&&(d=void 0),this._backgroundColor=d,this.update()}set command(d){this._command?.fromApi!==d&&(this._internalCommandRegistration.clear(),typeof d=="string"?this._command={fromApi:d,internal:Ue(this,b,"f").toInternal({title:"",command:d},this._internalCommandRegistration)}:d?this._command={fromApi:d,internal:Ue(this,b,"f").toInternal(d,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(d){this._accessibilityInformation=d,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Ue(this,y,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let d;this._extension?this._id?d=`${this._extension.identifier.value}.${this._id}`:d=this._extension.identifier.value:d=this._id;let c;this._name?c=this._name:c=(0,S.localize)(0,null,this._extension.displayName||this._extension.name);let m=this._color;this._backgroundColor&&(m=k.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const E=this._tooltip?C.MarkdownString.fromStrict(this._tooltip):void 0;Ue(this,y,"f").$setEntry(this._entryId,d,c,this._text,E,this._command?.internal,m,this._backgroundColor,this._alignment===g.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=k,y=new WeakMap,b=new WeakMap,k.ID_GEN=0,k.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new g.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new g.ThemeColor("statusBarItem.warningForeground")]]);class n{constructor(d){this._messages=[],this._item=d.createStatusBarEntry(void 0,"status.extensionMessage",g.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,S.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(d){const c={message:d};return this._messages.unshift(c),this._update(),new g.Disposable(()=>{const m=this._messages.indexOf(c);m>=0&&(this._messages.splice(m,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class I{constructor(d,c){this._proxy=d.getProxy(F.MainContext.MainThreadStatusBar),this._commands=c,this._statusMessage=new n(this)}createStatusBarEntry(d,c,m,E){return new k(this._proxy,this._commands,d,c,m,E)}setStatusBarMessage(d,c){const m=this._statusMessage.setMessage(d);let E;return typeof c=="number"?E=setTimeout(()=>m.dispose(),c):typeof c!="undefined"&&c.then(()=>m.dispose(),()=>m.dispose()),new g.Disposable(()=>{m.dispose(),clearTimeout(E)})}}e.ExtHostStatusBar=I}),define(be[77],Ee([0,1,5,3,4]),function(ee,e,g,F,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class _{constructor(y){this._onDidChangeStorage=new F.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=y.getProxy(g.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(y,b){this._proxy.$registerExtensionStorageKeysToSync(y,b)}getValue(y,b,k){return this._proxy.$getValue(y,b).then(n=>n||k)}setValue(y,b,k){return this._proxy.$setValue(y,b,k)}$acceptValue(y,b,k){this._onDidChangeStorage.fire({shared:y,key:b,value:k})}}e.ExtHostStorage=_,e.IExtHostStorage=(0,S.createDecorator)("IExtHostStorage")}),define(be[78],Ee([0,1,4,29,15,76,2]),function(ee,e,g,F,S,_,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,g.createDecorator)("IExtensionStoragePaths");let y=class{constructor(k,n,I){this._logService=n,this._extHostFileSystem=I,this._workspace=k.workspace??void 0,this._environment=k.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(l=>this._value=l)}async _getWorkspaceStorageURI(k){return C.URI.joinPath(this._environment.workspaceStorageHome,k)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const k=this._workspace.id,n=await this._getWorkspaceStorageURI(k);try{return await this._extHostFileSystem.value.stat(n),this._logService.trace("[ExtHostStorage] storage dir already exists",n),n}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",n),await this._extHostFileSystem.value.createDirectory(n),await this._extHostFileSystem.value.writeFile(C.URI.joinPath(n,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:C.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),n}catch(I){this._logService.error("[ExtHostStorage]",I);return}}workspaceValue(k){if(this._value)return C.URI.joinPath(this._value,k.identifier.value)}globalValue(k){return C.URI.joinPath(this._environment.globalStorageHome,k.identifier.value.toLowerCase())}onWillDeactivateAll(){}};y=ze([qe(0,F.IExtHostInitDataService),qe(1,S.ILogService),qe(2,_.IExtHostConsumerFileSystem)],y),e.ExtensionStoragePaths=y}),define(be[38],Ee([0,1,3,5,4,2,13,6,7,137,12,175,20,36,158,64,10]),function(ee,e,g,F,S,_,C,y,b,k,n,I,l,d,c,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,S.createDecorator)("IExtHostTerminalService");class w{constructor(i,u,f,v){this._proxy=i,this._id=u,this._creationOptions=f,this._name=v,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(T=>this._pidPromiseComplete=T);const D=this;this.value={get name(){return D._name||""},get processId(){return D._pidPromise},get creationOptions(){return D._creationOptions},get exitStatus(){return D._exitStatus},sendText(T,o=!0){D._checkDisposed(),D._proxy.$sendText(D._id,T,o)},show(T){D._checkDisposed(),D._proxy.$show(D._id,T)},hide(){D._checkDisposed(),D._proxy.$hide(D._id)},dispose(){D._disposed||(D._disposed=!0,D._proxy.$dispose(D._id))},get dimensions(){if(!(D._cols===void 0||D._rows===void 0))return{columns:D._cols,rows:D._rows}}}}async create(i,u){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:i.name,shellPath:(0,E.withNullAsUndefined)(i.shellPath),shellArgs:(0,E.withNullAsUndefined)(i.shellArgs),cwd:(0,E.withNullAsUndefined)(i.cwd),env:(0,E.withNullAsUndefined)(i.env),icon:(0,E.withNullAsUndefined)(r(i.iconPath)),color:m.ThemeColor.isThemeColor(i.color)?i.color.id:void 0,initialText:(0,E.withNullAsUndefined)(i.message),strictEnv:(0,E.withNullAsUndefined)(i.strictEnv),hideFromUser:(0,E.withNullAsUndefined)(i.hideFromUser),isFeatureTerminal:(0,E.withNullAsUndefined)(u?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,E.withNullAsUndefined)(u?.useShellEnvironment),isSplitTerminal:u?.isSplitTerminal,target:u?.target})}async createExtensionTerminal(i,u,f){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:f,isSplitTerminal:i,target:u}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(i){this._name=i}setExitCode(i){this._exitStatus=Object.freeze({code:i})}setDimensions(i,u){return i===this._cols&&u===this._rows||i===0||u===0?!1:(this._cols=i,this._rows=u,!0)}_setProcessId(i){this._pidPromiseComplete?(this._pidPromiseComplete(i),this._pidPromiseComplete=void 0):this._pidPromise.then(u=>{u!==i&&(this._pidPromise=Promise.resolve(i))})}}e.ExtHostTerminal=w;class P{constructor(i){this._pty=i,this.id=0,this.shouldPersist=!1,this._onProcessData=new g.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new g.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new g.Emitter,this._onProcessTitleChanged=new g.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new g.Emitter,this._onProcessShellTypeChanged=new g.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(i){this._pty.handleInput&&this._pty.handleInput(i)}resize(i,u){this._pty.setDimensions&&this._pty.setDimensions({columns:i,rows:u})}async processBinary(i){}acknowledgeDataEvent(i){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(i){this._pty.onDidWrite(u=>this._onProcessData.fire(u)),this._pty.onDidClose&&this._pty.onDidClose((u=void 0)=>{this._onProcessExit.fire(u===void 0?void 0:u)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(u=>this._onProcessOverrideDimensions.fire(u&&{cols:u.columns,rows:u.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(u=>this._onProcessTitleChanged.fire(u)),this._pty.open(i||void 0),this._pty.setDimensions&&i&&this._pty.setDimensions(i),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=P;let a=1,h=class extends y.Disposable{constructor(i,u){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new g.Emitter,this._onDidOpenTerminal=new g.Emitter,this._onDidChangeActiveTerminal=new g.Emitter,this._onDidChangeTerminalDimensions=new g.Emitter,this._proxy=u.getProxy(F.MainContext.MainThreadTerminalService),this._bufferer=new c.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new g.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(i),this._register({dispose:()=>{for(const[f,v]of this._terminalProcesses)v.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(i=>i.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}getDefaultShell(i){return(i?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(i){return(i?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(i,u){const f=new w(this._proxy,(0,d.generateUuid)(),i,i.name),v=new P(i.pty);return f.createExtensionTerminal(u?.isSplitTerminal,u?.target,r(i.iconPath)).then(D=>{const T=this._setupExtHostProcessListeners(D,v);this._terminalProcessDisposables[D]=T}),this._terminals.push(f),f.value}attachPtyToTerminal(i,u){if(!this._getTerminalById(i))throw new Error(`Cannot resolve terminal with id ${i} for virtual process`);const v=new P(u),D=this._setupExtHostProcessListeners(i,v);this._terminalProcessDisposables[i]=D}async $acceptActiveTerminalChanged(i){const u=this._activeTerminal;if(i===null){this._activeTerminal=void 0,u!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const f=this._getTerminalById(i);f&&(this._activeTerminal=f,u!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(i,u){const f=this._getTerminalById(i);f&&this._onDidWriteTerminalData.fire({terminal:f.value,data:u})}async $acceptTerminalDimensions(i,u,f){const v=this._getTerminalById(i);v&&v.setDimensions(u,f)&&this._onDidChangeTerminalDimensions.fire({terminal:v.value,dimensions:v.value.dimensions})}async $acceptTerminalMaximumDimensions(i,u,f){this._terminalProcesses.get(i)?.resize(u,f)}async $acceptTerminalTitleChange(i,u){const f=this._getTerminalById(i);f&&(f.name=u)}async $acceptTerminalClosed(i,u){const f=this._getTerminalObjectIndexById(this._terminals,i);if(f!==null){const v=this._terminals.splice(f,1)[0];v.setExitCode(u),this._onDidCloseTerminal.fire(v.value)}}$acceptTerminalOpened(i,u,f,v){if(u){const o=this._getTerminalObjectIndexById(this._terminals,u);if(o!==null){this._terminals[o]._id=i,this._onDidOpenTerminal.fire(this.terminals[o]),this._terminals[o].isOpen=!0;return}}const D={name:v.name,shellPath:v.executable,shellArgs:v.args,cwd:typeof v.cwd=="string"?v.cwd:_.URI.revive(v.cwd),env:v.env,hideFromUser:v.hideFromUser},T=new w(this._proxy,i,D,f);this._terminals.push(T),this._onDidOpenTerminal.fire(T.value),T.isOpen=!0}async $acceptTerminalProcessId(i,u){const f=this._getTerminalById(i);f&&f._setProcessId(u)}async $startExtensionTerminal(i,u){const f=this._getTerminalById(i);if(!f)return{message:(0,k.localize)(0,null,i)};f.isOpen||await new Promise(D=>{const T=this.onDidOpenTerminal(async o=>{o===f.value&&(T.dispose(),D())})});const v=this._terminalProcesses.get(i);v?v.startSendingEvents(u):this._extensionTerminalAwaitingStart[i]={initialDimensions:u}}_setupExtHostProcessListeners(i,u){const f=new y.DisposableStore;f.add(u.onProcessReady(D=>this._proxy.$sendProcessReady(i,D.pid,D.cwd))),f.add(u.onProcessTitleChanged(D=>this._proxy.$sendProcessTitle(i,D))),this._bufferer.startBuffering(i,u.onProcessData),f.add(u.onProcessExit(D=>this._onProcessExit(i,D))),u.onProcessOverrideDimensions&&f.add(u.onProcessOverrideDimensions(D=>this._proxy.$sendOverrideDimensions(i,D))),this._terminalProcesses.set(i,u);const v=this._extensionTerminalAwaitingStart[i];return v&&u instanceof P&&(u.startSendingEvents(v.initialDimensions),delete this._extensionTerminalAwaitingStart[i]),f}$acceptProcessAckDataEvent(i,u){this._terminalProcesses.get(i)?.acknowledgeDataEvent(u)}$acceptProcessInput(i,u){this._terminalProcesses.get(i)?.input(u)}$acceptProcessResize(i,u,f){try{this._terminalProcesses.get(i)?.resize(u,f)}catch(v){if(v.code!=="EPIPE"&&v.code!=="ERR_IPC_CHANNEL_CLOSED")throw v}}$acceptProcessShutdown(i,u){this._terminalProcesses.get(i)?.shutdown(u)}$acceptProcessRequestInitialCwd(i){this._terminalProcesses.get(i)?.getInitialCwd().then(u=>this._proxy.$sendProcessInitialCwd(i,u))}$acceptProcessRequestCwd(i){this._terminalProcesses.get(i)?.getCwd().then(u=>this._proxy.$sendProcessCwd(i,u))}$acceptProcessRequestLatency(i){return i}registerLinkProvider(i){return this._linkProviders.add(i),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new b.Disposable(()=>{this._linkProviders.delete(i),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(i,u,f){if(this._profileProviders.has(u))throw new Error(`Terminal profile provider "${u}" already registered`);return this._profileProviders.set(u,f),this._proxy.$registerProfileProvider(u,i.identifier.value),new b.Disposable(()=>{this._profileProviders.delete(u),this._proxy.$unregisterProfileProvider(u)})}async $createContributedProfileTerminal(i,u){const f=new l.CancellationTokenSource().token,v=await this._profileProviders.get(i)?.provideTerminalProfile(f);if(!f.isCancellationRequested){if(!v||!("options"in v))throw new Error(`No terminal profile options provided for id "${i}"`);if("pty"in v.options){this.createExtensionTerminal(v.options,u);return}this.createTerminalFromOptions(v.options,u)}}async $provideLinks(i,u){const f=this._getTerminalById(i);if(!f)return[];this._terminalLinkCache.delete(i);const v=this._terminalLinkCancellationSource.get(i);v&&v.dispose(!0);const D=new l.CancellationTokenSource;this._terminalLinkCancellationSource.set(i,D);const T=[],o={terminal:f.value,line:u},A=[];for(const oe of this._linkProviders)A.push(new Promise(async he=>{D.token.onCancellationRequested(()=>he({provider:oe,links:[]}));const Q=await oe.provideTerminalLinks(o,D.token)||[];D.token.isCancellationRequested||he({provider:oe,links:Q})}));const L=await Promise.all(A);if(D.token.isCancellationRequested)return[];const B=new Map;for(const oe of L)oe&&oe.links.length>0&&T.push(...oe.links.map(he=>{const Q={id:a++,startIndex:he.startIndex,length:he.length,label:he.tooltip};return B.set(Q.id,{provider:oe.provider,link:he}),Q}));return this._terminalLinkCache.set(i,B),T}$activateLink(i,u){const f=this._terminalLinkCache.get(i)?.get(u);!f||f.provider.handleTerminalLink(f.link)}_onProcessExit(i,u){this._bufferer.stopBuffering(i),this._terminalProcesses.delete(i),delete this._extensionTerminalAwaitingStart[i];const f=this._terminalProcessDisposables[i];f&&(f.dispose(),delete this._terminalProcessDisposables[i]),this._proxy.$sendProcessExit(i,u)}_getTerminalById(i){return this._getTerminalObjectById(this._terminals,i)}_getTerminalObjectById(i,u){const f=this._getTerminalObjectIndexById(i,u);return f!==null?i[f]:null}_getTerminalObjectIndexById(i,u){let f=null;return i.some((v,D)=>v._id===u?(f=D,!0):!1),f}getEnvironmentVariableCollection(i){let u=this._environmentVariableCollections.get(i.identifier.value);return u||(u=new p,this._setEnvironmentVariableCollection(i.identifier.value,u)),u}_syncEnvironmentVariableCollection(i,u){const f=(0,I.serializeEnvironmentVariableCollection)(u.map);this._proxy.$setEnvironmentVariableCollection(i,u.persistent,f.length===0?void 0:f)}$initEnvironmentVariableCollections(i){i.forEach(u=>{const f=u[0],v=new p(u[1]);this._setEnvironmentVariableCollection(f,v)})}$acceptDefaultProfile(i,u){this._defaultProfile=i,this._defaultAutomationProfile=u}_setEnvironmentVariableCollection(i,u){this._environmentVariableCollections.set(i,u),u.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(i,u)})}};h=ze([qe(1,C.IExtHostRpcService)],h),e.BaseExtHostTerminalService=h;class p{constructor(i){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new g.Emitter,this.map=new Map(i)}get persistent(){return this._persistent}set persistent(i){this._persistent=i,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(i,u){this._setIfDiffers(i,{value:u,type:b.EnvironmentVariableMutatorType.Replace})}append(i,u){this._setIfDiffers(i,{value:u,type:b.EnvironmentVariableMutatorType.Append})}prepend(i,u){this._setIfDiffers(i,{value:u,type:b.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(i,u){const f=this.map.get(i);(!f||f.value!==u.value||f.type!==u.type)&&(this.map.set(i,u),this._onDidChangeCollection.fire())}get(i){return this.map.get(i)}forEach(i,u){this.map.forEach((f,v)=>i.call(u,v,f,this))}delete(i){this.map.delete(i),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=p;let t=class extends h{constructor(i){super(!1,i)}createTerminal(i,u,f){throw new n.NotSupportedError}createTerminalFromOptions(i,u){throw new n.NotSupportedError}};t=ze([qe(0,C.IExtHostRpcService)],t),e.WorkerExtHostTerminalService=t;function r(s){if(!(!s||typeof s=="string"))return"id"in s?{id:s.id,color:s.color}:s}});var nt=this&&this.__classPrivateFieldSet||function(ee,e,g,F,S){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?S.call(ee,g):S?S.value=g:e.set(ee,g),g},Ue=this&&this.__classPrivateFieldGet||function(ee,e,g,F){if(g==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!F:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?F:g==="a"?F.call(ee):F?F.value:e.get(ee)};define(be[210],Ee([0,1,24,20,3,52,42,54,6,23,10,36,5,13,67,9,7,183,99,72]),function(ee,e,g,F,S,_,C,y,b,k,n,I,l,d,c,m,E,w,P,a){"use strict";var h,p,t,r,s,i,u;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let f=class{constructor(R,K){this.resultsChangedEmitter=new S.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=R.getProxy(l.MainContext.MainThreadTesting),this.observer=new he(this.proxy),this.runTracker=new D(this.proxy),K.registerArgumentProcessor({processArgument:x=>x?.$mid===13?m.TestItem.toItemFromContext(x):x})}createTestController(R,K){const x=new b.DisposableStore,j=x.add(new w.SingleUseTestCollection(R)),ue=new Map,$=this.proxy,te={items:j.root.children,get label(){return K},set label(ye){K=ye,j.root.label=ye,$.$updateControllerLabel(R,K)},get id(){return R},createRunProfile:(ye,Re,Te,$e)=>{let Je=(0,C.hash)(ye);for(;ue.has(Je);)Je++;const Ve=new Q(this.proxy,R,Je,ye,Re,Te,$e);return ue.set(Je,Ve),Ve},createTestItem(ye,Re,Te){return new c.TestItemImpl(R,ye,Re,Te)},createTestRun:(ye,Re,Te=!0)=>this.runTracker.createTestRun(R,j,ye,Re,Te),set resolveChildrenHandler(ye){j.resolveHandler=ye},get resolveChildrenHandler(){return j.resolveHandler},dispose:()=>{x.dispose()}};te.createRunConfiguration=te.createRunProfile,$.$registerTestController(R,K),x.add((0,b.toDisposable)(()=>$.$unregisterTestController(R)));const ce={controller:te,collection:j,profiles:ue};return this.controllers.set(R,ce),x.add((0,b.toDisposable)(()=>this.controllers.delete(R))),x.add(j.onDidGenerateDiff(ye=>$.$publishDiff(R,ye))),te}createTestObserver(){return this.observer.checkout()}async runTests(R,K=F.CancellationToken.None){const x=T(R);if(!x)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const j=this.controllers.get(x.controllerId);if(!j)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:R.include?.map(ue=>ue.id)??[j.collection.root.id],profileGroup:z[x.kind],profileId:x.profileId,controllerId:x.controllerId}],exclude:R.exclude?.map(ue=>({testId:ue.id,controllerId:x.controllerId}))},K)}$provideFileCoverage(R,K,x){return y.Iterable.find(this.runTracker.trackers,j=>j.id===R)?.getCoverage(K)?.provideFileCoverage(x)??Promise.resolve([])}$resolveFileCoverage(R,K,x,j){return y.Iterable.find(this.runTracker.trackers,ue=>ue.id===R)?.getCoverage(K)?.resolveFileCoverage(x,j)??Promise.resolve([])}$configureRunProfile(R,K){this.controllers.get(R)?.profiles.get(K)?.configureHandler?.()}$publishTestResults(R){this.results=Object.freeze(R.map(K=>(0,k.deepFreeze)(m.TestResults.to(K))).concat(this.results).sort((K,x)=>x.completedAt-K.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest({controllerId:R,testId:K},x){const j=this.controllers.get(R)?.collection;j&&(await j.expand(K,x<0?Infinity:x),j.flushDiff())}$acceptDiff(R){this.observer.applyDiff(R)}async $runControllerTests(R,K){const x=this.controllers.get(R.controllerId);if(!x)return;const{collection:j,profiles:ue}=x,$=ue.get(R.profileId);if(!$)return;const te=R.testIds.map(Te=>j.tree.get(Te)).filter(n.isDefined),ce=R.excludeExtIds.map(Te=>x.collection.tree.get(Te)).filter(n.isDefined).filter(Te=>te.some($e=>$e.fullId.compare(Te.fullId)===2));if(!te.length)return;const ye=new E.TestRunRequest(te.some(Te=>Te.actual instanceof c.TestItemRootImpl)?void 0:te.map(Te=>Te.actual),ce.map(Te=>Te.actual),$),Re=this.runTracker.prepareForMainThreadTestRun(ye,o.fromInternal(R,x.collection),K);try{await $.runHandler(ye,K)}finally{Re.isRunning&&!K.isCancellationRequested&&await S.Event.toPromise(Re.onEnd),this.runTracker.cancelRunById(R.runId)}}$cancelExtensionTestRun(R){R===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(R)}};f=ze([qe(0,d.IExtHostRpcService)],f),e.ExtHostTesting=f;class v extends b.Disposable{constructor(R,K,x){super();this.dto=R,this.proxy=K,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new S.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new F.CancellationTokenSource(x)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:j}of this.tasks.values())j.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(R){return this.tasks.get(R)?.coverage}createRun(R){const K=(0,I.generateUuid)(),x=new A(this.proxy,this.dto.id,K),j=new L(R,this.cts.token,K,x,this.dto,this.sharedTestIds,this.proxy,()=>{this.tasks.delete(j.taskId),this.isRunning||this.dispose()});return this.tasks.set(j.taskId,{run:j,coverage:x}),j}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}}class D{constructor(R){this.proxy=R,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(R,K,x){return this.getTracker(R,K,x)}cancelRunById(R){for(const K of this.tracked.values())if(K.id===R){K.dispose();return}}cancelAllRuns(){for(const R of this.tracked.values())R.dispose()}createTestRun(R,K,x,j,ue){const $=this.tracked.get(x);if($)return $.createRun(j);const te=o.fromPublic(R,K,x,ue),ce=T(x);this.proxy.$startedExtensionTestRun({controllerId:R,profile:ce&&{group:z[ce.kind],id:ce.profileId},exclude:x.exclude?.map(Re=>Re.id)??[],id:te.id,include:x.include?.map(Re=>Re.id)??[K.root.id],persist:ue});const ye=this.getTracker(x,te);return ye.onEnd(()=>this.proxy.$finishedExtensionTestRun(te.id)),ye.createRun(j)}getTracker(R,K,x){const j=new v(K,this.proxy,x);return this.tracked.set(R,j),j.onEnd(()=>this.tracked.delete(R)),j}}e.TestRunCoordinator=D;const T=V=>{if(!!V.profile){if(!(V.profile instanceof Q))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return V.profile}};class o{constructor(R,K,x,j,ue,$){this.controllerId=R,this.id=K,this.isPersisted=ue,this.colllection=$,this.includePrefix=x.map(te=>te+"\0"),this.excludePrefix=j.map(te=>te+"\0")}static fromPublic(R,K,x,j){return new o(R,(0,I.generateUuid)(),x.include?.map(ue=>a.TestId.fromExtHostTestItem(ue,R).toString())??[R],x.exclude?.map(ue=>a.TestId.fromExtHostTestItem(ue,R).toString())??[],j,K)}static fromInternal(R,K){return new o(R.controllerId,R.runId,R.testIds,R.excludeExtIds,!0,K)}isIncluded(R){const K=a.TestId.fromExtHostTestItem(R,this.controllerId).toString()+"\0";for(const x of this.excludePrefix)if(K===x||K.startsWith(x))return!1;for(const x of this.includePrefix)if(K===x||K.startsWith(x))return!0;return!1}}e.TestRunDto=o;class A{constructor(R,K,x){this.proxy=R,this.runId=K,this.taskId=x}set coverageProvider(R){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!R||(this._coverageProvider=R,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(R){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(R))());try{return(await this.fileCoverage)?.map(m.TestCoverage.fromFile)??[]}catch(K){throw this.fileCoverage=void 0,K}}async resolveFileCoverage(R,K){const x=await this.fileCoverage;let j=x?.[R];return!this._coverageProvider||!x||!j?[]:(j.detailedCoverage||(j=x[R]=await this._coverageProvider.resolveFileCoverage?.(j,K)??j),j.detailedCoverage?.map(m.TestCoverage.fromDetailed)??[])}}class L{constructor(R,K,x,j,ue,$,te,ce){this.name=R,this.token=K,this.taskId=x,h.set(this,void 0),p.set(this,void 0),t.set(this,void 0),r.set(this,void 0),s.set(this,void 0),i.set(this,!1),nt(this,r,ce,"f"),nt(this,h,te,"f"),nt(this,p,ue,"f"),nt(this,s,j,"f"),nt(this,t,$,"f"),te.$startedTestRunTask(ue.id,{id:this.taskId,name:R,running:!0})}set coverageProvider(R){Ue(this,s,"f").coverageProvider=R}get coverageProvider(){return Ue(this,s,"f").coverageProvider}get isPersisted(){return Ue(this,p,"f").isPersisted}setState(R,K,x){const j=Ue(this,p,"f");!Ue(this,i,"f")&&j.isIncluded(R)&&(this.ensureTestIsKnown(R),Ue(this,h,"f").$updateTestStateInRun(j.id,this.taskId,a.TestId.fromExtHostTestItem(R,j.controllerId).toString(),K,x))}appendMessage(R,K){const x=Ue(this,p,"f");!Ue(this,i,"f")&&x.isIncluded(R)&&(this.ensureTestIsKnown(R),Ue(this,h,"f").$appendTestMessageInRun(x.id,this.taskId,a.TestId.fromExtHostTestItem(R,x.controllerId).toString(),m.TestMessage.from(K)))}appendOutput(R){Ue(this,i,"f")||Ue(this,h,"f").$appendOutputToRun(Ue(this,p,"f").id,this.taskId,g.VSBuffer.fromString(R))}end(){Ue(this,i,"f")||(nt(this,i,!0,"f"),Ue(this,h,"f").$finishedTestRunTask(Ue(this,p,"f").id,this.taskId),Ue(this,r,"f").call(this))}ensureTestIsKnown(R){if(!(R instanceof c.TestItemImpl))throw new c.InvalidTestItemError(R.id);const K=Ue(this,t,"f");if(K.has(R.id))return;const x=[];for(;x.unshift(m.TestItem.from(R)),!(K.has(R.id)||(K.add(R.id),!R.parent));)R=R.parent;const j=Ue(this,p,"f").colllection.root;K.has(j.id)||(K.add(j.id),x.unshift(m.TestItem.from(j))),Ue(this,h,"f").$addTestsToRun(Ue(this,p,"f").controllerId,Ue(this,p,"f").id,x)}}h=new WeakMap,p=new WeakMap,t=new WeakMap,r=new WeakMap,s=new WeakMap,i=new WeakMap;class B extends P.IncrementalChangeCollector{constructor(R){super();this.emitter=R,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(R){this.added.add(R)}update(R){Object.assign(R.revived,m.TestItem.toPlain(R.item)),this.added.has(R)||this.updated.add(R)}remove(R){if(this.added.has(R)){this.added.delete(R);return}if(this.updated.delete(R),R.parent&&this.alreadyRemoved.has(R.parent)){this.alreadyRemoved.add(R.item.extId);return}this.removed.add(R)}getChangeEvent(){const{added:R,updated:K,removed:x}=this;return{get added(){return[...R].map(j=>j.revived)},get updated(){return[...K].map(j=>j.revived)},get removed(){return[...x].map(j=>j.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class oe extends P.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new S.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(R){return this.items.get(R)}getMirroredTestDataByReference(R){return this.items.get(R.id)}createItem(R,K){return{...R,revived:m.TestItem.toPlain(R.item),depth:K?K.depth+1:0,children:new Set}}createChangeCollector(){return new B(this.changeEmitter)}}e.MirroredTestCollection=oe;class he{constructor(R){this.proxy=R}checkout(){this.current||(this.current=this.createObserverData());const R=this.current;return R.observers++,{onDidChangeTest:R.tests.onDidChangeTests,get tests(){return[...R.tests.rootTests].map(K=>K.revived)},dispose:(0,_.once)(()=>{--R.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(R){return this.current?.tests.getMirroredTestDataByReference(R)}applyDiff(R){this.current?.tests.apply(R)}createObserverData(){const R=new oe;return this.proxy.$subscribeToDiffs(),{observers:0,tests:R}}}class Q{constructor(R,K,x,j,ue,$,te=!1){this.controllerId=K,this.profileId=x,this._label=j,this.kind=ue,this.runHandler=$,this._isDefault=te,u.set(this,void 0),nt(this,u,R,"f");const ce=z[ue];if(typeof ce!="number")throw new Error(`Unknown TestRunProfile.group ${ue}`);Ue(this,u,"f").$publishTestRunProfile({profileId:x,controllerId:K,label:j,group:ce,isDefault:te,hasConfigurationHandler:!1})}get label(){return this._label}set label(R){R!==this._label&&(this._label=R,Ue(this,u,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:R}))}get isDefault(){return this._isDefault}set isDefault(R){R!==this._isDefault&&(this._isDefault=R,Ue(this,u,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:R}))}get configureHandler(){return this._configureHandler}set configureHandler(R){R!==this._configureHandler&&(this._configureHandler=R,Ue(this,u,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!R}))}dispose(){Ue(this,u,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=Q,u=new WeakMap;const z={[E.TestRunProfileKind.Coverage]:8,[E.TestRunProfileKind.Debug]:4,[E.TestRunProfileKind.Run]:2}}),define(be[211],Ee([0,1,3,17,5,102,9,7]),function(ee,e,g,F,S,_,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class b{constructor(n,I){this._extHostDocumentsAndEditors=I,this._onDidChangeTextEditorSelection=new g.Emitter,this._onDidChangeTextEditorOptions=new g.Emitter,this._onDidChangeTextEditorVisibleRanges=new g.Emitter,this._onDidChangeTextEditorViewColumn=new g.Emitter,this._onDidChangeActiveTextEditor=new g.Emitter,this._onDidChangeVisibleTextEditors=new g.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=n.getProxy(S.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(l=>this._onDidChangeVisibleTextEditors.fire(l)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(l=>this._onDidChangeActiveTextEditor.fire(l))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(n){const I=this._extHostDocumentsAndEditors.allEditors();return n?I:I.map(l=>l.value)}async showTextDocument(n,I,l){let d;typeof I=="number"?d={position:C.ViewColumn.from(I),preserveFocus:l}:typeof I=="object"?d={position:C.ViewColumn.from(I.viewColumn),preserveFocus:I.preserveFocus,selection:typeof I.selection=="object"?C.Range.from(I.selection):void 0,pinned:typeof I.preview=="boolean"?!I.preview:void 0}:d={preserveFocus:!1};const c=await this._proxy.$tryShowTextDocument(n.uri,d),m=c&&this._extHostDocumentsAndEditors.getEditor(c);if(m)return m.value;throw c?new Error(`Could NOT open editor for "${n.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${n.uri.toString()}".`)}createTextEditorDecorationType(n,I){return new _.TextEditorDecorationType(this._proxy,n,I).value}$acceptEditorPropertiesChanged(n,I){const l=this._extHostDocumentsAndEditors.getEditor(n);if(!l)throw new Error("unknown text editor");if(I.options&&l._acceptOptions(I.options),I.selections){const d=I.selections.selections.map(C.Selection.to);l._acceptSelections(d)}if(I.visibleRanges){const d=F.coalesce(I.visibleRanges.map(C.Range.to));l._acceptVisibleRanges(d)}if(I.options&&this._onDidChangeTextEditorOptions.fire({textEditor:l.value,options:{...I.options,lineNumbers:C.TextEditorLineNumbersStyle.to(I.options.lineNumbers)}}),I.selections){const d=y.TextEditorSelectionChangeKind.fromValue(I.selections.source),c=I.selections.selections.map(C.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:l.value,selections:c,kind:d})}if(I.visibleRanges){const d=F.coalesce(I.visibleRanges.map(C.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:l.value,visibleRanges:d})}}$acceptEditorPositionData(n){for(const I in n){const l=this._extHostDocumentsAndEditors.getEditor(I);if(!l)throw new Error("Unknown text editor");const d=C.ViewColumn.to(n[I]);l.value.viewColumn!==d&&(l._acceptViewColumn(d),this._onDidChangeTextEditorViewColumn.fire({textEditor:l.value,viewColumn:d}))}}getDiffInformation(n){return Promise.resolve(this._proxy.$getDiffInformation(n))}}e.ExtHostEditors=b}),define(be[212],Ee([0,1,2,4,5,6,7]),function(ee,e,g,F,S,_,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,F.createDecorator)("IExtHostTimeline");class y{constructor(n,I){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=n.getProxy(S.MainContext.MainThreadTimeline),I.registerArgumentProcessor({processArgument:l=>{if(l&&l.$mid===11){const d=l.uri===void 0?void 0:g.URI.revive(l.uri);return this._itemsBySourceAndUriMap.get(l.source)?.get(b(d))?.get(l.handle)}return l}})}async $getTimeline(n,I,l,d,c){return this._providers.get(n)?.provideTimeline(g.URI.revive(I),l,d,c)}registerTimelineProvider(n,I,l,d){const c=new _.DisposableStore,m=this.convertTimelineItem(I.id,d,c).bind(this);let E;I.onDidChange&&(E=I.onDidChange(P=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...P,id:I.id}),this));const w=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...I,scheme:n,onDidChange:void 0,async provideTimeline(P,a,h,p){p?.resetCache&&(c.clear(),w.get(I.id)?.clear());const t=await I.provideTimeline(P,a,h);if(t==null)return;const r=m(P,p);return{...t,source:I.id,items:t.items.map(r)}},dispose(){for(const P of w.values())P.get(I.id)?.clear();E?.dispose(),c.dispose()}})}convertTimelineItem(n,I,l){return(d,c)=>{let m;if(c?.cacheResults){let E=this._itemsBySourceAndUriMap.get(n);E===void 0&&(E=new Map,this._itemsBySourceAndUriMap.set(n,E));const w=b(d);m=E.get(w),m===void 0&&(m=new Map,E.set(w,m))}return E=>{const{iconPath:w,...P}=E,a=`${n}|${E.id??E.timestamp}`;m?.set(a,E);let h,p,t;return E.iconPath&&(w instanceof C.ThemeIcon?t={id:w.id,color:w.color}:g.URI.isUri(w)?(h=w,p=w):{light:h,dark:p}=w),{...P,id:P.id??void 0,handle:a,source:n,command:E.command?I.toInternal(E.command,l):void 0,icon:h,iconDark:p,themeIcon:t,accessibilityInformation:E.accessibilityInformation}}}}registerTimelineProviderCore(n){if(this._providers.get(n.id))throw new Error(`Timeline Provider ${n.id} already exists.`);return this._proxy.$registerTimelineProvider({id:n.id,label:n.label,scheme:n.scheme}),this._providers.set(n.id,n),(0,_.toDisposable)(()=>{for(const l of this._itemsBySourceAndUriMap.values())l.get(n.id)?.clear();this._providers.delete(n.id),this._proxy.$unregisterTimelineProvider(n.id),n.dispose()})}}e.ExtHostTimeline=y;function b(k){return k?.toString()}}),define(be[213],Ee([0,1,6,11,2,5]),function(ee,e,g,F,S,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class C{constructor(b){this._openers=new Map,this._proxy=b.getProxy(_.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(b,k,n,I){if(this._openers.has(k))throw new Error(`Opener with id '${k}' already registered`);const l=I.schemes.find(d=>!C.supportedSchemes.has(d));if(l)throw new Error(`Scheme '${l}' is not supported. Only http and https are currently supported.`);return this._openers.set(k,n),this._proxy.$registerUriOpener(k,I.schemes,b,I.label),(0,g.toDisposable)(()=>{this._openers.delete(k),this._proxy.$unregisterUriOpener(k)})}async $canOpenUri(b,k,n){const I=this._openers.get(b);if(!I)throw new Error(`Unknown opener with id: ${b}`);const l=S.URI.revive(k);return I.canOpenExternalUri(l,n)}async $openUri(b,k,n){const I=this._openers.get(b);if(!I)throw new Error(`Unknown opener id: '${b}'`);return I.openExternalUri(S.URI.revive(k.resolvedUri),{sourceUri:S.URI.revive(k.sourceUri)},n)}}e.ExtHostUriOpeners=C,C.supportedSchemes=new Set([F.Schemas.http,F.Schemas.https])}),define(be[214],Ee([0,1,5,2,6,12,26]),function(ee,e,g,F,S,_,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class y{constructor(k){this.handles=new Set,this.handlers=new Map,this._proxy=k.getProxy(g.MainContext.MainThreadUrls)}registerUriHandler(k,n){if(this.handles.has(C.ExtensionIdentifier.toKey(k)))throw new Error(`Protocol handler already registered for extension ${k}`);const I=y.HandlePool++;return this.handles.add(C.ExtensionIdentifier.toKey(k)),this.handlers.set(I,n),this._proxy.$registerUriHandler(I,k),(0,S.toDisposable)(()=>{this.handles.delete(C.ExtensionIdentifier.toKey(k)),this.handlers.delete(I),this._proxy.$unregisterUriHandler(I)})}$handleExternalUri(k,n){const I=this.handlers.get(k);if(!I)return Promise.resolve(void 0);try{I.handleUri(F.URI.revive(n))}catch(l){(0,_.onUnexpectedError)(l)}return Promise.resolve(void 0)}async createAppUri(k){return F.URI.revive(await this._proxy.$createAppUri(k))}}e.ExtHostUrls=y,y.HandlePool=0});var nt=this&&this.__classPrivateFieldSet||function(ee,e,g,F,S){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?S.call(ee,g):S?S.value=g:e.set(ee,g),g},Ue=this&&this.__classPrivateFieldGet||function(ee,e,g,F){if(g==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!F:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?F:g==="a"?F.call(ee):F?F.value:e.get(ee)};define(be[49],Ee([0,1,3,2,147,167,70,5]),function(ee,e,g,F,S,_,C,y){"use strict";var b,k,n,I,l,d,c,m,E,w,P,a;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class h{constructor(v,D,T,o,A,L,B){b.set(this,void 0),k.set(this,void 0),n.set(this,void 0),I.set(this,void 0),l.set(this,void 0),d.set(this,void 0),c.set(this,""),m.set(this,void 0),E.set(this,!1),w.set(this,!1),P.set(this,!1),this._onMessageEmitter=new g.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,a.set(this,new g.Emitter),this._onDidDispose=Ue(this,a,"f").event,nt(this,b,v,"f"),nt(this,k,D,"f"),nt(this,m,T,"f"),nt(this,I,o,"f"),nt(this,l,A,"f"),nt(this,d,L,"f"),nt(this,P,p(L),"f"),nt(this,n,B,"f")}dispose(){nt(this,E,!0,"f"),Ue(this,a,"f").fire(),Ue(this,a,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(v){return nt(this,w,!0,"f"),(0,C.asWebviewUri)(v,Ue(this,I,"f").remote)}get cspSource(){return C.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Ue(this,c,"f")}set html(v){this.assertNotDisposed(),Ue(this,c,"f")!==v&&(nt(this,c,v,"f"),!Ue(this,w,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(v)&&(nt(this,w,!0,"f"),Ue(this,n,"f").report("Webview vscode-resource: uris",Ue(this,d,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ue(this,k,"f").$setHtml(Ue(this,b,"f"),v))}get options(){return this.assertNotDisposed(),Ue(this,m,"f")}set options(v){this.assertNotDisposed(),Ue(this,k,"f").$setOptions(Ue(this,b,"f"),s(Ue(this,d,"f"),Ue(this,l,"f"),v)),nt(this,m,v,"f")}async postMessage(v){if(Ue(this,E,"f"))return!1;const D=(0,_.serializeWebviewMessage)(v,{serializeBuffersForPostMessage:Ue(this,P,"f")});return Ue(this,k,"f").$postMessage(Ue(this,b,"f"),D.message,...D.buffers)}assertNotDisposed(){if(Ue(this,E,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=h,b=new WeakMap,k=new WeakMap,n=new WeakMap,I=new WeakMap,l=new WeakMap,d=new WeakMap,c=new WeakMap,m=new WeakMap,E=new WeakMap,w=new WeakMap,P=new WeakMap,a=new WeakMap;function p(f){try{const v=(0,S.normalizeVersion)((0,S.parseVersion)(f.engines.vscode));return!!v&&v.majorBase>=1&&v.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=p;class t{constructor(v,D,T,o,A){this.initData=D,this.workspace=T,this._logService=o,this._deprecationService=A,this._webviews=new Map,this._webviewProxy=v.getProxy(y.MainContext.MainThreadWebviews)}$onMessage(v,D,...T){const o=this.getWebview(v);if(o){const{message:A}=(0,_.deserializeWebviewMessage)(D,T);o._onMessageEmitter.fire(A)}}$onMissingCsp(v,D){this._logService.warn(`${D} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(v,D,T){const o=new h(v,this._webviewProxy,i(D),this.initData,this.workspace,T,this._deprecationService);return this._webviews.set(v,o),o._onDidDispose(()=>{this._webviews.delete(v)}),o}deleteWebview(v){this._webviews.delete(v)}getWebview(v){return this._webviews.get(v)}}e.ExtHostWebviews=t;function r(f){return{id:f.identifier,location:f.extensionLocation}}e.toExtensionData=r;function s(f,v,D){return{enableCommandUris:D.enableCommandUris,enableScripts:D.enableScripts,portMapping:D.portMapping,localResourceRoots:D.localResourceRoots||u(f,v)}}e.serializeWebviewOptions=s;function i(f){return{enableCommandUris:f.enableCommandUris,enableScripts:f.enableScripts,portMapping:f.portMapping,localResourceRoots:f.localResourceRoots?.map(v=>F.URI.from(v))}}e.reviveOptions=i;function u(f,v){return[...(v?.getWorkspaceFolders()||[]).map(D=>D.uri),f.extensionLocation]}}),define(be[215],Ee([0,1,20,42,6,11,25,2,9,49,65,5,7]),function(ee,e,g,F,S,_,C,y,b,k,n,I,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class d{constructor(t,r){this.document=t,this._storagePath=r,this._backupCounter=1,this._edits=new n.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,r){await this.getEdit(t).undo(),r||this.disposeBackup()}async redo(t,r){await this.getEdit(t).redo(),r||this.disposeBackup()}disposeEdits(t){for(const r of t)this._edits.delete(r)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=h(this.document.uri)+this._backupCounter++;return(0,C.joinPath)(this._storagePath,t)}updateBackup(t){this._backup?.delete(),this._backup=t}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(t){const r=this._edits.get(t,0);if(!r)throw new Error("No edit found");return r}}class c{constructor(){this._documents=new Map}get(t,r){return this._documents.get(this.key(t,r))}add(t,r,s){const i=this.key(t,r.uri);if(this._documents.has(i))throw new Error(`Document already exists for viewType:${t} resource:${r.uri}`);const u=new d(r,s);return this._documents.set(i,u),u}delete(t,r){const s=this.key(t,r.uri);this._documents.delete(s)}key(t,r){return`${t}@@@${r}`}}var m;(function(p){p[p.Text=0]="Text",p[p.Custom=1]="Custom"})(m||(m={}));class E{constructor(){this._providers=new Map}addTextProvider(t,r,s){return this.add(0,t,r,s)}addCustomProvider(t,r,s){return this.add(1,t,r,s)}get(t){return this._providers.get(t)}add(t,r,s,i){if(this._providers.has(r))throw new Error(`Provider for viewType:${r} already registered`);return this._providers.set(r,{type:t,extension:s,provider:i}),new l.Disposable(()=>this._providers.delete(r))}}class w{constructor(t,r,s,i,u){this._extHostDocuments=r,this._extensionStoragePaths=s,this._extHostWebview=i,this._extHostWebviewPanels=u,this._editorProviders=new E,this._documents=new c,this._proxy=t.getProxy(I.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,r,s,i){const u=new S.DisposableStore;return P(s)?(u.add(this._editorProviders.addTextProvider(r,t,s)),this._proxy.$registerTextEditorProvider((0,k.toExtensionData)(t),r,i.webviewOptions||{},{supportsMove:!!s.moveCustomTextEditor},(0,k.shouldSerializeBuffersForPostMessage)(t))):(u.add(this._editorProviders.addCustomProvider(r,t,s)),this.supportEditing(s)&&u.add(s.onDidChangeCustomDocument(f=>{const v=this.getCustomDocumentEntry(r,f.document.uri);if(a(f)){const D=v.addEdit(f);this._proxy.$onDidEdit(f.document.uri,r,D,f.label)}else this._proxy.$onContentChange(f.document.uri,r)})),this._proxy.$registerCustomEditorProvider((0,k.toExtensionData)(t),r,i.webviewOptions||{},!!i.supportsMultipleEditorsPerDocument,(0,k.shouldSerializeBuffersForPostMessage)(t))),l.Disposable.from(u,new l.Disposable(()=>{this._proxy.$unregisterEditorProvider(r)}))}async $createCustomDocument(t,r,s,i,u){const f=this._editorProviders.get(r);if(!f)throw new Error(`No provider found for '${r}'`);if(f.type!==1)throw new Error(`Invalid provide type for '${r}'`);const v=y.URI.revive(t),D=await f.provider.openCustomDocument(v,{backupId:s,untitledDocumentData:i?.buffer},u);let T;return this.supportEditing(f.provider)&&this._extensionStoragePaths&&(T=this._extensionStoragePaths.workspaceValue(f.extension)??this._extensionStoragePaths.globalValue(f.extension)),this._documents.add(r,D,T),{editable:this.supportEditing(f.provider)}}async $disposeCustomDocument(t,r){const s=this._editorProviders.get(r);if(!s)throw new Error(`No provider found for '${r}'`);if(s.type!==1)throw new Error(`Invalid provider type for '${r}'`);const i=y.URI.revive(t),{document:u}=this.getCustomDocumentEntry(r,i);this._documents.delete(r,u),u.dispose()}async $resolveWebviewEditor(t,r,s,i,u,f){const v=this._editorProviders.get(s);if(!v)throw new Error(`No provider found for '${s}'`);const D=b.ViewColumn.to(u),T=this._extHostWebview.createNewWebview(r,i.webviewOptions,v.extension),o=this._extHostWebviewPanels.createNewWebviewPanel(r,s,i.title,D,i.panelOptions,T),A=y.URI.revive(t);switch(v.type){case 1:{const{document:L}=this.getCustomDocumentEntry(s,A);return v.provider.resolveCustomEditor(L,o,f)}case 0:{const L=this._extHostDocuments.getDocument(A);return v.provider.resolveCustomTextEditor(L,o,f)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,r,s){this.getCustomDocumentEntry(r,t).disposeEdits(s)}async $onMoveCustomEditor(t,r,s){const i=this._editorProviders.get(s);if(!i)throw new Error(`No provider found for '${s}'`);if(!i.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${s}'`);const u=this._extHostWebviewPanels.getWebviewPanel(t);if(!u)throw new Error("No webview found");const f=y.URI.revive(r),v=this._extHostDocuments.getDocument(f);await i.provider.moveCustomTextEditor(v,u,g.CancellationToken.None)}async $undo(t,r,s,i){return this.getCustomDocumentEntry(r,t).undo(s,i)}async $redo(t,r,s,i){return this.getCustomDocumentEntry(r,t).redo(s,i)}async $revert(t,r,s){const i=this.getCustomDocumentEntry(r,t);await this.getCustomEditorProvider(r).revertCustomDocument(i.document,s),i.disposeBackup()}async $onSave(t,r,s){const i=this.getCustomDocumentEntry(r,t);await this.getCustomEditorProvider(r).saveCustomDocument(i.document,s),i.disposeBackup()}async $onSaveAs(t,r,s,i){const u=this.getCustomDocumentEntry(r,t);return this.getCustomEditorProvider(r).saveCustomDocumentAs(u.document,y.URI.revive(s),i)}async $backup(t,r,s){const i=this.getCustomDocumentEntry(r,t),f=await this.getCustomEditorProvider(r).backupCustomDocument(i.document,{destination:i.getNewBackupUri()},s);return i.updateBackup(f),f.id}getCustomDocumentEntry(t,r){const s=this._documents.get(t,y.URI.revive(r));if(!s)throw new Error("No custom document found");return s}getCustomEditorProvider(t){const s=this._editorProviders.get(t)?.provider;if(!s||!this.supportEditing(s))throw new Error("Custom document is not editable");return s}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=w;function P(p){return typeof p.resolveCustomTextEditor=="function"}function a(p){return typeof p.undo=="function"&&typeof p.redo=="function"}function h(p){const t=p.scheme===_.Schemas.file||p.scheme===_.Schemas.untitled?p.fsPath:p.toString();return(0,F.hash)(t)+""}});var nt=this&&this.__classPrivateFieldSet||function(ee,e,g,F,S){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?S.call(ee,g):S?S.value=g:e.set(ee,g),g},Ue=this&&this.__classPrivateFieldGet||function(ee,e,g,F){if(g==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!F:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?F:g==="a"?F.call(ee):F?F.value:e.get(ee)};define(be[216],Ee([0,1,3,6,2,36,9,49,5,7]),function(ee,e,g,F,S,_,C,y,b,k){"use strict";var n,I,l,d,c,m,E,w,P,a,h,p,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class r extends F.Disposable{constructor(f,v,D,T,o,A,L){super();n.set(this,void 0),I.set(this,void 0),l.set(this,void 0),d.set(this,void 0),c.set(this,void 0),m.set(this,void 0),E.set(this,void 0),w.set(this,void 0),P.set(this,!0),a.set(this,!0),h.set(this,!1),p.set(this,this._register(new g.Emitter)),this.onDidDispose=Ue(this,p,"f").event,t.set(this,this._register(new g.Emitter)),this.onDidChangeViewState=Ue(this,t,"f").event,nt(this,n,f,"f"),nt(this,I,v,"f"),nt(this,l,D,"f"),nt(this,c,A,"f"),nt(this,w,o,"f"),nt(this,m,T,"f"),nt(this,d,L,"f")}dispose(){Ue(this,h,"f")||(nt(this,h,!0,"f"),Ue(this,p,"f").fire(),Ue(this,I,"f").$disposeWebview(Ue(this,n,"f")),Ue(this,d,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Ue(this,d,"f")}get viewType(){return this.assertNotDisposed(),Ue(this,l,"f")}get title(){return this.assertNotDisposed(),Ue(this,m,"f")}set title(f){this.assertNotDisposed(),Ue(this,m,"f")!==f&&(nt(this,m,f,"f"),Ue(this,I,"f").$setTitle(Ue(this,n,"f"),f))}get iconPath(){return this.assertNotDisposed(),Ue(this,E,"f")}set iconPath(f){this.assertNotDisposed(),Ue(this,E,"f")!==f&&(nt(this,E,f,"f"),Ue(this,I,"f").$setIconPath(Ue(this,n,"f"),S.URI.isUri(f)?{light:f,dark:f}:f))}get options(){return Ue(this,c,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Ue(this,w,"f")=="number"&&Ue(this,w,"f")<0))return Ue(this,w,"f")}get active(){return this.assertNotDisposed(),Ue(this,a,"f")}get visible(){return this.assertNotDisposed(),Ue(this,P,"f")}_updateViewState(f){Ue(this,h,"f")||(this.active!==f.active||this.visible!==f.visible||this.viewColumn!==f.viewColumn)&&(nt(this,a,f.active,"f"),nt(this,P,f.visible,"f"),nt(this,w,f.viewColumn,"f"),Ue(this,t,"f").fire({webviewPanel:this}))}reveal(f,v){this.assertNotDisposed(),Ue(this,I,"f").$reveal(Ue(this,n,"f"),{viewColumn:f?C.ViewColumn.from(f):void 0,preserveFocus:!!v})}assertNotDisposed(){if(Ue(this,h,"f"))throw new Error("Webview is disposed")}}n=new WeakMap,I=new WeakMap,l=new WeakMap,d=new WeakMap,c=new WeakMap,m=new WeakMap,E=new WeakMap,w=new WeakMap,P=new WeakMap,a=new WeakMap,h=new WeakMap,p=new WeakMap,t=new WeakMap;class s{constructor(f,v,D){this.webviews=v,this.workspace=D,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=f.getProxy(b.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,_.generateUuid)()}createWebviewPanel(f,v,D,T,o={}){const A=typeof T=="object"?T.viewColumn:T,L={viewColumn:C.ViewColumn.from(A),preserveFocus:typeof T=="object"&&!!T.preserveFocus},B=(0,y.shouldSerializeBuffersForPostMessage)(f),oe=s.newHandle();this._proxy.$createWebviewPanel((0,y.toExtensionData)(f),oe,v,{title:D,panelOptions:i(o),webviewOptions:(0,y.serializeWebviewOptions)(f,this.workspace,o),serializeBuffersForPostMessage:B},L);const he=this.webviews.createNewWebview(oe,o,f);return this.createNewWebviewPanel(oe,v,D,A,o,he)}$onDidChangeWebviewPanelViewStates(f){const v=Object.keys(f);v.sort((D,T)=>{const o=f[D],A=f[T];return o.active?1:A.active?-1:+o.visible-+A.visible});for(const D of v){const T=this.getWebviewPanel(D);if(!T)continue;const o=f[D];T._updateViewState({active:o.active,visible:o.visible,viewColumn:C.ViewColumn.to(o.position)})}}async $onDidDisposeWebviewPanel(f){this.getWebviewPanel(f)?.dispose(),this._webviewPanels.delete(f),this.webviews.deleteWebview(f)}registerWebviewPanelSerializer(f,v,D){if(this._serializers.has(v))throw new Error(`Serializer for '${v}' already registered`);return this._serializers.set(v,{serializer:D,extension:f}),this._proxy.$registerSerializer(v,{serializeBuffersForPostMessage:(0,y.shouldSerializeBuffersForPostMessage)(f)}),new k.Disposable(()=>{this._serializers.delete(v),this._proxy.$unregisterSerializer(v)})}async $deserializeWebviewPanel(f,v,D,T){const o=this._serializers.get(v);if(!o)throw new Error(`No serializer found for '${v}'`);const{serializer:A,extension:L}=o,B=this.webviews.createNewWebview(f,D.webviewOptions,L),oe=this.createNewWebviewPanel(f,v,D.title,T,D.panelOptions,B);await A.deserializeWebviewPanel(oe,D.state)}createNewWebviewPanel(f,v,D,T,o,A){const L=new r(f,this._proxy,v,D,T,o,A);return this._webviewPanels.set(f,L),L}getWebviewPanel(f){return this._webviewPanels.get(f)}}e.ExtHostWebviewPanels=s;function i(u){return{enableFindWidget:u.enableFindWidget,retainContextWhenHidden:u.retainContextWhenHidden}}});var nt=this&&this.__classPrivateFieldSet||function(ee,e,g,F,S){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?S.call(ee,g):S?S.value=g:e.set(ee,g),g},Ue=this&&this.__classPrivateFieldGet||function(ee,e,g,F){if(g==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!F:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?F:g==="a"?F.call(ee):F?F.value:e.get(ee)};define(be[217],Ee([0,1,3,6,49,5,7]),function(ee,e,g,F,S,_,C){"use strict";var y,b,k,n,I,l,d,c,m,E;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class w extends F.Disposable{constructor(h,p,t,r,s,i){super();y.set(this,void 0),b.set(this,void 0),k.set(this,void 0),n.set(this,void 0),I.set(this,!1),l.set(this,void 0),d.set(this,void 0),c.set(this,void 0),m.set(this,this._register(new g.Emitter)),this.onDidChangeVisibility=Ue(this,m,"f").event,E.set(this,this._register(new g.Emitter)),this.onDidDispose=Ue(this,E,"f").event,nt(this,k,t,"f"),nt(this,d,r,"f"),nt(this,y,h,"f"),nt(this,b,p,"f"),nt(this,n,s,"f"),nt(this,l,i,"f")}dispose(){Ue(this,I,"f")||(nt(this,I,!0,"f"),Ue(this,E,"f").fire(),Ue(this,n,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Ue(this,d,"f")}set title(h){this.assertNotDisposed(),Ue(this,d,"f")!==h&&(nt(this,d,h,"f"),Ue(this,b,"f").$setWebviewViewTitle(Ue(this,y,"f"),h))}get description(){return this.assertNotDisposed(),Ue(this,c,"f")}set description(h){this.assertNotDisposed(),Ue(this,c,"f")!==h&&(nt(this,c,h,"f"),Ue(this,b,"f").$setWebviewViewDescription(Ue(this,y,"f"),h))}get visible(){return Ue(this,l,"f")}get webview(){return Ue(this,n,"f")}get viewType(){return Ue(this,k,"f")}_setVisible(h){h===Ue(this,l,"f")||Ue(this,I,"f")||(nt(this,l,h,"f"),Ue(this,m,"f").fire())}show(h){this.assertNotDisposed(),Ue(this,b,"f").$show(Ue(this,y,"f"),!!h)}assertNotDisposed(){if(Ue(this,I,"f"))throw new Error("Webview is disposed")}}y=new WeakMap,b=new WeakMap,k=new WeakMap,n=new WeakMap,I=new WeakMap,l=new WeakMap,d=new WeakMap,c=new WeakMap,m=new WeakMap,E=new WeakMap;class P{constructor(h,p){this._extHostWebview=p,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=h.getProxy(_.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(h,p,t,r){if(this._viewProviders.has(p))throw new Error(`View provider for '${p}' already registered`);return this._viewProviders.set(p,{provider:t,extension:h}),this._proxy.$registerWebviewViewProvider((0,S.toExtensionData)(h),p,{retainContextWhenHidden:r?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new C.Disposable(()=>{this._viewProviders.delete(p),this._proxy.$unregisterWebviewViewProvider(p)})}async $resolveWebviewView(h,p,t,r,s){const i=this._viewProviders.get(p);if(!i)throw new Error(`No view provider found for '${p}'`);const{provider:u,extension:f}=i,v=this._extHostWebview.createNewWebview(h,{},f),D=new w(h,this._proxy,p,t,v,!0);this._webviewViews.set(h,D),await u.resolveWebviewView(D,{state:r},s)}async $onDidChangeWebviewViewVisibility(h,p){this.getWebviewView(h)._setVisible(p)}async $disposeWebviewView(h){const p=this.getWebviewView(h);this._webviewViews.delete(h),p.dispose(),this._extHostWebview.deleteWebview(h)}getWebviewView(h){const p=this._webviewViews.get(h);if(!p)throw new Error("No webview found");return p}}e.ExtHostWebviewViews=P}),define(be[106],Ee([0,1,3,5,2,11,8,4,13]),function(ee,e,g,F,S,_,C,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let k=class xn{constructor(I){this._onDidChangeWindowState=new g.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=xn.InitialState,this._proxy=I.getProxy(F.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(l=>this.$onDidChangeWindowFocus(l))}get state(){return this._state}$onDidChangeWindowFocus(I){I!==this._state.focused&&(this._state={...this._state,focused:I},this._onDidChangeWindowState.fire(this._state))}openUri(I,l){let d;if(typeof I=="string"){d=I;try{I=S.URI.parse(I)}catch(c){return Promise.reject(`Invalid uri - '${I}'`)}}return(0,C.isFalsyOrWhitespace)(I.scheme)?Promise.reject("Invalid scheme - cannot be empty"):I.scheme===_.Schemas.command?Promise.reject(`Invalid scheme '${I.scheme}'`):this._proxy.$openUri(I,d,l)}async asExternalUri(I,l){if((0,C.isFalsyOrWhitespace)(I.scheme))return Promise.reject("Invalid scheme - cannot be empty");const d=await this._proxy.$asExternalUri(I,l);return S.URI.from(d)}};k.InitialState={focused:!0},k=ze([qe(0,b.IExtHostRpcService)],k),e.ExtHostWindow=k,e.IExtHostWindow=(0,y.createDecorator)("IExtHostWindow")}),define(be[218],Ee([0,1,15,5,29,13]),function(ee,e,g,F,S,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let C=class extends g.AbstractLogger{constructor(b,k){super();this._proxy=b.getProxy(F.MainContext.MainThreadLog),this._logFile=k.logFile.toJSON(),this.setLevel(k.logLevel)}$setLevel(b){this.setLevel(b)}trace(b,...k){this.getLevel()<=g.LogLevel.Trace&&this._proxy.$log(this._logFile,g.LogLevel.Trace,Array.from(arguments))}debug(b,...k){this.getLevel()<=g.LogLevel.Debug&&this._proxy.$log(this._logFile,g.LogLevel.Debug,Array.from(arguments))}info(b,...k){this.getLevel()<=g.LogLevel.Info&&this._proxy.$log(this._logFile,g.LogLevel.Info,Array.from(arguments))}warn(b,...k){this.getLevel()<=g.LogLevel.Warning&&this._proxy.$log(this._logFile,g.LogLevel.Warning,Array.from(arguments))}error(b,...k){this.getLevel()<=g.LogLevel.Error&&this._proxy.$log(this._logFile,g.LogLevel.Error,Array.from(arguments))}critical(b,...k){this.getLevel()<=g.LogLevel.Critical&&this._proxy.$log(this._logFile,g.LogLevel.Critical,Array.from(arguments))}flush(){}};C=ze([qe(0,_.IExtHostRpcService),qe(1,S.IExtHostInitDataService)],C),e.ExtHostLogService=C}),define(be[219],Ee([0,1,16,20,12,3,6,117,188,103,24]),function(ee,e,g,F,S,_,C,y,b,k,n){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function l(i,u){try{return JSON.stringify(i,u)}catch(f){return"null"}}function d(i,u){return JSON.stringify(i,u)}function c(i){return i?(u,f)=>f&&f.$mid===1?i.transformOutgoing(f):f:null}var m;(function(i){i[i.LocalSide=0]="LocalSide",i[i.OtherSide=1]="OtherSide"})(m=e.RequestInitiator||(e.RequestInitiator={}));var E;(function(i){i[i.Responsive=0]="Responsive",i[i.Unresponsive=1]="Unresponsive"})(E=e.ResponsiveState||(e.ResponsiveState={}));const w=()=>{},P=Symbol.for("rpcProtocol"),a=Symbol.for("rpcProxy");class h extends C.Disposable{constructor(u,f=null,v=null){super();this[I]=!0,this._onDidChangeResponsiveState=this._register(new _.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=u,this._logger=f,this._uriTransformer=v,this._uriReplacer=c(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let D=0,T=k.ProxyIdentifier.count;D<T;D++)this._locals[D]=null,this._proxies[D]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new g.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(D=>this._receiveOneMessage(D))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(u=>{this._pendingRPCReplies[u].resolveErr(S.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(u){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+h.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(u){this._unresponsiveTime=Date.now()+h.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(u){this._responsiveState!==u&&(this._responsiveState=u,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(u){return this._uriTransformer?(0,y.transformIncomingURIs)(u,this._uriTransformer):u}getProxy(u){const{nid:f,sid:v}=u;return this._proxies[f]||(this._proxies[f]=this._createProxy(f,v)),this._proxies[f]}_createProxy(u,f){let v={get:(D,T)=>(typeof T=="string"&&!D[T]&&T.charCodeAt(0)===36&&(D[T]=(...o)=>this._remoteCall(u,T,o)),T===a?f:D[T])};return new Proxy(Object.create(null),v)}set(u,f){return this._locals[u.nid]=f,f}assertRegistered(u){for(let f=0,v=u.length;f<v;f++){const D=u[f];if(!this._locals[D.nid])throw new Error(`Missing actor ${D.sid} (isMain: ${D.isMain})`)}}_receiveOneMessage(u){if(this._isDisposed)return;const f=u.byteLength,v=p.read(u,0),D=v.readUInt8(),T=v.readUInt32();switch(D){case 1:case 2:{let{rpcId:o,method:A,args:L}=t.deserializeRequestJSONArgs(v);this._uriTransformer&&(L=(0,y.transformIncomingURIs)(L,this._uriTransformer)),this._receiveRequest(f,T,o,A,L,D===2);break}case 3:case 4:{let{rpcId:o,method:A,args:L}=t.deserializeRequestMixedArgs(v);this._uriTransformer&&(L=(0,y.transformIncomingURIs)(L,this._uriTransformer)),this._receiveRequest(f,T,o,A,L,D===4);break}case 5:{this._logger&&this._logger.logIncoming(f,T,0,"ack"),this._onDidReceiveAcknowledge(T);break}case 6:{this._receiveCancel(f,T);break}case 7:{this._receiveReply(f,T,void 0);break}case 9:{let o=t.deserializeReplyOKJSON(v);this._uriTransformer&&(o=(0,y.transformIncomingURIs)(o,this._uriTransformer)),this._receiveReply(f,T,o);break}case 8:{let o=t.deserializeReplyOKVSBuffer(v);this._receiveReply(f,T,o);break}case 10:{let o=t.deserializeReplyErrError(v);this._uriTransformer&&(o=(0,y.transformIncomingURIs)(o,this._uriTransformer)),this._receiveReplyErr(f,T,o);break}case 11:{this._receiveReplyErr(f,T,void 0);break}default:console.error("received unexpected message"),console.error(u)}}_receiveRequest(u,f,v,D,T,o){this._logger&&this._logger.logIncoming(u,f,1,`receiveRequest ${(0,k.getStringIdentifierForProxy)(v)}.${D}(`,T);const A=String(f);let L,B;if(o){const he=new F.CancellationTokenSource;T.push(he.token),L=this._invokeHandler(v,D,T),B=()=>he.cancel()}else L=this._invokeHandler(v,D,T),B=w;this._cancelInvokedHandlers[A]=B;const oe=t.serializeAcknowledged(f);this._logger&&this._logger.logOutgoing(oe.byteLength,f,1,"ack"),this._protocol.send(oe),L.then(he=>{delete this._cancelInvokedHandlers[A];const Q=t.serializeReplyOK(f,he,this._uriReplacer);this._logger&&this._logger.logOutgoing(Q.byteLength,f,1,"reply:",he),this._protocol.send(Q)},he=>{delete this._cancelInvokedHandlers[A];const Q=t.serializeReplyErr(f,he);this._logger&&this._logger.logOutgoing(Q.byteLength,f,1,"replyErr:",he),this._protocol.send(Q)})}_receiveCancel(u,f){this._logger&&this._logger.logIncoming(u,f,1,"receiveCancel");const v=String(f);this._cancelInvokedHandlers[v]&&this._cancelInvokedHandlers[v]()}_receiveReply(u,f,v){this._logger&&this._logger.logIncoming(u,f,0,"receiveReply:",v);const D=String(f);if(!this._pendingRPCReplies.hasOwnProperty(D))return;const T=this._pendingRPCReplies[D];delete this._pendingRPCReplies[D],T.resolveOk(v)}_receiveReplyErr(u,f,v){this._logger&&this._logger.logIncoming(u,f,0,"receiveReplyErr:",v);const D=String(f);if(!this._pendingRPCReplies.hasOwnProperty(D))return;const T=this._pendingRPCReplies[D];delete this._pendingRPCReplies[D];let o;v&&(v.$isError?(o=new Error,o.name=v.name,o.message=v.message,o.stack=v.stack):o=v),T.resolveErr(o)}_invokeHandler(u,f,v){try{return Promise.resolve(this._doInvokeHandler(u,f,v))}catch(D){return Promise.reject(D)}}_doInvokeHandler(u,f,v){const D=this._locals[u];if(!D)throw new Error("Unknown actor "+(0,k.getStringIdentifierForProxy)(u));let T=D[f];if(typeof T!="function")throw new Error("Unknown method "+f+" on actor "+(0,k.getStringIdentifierForProxy)(u));return T.apply(D,v)}_remoteCall(u,f,v){if(this._isDisposed)return Promise.reject(S.canceled());let D=null;if(v.length>0&&F.CancellationToken.isCancellationToken(v[v.length-1])&&(D=v.pop()),D&&D.isCancellationRequested)return Promise.reject(S.canceled());const T=t.serializeRequestArguments(v,this._uriReplacer),o=++this._lastMessageId,A=String(o),L=new b.LazyPromise;D&&D.onCancellationRequested(()=>{const oe=t.serializeCancel(o);this._logger&&this._logger.logOutgoing(oe.byteLength,o,0,"cancel"),this._protocol.send(t.serializeCancel(o))}),this._pendingRPCReplies[A]=L,this._onWillSendRequest(o);const B=t.serializeRequest(o,u,f,T,!!D);return this._logger&&this._logger.logOutgoing(B.byteLength,o,0,`request: ${(0,k.getStringIdentifierForProxy)(u)}.${f}(`,v),this._protocol.send(B),L}}e.RPCProtocol=h,I=P,h.UNRESPONSIVE_TIME=3*1e3;class p{constructor(u,f){this._buff=u,this._offset=f}static alloc(u,f,v){let D=new p(n.VSBuffer.alloc(v+1+4),0);return D.writeUInt8(u),D.writeUInt32(f),D}static read(u,f){return new p(u,f)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(u){this._buff.writeUInt8(u,this._offset),this._offset+=1}readUInt8(){const u=this._buff.readUInt8(this._offset);return this._offset+=1,u}writeUInt32(u){this._buff.writeUInt32BE(u,this._offset),this._offset+=4}readUInt32(){const u=this._buff.readUInt32BE(this._offset);return this._offset+=4,u}static sizeShortString(u){return 1+u.byteLength}writeShortString(u){this._buff.writeUInt8(u.byteLength,this._offset),this._offset+=1,this._buff.set(u,this._offset),this._offset+=u.byteLength}readShortString(){const u=this._buff.readUInt8(this._offset);this._offset+=1;const v=this._buff.slice(this._offset,this._offset+u).toString();return this._offset+=u,v}static sizeLongString(u){return 4+u.byteLength}writeLongString(u){this._buff.writeUInt32BE(u.byteLength,this._offset),this._offset+=4,this._buff.set(u,this._offset),this._offset+=u.byteLength}readLongString(){const u=this._buff.readUInt32BE(this._offset);this._offset+=4;const v=this._buff.slice(this._offset,this._offset+u).toString();return this._offset+=u,v}writeBuffer(u){this._buff.writeUInt32BE(u.byteLength,this._offset),this._offset+=4,this._buff.set(u,this._offset),this._offset+=u.byteLength}static sizeVSBuffer(u){return 4+u.byteLength}writeVSBuffer(u){this._buff.writeUInt32BE(u.byteLength,this._offset),this._offset+=4,this._buff.set(u,this._offset),this._offset+=u.byteLength}readVSBuffer(){const u=this._buff.readUInt32BE(this._offset);this._offset+=4;const f=this._buff.slice(this._offset,this._offset+u);return this._offset+=u,f}static sizeMixedArray(u,f){let v=0;v+=1;for(let D=0,T=u.length;D<T;D++){const o=u[D],A=f[D];switch(v+=1,A){case 1:v+=this.sizeLongString(o);break;case 2:v+=this.sizeVSBuffer(o);break;case 3:break}}return v}writeMixedArray(u,f){this._buff.writeUInt8(u.length,this._offset),this._offset+=1;for(let v=0,D=u.length;v<D;v++){const T=u[v];switch(f[v]){case 1:this.writeUInt8(1),this.writeLongString(T);break;case 2:this.writeUInt8(2),this.writeVSBuffer(T);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const u=this._buff.readUInt8(this._offset);this._offset+=1;let f=new Array(u);for(let v=0;v<u;v++)switch(this.readUInt8()){case 1:f[v]=this.readLongString();break;case 2:f[v]=this.readVSBuffer();break;case 3:f[v]=void 0;break}return f}}class t{static _arrayContainsBufferOrUndefined(u){for(let f=0,v=u.length;f<v;f++)if(u[f]instanceof n.VSBuffer||typeof u[f]=="undefined")return!0;return!1}static serializeRequestArguments(u,f){if(this._arrayContainsBufferOrUndefined(u)){let v=[],D=[];for(let T=0,o=u.length;T<o;T++){const A=u[T];A instanceof n.VSBuffer?(v[T]=A,D[T]=2):typeof A=="undefined"?(v[T]=n.VSBuffer.alloc(0),D[T]=3):(v[T]=n.VSBuffer.fromString(d(A,f)),D[T]=1)}return{type:"mixed",args:v,argsType:D}}return{type:"simple",args:d(u,f)}}static serializeRequest(u,f,v,D,T){return D.type==="mixed"?this._requestMixedArgs(u,f,v,D.args,D.argsType,T):this._requestJSONArgs(u,f,v,D.args,T)}static _requestJSONArgs(u,f,v,D,T){const o=n.VSBuffer.fromString(v),A=n.VSBuffer.fromString(D);let L=0;L+=p.sizeUInt8(),L+=p.sizeShortString(o),L+=p.sizeLongString(A);let B=p.alloc(T?2:1,u,L);return B.writeUInt8(f),B.writeShortString(o),B.writeLongString(A),B.buffer}static deserializeRequestJSONArgs(u){const f=u.readUInt8(),v=u.readShortString(),D=u.readLongString();return{rpcId:f,method:v,args:JSON.parse(D)}}static _requestMixedArgs(u,f,v,D,T,o){const A=n.VSBuffer.fromString(v);let L=0;L+=p.sizeUInt8(),L+=p.sizeShortString(A),L+=p.sizeMixedArray(D,T);let B=p.alloc(o?4:3,u,L);return B.writeUInt8(f),B.writeShortString(A),B.writeMixedArray(D,T),B.buffer}static deserializeRequestMixedArgs(u){const f=u.readUInt8(),v=u.readShortString(),D=u.readMixedArray(),T=new Array(D.length);for(let o=0,A=D.length;o<A;o++){const L=D[o];typeof L=="string"?T[o]=JSON.parse(L):T[o]=L}return{rpcId:f,method:v,args:T}}static serializeAcknowledged(u){return p.alloc(5,u,0).buffer}static serializeCancel(u){return p.alloc(6,u,0).buffer}static serializeReplyOK(u,f,v){return typeof f=="undefined"?this._serializeReplyOKEmpty(u):f instanceof n.VSBuffer?this._serializeReplyOKVSBuffer(u,f):this._serializeReplyOKJSON(u,l(f,v))}static _serializeReplyOKEmpty(u){return p.alloc(7,u,0).buffer}static _serializeReplyOKVSBuffer(u,f){let v=0;v+=p.sizeVSBuffer(f);let D=p.alloc(8,u,v);return D.writeVSBuffer(f),D.buffer}static deserializeReplyOKVSBuffer(u){return u.readVSBuffer()}static _serializeReplyOKJSON(u,f){const v=n.VSBuffer.fromString(f);let D=0;D+=p.sizeLongString(v);let T=p.alloc(9,u,D);return T.writeLongString(v),T.buffer}static deserializeReplyOKJSON(u){const f=u.readLongString();return JSON.parse(f)}static serializeReplyErr(u,f){return f?this._serializeReplyErrEror(u,f):this._serializeReplyErrEmpty(u)}static _serializeReplyErrEror(u,f){const v=n.VSBuffer.fromString(l(S.transformErrorForSerialization(f),null));let D=0;D+=p.sizeLongString(v);let T=p.alloc(10,u,D);return T.writeLongString(v),T.buffer}static deserializeReplyErrError(u){const f=u.readLongString();return JSON.parse(f)}static _serializeReplyErrEmpty(u){return p.alloc(11,u,0).buffer}}var r;(function(i){i[i.RequestJSONArgs=1]="RequestJSONArgs",i[i.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",i[i.RequestMixedArgs=3]="RequestMixedArgs",i[i.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",i[i.Acknowledged=5]="Acknowledged",i[i.Cancel=6]="Cancel",i[i.ReplyOKEmpty=7]="ReplyOKEmpty",i[i.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",i[i.ReplyOKJSON=9]="ReplyOKJSON",i[i.ReplyErrError=10]="ReplyErrError",i[i.ReplyErrEmpty=11]="ReplyErrEmpty"})(r||(r={}));var s;(function(i){i[i.String=1]="String",i[i.VSBuffer=2]="VSBuffer",i[i.Undefined=3]="Undefined"})(s||(s={}))}),define(be[220],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const g=function(_){const C=y=>{self.removeEventListener("message",C);const b=y.data;Object.defineProperties(self,{postMessage:{value(k,n){b.postMessage(k,n)}},onmessage:{get(){return b.onmessage},set(k){b.onmessage=k}}}),b.addEventListener("message",k=>{self.dispatchEvent(new MessageEvent("message",{data:k.data}))}),b.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(_)};self.addEventListener("message",C)}.toString();class F extends EventTarget{constructor(_,C,y){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const b=`((${g})('${C}'))`,k=new Blob([b],{type:"application/javascript"}),n=URL.createObjectURL(k),I=new MessageChannel,l=n,d={type:"_newWorker",id:l,port:I.port2,url:n,options:y};_(d,[I.port2]),this.postMessage=I.port1.postMessage.bind(I.port1),this.terminate=()=>{const c={type:"_terminateWorker",id:l};I.port1.postMessage(c),URL.revokeObjectURL(n),I.port1.close(),I.port2.close()},Object.defineProperties(this,{onmessage:{get(){return I.port1.onmessage},set(c){I.port1.onmessage=c}},onmessageerror:{get(){return I.port1.onmessageerror},set(c){I.port1.onmessageerror=c}}}),I.port1.addEventListener("messageerror",c=>{const m=new MessageEvent("messageerror",{data:c.data});this.dispatchEvent(m)}),I.port1.addEventListener("message",c=>{const m=new MessageEvent("message",{data:c.data});this.dispatchEvent(m)}),I.port1.start()}}e.NestedWorker=F}),define(be[221],Ee([0,1,4]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,g.createDecorator)("remoteAgentService")}),define(be[222],Ee([0,1,11,14,22,2,4,96,46,184,221]),function(ee,e,g,F,S,_,C,y,b,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,C.createDecorator)("pathService");let I=class Bn{constructor(d,c,m,E){this.localUserHome=d,this.remoteAgentService=c,this.environmentService=m,this.contextService=E,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||S.OS)(),this.resolveUserHome=(async()=>{const w=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=w?.userHome||d})()}get defaultUriScheme(){return Bn.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(d,c){if(d.remoteAuthority)return g.Schemas.vscodeRemote;const m=(0,y.getVirtualWorkspaceScheme)(c.getWorkspace());if(m)return m;const E=c.getWorkspace().folders[0];if(E)return E.uri.scheme;const w=c.getWorkspace().configuration;return w?w.scheme:g.Schemas.file}async userHome(d){return d?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(d=>d===1?F.win32:F.posix)}async fileURI(d){let c="";if(await this.resolveOS===1&&(d=d.replace(/\\/g,"/")),d[0]==="/"&&d[1]==="/"){const E=d.indexOf("/",2);E===-1?(c=d.substring(2),d="/"):(c=d.substring(2,E),d=d.substring(E)||"/")}return _.URI.from({scheme:g.Schemas.file,authority:c,path:d,query:"",fragment:""})}};I=ze([qe(1,n.IRemoteAgentService),qe(2,k.IWorkbenchEnvironmentService),qe(3,b.IWorkspaceContextService)],I),e.AbstractPathService=I}),define(be[107],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class g{constructor(C,y){this.line=C,this.character=y}isBefore(C){return!1}isBeforeOrEqual(C){return!1}isAfter(C){return!1}isAfterOrEqual(C){return!1}isEqual(C){return!1}compareTo(C){return 0}translate(C,y){return new g(0,0)}with(C){return new g(0,0)}}e.Position=g;class F{constructor(C,y,b,k){this.isEmpty=!1,this.isSingleLine=!1,this.start=new g(C,y),this.end=new g(b,k)}contains(C){return!1}isEqual(C){return!1}intersection(C){}union(C){return new F(0,0,0,0)}with(C){return new F(0,0,0,0)}}e.Range=F;var S;(function(_){_[_.Information=1]="Information",_[_.Warning=2]="Warning"})(S=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(be[39],Ee([0,1,17,27,23,44,8,4,14,12,107]),function(ee,e,g,F,S,_,C,y,b,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return n.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const I="\u27EA ",l=" characters skipped \u27EB",d=(I.length+l.length+5)*2;e.ISearchService=(0,y.createDecorator)("searchService");var c;(function(R){R[R.file=0]="file",R[R.text=1]="text"})(c=e.SearchProviderType||(e.SearchProviderType={}));var m;(function(R){R[R.File=1]="File",R[R.Text=2]="Text"})(m=e.QueryType||(e.QueryType={}));function E(R){return!!R.preview}e.resultIsMatch=E;function w(R){return!!R.resource}e.isFileMatch=w;function P(R){return!!R.message}e.isProgressMessage=P;var a;(function(R){R[R.Normal=0]="Normal",R[R.NewSearchStarted=1]="NewSearchStarted"})(a=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class h{constructor(K){this.resource=K,this.results=[]}}e.FileMatch=h;class p{constructor(K,x,j){this.ranges=x;const ue=Array.isArray(x)?x:[x];if(j&&j.matchLines===1&&t(ue)){K=(0,C.getNLines)(K,j.matchLines);let $="",te=0,ce=0;const ye=Math.floor(j.charsPerLine/5),Re=[];for(const Te of ue){const $e=Math.max(Te.startColumn-ye,0),Je=Te.startColumn+j.charsPerLine;if($e>ce+ye+d){const Ve=I+($e-ce)+l;$+=Ve+K.slice($e,Je),te+=$e-(ce+Ve.length)}else $+=K.slice(ce,Je);Re.push(new s(0,Te.startColumn-te,Te.endColumn-te)),ce=Je}this.preview={text:$,matches:Array.isArray(this.ranges)?Re:Re[0]}}else{const $=Array.isArray(x)?x[0].startLineNumber:x.startLineNumber;this.preview={text:K,matches:(0,g.mapArrayOrNot)(x,te=>new r(te.startLineNumber-$,te.startColumn,te.endLineNumber-$,te.endColumn))}}}}e.TextSearchMatch=p;function t(R){const K=R[0].startLineNumber;for(const x of R)if(x.startLineNumber!==K||x.endLineNumber!==K)return!1;return!0}class r{constructor(K,x,j,ue){this.startLineNumber=K,this.startColumn=x,this.endLineNumber=j,this.endColumn=ue}}e.SearchRange=r;class s extends r{constructor(K,x,j){super(K,x,K,j)}}e.OneLineRange=s;var i;(function(R){R.Default="default",R.FileNames="fileNames",R.Type="type",R.Modified="modified",R.CountDescending="countDescending",R.CountAscending="countAscending"})(i=e.SearchSortOrder||(e.SearchSortOrder={}));function u(R,K=!0){const x=R&&R.files&&R.files.exclude,j=K&&R&&R.search&&R.search.exclude;if(!x&&!j)return;if(!x||!j)return x||j;let ue=Object.create(null);return ue=S.mixin(ue,S.deepClone(x)),ue=S.mixin(ue,S.deepClone(j),!0),ue}e.getExcludes=u;function f(R,K){return R.excludePattern&&F.match(R.excludePattern,K)?!1:R.includePattern||R.usingSearchPaths?R.includePattern&&F.match(R.includePattern,K)?!0:R.usingSearchPaths?!!R.folderQueries&&R.folderQueries.some(x=>{const j=x.folder.fsPath;if(_.isEqualOrParent(K,j)){const ue=b.relative(j,K);return!x.includePattern||!!F.match(x.includePattern,ue)}else return!1}):!1:!0}e.pathIncludedInQuery=f;var v;(function(R){R[R.unknownEncoding=1]="unknownEncoding",R[R.regexParseError=2]="regexParseError",R[R.globParseError=3]="globParseError",R[R.invalidLiteral=4]="invalidLiteral",R[R.rgProcessError=5]="rgProcessError",R[R.other=6]="other",R[R.canceled=7]="canceled"})(v=e.SearchErrorCode||(e.SearchErrorCode={}));class D extends Error{constructor(K,x){super(K);this.code=x}}e.SearchError=D;function T(R){const K=R.message;if((0,k.isPromiseCanceledError)(R))return new D(K,v.canceled);try{const x=JSON.parse(K);return new D(x.message,x.code)}catch(x){return new D(K,v.other)}}e.deserializeSearchError=T;function o(R){const K={message:R.message,code:R.code};return new Error(JSON.stringify(K))}e.serializeSearchError=o;function A(R){return R.type==="error"?!0:R.type==="success"}e.isSerializedSearchComplete=A;function L(R){return R.type==="success"}e.isSerializedSearchSuccess=L;function B(R){return!!R.path}e.isSerializedFileMatch=B;function oe(R,K){const x=R.searchPath?R.searchPath:R.relativePath;return(0,C.fuzzyContains)(x,K)}e.isFilePatternMatch=oe;class he{constructor(K){this.path=K,this.results=[]}addMatch(K){this.results.push(K)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=he;function Q(R,K){const x={...R||{},...K||{}};return Object.keys(x).filter(j=>{const ue=x[j];return typeof ue=="boolean"&&ue})}e.resolvePatternsForProvider=Q;class z{constructor(K,x){this._parsedIncludeExpression=null,this._excludeExpression={...K.excludePattern||{},...x.excludePattern||{}},this._parsedExcludeExpression=F.parse(this._excludeExpression);let j=K.includePattern;x.includePattern&&(j?j={...j,...x.includePattern}:j=x.includePattern),j&&(this._parsedIncludeExpression=F.parse(j))}includedInQuerySync(K,x,j){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(K,x,j)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(K,x,j))}includedInQuery(K,x,j){return Promise.resolve(this._parsedExcludeExpression(K,x,j)).then($=>!!$).then($=>$?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(K,x,j)).then(te=>!!te):Promise.resolve(!0)).then($=>$)}hasSiblingExcludeClauses(){return V(this._excludeExpression)}}e.QueryGlobTester=z;function V(R){for(const K in R)if(typeof R[K]!="boolean")return!0;return!1}}),define(be[32],Ee([0,1,17,16,20,3,21,11,81,25,8,10,2,139,4,15,154,46,47,29,13,7,39,5]),function(ee,e,g,F,S,_,C,y,b,k,n,I,l,d,c,m,E,w,P,a,h,p,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function s(A,L,B){return new k.ExtUri(oe=>v(oe,B)).isEqual(A,L)}function i(A,L,B){return s(A.uri,L.uri,B)?0:(0,n.compare)(A.uri.toString(),L.uri.toString())}function u(A,L,B){return A.index!==L.index?A.index<L.index?-1:1:s(A.uri,L.uri,B)?(0,n.compare)(A.name,L.name):(0,n.compare)(A.uri.toString(),L.uri.toString())}function f(A,L,B,oe){const he=A.slice(0).sort((z,V)=>B(z,V,oe)),Q=L.slice(0).sort((z,V)=>B(z,V,oe));return(0,g.delta)(he,Q,(z,V)=>B(z,V,oe))}function v(A,L){const B=L.getCapabilities(A.scheme);return!(B&&B&1024)}class D extends w.Workspace{constructor(L,B,oe,he,Q,z){super(L,oe.map(V=>new w.WorkspaceFolder(V)),he,z);this._name=B,this._isUntitled=Q,this._workspaceFolders=[],this._structure=C.TernarySearchTree.forUris(z),oe.forEach(V=>{this._workspaceFolders.push(V),this._structure.set(V.uri,V)})}static toExtHostWorkspace(L,B,oe,he){if(!L)return{workspace:null,added:[],removed:[]};const{id:Q,name:z,folders:V,configuration:R,isUntitled:K}=L,x=[],j=B;B?V.forEach((ce,ye)=>{const Re=l.URI.revive(ce.uri),Te=D._findFolder(oe||B,Re,he);Te?(Te.name=ce.name,Te.index=ce.index,x.push(Te)):x.push({uri:Re,name:ce.name,index:ye})}):x.push(...V.map(({uri:ce,name:ye,index:Re})=>({uri:l.URI.revive(ce),name:ye,index:Re}))),x.sort((ce,ye)=>ce.index<ye.index?-1:1);const ue=new D(Q,z,x,R?l.URI.revive(R):null,!!K,ce=>v(ce,he)),{added:$,removed:te}=f(j?j.workspaceFolders:[],ue.workspaceFolders,i,he);return{workspace:ue,added:$,removed:te}}static _findFolder(L,B,oe){for(let he=0;he<L.folders.length;he++){const Q=L.workspaceFolders[he];if(s(Q.uri,B,oe))return Q}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(L,B){return B&&this._structure.get(L)&&(L=(0,k.dirname)(L)),this._structure.findSubstr(L)}resolveWorkspaceFolder(L){return this._structure.get(L)}}let T=class{constructor(L,B,oe,he){this._onDidChangeWorkspace=new _.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new _.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=he,this._extHostFileSystemInfo=oe,this._requestIdProvider=new b.Counter,this._barrier=new F.Barrier,this._proxy=L.getProxy(r.MainContext.MainThreadWorkspace),this._messageService=L.getProxy(r.MainContext.MainThreadMessageService);const Q=B.workspace;this._confirmedWorkspace=Q?new D(Q.id,Q.name,[],Q.configuration?l.URI.revive(Q.configuration):null,!!Q.isUntitled,z=>v(z,oe)):void 0}$initializeWorkspace(L,B){this._trusted=B,this.$acceptWorkspaceData(L),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?l.URI.from({scheme:y.Schemas.untitled,path:(0,k.basename)((0,k.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(L,B,oe,...he){const Q=[];if(Array.isArray(he)&&he.forEach(x=>{l.URI.isUri(x.uri)&&!Q.some(j=>s(j.uri,x.uri,this._extHostFileSystemInfo))&&Q.push({uri:x.uri,name:x.name||(0,k.basenameOrAuthority)(x.uri)})}),this._unconfirmedWorkspace||[B,oe].some(x=>typeof x!="number"||x<0)||oe===0&&Q.length===0)return!1;const z=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(B+oe>z.length)return!1;const V=z.slice(0);V.splice(B,oe,...Q.map(x=>({uri:x.uri,name:x.name||(0,k.basenameOrAuthority)(x.uri),index:void 0})));for(let x=0;x<V.length;x++){const j=V[x];if(V.some((ue,$)=>$!==x&&s(j.uri,ue.uri,this._extHostFileSystemInfo)))return!1}V.forEach((x,j)=>x.index=j);const{added:R,removed:K}=f(z,V,u,this._extHostFileSystemInfo);if(R.length===0&&K.length===0)return!1;if(this._proxy){const x=L.displayName||L.name;this._proxy.$updateWorkspaceFolders(x,B,oe,Q).then(void 0,j=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(E.Severity.Error,(0,d.localize)(0,null,x,j.toString()),{extension:L},[])})}return this.trySetWorkspaceFolders(V),!0}getWorkspaceFolder(L,B){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,B)}async getWorkspaceFolder2(L,B){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,B)}async resolveWorkspaceFolder(L){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(L)}getPath(){if(!this._actualWorkspace)return;const{folders:L}=this._actualWorkspace;if(L.length!==0)return L[0].uri.fsPath}getRelativePath(L,B){let oe,he="";if(typeof L=="string"?(oe=l.URI.file(L),he=L):typeof L!="undefined"&&(oe=L,he=L.fsPath),!oe)return he;const Q=this.getWorkspaceFolder(oe,!0);if(!Q)return he;typeof B=="undefined"&&this._actualWorkspace&&(B=this._actualWorkspace.folders.length>1);let z=(0,k.relativePath)(Q.uri,oe);return B&&Q.name&&(z=`${Q.name}/${z}`),z}trySetWorkspaceFolders(L){this._actualWorkspace&&(this._unconfirmedWorkspace=D.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:L,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(L){const{workspace:B,added:oe,removed:he}=D.toExtHostWorkspace(L,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=B||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:oe,removed:he}))}findFiles(L,B,oe,he,Q=S.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${he.value}, entryPoint: findFiles`);let z;if(B===null?z=!1:B&&(typeof B=="string"?z=B:z=B.pattern),Q&&Q.isCancellationRequested)return Promise.resolve([]);const{includePattern:V,folder:R}=o(L);return this._proxy.$startFileSearch((0,I.withUndefinedAsNull)(V),(0,I.withUndefinedAsNull)(R),(0,I.withUndefinedAsNull)(z),(0,I.withUndefinedAsNull)(oe),Q).then(K=>Array.isArray(K)?K.map(x=>l.URI.revive(x)):[])}async findTextInFiles(L,B,oe,he,Q=S.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${he.value}, entryPoint: findTextInFiles`);const z=this._requestIdProvider.getNext(),V=typeof B.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:B.previewOptions,{includePattern:R,folder:K}=o(B.include),x=typeof B.exclude=="string"?B.exclude:B.exclude?B.exclude.pattern:void 0,j={ignoreSymlinks:typeof B.followSymlinks=="boolean"?!B.followSymlinks:void 0,disregardIgnoreFiles:typeof B.useIgnoreFiles=="boolean"?!B.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof B.useGlobalIgnoreFiles=="boolean"?!B.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof B.useDefaultExcludes=="boolean"?!B.useDefaultExcludes:!0,fileEncoding:B.encoding,maxResults:B.maxResults,previewOptions:V,afterContext:B.afterContext,beforeContext:B.beforeContext,includePattern:R,excludePattern:x},ue=!1;if(this._activeSearchCallbacks[z]=$=>{if(ue)return;const te=l.URI.revive($.resource);$.results.forEach(ce=>{(0,t.resultIsMatch)(ce)?oe({uri:te,preview:{text:ce.preview.text,matches:(0,g.mapArrayOrNot)(ce.preview.matches,ye=>new p.Range(ye.startLineNumber,ye.startColumn,ye.endLineNumber,ye.endColumn))},ranges:(0,g.mapArrayOrNot)(ce.ranges,ye=>new p.Range(ye.startLineNumber,ye.startColumn,ye.endLineNumber,ye.endColumn))}):oe({uri:te,text:ce.text,lineNumber:ce.lineNumber})})},Q.isCancellationRequested)return{};try{const $=await this._proxy.$startTextSearch(L,(0,I.withUndefinedAsNull)(K),j,z,Q);return delete this._activeSearchCallbacks[z],$||{}}catch($){throw delete this._activeSearchCallbacks[z],$}}$handleTextSearchResult(L,B){this._activeSearchCallbacks[B]&&this._activeSearchCallbacks[B](L)}saveAll(L){return this._proxy.$saveAll(L)}resolveProxy(L){return this._proxy.$resolveProxy(L)}get trusted(){return this._trusted}requestWorkspaceTrust(L){return this._proxy.$requestWorkspaceTrust(L)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};T=ze([qe(0,h.IExtHostRpcService),qe(1,a.IExtHostInitDataService),qe(2,P.IExtHostFileSystemInfo),qe(3,m.ILogService)],T),e.ExtHostWorkspace=T,e.IExtHostWorkspace=(0,c.createDecorator)("IExtHostWorkspace");function o(A){let L,B;return A&&(typeof A=="string"?L=A:(L=A.pattern,B=A.baseFolder||l.URI.file(A.base))),{includePattern:L,folder:B}}}),define(be[33],Ee([0,1,23,3,32,5,7,157,63,10,16,4,13,15,2]),function(ee,e,g,F,S,_,C,y,b,k,n,I,l,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function m(r,s){if(s){const i=s.split(".");let u=r;for(let f=0;u&&f<i.length;f++)u=u[i[f]];return u}}function E(r){return r instanceof c.URI}function w(r){return r&&r.uri instanceof c.URI&&r.languageId&&typeof r.languageId=="string"}function P(r){return r&&!r.uri&&r.languageId&&typeof r.languageId=="string"}function a(r){return r&&r.uri instanceof c.URI&&(!r.name||typeof r.name=="string")&&(!r.index||typeof r.index=="number")}function h(r){if(E(r))return{resource:r};if(w(r))return{resource:r.uri,overrideIdentifier:r.languageId};if(P(r))return{overrideIdentifier:r.languageId};if(a(r))return{resource:r.uri};if(r===null)return{resource:null}}let p=class{constructor(s,i,u){this._proxy=s.getProxy(_.MainContext.MainThreadConfiguration),this._extHostWorkspace=i,this._logService=u,this._barrier=new n.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(s=>this._actual)}$initializeConfiguration(s){this._actual=new t(this._proxy,this._extHostWorkspace,s,this._logService),this._barrier.open()}$acceptConfigurationChanged(s,i){this.getConfigProvider().then(u=>u.$acceptConfigurationChanged(s,i))}};p=ze([qe(0,l.IExtHostRpcService),qe(1,S.IExtHostWorkspace),qe(2,d.ILogService)],p),e.ExtHostConfiguration=p;class t{constructor(s,i,u,f){this._onDidChangeConfiguration=new F.Emitter,this._proxy=s,this._logService=f,this._extHostWorkspace=i,this._configuration=y.Configuration.parse(u),this._configurationScopes=this._toMap(u.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(s,i){const u={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=y.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(i,u))}getConfiguration(s,i,u){const f=h(i)||{},v=this._toReadonlyValue(s?m(this._configuration.getValue(void 0,f,this._extHostWorkspace.workspace),s):this._configuration.getValue(void 0,f,this._extHostWorkspace.workspace));s&&this._validateConfigurationAccess(s,f,u?.identifier);function D(o){if(o==null)return null;if(typeof o=="boolean")return o?1:4;switch(o){case C.ConfigurationTarget.Global:return 1;case C.ConfigurationTarget.Workspace:return 4;case C.ConfigurationTarget.WorkspaceFolder:return 5}}const T={has(o){return typeof m(v,o)!="undefined"},get:(o,A)=>{this._validateConfigurationAccess(s?`${s}.${o}`:o,f,u?.identifier);let L=m(v,o);if(typeof L=="undefined")L=A;else{let B;const oe=(he,Q)=>{let z;const V=()=>{B=B||(0,g.deepClone)(v),z=z||m(B,Q)};return(0,k.isObject)(he)?new Proxy(he,{get:(R,K)=>{if(typeof K=="string"&&K.toLowerCase()==="tojson")return V(),()=>z;if(B)return z=z||m(B,Q),z[K];const x=R[K];return typeof K=="string"?oe(x,`${Q}.${K}`):x},set:(R,K,x)=>(V(),z&&(z[K]=x),!0),deleteProperty:(R,K)=>(V(),z&&delete z[K],!0),defineProperty:(R,K,x)=>(V(),z&&Object.defineProperty(z,K,x),!0)}):he};L=oe(L,o)}return L},update:(o,A,L,B)=>{o=s?`${s}.${o}`:o;const oe=D(L);return A!==void 0?this._proxy.$updateConfigurationOption(oe,o,A,f,B):this._proxy.$removeConfigurationOption(oe,o,f,B)},inspect:o=>{o=s?`${s}.${o}`:o;const A=(0,g.deepClone)(this._configuration.inspect(o,f,this._extHostWorkspace.workspace));if(A)return{key:o,defaultValue:A.default?.value,globalValue:A.user?.value,workspaceValue:A.workspace?.value,workspaceFolderValue:A.workspaceFolder?.value,defaultLanguageValue:A.default?.override,globalLanguageValue:A.user?.override,workspaceLanguageValue:A.workspace?.override,workspaceFolderLanguageValue:A.workspaceFolder?.override,languageIds:A.overrideIdentifiers}}};return typeof v=="object"&&(0,g.mixin)(T,v,!1),Object.freeze(T)}_toReadonlyValue(s){const i=u=>(0,k.isObject)(u)?new Proxy(u,{get:(f,v)=>i(f[v]),set:(f,v,D)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(v)}' of object`)},deleteProperty:(f,v)=>{throw new Error(`TypeError: Cannot delete read only property '${String(v)}' of object`)},defineProperty:(f,v)=>{throw new Error(`TypeError: Cannot define property '${String(v)}' for a readonly object`)},setPrototypeOf:f=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):u;return i(s)}_validateConfigurationAccess(s,i,u){const f=b.OVERRIDE_PROPERTY_PATTERN.test(s)?4:this._configurationScopes.get(s),v=u?`[${u.value}] `:"";if(f===4){typeof i?.resource=="undefined"&&this._logService.warn(`${v}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(f===3){i?.resource&&this._logService.warn(`${v}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(s,i){const u=new y.ConfigurationChangeEvent(s,i,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(f,v)=>u.affectsConfiguration(f,h(v))})}_toMap(s){return s.reduce((i,u)=>(i.set(u[0],u[1]),i),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,I.createDecorator)("IExtHostConfiguration")});var nt=this&&this.__classPrivateFieldSet||function(ee,e,g,F,S){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?S.call(ee,g):S?S.value=g:e.set(ee,g),g},Ue=this&&this.__classPrivateFieldGet||function(ee,e,g,F){if(g==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!F:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?F:g==="a"?F.call(ee):F?F.value:e.get(ee)};define(be[108],Ee([0,1,2,16,3,5,7,32,48,33,20,38,13,29,4,11,22,15,74,174,12]),function(ee,e,g,F,S,_,C,y,b,k,n,I,l,d,c,m,E,w,P,a,h){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(he){function Q(V){if(V!=null)return V}he.from=Q;function z(V){if(V!=null)return V}he.to=z})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var r;(function(he){function Q(V){if(V!=null)return V}he.from=Q;function z(V){if(V!=null)return V}he.to=z})(r=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var s;(function(he){function Q(V){if(V!=null)return V}he.from=Q;function z(V){if(V!=null)return V}he.to=z})(s=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var i;(function(he){function Q(R){if(R){const K=R;return K&&!!K.process}else return!1}he.is=Q;function z(R){if(R==null)return;const K={process:R.process,args:R.args};return R.options&&(K.options=s.from(R.options)),K}he.from=z;function V(R){if(R!=null)return new C.ProcessExecution(R.process,R.args,R.options)}he.to=V})(i=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var u;(function(he){function Q(V){if(V!=null)return V}he.from=Q;function z(V){if(V!=null)return V}he.to=z})(u=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var f;(function(he){function Q(R){if(R){const K=R;return K&&(!!K.commandLine||!!K.command)}else return!1}he.is=Q;function z(R){if(R==null)return;const K={};return R.commandLine!==void 0?K.commandLine=R.commandLine:(K.command=R.command,K.args=R.args),R.options&&(K.options=u.from(R.options)),K}he.from=z;function V(R){if(!(R==null||R.command===void 0&&R.commandLine===void 0))return R.commandLine?new C.ShellExecution(R.commandLine,R.options):new C.ShellExecution(R.command,R.args?R.args:[],R.options)}he.to=V})(f=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var v;(function(he){function Q(R){if(R){let K=R;return K&&K.customExecution==="customExecution"}else return!1}he.is=Q;function z(R){return{customExecution:"customExecution"}}he.from=z;function V(R,K){return K.get(R)}he.to=V})(v=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var D;(function(he){function Q(z,V){let R;return z.scope!==void 0&&typeof z.scope!="number"?R=z.scope.uri:z.scope!==void 0&&typeof z.scope=="number"&&(z.scope===C.TaskScope.Workspace&&V&&V.workspaceFile?R=V.workspaceFile:R=a.USER_TASKS_GROUP_KEY),{id:z._id,workspaceFolder:R}}he.from=Q})(D=e.TaskHandleDTO||(e.TaskHandleDTO={}));var T;(function(he){function Q(R,K){if(R==null)return[];const x=[];for(let j of R){const ue=z(j,K);ue&&x.push(ue)}return x}he.fromMany=Q;function z(R,K){if(R==null)return;let x;R.execution instanceof C.ProcessExecution?x=i.from(R.execution):R.execution instanceof C.ShellExecution?x=f.from(R.execution):R.execution&&R.execution instanceof C.CustomExecution&&(x=v.from(R.execution));const j=t.from(R.definition);let ue;if(R.scope?typeof R.scope=="number"?ue=R.scope:ue=R.scope.uri:ue=C.TaskScope.Workspace,!j||!ue)return;const $=R.group?R.group.id:void 0;return{_id:R._id,definition:j,name:R.name,source:{extensionId:K.identifier.value,label:R.source,scope:ue},execution:x,isBackground:R.isBackground,group:$,presentationOptions:r.from(R.presentationOptions),problemMatchers:R.problemMatchers,hasDefinedMatchers:R.hasDefinedMatchers,runOptions:R.runOptions?R.runOptions:{reevaluateOnRerun:!0},detail:R.detail}}he.from=z;async function V(R,K,x){if(R==null)return;let j;i.is(R.execution)?j=i.to(R.execution):f.is(R.execution)?j=f.to(R.execution):v.is(R.execution)&&(j=v.to(R._id,x));const ue=t.to(R.definition);let $;if(R.source&&(R.source.scope!==void 0?typeof R.source.scope=="number"?$=R.source.scope:$=await K.resolveWorkspaceFolder(g.URI.revive(R.source.scope)):$=C.TaskScope.Workspace),!ue||!$)return;const te=new C.Task(ue,$,R.name,R.source.label,j,R.problemMatchers);return R.isBackground!==void 0&&(te.isBackground=R.isBackground),R.group!==void 0&&(te.group=C.TaskGroup.from(R.group)),R.presentationOptions&&(te.presentationOptions=r.to(R.presentationOptions)),R._id&&(te._id=R._id),R.detail&&(te.detail=R.detail),te}he.to=V})(T=e.TaskDTO||(e.TaskDTO={}));var o;(function(he){function Q(V){return V}he.from=Q;function z(V){if(!!V)return Object.assign(Object.create(null),V)}he.to=z})(o=e.TaskFilterDTO||(e.TaskFilterDTO={}));class A{constructor(Q,z,V){this._id=z,this._task=V,p.set(this,void 0),nt(this,p,Q,"f")}get task(){return this._task}terminate(){Ue(this,p,"f").terminateTask(this)}fireDidStartProcess(Q){}fireDidEndProcess(Q){}}p=new WeakMap;var L;(function(he){function Q(z){return{id:z._id,task:void 0}}he.from=Q})(L=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let B=class{constructor(Q,z,V,R,K,x,j,ue){this._onDidExecuteTask=new S.Emitter,this._onDidTerminateTask=new S.Emitter,this._onDidTaskProcessStarted=new S.Emitter,this._onDidTaskProcessEnded=new S.Emitter,this._proxy=Q.getProxy(_.MainContext.MainThreadTask),this._workspaceProvider=V,this._editorService=R,this._configurationService=K,this._terminalService=x,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=j,this._deprecationService=ue,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(Q,z,V){if(!V)return new C.Disposable(()=>{});const R=this.nextHandle();return this._handlers.set(R,{type:z,provider:V,extension:Q}),this._proxy.$registerTaskProvider(R,z),new C.Disposable(()=>{this._handlers.delete(R),this._proxy.$unregisterTaskProvider(R)})}registerTaskSystem(Q,z){this._proxy.$registerTaskSystem(Q,z)}fetchTasks(Q){return this._proxy.$fetchTasks(o.from(Q)).then(async z=>{const V=[];for(let R of z){const K=await T.to(R,this._workspaceProvider,this._providedCustomExecutions2);K&&V.push(K)}return V})}get taskExecutions(){const Q=[];return this._taskExecutions.forEach(z=>Q.push(z)),Q}terminateTask(Q){if(!(Q instanceof A))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(Q._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(Q,z,V){const R=this._providedCustomExecutions2.get(Q.id);if(R){if(this._activeCustomExecutions2.get(Q.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(Q.id,R),this._terminalService.attachPtyToTerminal(z,await R.callback(V))}this._lastStartedTask=Q.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(Q)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(Q){const z=await this.getTaskExecution(Q);this._taskExecutionPromises.delete(Q.id),this._taskExecutions.delete(Q.id),this.customExecutionComplete(Q),this._onDidTerminateTask.fire({execution:z})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(Q){const z=await this.getTaskExecution(Q.id);this._onDidTaskProcessStarted.fire({execution:z,processId:Q.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(Q){const z=await this.getTaskExecution(Q.id);this._onDidTaskProcessEnded.fire({execution:z,exitCode:Q.exitCode})}$provideTasks(Q,z){const V=this._handlers.get(Q);if(!V)return Promise.reject(new Error("no handler found"));const R=[],K=(0,F.asPromise)(()=>V.provider.provideTasks(n.CancellationToken.None)).then(x=>this.provideTasksInternal(z,R,V,x));return new Promise(x=>{K.then(j=>{Promise.all(R).then(()=>{x(j)})})})}async $resolveTask(Q,z){const V=this._handlers.get(Q);if(!V)return Promise.reject(new Error("no handler found"));if(z.definition.type!==V.type)throw new Error(`Unexpected: Task of type [${z.definition.type}] cannot be resolved by provider of type [${V.type}].`);const R=await T.to(z,this._workspaceProvider,this._providedCustomExecutions2);if(!R)throw new Error("Unexpected: Task cannot be resolved.");const K=await V.provider.resolveTask(R,n.CancellationToken.None);if(!K)return;this.checkDeprecation(K,V);const x=T.from(K,V.extension);if(!x)throw new Error("Unexpected: Task cannot be resolved.");if(K.definition!==R.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return v.is(x.execution)&&await this.addCustomExecution(x,K,!0),await this.resolveTaskInternal(x)}nextHandle(){return this._handleCounter++}async addCustomExecution(Q,z,V){const R=await this._proxy.$createTaskId(Q);!V&&!this._providedCustomExecutions2.has(R)&&this._notProvidedCustomExecutions.add(R),this._providedCustomExecutions2.set(R,z.execution)}async getTaskExecution(Q,z){if(typeof Q=="string"){const K=this._taskExecutionPromises.get(Q);if(!K)throw new Error("Unexpected: The specified task is missing an execution");return K}let V=this._taskExecutionPromises.get(Q.id);if(V)return V;const R=new Promise(async(K,x)=>{const j=z||await T.to(Q.task,this._workspaceProvider,this._providedCustomExecutions2);j?K(new A(this,Q.id,j)):x("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(Q.id,R),R.then(K=>(this._taskExecutions.set(Q.id,K),K),K=>Promise.reject(K))}checkDeprecation(Q,z){Q._deprecated&&this._deprecationService.report("Task.constructor",z.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(Q){this._activeCustomExecutions2.get(Q.id)&&this._activeCustomExecutions2.delete(Q.id),this._notProvidedCustomExecutions.has(Q.id)&&this._lastStartedTask!==Q.id&&(this._providedCustomExecutions2.delete(Q.id),this._notProvidedCustomExecutions.delete(Q.id));let V=this._notProvidedCustomExecutions.values(),R=V.next();for(;!R.done;)!this._activeCustomExecutions2.has(R.value)&&this._lastStartedTask!==R.value&&(this._providedCustomExecutions2.delete(R.value),this._notProvidedCustomExecutions.delete(R.value)),R=V.next()}};B=ze([qe(0,l.IExtHostRpcService),qe(1,d.IExtHostInitDataService),qe(2,y.IExtHostWorkspace),qe(3,b.IExtHostDocumentsAndEditors),qe(4,k.IExtHostConfiguration),qe(5,I.IExtHostTerminalService),qe(6,w.ILogService),qe(7,P.IExtHostApiDeprecationService)],B),e.ExtHostTaskBase=B;let oe=class extends B{constructor(Q,z,V,R,K,x,j,ue){super(Q,z,V,R,K,x,j,ue);this.registerTaskSystem(m.Schemas.vscodeRemote,{scheme:m.Schemas.vscodeRemote,authority:"",platform:E.PlatformToString(0)})}async executeTask(Q,z){if(!z.execution)throw new Error("Tasks to execute must include an execution");const V=T.from(z,Q);if(V===void 0)throw new Error("Task is not valid");if(v.is(V.execution))await this.addCustomExecution(V,z,!1);else throw new h.NotSupportedError;const R=await this.getTaskExecution(await this._proxy.$getTaskExecution(V),z);return this._proxy.$executeTask(V).catch(K=>{throw new Error(K)}),R}provideTasksInternal(Q,z,V,R){const K=[];if(R)for(let x of R){this.checkDeprecation(x,V),(!x.definition||!Q[x.definition.type])&&this._logService.warn(`The task [${x.source}, ${x.name}] uses an undefined task type. The task will be ignored in the future.`);const j=T.from(x,V.extension);j&&v.is(j.execution)?(K.push(j),z.push(this.addCustomExecution(j,x,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:K,extension:V.extension}}async resolveTaskInternal(Q){if(v.is(Q.execution))return Q;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(Q,z){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(Q,z,V){}};oe=ze([qe(0,l.IExtHostRpcService),qe(1,d.IExtHostInitDataService),qe(2,y.IExtHostWorkspace),qe(3,b.IExtHostDocumentsAndEditors),qe(4,k.IExtHostConfiguration),qe(5,I.IExtHostTerminalService),qe(6,w.ILogService),qe(7,P.IExtHostApiDeprecationService)],oe),e.WorkerExtHostTask=oe,e.IExtHostTask=(0,c.createDecorator)("IExtHostTask")}),define(be[223],Ee([0,1,17,50,27,84,21,11,14,25,8,10,2,120,143,94,46,100,222,39]),function(ee,e,g,F,S,_,C,y,b,k,n,I,l,d,c,m,E,w,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let h=class{constructor(D,T,o,A){this.configurationService=D,this.workspaceContextService=T,this.editorGroupsService=o,this.pathService=A}text(D,T,o={}){D=this.getContentPattern(D,o);const A=this.configurationService.getValue(),L=T&&T.some(oe=>!this.configurationService.getValue({resource:oe}).search.useRipgrep);return{...this.commonQuery(T?.map(E.toWorkspaceFolder),o),type:2,contentPattern:D,previewOptions:o.previewOptions,maxFileSize:o.maxFileSize,usePCRE2:A.search.usePCRE2||L||!1,beforeContext:o.beforeContext,afterContext:o.afterContext,userDisabledExcludesAndIgnoreFiles:o.disregardExcludeSettings&&o.disregardIgnoreFiles}}getContentPattern(D,T){const o=this.configurationService.getValue();D.isRegExp&&(D.pattern=D.pattern.replace(/\r?\n/g,"\\n"));const A={...D,wordSeparators:o.editor.wordSeparators};return this.isCaseSensitive(D,T)&&(A.isCaseSensitive=!0),this.isMultiline(D)&&(A.isMultiline=!0),A}file(D,T={}){return{...this.commonQuery(D,T),type:1,filePattern:T.filePattern?T.filePattern.trim():T.filePattern,exists:T.exists,sortByScore:T.sortByScore,cacheKey:T.cacheKey}}handleIncludeExclude(D,T){return D?(D=Array.isArray(D)?D.map(i):i(D),T?this.parseSearchPaths(D):{pattern:t(...Array.isArray(D)?D:[D])}):{}}commonQuery(D=[],T={}){const o=this.handleIncludeExclude(T.includePattern,T.expandPatterns),A=this.handleIncludeExclude(T.excludePattern,T.expandPatterns),L=D.length>1,B=(o.searchPaths&&o.searchPaths.length?o.searchPaths.map(Q=>this.getFolderQueryForSearchPath(Q,T,A)):D.map(Q=>this.getFolderQueryForRoot(Q,T,A,L))).filter(Q=>!!Q),oe={_reason:T._reason,folderQueries:B,usingSearchPaths:!!(o.searchPaths&&o.searchPaths.length),extraFileResources:T.extraFileResources,excludePattern:A.pattern,includePattern:o.pattern,onlyOpenEditors:T.onlyOpenEditors,maxResults:T.maxResults};if(T.onlyOpenEditors){const z=g.coalesce(g.flatten(this.editorGroupsService.groups.map(R=>R.editors.map(K=>K.resource)))).filter(R=>(0,a.pathIncludedInQuery)(oe,R.fsPath)),V=this.commonQueryFromFileList(z);return{...oe,...V}}const he=T.extraFileResources&&T.extraFileResources.filter(Q=>(0,a.pathIncludedInQuery)(oe,Q.fsPath));return oe.extraFileResources=he&&he.length?he:void 0,oe}commonQueryFromFileList(D){const T=[],o=new C.ResourceMap,A={};let L=!1;return D.forEach(B=>{if(B.scheme===y.Schemas.walkThrough)return;if((0,k.isAbsolutePath)(B)){const he=this.workspaceContextService.getWorkspaceFolder(B)?.uri??B.with({path:b.dirname(B.fsPath)});let Q=o.get(he);Q||(L=!0,Q={folder:he,includePattern:{}},T.push(Q),o.set(he,Q));const z=b.relative(he.fsPath,B.fsPath);(0,I.assertIsDefined)(Q.includePattern)[z.replace(/\\/g,"/")]=!0}else B.fsPath&&(L=!0,A[B.fsPath]=!0)}),{folderQueries:T,includePattern:A,usingSearchPaths:!0,excludePattern:L?void 0:{"**/*":!0}}}isCaseSensitive(D,T){if(T.isSmartCase){if(D.isRegExp){if(n.containsUppercaseCharacter(D.pattern,!0))return!0}else if(n.containsUppercaseCharacter(D.pattern))return!0}return!!D.isCaseSensitive}isMultiline(D){return D.isMultiline||D.isRegExp&&(0,d.isMultilineRegexSource)(D.pattern)||D.pattern.indexOf(`
`)>=0?!0:!!D.isMultiline}parseSearchPaths(D){const T=V=>b.isAbsolute(V)||/^\.\.?([\/\\]|$)/.test(V),A=(Array.isArray(D)?D:r(D)).map(V=>{const R=this.pathService.resolvedUserHome;return R?(0,_.untildify)(V,R.scheme===y.Schemas.file?R.fsPath:R.path):V}),L=F.groupBy(A,V=>T(V)?"searchPaths":"exprSegments"),B=(L.exprSegments||[]).map(V=>n.rtrim(V,"/")).map(V=>n.rtrim(V,"\\")).map(V=>(V[0]==="."&&(V="*"+V),s(V))),oe={},he=this.expandSearchPathPatterns(L.searchPaths||[]);he&&he.length&&(oe.searchPaths=he);const Q=g.flatten(B),z=t(...Q);return z&&(oe.pattern=z),oe}getExcludesForFolder(D,T){return T.disregardExcludeSettings?void 0:(0,a.getExcludes)(D,!T.disregardSearchExcludeSettings)}expandSearchPathPatterns(D){if(!D||!D.length)return[];const T=g.flatten(D.map(A=>{let{pathPortion:L,globPortion:B}=p(A);B&&(B=u(B));const oe=this.expandOneSearchPath(L);return g.flatten(oe.map(he=>this.resolveOneSearchPathPattern(he,B)))})),o=new Map;return T.forEach(A=>{const L=A.searchPath.toString(),B=o.get(L);B?A.pattern&&(B.pattern=B.pattern||{},B.pattern[A.pattern]=!0):o.set(L,{searchPath:A.searchPath,pattern:A.pattern?t(A.pattern):void 0})}),Array.from(o.values())}expandOneSearchPath(D){if(b.isAbsolute(D)){const T=this.workspaceContextService.getWorkspace().folders;return T[0]&&T[0].uri.scheme!==y.Schemas.file?[{searchPath:T[0].uri.with({path:D})}]:[{searchPath:l.URI.file(b.normalize(D))}]}if(this.workspaceContextService.getWorkbenchState()===2){const T=this.workspaceContextService.getWorkspace().folders[0].uri;if(D=i(D),D.startsWith("../")||D===".."){const A=b.posix.resolve(T.path,D);return[{searchPath:T.with({path:A})}]}const o=u(D);return[{searchPath:T,pattern:o}]}else{if(D==="./"||D===".\\")return[];{const T=D.replace(/^\.[\/\\]/,""),A=this.workspaceContextService.getWorkspace().folders.map(L=>{const B=T.match(new RegExp(`^${n.escapeRegExpCharacters(L.name)}(?:/(.*)|$)`));return B?{match:B,folder:L}:null}).filter(I.isDefined);if(A.length)return A.map(L=>{const B=L.match[1];return{searchPath:L.folder.uri,pattern:B&&u(B)}});{const L=D.match(/\.[\/\\](.+)[\/\\]?/),B=L?L[1]:D,oe=c.localize(0,null,B);throw new Error(oe)}}}}resolveOneSearchPathPattern(D,T){const o=D.pattern&&T?`${D.pattern}/${T}`:D.pattern||T,A=[{searchPath:D.searchPath,pattern:o}];return o&&!o.endsWith("**")&&A.push({searchPath:D.searchPath,pattern:o+"/**"}),A}getFolderQueryForSearchPath(D,T,o){const A=this.getFolderQueryForRoot((0,E.toWorkspaceFolder)(D.searchPath),T,o,!1);return A?{...A,includePattern:D.pattern}:null}getFolderQueryForRoot(D,T,o,A){let L;const B=l.URI.isUri(D)?D:D.uri;if(o.searchPaths){const V=o.searchPaths.filter(R=>(0,k.isEqual)(R.searchPath,B))[0];if(V&&!V.pattern)return null;V&&(L=V.pattern)}const oe=this.configurationService.getValue({resource:B}),Q={...this.getExcludesForFolder(oe,T)||{},...L||{}},z=l.URI.isUri(D)?(0,k.basename)(D):D.name;return{folder:B,folderName:A?z:void 0,excludePattern:Object.keys(Q).length>0?Q:void 0,fileEncoding:oe.files&&oe.files.encoding,disregardIgnoreFiles:typeof T.disregardIgnoreFiles=="boolean"?T.disregardIgnoreFiles:!oe.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof T.disregardGlobalIgnoreFiles=="boolean"?T.disregardGlobalIgnoreFiles:!oe.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof T.ignoreSymlinks=="boolean"?T.ignoreSymlinks:!oe.search.followSymlinks}}};h=ze([qe(0,m.IConfigurationService),qe(1,E.IWorkspaceContextService),qe(2,w.IEditorGroupsService),qe(3,P.IPathService)],h),e.QueryBuilder=h;function p(v){const D=v.match(/[\*\{\}\(\)\[\]\?]/);if(D){const T=D.index,o=v.substr(0,T).match(/[/|\\][^/\\]*$/);if(o){let A=v.substr(0,o.index);return A.match(/[/\\]/)||(A+="/"),{pathPortion:A,globPortion:v.substr((o.index||0)+1)}}}return{pathPortion:v}}function t(...v){return v.length?v.reduce((D,T)=>(D[T]=!0,D),Object.create(null)):void 0}function r(v){return S.splitGlobAware(v,",").map(D=>D.trim()).filter(D=>!!D.length)}function s(v){return[`**/${v}/**`,`**/${v}`].map(T=>T.replace(/\*\*\/\*\*/g,"**"))}function i(v){return v.replace(/\\/g,"/")}function u(v){return i(v).replace(/^\.\//,"").replace(/\/+$/g,"")}function f(v,D){v=g.distinct(v,A=>A.toString());const T=[],o=D.getWorkspace();return v&&v.forEach(A=>{let L;if(D.getWorkbenchState()===2)L=(0,k.relativePath)(o.folders[0].uri,A),L&&L!=="."&&(L="./"+L);else{const B=D.getWorkspaceFolder(A);if(B){const oe=B.name;if(o.folders.filter(Q=>Q.name===oe).length===1){const Q=(0,k.relativePath)(B.uri,A);Q===""?L=`./${B.name}`:L=`./${B.name}/${Q}`}else L=A.fsPath}}L&&T.push(L)}),T}e.resolveResourcesForSearchIncludes=f}),define(be[224],Ee([0,1,25,2,20,12,4,223,39,46]),function(ee,e,g,F,S,_,C,y,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const n=7e3;function I(m,E){const w=E.activationEvents;if(!w)return Promise.resolve(void 0);const P=[],a=[];for(const i of w)if(/^workspaceContains:/.test(i)){const u=i.substr("workspaceContains:".length);u.indexOf("*")>=0||u.indexOf("?")>=0||m.forceUsingSearch?a.push(u):P.push(u)}if(P.length===0&&a.length===0)return Promise.resolve(void 0);let h;const p=new Promise((i,u)=>{h=i}),t=i=>h({activationEvent:i}),r=Promise.all(P.map(i=>l(m,i,t))).then(()=>{}),s=d(m,E.identifier,a,t);return Promise.all([r,s]).then(()=>{h(void 0)}),p}e.checkActivateWorkspaceContainsExtension=I;async function l(m,E,w){for(const P of m.folders)if(await m.exists(g.joinPath(F.URI.revive(P),E))){w(`workspaceContains:${E}`);return}}async function d(m,E,w,P){if(w.length===0)return Promise.resolve(void 0);const a=new S.CancellationTokenSource,h=m.checkExists(m.folders,w,a.token),p=setTimeout(async()=>{a.cancel(),P(`workspaceContainsTimeout:${w.join(",")}`)},n);let t=!1;try{t=await h}catch(r){_.isPromiseCanceledError(r)||_.onUnexpectedError(r)}a.dispose(),clearTimeout(p),t&&P(`workspaceContains:${w.join(",")}`)}function c(m,E,w,P){const a=m.get(C.IInstantiationService),h=m.get(b.ISearchService),t=a.createInstance(y.QueryBuilder).file(E.map(r=>(0,k.toWorkspaceFolder)(F.URI.revive(r))),{_reason:"checkExists",includePattern:w,exists:!0});return h.fileSearch(t,P).then(r=>!!r.limitHit,r=>_.isPromiseCanceledError(r)?!1:Promise.reject(r))}e.checkGlobFileExists=c});var nt=this&&this.__classPrivateFieldSet||function(ee,e,g,F,S){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?S.call(ee,g):S?S.value=g:e.set(ee,g),g},Ue=this&&this.__classPrivateFieldGet||function(ee,e,g,F){if(g==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!F:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?F:g==="a"?F.call(ee):F?F.value:e.get(ee)};define(be[34],Ee([0,1,134,14,79,25,16,6,21,2,15,5,33,187,77,32,30,185,12,26,24,162,7,95,4,29,78,13,62,68,38,3,224,73,164]),function(ee,e,g,F,S,_,C,y,b,k,n,I,l,d,c,m,E,w,P,a,h,p,t,r,s,i,u,f,v,D,T,o,A,L,B){"use strict";var oe,he,Q;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,s.createDecorator)("IHostUtils");let z=class $n extends y.Disposable{constructor(x,j,ue,$,te,ce,ye,Re,Te,$e){super();this._onDidChangeRemoteConnectionData=this._register(new o.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=j,this._extHostContext=ue,this._initData=ye,this._extHostWorkspace=$,this._extHostConfiguration=te,this._logService=ce,this._extHostTunnelService=Te,this._extHostTerminalService=$e,this._disposables=new y.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(I.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(I.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(I.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new C.Barrier,this._readyToStartExtensionHost=new C.Barrier,this._readyToRunExtensions=new C.Barrier,this._eagerExtensionsActivated=new C.Barrier,this._registry=new w.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new c.ExtHostStorage(this._extHostContext),this._secretState=new L.ExtHostSecretState(this._extHostContext),this._storagePath=Re,this._instaService=x.createChild(new v.ServiceCollection([c.IExtHostStorage,this._storage],[L.IExtHostSecretState,this._secretState]));const Je=new Set;this._initData.hostExtensions.forEach(Ve=>Je.add(a.ExtensionIdentifier.toKey(Ve))),this._activator=new d.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(Ve,je,O)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Ve,P.transformErrorForSerialization(je),O)},actualActivateExtension:async(Ve,je)=>{if(Je.has(a.ExtensionIdentifier.toKey(Ve)))return await this._mainThreadExtensionsProxy.$activateExtension(Ve,je),new d.HostExtension;const O=this._registry.getExtensionDescription(Ve);return this._activateExtension(O,je)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),S.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(x){P.onUnexpectedError(x)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let x=[];try{x=this._registry.getAllExtensionDescriptions().map(te=>te.identifier).filter(te=>this.isActivated(te)).map(te=>this._deactivate(te))}catch(j){}await Promise.all(x)}isActivated(x){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(x):!1}_activateByEvent(x,j){return this._activator.activateByEvent(x,j)}_activateById(x,j){return this._activator.activateById(x,j)}activateByIdWithErrors(x,j){return this._activateById(x,j).then(()=>{const ue=this._activator.getActivatedExtension(x);if(ue.activationFailed)return Promise.reject(ue.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(x=>this._registry)}getExtensionExports(x){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(x).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const x=b.TernarySearchTree.forPaths(),j=this._registry.getAllExtensionDescriptions().map(ue=>{if(!!this._getEntryPoint(ue))return this._hostUtils.realpath(ue.extensionLocation.fsPath).then($=>x.set(k.URI.file($).fsPath,ue))});this._extensionPathIndex=Promise.all(j).then(()=>x)}return this._extensionPathIndex}_deactivate(x){let j=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(x))return j;const ue=this._activator.getActivatedExtension(x);if(!ue)return j;try{typeof ue.module.deactivate=="function"&&(j=Promise.resolve(ue.module.deactivate()).then(void 0,$=>(this._logService.error($),Promise.resolve(void 0))))}catch($){this._logService.error($)}try{(0,y.dispose)(ue.subscriptions)}catch($){this._logService.error($)}return j}async _activateExtension(x,j){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(x.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(x.identifier),this._doActivateExtension(x,j).then(ue=>{const $=ue.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(x.identifier,$.codeLoadingTime,$.activateCallTime,$.activateResolvedTime,j),this._logExtensionActivationTimes(x,j,"success",$),ue},ue=>{throw this._logExtensionActivationTimes(x,j,"failure"),ue})}_logExtensionActivationTimes(x,j,ue,$){const te=V(x,j);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...te,...$||{},outcome:ue})}_doActivateExtension(x,j){const ue=V(x,j);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",ue);const $=this._getEntryPoint(x);if(!$)return Promise.resolve(new d.EmptyExtension(d.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${x.identifier.value} ${JSON.stringify(j)}`),this._logService.flush();const te=new d.ExtensionActivationTimesBuilder(j.startup);return Promise.all([this._loadCommonJSModule(x.identifier,(0,_.joinPath)(x.extensionLocation,$),te),this._loadExtensionContext(x)]).then(ce=>(S.mark(`code/extHost/willActivateExtension/${x.identifier.value}`),$n._callActivate(this._logService,x.identifier,ce[0],ce[1],te))).then(ce=>(S.mark(`code/extHost/didActivateExtension/${x.identifier.value}`),ce))}_loadExtensionContext(x){const j=new p.ExtensionGlobalMemento(x,this._storage),ue=new p.ExtensionMemento(x.identifier.value,!1,this._storage),$=new B.ExtensionSecrets(x,this._secretState),te=x.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,ce=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${x.identifier.value}`),Promise.all([j.whenReady,ue.whenReady,this._storagePath.whenReady]).then(()=>{const ye=this;let Re;return Object.freeze({globalState:j,workspaceState:ue,secrets:$,subscriptions:[],get extensionUri(){return x.extensionLocation},get extensionPath(){return x.extensionLocation.fsPath},asAbsolutePath(Te){return F.join(x.extensionLocation.fsPath,Te)},get storagePath(){return ye._storagePath.workspaceValue(x)?.fsPath},get globalStoragePath(){return ye._storagePath.globalValue(x).fsPath},get logPath(){return F.join(ye._initData.logsLocation.fsPath,x.identifier.value)},get logUri(){return k.URI.joinPath(ye._initData.logsLocation,x.identifier.value)},get storageUri(){return ye._storagePath.workspaceValue(x)},get globalStorageUri(){return ye._storagePath.globalValue(x)},get extensionMode(){return te},get extension(){return Re===void 0&&(Re=new R(ye,x.identifier,x,ce)),Re},get extensionRuntime(){return(0,E.checkProposedApiEnabled)(x),ye.extensionRuntime},get environmentVariableCollection(){return ye._extHostTerminalService.getEnvironmentVariableCollection(x)}})})}static _callActivate(x,j,ue,$,te){return ue=ue||{activate:void 0,deactivate:void 0},this._callActivateOptional(x,j,ue,$,te).then(ce=>new d.ActivatedExtension(!1,null,te.build(),ue,ce,$.subscriptions))}static _callActivateOptional(x,j,ue,$,te){if(typeof ue.activate=="function")try{te.activateCallStart(),x.trace(`ExtensionService#_callActivateOptional ${j.value}`);const ce=typeof global=="object"?global:self,ye=ue.activate.apply(ce,[$]);return te.activateCallStop(),te.activateResolveStart(),Promise.resolve(ye).then(Re=>(te.activateResolveStop(),Re))}catch(ce){return Promise.reject(ce)}else return Promise.resolve(ue)}_activateOneStartupFinished(x,j){this._activateById(x.identifier,{startup:!1,extensionId:x.identifier,activationEvent:j}).then(void 0,ue=>{this._logService.error(ue)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(S.getMarks());for(const x of this._registry.getAllExtensionDescriptions())if(x.activationEvents)for(const j of x.activationEvents)j==="onStartupFinished"&&this._activateOneStartupFinished(x,j)}_handleEagerExtensions(){const x=this._activateByEvent("*",!0).then(void 0,te=>{this._logService.error(te)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(te=>this._handleWorkspaceContainsEagerExtensions(te.added)));const j=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],ue=this._handleWorkspaceContainsEagerExtensions(j),$=Promise.all([x,ue]).then(()=>{});return Promise.race([$,(0,C.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),$}_handleWorkspaceContainsEagerExtensions(x){return x.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(j=>this._handleWorkspaceContainsEagerExtension(x,j))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(x,j){if(this.isActivated(j.identifier))return;const ue=!this._initData.remote.isRemote&&!!this._initData.remote.authority,$={folders:x.map(ce=>ce.uri),forceUsingSearch:ue,exists:ce=>this._hostUtils.exists(ce.fsPath),checkExists:(ce,ye,Re)=>this._mainThreadWorkspaceProxy.$checkExists(ce,ye,Re)},te=await(0,A.checkActivateWorkspaceContainsExtension)($,j);if(!!te)return this._activateById(j.identifier,{startup:!0,extensionId:j.identifier,activationEvent:te.activationEvent}).then(void 0,ce=>this._logService.error(ce))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(x){throw console.error(x),x}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:x,extensionTestsLocationURI:j}=this._initData.environment;if(!x||!j)throw new Error(g.localize(0,null));const ue=await this._loadCommonJSModule(null,j,new d.ExtensionActivationTimesBuilder(!1));if(!ue||typeof ue.run!="function")throw new Error(g.localize(1,null,j.toString()));return new Promise(($,te)=>{const ce=(Te,$e)=>{Te?te(Te):$(typeof $e=="number"&&$e>0?1:0)},ye=(0,_.originalFSPath)(j),Re=ue.run(ye,ce);Re&&Re.then&&Re.then(()=>{$(0)}).catch(Te=>{te(Te.toString())})})}async $extensionTestsExit(x){this._logService.info(`extension host terminating: test runner requested exit with code ${x}`),this._logService.info(`exiting with code ${x}`),this._logService.flush(),this._hostUtils.exit(x)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(x,j){return this._resolvers[x]=j,(0,y.toDisposable)(()=>{delete this._resolvers[x]})}async _activateAndGetResolver(x){const j=x.indexOf("+");if(j===-1)throw new Error("Not an authority that can be resolved!");const ue=x.substr(0,j);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${ue}`,!1),{authorityPrefix:ue,resolver:this._resolvers[ue]}}async $resolveAuthority(x,j){const{authorityPrefix:ue,resolver:$}=await this._activateAndGetResolver(x);if(!$)return{type:"error",error:{code:r.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${ue}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions($)),S.mark(`code/extHost/willResolveAuthority/${ue}`);const te=await $.resolve(x,{resolveAttempt:j});S.mark(`code/extHost/didResolveAuthorityOK/${ue}`);const ce={authority:x,host:te.host,port:te.port,connectionToken:te.connectionToken},ye={extensionHostEnv:te.extensionHostEnv,isTrusted:te.isTrusted};return{type:"ok",value:{authority:ce,options:ye,tunnelInformation:{environmentTunnels:te.environmentTunnels}}}}catch(te){if(S.mark(`code/extHost/didResolveAuthorityError/${ue}`),te instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:te._code,message:te._message,detail:te._detail}};throw te}}async $getCanonicalURI(x,j){const{authorityPrefix:ue,resolver:$}=await this._activateAndGetResolver(x);if(!$)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${ue}`);const te=k.URI.revive(j);if(typeof $.getCanonicalURI=="undefined")return te;const ce=await(0,C.asPromise)(()=>$.getCanonicalURI(te));return ce||te}$startExtensionHost(x){return this._registry.keepOnly(x),this._startExtensionHost()}$activateByEvent(x,j){return j===1?this._activateByEvent(x,!1):this._readyToRunExtensions.wait().then(ue=>this._activateByEvent(x,!1))}async $activate(x,j){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(x)?(await this._activateById(x,j),!0):!1}async $deltaExtensions(x,j){x.forEach($=>$.extensionLocation=k.URI.revive($.extensionLocation));const ue=await this.getExtensionPathIndex();return await Promise.all(j.map(async $=>{const te=this._registry.getExtensionDescription($);if(!te)return;const ce=await this._hostUtils.realpath(te.extensionLocation.fsPath);ue.delete(k.URI.file(ce).fsPath)})),await Promise.all(x.map(async $=>{const te=await this._hostUtils.realpath($.extensionLocation.fsPath);ue.set(k.URI.file(te).fsPath,$)})),this._registry.deltaExtensions(x,j),Promise.resolve(void 0)}async $test_latency(x){return x}async $test_up(x){return x.byteLength}async $test_down(x){let j=h.VSBuffer.alloc(x),ue=Math.random()%256;for(let $=0;$<x;$++)j.writeUInt8(ue,$);return j}async $updateRemoteConnectionData(x){this._remoteConnectionData=x,this._onDidChangeRemoteConnectionData.fire()}};z=ze([qe(0,s.IInstantiationService),qe(1,e.IHostUtils),qe(2,f.IExtHostRpcService),qe(3,m.IExtHostWorkspace),qe(4,l.IExtHostConfiguration),qe(5,n.ILogService),qe(6,i.IExtHostInitDataService),qe(7,u.IExtensionStoragePaths),qe(8,D.IExtHostTunnelService),qe(9,T.IExtHostTerminalService)],z),e.AbstractExtHostExtensionService=z;function V(K,x){return{id:K.identifier.value,name:K.name,extensionVersion:K.version,publisherDisplayName:K.publisher,activationEvents:K.activationEvents?K.activationEvents.join(","):null,isBuiltin:K.isBuiltin,reason:x.activationEvent,reasonId:x.extensionId.value}}e.IExtHostExtensionService=(0,s.createDecorator)("IExtHostExtensionService");class R{constructor(x,j,ue,$){oe.set(this,void 0),he.set(this,void 0),Q.set(this,void 0),nt(this,oe,x,"f"),nt(this,he,j,"f"),nt(this,Q,ue.identifier,"f"),this.id=ue.identifier.value,this.extensionUri=ue.extensionLocation,this.extensionPath=F.normalize((0,_.originalFSPath)(ue.extensionLocation)),this.packageJSON=ue,this.extensionKind=$}get isActive(){return Ue(this,oe,"f").isActivated(Ue(this,Q,"f"))}get exports(){if(this.packageJSON.api!=="none")return Ue(this,oe,"f").getExtensionExports(Ue(this,Q,"f"))}activate(){return Ue(this,oe,"f").activateByIdWithErrors(Ue(this,Q,"f"),{startup:!1,extensionId:Ue(this,he,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=R,oe=new WeakMap,he=new WeakMap,Q=new WeakMap}),define(be[109],Ee([0,1,14,2,3,16,5,7,172,32,34,48,176,33,173,13,4,10,41,66]),function(ee,e,g,F,S,_,C,y,b,k,n,I,l,d,c,m,E,w,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,E.createDecorator)("IExtHostDebugService");let h=class{constructor(v,D,T,o,A,L){this._workspaceService=D,this._extensionService=T,this._editorsService=o,this._configurationService=A,this._editorTabs=L,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new S.Emitter,this._onDidTerminateDebugSession=new S.Emitter,this._onDidChangeActiveDebugSession=new S.Emitter,this._onDidReceiveDebugSessionCustomEvent=new S.Emitter,this._debugServiceProxy=v.getProxy(C.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new S.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new t(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(B=>{B.onDidChange(oe=>{this.registerAllDebugTypes(B)}),this.registerAllDebugTypes(B)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(v,D){const T=v;if(typeof T.sourceReference=="number"&&T.sourceReference>0){let o=`debug:${encodeURIComponent(T.path||"")}`,A="?";return D&&(o+=`${A}session=${encodeURIComponent(D.id)}`,A="&"),o+=`${A}ref=${T.sourceReference}`,F.URI.parse(o)}else{if(T.path)return F.URI.file(T.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(v){const D=[];for(const T of v.getAllExtensionDescriptions())if(T.contributes){const o=T.contributes.debuggers;if(o&&o.length>0)for(const A of o)(0,c.isDebuggerMainContribution)(A)&&D.push(A.type)}this._debugServiceProxy.$registerDebugTypes(D)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const v=[];return this._breakpoints.forEach(D=>v.push(D)),v}addBreakpoints(v){this.startBreakpoints();const D=v.filter(A=>{const L=A.id;return this._breakpoints.has(L)?!1:(this._breakpoints.set(L,A),!0)});this.fireBreakpointChanges(D,[],[]);const T=[],o=new Map;for(const A of D)if(A instanceof y.SourceBreakpoint){let L=o.get(A.location.uri.toString());L||(L={type:"sourceMulti",uri:A.location.uri,lines:[]},o.set(A.location.uri.toString(),L),T.push(L)),L.lines.push({id:A.id,enabled:A.enabled,condition:A.condition,hitCondition:A.hitCondition,logMessage:A.logMessage,line:A.location.range.start.line,character:A.location.range.start.character})}else A instanceof y.FunctionBreakpoint&&T.push({type:"function",id:A.id,enabled:A.enabled,hitCondition:A.hitCondition,logMessage:A.logMessage,condition:A.condition,functionName:A.functionName});return this._debugServiceProxy.$registerBreakpoints(T)}removeBreakpoints(v){this.startBreakpoints();const D=v.filter(L=>this._breakpoints.delete(L.id));this.fireBreakpointChanges([],D,[]);const T=D.filter(L=>L instanceof y.SourceBreakpoint).map(L=>L.id),o=D.filter(L=>L instanceof y.FunctionBreakpoint).map(L=>L.id),A=D.filter(L=>L instanceof y.DataBreakpoint).map(L=>L.id);return this._debugServiceProxy.$unregisterBreakpoints(T,o,A)}startDebugging(v,D,T){return this._debugServiceProxy.$startDebugging(v?v.uri:void 0,D,{parentSessionID:T.parentSession?T.parentSession.id:void 0,lifecycleManagedByParent:T.lifecycleManagedByParent,repl:T.consoleMode===y.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:T.noDebug,compact:T.compact,debugUI:T.debugUI})}stopDebugging(v){return this._debugServiceProxy.$stopDebugging(v?v.id:void 0)}registerDebugConfigurationProvider(v,D,T){if(!D)return new y.Disposable(()=>{});const o=this._configProviderHandleCounter++;return this._configProviders.push({type:v,handle:o,provider:D}),this._debugServiceProxy.$registerDebugConfigurationProvider(v,T,!!D.provideDebugConfigurations,!!D.resolveDebugConfiguration,!!D.resolveDebugConfigurationWithSubstitutedVariables,o),new y.Disposable(()=>{this._configProviders=this._configProviders.filter(A=>A.provider!==D),this._debugServiceProxy.$unregisterDebugConfigurationProvider(o)})}registerDebugAdapterDescriptorFactory(v,D,T){if(!T)return new y.Disposable(()=>{});if(!this.definesDebugType(v,D))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${D}' debugger.`);if(this.getAdapterDescriptorFactoryByType(D))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const o=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:D,handle:o,factory:T}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(D,o),new y.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(A=>A.factory!==T),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(o)})}registerDebugAdapterTrackerFactory(v,D){if(!D)return new y.Disposable(()=>{});const T=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:v,handle:T,factory:D}),new y.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(o=>o.factory!==D)})}async $runInTerminal(v,D){return Promise.resolve(void 0)}async $substituteVariables(v,D){if(!this._variableResolver){const[A,L]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(A||[],this._editorsService,L)}let T;const o=await this.getFolder(v);return o&&(T={uri:o.uri,name:o.name,index:o.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(T,D)}createDebugAdapter(v,D){if(v.type==="implementation")return new i(v.implementation)}createSignService(){}async $startDASession(v,D){const T=this,o=await this.getSession(D);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(o.type),o).then(A=>{if(!A)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${o.type}' (extension might have failed to activate)`);const L=this.convertToDto(A),B=this.createDebugAdapter(L,o);if(!B)throw new Error(`Couldn't create a debug adapter for type '${o.type}'.`);const oe=B;return this._debugAdapters.set(v,oe),this.getDebugAdapterTrackers(o).then(he=>(he&&this._debugAdaptersTrackers.set(v,he),oe.onMessage(async Q=>{if(Q.type==="request"&&Q.command==="handshake"){const z=Q,V={type:"response",seq:0,command:z.command,request_seq:z.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const R=await this._signService.sign(z.arguments.value);V.body={signature:R},oe.sendResponse(V)}else throw new Error("no signer")}catch(R){V.success=!1,V.message=R.message,oe.sendResponse(V)}}else he&&he.onDidSendMessage&&he.onDidSendMessage(Q),Q=(0,c.convertToVSCPaths)(Q,!0),T._debugServiceProxy.$acceptDAMessage(v,Q)}),oe.onError(Q=>{he&&he.onError&&he.onError(Q),this._debugServiceProxy.$acceptDAError(v,Q.name,Q.message,Q.stack)}),oe.onExit(Q=>{he&&he.onExit&&he.onExit((0,w.withNullAsUndefined)(Q),void 0),this._debugServiceProxy.$acceptDAExit(v,(0,w.withNullAsUndefined)(Q),void 0)}),he&&he.onWillStartSession&&he.onWillStartSession(),oe.startSession()))})}$sendDAMessage(v,D){D=(0,c.convertToDAPaths)(D,!1);const T=this._debugAdaptersTrackers.get(v);T&&T.onWillReceiveMessage&&T.onWillReceiveMessage(D);const o=this._debugAdapters.get(v);o&&o.sendMessage(D)}$stopDASession(v){const D=this._debugAdaptersTrackers.get(v);this._debugAdaptersTrackers.delete(v),D&&D.onWillStopSession&&D.onWillStopSession();const T=this._debugAdapters.get(v);return this._debugAdapters.delete(v),T?T.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(v){const D=[],T=[],o=[];if(v.added)for(const A of v.added){const L=A.id;if(L&&!this._breakpoints.has(L)){let B;if(A.type==="function")B=new y.FunctionBreakpoint(A.functionName,A.enabled,A.condition,A.hitCondition,A.logMessage);else if(A.type==="data")B=new y.DataBreakpoint(A.label,A.dataId,A.canPersist,A.enabled,A.hitCondition,A.condition,A.logMessage);else{const oe=F.URI.revive(A.uri);B=new y.SourceBreakpoint(new y.Location(oe,new y.Position(A.line,A.character)),A.enabled,A.condition,A.hitCondition,A.logMessage)}B._id=L,this._breakpoints.set(L,B),D.push(B)}}if(v.removed)for(const A of v.removed){const L=this._breakpoints.get(A);L&&(this._breakpoints.delete(A),T.push(L))}if(v.changed){for(const A of v.changed)if(A.id){const L=this._breakpoints.get(A.id);if(L){if(L instanceof y.FunctionBreakpoint&&A.type==="function"){const B=L;B.enabled=A.enabled,B.condition=A.condition,B.hitCondition=A.hitCondition,B.logMessage=A.logMessage,B.functionName=A.functionName}else if(L instanceof y.SourceBreakpoint&&A.type==="source"){const B=L;B.enabled=A.enabled,B.condition=A.condition,B.hitCondition=A.hitCondition,B.logMessage=A.logMessage,B.location=new y.Location(F.URI.revive(A.uri),new y.Position(A.line,A.character))}o.push(L)}}}this.fireBreakpointChanges(D,T,o)}$provideDebugConfigurations(v,D,T){return(0,_.asPromise)(async()=>{const o=this.getConfigProviderByHandle(v);if(!o)throw new Error("no DebugConfigurationProvider found");if(!o.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const A=await this.getFolder(D);return o.provideDebugConfigurations(A,T)}).then(o=>{if(!o)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return o})}$resolveDebugConfiguration(v,D,T,o){return(0,_.asPromise)(async()=>{const A=this.getConfigProviderByHandle(v);if(!A)throw new Error("no DebugConfigurationProvider found");if(!A.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const L=await this.getFolder(D);return A.resolveDebugConfiguration(L,T,o)})}$resolveDebugConfigurationWithSubstitutedVariables(v,D,T,o){return(0,_.asPromise)(async()=>{const A=this.getConfigProviderByHandle(v);if(!A)throw new Error("no DebugConfigurationProvider found");if(!A.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const L=await this.getFolder(D);return A.resolveDebugConfigurationWithSubstitutedVariables(L,T,o)})}async $provideDebugAdapter(v,D){const T=this.getAdapterDescriptorFactoryByHandle(v);if(!T)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const o=await this.getSession(D);return this.getAdapterDescriptor(T,o).then(A=>{if(!A)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${o.type}'`);return this.convertToDto(A)})}async $acceptDebugSessionStarted(v){const D=await this.getSession(v);this._onDidStartDebugSession.fire(D)}async $acceptDebugSessionTerminated(v){const D=await this.getSession(v);D&&(this._onDidTerminateDebugSession.fire(D),this._debugSessions.delete(D.id))}async $acceptDebugSessionActiveChanged(v){this._activeDebugSession=v?await this.getSession(v):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(v,D){const T=await this.getSession(v);T&&T._acceptNameChanged(D)}async $acceptDebugSessionCustomEvent(v,D){const o={session:await this.getSession(v),event:D.event,body:D.body};this._onDidReceiveDebugSessionCustomEvent.fire(o)}convertToDto(v){if(v instanceof y.DebugAdapterExecutable)return{type:"executable",command:v.command,args:v.args,options:v.options};if(v instanceof y.DebugAdapterServer)return{type:"server",port:v.port,host:v.host};if(v instanceof y.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:v.path};if(v instanceof y.DebugAdapterInlineImplementation)return{type:"implementation",implementation:v.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(v){const D=this._adapterFactories.filter(T=>T.type===v);if(D.length>0)return D[0].factory}getAdapterDescriptorFactoryByHandle(v){const D=this._adapterFactories.filter(T=>T.handle===v);if(D.length>0)return D[0].factory}getConfigProviderByHandle(v){const D=this._configProviders.filter(T=>T.handle===v);if(D.length>0)return D[0].provider}definesDebugType(v,D){if(v.contributes){const T=v.contributes.debuggers;if(T&&T.length>0){for(const o of T)if(o.label&&o.type&&o.type===D)return!0}}return!1}getDebugAdapterTrackers(v){const T=v.configuration.type,o=this._trackerFactories.filter(A=>A.type===T||A.type==="*").map(A=>(0,_.asPromise)(()=>A.factory.createDebugAdapterTracker(v)).then(L=>L,L=>null));return Promise.race([Promise.all(o).then(A=>{const L=A.filter(B=>!!B);if(L.length>0)return new s(L)}),new Promise((A,L)=>{const B=setTimeout(()=>{clearTimeout(B),L(new Error("timeout"))},1e3)})]).catch(A=>{})}async getAdapterDescriptor(v,D){const T=D.configuration.debugServer;if(typeof T=="number")return Promise.resolve(new y.DebugAdapterServer(T));if(v){const A=await this._extensionService.getExtensionRegistry();return(0,_.asPromise)(()=>v.createDebugAdapterDescriptor(D,this.daExecutableFromPackage(D,A))).then(L=>{if(L)return L})}const o=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(D,o))}daExecutableFromPackage(v,D){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(v,D,T){(v.length>0||D.length>0||T.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:v,removed:D,changed:T}))}async getSession(v){if(v)if(typeof v=="string"){const D=this._debugSessions.get(v);if(D)return D}else{let D=this._debugSessions.get(v.id);if(!D){const T=await this.getFolder(v.folderUri),o=v.parent?this._debugSessions.get(v.parent):void 0;D=new p(this._debugServiceProxy,v.id,v.type,v.name,T,v.configuration,o),this._debugSessions.set(D.id,D),this._debugServiceProxy.$sessionCached(D.id)}return D}throw new Error("cannot find session")}getFolder(v){if(v){const D=F.URI.revive(v);return this._workspaceService.resolveWorkspaceFolder(D)}return Promise.resolve(void 0)}};h=ze([qe(0,m.IExtHostRpcService),qe(1,k.IExtHostWorkspace),qe(2,n.IExtHostExtensionService),qe(3,I.IExtHostDocumentsAndEditors),qe(4,d.IExtHostConfiguration),qe(5,a.IExtHostEditorTabs)],h),e.ExtHostDebugServiceBase=h;class p{constructor(v,D,T,o,A,L,B){this._debugServiceProxy=v,this._id=D,this._type=T,this._name=o,this._workspaceFolder=A,this._configuration=L,this._parentSession=B}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(v){this._name=v,this._debugServiceProxy.$setDebugSessionName(this._id,v)}get parentSession(){return this._parentSession}_acceptNameChanged(v){this._name=v}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(v,D){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,v,D)}getDebugProtocolBreakpoint(v){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,v.id)}}e.ExtHostDebugSession=p;class t{constructor(v){this.value=Object.freeze({append(D){v.$appendDebugConsole(D)},appendLine(D){this.append(D+`
`)}})}}e.ExtHostDebugConsole=t;class r extends l.AbstractVariableResolverService{constructor(v,D,T,o,A){function L(){if(D){const B=D.activeEditor();if(B)return B.document.uri;const oe=o.tabs.filter(he=>he.isActive);if(oe.length>0)return oe[0].resource}}super({getFolderUri:B=>{const oe=v.filter(he=>he.name===B);if(oe&&oe.length>0)return oe[0].uri},getWorkspaceFolderCount:()=>v.length,getConfigurationValue:(B,oe)=>T.getConfiguration(void 0,B).get(oe),getAppRoot:()=>P.cwd(),getExecPath:()=>P.env.VSCODE_EXEC_PATH,getFilePath:()=>{const B=L();if(B)return g.normalize(B.fsPath)},getWorkspaceFolderPathForFile:()=>{if(A){const B=L();if(B){const oe=A.getWorkspaceFolder(B);if(oe)return g.normalize(oe.uri.fsPath)}}},getSelectedText:()=>{if(D){const B=D.activeEditor();if(B&&!B.selection.isEmpty)return B.document.getText(B.selection)}},getLineNumber:()=>{if(D){const B=D.activeEditor();if(B)return String(B.selection.end.line+1)}}},void 0,Promise.resolve(P.env))}}e.ExtHostVariableResolverService=r;class s{constructor(v){this.trackers=v}onWillStartSession(){this.trackers.forEach(v=>v.onWillStartSession?v.onWillStartSession():void 0)}onWillReceiveMessage(v){this.trackers.forEach(D=>D.onWillReceiveMessage?D.onWillReceiveMessage(v):void 0)}onDidSendMessage(v){this.trackers.forEach(D=>D.onDidSendMessage?D.onDidSendMessage(v):void 0)}onWillStopSession(){this.trackers.forEach(v=>v.onWillStopSession?v.onWillStopSession():void 0)}onError(v){this.trackers.forEach(D=>D.onError?D.onError(v):void 0)}onExit(v,D){this.trackers.forEach(T=>T.onExit?T.onExit(v,D):void 0)}}class i extends b.AbstractDebugAdapter{constructor(v){super();this.implementation=v,v.onDidSendMessage(D=>{this.acceptMessage(D)})}startSession(){return Promise.resolve(void 0)}sendMessage(v){this.implementation.handleMessage(v)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let u=class extends h{constructor(v,D,T,o,A,L){super(v,D,T,o,A,L)}createVariableResolver(v,D,T){return new r(v,D,T,this._editorTabs)}};u=ze([qe(0,m.IExtHostRpcService),qe(1,k.IExtHostWorkspace),qe(2,n.IExtHostExtensionService),qe(3,I.IExtHostDocumentsAndEditors),qe(4,d.IExtHostConfiguration),qe(5,a.IExtHostEditorTabs)],u),e.WorkerExtHostDebugService=u}),define(be[225],Ee([0,1,79,2,5,33,30,26,13,29,4,34,41,15]),function(ee,e,g,F,S,_,C,y,b,k,n,I,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let c=class{constructor(a,h,p,t,r,s,i){this._apiFactory=a,this._extensionRegistry=h,this._instaService=p,this._extHostConfiguration=t,this._extHostExtensionService=r,this._initData=s,this._logService=i,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),g.mark("code/extHost/willWaitForConfig");const a=await this._extHostConfiguration.getConfigProvider();g.mark("code/extHost/didWaitForConfig");const h=await this._extHostExtensionService.getExtensionPathIndex();this.register(new m(this._apiFactory,h,this._extensionRegistry,a,this._logService)),this.register(this._instaService.createInstance(E)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(w,h,this._initData.environment.appUriScheme))}register(a){if(Array.isArray(a.nodeModuleName))for(let h of a.nodeModuleName)this._factories.set(h,a);else this._factories.set(a.nodeModuleName,a);typeof a.alternativeModuleName=="function"&&this._alternatives.push(h=>a.alternativeModuleName(h))}};c=ze([qe(2,n.IInstantiationService),qe(3,_.IExtHostConfiguration),qe(4,I.IExtHostExtensionService),qe(5,k.IExtHostInitDataService),qe(6,d.ILogService)],c),e.RequireInterceptor=c;class m{constructor(a,h,p,t,r){this._apiFactory=a,this._extensionPaths=h,this._extensionRegistry=p,this._configProvider=t,this._logService=r,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(a,h){const p=this._extensionPaths.findSubstr(h.fsPath);if(p){let t=this._extApiImpl.get(y.ExtensionIdentifier.toKey(p.identifier));return t||(t=this._apiFactory(p,this._extensionRegistry,this._configProvider),this._extApiImpl.set(y.ExtensionIdentifier.toKey(p.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((r,s)=>t+=`	${s} -> ${r.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${h.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(C.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let E=class{constructor(a,h){this.nodeModuleName="keytar";const{environment:p}=h,t=a.getProxy(S.MainContext.MainThreadKeytar);if(p.appRoot){let r=p.appRoot.fsPath;l.platform==="win32"&&(r=r.replace(/\\/g,"/")),r[r.length-1]==="/"&&(r=r.substr(0,r.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${r}/node_modules.asar/keytar`),this.alternativeNames.add(`${r}/node_modules/keytar`)}this._impl={getPassword:(r,s)=>t.$getPassword(r,s),setPassword:(r,s,i)=>t.$setPassword(r,s,i),deletePassword:(r,s)=>t.$deletePassword(r,s),findPassword:r=>t.$findPassword(r),findCredentials(r){return t.$findCredentials(r)}}}load(a,h){return this._impl}alternativeModuleName(a){const h=a.length;if(h<=7||!this.alternativeNames)return;const p=h-7;if((a.charAt(p)==="/"||a.charAt(p)==="\\")&&a.endsWith("keytar")&&(a=a.replace(/\\/g,"/"),this.alternativeNames.has(a)))return"keytar"}};E=ze([qe(0,b.IExtHostRpcService),qe(1,k.IExtHostInitDataService)],E);let w=class{constructor(a,h,p){this._extensionPaths=a,this._appUriScheme=h,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=p.getProxy(S.MainContext.MainThreadTelemetry);const t=p.getProxy(S.MainContext.MainThreadWindow);this._impl=(r,s)=>{const i=F.URI.parse(r);return s?this.callOriginal(r,s):i.scheme==="http"||i.scheme==="https"?t.$openUri(i,r,{allowTunneling:!0}):i.scheme==="mailto"||i.scheme===this._appUriScheme?t.$openUri(i,r,{}):this.callOriginal(r,s)}}load(a,h,p){const t=this._extensionPaths.findSubstr(h.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=p(a),this._impl}callOriginal(a,h){return this.sendNoForwardTelemetry(),this._original(a,h)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};w=ze([qe(2,b.IExtHostRpcService)],w)}),define(be[226],Ee([0,1,16,12,79,6,2,5,219,15,59,62,29,153,13,69,34,38]),function(ee,e,g,F,S,_,C,y,b,k,n,I,l,d,c,m,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class P{constructor(h,p,t,r){this._disposables=new _.DisposableStore,this._isTerminating=!1,this._hostUtils=t,this._rpcProtocol=new b.RPCProtocol(h,null,r),p=P._transform(p,this._rpcProtocol);const s=new I.ServiceCollection(...(0,n.getSingletonServiceDescriptors)());s.set(l.IExtHostInitDataService,{_serviceBrand:void 0,...p}),s.set(c.IExtHostRpcService,new c.ExtHostRpcService(this._rpcProtocol)),s.set(m.IURITransformerService,new m.URITransformerService(r)),s.set(E.IHostUtils,t);const i=new d.InstantiationService(s,!0),u=i.invokeFunction(T=>T.get(w.IExtHostTerminalService));this._disposables.add(u),this._logService=i.invokeFunction(T=>T.get(k.ILogService)),S.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",p),this._extensionService=i.invokeFunction(T=>T.get(E.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const f=new WeakMap;this._extensionService.getExtensionPathIndex().then(T=>{Error.prepareStackTrace=(o,A)=>{let L="",B,oe;for(const he of A)L+=`
	at ${he.toString()}`,oe=he.getFileName(),!B&&oe&&(B=T.findSubstr(oe));return f.set(o,B),`${o.name||"Error"}: ${o.message||""}${L}`}});const v=this._rpcProtocol.getProxy(y.MainContext.MainThreadExtensionService),D=this._rpcProtocol.getProxy(y.MainContext.MainThreadErrors);F.setUnexpectedErrorHandler(T=>{const o=F.transformErrorForSerialization(T),A=f.get(T);A?v.$onExtensionRuntimeError(A.identifier,o):D.$onUnexpectedError(o)})}terminate(h){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${h}`),this._logService.flush(),this._disposables.dispose(),F.setUnexpectedErrorHandler(t=>{this._logService.error(t)}),this._rpcProtocol.dispose();const p=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,g.timeout)(4e3),p]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(h,p){h.extensions.forEach(r=>r.extensionLocation=C.URI.revive(p.transformIncomingURIs(r.extensionLocation))),h.environment.appRoot=C.URI.revive(p.transformIncomingURIs(h.environment.appRoot));const t=h.environment.extensionDevelopmentLocationURI;return t&&(h.environment.extensionDevelopmentLocationURI=t.map(r=>C.URI.revive(p.transformIncomingURIs(r)))),h.environment.extensionTestsLocationURI=C.URI.revive(p.transformIncomingURIs(h.environment.extensionTestsLocationURI)),h.environment.globalStorageHome=C.URI.revive(p.transformIncomingURIs(h.environment.globalStorageHome)),h.environment.workspaceStorageHome=C.URI.revive(p.transformIncomingURIs(h.environment.workspaceStorageHome)),h.logsLocation=C.URI.revive(p.transformIncomingURIs(h.logsLocation)),h.logFile=C.URI.revive(p.transformIncomingURIs(h.logFile)),h.workspace=p.transformIncomingURIs(h.workspace),h}}e.ExtensionHostMain=P}),define(be[227],Ee([0,1,14,20,58,27,25,55,39]),function(ee,e,g,F,S,_,C,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class k{constructor(l,d,c){this.config=l,this.provider=d,this.sessionToken=c,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=l.filePattern,this.includePattern=l.includePattern&&_.parse(l.includePattern),this.maxResults=l.maxResults||void 0,this.exists=l.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=l.excludePattern&&_.parse(l.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(l=>l.cancel()),this.activeCancellationTokens=new Set}search(l){const d=this.config.folderQueries||[];return new Promise((c,m)=>{const E=w=>{this.resultCount++,l(w)};if(this.isCanceled)return c({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(w=>{const P=w.toString(),a=g.basename(P);this.globalExcludePattern&&this.globalExcludePattern(P,a)||this.matchFile(E,{base:w,basename:a})}),Promise.all(d.map(w=>this.searchInFolder(w,E))).then(w=>{c({limitHit:this.isLimitHit,stats:w[0]||void 0})},w=>{m(new Error((0,S.toErrorMessage)(w)))})})}async searchInFolder(l,d){const c=new F.CancellationTokenSource,m=this.getSearchOptionsForFolder(l),E=this.initDirectoryTree(),w=new b.QueryGlobTester(this.config,l),P=!w.hasSiblingExcludeClauses();let a;try{this.activeCancellationTokens.add(c),a=y.StopWatch.create();const h=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},m,c.token),p=a.elapsed(),t=y.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(h&&h.forEach(r=>{const s=g.posix.relative(l.folder.path,r.path);if(P){const i=g.basename(r.path);this.matchFile(d,{base:l.folder,relativePath:s,basename:i});return}this.addDirectoryEntries(E,l.folder,s,d)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(E,w,d),{providerTime:p,postProcessTime:t.elapsed()})}finally{c.dispose(),this.activeCancellationTokens.delete(c)}}getSearchOptionsForFolder(l){const d=(0,b.resolvePatternsForProvider)(this.config.includePattern,l.includePattern),c=(0,b.resolvePatternsForProvider)(this.config.excludePattern,l.excludePattern);return{folder:l.folder,excludes:c,includes:d,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,followSymlinks:!l.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}addDirectoryEntries({pathToEntries:l},d,c,m){if(c===this.filePattern){const w=g.basename(this.filePattern);this.matchFile(m,{base:d,relativePath:this.filePattern,basename:w})}function E(w){const P=g.basename(w),a=g.dirname(w);let h=l[a];h||(h=l[a]=[],E(a)),h.push({base:d,relativePath:w,basename:P})}E(c)}matchDirectoryTree({rootEntries:l,pathToEntries:d},c,m){const E=this,w=this.filePattern;function P(a){const h=_.hasSiblingFn(()=>a.map(p=>p.basename));for(let p=0,t=a.length;p<t;p++){const r=a[p],{relativePath:s,basename:i}=r;if(!c.includedInQuerySync(s,i,w!==i?h:void 0))continue;const u=d[s];if(u)P(u);else{if(s===w)continue;E.matchFile(m,r)}if(E.isLimitHit)break}}P(l)}matchFile(l,d){(!this.includePattern||d.relativePath&&this.includePattern(d.relativePath,d.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||l(d))}}class n{constructor(){this.sessions=new Map}fileSearch(l,d,c,m){const E=this.getSessionTokenSource(l.cacheKey),w=new k(l,d,E&&E.token);let P=0;const a=h=>{P+=h.length,c(h.map(p=>this.rawMatchToSearchItem(p)))};return this.doSearch(w,n.BATCH_SIZE,a,m).then(h=>({limitHit:h.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:P,detailStats:h.stats}}))}clearCache(l){const d=this.getSessionTokenSource(l);d&&d.cancel()}getSessionTokenSource(l){if(!!l)return this.sessions.has(l)||this.sessions.set(l,new F.CancellationTokenSource),this.sessions.get(l)}rawMatchToSearchItem(l){return l.relativePath?{resource:C.joinPath(l.base,l.relativePath)}:{resource:l.base}}doSearch(l,d,c,m){m.onCancellationRequested(()=>{l.cancel()});const E=P=>{P&&(w.push(P),d>0&&w.length>=d&&(c(w),w=[]))};let w=[];return l.search(E).then(P=>(w.length&&c(w),P),P=>(w.length&&c(w),Promise.reject(P)))}}e.FileSearchManager=n,n.BATCH_SIZE=512}),define(be[228],Ee([0,1,14,17,20,58,25,27,2,39,11,10]),function(ee,e,g,F,S,_,C,y,b,k,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class l{constructor(a,h,p){this.query=a,this.provider=h,this.fileUtils=p,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(a,h){const p=this.query.folderQueries||[],t=new S.CancellationTokenSource;return h.onCancellationRequested(()=>t.cancel()),new Promise((r,s)=>{this.collector=new c(a);let i=!1;const u=(f,v)=>{if(!i&&!this.isLimitHit){const D=this.resultSize(f);E(f)&&typeof this.query.maxResults=="number"&&this.resultCount+D>this.query.maxResults&&(this.isLimitHit=!0,i=!0,t.cancel(),f=this.trimResultToSize(f,this.query.maxResults-this.resultCount));const T=this.resultSize(f);this.resultCount+=T,(T>0||!E(f))&&this.collector.add(f,v)}};Promise.all(p.map((f,v)=>this.searchInFolder(f,D=>u(D,v),t.token))).then(f=>{t.dispose(),this.collector.flush();const v=f.some(D=>!!D&&!!D.limitHit);r({limitHit:this.isLimitHit||v,messages:(0,F.flatten)(f.map(D=>D?.message?(0,I.isArray)(D.message)?D.message:[D.message]:[])),stats:{type:"textSearchProvider"}})},f=>{t.dispose();const v=(0,_.toErrorMessage)(f);s(new Error(v))})})}resultSize(a){return E(a)?Array.isArray(a.ranges)?a.ranges.length:1:0}trimResultToSize(a,h){const p=Array.isArray(a.ranges)?a.ranges:[a.ranges],t=Array.isArray(a.preview.matches)?a.preview.matches:[a.preview.matches];return{ranges:p.slice(0,h),preview:{matches:t.slice(0,h),text:a.preview.text},uri:a.uri}}async searchInFolder(a,h,p){const t=new k.QueryGlobTester(this.query,a),r=[],s={report:f=>{if(!this.validateProviderResult(f))return;const v=a.folder.scheme===n.Schemas.file?y.hasSiblingPromiseFn(()=>this.fileUtils.readdir(C.dirname(f.uri))):void 0,D=C.relativePath(a.folder,f.uri);D&&r.push(t.includedInQuery(D,g.basename(D),v).then(T=>{T&&h(f)}))}},i=this.getSearchOptionsForFolder(a),u=await this.provider.provideTextSearchResults(d(this.query.contentPattern),i,s,p);return await Promise.all(r),u}validateProviderResult(a){if(E(a)){if(Array.isArray(a.ranges)){if(!Array.isArray(a.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(a.preview.matches.length!==a.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(a.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(a){const h=(0,k.resolvePatternsForProvider)(this.query.includePattern,a.includePattern),p=(0,k.resolvePatternsForProvider)(this.query.excludePattern,a.excludePattern),t={folder:b.URI.from(a.folder),excludes:p,includes:h,useIgnoreFiles:!a.disregardIgnoreFiles,useGlobalIgnoreFiles:!a.disregardGlobalIgnoreFiles,followSymlinks:!a.ignoreSymlinks,encoding:a.fileEncoding&&this.fileUtils.toCanonicalName(a.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=l;function d(P){return{isCaseSensitive:P.isCaseSensitive||!1,isRegExp:P.isRegExp||!1,isWordMatch:P.isWordMatch||!1,isMultiline:P.isMultiline||!1,pattern:P.pattern}}class c{constructor(a){this._onResult=a,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new w(512,h=>this.sendItems(h))}add(a,h){this._currentFileMatch&&(this._currentFolderIdx!==h||!C.isEqual(this._currentUri,a.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=h,this._currentFileMatch={resource:a.uri,results:[]}),this._currentFileMatch.results.push(m(a))}pushToCollector(){const a=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,a)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(a){this._onResult(a)}}e.TextSearchResultsCollector=c;function m(P){return E(P)?{preview:{matches:(0,F.mapArrayOrNot)(P.preview.matches,a=>({startLineNumber:a.start.line,startColumn:a.start.character,endLineNumber:a.end.line,endColumn:a.end.character})),text:P.preview.text},ranges:(0,F.mapArrayOrNot)(P.ranges,a=>({startLineNumber:a.start.line,startColumn:a.start.character,endLineNumber:a.end.line,endColumn:a.end.character}))}:{text:P.text,lineNumber:P.lineNumber}}function E(P){return!!P.preview}e.extensionResultIsMatch=E;class w{constructor(a,h){this.maxBatchSize=a,this.cb=h,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(a,h){!a||this.addItemToBatch(a,h)}addItems(a,h){!a||this.addItemsToBatch(a,h)}addItemToBatch(a,h){this.batch.push(a),this.batchSize+=h,this.onUpdate()}addItemsToBatch(a,h){this.batch=this.batch.concat(a),this.batchSize+=h,this.onUpdate()}onUpdate(){this.totalNumberCompleted<w.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},w.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=w,w.TIMEOUT=4e3,w.START_BATCH_AFTER_COUNT=50}),define(be[110],Ee([0,1,6,5,4,227,13,69,15,2,228]),function(ee,e,g,F,S,_,C,y,b,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,S.createDecorator)("IExtHostSearch");let I=class{constructor(m,E,w){this.extHostRpc=m,this._uriTransformer=E,this._logService=w,this._proxy=this.extHostRpc.getProxy(F.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new _.FileSearchManager}_transformScheme(m){return this._uriTransformer.transformOutgoingScheme(m)}registerTextSearchProvider(m,E){if(this._textSearchUsedSchemes.has(m))throw new Error(`a text search provider for the scheme '${m}' is already registered`);this._textSearchUsedSchemes.add(m);const w=this._handlePool++;return this._textSearchProvider.set(w,E),this._proxy.$registerTextSearchProvider(w,this._transformScheme(m)),(0,g.toDisposable)(()=>{this._textSearchUsedSchemes.delete(m),this._textSearchProvider.delete(w),this._proxy.$unregisterProvider(w)})}registerFileSearchProvider(m,E){if(this._fileSearchUsedSchemes.has(m))throw new Error(`a file search provider for the scheme '${m}' is already registered`);this._fileSearchUsedSchemes.add(m);const w=this._handlePool++;return this._fileSearchProvider.set(w,E),this._proxy.$registerFileSearchProvider(w,this._transformScheme(m)),(0,g.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(m),this._fileSearchProvider.delete(w),this._proxy.$unregisterProvider(w)})}$provideFileSearchResults(m,E,w,P){const a=l(w),h=this._fileSearchProvider.get(m);if(h)return this._fileSearchManager.fileSearch(a,h,p=>{this._proxy.$handleFileMatch(m,E,p.map(t=>t.resource))},P);throw new Error("unknown provider: "+m)}$clearCache(m){return this._fileSearchManager.clearCache(m),Promise.resolve(void 0)}$provideTextSearchResults(m,E,w,P){const a=this._textSearchProvider.get(m);if(!a||!a.provideTextSearchResults)throw new Error(`Unknown provider ${m}`);const h=l(w);return this.createTextSearchManager(h,a).search(t=>this._proxy.$handleTextMatch(m,E,t),P)}createTextSearchManager(m,E){return new n.TextSearchManager(m,E,{readdir:w=>Promise.resolve([]),toCanonicalName:w=>w})}};I=ze([qe(0,C.IExtHostRpcService),qe(1,y.IURITransformerService),qe(2,b.ILogService)],I),e.ExtHostSearch=I;function l(c){return{...c,folderQueries:c.folderQueries&&c.folderQueries.map(d),extraFileResources:c.extraFileResources&&c.extraFileResources.map(m=>k.URI.revive(m))}}e.reviveQuery=l;function d(c){return{...c,folder:k.URI.revive(c.folder)}}}),define(be[229],Ee([0,1,20,12,3,43,2,127,87,121,57,61,5,192,191,75,193,33,194,195,196,178,197,48,34,198,179,200,201,202,105,181,207,208,209,77,38,211,182,9,7,214,49,106,32,30,50,169,199,96,104,108,109,110,15,69,13,29,203,166,68,74,189,212,165,78,76,217,215,216,190,47,210,213,73,66,97,205,107,206,11,155,204,163,161]),function(ee,e,g,F,S,_,C,y,b,k,n,I,l,d,c,m,E,w,P,a,h,p,t,r,s,i,u,f,v,D,T,o,A,L,B,oe,he,Q,z,V,R,K,x,j,ue,$,te,ce,ye,Re,Te,$e,Je,Ve,je,O,G,X,se,q,ie,ge,Le,We,ve,Xe,H,Z,de,Be,xe,Ze,De,Se,Pe,re,ae,fe,pe,U,me,we,Ie,Oe,He){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function et(Qe){const Ke=Qe.get(X.IExtHostInitDataService),lt=Qe.get(Ze.IExtHostFileSystemInfo),ft=Qe.get(H.IExtHostConsumerFileSystem),_t=Qe.get(s.IExtHostExtensionService),ut=Qe.get(ue.IExtHostWorkspace),ot=Qe.get(ae.IExtHostTelemetry),_e=Qe.get(w.IExtHostConfiguration),ke=Qe.get(O.IURITransformerService),Y=Qe.get(G.IExtHostRpcService),W=Qe.get(oe.IExtHostStorage),Fe=Qe.get(Xe.IExtensionStoragePaths),Me=Qe.get(je.ILogService),tt=Qe.get(ie.IExtHostTunnelService),Ge=Qe.get(ge.IExtHostApiDeprecationService),dt=Qe.get(j.IExtHostWindow),yt=Qe.get(Pe.IExtHostSecretState),kt=Qe.get(re.IExtHostEditorTabs);Y.set(l.ExtHostContext.ExtHostFileSystemInfo,lt),Y.set(l.ExtHostContext.ExtHostLogService,Me),Y.set(l.ExtHostContext.ExtHostWorkspace,ut),Y.set(l.ExtHostContext.ExtHostConfiguration,_e),Y.set(l.ExtHostContext.ExtHostExtensionService,_t),Y.set(l.ExtHostContext.ExtHostStorage,W),Y.set(l.ExtHostContext.ExtHostTunnelService,tt),Y.set(l.ExtHostContext.ExtHostWindow,dt),Y.set(l.ExtHostContext.ExtHostSecretState,yt),Y.set(l.ExtHostContext.ExtHostTelemetry,ot),Y.set(l.ExtHostContext.ExtHostEditorTabs,kt);const bt=Y.set(l.ExtHostContext.ExtHostDecorations,Qe.get(Te.IExtHostDecorations)),mt=Y.set(l.ExtHostContext.ExtHostDocumentsAndEditors,Qe.get(r.IExtHostDocumentsAndEditors)),ct=Y.set(l.ExtHostContext.ExtHostCommands,Qe.get(m.IExtHostCommands)),Et=Y.set(l.ExtHostContext.ExtHostTerminalService,Qe.get(he.IExtHostTerminalService)),gt=Y.set(l.ExtHostContext.ExtHostDebugService,Qe.get(Je.IExtHostDebugService)),Ot=Y.set(l.ExtHostContext.ExtHostSearch,Qe.get(Ve.IExtHostSearch)),Pt=Y.set(l.ExtHostContext.ExtHostTask,Qe.get($e.IExtHostTask)),Kt=Y.set(l.ExtHostContext.ExtHostOutputService,Qe.get(T.IExtHostOutputService)),Ut=Y.set(l.ExtHostContext.ExtHostUrls,new K.ExtHostUrls(Y)),Ct=Y.set(l.ExtHostContext.ExtHostDocuments,new t.ExtHostDocuments(Y,mt)),Qt=Y.set(l.ExtHostContext.ExtHostDocumentContentProviders,new h.ExtHostDocumentContentProvider(Y,mt,Me)),Yt=Y.set(l.ExtHostContext.ExtHostDocumentSaveParticipant,new p.ExtHostDocumentSaveParticipant(Me,Ct,Y.getProxy(l.MainContext.MainThreadBulkEdits))),pt=Y.set(l.ExtHostContext.ExtHostNotebook,new se.ExtHostNotebookController(Y,ct,mt,Ct,Fe)),qt=Y.set(l.ExtHostContext.ExtHostNotebookDocuments,new Oe.ExtHostNotebookDocuments(Me,pt)),zt=Y.set(l.ExtHostContext.ExtHostNotebookEditors,new Ie.ExtHostNotebookEditors(Me,Y,pt)),Jt=Y.set(l.ExtHostContext.ExtHostNotebookKernels,new fe.ExtHostNotebookKernels(Y,Ke,pt,Me)),Xt=Y.set(l.ExtHostContext.ExtHostNotebookRenderers,new U.ExtHostNotebookRenderers(Y,pt)),At=Y.set(l.ExtHostContext.ExtHostEditors,new Q.ExtHostEditors(Y,mt)),jt=Y.set(l.ExtHostContext.ExtHostTreeViews,new z.ExtHostTreeViews(Y.getProxy(l.MainContext.MainThreadTreeViews),ct,Me)),Zt=Y.set(l.ExtHostContext.ExtHostEditorInsets,new ce.ExtHostEditorInsets(Y.getProxy(l.MainContext.MainThreadEditorInsets),At,Ke)),Ht=Y.set(l.ExtHostContext.ExtHostDiagnostics,new P.ExtHostDiagnostics(Y,Me)),ht=Y.set(l.ExtHostContext.ExtHostLanguageFeatures,new f.ExtHostLanguageFeatures(Y,ke,Ct,ct,Ht,Me,Ge)),bn=Y.set(l.ExtHostContext.ExtHostFileSystem,new i.ExtHostFileSystem(Y,ht)),Rt=Y.set(l.ExtHostContext.ExtHostFileSystemEventService,new u.ExtHostFileSystemEventService(Y,Me,mt)),xt=Y.set(l.ExtHostContext.ExtHostQuickOpen,(0,A.createExtHostQuickOpen)(Y,ut,ct)),cn=Y.set(l.ExtHostContext.ExtHostSCM,new L.ExtHostSCM(Y,ct,Me)),En=Y.set(l.ExtHostContext.ExtHostComments,(0,E.createExtHostComments)(Y,ct,Ct)),dn=Y.set(l.ExtHostContext.ExtHostProgress,new o.ExtHostProgress(Y.getProxy(l.MainContext.MainThreadProgress))),_n=Y.set(l.ExtHostContext.ExtHosLabelService,new ye.ExtHostLabelService(Y)),hn=Y.set(l.ExtHostContext.ExtHostTheming,new q.ExtHostTheming(Y)),Vt=Y.set(l.ExtHostContext.ExtHostAuthentication,new Le.ExtHostAuthentication(Y)),en=Y.set(l.ExtHostContext.ExtHostTimeline,new We.ExtHostTimeline(Y,ct)),tn=Y.set(l.ExtHostContext.ExtHostWebviews,new x.ExtHostWebviews(Y,{remote:Ke.remote},ut,Me,Ge)),nn=Y.set(l.ExtHostContext.ExtHostWebviewPanels,new Be.ExtHostWebviewPanels(Y,tn,ut)),yn=Y.set(l.ExtHostContext.ExtHostCustomEditors,new de.ExtHostCustomEditors(Y,Ct,Fe,tn,nn)),Sn=Y.set(l.ExtHostContext.ExtHostWebviewViews,new Z.ExtHostWebviewViews(Y,tn)),Mt=Y.set(l.ExtHostContext.ExtHostTesting,new De.ExtHostTesting(Y,ct)),Dn=Y.set(l.ExtHostContext.ExtHostUriOpeners,new Se.ExtHostUriOpeners(Y));Y.set(l.ExtHostContext.ExtHostInteractive,new He.ExtHostInteractive(Y,pt,mt));const Cn=(0,te.values)(l.ExtHostContext);Y.assertRegistered(Cn);const rn=new xe.ExtHostBulkEdits(Y,mt),kn=new c.ExtHostClipboard(Y),Bt=new D.ExtHostMessageService(Y,Me),Lt=new a.ExtHostDialogs(Y),fn=new B.ExtHostStatusBar(Y,ct.converter),Tt=new v.ExtHostLanguages(Y,Ct);return d.ExtHostApiCommands.register(ct),function(Ne,sn,mn){const vt=function(){let J=!Ne.isUnderDevelopment;function le(Ae){J||(Me.info(`Extension '${Ne.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),J=!0)}return function Ae(st){if(Array.isArray(st))st.forEach(Ae);else if(typeof st=="string")le(st);else{const wt=st;typeof wt.scheme=="undefined"&&le(st),!Ne.enableProposedApi&&typeof wt.exclusive=="boolean"&&(0,$.throwProposedApiError)(Ne)}return st}}(),In={getSession(J,le,Ae){return Ae?.forceRecreate&&(0,$.checkProposedApiEnabled)(Ne),Vt.getSession(Ne,J,le,Ae)},get onDidChangeSessions(){return Vt.onDidChangeSessions},registerAuthenticationProvider(J,le,Ae,st){return Vt.registerAuthenticationProvider(J,le,Ae,st)}},Pn={registerCommand(J,le,Ae){return ct.registerCommand(!0,J,le,Ae)},registerTextEditorCommand(J,le,Ae){return ct.registerCommand(!0,J,(...st)=>{const wt=At.getActiveTextEditor();if(!wt){Me.warn("Cannot execute "+J+" because there is no active text editor.");return}return wt.edit(Dt=>{le.apply(Ae,[wt,Dt,...st])}).then(Dt=>{Dt||Me.warn("Edits from command "+J+" were not applied.")},Dt=>{Me.warn("An error occurred while running command "+J,Dt)})})},registerDiffInformationCommand:(J,le,Ae)=>((0,$.checkProposedApiEnabled)(Ne),ct.registerCommand(!0,J,async(...st)=>{const wt=mt.activeEditor(!0);if(!wt){Me.warn("Cannot execute "+J+" because there is no active text editor.");return}const Dt=await At.getDiffInformation(wt.id);le.apply(Ae,[Dt,...st])})),executeCommand(J,...le){return ct.executeCommand(J,...le)},getCommands(J=!1){return ct.getCommands(J)}},gn={get machineId(){return Ke.telemetryInfo.machineId},get sessionId(){return Ke.telemetryInfo.sessionId},get language(){return Ke.environment.appLanguage},get appName(){return Ke.environment.appName},get appRoot(){return Ke.environment.appRoot?.fsPath??""},get uriScheme(){return Ke.environment.appUriScheme},get clipboard(){return kn.value},get shell(){return Et.getDefaultShell(!1)},get isTelemetryEnabled(){return ot.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return ot.onDidChangeTelemetryEnabled},get isNewAppInstall(){const J=Date.now()-new Date(Ke.telemetryInfo.firstSessionDate).getTime();return isNaN(J)?!1:J<1e3*60*60*24},openExternal(J,le){return dt.openUri(J,{allowTunneling:!!Ke.remote.authority,allowContributedOpeners:le?.allowContributedOpeners})},async asExternalUri(J){if(J.scheme===Ke.environment.appUriScheme)return Ut.createAppUri(J);try{return await dt.asExternalUri(J,{allowTunneling:!!Ke.remote.authority})}catch(le){if((0,we.matchesScheme)(J,me.Schemas.http)||(0,we.matchesScheme)(J,me.Schemas.https))return J;throw le}},get remoteName(){return(0,Re.getRemoteName)(Ke.remote.authority)},get uiKind(){return Ke.uiKind}};Ke.environment.extensionTestsLocationURI||Object.freeze(gn);const pn=Ke.remote.isRemote?R.ExtensionKind.Workspace:R.ExtensionKind.UI,on={createTestController(J,le){return(0,$.checkProposedApiEnabled)(Ne),Mt.createTestController(J,le)},createTestObserver(){return(0,$.checkProposedApiEnabled)(Ne),Mt.createTestObserver()},runTests(J){return(0,$.checkProposedApiEnabled)(Ne),Mt.runTests(J)},get onDidChangeTestResults(){return(0,$.checkProposedApiEnabled)(Ne),Mt.onResultsChanged},get testResults(){return(0,$.checkProposedApiEnabled)(Ne),Mt.results}},An={getExtension(J){const le=sn.getExtensionDescription(J);if(le)return new s.Extension(_t,Ne.identifier,le,pn)},get all(){return sn.getAllExtensionDescriptions().map(J=>new s.Extension(_t,Ne.identifier,J,pn))},get onDidChange(){return sn.onDidChange}},Tn={createDiagnosticCollection(J){return Ht.createDiagnosticCollection(Ne.identifier,J)},get onDidChangeDiagnostics(){return Ht.onDidChangeDiagnostics},getDiagnostics:J=>Ht.getDiagnostics(J),getLanguages(){return Tt.getLanguages()},setTextDocumentLanguage(J,le){return Tt.changeLanguage(J.uri,le)},match(J,le){return(0,n.score)(V.LanguageSelector.from(J),le.uri,le.languageId,!0)},registerCodeActionsProvider(J,le,Ae){return ht.registerCodeActionProvider(Ne,vt(J),le,Ae)},registerCodeLensProvider(J,le){return ht.registerCodeLensProvider(Ne,vt(J),le)},registerDefinitionProvider(J,le){return ht.registerDefinitionProvider(Ne,vt(J),le)},registerDeclarationProvider(J,le){return ht.registerDeclarationProvider(Ne,vt(J),le)},registerImplementationProvider(J,le){return ht.registerImplementationProvider(Ne,vt(J),le)},registerTypeDefinitionProvider(J,le){return ht.registerTypeDefinitionProvider(Ne,vt(J),le)},registerHoverProvider(J,le){return ht.registerHoverProvider(Ne,vt(J),le,Ne.identifier)},registerEvaluatableExpressionProvider(J,le){return ht.registerEvaluatableExpressionProvider(Ne,vt(J),le,Ne.identifier)},registerInlineValuesProvider(J,le){return ht.registerInlineValuesProvider(Ne,vt(J),le,Ne.identifier)},registerDocumentHighlightProvider(J,le){return ht.registerDocumentHighlightProvider(Ne,vt(J),le)},registerLinkedEditingRangeProvider(J,le){return ht.registerLinkedEditingRangeProvider(Ne,vt(J),le)},registerReferenceProvider(J,le){return ht.registerReferenceProvider(Ne,vt(J),le)},registerRenameProvider(J,le){return ht.registerRenameProvider(Ne,vt(J),le)},registerDocumentSymbolProvider(J,le,Ae){return ht.registerDocumentSymbolProvider(Ne,vt(J),le,Ae)},registerWorkspaceSymbolProvider(J){return ht.registerWorkspaceSymbolProvider(Ne,J)},registerDocumentFormattingEditProvider(J,le){return ht.registerDocumentFormattingEditProvider(Ne,vt(J),le)},registerDocumentRangeFormattingEditProvider(J,le){return ht.registerDocumentRangeFormattingEditProvider(Ne,vt(J),le)},registerOnTypeFormattingEditProvider(J,le,Ae,...st){return ht.registerOnTypeFormattingEditProvider(Ne,vt(J),le,[Ae].concat(st))},registerDocumentSemanticTokensProvider(J,le,Ae){return ht.registerDocumentSemanticTokensProvider(Ne,vt(J),le,Ae)},registerDocumentRangeSemanticTokensProvider(J,le,Ae){return ht.registerDocumentRangeSemanticTokensProvider(Ne,vt(J),le,Ae)},registerSignatureHelpProvider(J,le,Ae,...st){return typeof Ae=="object"?ht.registerSignatureHelpProvider(Ne,vt(J),le,Ae):ht.registerSignatureHelpProvider(Ne,vt(J),le,typeof Ae=="undefined"?[]:[Ae,...st])},registerCompletionItemProvider(J,le,...Ae){return ht.registerCompletionItemProvider(Ne,vt(J),le,Ae)},registerInlineCompletionItemProvider(J,le){return(0,$.checkProposedApiEnabled)(Ne),ht.registerInlineCompletionsProvider(Ne,vt(J),le)},registerDocumentLinkProvider(J,le){return ht.registerDocumentLinkProvider(Ne,vt(J),le)},registerColorProvider(J,le){return ht.registerColorProvider(Ne,vt(J),le)},registerFoldingRangeProvider(J,le){return ht.registerFoldingRangeProvider(Ne,vt(J),le)},registerSelectionRangeProvider(J,le){return ht.registerSelectionRangeProvider(Ne,J,le)},registerCallHierarchyProvider(J,le){return ht.registerCallHierarchyProvider(Ne,J,le)},setLanguageConfiguration:(J,le)=>ht.setLanguageConfiguration(Ne,J,le),getTokenInformationAtPosition(J,le){return(0,$.checkProposedApiEnabled)(Ne),Tt.tokenAtPosition(J,le)},registerInlayHintsProvider(J,le){return(0,$.checkProposedApiEnabled)(Ne),ht.registerInlayHintsProvider(Ne,J,le)},registerTypeHierarchyProvider(J,le){return(0,$.checkProposedApiEnabled)(Ne),ht.registerTypeHierarchyProvider(Ne,J,le)}},Rn={get activeTextEditor(){return At.getActiveTextEditor()},get visibleTextEditors(){return At.getVisibleTextEditors()},get activeTerminal(){return Et.activeTerminal},get terminals(){return Et.terminals},async showTextDocument(J,le,Ae){const st=await(C.URI.isUri(J)?Promise.resolve(vn.openTextDocument(J)):Promise.resolve(J));return At.showTextDocument(st,le,Ae)},createTextEditorDecorationType(J){return At.createTextEditorDecorationType(Ne,J)},onDidChangeActiveTextEditor(J,le,Ae){return At.onDidChangeActiveTextEditor(J,le,Ae)},onDidChangeVisibleTextEditors(J,le,Ae){return At.onDidChangeVisibleTextEditors(J,le,Ae)},onDidChangeTextEditorSelection(J,le,Ae){return At.onDidChangeTextEditorSelection(J,le,Ae)},onDidChangeTextEditorOptions(J,le,Ae){return At.onDidChangeTextEditorOptions(J,le,Ae)},onDidChangeTextEditorVisibleRanges(J,le,Ae){return At.onDidChangeTextEditorVisibleRanges(J,le,Ae)},onDidChangeTextEditorViewColumn(J,le,Ae){return At.onDidChangeTextEditorViewColumn(J,le,Ae)},onDidCloseTerminal(J,le,Ae){return Et.onDidCloseTerminal(J,le,Ae)},onDidOpenTerminal(J,le,Ae){return Et.onDidOpenTerminal(J,le,Ae)},onDidChangeActiveTerminal(J,le,Ae){return Et.onDidChangeActiveTerminal(J,le,Ae)},onDidChangeTerminalDimensions(J,le,Ae){return(0,$.checkProposedApiEnabled)(Ne),Et.onDidChangeTerminalDimensions(J,le,Ae)},onDidWriteTerminalData(J,le,Ae){return(0,$.checkProposedApiEnabled)(Ne),Et.onDidWriteTerminalData(J,le,Ae)},get state(){return dt.state},onDidChangeWindowState(J,le,Ae){return dt.onDidChangeWindowState(J,le,Ae)},showInformationMessage(J,...le){return Bt.showMessage(Ne,_.default.Info,J,le[0],le.slice(1))},showWarningMessage(J,...le){return Bt.showMessage(Ne,_.default.Warning,J,le[0],le.slice(1))},showErrorMessage(J,...le){return Bt.showMessage(Ne,_.default.Error,J,le[0],le.slice(1))},showQuickPick(J,le,Ae){return xt.showQuickPick(J,!!Ne.enableProposedApi,le,Ae)},showWorkspaceFolderPick(J){return xt.showWorkspaceFolderPick(J)},showInputBox(J,le){return xt.showInput(J,le)},showOpenDialog(J){return Lt.showOpenDialog(J)},showSaveDialog(J){return Lt.showSaveDialog(J)},createStatusBarItem(J,le,Ae){let st,wt,Dt;return typeof J=="string"?(st=J,wt=le,Dt=Ae):(wt=J,Dt=le),fn.createStatusBarEntry(Ne,st,wt,Dt)},setStatusBarMessage(J,le){return fn.setStatusBarMessage(J,le)},withScmProgress(J){return Ge.report("window.withScmProgress",Ne,"Use 'withProgress' instead."),dn.withProgress(Ne,{location:R.ProgressLocation.SourceControl},(le,Ae)=>J({report(st){}}))},withProgress(J,le){return dn.withProgress(Ne,J,le)},createOutputChannel(J){return Kt.createOutputChannel(J,Ne)},createWebviewPanel(J,le,Ae,st){return nn.createWebviewPanel(Ne,J,le,Ae,st)},createWebviewTextEditorInset(J,le,Ae,st){return(0,$.checkProposedApiEnabled)(Ne),Zt.createWebviewEditorInset(J,le,Ae,st,Ne)},createTerminal(J,le,Ae){return typeof J=="object"?(J.color&&(0,$.checkProposedApiEnabled)(Ne),"pty"in J?Et.createExtensionTerminal(J):Et.createTerminalFromOptions(J)):Et.createTerminal(J,le,Ae)},registerTerminalLinkProvider(J){return Et.registerLinkProvider(J)},registerTerminalProfileProvider(J,le){return Et.registerProfileProvider(Ne,J,le)},registerTreeDataProvider(J,le){return jt.registerTreeDataProvider(J,le,Ne)},createTreeView(J,le){return jt.createTreeView(J,le,Ne)},registerWebviewPanelSerializer:(J,le)=>nn.registerWebviewPanelSerializer(Ne,J,le),registerCustomEditorProvider:(J,le,Ae={})=>yn.registerCustomEditorProvider(Ne,J,le,Ae),registerFileDecorationProvider(J){return bt.registerFileDecorationProvider(J,Ne.identifier)},registerUriHandler(J){return Ut.registerUriHandler(Ne.identifier,J)},createQuickPick(){return xt.createQuickPick(Ne.identifier,!!Ne.enableProposedApi)},createInputBox(){return xt.createInputBox(Ne.identifier)},get activeColorTheme(){return hn.activeColorTheme},onDidChangeActiveColorTheme(J,le,Ae){return hn.onDidChangeActiveColorTheme(J,le,Ae)},registerWebviewViewProvider(J,le,Ae){return Sn.registerWebviewViewProvider(Ne,J,le,Ae?.webviewOptions)},get activeNotebookEditor(){return(0,$.checkProposedApiEnabled)(Ne),pt.activeNotebookEditor},onDidChangeActiveNotebookEditor(J,le,Ae){return(0,$.checkProposedApiEnabled)(Ne),pt.onDidChangeActiveNotebookEditor(J,le,Ae)},get visibleNotebookEditors(){return(0,$.checkProposedApiEnabled)(Ne),pt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,$.checkProposedApiEnabled)(Ne),pt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(J,le,Ae){return(0,$.checkProposedApiEnabled)(Ne),zt.onDidChangeNotebookEditorSelection(J,le,Ae)},onDidChangeNotebookEditorVisibleRanges(J,le,Ae){return(0,$.checkProposedApiEnabled)(Ne),zt.onDidChangeNotebookEditorVisibleRanges(J,le,Ae)},showNotebookDocument(J,le){return(0,$.checkProposedApiEnabled)(Ne),pt.showNotebookDocument(J,le)},registerExternalUriOpener(J,le,Ae){return(0,$.checkProposedApiEnabled)(Ne),Dn.registerExternalUriOpener(Ne.identifier,J,le,Ae)},get openEditors(){return(0,$.checkProposedApiEnabled)(Ne),kt.tabs},get onDidChangeOpenEditors(){return(0,$.checkProposedApiEnabled)(Ne),kt.onDidChangeTabs},getInlineCompletionItemController(J){return(0,$.checkProposedApiEnabled)(Ne),f.InlineCompletionController.get(J)}},vn={get rootPath(){return Ge.report("workspace.rootPath",Ne,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ut.getPath()},set rootPath(J){throw F.readonly()},getWorkspaceFolder(J){return ut.getWorkspaceFolder(J)},get workspaceFolders(){return ut.getWorkspaceFolders()},get name(){return ut.name},set name(J){throw F.readonly()},get workspaceFile(){return ut.workspaceFile},set workspaceFile(J){throw F.readonly()},updateWorkspaceFolders:(J,le,...Ae)=>ut.updateWorkspaceFolders(Ne,J,le||0,...Ae),onDidChangeWorkspaceFolders:function(J,le,Ae){return ut.onDidChangeWorkspace(J,le,Ae)},asRelativePath:(J,le)=>ut.getRelativePath(J,le),findFiles:(J,le,Ae,st)=>ut.findFiles(V.GlobPattern.from(J),V.GlobPattern.from(le),Ae,Ne.identifier,st),findTextInFiles:(J,le,Ae,st)=>{let wt,Dt;return typeof le=="object"?(wt=le,Dt=Ae):(wt={},Dt=le,st=Ae),ut.findTextInFiles(J,wt||{},Dt,Ne.identifier,st)},saveAll:J=>ut.saveAll(J),applyEdit(J){return rn.applyWorkspaceEdit(J)},createFileSystemWatcher:(J,le,Ae,st)=>Rt.createFileSystemWatcher(V.GlobPattern.from(J),le,Ae,st),get textDocuments(){return Ct.getAllDocumentData().map(J=>J.document)},set textDocuments(J){throw F.readonly()},openTextDocument(J){let le;const Ae=J;if(typeof J=="string")le=Promise.resolve(C.URI.file(J));else if(C.URI.isUri(J))le=Promise.resolve(J);else if(!Ae||typeof Ae=="object")le=Ct.createDocumentData(Ae);else throw new Error("illegal argument - uriOrFileNameOrOptions");return le.then(st=>Ct.ensureDocumentData(st).then(wt=>wt.document))},onDidOpenTextDocument:(J,le,Ae)=>Ct.onDidAddDocument(J,le,Ae),onDidCloseTextDocument:(J,le,Ae)=>Ct.onDidRemoveDocument(J,le,Ae),onDidChangeTextDocument:(J,le,Ae)=>Ct.onDidChangeDocument(J,le,Ae),onDidSaveTextDocument:(J,le,Ae)=>Ct.onDidSaveDocument(J,le,Ae),onWillSaveTextDocument:(J,le,Ae)=>Yt.getOnWillSaveTextDocumentEvent(Ne)(J,le,Ae),get notebookDocuments(){return pt.notebookDocuments.map(J=>J.apiNotebook)},async openNotebookDocument(J,le){let Ae;if(C.URI.isUri(J))Ae=J,await pt.openNotebookDocument(J);else if(typeof J=="string")Ae=C.URI.revive(await pt.createNotebookDocument({viewType:J,content:le}));else throw new Error("Invalid arguments");return pt.getNotebookDocument(Ae).apiNotebook},get onDidOpenNotebookDocument(){return pt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return pt.onDidCloseNotebookDocument},registerNotebookSerializer(J,le,Ae,st){return pt.registerNotebookSerializer(Ne,J,le,Ae,Ne.enableProposedApi?st:void 0)},registerNotebookContentProvider:(J,le,Ae,st)=>((0,$.checkProposedApiEnabled)(Ne),pt.registerNotebookContentProvider(Ne,J,le,Ae,Ne.enableProposedApi?st:void 0)),onDidChangeConfiguration:(J,le,Ae)=>mn.onDidChangeConfiguration(J,le,Ae),getConfiguration(J,le){return le=arguments.length===1?void 0:le,mn.getConfiguration(J,le,Ne)},registerTextDocumentContentProvider(J,le){return Qt.registerTextDocumentContentProvider(J,le)},registerTaskProvider:(J,le)=>(Ge.report("window.registerTaskProvider",Ne,"Use the corresponding function on the 'tasks' namespace instead"),Pt.registerTaskProvider(Ne,J,le)),registerFileSystemProvider(J,le,Ae){return bn.registerFileSystemProvider(Ne.identifier,J,le,Ae,Ne.enableProposedApi)},get fs(){return ft.value},registerFileSearchProvider:(J,le)=>((0,$.checkProposedApiEnabled)(Ne),Ot.registerFileSearchProvider(J,le)),registerTextSearchProvider:(J,le)=>((0,$.checkProposedApiEnabled)(Ne),Ot.registerTextSearchProvider(J,le)),registerRemoteAuthorityResolver:(J,le)=>((0,$.checkProposedApiEnabled)(Ne),_t.registerRemoteAuthorityResolver(J,le)),registerResourceLabelFormatter:J=>((0,$.checkProposedApiEnabled)(Ne),_n.$registerResourceLabelFormatter(J)),onDidCreateFiles:(J,le,Ae)=>Rt.onDidCreateFile(J,le,Ae),onDidDeleteFiles:(J,le,Ae)=>Rt.onDidDeleteFile(J,le,Ae),onDidRenameFiles:(J,le,Ae)=>Rt.onDidRenameFile(J,le,Ae),onWillCreateFiles:(J,le,Ae)=>Rt.getOnWillCreateFileEvent(Ne)(J,le,Ae),onWillDeleteFiles:(J,le,Ae)=>Rt.getOnWillDeleteFileEvent(Ne)(J,le,Ae),onWillRenameFiles:(J,le,Ae)=>Rt.getOnWillRenameFileEvent(Ne)(J,le,Ae),openTunnel:J=>((0,$.checkProposedApiEnabled)(Ne),tt.openTunnel(Ne,J).then(le=>{if(!le)throw new Error("cannot open tunnel");return le})),get tunnels(){return(0,$.checkProposedApiEnabled)(Ne),tt.getTunnels()},onDidChangeTunnels:(J,le,Ae)=>((0,$.checkProposedApiEnabled)(Ne),tt.onDidChangeTunnels(J,le,Ae)),registerPortAttributesProvider:(J,le)=>((0,$.checkProposedApiEnabled)(Ne),tt.registerPortsAttributesProvider(J,le)),registerTimelineProvider:(J,le)=>((0,$.checkProposedApiEnabled)(Ne),en.registerTimelineProvider(J,le,Ne.identifier,ct.converter)),get isTrusted(){return ut.trusted},requestWorkspaceTrust:J=>((0,$.checkProposedApiEnabled)(Ne),ut.requestWorkspaceTrust(J)),onDidGrantWorkspaceTrust:(J,le,Ae)=>ut.onDidGrantWorkspaceTrust(J,le,Ae)},Fn={get inputBox(){return Ge.report("scm.inputBox",Ne,"Use 'SourceControl.inputBox' instead"),cn.getLastInputBox(Ne)},createSourceControl(J,le,Ae){return cn.createSourceControl(Ne,J,le,Ae)}},Mn={createCommentController(J,le){return En.createCommentController(Ne,J,le)}},Ln={get activeDebugSession(){return gt.activeDebugSession},get activeDebugConsole(){return gt.activeDebugConsole},get breakpoints(){return gt.breakpoints},onDidStartDebugSession(J,le,Ae){return gt.onDidStartDebugSession(J,le,Ae)},onDidTerminateDebugSession(J,le,Ae){return gt.onDidTerminateDebugSession(J,le,Ae)},onDidChangeActiveDebugSession(J,le,Ae){return gt.onDidChangeActiveDebugSession(J,le,Ae)},onDidReceiveDebugSessionCustomEvent(J,le,Ae){return gt.onDidReceiveDebugSessionCustomEvent(J,le,Ae)},onDidChangeBreakpoints(J,le,Ae){return gt.onDidChangeBreakpoints(J,le,Ae)},registerDebugConfigurationProvider(J,le,Ae){return gt.registerDebugConfigurationProvider(J,le,Ae||R.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(J,le){return gt.registerDebugAdapterDescriptorFactory(Ne,J,le)},registerDebugAdapterTrackerFactory(J,le){return gt.registerDebugAdapterTrackerFactory(J,le)},startDebugging(J,le,Ae){return!Ae||typeof Ae=="object"&&"configuration"in Ae?gt.startDebugging(J,le,{parentSession:Ae}):gt.startDebugging(J,le,Ae||{})},stopDebugging(J){return gt.stopDebugging(J)},addBreakpoints(J){return gt.addBreakpoints(J)},removeBreakpoints(J){return gt.removeBreakpoints(J)},asDebugSourceUri(J,le){return gt.asDebugSourceUri(J,le)}},Nn={registerTaskProvider:(J,le)=>Pt.registerTaskProvider(Ne,J,le),fetchTasks:J=>Pt.fetchTasks(J),executeTask:J=>Pt.executeTask(Ne,J),get taskExecutions(){return Pt.taskExecutions},onDidStartTask:(J,le,Ae)=>Pt.onDidStartTask(J,le,Ae),onDidEndTask:(J,le,Ae)=>Pt.onDidEndTask(J,le,Ae),onDidStartTaskProcess:(J,le,Ae)=>Pt.onDidStartTaskProcess(J,le,Ae),onDidEndTaskProcess:(J,le,Ae)=>Pt.onDidEndTaskProcess(J,le,Ae)},an={createNotebookController(J,le,Ae,st,wt){return Jt.createNotebookController(Ne,J,le,Ae,st,Ne.enableProposedApi?wt:void 0)},registerNotebookCellStatusBarItemProvider:(J,le)=>pt.registerNotebookCellStatusBarItemProvider(Ne,J,le),get onDidSaveNotebookDocument(){return(0,$.checkProposedApiEnabled)(Ne),qt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(J){return(0,$.checkProposedApiEnabled)(Ne),zt.createNotebookEditorDecorationType(J)},createRendererMessaging(J){return Xt.createRendererMessaging(Ne,J)},onDidChangeNotebookDocumentMetadata(J,le,Ae){return(0,$.checkProposedApiEnabled)(Ne),qt.onDidChangeNotebookDocumentMetadata(J,le,Ae)},onDidChangeNotebookCells(J,le,Ae){return(0,$.checkProposedApiEnabled)(Ne),pt.onDidChangeNotebookCells(J,le,Ae)},onDidChangeNotebookCellExecutionState(J,le,Ae){return(0,$.checkProposedApiEnabled)(Ne),pt.onDidChangeNotebookCellExecutionState(J,le,Ae)},onDidChangeCellOutputs(J,le,Ae){return(0,$.checkProposedApiEnabled)(Ne),pt.onDidChangeCellOutputs(J,le,Ae)},onDidChangeCellMetadata(J,le,Ae){return(0,$.checkProposedApiEnabled)(Ne),pt.onDidChangeCellMetadata(J,le,Ae)},createConcatTextDocument(J,le){return(0,$.checkProposedApiEnabled)(Ne),new ve.ExtHostNotebookConcatDocument(pt,Ct,J,le)}};return{version:Ke.version,authentication:In,commands:Pn,comments:Mn,debug:Ln,env:gn,extensions:An,languages:Tn,notebooks:an,scm:Fn,tasks:Nn,tests:on,window:Rn,workspace:vn,Breakpoint:R.Breakpoint,CallHierarchyIncomingCall:R.CallHierarchyIncomingCall,CallHierarchyItem:R.CallHierarchyItem,CallHierarchyOutgoingCall:R.CallHierarchyOutgoingCall,CancellationError:F.CancellationError,CancellationTokenSource:g.CancellationTokenSource,CandidatePortSource:l.CandidatePortSource,CodeAction:R.CodeAction,CodeActionKind:R.CodeActionKind,CodeActionTriggerKind:R.CodeActionTriggerKind,CodeLens:R.CodeLens,Color:R.Color,ColorInformation:R.ColorInformation,ColorPresentation:R.ColorPresentation,ColorThemeKind:R.ColorThemeKind,CommentMode:R.CommentMode,CommentThreadCollapsibleState:R.CommentThreadCollapsibleState,CompletionItem:R.CompletionItem,CompletionItemKind:R.CompletionItemKind,CompletionItemTag:R.CompletionItemTag,CompletionList:R.CompletionList,CompletionTriggerKind:R.CompletionTriggerKind,ConfigurationTarget:R.ConfigurationTarget,CustomExecution:R.CustomExecution,DebugAdapterExecutable:R.DebugAdapterExecutable,DebugAdapterInlineImplementation:R.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:R.DebugAdapterNamedPipeServer,DebugAdapterServer:R.DebugAdapterServer,DebugConfigurationProviderTriggerKind:R.DebugConfigurationProviderTriggerKind,DebugConsoleMode:R.DebugConsoleMode,DecorationRangeBehavior:R.DecorationRangeBehavior,Diagnostic:R.Diagnostic,DiagnosticRelatedInformation:R.DiagnosticRelatedInformation,DiagnosticSeverity:R.DiagnosticSeverity,DiagnosticTag:R.DiagnosticTag,Disposable:R.Disposable,DocumentHighlight:R.DocumentHighlight,DocumentHighlightKind:R.DocumentHighlightKind,DocumentLink:R.DocumentLink,DocumentSymbol:R.DocumentSymbol,EndOfLine:R.EndOfLine,EnvironmentVariableMutatorType:R.EnvironmentVariableMutatorType,EvaluatableExpression:R.EvaluatableExpression,InlineValueText:R.InlineValueText,InlineValueVariableLookup:R.InlineValueVariableLookup,InlineValueEvaluatableExpression:R.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:R.InlineCompletionTriggerKind,EventEmitter:S.Emitter,ExtensionKind:R.ExtensionKind,ExtensionMode:R.ExtensionMode,ExternalUriOpenerPriority:R.ExternalUriOpenerPriority,FileChangeType:R.FileChangeType,FileDecoration:R.FileDecoration,FileSystemError:R.FileSystemError,FileType:I.FileType,FilePermission:I.FilePermission,FoldingRange:R.FoldingRange,FoldingRangeKind:R.FoldingRangeKind,FunctionBreakpoint:R.FunctionBreakpoint,InlineCompletionItem:R.InlineSuggestion,InlineCompletionList:R.InlineSuggestions,Hover:R.Hover,IndentAction:k.IndentAction,Location:R.Location,MarkdownString:R.MarkdownString,OverviewRulerLane:b.OverviewRulerLane,ParameterInformation:R.ParameterInformation,PortAutoForwardAction:R.PortAutoForwardAction,Position:R.Position,ProcessExecution:R.ProcessExecution,ProgressLocation:R.ProgressLocation,QuickInputButtons:R.QuickInputButtons,Range:R.Range,RelativePattern:R.RelativePattern,Selection:R.Selection,SelectionRange:R.SelectionRange,SemanticTokens:R.SemanticTokens,SemanticTokensBuilder:R.SemanticTokensBuilder,SemanticTokensEdit:R.SemanticTokensEdit,SemanticTokensEdits:R.SemanticTokensEdits,SemanticTokensLegend:R.SemanticTokensLegend,ShellExecution:R.ShellExecution,ShellQuoting:R.ShellQuoting,SignatureHelp:R.SignatureHelp,SignatureHelpTriggerKind:R.SignatureHelpTriggerKind,SignatureInformation:R.SignatureInformation,SnippetString:R.SnippetString,SourceBreakpoint:R.SourceBreakpoint,StandardTokenType:R.StandardTokenType,StatusBarAlignment:R.StatusBarAlignment,SymbolInformation:R.SymbolInformation,SymbolKind:R.SymbolKind,SymbolTag:R.SymbolTag,Task:R.Task,TaskGroup:R.TaskGroup,TaskPanelKind:R.TaskPanelKind,TaskRevealKind:R.TaskRevealKind,TaskScope:R.TaskScope,TerminalLink:R.TerminalLink,TerminalProfile:R.TerminalProfile,TextDocumentSaveReason:R.TextDocumentSaveReason,TextEdit:R.TextEdit,TextEditorCursorStyle:y.TextEditorCursorStyle,TextEditorLineNumbersStyle:R.TextEditorLineNumbersStyle,TextEditorRevealType:R.TextEditorRevealType,TextEditorSelectionChangeKind:R.TextEditorSelectionChangeKind,TextDocumentChangeReason:R.TextDocumentChangeReason,ThemeColor:R.ThemeColor,ThemeIcon:R.ThemeIcon,TreeItem:R.TreeItem,TreeItemCollapsibleState:R.TreeItemCollapsibleState,TypeHierarchyItem:R.TypeHierarchyItem,UIKind:l.UIKind,Uri:C.URI,ViewColumn:R.ViewColumn,WorkspaceEdit:R.WorkspaceEdit,InlayHint:R.InlayHint,InlayHintKind:R.InlayHintKind,RemoteAuthorityResolverError:R.RemoteAuthorityResolverError,ResolvedAuthority:R.ResolvedAuthority,SourceControlInputBoxValidationType:R.SourceControlInputBoxValidationType,ExtensionRuntime:R.ExtensionRuntime,TimelineItem:R.TimelineItem,NotebookRange:R.NotebookRange,NotebookCellKind:R.NotebookCellKind,NotebookCellExecutionState:R.NotebookCellExecutionState,NotebookCellData:R.NotebookCellData,NotebookData:R.NotebookData,NotebookRendererScript:R.NotebookRendererScript,NotebookCellStatusBarAlignment:R.NotebookCellStatusBarAlignment,NotebookEditorRevealType:R.NotebookEditorRevealType,NotebookCellOutput:R.NotebookCellOutput,NotebookCellOutputItem:R.NotebookCellOutputItem,NotebookCellStatusBarItem:R.NotebookCellStatusBarItem,NotebookControllerAffinity:R.NotebookControllerAffinity,PortAttributes:R.PortAttributes,LinkedEditingRanges:R.LinkedEditingRanges,TestResultState:R.TestResultState,TestRunRequest:R.TestRunRequest,TestMessage:R.TestMessage,TestRunProfileKind:R.TestRunProfileKind,TextSearchCompleteMessageType:pe.TextSearchCompleteMessageType,TestMessageSeverity:R.TestMessageSeverity,CoveredCount:R.CoveredCount,FileCoverage:R.FileCoverage,StatementCoverage:R.StatementCoverage,BranchCoverage:R.BranchCoverage,FunctionCoverage:R.FunctionCoverage,WorkspaceTrustState:R.WorkspaceTrustState}}}e.createApiFactoryAndRegisterActors=et}),define(be[230],Ee([0,1,59,105,32,104,33,75,48,38,108,109,110,77,68,74,106,76,47,73,97,66]),function(ee,e,g,F,S,_,C,y,b,k,n,I,l,d,c,m,E,w,P,a,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,g.registerSingleton)(m.IExtHostApiDeprecationService,m.ExtHostApiDeprecationService),(0,g.registerSingleton)(y.IExtHostCommands,y.ExtHostCommands),(0,g.registerSingleton)(C.IExtHostConfiguration,C.ExtHostConfiguration),(0,g.registerSingleton)(w.IExtHostConsumerFileSystem,w.ExtHostConsumerFileSystem),(0,g.registerSingleton)(I.IExtHostDebugService,I.WorkerExtHostDebugService),(0,g.registerSingleton)(_.IExtHostDecorations,_.ExtHostDecorations),(0,g.registerSingleton)(b.IExtHostDocumentsAndEditors,b.ExtHostDocumentsAndEditors),(0,g.registerSingleton)(P.IExtHostFileSystemInfo,P.ExtHostFileSystemInfo),(0,g.registerSingleton)(F.IExtHostOutputService,F.ExtHostOutputService),(0,g.registerSingleton)(l.IExtHostSearch,l.ExtHostSearch),(0,g.registerSingleton)(d.IExtHostStorage,d.ExtHostStorage),(0,g.registerSingleton)(n.IExtHostTask,n.WorkerExtHostTask),(0,g.registerSingleton)(k.IExtHostTerminalService,k.WorkerExtHostTerminalService),(0,g.registerSingleton)(c.IExtHostTunnelService,c.ExtHostTunnelService),(0,g.registerSingleton)(E.IExtHostWindow,E.ExtHostWindow),(0,g.registerSingleton)(S.IExtHostWorkspace,S.ExtHostWorkspace),(0,g.registerSingleton)(a.IExtHostSecretState,a.ExtHostSecretState),(0,g.registerSingleton)(h.IExtHostTelemetry,h.ExtHostTelemetry),(0,g.registerSingleton)(p.IExtHostEditorTabs,p.ExtHostEditorTabs)}),define(be[231],Ee([0,1,229,34,225,7,16,5,11]),function(ee,e,g,F,S,_,C,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;var k;(function(c){const m=self.trustedTypes?.createPolicy("TrustedFunctionWorkaround",{createScript:(w,...P)=>{P.forEach(t=>{if(!self.trustedTypes?.isScript(t))throw new Error("TrustedScripts only, please")});const a=P.slice(0,-1).join(","),h=P.pop().toString();return`(function anonymous(${a}) {
${h}
})`}});function E(...w){return m?self.eval(m.createScript("",...w)):new Function(...w)}c.create=E})(k||(k={}));class n extends S.RequireInterceptor{_installInterceptor(){}getModule(m,E){for(let w of this._alternatives){let P=w(m);if(P){m=P;break}}if(this._factories.has(m))return this._factories.get(m).load(m,E,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class I extends F.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=_.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const m=this._extHostContext.getProxy(y.MainContext.MainThreadConsole);d(m,this._initData.environment.isExtensionDevelopmentDebug);const E=this._instaService.invokeFunction(g.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(n,E,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(m){return m.browser}async _loadCommonJSModule(m,E,w){E=E.with({path:l(E.path,".js")}),m&&performance.mark(`code/extHost/willFetchExtensionCode/${m.value}`);const P=await fetch(b.FileAccess.asBrowserUri(E).toString(!0));if(m&&performance.mark(`code/extHost/didFetchExtensionCode/${m.value}`),P.status!==200)throw new Error(P.statusText);const a=await P.text(),h=`${E.toString(!0)}#vscode-extension`,p=`${a}
//# sourceURL=${h}`;let t;try{t=k.create(I._ttpExtensionScripts?.createScript("module")??"module",I._ttpExtensionScripts?.createScript("exports")??"exports",I._ttpExtensionScripts?.createScript("require")??"require",I._ttpExtensionScripts?.createScript(p)??p)}catch(u){throw console.error(m?`Loading code for extension ${m.value} failed: ${u.message}`:`Loading code failed: ${u.message}`),console.error(`${E.toString(!0)}${typeof u.line=="number"?` line ${u.line}`:""}${typeof u.column=="number"?` column ${u.column}`:""}`),console.error(u),u}const r={},s={exports:r},i=u=>{const f=this._fakeModules.getModule(u,E);if(f===void 0)throw new Error(`Cannot load module '${u}'`);return f};try{return w.codeLoadingStart(),m&&performance.mark(`code/extHost/willLoadExtensionCode/${m.value}`),t(s,r,i),s.exports!==r?s.exports:r}finally{m&&performance.mark(`code/extHost/didLoadExtensionCode/${m.value}`),w.codeLoadingStop()}}async $setRemoteEnvironment(m){throw new Error("Not supported")}async _waitForDebuggerAttachment(m=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const E=Date.now()+m;for(;Date.now()<E&&!("__jsDebugIsReady"in globalThis);)await(0,C.timeout)(10)}}e.ExtHostExtensionService=I,I._ttpExtensionScripts=self.trustedTypes?.createPolicy("ExtensionScripts",{createScript:c=>c});function l(c,m){return c.endsWith(m)?c:c+m}function d(c,m){E("info","log"),E("log","log"),E("warn","warn"),E("error","error");function E(a,h){const p=console[a];console[a]=function(){c.$logExtensionHostMessage({type:"__$console",severity:h,arguments:P(arguments)}),m&&p.apply(console,arguments)}}const w=1e5;function P(a){const h=[],p=[];if(a.length)for(let t=0;t<a.length;t++){if(typeof a[t]=="undefined")a[t]="undefined";else if(a[t]instanceof Error){const r=a[t];r.stack?a[t]=r.stack:a[t]=r.toString()}p.push(a[t])}try{const t=JSON.stringify(p,function(r,s){if(s&&typeof s=="object"){if(h.indexOf(s)!==-1)return"[Circular]";h.push(s)}return s});return t.length>w?"Output omitted for a large object that exceeds the limits":t}catch(t){return`Output omitted for an object that cannot be inspected ('${t.toString()}')`}}}}),define(be[232],Ee([0,1,59,15,34,78,231,218]),function(ee,e,g,F,S,_,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,g.registerSingleton)(S.IExtHostExtensionService,C.ExtHostExtensionService),(0,g.registerSingleton)(F.ILogService,y.ExtHostLogService),(0,g.registerSingleton)(_.IExtensionStoragePaths,_.ExtensionStoragePaths)}),define(be[234],Ee([0,1,24,3,186,226,220,14,79,11,2,230,232]),function(ee,e,g,F,S,_,C,y,b,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const I=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const l=postMessage.bind(self);if(self.postMessage=()=>console.trace("'postMessage' has been blocked"),self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const P=self.trustedTypes?.createPolicy("extensionHostWorker",{createScriptURL:h=>h}),a=self.Worker;Worker=function(h,p){/^file:/i.test(h.toString())&&(h=k.FileAccess.asBrowserUri(n.URI.parse(h.toString())).toString(!0));const t=`(function() {
	const ttPolicy = self.trustedTypes ? self.trustedTypes.createPolicy('extensionHostWorker', { createScriptURL: (value) => value }) : undefined;
	const stringUrl = '${h}';
	importScripts(ttPolicy ? ttPolicy.createScriptURL(stringUrl) : stringUrl);
})();
`;p=p||{},p.name=p.name||y.basename(h.toString());const r=new Blob([t],{type:"application/javascript"}),s=URL.createObjectURL(r);return new a(P?P.createScriptURL(s):s,p)}}else self.Worker=class extends C.NestedWorker{constructor(P,a){super(l,P,{name:y.basename(P.toString()),...a})}};const d=new class{exit(P){I()}async exists(P){return!0}async realpath(P){return P}};class c{constructor(){const a=new MessageChannel,h=new F.Emitter;let p=!1;l(a.port2,[a.port2]),a.port1.onmessage=t=>{const{data:r}=t;if(!(r instanceof ArrayBuffer)){console.warn("UNKNOWN data received",r);return}const s=g.VSBuffer.wrap(new Uint8Array(r,0,r.byteLength));if((0,S.isMessageOfType)(s,2)){p=!0,E("received terminate message from renderer");return}h.fire(s)},this.protocol={onMessage:h.event,send:t=>{if(!p){const r=t.buffer.buffer.slice(t.buffer.byteOffset,t.buffer.byteOffset+t.buffer.byteLength);a.port1.postMessage(r,[r])}}}}}function m(P){return new Promise(a=>{const h=P.onMessage(p=>{h.dispose();const t=JSON.parse(p.toString());P.send((0,S.createMessageOfType)(0)),a({protocol:P,initData:t})});P.send((0,S.createMessageOfType)(1))})}let E=P=>I();function w(){const P=new c;b.mark("code/extHost/willConnectToRenderer"),m(P.protocol).then(a=>{b.mark("code/extHost/didWaitForInitData");const h=new _.ExtensionHostMain(a.protocol,a.initData,d,null);E=p=>h.terminate(p)})}e.create=w})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/818c6613f765dd54bb29e77b4f7094a37cf67d08/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
